/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],Se=function(X){for(var e=[],g=0,i=X.length;g<i;g++)e[g]=Ee[X[g]];return e};define(Ee[56],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(i,D){if(!i)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(Ee[73],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function g(P){return P?P.replace(/\$\((.*?)\)/g,(k,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=g;class i{constructor(k,C,I){this.id=k,this.definition=C,this.description=I,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function D(P,k){const C=["codicon","codicon-"+P];return k&&C.push("codicon-modifier-"+k),C}e.getClassNamesArray=D;var _;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function C(T){if(T instanceof i)return["codicon","codicon-"+T.id];const c=k.exec(T.id);if(!c)return C(i.error);let[,E,h]=c;const w=["codicon","codicon-"+E];return h&&w.push("codicon-modifier-"+h.substr(1)),w}P.asClassNameArray=C;function I(T){return C(T).join(" ")}P.asClassName=I;function L(T){return"."+C(T).join(".")}P.asCSSSelector=L})(_=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[74],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function i(L){const T=[];for(let c in L)g.call(L,c)&&T.push(L[c]);return T}e.values=i;function D(L,T){for(let c in L)if(g.call(L,c)&&T({key:c,value:L[c]},function(){delete L[c]})===!1)return}e.forEach=D;function _(L,T){const c=Object.create(null);for(const E of L){const h=T(E);let w=c[h];w||(w=c[h]=[]),w.push(E)}return c}e.groupBy=_;function P(L){const T=Object.create(null);return L&&L.forEach((c,E)=>{T[E]=c}),T}e.fromMap=P;function k(L,T){const c=[],E=[];for(let h of L)T.has(h)||c.push(h);for(let h of T)L.has(h)||E.push(h);return{removed:c,added:E}}e.diffSets=k;function C(L,T){const c=[],E=[];for(let[h,w]of L)T.has(h)||c.push(w);for(let[h,w]of T)L.has(h)||E.push(w);return{removed:c,added:E}}e.diffMaps=C;class I{constructor(){this.map=new Map}add(T,c){let E=this.map.get(T);E||(E=new Set,this.map.set(T,E)),E.add(c)}delete(T,c){const E=this.map.get(T);!E||(E.delete(c),E.size===0&&this.map.delete(T))}forEach(T,c){const E=this.map.get(T);!E||E.forEach(c)}}e.SetMap=I}),define(Ee[57],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(P){return(k,C,I)=>{let L=null,T=null;if(typeof I.value=="function"?(L="value",T=I.value):typeof I.get=="function"&&(L="get",T=I.get),!T)throw new Error("not supported");I[L]=P(T,C)}}e.createDecorator=g;function i(P,k,C){let I=null,L=null;if(typeof C.value=="function"?(I="value",L=C.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(I="get",L=C.get),!L)throw new Error("not supported");const T=`$memoize$${k}`;C[I]=function(...c){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,c)}),this[T]}}e.memoize=i;function D(P,k,C){return g((I,L)=>{const T=`$debounce$${L}`,c=`$debounce$result$${L}`;return function(...E){this[c]||(this[c]=C?C():void 0),clearTimeout(this[T]),k&&(this[c]=k(this[c],...E),E=[this[c]]),this[T]=setTimeout(()=>{I.apply(this,E),this[c]=C?C():void 0},P)}})}e.debounce=D;function _(P,k,C){return g((I,L)=>{const T=`$throttle$timer$${L}`,c=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,h=`$throttle$pending$${L}`;return function(...w){if(this[c]||(this[c]=C?C():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...w)),this[h])return;const v=this[E]+P;v<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[c]]),this[c]=C?C():void 0):(this[h]=!0,this[T]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),I.apply(this,[this[c]]),this[c]=C?C():void 0},v-Date.now()))}})}e.throttle=_}),define(Ee[15],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(S=>{S(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=g,e.errorHandler=new g;function i(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=i;function D(p){C(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=D;function _(p){C(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=_;function P(p){if(p instanceof Error){let{name:a,message:S}=p;const n=p.stacktrace||p.stack;return{$isError:!0,name:a,message:S,stack:n}}return p}e.transformErrorForSerialization=P;const k="Canceled";function C(p){return p instanceof Error&&p.name===k&&p.message===k}e.isPromiseCanceledError=C;class I extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=I;function L(){const p=new Error(k);return p.name=p.message,p}e.canceled=L;function T(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=T;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function E(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(p){const a=new Error(`${p} has been disposed`);return a.name="DISPOSED",a}e.disposed=h;function w(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=w;class v extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=v;class R extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=R;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function s(p){const a=p;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=s;function o(p,a=Object.create(null)){const S=new Error(p);return a.actions&&(S.actions=a.actions),S}e.createErrorWithActions=o}),define(Ee[16],Se([0,1,15]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(j,te=0){return j[j.length-(1+te)]}e.tail=i;function D(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=D;function _(j,te,ae=(ge,Ie)=>ge===Ie){if(j===te)return!0;if(!j||!te||j.length!==te.length)return!1;for(let ge=0,Ie=j.length;ge<Ie;ge++)if(!ae(j[ge],te[ge]))return!1;return!0}e.equals=_;function P(j,te,ae){let ge=0,Ie=j.length-1;for(;ge<=Ie;){const Me=(ge+Ie)/2|0,Ne=ae(j[Me],te);if(Ne<0)ge=Me+1;else if(Ne>0)Ie=Me-1;else return Me}return-(ge+1)}e.binarySearch=P;function k(j,te){let ae=0,ge=j.length;if(ge===0)return 0;for(;ae<ge;){const Ie=Math.floor((ae+ge)/2);te(j[Ie])?ge=Ie:ae=Ie+1}return ae}e.findFirstInSorted=k;function C(j,te,ae){if(j=j|0,j>=te.length)throw new TypeError("invalid index");let ge=te[Math.floor(te.length*Math.random())],Ie=[],Me=[],Ne=[];for(let q of te){const J=ae(q,ge);J<0?Ie.push(q):J>0?Me.push(q):Ne.push(q)}return j<Ie.length?C(j,Ie,ae):j<Ie.length+Ne.length?Ne[0]:C(j-(Ie.length+Ne.length),Me,ae)}e.quickSelect=C;function I(j,te){const ae=[];let ge;for(const Ie of j.slice(0).sort(te))!ge||te(ge[0],Ie)!==0?(ge=[Ie],ae.push(ge)):ge.push(Ie);return ae}e.groupBy=I;function L(j,te,ae){const ge=[];function Ie(q,J,ne){if(J===0&&ne.length===0)return;const he=ge[ge.length-1];he&&he.start+he.deleteCount===q?(he.deleteCount+=J,he.toInsert.push(...ne)):ge.push({start:q,deleteCount:J,toInsert:ne})}let Me=0,Ne=0;for(;;){if(Me===j.length){Ie(Me,0,te.slice(Ne));break}if(Ne===te.length){Ie(Me,j.length-Me,[]);break}const q=j[Me],J=te[Ne],ne=ae(q,J);ne===0?(Me+=1,Ne+=1):ne<0?(Ie(Me,1,[]),Me+=1):ne>0&&(Ie(Me,0,[J]),Ne+=1)}return ge}e.sortedDiff=L;function T(j,te,ae){const ge=L(j,te,ae),Ie=[],Me=[];for(const Ne of ge)Ie.push(...j.slice(Ne.start,Ne.start+Ne.deleteCount)),Me.push(...Ne.toInsert);return{removed:Ie,added:Me}}e.delta=T;function c(j,te,ae){if(ae===0)return[];const ge=j.slice(0,ae).sort(te);return h(j,te,ge,ae,j.length),ge}e.top=c;function E(j,te,ae,ge,Ie){return ae===0?Promise.resolve([]):new Promise((Me,Ne)=>{(async()=>{const q=j.length,J=j.slice(0,ae).sort(te);for(let ne=ae,he=Math.min(ae+ge,q);ne<q;ne=he,he=Math.min(he+ge,q)){if(ne>ae&&await new Promise(ee=>setTimeout(ee)),Ie&&Ie.isCancellationRequested)throw(0,g.canceled)();h(j,te,J,ne,he)}return J})().then(Me,Ne)})}e.topAsync=E;function h(j,te,ae,ge,Ie){for(const Me=ae.length;ge<Ie;ge++){const Ne=j[ge];if(te(Ne,ae[Me-1])<0){ae.pop();const q=k(ae,J=>te(Ne,J)<0);ae.splice(q,0,Ne)}}}function w(j){return j.filter(te=>!!te)}e.coalesce=w;function v(j){let te=0;for(let ae=0;ae<j.length;ae++)j[ae]&&(j[te]=j[ae],te+=1);j.length=te}e.coalesceInPlace=v;function R(j,te,ae){j.splice(ae,0,j.splice(te,1)[0])}e.move=R;function b(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=b;function s(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=s;function o(j,te=ae=>ae){const ae=new Set;return j.filter(ge=>{const Ie=te(ge);return ae.has(Ie)?!1:(ae.add(Ie),!0)})}e.distinct=o;function p(j){const te=Object.create(null);return ae=>{const ge=j(ae);return te[ge]?!1:(te[ge]=!0,!0)}}e.uniqueFilter=p;function a(j,te){const ae=S(j,te);if(ae!==-1)return j[ae]}e.findLast=a;function S(j,te){for(let ae=j.length-1;ae>=0;ae--){const ge=j[ae];if(te(ge))return ae}return-1}e.lastIndex=S;function n(j,te){return j.length>0?j[0]:te}e.firstOrDefault=n;function t(j,te,ae=(ge,Ie)=>ge===Ie){let ge=0;for(let Ie=0,Me=Math.min(j.length,te.length);Ie<Me&&ae(j[Ie],te[Ie]);Ie++)ge++;return ge}e.commonPrefixLength=t;function r(j){return[].concat(...j)}e.flatten=r;function l(j,te){let ae=typeof te=="number"?j:0;typeof te=="number"?ae=j:(ae=0,te=j);const ge=[];if(ae<=te)for(let Ie=ae;Ie<te;Ie++)ge.push(Ie);else for(let Ie=ae;Ie>te;Ie--)ge.push(Ie);return ge}e.range=l;function d(j,te,ae){return j.reduce((ge,Ie)=>(ge[te(Ie)]=ae?ae(Ie):Ie,ge),Object.create(null))}e.index=d;function m(j,te){return j.push(te),()=>f(j,te)}e.insert=m;function f(j,te){const ae=j.indexOf(te);if(ae>-1)return j.splice(ae,1),te}e.remove=f;function u(j,te,ae){const ge=j.slice(0,te),Ie=j.slice(te);return ge.concat(ae,Ie)}e.arrayInsert=u;function y(j,te){let ae;if(typeof te=="number"){let ge=te;ae=()=>{const Ie=Math.sin(ge++)*179426549;return Ie-Math.floor(Ie)}}else ae=Math.random;for(let ge=j.length-1;ge>0;ge-=1){const Ie=Math.floor(ae()*(ge+1)),Me=j[ge];j[ge]=j[Ie],j[Ie]=Me}}e.shuffle=y;function A(j,te){const ae=j.indexOf(te);ae>-1&&(j.splice(ae,1),j.unshift(te))}e.pushToStart=A;function N(j,te){const ae=j.indexOf(te);ae>-1&&(j.splice(ae,1),j.push(te))}e.pushToEnd=N;function B(j,te){return Array.isArray(j)?j.map(te):te(j)}e.mapArrayOrNot=B;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function O(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=O;function z(j,te){for(const ae of j){const ge=te(ae);if(ge!==void 0)return ge}}e.mapFind=z;function W(j,te,ae){const ge=x(j,te),Ie=j.length,Me=ae.length;j.length=Ie+Me;for(let Ne=Ie-1;Ne>=ge;Ne--)j[Ne+Me]=j[Ne];for(let Ne=0;Ne<Me;Ne++)j[Ne+ge]=ae[Ne]}e.insertInto=W;function M(j,te,ae,ge){const Ie=x(j,te),Me=j.splice(Ie,ae);return W(j,Ie,ge),Me}e.splice=M;function x(j,te){return te<0?Math.max(te+j.length,0):Math.min(te,j.length)}function V(j,te){return(ae,ge)=>te(j(ae),j(ge))}e.compareBy=V;const U=(j,te)=>j-te;e.numberComparator=U;function H(j,te){if(j.length===0)return;let ae=j[0];for(let ge=1;ge<j.length;ge++){const Ie=j[ge];te(Ie,ae)>0&&(ae=Ie)}return ae}e.findMaxBy=H;function Y(j,te){if(j.length===0)return;let ae=j[0];for(let ge=1;ge<j.length;ge++){const Ie=j[ge];te(Ie,ae)>=0&&(ae=Ie)}return ae}e.findLastMaxBy=Y;function re(j,te){return H(j,(ae,ge)=>-te(ae,ge))}e.findMinBy=re;class K{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ae=this.firstIdx;for(;ae<this.items.length&&te(this.items[ae]);)ae++;const ge=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,ge}takeFromEndWhile(te){let ae=this.lastIdx;for(;ae>=0&&te(this.items[ae]);)ae--;const ge=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,ge}peek(){return this.items[this.firstIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}takeCount(te){const ae=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ae}}e.ArrayQueue=K}),define(Ee[75],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(i){const D=this;let _=!1,P;return function(){return _||(_=!0,P=i.apply(D,arguments)),P}}e.once=g}),define(Ee[76],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(Ee[77],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(i){function D(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}i.is=D;const _=Object.freeze([]);function P(){return _}i.empty=P;function*k(p){yield p}i.single=k;function C(p){return p||_}i.from=C;function I(p){return!p||p[Symbol.iterator]().next().done===!0}i.isEmpty=I;function L(p){return p[Symbol.iterator]().next().value}i.first=L;function T(p,a){for(const S of p)if(a(S))return!0;return!1}i.some=T;function c(p,a){for(const S of p)if(a(S))return S}i.find=c;function*E(p,a){for(const S of p)a(S)&&(yield S)}i.filter=E;function*h(p,a){let S=0;for(const n of p)yield a(n,S++)}i.map=h;function*w(...p){for(const a of p)for(const S of a)yield S}i.concat=w;function*v(p){for(const a of p)for(const S of a)yield S}i.concatNested=v;function R(p,a,S){let n=S;for(const t of p)n=a(n,t);return n}i.reduce=R;function*b(p,a,S=p.length){for(a<0&&(a+=p.length),S<0?S+=p.length:S>p.length&&(S=p.length);a<S;a++)yield p[a]}i.slice=b;function s(p,a=Number.POSITIVE_INFINITY){const S=[];if(a===0)return[S,p];const n=p[Symbol.iterator]();for(let t=0;t<a;t++){const r=n.next();if(r.done)return[S,i.empty()];S.push(r.value)}return[S,{[Symbol.iterator](){return n}}]}i.consume=s;function o(p,a,S=(n,t)=>n===t){const n=p[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const r=n.next(),l=t.next();if(r.done!==l.done)return!1;if(r.done)return!0;if(!S(r.value,l.value))return!1}}i.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(Ee[58],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var i;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(a){a.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function P(a,S=!1){let n=0,t=a.length,r="",l=0,d=16,m=0;function f(O){let z=0,W=0;for(;z<O;){const M=a.charCodeAt(n);if(M>=48&&M<=57)W=W*16+M-48;else if(M>=65&&M<=70)W=W*16+M-65+10;else if(M>=97&&M<=102)W=W*16+M-97+10;else break;n++,z++}return z<O&&(W=-1),W}function u(O){n=O,r="",l=0,d=16,m=0}function y(){const O=n;if(a.charCodeAt(n)===48)n++;else for(n++;n<a.length&&I(a.charCodeAt(n));)n++;if(n<a.length&&a.charCodeAt(n)===46)if(n++,n<a.length&&I(a.charCodeAt(n)))for(n++;n<a.length&&I(a.charCodeAt(n));)n++;else return m=3,a.substring(O,n);let z=n;if(n<a.length&&(a.charCodeAt(n)===69||a.charCodeAt(n)===101))if(n++,(n<a.length&&a.charCodeAt(n)===43||a.charCodeAt(n)===45)&&n++,n<a.length&&I(a.charCodeAt(n))){for(n++;n<a.length&&I(a.charCodeAt(n));)n++;z=n}else m=3;return a.substring(O,z)}function A(){let O="",z=n;for(;;){if(n>=t){O+=a.substring(z,n),m=2;break}const W=a.charCodeAt(n);if(W===34){O+=a.substring(z,n),n++;break}if(W===92){if(O+=a.substring(z,n),n++,n>=t){m=2;break}switch(a.charCodeAt(n++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const x=f(4);x>=0?O+=String.fromCharCode(x):m=4;break}default:m=5}z=n;continue}if(W>=0&&W<=31)if(C(W)){O+=a.substring(z,n),m=2;break}else m=6;n++}return O}function N(){if(r="",m=0,l=n,n>=t)return l=t,d=17;let O=a.charCodeAt(n);if(k(O)){do n++,r+=String.fromCharCode(O),O=a.charCodeAt(n);while(k(O));return d=15}if(C(O))return n++,r+=String.fromCharCode(O),O===13&&a.charCodeAt(n)===10&&(n++,r+=`
`),d=14;switch(O){case 123:return n++,d=1;case 125:return n++,d=2;case 91:return n++,d=3;case 93:return n++,d=4;case 58:return n++,d=6;case 44:return n++,d=5;case 34:return n++,r=A(),d=10;case 47:{const z=n-1;if(a.charCodeAt(n+1)===47){for(n+=2;n<t&&!C(a.charCodeAt(n));)n++;return r=a.substring(z,n),d=12}if(a.charCodeAt(n+1)===42){n+=2;const W=t-1;let M=!1;for(;n<W;){if(a.charCodeAt(n)===42&&a.charCodeAt(n+1)===47){n+=2,M=!0;break}n++}return M||(n++,m=1),r=a.substring(z,n),d=13}return r+=String.fromCharCode(O),n++,d=16}case 45:if(r+=String.fromCharCode(O),n++,n===t||!I(a.charCodeAt(n)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=y(),d=11;default:for(;n<t&&B(O);)n++,O=a.charCodeAt(n);if(l!==n){switch(r=a.substring(l,n),r){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return r+=String.fromCharCode(O),n++,d=16}}function B(O){if(k(O)||C(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:u,getPosition:()=>n,scan:S?F:N,getToken:()=>d,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>m}}e.createScanner=P;function k(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function C(a){return a===10||a===13||a===8232||a===8233}function I(a){return a>=48&&a<=57}var L;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(L||(L={}));function T(a,S){const n=[],t=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function m(f,u,y,A){l.value=f,l.offset=u,l.length=y,l.type=A,l.colonOffset=void 0,r=l}try{s(a,{onObjectBegin:(f,u)=>{if(S<=f)throw t;r=void 0,d=S>f,n.push("")},onObjectProperty:(f,u,y)=>{if(S<u||(m(f,u,y,"property"),n[n.length-1]=f,S<=u+y))throw t},onObjectEnd:(f,u)=>{if(S<=f)throw t;r=void 0,n.pop()},onArrayBegin:(f,u)=>{if(S<=f)throw t;r=void 0,n.push(0)},onArrayEnd:(f,u)=>{if(S<=f)throw t;r=void 0,n.pop()},onLiteralValue:(f,u,y)=>{if(S<u||(m(f,u,y,p(f)),S<=u+y))throw t},onSeparator:(f,u,y)=>{if(S<=u)throw t;if(f===":"&&r&&r.type==="property")r.colonOffset=u,d=!1,r=void 0;else if(f===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(d=!0,n[n.length-1]=""),r=void 0}}})}catch(f){if(f!==t)throw f}return{path:n,previousNode:r,isAtPropertyKey:d,matches:f=>{let u=0;for(let y=0;u<f.length&&y<n.length;y++)if(f[u]===n[y]||f[u]==="*")u++;else if(f[u]!=="**")return!1;return u===f.length}}}e.getLocation=T;function c(a,S=[],n=_.DEFAULT){let t=null,r=[];const l=[];function d(f){Array.isArray(r)?r.push(f):t!==null&&(r[t]=f)}return s(a,{onObjectBegin:()=>{const f={};d(f),l.push(r),r=f,t=null},onObjectProperty:f=>{t=f},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const f=[];d(f),l.push(r),r=f,t=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:d,onError:(f,u,y)=>{S.push({error:f,offset:u,length:y})}},n),r[0]}e.parse=c;function E(a,S=[],n=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(f){t.type==="property"&&(t.length=f-t.offset,t=t.parent)}function l(f){return t.children.push(f),f}s(a,{onObjectBegin:f=>{t=l({type:"object",offset:f,length:-1,parent:t,children:[]})},onObjectProperty:(f,u,y)=>{t=l({type:"property",offset:u,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:f,offset:u,length:y,parent:t})},onObjectEnd:(f,u)=>{t.length=f+u-t.offset,t=t.parent,r(f+u)},onArrayBegin:(f,u)=>{t=l({type:"array",offset:f,length:-1,parent:t,children:[]})},onArrayEnd:(f,u)=>{t.length=f+u-t.offset,t=t.parent,r(f+u)},onLiteralValue:(f,u,y)=>{l({type:p(f),offset:u,length:y,parent:t,value:f}),r(u+y)},onSeparator:(f,u,y)=>{t.type==="property"&&(f===":"?t.colonOffset=u:f===","&&r(u))},onError:(f,u,y)=>{S.push({error:f,offset:u,length:y})}},n);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=E;function h(a,S){if(!a)return;let n=a;for(let t of S)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===t){n=l.children[1],r=!0;break}if(!r)return}else{const r=t;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=h;function w(a){if(!a.parent||!a.parent.children)return[];const S=w(a.parent);if(a.parent.type==="property"){const n=a.parent.children[0].value;S.push(n)}else if(a.parent.type==="array"){const n=a.parent.children.indexOf(a);n!==-1&&S.push(n)}return S}e.getNodePath=w;function v(a){switch(a.type){case"array":return a.children.map(v);case"object":{const S=Object.create(null);for(let n of a.children){const t=n.children[1];t&&(S[n.children[0].value]=v(t))}return S}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=v;function R(a,S,n=!1){return S>=a.offset&&S<a.offset+a.length||n&&S===a.offset+a.length}e.contains=R;function b(a,S,n=!1){if(R(a,S,n)){const t=a.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=S;r++){const l=b(t[r],S,n);if(l)return l}return a}}e.findNodeAtOffset=b;function s(a,S,n=_.DEFAULT){const t=P(a,!1);function r(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(K){return K?j=>K(j,t.getTokenOffset(),t.getTokenLength()):()=>!0}const d=r(S.onObjectBegin),m=l(S.onObjectProperty),f=r(S.onObjectEnd),u=r(S.onArrayBegin),y=r(S.onArrayEnd),A=l(S.onLiteralValue),N=l(S.onSeparator),B=r(S.onComment),F=l(S.onError),O=n&&n.disallowComments,z=n&&n.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:O||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:O?M(10):B();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,j=[],te=[]){if(F(K),j.length+te.length>0){let ae=t.getToken();for(;ae!==17;){if(j.indexOf(ae)!==-1){W();break}else if(te.indexOf(ae)!==-1)break;ae=W()}}}function x(K){const j=t.getTokenValue();return K?A(j):m(j),W(),!0}function V(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch{M(2)}A(K);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return W(),!0}function U(){return t.getToken()!==10?(M(3,[],[2,5]),!1):(x(!1),t.getToken()===6?(N(":"),W(),re()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function H(){d(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||M(4,[],[]),N(","),W(),t.getToken()===2&&z)break}else K&&M(6,[],[]);U()||M(4,[],[2,5]),K=!0}return f(),t.getToken()!==2?M(7,[2],[]):W(),!0}function Y(){u(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||M(4,[],[]),N(","),W(),t.getToken()===4&&z)break}else K&&M(6,[],[]);re()||M(4,[],[4,5]),K=!0}return y(),t.getToken()!==4?M(8,[4],[]):W(),!0}function re(){switch(t.getToken()){case 3:return Y();case 1:return H();case 10:return x(!0);default:return V()}}return W(),t.getToken()===17?n.allowEmptyContent?!0:(M(4,[],[]),!1):re()?(t.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=s;function o(a,S){let n=P(a),t=[],r,l=0,d;do switch(d=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:l!==d&&t.push(a.substring(l,d)),S!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,S)),l=n.getPosition();break}while(r!==17);return t.join("")}e.stripComments=o;function p(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ee[139],Se([0,1,58]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(I,L,T){let c,E,h,w,v;if(L){for(w=L.offset,v=w+L.length,h=w;h>0&&!C(I,h-1);)h--;let d=v;for(;d<I.length&&!C(I,d);)d++;E=I.substring(h,d),c=P(E,T)}else E=I,c=0,h=0,w=0,v=I.length;const R=k(T,I);let b=!1,s=0,o;T.insertSpaces?o=_(" ",T.tabSize||4):o="	";const p=(0,g.createScanner)(E,!1);let a=!1;function S(){return R+_(o,c+s)}function n(){let d=p.scan();for(b=!1;d===15||d===14;)b=b||d===14,d=p.scan();return a=d===16||p.getTokenError()!==0,d}const t=[];function r(d,m,f){!a&&m<v&&f>w&&I.substring(m,f)!==d&&t.push({offset:m,length:f-m,content:d})}let l=n();if(l!==17){const d=p.getTokenOffset()+h,m=_(o,c);r(m,h,d)}for(;l!==17;){let d=p.getTokenOffset()+p.getTokenLength()+h,m=n(),f="";for(;!b&&(m===12||m===13);){const y=p.getTokenOffset()+h;r(" ",d,y),d=p.getTokenOffset()+p.getTokenLength()+h,f=m===12?S():"",m=n()}if(m===2)l!==1&&(s--,f=S());else if(m===4)l!==3&&(s--,f=S());else{switch(l){case 3:case 1:s++,f=S();break;case 5:case 12:f=S();break;case 13:b?f=S():f=" ";break;case 6:f=" ";break;case 10:if(m===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?f=" ":m!==5&&m!==17&&(a=!0);break;case 16:a=!0;break}b&&(m===12||m===13)&&(f=S())}const u=p.getTokenOffset()+h;r(f,d,u),l=m}return t}e.format=i;function D(I,L){const T=JSON.stringify(I,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?T.replace(/\r\n|\r|\n/g,L.eol):T}e.toFormattedString=D;function _(I,L){let T="";for(let c=0;c<L;c++)T+=I;return T}function P(I,L){let T=0,c=0;const E=L.tabSize||4;for(;T<I.length;){const h=I.charAt(T);if(h===" ")c++;else if(h==="	")c+=E;else break;T++}return Math.floor(c/E)}function k(I,L){for(let T=0;T<L.length;T++){const c=L.charAt(T);if(c==="\r")return T+1<L.length&&L.charAt(T+1)===`
`?`\r
`:"\r";if(c===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=k;function C(I,L){return`\r
`.indexOf(I.charAt(L))!==-1}e.isEOL=C}),define(Ee[140],Se([0,1,58,139]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(I,L,T){return _(I,L,void 0,T)}e.removeProperty=D;function _(I,L,T,c,E){const h=L.slice(),w=[],v=(0,g.parseTree)(I,w);let R,b;for(;h.length>0&&(b=h.pop(),R=(0,g.findNodeAtLocation)(v,h),R===void 0&&T!==void 0);)typeof b=="string"?T={[b]:T}:T=[T];if(R)if(R.type==="object"&&typeof b=="string"&&Array.isArray(R.children)){const s=(0,g.findNodeAtLocation)(R,[b]);if(s!==void 0)if(T===void 0){if(!s.parent)throw new Error("Malformed AST");const o=R.children.indexOf(s.parent);let p,a=s.parent.offset+s.parent.length;if(o>0){const S=R.children[o-1];p=S.offset+S.length}else p=R.offset+1,R.children.length>1&&(a=R.children[1].offset);return P(I,{offset:p,length:a-p,content:""},c)}else return P(I,{offset:s.offset,length:s.length,content:JSON.stringify(T)},c);else{if(T===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(T)}`,p=E?E(R.children.map(S=>S.children[0].value)):R.children.length;let a;if(p>0){const S=R.children[p-1];a={offset:S.offset+S.length,length:0,content:","+o}}else R.children.length===0?a={offset:R.offset+1,length:0,content:o}:a={offset:R.offset+1,length:0,content:o+","};return P(I,a,c)}}else if(R.type==="array"&&typeof b=="number"&&Array.isArray(R.children))if(T!==void 0){const s=`${JSON.stringify(T)}`;let o;if(R.children.length===0||b===0)o={offset:R.offset+1,length:0,content:R.children.length===0?s:s+","};else{const p=b===-1||b>R.children.length?R.children.length:b,a=R.children[p-1];o={offset:a.offset+a.length,length:0,content:","+s}}return P(I,o,c)}else{const s=b,o=R.children[s];let p;if(R.children.length===1)p={offset:R.offset+1,length:R.length-2,content:""};else if(R.children.length-1===s){const a=R.children[s-1],S=a.offset+a.length,n=R.offset+R.length;p={offset:S,length:n-2-S,content:""}}else p={offset:o.offset,length:R.children[s+1].offset-o.offset,content:""};return P(I,p,c)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${R.type}`);else{if(T===void 0)throw new Error("Can not delete in empty document");return P(I,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(T)},c)}}e.setProperty=_;function P(I,L,T){let c=k(I,L),E=L.offset,h=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;E>0&&!(0,i.isEOL)(c,E-1);)E--;for(;h<c.length&&!(0,i.isEOL)(c,h);)h++}const w=(0,i.format)(c,{offset:E,length:h-E},T);for(let R=w.length-1;R>=0;R--){const b=w[R];c=k(c,b),E=Math.min(E,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const v=I.length-(c.length-h)-E;return[{offset:E,length:v,content:c.substring(E,h)}]}e.withFormatting=P;function k(I,L){return I.substring(0,L.offset)+L.content+I.substring(L.offset+L.length)}e.applyEdit=k;function C(I,L){let T=L.slice(0).sort((E,h)=>{const w=E.offset-h.offset;return w===0?E.length-h.length:w}),c=I.length;for(let E=T.length-1;E>=0;E--){let h=T[E];if(h.offset+h.length<=c)I=k(I,h);else throw new Error("Overlapping edit");c=h.offset}return I}e.applyEdits=C}),define(Ee[93],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new g(()=>D(this.getValue()))}}e.Lazy=g}),define(Ee[6],Se([0,1,75,77]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let _=null;function P(t){_=t}if(e.setDisposableTracker=P,D){const t="__is_disposable_tracked__";P(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[t]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==b.None)try{r[t]=!0}catch{}}markAsDisposed(r){if(r&&r!==b.None)try{r[t]=!0}catch{}}markAsSingleton(r){}})}function k(t){return _?.trackDisposable(t),t}function C(t){_?.markAsDisposed(t)}function I(t,r){_?.setParent(t,r)}function L(t,r){if(!!_)for(const l of t)_.setParent(l,r)}function T(t){return _?.markAsSingleton(t),t}e.markAsSingleton=T;class c extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=c;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(i.Iterable.is(t)){let r=[];for(const l of t)if(l)try{l.dispose()}catch(d){r.push(d)}if(r.length===1)throw r[0];if(r.length>1)throw new c(r);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const r=v(()=>h(t));return L(t,r),r}e.combinedDisposable=w;function v(t){const r=k({dispose:(0,g.once)(()=>{C(r),t()})});return r}e.toDisposable=v;class R{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return I(r,this),this._isDisposed?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=R,R.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new R,k(this),I(this._store,this)}dispose(){C(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&I(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&I(r,null),r}}e.MutableDisposable=s;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class p{constructor(){this.references=new Map}acquire(r,...l){let d=this.references.get(r);d||(d={counter:0,object:this.createReferencedObject(r,...l)},this.references.set(r,d));const{object:m}=d,f=(0,g.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(r,d.object),this.references.delete(r))});return d.counter++,{object:m,dispose:f}}}e.ReferenceCollection=p;class a{constructor(r){this.referenceCollection=r}async acquire(r,...l){const d=this.referenceCollection.acquire(r,...l);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(m){throw d.dispose(),m}}}e.AsyncReferenceCollection=a;class S{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=S;function n(t){const r=new R;try{t(r)}finally{r.dispose()}}e.disposeOnReturn=n}),define(Ee[94],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(_){this.element=_,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class i{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let _=this._first;for(;_!==g.Undefined;){const P=_.next;_.prev=g.Undefined,_.next=g.Undefined,_=P}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,P){const k=new g(_);if(this._first===g.Undefined)this._first=k,this._last=k;else if(P){const I=this._last;this._last=k,k.prev=I,I.next=k}else{const I=this._first;this._first=k,k.next=I,I.prev=k}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(k))}}shift(){if(this._first!==g.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==g.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==g.Undefined&&_.next!==g.Undefined){const P=_.prev;P.next=_.next,_.next.prev=P}else _.prev===g.Undefined&&_.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):_.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):_.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==g.Undefined;)yield _.element,_=_.next}}e.LinkedList=i}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Pe,De){for(var ye=0;ye<De.length;ye++){var le=De[ye];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(Pe,le.key,le)}}function e(Pe,De,ye){return De&&X(Pe.prototype,De),ye&&X(Pe,ye),Pe}function g(Pe,De){if(!!Pe){if(typeof Pe=="string")return i(Pe,De);var ye=Object.prototype.toString.call(Pe).slice(8,-1);if(ye==="Object"&&Pe.constructor&&(ye=Pe.constructor.name),ye==="Map"||ye==="Set")return Array.from(Pe);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return i(Pe,De)}}function i(Pe,De){(De==null||De>Pe.length)&&(De=Pe.length);for(var ye=0,le=new Array(De);ye<De;ye++)le[ye]=Pe[ye];return le}function D(Pe,De){var ye=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ye)return(ye=ye.call(Pe)).next.bind(ye);if(Array.isArray(Pe)||(ye=g(Pe))||De&&Pe&&typeof Pe.length=="number"){ye&&(Pe=ye);var le=0;return function(){return le>=Pe.length?{done:!0}:{done:!1,value:Pe[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var _={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Pe){_.exports.defaults=Pe}_.exports={defaults:P(),getDefaults:P,changeDefaults:k};var C=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(De){return c[De]};function h(Pe,De){if(De){if(C.test(Pe))return Pe.replace(I,E)}else if(L.test(Pe))return Pe.replace(T,E);return Pe}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(w,function(De,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var R=/(^|[^\[])\^/g;function b(Pe,De){Pe=Pe.source||Pe,De=De||"";var ye={replace:function(de,we){return we=we.source||we,we=we.replace(R,"$1"),Pe=Pe.replace(de,we),ye},getRegex:function(){return new RegExp(Pe,De)}};return ye}var s=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Pe,De,ye){if(Pe){var le;try{le=decodeURIComponent(v(ye)).replace(s,"").toLowerCase()}catch{return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}De&&!o.test(ye)&&(ye=r(De,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var a={},S=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Pe,De){a[" "+Pe]||(S.test(Pe)?a[" "+Pe]=Pe+"/":a[" "+Pe]=f(Pe,"/",!0)),Pe=a[" "+Pe];var ye=Pe.indexOf(":")===-1;return De.substring(0,2)==="//"?ye?De:Pe.replace(n,"$1")+De:De.charAt(0)==="/"?ye?De:Pe.replace(t,"$1")+De:Pe+De}var l={exec:function(){}};function d(Pe){for(var De=1,ye,le;De<arguments.length;De++){ye=arguments[De];for(le in ye)Object.prototype.hasOwnProperty.call(ye,le)&&(Pe[le]=ye[le])}return Pe}function m(Pe,De){var ye=Pe.replace(/\|/g,function(we,ve,Re){for(var Ge=!1,We=ve;--We>=0&&Re[We]==="\\";)Ge=!Ge;return Ge?"|":" |"}),le=ye.split(/ \|/),de=0;if(le[0].trim()||le.shift(),le[le.length-1].trim()||le.pop(),le.length>De)le.splice(De);else for(;le.length<De;)le.push("");for(;de<le.length;de++)le[de]=le[de].trim().replace(/\\\|/g,"|");return le}function f(Pe,De,ye){var le=Pe.length;if(le===0)return"";for(var de=0;de<le;){var we=Pe.charAt(le-de-1);if(we===De&&!ye)de++;else if(we!==De&&ye)de++;else break}return Pe.substr(0,le-de)}function u(Pe,De){if(Pe.indexOf(De[1])===-1)return-1;for(var ye=Pe.length,le=0,de=0;de<ye;de++)if(Pe[de]==="\\")de++;else if(Pe[de]===De[0])le++;else if(Pe[de]===De[1]&&(le--,le<0))return de;return-1}function y(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Pe,De){if(De<1)return"";for(var ye="";De>1;)De&1&&(ye+=Pe),De>>=1,Pe+=Pe;return ye+Pe}var N={escape:h,unescape:v,edit:b,cleanUrl:p,resolveUrl:r,noopTest:l,merge:d,splitCells:m,rtrim:f,findClosingBracket:u,checkSanitizeDeprecation:y,repeatString:A},B=_.exports.defaults,F=N.rtrim,O=N.splitCells,z=N.escape,W=N.findClosingBracket;function M(Pe,De,ye,le){var de=De.href,we=De.title?z(De.title):null,ve=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){le.state.inLink=!0;var Re={type:"link",raw:ye,href:de,title:we,text:ve,tokens:le.inlineTokens(ve,[])};return le.state.inLink=!1,Re}else return{type:"image",raw:ye,href:de,title:we,text:z(ve)}}function x(Pe,De){var ye=Pe.match(/^(\s+)(?:```)/);if(ye===null)return De;var le=ye[1];return De.split(`
`).map(function(de){var we=de.match(/^\s+/);if(we===null)return de;var ve=we[0];return ve.length>=le.length?de.slice(le.length):de}).join(`
`)}var V=function(){function Pe(ye){this.options=ye||B}var De=Pe.prototype;return De.space=function(le){var de=this.rules.block.newline.exec(le);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},De.code=function(le){var de=this.rules.block.code.exec(le);if(de){var we=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},De.fences=function(le){var de=this.rules.block.fences.exec(le);if(de){var we=de[0],ve=x(we,de[3]||"");return{type:"code",raw:we,lang:de[2]?de[2].trim():de[2],text:ve}}},De.heading=function(le){var de=this.rules.block.heading.exec(le);if(de){var we=de[2].trim();if(/#$/.test(we)){var ve=F(we,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(we=ve.trim())}var Re={type:"heading",raw:de[0],depth:de[1].length,text:we,tokens:[]};return this.lexer.inline(Re.text,Re.tokens),Re}},De.hr=function(le){var de=this.rules.block.hr.exec(le);if(de)return{type:"hr",raw:de[0]}},De.blockquote=function(le){var de=this.rules.block.blockquote.exec(le);if(de){var we=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},De.list=function(le){var de=this.rules.block.list.exec(le);if(de){var we,ve,Re,Ge,We,Xe,st,ot,fe,ke,ue=de[1].trim(),Q=ue.length>1,Te={type:"list",raw:"",ordered:Q,start:Q?+ue.slice(0,-1):"",loose:!1,items:[]};ue=Q?"\\d{1,9}\\"+ue.slice(-1):"\\"+ue,this.options.pedantic&&(ue=Q?ue:"[*+-]");for(var Oe=new RegExp("^( {0,3}"+ue+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");le&&!(this.rules.block.hr.test(le)||!(de=Oe.exec(le)));){fe=de[2].split(`
`),this.options.pedantic?(Ge=2,ke=fe[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),ke=fe[0].slice(Ge-de[1].length)),Xe=!1,we=de[0],!fe[0]&&/^ *$/.test(fe[1])&&(we=de[1]+fe.slice(0,2).join(`
`)+`
`,Te.loose=!0,fe=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(We=1;We<fe.length;We++){if(ot=fe[We],this.options.pedantic&&(ot=ot.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(ot)){we=de[1]+fe.slice(0,We).join(`
`)+`
`;break}if(!Xe){ot.trim()||(Xe=!0),ot.search(/[^ ]/)>=Ge?ke+=`
`+ot.slice(Ge):ke+=`
`+ot;continue}if(ot.search(/[^ ]/)>=Ge||!ot.trim()){ke+=`
`+ot.slice(Ge);continue}else{we=de[1]+fe.slice(0,We).join(`
`)+`
`;break}}Te.loose||(st?Te.loose=!0:/\n *\n *$/.test(we)&&(st=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(ke),ve&&(Re=ve[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Te.items.push({type:"list_item",raw:we,task:!!ve,checked:Re,loose:!1,text:ke}),Te.raw+=we,le=le.slice(we.length)}Te.items[Te.items.length-1].raw=we.trimRight(),Te.items[Te.items.length-1].text=ke.trimRight(),Te.raw=Te.raw.trimRight();var qe=Te.items.length;for(We=0;We<qe;We++)this.lexer.state.top=!1,Te.items[We].tokens=this.lexer.blockTokens(Te.items[We].text,[]),Te.items[We].tokens.some(function(ht){return ht.type==="space"})&&(Te.loose=!0,Te.items[We].loose=!0);return Te}},De.html=function(le){var de=this.rules.block.html.exec(le);if(de){var we={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},De.def=function(le){var de=this.rules.block.def.exec(le);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var we=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:de[0],href:de[2],title:de[3]}}},De.table=function(le){var de=this.rules.block.table.exec(le);if(de){var we={type:"table",header:O(de[1]).map(function(st){return{text:st}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=de[0];var ve=we.align.length,Re,Ge,We,Xe;for(Re=0;Re<ve;Re++)/^ *-+: *$/.test(we.align[Re])?we.align[Re]="right":/^ *:-+: *$/.test(we.align[Re])?we.align[Re]="center":/^ *:-+ *$/.test(we.align[Re])?we.align[Re]="left":we.align[Re]=null;for(ve=we.rows.length,Re=0;Re<ve;Re++)we.rows[Re]=O(we.rows[Re],we.header.length).map(function(st){return{text:st}});for(ve=we.header.length,Ge=0;Ge<ve;Ge++)we.header[Ge].tokens=[],this.lexer.inlineTokens(we.header[Ge].text,we.header[Ge].tokens);for(ve=we.rows.length,Ge=0;Ge<ve;Ge++)for(Xe=we.rows[Ge],We=0;We<Xe.length;We++)Xe[We].tokens=[],this.lexer.inlineTokens(Xe[We].text,Xe[We].tokens);return we}}},De.lheading=function(le){var de=this.rules.block.lheading.exec(le);if(de){var we={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.paragraph=function(le){var de=this.rules.block.paragraph.exec(le);if(de){var we={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.text=function(le){var de=this.rules.block.text.exec(le);if(de){var we={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.escape=function(le){var de=this.rules.inline.escape.exec(le);if(de)return{type:"escape",raw:de[0],text:z(de[1])}},De.tag=function(le){var de=this.rules.inline.tag.exec(le);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]):de[0]}},De.link=function(le){var de=this.rules.inline.link.exec(le);if(de){var we=de[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ve=F(we.slice(0,-1),"\\");if((we.length-ve.length)%2==0)return}else{var Re=W(de[2],"()");if(Re>-1){var Ge=de[0].indexOf("!")===0?5:4,We=Ge+de[1].length+Re;de[2]=de[2].substring(0,Re),de[0]=de[0].substring(0,We).trim(),de[3]=""}}var Xe=de[2],st="";if(this.options.pedantic){var ot=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Xe);ot&&(Xe=ot[1],st=ot[3])}else st=de[3]?de[3].slice(1,-1):"";return Xe=Xe.trim(),/^</.test(Xe)&&(this.options.pedantic&&!/>$/.test(we)?Xe=Xe.slice(1):Xe=Xe.slice(1,-1)),M(de,{href:Xe&&Xe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},De.reflink=function(le,de){var we;if((we=this.rules.inline.reflink.exec(le))||(we=this.rules.inline.nolink.exec(le))){var ve=(we[2]||we[1]).replace(/\s+/g," ");if(ve=de[ve.toLowerCase()],!ve||!ve.href){var Re=we[0].charAt(0);return{type:"text",raw:Re,text:Re}}return M(we,ve,we[0],this.lexer)}},De.emStrong=function(le,de,we){we===void 0&&(we="");var ve=this.rules.inline.emStrong.lDelim.exec(le);if(!!ve&&!(ve[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=ve[1]||ve[2]||"";if(!Re||Re&&(we===""||this.rules.inline.punctuation.exec(we))){var Ge=ve[0].length-1,We,Xe,st=Ge,ot=0,fe=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,de=de.slice(-1*le.length+Ge);(ve=fe.exec(de))!=null;)if(We=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!We){if(Xe=We.length,ve[3]||ve[4]){st+=Xe;continue}else if((ve[5]||ve[6])&&Ge%3&&!((Ge+Xe)%3)){ot+=Xe;continue}if(st-=Xe,!(st>0)){if(Xe=Math.min(Xe,Xe+st+ot),Math.min(Ge,Xe)%2){var ke=le.slice(1,Ge+ve.index+Xe);return{type:"em",raw:le.slice(0,Ge+ve.index+Xe+1),text:ke,tokens:this.lexer.inlineTokens(ke,[])}}var ue=le.slice(2,Ge+ve.index+Xe-1);return{type:"strong",raw:le.slice(0,Ge+ve.index+Xe+1),text:ue,tokens:this.lexer.inlineTokens(ue,[])}}}}}},De.codespan=function(le){var de=this.rules.inline.code.exec(le);if(de){var we=de[2].replace(/\n/g," "),ve=/[^ ]/.test(we),Re=/^ /.test(we)&&/ $/.test(we);return ve&&Re&&(we=we.substring(1,we.length-1)),we=z(we,!0),{type:"codespan",raw:de[0],text:we}}},De.br=function(le){var de=this.rules.inline.br.exec(le);if(de)return{type:"br",raw:de[0]}},De.del=function(le){var de=this.rules.inline.del.exec(le);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},De.autolink=function(le,de){var we=this.rules.inline.autolink.exec(le);if(we){var ve,Re;return we[2]==="@"?(ve=z(this.options.mangle?de(we[1]):we[1]),Re="mailto:"+ve):(ve=z(we[1]),Re=ve),{type:"link",raw:we[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(le,de){var we;if(we=this.rules.inline.url.exec(le)){var ve,Re;if(we[2]==="@")ve=z(this.options.mangle?de(we[0]):we[0]),Re="mailto:"+ve;else{var Ge;do Ge=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ge!==we[0]);ve=z(we[0]),we[1]==="www."?Re="http://"+ve:Re=ve}return{type:"link",raw:we[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(le,de){var we=this.rules.inline.text.exec(le);if(we){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):z(we[0]):we[0]:ve=z(this.options.smartypants?de(we[0]):we[0]),{type:"text",raw:we[0],text:ve}}},Pe}(),U=N.noopTest,H=N.edit,Y=N.merge,re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=H(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=H(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=H(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=H(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=H(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=H(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=Y({},re),re.gfm=Y({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=H(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=Y({},re.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:H(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=H(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=H(re._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=H(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=H(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=H(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=H(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=H(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=H(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=H(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=H(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=Y({},K),K.pedantic=Y({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=Y({},K.normal,{escape:H(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=H(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=Y({},K.gfm,{br:H(K.br).replace("{2,}","*").getRegex(),text:H(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var j={block:re,inline:K},te=V,ae=_.exports.defaults,ge=j.block,Ie=j.inline,Me=N.repeatString;function Ne(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Pe){var De="",ye,le,de=Pe.length;for(ye=0;ye<de;ye++)le=Pe.charCodeAt(ye),Math.random()>.5&&(le="x"+le.toString(16)),De+="&#"+le+";";return De}var J=function(){function Pe(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ae,this.options.tokenizer=this.options.tokenizer||new te,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var le={block:ge.normal,inline:Ie.normal};this.options.pedantic?(le.block=ge.pedantic,le.inline=Ie.pedantic):this.options.gfm&&(le.block=ge.gfm,this.options.breaks?le.inline=Ie.breaks:le.inline=Ie.gfm),this.tokenizer.rules=le}Pe.lex=function(le,de){var we=new Pe(de);return we.lex(le)},Pe.lexInline=function(le,de){var we=new Pe(de);return we.inlineTokens(le)};var De=Pe.prototype;return De.lex=function(le){le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},De.blockTokens=function(le,de){var we=this;de===void 0&&(de=[]),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var ve,Re,Ge,We;le;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(ve=st.call({lexer:we},le,de))?(le=le.substring(ve.raw.length),de.push(ve),!0):!1}))){if(ve=this.tokenizer.space(le)){le=le.substring(ve.raw.length),ve.type&&de.push(ve);continue}if(ve=this.tokenizer.code(le)){le=le.substring(ve.raw.length),Re=de[de.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):de.push(ve);continue}if(ve=this.tokenizer.fences(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.heading(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.hr(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.blockquote(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.list(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.html(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.def(le)){le=le.substring(ve.raw.length),Re=de[de.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.lheading(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(Ge=le,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,ot=le.slice(1),fe=void 0;we.options.extensions.startBlock.forEach(function(ke){fe=ke.call({lexer:this},ot),typeof fe=="number"&&fe>=0&&(st=Math.min(st,fe))}),st<1/0&&st>=0&&(Ge=le.substring(0,st+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(Ge))){Re=de[de.length-1],We&&Re.type==="paragraph"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):de.push(ve),We=Ge.length!==le.length,le=le.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(le)){le=le.substring(ve.raw.length),Re=de[de.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):de.push(ve);continue}if(le){var Xe="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return this.state.top=!0,de},De.inline=function(le,de){this.inlineQueue.push({src:le,tokens:de})},De.inlineTokens=function(le,de){var we=this;de===void 0&&(de=[]);var ve,Re,Ge,We=le,Xe,st,ot;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;(Xe=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)fe.includes(Xe[0].slice(Xe[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,Xe.index)+"["+Me("a",Xe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Xe=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,Xe.index)+"["+Me("a",Xe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Xe=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,Xe.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;)if(st||(ot=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ve=ue.call({lexer:we},le,de))?(le=le.substring(ve.raw.length),de.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.tag(le)){le=le.substring(ve.raw.length),Re=de[de.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):de.push(ve);continue}if(ve=this.tokenizer.link(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(ve.raw.length),Re=de[de.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):de.push(ve);continue}if(ve=this.tokenizer.emStrong(le,We,ot)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.codespan(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.br(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.del(le)){le=le.substring(ve.raw.length),de.push(ve);continue}if(ve=this.tokenizer.autolink(le,q)){le=le.substring(ve.raw.length),de.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(le,q))){le=le.substring(ve.raw.length),de.push(ve);continue}if(Ge=le,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Q=le.slice(1),Te=void 0;we.options.extensions.startInline.forEach(function(Oe){Te=Oe.call({lexer:this},Q),typeof Te=="number"&&Te>=0&&(ue=Math.min(ue,Te))}),ue<1/0&&ue>=0&&(Ge=le.substring(0,ue+1))}(),ve=this.tokenizer.inlineText(Ge,Ne)){le=le.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(ot=ve.raw.slice(-1)),st=!0,Re=de[de.length-1],Re&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):de.push(ve);continue}if(le){var ke="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return de},e(Pe,null,[{key:"rules",get:function(){return{block:ge,inline:Ie}}}]),Pe}(),ne=_.exports.defaults,he=N.cleanUrl,ee=N.escape,oe=function(){function Pe(ye){this.options=ye||ne}var De=Pe.prototype;return De.code=function(le,de,we){var ve=(de||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(le,ve);Re!=null&&Re!==le&&(we=!0,le=Re)}return le=le.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+ee(ve,!0)+'">'+(we?le:ee(le,!0))+`</code></pre>
`:"<pre><code>"+(we?le:ee(le,!0))+`</code></pre>
`},De.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},De.html=function(le){return le},De.heading=function(le,de,we,ve){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+ve.slug(we)+'">'+le+"</h"+de+`>
`:"<h"+de+">"+le+"</h"+de+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(le,de,we){var ve=de?"ol":"ul",Re=de&&we!==1?' start="'+we+'"':"";return"<"+ve+Re+`>
`+le+"</"+ve+`>
`},De.listitem=function(le){return"<li>"+le+`</li>
`},De.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(le){return"<p>"+le+`</p>
`},De.table=function(le,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+de+`</table>
`},De.tablerow=function(le){return`<tr>
`+le+`</tr>
`},De.tablecell=function(le,de){var we=de.header?"th":"td",ve=de.align?"<"+we+' align="'+de.align+'">':"<"+we+">";return ve+le+"</"+we+`>
`},De.strong=function(le){return"<strong>"+le+"</strong>"},De.em=function(le){return"<em>"+le+"</em>"},De.codespan=function(le){return"<code>"+le+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(le){return"<del>"+le+"</del>"},De.link=function(le,de,we){if(le=he(this.options.sanitize,this.options.baseUrl,le),le===null)return we;var ve='<a href="'+ee(le)+'"';return de&&(ve+=' title="'+de+'"'),ve+=">"+we+"</a>",ve},De.image=function(le,de,we){if(le=he(this.options.sanitize,this.options.baseUrl,le),le===null)return we;var ve='<img src="'+le+'" alt="'+we+'"';return de&&(ve+=' title="'+de+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(le){return le},Pe}(),_e=function(){function Pe(){}var De=Pe.prototype;return De.strong=function(le){return le},De.em=function(le){return le},De.codespan=function(le){return le},De.del=function(le){return le},De.html=function(le){return le},De.text=function(le){return le},De.link=function(le,de,we){return""+we},De.image=function(le,de,we){return""+we},De.br=function(){return""},Pe}(),Ue=function(){function Pe(){this.seen={}}var De=Pe.prototype;return De.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(le,de){var we=le,ve=0;if(this.seen.hasOwnProperty(we)){ve=this.seen[le];do ve++,we=le+"-"+ve;while(this.seen.hasOwnProperty(we))}return de||(this.seen[le]=ve,this.seen[we]=0),we},De.slug=function(le,de){de===void 0&&(de={});var we=this.serialize(le);return this.getNextSafeSlug(we,de.dryrun)},Pe}(),Ve=oe,Ke=_e,Je=Ue,it=_.exports.defaults,at=N.unescape,et=function(){function Pe(ye){this.options=ye||it,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Je}Pe.parse=function(le,de){var we=new Pe(de);return we.parse(le)},Pe.parseInline=function(le,de){var we=new Pe(de);return we.parseInline(le)};var De=Pe.prototype;return De.parse=function(le,de){de===void 0&&(de=!0);var we="",ve,Re,Ge,We,Xe,st,ot,fe,ke,ue,Q,Te,Oe,Ze,qe,ht,wt,yt,bt,mt=le.length;for(ve=0;ve<mt;ve++){if(ue=le[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(bt=this.options.extensions.renderers[ue.type].call({parser:this},ue),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){we+=bt||"";continue}switch(ue.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,at(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(fe="",ot="",We=ue.header.length,Re=0;Re<We;Re++)ot+=this.renderer.tablecell(this.parseInline(ue.header[Re].tokens),{header:!0,align:ue.align[Re]});for(fe+=this.renderer.tablerow(ot),ke="",We=ue.rows.length,Re=0;Re<We;Re++){for(st=ue.rows[Re],ot="",Xe=st.length,Ge=0;Ge<Xe;Ge++)ot+=this.renderer.tablecell(this.parseInline(st[Ge].tokens),{header:!1,align:ue.align[Ge]});ke+=this.renderer.tablerow(ot)}we+=this.renderer.table(fe,ke);continue}case"blockquote":{ke=this.parse(ue.tokens),we+=this.renderer.blockquote(ke);continue}case"list":{for(Q=ue.ordered,Te=ue.start,Oe=ue.loose,We=ue.items.length,ke="",Re=0;Re<We;Re++)qe=ue.items[Re],ht=qe.checked,wt=qe.task,Ze="",qe.task&&(yt=this.renderer.checkbox(ht),Oe?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=yt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=yt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:yt}):Ze+=yt),Ze+=this.parse(qe.tokens,Oe),ke+=this.renderer.listitem(Ze,wt,ht);we+=this.renderer.list(ke,Q,Te);continue}case"html":{we+=this.renderer.html(ue.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(ke=ue.tokens?this.parseInline(ue.tokens):ue.text;ve+1<mt&&le[ve+1].type==="text";)ue=le[++ve],ke+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);we+=de?this.renderer.paragraph(ke):ke;continue}default:{var vt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return we},De.parseInline=function(le,de){de=de||this.renderer;var we="",ve,Re,Ge,We=le.length;for(ve=0;ve<We;ve++){if(Re=le[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(Ge=this.options.extensions.renderers[Re.type].call({parser:this},Re),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){we+=Ge||"";continue}switch(Re.type){case"escape":{we+=de.text(Re.text);break}case"html":{we+=de.html(Re.text);break}case"link":{we+=de.link(Re.href,Re.title,this.parseInline(Re.tokens,de));break}case"image":{we+=de.image(Re.href,Re.title,Re.text);break}case"strong":{we+=de.strong(this.parseInline(Re.tokens,de));break}case"em":{we+=de.em(this.parseInline(Re.tokens,de));break}case"codespan":{we+=de.codespan(Re.text);break}case"br":{we+=de.br();break}case"del":{we+=de.del(this.parseInline(Re.tokens,de));break}case"text":{we+=de.text(Re.text);break}default:{var Xe='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return we},Pe}(),nt=J,ct=et,dt=V,Pt=oe,xe=_e,Rt=Ue,Z=N.merge,ie=N.checkSanitizeDeprecation,be=N.escape,ze=_.exports.getDefaults,Qe=_.exports.changeDefaults,me=_.exports.defaults;function Ce(Pe,De,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof De=="function"&&(ye=De,De=null),De=Z({},Ce.defaults,De||{}),ie(De),ye){var le=De.highlight,de;try{de=nt.lex(Pe,De)}catch(Ge){return ye(Ge)}var we=function(We){var Xe;if(!We)try{De.walkTokens&&Ce.walkTokens(de,De.walkTokens),Xe=ct.parse(de,De)}catch(st){We=st}return De.highlight=le,We?ye(We):ye(null,Xe)};if(!le||le.length<3||(delete De.highlight,!de.length))return we();var ve=0;Ce.walkTokens(de,function(Ge){Ge.type==="code"&&(ve++,setTimeout(function(){le(Ge.text,Ge.lang,function(We,Xe){if(We)return we(We);Xe!=null&&Xe!==Ge.text&&(Ge.text=Xe,Ge.escaped=!0),ve--,ve===0&&we()})},0))}),ve===0&&we();return}try{var Re=nt.lex(Pe,De);return De.walkTokens&&Ce.walkTokens(Re,De.walkTokens),ct.parse(Re,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+be(Ge.message+"",!0)+"</pre>";throw Ge}}Ce.options=Ce.setOptions=function(Pe){return Z(Ce.defaults,Pe),Qe(Ce.defaults),Ce},Ce.getDefaults=ze,Ce.defaults=me,Ce.use=function(){for(var Pe=this,De=arguments.length,ye=new Array(De),le=0;le<De;le++)ye[le]=arguments[le];var de=Z.apply(void 0,[{}].concat(ye)),we=Ce.defaults.extensions||{renderers:{},childTokens:{}},ve;ye.forEach(function(Re){if(Re.extensions&&(ve=!0,Re.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Xe=we.renderers?we.renderers[We.name]:null;Xe?we.renderers[We.name]=function(){for(var st=arguments.length,ot=new Array(st),fe=0;fe<st;fe++)ot[fe]=arguments[fe];var ke=We.renderer.apply(this,ot);return ke===!1&&(ke=Xe.apply(this,ot)),ke}:we.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[We.level]?we[We.level].unshift(We.tokenizer):we[We.level]=[We.tokenizer],We.start&&(We.level==="block"?we.startBlock?we.startBlock.push(We.start):we.startBlock=[We.start]:We.level==="inline"&&(we.startInline?we.startInline.push(We.start):we.startInline=[We.start]))}We.childTokens&&(we.childTokens[We.name]=We.childTokens)})),Re.renderer&&function(){var We=Ce.defaults.renderer||new Pt,Xe=function(fe){var ke=We[fe];We[fe]=function(){for(var ue=arguments.length,Q=new Array(ue),Te=0;Te<ue;Te++)Q[Te]=arguments[Te];var Oe=Re.renderer[fe].apply(We,Q);return Oe===!1&&(Oe=ke.apply(We,Q)),Oe}};for(var st in Re.renderer)Xe(st);de.renderer=We}(),Re.tokenizer&&function(){var We=Ce.defaults.tokenizer||new dt,Xe=function(fe){var ke=We[fe];We[fe]=function(){for(var ue=arguments.length,Q=new Array(ue),Te=0;Te<ue;Te++)Q[Te]=arguments[Te];var Oe=Re.tokenizer[fe].apply(We,Q);return Oe===!1&&(Oe=ke.apply(We,Q)),Oe}};for(var st in Re.tokenizer)Xe(st);de.tokenizer=We}(),Re.walkTokens){var Ge=Ce.defaults.walkTokens;de.walkTokens=function(We){Re.walkTokens.call(Pe,We),Ge&&Ge(We)}}ve&&(de.extensions=we),Ce.setOptions(de)})},Ce.walkTokens=function(Pe,De){for(var ye=function(){var ve=de.value;switch(De(ve),ve.type){case"table":{for(var Re=D(ve.header),Ge;!(Ge=Re()).done;){var We=Ge.value;Ce.walkTokens(We.tokens,De)}for(var Xe=D(ve.rows),st;!(st=Xe()).done;)for(var ot=st.value,fe=D(ot),ke;!(ke=fe()).done;){var ue=ke.value;Ce.walkTokens(ue.tokens,De)}break}case"list":{Ce.walkTokens(ve.items,De);break}default:Ce.defaults.extensions&&Ce.defaults.extensions.childTokens&&Ce.defaults.extensions.childTokens[ve.type]?Ce.defaults.extensions.childTokens[ve.type].forEach(function(Q){Ce.walkTokens(ve[Q],De)}):ve.tokens&&Ce.walkTokens(ve.tokens,De)}},le=D(Pe),de;!(de=le()).done;)ye()},Ce.parseInline=function(Pe,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");De=Z({},Ce.defaults,De||{}),ie(De);try{var ye=nt.lexInline(Pe,De);return De.walkTokens&&Ce.walkTokens(ye,De.walkTokens),ct.parseInline(ye,De)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+be(le.message+"",!0)+"</pre>";throw le}},Ce.Parser=ct,Ce.parser=ct.parse,Ce.Renderer=Pt,Ce.TextRenderer=xe,Ce.Lexer=nt,Ce.lexer=nt.lex,Ce.Tokenizer=dt,Ce.Slugger=Rt,Ce.parse=Ce;var $e=Ce;return $e}),define(Ee[78],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(P,k,C){return Math.min(Math.max(P,k),C)}e.clamp=g;function i(P,k){return(k+P%k)%k}e.rot=i;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class _{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=_}),function(){function X(D){const _=[];typeof D=="number"&&_.push("code/timeOrigin",D);function P(C){_.push(C,Date.now())}function k(){const C=[];for(let I=0;I<_.length;I+=2)C.push({name:_[I],startTime:_[I+1]});return C}return{mark:P,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))_.push({name:P.name,startTime:Math.round(D+P.startTime)});return _}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=g(i))}(),define(Ee[12],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let i=!1,D=!1,_=!1,P=!1,k=!1,C=!1,I=!1,L=!1,T,c=g,E,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const v=typeof w?.versions?.electron=="string",R=v&&w?.type==="renderer";if(e.isElectronSandboxed=R&&w?.sandboxed,typeof navigator=="object"&&!R)h=navigator.userAgent,i=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=h.indexOf("Linux")>=0,C=!0,T=navigator.language,c=T;else if(typeof w=="object"){i=w.platform==="win32",D=w.platform==="darwin",_=w.platform==="linux",P=_&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,I=v,T=g,c=g;const r=w.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),d=l.availableLanguages["*"];T=l.locale,c=d||g,E=l._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function s(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let o=0;D?o=1:i?o=3:_&&(o=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=_,e.isLinuxSnap=P,e.isNative=k,e.isElectron=I,e.isWeb=C,e.isIOS=L,e.platform=o,e.userAgent=h,e.language=c;var p;(function(r){function l(){return e.language}r.value=l;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=d;function m(){return e.language==="en"}r.isDefault=m})(p=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let m=0,f=r.length;m<f;m++){const u=r[m];if(u.id===d.data.vscodeScheduleAsyncWork){r.splice(m,1),u.callback();return}}});let l=0;return d=>{const m=++l;r.push({id:m,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:m},"*")}}return r=>setTimeout(r)})();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||L?2:i?1:3;let S=!0,n=!1;function t(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,S=new Uint16Array(r.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=t}),define(Ee[40],Se([0,1,12]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(Ee[9],Se([0,1,40]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,_=90,P=122,k=46,C=47,I=92,L=58,T=63;class c extends Error{constructor(o,p,a){let S;typeof p=="string"&&p.indexOf("not ")===0?(S="must not be",p=p.replace(/^not /,"")):S="must be";const n=o.indexOf(".")!==-1?"property":"argument";let t=`The "${o}" ${n} ${S} of type ${p}`;t+=`. Received type ${typeof a}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function E(s,o){if(typeof s!="string")throw new c(o,"string",s)}function h(s){return s===C||s===I}function w(s){return s===C}function v(s){return s>=i&&s<=_||s>=D&&s<=P}function R(s,o,p,a){let S="",n=0,t=-1,r=0,l=0;for(let d=0;d<=s.length;++d){if(d<s.length)l=s.charCodeAt(d);else{if(a(l))break;l=C}if(a(l)){if(!(t===d-1||r===1))if(r===2){if(S.length<2||n!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const m=S.lastIndexOf(p);m===-1?(S="",n=0):(S=S.slice(0,m),n=S.length-1-S.lastIndexOf(p)),t=d,r=0;continue}else if(S.length!==0){S="",n=0,t=d,r=0;continue}}o&&(S+=S.length>0?`${p}..`:"..",n=2)}else S.length>0?S+=`${p}${s.slice(t+1,d)}`:S=s.slice(t+1,d),n=d-t-1;t=d,r=0}else l===k&&r!==-1?++r:r=-1}return S}function b(s,o){if(o===null||typeof o!="object")throw new c("pathObject","Object",o);const p=o.dir||o.root,a=o.base||`${o.name||""}${o.ext||""}`;return p?p===o.root?`${p}${a}`:`${p}${s}${a}`:a}e.win32={resolve(...s){let o="",p="",a=!1;for(let S=s.length-1;S>=-1;S--){let n;if(S>=0){if(n=s[S],E(n,"path"),n.length===0)continue}else o.length===0?n=g.cwd():(n=g.env[`=${o}`]||g.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===I)&&(n=`${o}\\`));const t=n.length;let r=0,l="",d=!1;const m=n.charCodeAt(0);if(t===1)h(m)&&(r=1,d=!0);else if(h(m))if(d=!0,h(n.charCodeAt(1))){let f=2,u=f;for(;f<t&&!h(n.charCodeAt(f));)f++;if(f<t&&f!==u){const y=n.slice(u,f);for(u=f;f<t&&h(n.charCodeAt(f));)f++;if(f<t&&f!==u){for(u=f;f<t&&!h(n.charCodeAt(f));)f++;(f===t||f!==u)&&(l=`\\\\${y}\\${n.slice(u,f)}`,r=f)}}}else r=1;else v(m)&&n.charCodeAt(1)===L&&(l=n.slice(0,2),r=2,t>2&&h(n.charCodeAt(2))&&(d=!0,r=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(a){if(o.length>0)break}else if(p=`${n.slice(r)}\\${p}`,a=d,d&&o.length>0)break}return p=R(p,!a,"\\",h),a?`${o}\\${p}`:`${o}${p}`||"."},normalize(s){E(s,"path");const o=s.length;if(o===0)return".";let p=0,a,S=!1;const n=s.charCodeAt(0);if(o===1)return w(n)?"\\":s;if(h(n))if(S=!0,h(s.charCodeAt(1))){let r=2,l=r;for(;r<o&&!h(s.charCodeAt(r));)r++;if(r<o&&r!==l){const d=s.slice(l,r);for(l=r;r<o&&h(s.charCodeAt(r));)r++;if(r<o&&r!==l){for(l=r;r<o&&!h(s.charCodeAt(r));)r++;if(r===o)return`\\\\${d}\\${s.slice(l)}\\`;r!==l&&(a=`\\\\${d}\\${s.slice(l,r)}`,p=r)}}}else p=1;else v(n)&&s.charCodeAt(1)===L&&(a=s.slice(0,2),p=2,o>2&&h(s.charCodeAt(2))&&(S=!0,p=3));let t=p<o?R(s.slice(p),!S,"\\",h):"";return t.length===0&&!S&&(t="."),t.length>0&&h(s.charCodeAt(o-1))&&(t+="\\"),a===void 0?S?`\\${t}`:t:S?`${a}\\${t}`:`${a}${t}`},isAbsolute(s){E(s,"path");const o=s.length;if(o===0)return!1;const p=s.charCodeAt(0);return h(p)||o>2&&v(p)&&s.charCodeAt(1)===L&&h(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,p;for(let n=0;n<s.length;++n){const t=s[n];E(t,"path"),t.length>0&&(o===void 0?o=p=t:o+=`\\${t}`)}if(o===void 0)return".";let a=!0,S=0;if(typeof p=="string"&&h(p.charCodeAt(0))){++S;const n=p.length;n>1&&h(p.charCodeAt(1))&&(++S,n>2&&(h(p.charCodeAt(2))?++S:a=!1))}if(a){for(;S<o.length&&h(o.charCodeAt(S));)S++;S>=2&&(o=`\\${o.slice(S)}`)}return e.win32.normalize(o)},relative(s,o){if(E(s,"from"),E(o,"to"),s===o)return"";const p=e.win32.resolve(s),a=e.win32.resolve(o);if(p===a||(s=p.toLowerCase(),o=a.toLowerCase(),s===o))return"";let S=0;for(;S<s.length&&s.charCodeAt(S)===I;)S++;let n=s.length;for(;n-1>S&&s.charCodeAt(n-1)===I;)n--;const t=n-S;let r=0;for(;r<o.length&&o.charCodeAt(r)===I;)r++;let l=o.length;for(;l-1>r&&o.charCodeAt(l-1)===I;)l--;const d=l-r,m=t<d?t:d;let f=-1,u=0;for(;u<m;u++){const A=s.charCodeAt(S+u);if(A!==o.charCodeAt(r+u))break;A===I&&(f=u)}if(u!==m){if(f===-1)return a}else{if(d>m){if(o.charCodeAt(r+u)===I)return a.slice(r+u+1);if(u===2)return a.slice(r+u)}t>m&&(s.charCodeAt(S+u)===I?f=u:u===2&&(f=3)),f===-1&&(f=0)}let y="";for(u=S+f+1;u<=n;++u)(u===n||s.charCodeAt(u)===I)&&(y+=y.length===0?"..":"\\..");return r+=f,y.length>0?`${y}${a.slice(r,l)}`:(a.charCodeAt(r)===I&&++r,a.slice(r,l))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const p=o.charCodeAt(2);if(p!==T&&p!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(v(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return s},dirname(s){E(s,"path");const o=s.length;if(o===0)return".";let p=-1,a=0;const S=s.charCodeAt(0);if(o===1)return h(S)?s:".";if(h(S)){if(p=a=1,h(s.charCodeAt(1))){let r=2,l=r;for(;r<o&&!h(s.charCodeAt(r));)r++;if(r<o&&r!==l){for(l=r;r<o&&h(s.charCodeAt(r));)r++;if(r<o&&r!==l){for(l=r;r<o&&!h(s.charCodeAt(r));)r++;if(r===o)return s;r!==l&&(p=a=r+1)}}}}else v(S)&&s.charCodeAt(1)===L&&(p=o>2&&h(s.charCodeAt(2))?3:2,a=p);let n=-1,t=!0;for(let r=o-1;r>=a;--r)if(h(s.charCodeAt(r))){if(!t){n=r;break}}else t=!1;if(n===-1){if(p===-1)return".";n=p}return s.slice(0,n)},basename(s,o){o!==void 0&&E(o,"ext"),E(s,"path");let p=0,a=-1,S=!0,n;if(s.length>=2&&v(s.charCodeAt(0))&&s.charCodeAt(1)===L&&(p=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,r=-1;for(n=s.length-1;n>=p;--n){const l=s.charCodeAt(n);if(h(l)){if(!S){p=n+1;break}}else r===-1&&(S=!1,r=n+1),t>=0&&(l===o.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=r))}return p===a?a=r:a===-1&&(a=s.length),s.slice(p,a)}for(n=s.length-1;n>=p;--n)if(h(s.charCodeAt(n))){if(!S){p=n+1;break}}else a===-1&&(S=!1,a=n+1);return a===-1?"":s.slice(p,a)},extname(s){E(s,"path");let o=0,p=-1,a=0,S=-1,n=!0,t=0;s.length>=2&&s.charCodeAt(1)===L&&v(s.charCodeAt(0))&&(o=a=2);for(let r=s.length-1;r>=o;--r){const l=s.charCodeAt(r);if(h(l)){if(!n){a=r+1;break}continue}S===-1&&(n=!1,S=r+1),l===k?p===-1?p=r:t!==1&&(t=1):p!==-1&&(t=-1)}return p===-1||S===-1||t===0||t===1&&p===S-1&&p===a+1?"":s.slice(p,S)},format:b.bind(null,"\\"),parse(s){E(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const p=s.length;let a=0,S=s.charCodeAt(0);if(p===1)return h(S)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(h(S)){if(a=1,h(s.charCodeAt(1))){let f=2,u=f;for(;f<p&&!h(s.charCodeAt(f));)f++;if(f<p&&f!==u){for(u=f;f<p&&h(s.charCodeAt(f));)f++;if(f<p&&f!==u){for(u=f;f<p&&!h(s.charCodeAt(f));)f++;f===p?a=f:f!==u&&(a=f+1)}}}}else if(v(S)&&s.charCodeAt(1)===L){if(p<=2)return o.root=o.dir=s,o;if(a=2,h(s.charCodeAt(2))){if(p===3)return o.root=o.dir=s,o;a=3}}a>0&&(o.root=s.slice(0,a));let n=-1,t=a,r=-1,l=!0,d=s.length-1,m=0;for(;d>=a;--d){if(S=s.charCodeAt(d),h(S)){if(!l){t=d+1;break}continue}r===-1&&(l=!1,r=d+1),S===k?n===-1?n=d:m!==1&&(m=1):n!==-1&&(m=-1)}return r!==-1&&(n===-1||m===0||m===1&&n===r-1&&n===t+1?o.base=o.name=s.slice(t,r):(o.name=s.slice(t,n),o.base=s.slice(t,r),o.ext=s.slice(n,r))),t>0&&t!==a?o.dir=s.slice(0,t-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let o="",p=!1;for(let a=s.length-1;a>=-1&&!p;a--){const S=a>=0?s[a]:g.cwd();E(S,"path"),S.length!==0&&(o=`${S}/${o}`,p=S.charCodeAt(0)===C)}return o=R(o,!p,"/",w),p?`/${o}`:o.length>0?o:"."},normalize(s){if(E(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===C,p=s.charCodeAt(s.length-1)===C;return s=R(s,!o,"/",w),s.length===0?o?"/":p?"./":".":(p&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return E(s,"path"),s.length>0&&s.charCodeAt(0)===C},join(...s){if(s.length===0)return".";let o;for(let p=0;p<s.length;++p){const a=s[p];E(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(E(s,"from"),E(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const p=1,a=s.length,S=a-p,n=1,t=o.length-n,r=S<t?S:t;let l=-1,d=0;for(;d<r;d++){const f=s.charCodeAt(p+d);if(f!==o.charCodeAt(n+d))break;f===C&&(l=d)}if(d===r)if(t>r){if(o.charCodeAt(n+d)===C)return o.slice(n+d+1);if(d===0)return o.slice(n+d)}else S>r&&(s.charCodeAt(p+d)===C?l=d:d===0&&(l=0));let m="";for(d=p+l+1;d<=a;++d)(d===a||s.charCodeAt(d)===C)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(n+l)}`},toNamespacedPath(s){return s},dirname(s){if(E(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===C;let p=-1,a=!0;for(let S=s.length-1;S>=1;--S)if(s.charCodeAt(S)===C){if(!a){p=S;break}}else a=!1;return p===-1?o?"/":".":o&&p===1?"//":s.slice(0,p)},basename(s,o){o!==void 0&&E(o,"ext"),E(s,"path");let p=0,a=-1,S=!0,n;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,r=-1;for(n=s.length-1;n>=0;--n){const l=s.charCodeAt(n);if(l===C){if(!S){p=n+1;break}}else r===-1&&(S=!1,r=n+1),t>=0&&(l===o.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=r))}return p===a?a=r:a===-1&&(a=s.length),s.slice(p,a)}for(n=s.length-1;n>=0;--n)if(s.charCodeAt(n)===C){if(!S){p=n+1;break}}else a===-1&&(S=!1,a=n+1);return a===-1?"":s.slice(p,a)},extname(s){E(s,"path");let o=-1,p=0,a=-1,S=!0,n=0;for(let t=s.length-1;t>=0;--t){const r=s.charCodeAt(t);if(r===C){if(!S){p=t+1;break}continue}a===-1&&(S=!1,a=t+1),r===k?o===-1?o=t:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||a===-1||n===0||n===1&&o===a-1&&o===p+1?"":s.slice(o,a)},format:b.bind(null,"/"),parse(s){E(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const p=s.charCodeAt(0)===C;let a;p?(o.root="/",a=1):a=0;let S=-1,n=0,t=-1,r=!0,l=s.length-1,d=0;for(;l>=a;--l){const m=s.charCodeAt(l);if(m===C){if(!r){n=l+1;break}continue}t===-1&&(r=!1,t=l+1),m===k?S===-1?S=l:d!==1&&(d=1):S!==-1&&(d=-1)}if(t!==-1){const m=n===0&&p?1:n;S===-1||d===0||d===1&&S===t-1&&S===n+1?o.base=o.name=s.slice(m,t):(o.name=s.slice(m,S),o.base=s.slice(m,t),o.ext=s.slice(S,t))}return n>0?o.dir=s.slice(0,n-1):p&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ee[95],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var i;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(_,...P){const k=P.reduce((L,T)=>(L[T]=!0,L),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(L=>!k[L]).forEach(L=>{for(let T=0;T<C.length;T++)if(L.search(C[T])!==-1){delete _[L];break}})}e.sanitizeProcessEnvironment=D}),define(Ee[46],Se([0,1,12]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(P){this._highResolution=i&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Ee[3],Se([0,1,15,75,6,94,46]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(o){o.None=()=>D.Disposable.None;function p(M){return(x,V=null,U)=>{let H=!1,Y;return Y=M(re=>{if(!H)return Y?Y.dispose():H=!0,x.call(V,re)},null,U),H&&Y.dispose(),Y}}o.once=p;function a(M,x){return d((V,U=null,H)=>M(Y=>V.call(U,x(Y)),null,H))}o.map=a;function S(M,x){return d((V,U=null,H)=>M(Y=>{x(Y),V.call(U,Y)},null,H))}o.forEach=S;function n(M,x){return d((V,U=null,H)=>M(Y=>x(Y)&&V.call(U,Y),null,H))}o.filter=n;function t(M){return M}o.signal=t;function r(...M){return(x,V=null,U)=>(0,D.combinedDisposable)(...M.map(H=>H(Y=>x.call(V,Y),null,U)))}o.any=r;function l(M,x,V){let U=V;return a(M,H=>(U=x(U,H),U))}o.reduce=l;function d(M){let x;const V=new c({onFirstListenerAdd(){x=M(V.fire,V)},onLastListenerRemove(){x.dispose()}});return V.event}function m(M,x,V,U=100,H=!1){let Y,re,K=0;return M(j=>{K++,Y=V(Y,j),H&&!re&&(x(Y),Y=void 0),clearTimeout(re),re=setTimeout(()=>{const te=Y;Y=void 0,re=void 0,(!H||K>1)&&x(te),K=0},U)})}o.debouncedListener=m;function f(M,x,V=100,U=!1,H){let Y,re,K,j=0;const te=new c({leakWarningThreshold:H,onFirstListenerAdd(){Y=M(ae=>{j++,re=x(re,ae),U&&!K&&(te.fire(re),re=void 0),clearTimeout(K),K=setTimeout(()=>{const ge=re;re=void 0,K=void 0,(!U||j>1)&&te.fire(ge),j=0},V)})},onLastListenerRemove(){Y.dispose()}});return te.event}o.debounce=f;function u(M,x=(V,U)=>V===U){let V=!0,U;return n(M,H=>{const Y=V||!x(H,U);return V=!1,U=H,Y})}o.latch=u;function y(M,x){return[o.filter(M,x),o.filter(M,V=>!x(V))]}o.split=y;function A(M,x=!1,V=[]){let U=V.slice(),H=M(K=>{U?U.push(K):re.fire(K)});const Y=()=>{U&&U.forEach(K=>re.fire(K)),U=null},re=new c({onFirstListenerAdd(){H||(H=M(K=>re.fire(K)))},onFirstListenerDidAdd(){U&&(x?setTimeout(Y):Y())},onLastListenerRemove(){H&&H.dispose(),H=null}});return re.event}o.buffer=A;class N{constructor(x){this.event=x}map(x){return new N(a(this.event,x))}forEach(x){return new N(S(this.event,x))}filter(x){return new N(n(this.event,x))}reduce(x,V){return new N(l(this.event,x,V))}latch(){return new N(u(this.event))}debounce(x,V=100,U=!1,H){return new N(f(this.event,x,V,U,H))}on(x,V,U){return this.event(x,V,U)}once(x,V,U){return p(this.event)(x,V,U)}}function B(M){return new N(M)}o.chain=B;function F(M,x,V=U=>U){const U=(...K)=>re.fire(V(...K)),H=()=>M.on(x,U),Y=()=>M.removeListener(x,U),re=new c({onFirstListenerAdd:H,onLastListenerRemove:Y});return re.event}o.fromNodeEventEmitter=F;function O(M,x,V=U=>U){const U=(...K)=>re.fire(V(...K)),H=()=>M.addEventListener(x,U),Y=()=>M.removeEventListener(x,U),re=new c({onFirstListenerAdd:H,onLastListenerRemove:Y});return re.event}o.fromDOMEventEmitter=O;function z(M){return new Promise(x=>p(M)(x))}o.toPromise=z;function W(M,x){return x(void 0),M(V=>x(V))}o.runAndSubscribe=W})(k=e.Event||(e.Event={}));class C{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${C._idPool++}`}start(p){this._stopWatch=new P.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let I=-1;function L(o){const p=I;return I=o,{dispose(){I=p}}}e.setGlobalLeakWarningThreshold=L;class T{constructor(p,a=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let a=I;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||p<a)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(S)||0;if(this._stacks.set(S,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,r=0;for(const[l,d]of this._stacks)(!t||r<d)&&(t=l,r=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(S)||0;this._stacks.set(S,t-1)}}}class c{constructor(p){this._disposed=!1,this._options=p,this._leakageMon=I>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(p,a,S)=>{this._listeners||(this._listeners=new _.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(a?[p,a]:p);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,a);const r=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof D.DisposableStore?S.add(l):Array.isArray(S)&&S.push(l),l}),this._event}fire(p){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,p]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,S]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,S):a[0].call(a[1],S)}catch(n){(0,g.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class E extends c{async fireAsync(p,a,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,p]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),r=[],l={...t,token:a,waitUntil:d=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");S&&(d=S(d,typeof n=="function"?n:n[0])),r.push(d)}};try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(d){(0,g.onUnexpectedError)(d);continue}Object.freeze(r),await Promise.allSettled(r).then(d=>{for(const m of d)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=E;class h extends c{constructor(p){super(p);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=h;class w extends h{constructor(p){super(p);this._delay=p.delay??100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}e.DebounceEmitter=w;class v extends c{constructor(p){super(p);this._queuedEvents=[],this._mergeFn=p?.merge}fire(p){this._queuedEvents.push(p),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class R{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const a={event:p,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const S=()=>{this.hasListeners&&this.unhook(a);const n=this.events.indexOf(a);this.events.splice(n,1)};return(0,D.toDisposable)((0,i.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(a=>this.emitter.fire(a))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=R;class b{constructor(){this.buffers=[]}wrapEvent(p){return(a,S,n)=>p(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>a.call(S,t)):a.call(S,t)},void 0,n)}bufferEvents(p){const a=[];this.buffers.push(a);const S=p();return this.buffers.pop(),a.forEach(n=>n()),S}}e.EventBufferer=b;class s{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(Ee[21],Se([0,1,3]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(k,C){const I=setTimeout(k.bind(C),0);return{dispose(){clearTimeout(I)}}});var D;(function(k){function C(I){return I===k.None||I===k.Cancelled||I instanceof _?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}k.isCancellationToken=C,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=D.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Ee[141],Se([0,1,21]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class i{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new g.CancellationTokenSource,k=this.task(P.token);return this.result={promise:k,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=i;class D{constructor(P){this.computeFn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const k=JSON.stringify(P);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(P)),this.lastCache}}e.LRUCachedComputed=D}),define(Ee[96],Se([0,1,15,6]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=D;function _(s){const o=s;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=_;function P(s,o){return new k(s,o)}e.newWriteableStream=P;class k{constructor(o,p){this.reducer=o,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(p=>p(o))}emitError(o){this.listeners.error.length===0?(0,g.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(p=>p(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,p){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(o,p){if(this.state.destroyed)return;let a;switch(o){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const S=a.indexOf(p);S>=0&&a.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(s,o){const p=[];let a;for(;(a=s.read())!==null;)p.push(a);return o(p)}e.consumeReadable=C;function I(s,o,p){const a=[];let S;for(;(S=s.read())!==null&&a.length<p;)a.push(S);return S===null&&a.length>0?o(a):{read:()=>{if(a.length>0)return a.shift();if(typeof S!="undefined"){const n=S;return S=void 0,n}return s.read()}}}e.peekReadable=I;function L(s,o){return new Promise((p,a)=>{const S=[];T(s,{onData:n=>{o&&S.push(n)},onError:n=>{o?a(n):p(void 0)},onEnd:()=>{p(o?o(S):void 0)}})})}e.consumeStream=L;function T(s,o){let p=!1;return s.on("error",a=>{p||o.onError(a)}),s.on("end",()=>{p||o.onEnd()}),s.on("data",a=>{p||o.onData(a)}),(0,i.toDisposable)(()=>p=!0)}e.listenStream=T;function c(s,o){return new Promise((p,a)=>{const S=new i.DisposableStore,n=[],t=d=>{if(n.push(d),n.length>o)return S.dispose(),s.pause(),p({stream:s,buffer:n,ended:!1})},r=d=>a(d),l=()=>p({stream:s,buffer:n,ended:!0});S.add((0,i.toDisposable)(()=>s.removeListener("error",r))),s.on("error",r),S.add((0,i.toDisposable)(()=>s.removeListener("end",l))),s.on("end",l),S.add((0,i.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=c;function E(s,o){const p=P(o);return p.end(s),p}e.toStream=E;function h(){const s=P(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=h;function w(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}e.toReadable=w;function v(s,o,p){const a=P(p);return T(s,{onData:S=>a.write(o.data(S)),onError:S=>a.error(o.error?o.error(S):S),onEnd:()=>a.end()}),a}e.transform=v;function R(s,o,p){let a=!1;return{read:()=>{const S=o.read();return a?S:(a=!0,S!==null?p([s,S]):s)}}}e.prefixedReadable=R;function b(s,o,p){let a=!1;const S=P(p);return T(o,{onData:n=>a?S.write(n):(a=!0,S.write(p([s,n]))),onError:n=>S.error(n),onEnd:()=>{a||(a=!0,S.write(s)),S.end()}}),S}e.prefixedStream=b}),define(Ee[22],Se([0,1,96]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let D,_;class P{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new P(Buffer.allocUnsafe(t)):new P(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new P(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&i?new P(Buffer.from(t)):(D||(D=new TextEncoder),new P(D.encode(t)))}static fromByteArray(t){const r=P.alloc(t.length);for(let l=0,d=t.length;l<d;l++)r.buffer[l]=t[l];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let m=0,f=t.length;m<f;m++)r+=t[m].byteLength}const l=P.alloc(r);let d=0;for(let m=0,f=t.length;m<f;m++){const u=t[m];l.set(u,d),d+=u.byteLength}return l}clone(){const t=P.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(t,r){return new P(this.buffer.subarray(t,r))}set(t,r){if(t instanceof P)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,r){L(this.buffer,t,r)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,r){c(this.buffer,t,r)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,r){h(this.buffer,t,r)}}e.VSBuffer=P;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=k;function C(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255}e.writeUInt16LE=C;function I(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=I;function L(n,t,r){n[r+3]=t,t=t>>>8,n[r+2]=t,t=t>>>8,n[r+1]=t,t=t>>>8,n[r]=t}e.writeUInt32BE=L;function T(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=T;function c(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255,t=t>>>8,n[r+2]=t&255,t=t>>>8,n[r+3]=t&255}e.writeUInt32LE=c;function E(n,t){return n[t]}e.readUInt8=E;function h(n,t,r){n[r]=t}e.writeUInt8=h;function w(n){return g.consumeReadable(n,t=>P.concat(t))}e.readableToBuffer=w;function v(n){return g.toReadable(n)}e.bufferToReadable=v;function R(n){return g.consumeStream(n,t=>P.concat(t))}e.streamToBuffer=R;async function b(n){return n.ended?P.concat(n.buffer):P.concat([...n.buffer,await R(n.stream)])}e.bufferedStreamToBuffer=b;function s(n){return g.toStream(n,t=>P.concat(t))}e.bufferToStream=s;function o(n){return g.transform(n,{data:t=>typeof t=="string"?P.fromString(t):P.wrap(t)},t=>P.concat(t))}e.streamToBufferReadableStream=o;function p(n){return g.newWriteableStream(t=>P.concat(t),n)}e.newWriteableBufferStream=p;function a(n,t){return g.prefixedReadable(n,t,r=>P.concat(r))}e.prefixedBufferReadable=a;function S(n,t){return g.prefixedStream(n,t,r=>P.concat(r))}e.prefixedBufferStream=S}),define(Ee[8],Se([0,1,141,93]),function(X,e,g,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(me){return!me||typeof me!="string"?!0:me.trim().length===0}e.isFalsyOrWhitespace=_;const P=/{(\d+)}/g;function k(me,...Ce){return Ce.length===0?me:me.replace(P,function($e,Pe){const De=parseInt(Pe,10);return isNaN(De)||De<0||De>=Ce.length?$e:Ce[De]})}e.format=k;const C=/{([^}]+)}/g;function I(me,Ce){return me.replace(C,($e,Pe)=>Ce[Pe]??$e)}e.format2=I;function L(me){return me.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=L;function T(me){return me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function c(me,Ce){let $e=0;const Pe=Ce.charCodeAt(0);for(let De=me.length-1;De>=0;De--)me.charCodeAt(De)===Pe&&$e++;return $e}e.count=c;function E(me,Ce,$e="\u2026"){return me.length<=Ce?me:`${me.substr(0,Ce)}${$e}`}e.truncate=E;function h(me,Ce=" "){const $e=w(me,Ce);return v($e,Ce)}e.trim=h;function w(me,Ce){if(!me||!Ce)return me;const $e=Ce.length;if($e===0||me.length===0)return me;let Pe=0;for(;me.indexOf(Ce,Pe)===Pe;)Pe=Pe+$e;return me.substring(Pe)}e.ltrim=w;function v(me,Ce){if(!me||!Ce)return me;const $e=Ce.length,Pe=me.length;if($e===0||Pe===0)return me;let De=Pe,ye=-1;for(;ye=me.lastIndexOf(Ce,De-1),!(ye===-1||ye+$e!==De);){if(ye===0)return"";De=ye}return me.substring(0,De)}e.rtrim=v;function R(me){return me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=R;function b(me){return me.replace(/\*/g,"")}e.stripWildcards=b;function s(me,Ce,$e={}){if(!me)throw new Error("Cannot create regex from empty string");Ce||(me=T(me)),$e.wholeWord&&(/\B/.test(me.charAt(0))||(me="\\b"+me),/\B/.test(me.charAt(me.length-1))||(me=me+"\\b"));let Pe="";return $e.global&&(Pe+="g"),$e.matchCase||(Pe+="i"),$e.multiline&&(Pe+="m"),$e.unicode&&(Pe+="u"),new RegExp(me,Pe)}e.createRegExp=s;function o(me){return me.source==="^"||me.source==="^$"||me.source==="$"||me.source==="^\\s*$"?!1:!!(me.exec("")&&me.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function p(me){return!!me.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function a(me){return(me.global?"g":"")+(me.ignoreCase?"i":"")+(me.multiline?"m":"")+(me.unicode?"u":"")}e.regExpFlags=a;function S(me){return me.split(/\r\n|\r|\n/)}e.splitLines=S;function n(me){for(let Ce=0,$e=me.length;Ce<$e;Ce++){const Pe=me.charCodeAt(Ce);if(Pe!==32&&Pe!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function t(me,Ce=0,$e=me.length){for(let Pe=Ce;Pe<$e;Pe++){const De=me.charCodeAt(Pe);if(De!==32&&De!==9)return me.substring(Ce,Pe)}return me.substring(Ce,$e)}e.getLeadingWhitespace=t;function r(me,Ce=me.length-1){for(let $e=Ce;$e>=0;$e--){const Pe=me.charCodeAt($e);if(Pe!==32&&Pe!==9)return $e}return-1}e.lastNonWhitespaceIndex=r;function l(me,Ce){return me<Ce?-1:me>Ce?1:0}e.compare=l;function d(me,Ce,$e=0,Pe=me.length,De=0,ye=Ce.length){for(;$e<Pe&&De<ye;$e++,De++){let we=me.charCodeAt($e),ve=Ce.charCodeAt(De);if(we<ve)return-1;if(we>ve)return 1}const le=Pe-$e,de=ye-De;return le<de?-1:le>de?1:0}e.compareSubstring=d;function m(me,Ce){return f(me,Ce,0,me.length,0,Ce.length)}e.compareIgnoreCase=m;function f(me,Ce,$e=0,Pe=me.length,De=0,ye=Ce.length){for(;$e<Pe&&De<ye;$e++,De++){let we=me.charCodeAt($e),ve=Ce.charCodeAt(De);if(we===ve)continue;if(we>=128||ve>=128)return d(me.toLowerCase(),Ce.toLowerCase(),$e,Pe,De,ye);u(we)&&(we-=32),u(ve)&&(ve-=32);const Re=we-ve;if(Re!==0)return Re}const le=Pe-$e,de=ye-De;return le<de?-1:le>de?1:0}e.compareSubstringIgnoreCase=f;function u(me){return me>=97&&me<=122}e.isLowerAsciiLetter=u;function y(me){return me>=65&&me<=90}e.isUpperAsciiLetter=y;function A(me,Ce){return me.length===Ce.length&&f(me,Ce)===0}e.equalsIgnoreCase=A;function N(me,Ce){const $e=Ce.length;return Ce.length>me.length?!1:f(me,Ce,0,$e)===0}e.startsWithIgnoreCase=N;function B(me,Ce){let $e,Pe=Math.min(me.length,Ce.length);for($e=0;$e<Pe;$e++)if(me.charCodeAt($e)!==Ce.charCodeAt($e))return $e;return Pe}e.commonPrefixLength=B;function F(me,Ce){let $e,Pe=Math.min(me.length,Ce.length);const De=me.length-1,ye=Ce.length-1;for($e=0;$e<Pe;$e++)if(me.charCodeAt(De-$e)!==Ce.charCodeAt(ye-$e))return $e;return Pe}e.commonSuffixLength=F;function O(me){return 55296<=me&&me<=56319}e.isHighSurrogate=O;function z(me){return 56320<=me&&me<=57343}e.isLowSurrogate=z;function W(me,Ce){return(me-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=W;function M(me,Ce,$e){const Pe=me.charCodeAt($e);if(O(Pe)&&$e+1<Ce){const De=me.charCodeAt($e+1);if(z(De))return W(Pe,De)}return Pe}e.getNextCodePoint=M;function x(me,Ce){const $e=me.charCodeAt(Ce-1);if(z($e)&&Ce>1){const Pe=me.charCodeAt(Ce-2);if(O(Pe))return W(Pe,$e)}return $e}function V(me,Ce){const $e=dt.getInstance(),Pe=Ce,De=me.length,ye=M(me,De,Ce);Ce+=ye>=65536?2:1;let le=$e.getGraphemeBreakType(ye);for(;Ce<De;){const de=M(me,De,Ce),we=$e.getGraphemeBreakType(de);if(nt(le,we))break;Ce+=de>=65536?2:1,le=we}return Ce-Pe}e.nextCharLength=V;function U(me,Ce){const $e=dt.getInstance(),Pe=Ce,De=x(me,Ce);Ce-=De>=65536?2:1;let ye=$e.getGraphemeBreakType(De);for(;Ce>0;){const le=x(me,Ce),de=$e.getGraphemeBreakType(le);if(nt(de,ye))break;Ce-=le>=65536?2:1,ye=de}return Pe-Ce}e.prevCharLength=U;function H(me,Ce){const $e=dt.getInstance(),Pe=me.length,De=Ce,ye=M(me,Pe,Ce),le=$e.getGraphemeBreakType(ye);Ce+=ye>=65536?2:1;let de=le;for(;Ce<Pe;){const ve=M(me,Pe,Ce),Re=$e.getGraphemeBreakType(ve);if(nt(de,Re))break;Ce+=ve>=65536?2:1,de=Re}const we=Ce;for(Ce=De,de=le;Ce>0;){const ve=x(me,Ce),Re=$e.getGraphemeBreakType(ve);if(nt(Re,de))break;Ce-=ve>=65536?2:1,de=Re}return[Ce,we]}function Y(me,Ce){return Ce>0&&z(me.charCodeAt(Ce))?H(me,Ce-1):H(me,Ce)}e.getCharContainingOffset=Y;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(me){return re.test(me)}e.containsRTL=K;const j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function te(me){return j.test(me)}e.containsEmoji=te;const ae=/^[\t\n\r\x20-\x7E]*$/;function ge(me){return ae.test(me)}e.isBasicASCII=ge,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ie(me){return e.UNUSUAL_LINE_TERMINATORS.test(me)}e.containsUnusualLineTerminators=Ie;function Me(me){for(let Ce=0,$e=me.length;Ce<$e;Ce++)if(Ne(me.charCodeAt(Ce)))return!0;return!1}e.containsFullWidthCharacter=Me;function Ne(me){return me>=11904&&me<=55215||me>=63744&&me<=64255||me>=65281&&me<=65374}e.isFullWidthCharacter=Ne;function q(me){return me>=127462&&me<=127487||me===8986||me===8987||me===9200||me===9203||me>=9728&&me<=10175||me===11088||me===11093||me>=127744&&me<=128591||me>=128640&&me<=128764||me>=128992&&me<=129008||me>=129280&&me<=129535||me>=129648&&me<=129782}e.isEmojiImprecise=q;function J(me,Ce){if(me.length<Ce)return me;const $e=/\b/g;let Pe=0;for(;$e.test(me)&&!(me.length-$e.lastIndex<Ce);)Pe=$e.lastIndex,$e.lastIndex+=1;return me.substring(Pe).replace(/^\s/,"")}e.lcut=J;const ne=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function oe(me){return me&&(me=me.replace(ne,""),me=me.replace(he,""),me=me.replace(ee,"")),me}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(me){return!!(me&&me.length>0&&me.charCodeAt(0)===65279)}e.startsWithUTF8BOM=_e;function Ue(me){return _e(me)?me.substr(1):me}e.stripUTF8BOM=Ue;function Ve(me,Ce){if(!me||!Ce||me.length<Ce.length)return!1;const $e=Ce.length,Pe=me.toLowerCase();let De=0,ye=-1;for(;De<$e;){const le=Pe.indexOf(Ce[De],ye+1);if(le<0)return!1;ye=le,De++}return!0}e.fuzzyContains=Ve;function Ke(me,Ce=!1){return me?(Ce&&(me=me.replace(/\\./g,"")),me.toLowerCase()!==me):!1}e.containsUppercaseCharacter=Ke;function Je(me){return me.charAt(0).toUpperCase()+me.slice(1)}e.uppercaseFirstLetter=Je;function it(me,Ce=1){if(Ce===0)return"";let $e=-1;do $e=me.indexOf(`
`,$e+1),Ce--;while(Ce>0&&$e>=0);return $e===-1?me:(me[$e-1]==="\r"&&$e--,me.substr(0,$e))}e.getNLines=it;function at(me){const Ce=90-65+1;return me=me%(2*Ce),me<Ce?String.fromCharCode(97+me):String.fromCharCode(65+me-Ce)}e.singleLetterHash=at;function et(me){return dt.getInstance().getGraphemeBreakType(me)}e.getGraphemeBreakType=et;function nt(me,Ce){return me===0?Ce!==5&&Ce!==7:me===2&&Ce===3?!1:me===4||me===2||me===3||Ce===4||Ce===2||Ce===3?!0:!(me===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(me===11||me===9)&&(Ce===9||Ce===10)||(me===12||me===10)&&Ce===10||Ce===5||Ce===13||Ce===7||me===1||me===13&&Ce===14||me===6&&Ce===6)}e.breakBetweenGraphemeBreakType=nt;var ct;(function(me){me[me.Other=0]="Other",me[me.Prepend=1]="Prepend",me[me.CR=2]="CR",me[me.LF=3]="LF",me[me.Control=4]="Control",me[me.Extend=5]="Extend",me[me.Regional_Indicator=6]="Regional_Indicator",me[me.SpacingMark=7]="SpacingMark",me[me.L=8]="L",me[me.V=9]="V",me[me.T=10]="T",me[me.LV=11]="LV",me[me.LVT=12]="LVT",me[me.ZWJ=13]="ZWJ",me[me.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class dt{constructor(){this._data=Pt()}static getInstance(){return dt._INSTANCE||(dt._INSTANCE=new dt),dt._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const $e=this._data,Pe=$e.length/3;let De=1;for(;De<=Pe;)if(Ce<$e[3*De])De=2*De;else if(Ce>$e[3*De+1])De=2*De+1;else return $e[3*De+2];return 0}}dt._INSTANCE=null;function Pt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(me,Ce){if(me===0)return 0;const $e=Rt(me,Ce);if($e!==void 0)return $e;const Pe=x(Ce,me);return me-=Z(Pe),me}e.getLeftDeleteOffset=xe;function Rt(me,Ce){let $e=x(Ce,me);for(me-=Z($e);ie($e)||$e===65039||$e===8419;){if(me===0)return;$e=x(Ce,me),me-=Z($e)}if(!!q($e)){if(me>=0){const Pe=x(Ce,me);Pe===8205&&(me-=Z(Pe))}return me}}function Z(me){return me>=65536?2:1}function ie(me){return 127995<=me&&me<=127999}var be;(function(me){me[me.zwj=8205]="zwj",me[me.emojiVariantSelector=65039]="emojiVariantSelector",me[me.enclosingKeyCap=8419]="enclosingKeyCap"})(be||(be={})),e.noBreakWhitespace="\xA0";class ze{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return ze.cache.get(Array.from(Ce))}static getLocales(){return ze._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze,D=ze,ze.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')),ze.cache=new g.LRUCachedComputed(me=>{function Ce(ve){const Re=new Map;for(let Ge=0;Ge<ve.length;Ge+=2)Re.set(ve[Ge],ve[Ge+1]);return Re}function $e(ve,Re){const Ge=new Map(ve);for(const[We,Xe]of Re)Ge.set(We,Xe);return Ge}function Pe(ve,Re){if(!ve)return Re;const Ge=new Map;for(const[We,Xe]of ve)Re.has(We)&&Ge.set(We,Xe);return Ge}const De=D.ambiguousCharacterData.getValue();let ye=me.filter(ve=>!ve.startsWith("_")&&ve in De);ye.length===0&&(ye=["_default"]);let le;for(const ve of ye){const Re=Ce(De[ve]);le=Pe(le,Re)}const de=Ce(De._common),we=$e(de,le);return new ze(we)}),ze._locales=new i.Lazy(()=>Object.keys(ze.ambiguousCharacterData.getValue()).filter(me=>!me.startsWith("_")));class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(Ce){return Qe.getData().has(Ce)}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe,Qe._data=void 0}),define(Ee[47],Se([0,1,8]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(R){return D(R,0)}e.hash=i;function D(R,b){switch(typeof R){case"object":return R===null?_(349,b):Array.isArray(R)?C(R,b):I(R,b);case"string":return k(R,b);case"boolean":return P(R,b);case"number":return _(R,b);case"undefined":return _(937,b);default:return _(617,b)}}e.doHash=D;function _(R,b){return(b<<5)-b+R|0}e.numberHash=_;function P(R,b){return _(R?433:863,b)}function k(R,b){b=_(149417,b);for(let s=0,o=R.length;s<o;s++)b=_(R.charCodeAt(s),b);return b}e.stringHash=k;function C(R,b){return b=_(104579,b),R.reduce((s,o)=>D(o,s),b)}function I(R,b){return b=_(181387,b),Object.keys(R).sort().reduce((s,o)=>(s=k(o,s),D(R[o],s)),b)}class L{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=D(b,this._value),this._value}}e.Hasher=L;var T;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function c(R,b,s=32){const o=s-b,p=~((1<<o)-1);return(R<<b|(p&R)>>>o)>>>0}function E(R,b=0,s=R.byteLength,o=0){for(let p=0;p<s;p++)R[b+p]=o}function h(R,b,s="0"){for(;R.length<b;)R=s+R;return R}function w(R,b=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(s=>s.toString(16).padStart(2,"0")).join(""):h((R>>>0).toString(16),b/4)}e.toHexString=w;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const s=b.length;if(s===0)return;const o=this._buff;let p=this._buffLen,a=this._leftoverHighSurrogate,S,n;for(a!==0?(S=a,n=-1,a=0):(S=b.charCodeAt(0),n=0);;){let t=S;if(g.isHighSurrogate(S))if(n+1<s){const r=b.charCodeAt(n+1);g.isLowSurrogate(r)?(n++,t=g.computeCodePoint(S,r)):t=65533}else{a=S;break}else g.isLowSurrogate(S)&&(t=65533);if(p=this._push(o,p,t),n++,n<s)S=b.charCodeAt(n);else break}this._buffLen=p,this._leftoverHighSurrogate=a}_push(b,s,o){return o<128?b[s++]=o:o<2048?(b[s++]=192|(o&1984)>>>6,b[s++]=128|(o&63)>>>0):o<65536?(b[s++]=224|(o&61440)>>>12,b[s++]=128|(o&4032)>>>6,b[s++]=128|(o&63)>>>0):(b[s++]=240|(o&1835008)>>>18,b[s++]=128|(o&258048)>>>12,b[s++]=128|(o&4032)>>>6,b[s++]=128|(o&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,s=this._buffDV;for(let d=0;d<64;d+=4)b.setUint32(d,s.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)b.setUint32(d,c(b.getUint32(d-12,!1)^b.getUint32(d-32,!1)^b.getUint32(d-56,!1)^b.getUint32(d-64,!1),1),!1);let o=this._h0,p=this._h1,a=this._h2,S=this._h3,n=this._h4,t,r,l;for(let d=0;d<80;d++)d<20?(t=p&a|~p&S,r=1518500249):d<40?(t=p^a^S,r=1859775393):d<60?(t=p&a|p&S|a&S,r=2400959708):(t=p^a^S,r=3395469782),l=c(o,5)+t+n+r+b.getUint32(d*4,!1)&4294967295,n=S,S=a,a=c(p,30),p=o,o=l;this._h0=this._h0+o&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[24],Se([0,1,16,8]),function(X,e,g,i){"use strict";var D,_,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,r){let l=n.get(t);return l===void 0&&(l=r,n.set(t,l)),l}e.getOrSet=k;function C(n){const t=[];return n.forEach((r,l)=>{t.push(`${l} => ${r}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=C;function I(n){const t=[];return n.forEach(r=>{t.push(r)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=I;class L{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return r-l}value(){return this._value[this._pos]}}e.StringIterator=L;class T{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class c{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const l=this._value.charCodeAt(r);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var E;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class R{constructor(t){this._iter=t}static forUris(t=()=>!1){return new R(new h(t))}static forPaths(){return new R(new c)}static forStrings(){return new R(new L)}static forConfigKeys(){return new R(new T)}clear(){this._root=void 0}fill(t,r){if(r){const l=r.slice(0);(0,g.shuffle)(l);for(let d of l)this.set(d,t)}else{const l=t.slice(0);(0,g.shuffle)(l);for(let d of l)this.set(d[0],d[1])}}set(t,r){const l=this._iter.reset(t);let d;this._root||(this._root=new w,this._root.segment=l.value());const m=[];for(d=this._root;;){const u=l.cmp(d.segment);if(u>0)d.left||(d.left=new w,d.left.segment=l.value()),m.push([-1,d]),d=d.left;else if(u<0)d.right||(d.right=new w,d.right.segment=l.value()),m.push([1,d]),d=d.right;else if(l.hasNext())l.next(),d.mid||(d.mid=new w,d.mid.segment=l.value()),m.push([0,d]),d=d.mid;else break}const f=d.value;d.value=r,d.key=t;for(let u=m.length-1;u>=0;u--){const y=m[u][1];y.updateHeight();const A=y.balanceFactor();if(A<-1||A>1){const N=m[u][0],B=m[u+1][0];if(N===1&&B===1)m[u][1]=y.rotateLeft();else if(N===-1&&B===-1)m[u][1]=y.rotateRight();else if(N===1&&B===-1)y.right=m[u+1][1]=m[u+1][1].rotateRight(),m[u][1]=y.rotateLeft();else if(N===-1&&B===1)y.left=m[u+1][1]=m[u+1][1].rotateLeft(),m[u][1]=y.rotateRight();else throw new Error;if(u>0)switch(m[u-1][0]){case-1:m[u-1][1].left=m[u][1];break;case 1:m[u-1][1].right=m[u][1];break;case 0:m[u-1][1].mid=m[u][1];break}else this._root=m[0][1]}}return f}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let l=this._root;for(;l;){const d=r.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else break}return l}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const l=this._iter.reset(t),d=[];let m=this._root;for(;m;){const f=l.cmp(m.segment);if(f>0)d.push([-1,m]),m=m.left;else if(f<0)d.push([1,m]),m=m.right;else if(l.hasNext())l.next(),d.push([0,m]),m=m.mid;else break}if(!!m){if(r?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this._min(m.right),{key:u,value:y,segment:A}=f;this._delete(f.key,!1),m.key=u,m.value=y,m.segment=A}else{const f=m.left??m.right;if(d.length>0){const[u,y]=d[d.length-1];switch(u){case-1:y.left=f;break;case 0:y.mid=f;break;case 1:y.right=f;break}}else this._root=f}for(let f=d.length-1;f>=0;f--){const u=d[f][1];u.updateHeight();const y=u.balanceFactor();if(y>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),d[f][1]=u.rotateLeft()):y<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),d[f][1]=u.rotateRight()),f>0)switch(d[f-1][0]){case-1:d[f-1][1].left=d[f][1];break;case 1:d[f-1][1].right=d[f][1];break;case 0:d[f-1][1].mid=d[f][1];break}else this._root=d[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let l=this._root,d;for(;l;){const m=r.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(r.hasNext())r.next(),d=l.value||d,l=l.mid;else break}return l&&l.value||d}findSuperstr(t){const r=this._iter.reset(t);let l=this._root;for(;l;){const d=r.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[r,l]of this)t(l,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const l=r.balanceFactor();return l<-1||l>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=R;class b{constructor(t,r){this.uri=t,this.value=r}}class s{constructor(t,r){this[D]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=r??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new b(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[l,d]of this.map)t(d.value,d.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=n=>n.toString();var o;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class p{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const l=this._map.get(t);if(!!l)return r!==0&&this.touch(l,r),l.value}set(t,r,l=0){let d=this._map.get(t);if(d)d.value=r,l!==0&&this.touch(d,l);else{switch(d={key:t,value:r,next:void 0,previous:void 0},l){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(t,d),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const l=this._state;let d=this._head;for(;d;){if(r?t.bind(r)(d.value,d.key,this):t(d.value,d.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const t=this,r=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.key,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}values(){const t=this,r=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.value,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}entries(){const t=this,r=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:[l.key,l.value],done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,l=this.size;for(;r&&l>t;)this._map.delete(r.key),r=r.next,l--;this._head=r,this._size=l,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,l=t.previous;if(!r||!l)throw new Error("Invalid list");r.previous=l,l.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const l=t.next,d=t.previous;t===this._tail?(d.next=void 0,this._tail=d):(l.previous=d,d.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const l=t.next,d=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=d,d.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,l)=>{t.push([l,r])}),t}fromJSON(t){this.clear();for(const[r,l]of t)this.set(r,l)}}e.LinkedMap=p;class a extends p{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class S{constructor(t){P.set(this,void 0),tt(this,P,t,"f")}get size(){return Fe(this,P,"f").size}forEach(t,r){Fe(this,P,"f").forEach(t,r)}get(t){return Fe(this,P,"f").get(t)}has(t){return Fe(this,P,"f").has(t)}entries(){return Fe(this,P,"f").entries()}keys(){return Fe(this,P,"f").keys()}values(){return Fe(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Fe(this,P,"f").entries()}}e.ReadonlyMapView=S}),define(Ee[97],Se([0,1,24,8]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ee){return function(oe,_e){for(let Ue=0,Ve=ee.length;Ue<Ve;Ue++){const Ke=ee[Ue](oe,_e);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(ee,oe,_e){if(!_e||_e.length<oe.length)return null;let Ue;return ee?Ue=i.startsWithIgnoreCase(_e,oe):Ue=_e.indexOf(oe)===0,Ue?oe.length>0?[{start:0,end:oe.length}]:[]:null}function P(ee,oe){const _e=oe.toLowerCase().indexOf(ee.toLowerCase());return _e===-1?null:[{start:_e,end:_e+ee.length}]}e.matchesContiguousSubString=P;function k(ee,oe){return C(ee.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=k;function C(ee,oe,_e,Ue){if(_e===ee.length)return[];if(Ue===oe.length)return null;if(ee[_e]===oe[Ue]){let Ve=null;return(Ve=C(ee,oe,_e+1,Ue+1))?R({start:Ue,end:Ue+1},Ve):null}return C(ee,oe,_e,Ue+1)}function I(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.isUpper=L;function T(ee){return 48<=ee&&ee<=57}function c(ee){return ee===32||ee===9||ee===10||ee===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>E.add(ee.charCodeAt(0)));function h(ee){return c(ee)||E.has(ee)}function w(ee,oe){return ee===oe||h(ee)&&h(oe)}function v(ee){return I(ee)||L(ee)||T(ee)}function R(ee,oe){return oe.length===0?oe=[ee]:ee.end===oe[0].start?oe[0].start=ee.start:oe.unshift(ee),oe}function b(ee,oe){for(let _e=oe;_e<ee.length;_e++){const Ue=ee.charCodeAt(_e);if(L(Ue)||T(Ue)||_e>0&&!v(ee.charCodeAt(_e-1)))return _e}return ee.length}function s(ee,oe,_e,Ue){if(_e===ee.length)return[];if(Ue===oe.length)return null;if(ee[_e]!==oe[Ue].toLowerCase())return null;{let Ve=null,Ke=Ue+1;for(Ve=s(ee,oe,_e+1,Ue+1);!Ve&&(Ke=b(oe,Ke))<oe.length;)Ve=s(ee,oe,_e+1,Ke),Ke++;return Ve===null?null:R({start:Ue,end:Ue+1},Ve)}}function o(ee){let oe=0,_e=0,Ue=0,Ve=0,Ke=0;for(let nt=0;nt<ee.length;nt++)Ke=ee.charCodeAt(nt),L(Ke)&&oe++,I(Ke)&&_e++,v(Ke)&&Ue++,T(Ke)&&Ve++;const Je=oe/ee.length,it=_e/ee.length,at=Ue/ee.length,et=Ve/ee.length;return{upperPercent:Je,lowerPercent:it,alphaPercent:at,numericPercent:et}}function p(ee){const{upperPercent:oe,lowerPercent:_e}=ee;return _e===0&&oe>.6}function a(ee){const{upperPercent:oe,lowerPercent:_e,alphaPercent:Ue,numericPercent:Ve}=ee;return _e>.2&&oe<.8&&Ue>.6&&Ve<.2}function S(ee){let oe=0,_e=0,Ue=0,Ve=0;for(let Ke=0;Ke<ee.length;Ke++)Ue=ee.charCodeAt(Ke),L(Ue)&&oe++,I(Ue)&&_e++,c(Ue)&&Ve++;return(oe===0||_e===0)&&Ve===0?ee.length<=30:oe<=5}function n(ee,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!S(ee)||oe.length>60)return null;const _e=o(oe);if(!a(_e)){if(!p(_e))return null;oe=oe.toLowerCase()}let Ue=null,Ve=0;for(ee=ee.toLowerCase();Ve<oe.length&&(Ue=s(ee,oe,0,Ve))===null;)Ve=b(oe,Ve+1);return Ue}e.matchesCamelCase=n;function t(ee,oe,_e=!1){if(!oe||oe.length===0)return null;let Ue=null,Ve=0;for(ee=ee.toLowerCase(),oe=oe.toLowerCase();Ve<oe.length&&(Ue=r(ee,oe,0,Ve,_e))===null;)Ve=l(oe,Ve+1);return Ue}e.matchesWords=t;function r(ee,oe,_e,Ue,Ve){if(_e===ee.length)return[];if(Ue===oe.length)return null;if(w(ee.charCodeAt(_e),oe.charCodeAt(Ue))){let Ke=null,Je=Ue+1;if(Ke=r(ee,oe,_e+1,Ue+1,Ve),!Ve)for(;!Ke&&(Je=l(oe,Je))<oe.length;)Ke=r(ee,oe,_e+1,Je,Ve),Je++;return Ke===null?null:R({start:Ue,end:Ue+1},Ke)}else return null}function l(ee,oe){for(let _e=oe;_e<ee.length;_e++)if(h(ee.charCodeAt(_e))||_e>0&&h(ee.charCodeAt(_e-1)))return _e;return ee.length}const d=D(e.matchesPrefix,n,P),m=D(e.matchesPrefix,n,k),f=new g.LRUCache(1e4);function u(ee,oe,_e=!1){if(typeof ee!="string"||typeof oe!="string")return null;let Ue=f.get(ee);Ue||(Ue=new RegExp(i.convertSimple2RegExpPattern(ee),"i"),f.set(ee,Ue));const Ve=Ue.exec(oe);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:_e?m(ee,oe):d(ee,oe)}e.matchesFuzzy=u;function y(ee,oe){const _e=Ie(ee,ee.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return _e?N(_e):null}e.matchesFuzzy2=y;function A(ee,oe,_e,Ue,Ve,Ke){const Je=Math.min(13,ee.length);for(;_e<Je;_e++){const it=Ie(ee,oe,_e,Ue,Ve,Ke,!1);if(it)return it}return[0,Ke]}e.anyScore=A;function N(ee){if(typeof ee=="undefined")return[];const oe=[],_e=ee[1];for(let Ue=ee.length-1;Ue>1;Ue--){const Ve=ee[Ue]+_e,Ke=oe[oe.length-1];Ke&&Ke.end===Ve?Ke.end=Ve+1:oe.push({start:Ve,end:Ve+1})}return oe}e.createMatches=N;const B=128;function F(){const ee=[],oe=[];for(let _e=0;_e<=B;_e++)oe[_e]=0;for(let _e=0;_e<=B;_e++)ee.push(oe.slice(0));return ee}function O(ee){const oe=[];for(let _e=0;_e<=ee;_e++)oe[_e]=0;return oe}const z=O(2*B),W=O(2*B),M=F(),x=F(),V=F(),U=!1;function H(ee,oe,_e,Ue,Ve){function Ke(it,at,et=" "){for(;it.length<at;)it=et+it;return it}let Je=` |   |${Ue.split("").map(it=>Ke(it,3)).join("|")}
`;for(let it=0;it<=_e;it++)it===0?Je+=" |":Je+=`${oe[it-1]}|`,Je+=ee[it].slice(0,Ve+1).map(at=>Ke(at.toString(),3)).join("|")+`
`;return Je}function Y(ee,oe,_e,Ue){ee=ee.substr(oe),_e=_e.substr(Ue),console.log(H(x,ee,ee.length,_e,_e.length)),console.log(H(V,ee,ee.length,_e,_e.length)),console.log(H(M,ee,ee.length,_e,_e.length))}function re(ee,oe){if(oe<0||oe>=ee.length)return!1;const _e=ee.codePointAt(oe);switch(_e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(_e)}}function K(ee,oe){if(oe<0||oe>=ee.length)return!1;switch(ee.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function j(ee,oe,_e){return oe[ee]!==_e[ee]}function te(ee,oe,_e,Ue,Ve,Ke,Je=!1){for(;oe<_e&&Ve<Ke;)ee[oe]===Ue[Ve]&&(Je&&(z[oe]=Ve),oe+=1),Ve+=1;return oe===_e}e.isPatternInWord=te;var ae;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var ge;(function(ee){ee.Default=[-100,0];function oe(_e){return!_e||_e.length===2&&_e[0]===-100&&_e[1]===0}ee.isDefault=oe})(ge=e.FuzzyScore||(e.FuzzyScore={}));function Ie(ee,oe,_e,Ue,Ve,Ke,Je){const it=ee.length>B?B:ee.length,at=Ue.length>B?B:Ue.length;if(_e>=it||Ke>=at||it-_e>at-Ke||!te(oe,_e,it,Ve,Ke,at,!0))return;Me(it,at,_e,Ke,oe,Ve);let et=1,nt=1,ct=_e,dt=Ke;const Pt=[!1];for(et=1,ct=_e;ct<it;et++,ct++){const be=z[ct],ze=W[ct],Qe=ct+1<it?W[ct+1]:at;for(nt=be-Ke+1,dt=be;dt<Qe;nt++,dt++){let me=Number.MIN_SAFE_INTEGER,Ce=!1;dt<=ze&&(me=Ne(ee,oe,ct,_e,Ue,Ve,dt,at,Ke,M[et-1][nt-1]===0,Pt));let $e=0;me!==Number.MAX_SAFE_INTEGER&&(Ce=!0,$e=me+x[et-1][nt-1]);const Pe=dt>be,De=Pe?x[et][nt-1]+(M[et][nt-1]>0?-5:0):0,ye=dt>be+1&&M[et][nt-1]>0,le=ye?x[et][nt-2]+(M[et][nt-2]>0?-5:0):0;if(ye&&(!Pe||le>=De)&&(!Ce||le>=$e))x[et][nt]=le,V[et][nt]=3,M[et][nt]=0;else if(Pe&&(!Ce||De>=$e))x[et][nt]=De,V[et][nt]=2,M[et][nt]=0;else if(Ce)x[et][nt]=$e,V[et][nt]=1,M[et][nt]=M[et-1][nt-1]+1;else throw new Error("not possible")}}if(U&&Y(ee,_e,Ue,Ke),!Pt[0]&&!Je)return;et--,nt--;const xe=[x[et][nt],Ke];let Rt=0,Z=0;for(;et>=1;){let be=nt;do{const ze=V[et][be];if(ze===3)be=be-2;else if(ze===2)be=be-1;else break}while(be>=1);Rt>1&&oe[_e+et-1]===Ve[Ke+nt-1]&&!j(be+Ke-1,Ue,Ve)&&Rt+1>M[et][be]&&(be=nt),be===nt?Rt++:Rt=1,Z||(Z=be),et--,nt=be-1,xe.push(nt)}at===it&&(xe[0]+=2);const ie=Z-it;return xe[0]-=ie,xe}e.fuzzyScore=Ie;function Me(ee,oe,_e,Ue,Ve,Ke){let Je=ee-1,it=oe-1;for(;Je>=_e&&it>=Ue;)Ve[Je]===Ke[it]&&(W[Je]=it,Je--),it--}function Ne(ee,oe,_e,Ue,Ve,Ke,Je,it,at,et,nt){if(oe[_e]!==Ke[Je])return Number.MIN_SAFE_INTEGER;let ct=1,dt=!1;return Je===_e-Ue?ct=ee[_e]===Ve[Je]?7:5:j(Je,Ve,Ke)&&(Je===0||!j(Je-1,Ve,Ke))?(ct=ee[_e]===Ve[Je]?7:5,dt=!0):re(Ke,Je)&&(Je===0||!re(Ke,Je-1))?ct=5:(re(Ke,Je-1)||K(Ke,Je-1))&&(ct=5,dt=!0),ct>1&&_e===Ue&&(nt[0]=!0),dt||(dt=j(Je,Ve,Ke)||re(Ke,Je-1)||K(Ke,Je-1)),_e===Ue?Je>at&&(ct-=dt?3:5):et?ct+=dt?2:0:ct+=dt?0:1,Je+1===it&&(ct-=dt?3:5),ct}function q(ee,oe,_e,Ue,Ve,Ke,Je){return ne(ee,oe,_e,Ue,Ve,Ke,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function J(ee,oe,_e,Ue,Ve,Ke,Je){return ne(ee,oe,_e,Ue,Ve,Ke,!1,Je)}e.fuzzyScoreGraceful=J;function ne(ee,oe,_e,Ue,Ve,Ke,Je,it){let at=Ie(ee,oe,_e,Ue,Ve,Ke,it);if(at&&!Je)return at;if(ee.length>=3){const et=Math.min(7,ee.length-1);for(let nt=_e+1;nt<et;nt++){const ct=he(ee,nt);if(ct){const dt=Ie(ct,ct.toLowerCase(),_e,Ue,Ve,Ke,it);dt&&(dt[0]-=3,(!at||dt[0]>at[0])&&(at=dt))}}}return at}function he(ee,oe){if(oe+1>=ee.length)return;const _e=ee[oe],Ue=ee[oe+1];if(_e!==Ue)return ee.slice(0,oe)+Ue+_e+ee.slice(oe+2)}}),define(Ee[142],Se([0,1,73,97,8]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(g.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${_.source}`,"g");function C(v){return v.replace(k,(R,b)=>b?R:`\\${R}`)}e.escapeIcons=C;const I=new RegExp(`\\\\${_.source}`,"g");function L(v){return v.replace(I,R=>`\\${R}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function c(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(T,(R,b,s,o)=>s?R:b||o||"")}e.stripIcons=c;function E(v){const R=v.indexOf(e.iconStartMarker);return R===-1?{text:v}:h(v,R)}e.parseLabelWithIcons=E;function h(v,R){const b=[];let s="";function o(d){if(d){s+=d;for(const m of d)b.push(S)}}let p=-1,a="",S=0,n,t,r=R;const l=v.length;for(o(v.substr(0,R));r<l;)n=v[r],t=v[r+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(p=r,o(a),a=e.iconStartMarker,r++):n===")"&&p!==-1?(S+=r-p+1,p=-1,a=""):p!==-1?P.test(n)?a+=n:(o(a),p=-1,a=""):o(n),r++;return o(a),{text:s,iconOffsets:b}}function w(v,R,b=!1){const{text:s,iconOffsets:o}=R;if(!o||o.length===0)return(0,i.matchesFuzzy)(v,s,b);const p=(0,D.ltrim)(s," "),a=s.length-p.length,S=(0,i.matchesFuzzy)(v,p,b);if(S)for(const n of S){const t=o[n.start+a]+a;n.start+=t,n.end+=t}return S}e.matchesFuzzyIconAware=w}),define(Ee[98],Se([0,1,15,142]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(E="",h=!1){if(this.value=E,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(E,h=0){return this.value+=I(this.supportThemeIcons?(0,i.escapeIcons)(E):E).replace(/([ \t]+)/g,(w,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,h){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=_;function P(c){return k(c)?!c.value:Array.isArray(c)?c.every(P):!0}e.isEmptyMarkdownString=P;function k(c){return c instanceof _?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function C(c,E){return c===E?!0:!c||!E?!1:c.value===E.value&&c.isTrusted===E.isTrusted&&c.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=C;function I(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function L(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function T(c){const E=[],h=c.split("|").map(v=>v.trim());c=h[0];const w=h[1];if(w){const v=/height=(\d+)/.exec(w),R=/width=(\d+)/.exec(w),b=v?v[1]:"",s=R?R[1]:"",o=isFinite(parseInt(s)),p=isFinite(parseInt(b));o&&E.push(`width="${s}"`),p&&E.push(`height="${b}"`)}return{href:c,dimensions:E}}e.parseHrefAndDimensions=T}),define(Ee[79],Se([0,1,24]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new g.LRUCache(1e4);function D(I){return C(I,"NFC",i)}e.normalizeNFC=D;const _=new g.LRUCache(1e4);function P(I){return C(I,"NFD",_)}e.normalizeNFD=P;const k=/[^\u0000-\u0080]/;function C(I,L,T){if(!I)return I;const c=T.get(I);if(c)return c;let E;return k.test(I)?E=I.normalize(L):E=I,T.set(I,E),E}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return P(L).replace(I,"")}}()}),define(Ee[48],Se([0,1,8]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const _="error",P="warning",k="warn",C="info",I="ignore";function L(c){return c?g.equalsIgnoreCase(_,c)?D.Error:g.equalsIgnoreCase(P,c)||g.equalsIgnoreCase(k,c)?D.Warning:g.equalsIgnoreCase(C,c)?D.Info:D.Ignore:D.Ignore}D.fromValue=L;function T(c){switch(c){case D.Error:return _;case D.Warning:return P;case D.Info:return C;default:return I}}D.toString=T}(i||(i={})),e.default=i}),define(Ee[13],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function i(m){return typeof m=="string"}e.isString=i;function D(m){return Array.isArray(m)&&m.every(f=>i(f))}e.isStringArray=D;function _(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=_;function P(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=P;function k(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=k;function C(m){return m===!0||m===!1}e.isBoolean=C;function I(m){return typeof m=="undefined"}e.isUndefined=I;function L(m){return!T(m)}e.isDefined=L;function T(m){return I(m)||m===null}e.isUndefinedOrNull=T;function c(m,f){if(!m)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=c;function E(m){if(T(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=E;function h(...m){const f=[];for(let u=0;u<m.length;u++){const y=m[u];if(T(y))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);f.push(y)}return f}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function v(m){if(!_(m))return!1;for(let f in m)if(w.call(m,f))return!1;return!0}e.isEmptyObject=v;function R(m){return typeof m=="function"}e.isFunction=R;function b(...m){return m.length>0&&m.every(R)}e.areFunctions=b;function s(m,f){const u=Math.min(m.length,f.length);for(let y=0;y<u;y++)o(m[y],f[y])}e.validateConstraints=s;function o(m,f){if(i(f)){if(typeof m!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(R(f)){try{if(m instanceof f)return}catch{}if(!T(m)&&m.constructor===f||f.length===1&&f.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function p(m){let f=[],u=Object.getPrototypeOf(m);for(;Object.prototype!==u;)f=f.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return f}e.getAllPropertyNames=p;function a(m){const f=[];for(const u of p(m))typeof m[u]=="function"&&f.push(u);return f}e.getAllMethodNames=a;function S(m,f){const u=A=>function(){const N=Array.prototype.slice.call(arguments,0);return f(A,N)};let y={};for(const A of m)y[A]=u(A);return y}e.createProxyObject=S;function n(m){return m===null?void 0:m}e.withNullAsUndefined=n;function t(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=t;function r(m){return class{constructor(){return new Proxy({},{get(f,u){if(f[u])return f[u];throw new Error(`Not Implemented: ${m}->${String(u)}`)}})}}}e.NotImplementedProxy=r;function l(m,f="Unreachable"){throw new Error(f)}e.assertNever=l;function d(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=d}),define(Ee[30],Se([0,1,9,12,8,13]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function k(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=k;function C(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function I(r,l=g.posix.sep){if(!r)return"";const d=r.length,m=r.charCodeAt(0);if(P(m)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let u=3;const y=u;for(;u<d&&!P(r.charCodeAt(u));u++);if(y!==u&&!P(r.charCodeAt(u+1))){for(u+=1;u<d;u++)if(P(r.charCodeAt(u)))return r.slice(0,u+1).replace(/[\\/]/g,l)}}return l}else if(R(m)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<d;f++)if(P(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=I;function L(r){if(!i.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let d=2;const m=d;for(;d<r.length&&(l=r.charCodeAt(d),l!==92);d++);return!(m===d||(l=r.charCodeAt(d+1),isNaN(l)||l===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,l=i.isWindows){const d=l?T:c;return!(!r||r.length===0||/^\s+$/.test(r)||(d.lastIndex=0,d.test(r))||l&&E.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function w(r,l,d){const m=r===l;return!d||m?m:!r||!l?!1:(0,D.equalsIgnoreCase)(r,l)}e.isEqual=w;function v(r,l,d,m=g.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(d){if(!(0,D.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let u=l.length;return l.charAt(l.length-1)===m&&u--,r.charAt(u)===m}return l.charAt(l.length-1)!==m&&(l+=m),r.indexOf(l)===0}e.isEqualOrParent=v;function R(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=R;function b(r,l){return i.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(l,r)),r=(0,g.normalize)(r),i.isWindows?(r=(0,D.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,D.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=b;function s(r){const l=(0,g.normalize)(r);return i.isWindows?r.length>3?!1:o(l)&&(r.length===2||l.charCodeAt(2)===92):l===g.posix.sep}e.isRootOrDriveLetter=s;function o(r,l){return(l!==void 0?l:i.isWindows)?R(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function p(r){return o(r)?r[0]:void 0}e.getDriveLetter=p;function a(r,l,d){return l.length>r.length?-1:r===l?0:(d&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=a;function S(r){const l=r.split(":");let d,m,f;if(l.forEach(u=>{const y=Number(u);(0,_.isNumber)(y)?m===void 0?m=y:f===void 0&&(f=y):d=d?[d,u].join(":"):u}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(r,l,d=8){let m="";for(let u=0;u<d;u++)m+=n.charAt(Math.floor(Math.random()*n.length));let f;return l?f=`${l}-${m}`:f=m,r?(0,g.join)(r,f):f}e.randomPath=t}),define(Ee[25],Se([0,1,13]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const v=Array.isArray(w)?[]:{};return Object.keys(w).forEach(R=>{w[R]&&typeof w[R]=="object"?v[R]=i(w[R]):v[R]=w[R]}),v}e.deepClone=i;function D(w){if(!w||typeof w!="object")return w;const v=[w];for(;v.length>0;){const R=v.shift();Object.freeze(R);for(const b in R)if(_.call(R,b)){const s=R[b];typeof s=="object"&&!Object.isFrozen(s)&&v.push(s)}}return w}e.deepFreeze=D;const _=Object.prototype.hasOwnProperty;function P(w,v){return k(w,v,new Set)}e.cloneAndChange=P;function k(w,v,R){if((0,g.isUndefinedOrNull)(w))return w;const b=v(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const s=[];for(const o of w)s.push(k(o,v,R));return s}if((0,g.isObject)(w)){if(R.has(w))throw new Error("Cannot clone recursive data-structure");R.add(w);const s={};for(let o in w)_.call(w,o)&&(s[o]=k(w[o],v,R));return R.delete(w),s}return w}function C(w,v,R=!0){return(0,g.isObject)(w)?((0,g.isObject)(v)&&Object.keys(v).forEach(b=>{b in w?R&&((0,g.isObject)(w[b])&&(0,g.isObject)(v[b])?C(w[b],v[b],R):w[b]=v[b]):w[b]=v[b]}),w):v}e.mixin=C;function I(w,v){if(w===v)return!0;if(w==null||v===null||v===void 0||typeof w!=typeof v||typeof w!="object"||Array.isArray(w)!==Array.isArray(v))return!1;let R,b;if(Array.isArray(w)){if(w.length!==v.length)return!1;for(R=0;R<w.length;R++)if(!I(w[R],v[R]))return!1}else{const s=[];for(b in w)s.push(b);s.sort();const o=[];for(b in v)o.push(b);if(o.sort(),!I(s,o))return!1;for(R=0;R<s.length;R++)if(!I(w[s[R]],v[s[R]]))return!1}return!0}e.equals=I;function L(w){const v=new Set;return JSON.stringify(w,(R,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=L;function T(w,v,R){const b=v(w);return typeof b=="undefined"?R:b}e.getOrDefault=T;function c(w,v){const R=Object.create(null);return!w||!v||Object.keys(v).forEach(s=>{const o=w[s],p=v[s];I(o,p)||(R[s]=p)}),R}e.distinct=c;function E(w,v){const R=v.toLowerCase(),b=Object.keys(w).find(s=>s.toLowerCase()===R);return b?w[b]:w[v]}e.getCaseInsensitive=E;function h(w,v){const R=Object.create(null);for(const[b,s]of Object.entries(w))v(b,s)&&(R[b]=s);return R}e.filter=h}),define(Ee[99],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function i(_){return _<0?0:_>255?255:_|0}e.toUint8=i;function D(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=D}),define(Ee[2],Se([0,1,9,12]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,_=/^\//,P=/^\/\//;function k(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(n,t){return!n&&!t?"file":n}function I(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==T&&(t=T+t):t=T;break}return t}const L="",T="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,r,l,d,m,f=!1){typeof t=="object"?(this.scheme=t.scheme||L,this.authority=t.authority||L,this.path=t.path||L,this.query=t.query||L,this.fragment=t.fragment||L):(this.scheme=C(t,f),this.authority=r||L,this.path=I(this.scheme,l||L),this.query=d||L,this.fragment=m||L,k(this,f))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:l,path:d,query:m,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=L),l===void 0?l=this.authority:l===null&&(l=L),d===void 0?d=this.path:d===null&&(d=L),m===void 0?m=this.query:m===null&&(m=L),f===void 0?f=this.fragment:f===null&&(f=L),r===this.scheme&&l===this.authority&&d===this.path&&m===this.query&&f===this.fragment?this:new w(r,l,d,m,f)}static parse(t,r=!1){const l=c.exec(t);return l?new w(l[2]||L,S(l[4]||L),S(l[5]||L),S(l[7]||L),S(l[9]||L),r):new w(L,L,L,L,L)}static file(t){let r=L;if(i.isWindows&&(t=t.replace(/\\/g,T)),t[0]===T&&t[1]===T){const l=t.indexOf(T,2);l===-1?(r=t.substring(2),t=T):(r=t.substring(2,l),t=t.substring(l)||T)}return new w("file",r,t,L,L)}static from(t){const r=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return k(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return i.isWindows&&t.scheme==="file"?l=E.file(g.win32.join(s(t,!0),...r)).path:l=g.posix.join(t.path,...r),t.with({path:l})}toString(t=!1){return o(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const r=new w(t);return r._formatted=t.external,r._fsPath=t._sep===h?t.fsPath:null,r}}else return t}}e.URI=E;const h=i.isWindows?1:void 0;class w extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(n,t){let r,l=-1;for(let d=0;d<n.length;d++){const m=n.charCodeAt(d);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)l!==-1&&(r+=encodeURIComponent(n.substring(l,d)),l=-1),r!==void 0&&(r+=n.charAt(d));else{r===void 0&&(r=n.substr(0,d));const f=v[m];f!==void 0?(l!==-1&&(r+=encodeURIComponent(n.substring(l,d)),l=-1),r+=f):l===-1&&(l=d)}}return l!==-1&&(r+=encodeURIComponent(n.substring(l))),r!==void 0?r:n}function b(n){let t;for(let r=0;r<n.length;r++){const l=n.charCodeAt(r);l===35||l===63?(t===void 0&&(t=n.substr(0,r)),t+=v[l]):t!==void 0&&(t+=n[r])}return t!==void 0?t:n}function s(n,t){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=s;function o(n,t){const r=t?b:R;let l="",{scheme:d,authority:m,path:f,query:u,fragment:y}=n;if(d&&(l+=d,l+=":"),(m||d==="file")&&(l+=T,l+=T),m){let A=m.indexOf("@");if(A!==-1){const N=m.substr(0,A);m=m.substr(A+1),A=N.indexOf(":"),A===-1?l+=r(N,!1):(l+=r(N.substr(0,A),!1),l+=":",l+=r(N.substr(A+1),!1)),l+="@"}m=m.toLowerCase(),A=m.indexOf(":"),A===-1?l+=r(m,!1):(l+=r(m.substr(0,A),!1),l+=m.substr(A))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const A=f.charCodeAt(1);A>=65&&A<=90&&(f=`/${String.fromCharCode(A+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const A=f.charCodeAt(0);A>=65&&A<=90&&(f=`${String.fromCharCode(A+32)}:${f.substr(2)}`)}l+=r(f,!0)}return u&&(l+="?",l+=r(u,!1)),y&&(l+="#",l+=t?y:R(y,!1)),l}function p(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+p(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(n){return n.match(a)?n.replace(a,t=>p(t)):n}}),define(Ee[59],Se([0,1,22,8,2]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(L){return JSON.stringify(L,C)}e.stringify=_;function P(L){let T=JSON.parse(L);return T=I(T),T}e.parse=P;var k;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function C(L,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,i.regExpFlags)(T)}:T}function I(L,T=0){if(!L||T>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return D.URI.revive(L);case 2:return new RegExp(L.source,L.flags)}if(L instanceof g.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let c=0;c<L.length;++c)L[c]=I(L[c],T+1);else for(const c in L)Object.hasOwnProperty.call(L,c)&&(L[c]=I(L[c],T+1))}return L}e.revive=I}),define(Ee[10],Se([0,1,12,2]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,I,L){this._hosts[C]=I,this._ports[C]=L}setConnectionToken(C,I){this._connectionTokens[C]=I}rewrite(C){if(this._delegate)return this._delegate(C);const I=C.authority;let L=this._hosts[I];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const T=this._ports[I],c=this._connectionTokens[I];let E=`path=${encodeURIComponent(C.path)}`;return typeof c=="string"&&(E+=`&tkn=${encodeURIComponent(c)}`),i.URI.from({scheme:g.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${L}:${T}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new _;class P{asBrowserUri(C,I){const L=this.toUri(C,I);return L.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===D.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:D.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(C,I){const L=this.toUri(C,I);return L.scheme===D.vscodeFileResource?L.with({scheme:D.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(C,I){return i.URI.isUri(C)?C:i.URI.parse(I.toUrl(C))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Ee[23],Se([0,1,30,10,9,12,8,2]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(E){return(0,k.uriToFsPath)(E,!0)}e.originalFSPath=C;class I{constructor(h){this._ignorePathCasing=h}compare(h,w,v=!1){return h===w?0:(0,P.compare)(this.getComparisonKey(h,v),this.getComparisonKey(w,v))}isEqual(h,w,v=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,v)===this.getComparisonKey(w,v)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,v=!1){if(h.scheme===w.scheme){if(h.scheme===i.Schemas.file)return g.isEqualOrParent(C(h),C(w),this._ignorePathCasing(h))&&h.query===w.query&&(v||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return g.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(v||h.fragment===w.fragment)}return!1}joinPath(h,...w){return k.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===i.Schemas.file?w=k.URI.file(D.dirname(C(h))).path:(w=D.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===i.Schemas.file?w=k.URI.file(D.normalize(C(h))).path:w=D.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===i.Schemas.file){const b=D.relative(C(h),C(w));return _.isWindows?g.toSlashes(b):b}let v=h.path||"/",R=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const s=Math.min(v.length,R.length);b<s&&!(v.charCodeAt(b)!==R.charCodeAt(b)&&v.charAt(b).toLowerCase()!==R.charAt(b).toLowerCase());b++);v=R.substr(0,b)+v.substr(b)}return D.posix.relative(v,R)}resolvePath(h,w){if(h.scheme===i.Schemas.file){const v=k.URI.file(D.resolve(C(h),w));return h.with({authority:v.authority,path:v.path})}return w=g.toPosixPath(w),h.with({path:D.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,P.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=D.sep){if(h.scheme===i.Schemas.file){const v=C(h);return v.length>g.getRoot(v).length&&v[v.length-1]===w}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=D.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=D.sep){let v=!1;if(h.scheme===i.Schemas.file){const R=C(h);v=R!==void 0&&R.length===g.getRoot(R).length&&R[R.length-1]===w}else{w="/";const R=h.path;v=R.length===1&&R.charCodeAt(R.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===i.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(E,h){const w=[];for(let v=0;v<E.length;v++){const R=h(E[v]);E.some((b,s)=>s===v?!1:(0,e.isEqualOrParent)(R,h(b)))||w.push(E[v])}return w}e.distinctParents=L;var T;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(w){const v=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(s=>{const[o,p]=s.split(":");o&&p&&v.set(o,p)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&v.set(E.META_DATA_MIME,b),v}E.parseMetaData=h})(T=e.DataUri||(e.DataUri={}));function c(E,h,w){if(h){let v=E.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),E.with({scheme:w,authority:h,path:v})}return E.with({scheme:w})}e.toLocalResource=c}),define(Ee[18],Se([0,1,21,15,3,6,23,12]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(K){return!!K&&typeof K.then=="function"}e.isThenable=C;function I(K){const j=new g.CancellationTokenSource,te=K(j.token),ae=new Promise((ge,Ie)=>{const Me=j.token.onCancellationRequested(()=>{Me.dispose(),j.dispose(),Ie((0,i.canceled)())});Promise.resolve(te).then(Ne=>{Me.dispose(),j.dispose(),ge(Ne)},Ne=>{Me.dispose(),j.dispose(),Ie(Ne)})});return new class{cancel(){j.cancel()}then(ge,Ie){return ae.then(ge,Ie)}catch(ge){return this.then(void 0,ge)}finally(ge){return ae.finally(ge)}}}e.createCancelablePromise=I;function L(K,j,te){return Promise.race([K,new Promise(ae=>j.onCancellationRequested(()=>ae(te)))])}e.raceCancellation=L;async function T(K){let j=-1;const te=K.map((ge,Ie)=>ge.then(Me=>(j=Ie,Me))),ae=await Promise.race(te);return K.forEach((ge,Ie)=>{Ie!==j&&ge.cancel()}),ae}e.raceCancellablePromises=T;function c(K,j,te){let ae;const ge=setTimeout(()=>{ae?.(void 0),te?.()},j);return Promise.race([K.finally(()=>clearTimeout(ge)),new Promise(Ie=>ae=Ie)])}e.raceTimeout=c;function E(K){return new Promise((j,te)=>{const ae=K();C(ae)?ae.then(j,te):j(ae)})}e.asPromise=E;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const te=()=>{this.queuedPromise=null;const ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ae};this.queuedPromise=new Promise(ae=>{this.activePromise.then(te,te).then(ae)})}return new Promise((te,ae)=>{this.queuedPromise.then(te,ae)})}return this.activePromise=j(),new Promise((te,ae)=>{this.activePromise.then(ge=>{this.activePromise=null,te(ge)},ge=>{this.activePromise=null,ae(ge)})})}}e.Throttler=h;class w{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=w;class v{constructor(){this.promiseMap=new Map}queue(j,te){const ge=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.promiseMap.get(j)===ge&&this.promiseMap.delete(j)});return this.promiseMap.set(j,ge),ge}}e.SequencerByKey=v;const R=(K,j)=>{let te=!0;const ae=setTimeout(()=>{te=!1,j()},K);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ae),te=!1}}},b=K=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,K())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,te=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Ie)=>{this.doResolve=ge,this.doReject=Ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=te===e.MicrotaskDelay?b(ae):R(te,ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class o{constructor(j){this.delayer=new s(j),this.throttler=new h}trigger(j,te){return this.delayer.trigger(()=>this.throttler.queue(j),te)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class p{constructor(){this._isOpen=!1,this._promise=new Promise((j,te)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class a extends p{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function S(K,j){return j?new Promise((te,ae)=>{const ge=setTimeout(()=>{Ie.dispose(),te()},K),Ie=j.onCancellationRequested(()=>{clearTimeout(ge),Ie.dispose(),ae((0,i.canceled)())})}):I(te=>S(K,te))}e.timeout=S;function n(K,j=0){const te=setTimeout(K,j);return(0,_.toDisposable)(()=>clearTimeout(te))}e.disposableTimeout=n;function t(K){const j=[];let te=0;const ae=K.length;function ge(){return te<ae?K[te++]():null}function Ie(Me){Me!=null&&j.push(Me);const Ne=ge();return Ne?Ne.then(Ie):Promise.resolve(j)}return Promise.resolve(null).then(Ie)}e.sequence=t;function r(K,j=ae=>!!ae,te=null){let ae=0;const ge=K.length,Ie=()=>{if(ae>=ge)return Promise.resolve(te);const Me=K[ae++];return Promise.resolve(Me()).then(q=>j(q)?Promise.resolve(q):Ie())};return Ie()}e.first=r;function l(K,j=ae=>!!ae,te=null){if(K.length===0)return Promise.resolve(te);let ae=K.length;const ge=()=>{ae=-1;for(const Ie of K)Ie.cancel?.()};return new Promise((Ie,Me)=>{for(const Ne of K)Ne.then(q=>{--ae>=0&&j(q)?(ge(),Ie(q)):ae===0&&Ie(te)}).catch(q=>{--ae>=0&&(ge(),Me(q))})})}e.firstParallel=l;class d{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((te,ae)=>{this.outstandingPromises.push({factory:j,c:te,e:ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const te=j.factory();te.then(j.c,j.e),te.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class m extends d{constructor(){super(1)}}e.Queue=m;class f{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const j=new x;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueFor(j,te=P.extUri){const ae=te.getComparisonKey(j);let ge=this.queues.get(ae);return ge||(ge=new m,D.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(ae),this.onDidQueueFinish()}),this.queues.set(ae,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=f;class u{constructor(j,te){this._token=-1,typeof j=="function"&&typeof te=="number"&&this.setIfNotSet(j,te)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,te){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},te)}setIfNotSet(j,te){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},te))}}e.TimeoutTimer=u;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,te){this.cancel(),this._token=setInterval(()=>{j()},te)}}e.IntervalTimer=y;class A{constructor(j,te){this.timeoutToken=-1,this.runner=j,this.timeout=te,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class N{constructor(j,te){te%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=te,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class B extends A{constructor(j,te){super(j,te);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class F extends _.Disposable{constructor(j,te,ae,ge){super();this.maxWorkChunkSize=j,this.maxPendingWork=te,this.throttleDelay=ae,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,k.setTimeout0)(()=>{if(j)return;const te=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(K,j)=>{const te=requestIdleCallback(K,typeof j=="number"?{timeout:j}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,cancelIdleCallback(te))}}}}();class O{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(te){this._error=te}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(K,j,te){let ae;for(let ge=0;ge<te;ge++)try{return await K()}catch(Ie){ae=Ie,await S(j)}throw ae}e.retry=z;class W{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,te,ae){return this._pending={taskId:j,cancel:()=>ae?.(),promise:te},te.then(()=>this.donePending(j),()=>this.donePending(j)),te}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let te,ae;const ge=new Promise((Ie,Me)=>{te=Ie,ae=Me});this._next={run:j,promise:ge,promiseResolve:te,promiseReject:ae}}return this._next.promise}}e.TaskSequentializer=W;class M{constructor(j,te=()=>Date.now()){this.interval=j,this.nowFn=te,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,te)=>{this.completeCallback=j,this.errorCallback=te})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(te=>{this.completeCallback(j),this.resolved=!0,te()})}error(j){return new Promise(te=>{this.errorCallback(j),this.rejected=!0,te()})}cancel(){new Promise(j=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=x;var V;(function(K){async function j(ae){let ge;const Ie=await Promise.all(ae.map(Me=>Me.then(Ne=>Ne,Ne=>{ge||(ge=Ne)})));if(typeof ge!="undefined")throw ge;return Ie}K.settled=j;function te(ae){return new Promise(async(ge,Ie)=>{try{await ae(ge,Ie)}catch(Me){Ie(Me)}})}K.withAsyncBody=te})(V=e.Promises||(e.Promises={}));var U;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(U||(U={}));class H{constructor(j){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const te={emitOne:ae=>this.emitOne(ae),emitMany:ae=>this.emitMany(ae),reject:ae=>this.reject(ae)};try{await Promise.resolve(j(te)),this.resolve()}catch(ae){this.reject(ae)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}static fromArray(j){return new H(te=>{te.emitMany(j)})}static fromPromise(j){return new H(async te=>{te.emitMany(await j)})}static fromPromises(j){return new H(async te=>{await Promise.all(j.map(async ae=>te.emitOne(await ae)))})}static merge(j){return new H(async te=>{await Promise.all(j.map(async ae=>{for await(const ge of ae)te.emitOne(ge)}))})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(j,te){return new H(async ae=>{for await(const ge of j)ae.emitOne(te(ge))})}map(j){return H.map(this,j)}static filter(j,te){return new H(async ae=>{for await(const ge of j)te(ge)&&ae.emitOne(ge)})}filter(j){return H.filter(this,j)}static coalesce(j){return H.filter(j,te=>!!te)}coalesce(){return H.coalesce(this)}static async toPromise(j){const te=[];for await(const ae of j)te.push(ae);return te}toPromise(){return H.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Y extends H{constructor(j,te){super(te);this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function re(K){const j=new g.CancellationTokenSource,te=K(j.token);return new Y(j,async ae=>{const ge=j.token.onCancellationRequested(()=>{ge.dispose(),j.dispose(),ae.reject((0,i.canceled)())});try{for await(const Ie of te){if(j.token.isCancellationRequested)return;ae.emitOne(Ie)}ge.dispose(),j.dispose()}catch(Ie){ge.dispose(),j.dispose(),ae.reject(Ie)}})}e.createCancelableAsyncIterable=re}),define(Ee[100],Se([0,1,18,9]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new g.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),_=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(f,u,y=!1){const A=f||"",N=u||"",B=D.value.collator.compare(A,N);return D.value.collatorIsNumeric&&B===0&&A!==N?A<N?-1:1:B}e.compareFileNames=k;function C(f,u){const y=_.value.collator;return f=f||"",u=u||"",p(y,f,u)}e.compareFileNamesDefault=C;function I(f,u){const y=_.value.collator;return f=f||"",u=u||"",t(f,u)||p(y,f,u)}e.compareFileNamesUpper=I;function L(f,u){const y=_.value.collator;return f=f||"",u=u||"",n(f,u)||p(y,f,u)}e.compareFileNamesLower=L;function T(f,u){return f=f||"",u=u||"",f===u?0:f<u?-1:1}e.compareFileNamesUnicode=T;function c(f,u,y=!1){y||(f=f&&f.toLowerCase(),u=u&&u.toLowerCase());const[A,N]=s(f),[B,F]=s(u);return A!==B?A<B?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=c;function E(f,u){const[y,A]=s(f),[N,B]=s(u);let F=D.value.collator.compare(A,B);if(F===0){if(D.value.collatorIsNumeric&&A!==B)return A<B?-1:1;if(F=D.value.collator.compare(y,N),D.value.collatorIsNumeric&&F===0&&y!==N)return y<N?-1:1}return F}e.compareFileExtensions=E;function h(f,u){f=f||"",u=u||"";const y=o(f),A=o(u),N=_.value.collator,B=P.value.collator;return p(B,y,A)||p(N,f,u)}e.compareFileExtensionsDefault=h;function w(f,u){f=f||"",u=u||"";const y=o(f),A=o(u),N=_.value.collator,B=P.value.collator;return p(B,y,A)||t(f,u)||p(N,f,u)}e.compareFileExtensionsUpper=w;function v(f,u){f=f||"",u=u||"";const y=o(f),A=o(u),N=_.value.collator,B=P.value.collator;return p(B,y,A)||n(f,u)||p(N,f,u)}e.compareFileExtensionsLower=v;function R(f,u){f=f||"",u=u||"";const y=o(f).toLowerCase(),A=o(u).toLowerCase();return y!==A?y<A?-1:1:f!==u?f<u?-1:1:0}e.compareFileExtensionsUnicode=R;const b=/^(.*?)(\.([^.]*))?$/;function s(f,u=!1){const y=f?b.exec(f):[];let A=[y&&y[1]||"",y&&y[3]||""];return u&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function o(f){const u=f?b.exec(f):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function p(f,u,y){let A=f.compare(u,y);return A!==0?A:u.length!==y.length?u.length<y.length?-1:1:0}function a(f){const u=f.charAt(0);return u.toLocaleUpperCase()!==u}function S(f){const u=f.charAt(0);return u.toLocaleLowerCase()!==u}function n(f,u){return a(f)&&S(u)?-1:S(f)&&a(u)?1:0}function t(f,u){return S(f)&&a(u)?-1:a(f)&&S(u)?1:0}function r(f,u,y=!1){return y||(f=f&&f.toLowerCase(),u=u&&u.toLowerCase()),f===u?0:f<u?-1:1}function l(f,u,y=!1){const A=f.split(i.sep),N=u.split(i.sep),B=A.length-1,F=N.length-1;let O,z;for(let W=0;;W++){if(O=B===W,z=F===W,O&&z)return k(A[W],N[W],y);if(O)return-1;if(z)return 1;const M=r(A[W],N[W],y);if(M!==0)return M}}e.comparePaths=l;function d(f,u,y){const A=f.toLowerCase(),N=u.toLowerCase(),B=m(f,u,y);if(B)return B;const F=A.endsWith(y),O=N.endsWith(y);if(F!==O)return F?-1:1;const z=k(A,N);return z!==0?z:A.localeCompare(N)}e.compareAnything=d;function m(f,u,y){const A=f.toLowerCase(),N=u.toLowerCase(),B=A.startsWith(y),F=N.startsWith(y);if(B!==F)return B?-1:1;if(B&&F){if(A.length<N.length)return-1;if(A.length>N.length)return 1}return 0}e.compareByPrefix=m}),define(Ee[101],Se([0,1,100,97,47,9,12,8]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,I=[C,[]];function L(M,x,V,U){if(!M||!x)return I;const H=M.length,Y=x.length;if(H<Y)return I;const re=M.toLowerCase();return T(x,V,Y,M,re,H,U)}e.scoreFuzzy=L;function T(M,x,V,U,H,Y,re){const K=[],j=[];for(let Ie=0;Ie<V;Ie++){const Me=Ie*Y,Ne=Me-Y,q=Ie>0,J=M[Ie],ne=x[Ie];for(let he=0;he<Y;he++){const ee=he>0,oe=Me+he,_e=oe-1,Ue=Ne+he-1,Ve=ee?K[_e]:0,Ke=q&&ee?K[Ue]:0,Je=q&&ee?j[Ue]:0;let it;!Ke&&q?it=0:it=c(J,ne,U,H,he,Je),it&&Ke+it>=Ve&&(re||q||H.startsWith(x,he))?(j[oe]=Je+1,K[oe]=Ke+it):(j[oe]=C,K[oe]=Ve)}}const te=[];let ae=V-1,ge=Y-1;for(;ae>=0&&ge>=0;){const Ie=ae*Y+ge;j[Ie]===C||(te.push(ge),ae--),ge--}return[K[V*Y-1],te.reverse()]}function c(M,x,V,U,H,Y){let re=0;if(!E(x,U[H]))return re;if(re+=1,Y>0&&(re+=Y*5),M===V[H]&&(re+=1),H===0)re+=8;else{const K=h(V.charCodeAt(H-1));K?re+=K:(0,i.isUpper)(V.charCodeAt(H))&&Y===0&&(re+=2)}return re}function E(M,x){return M===x?!0:M==="/"||M==="\\"?x==="/"||x==="\\":!1}function h(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function v(M,x,V=0,U=0){const H=x;return H.values&&H.values.length>1?R(M,H.values,V,U):b(M,x,V,U)}e.scoreFuzzy2=v;function R(M,x,V,U){let H=0;const Y=[];for(const re of x){const[K,j]=b(M,re,V,U);if(typeof K!="number")return w;H+=K,Y.push(...j)}return[H,m(Y)]}function b(M,x,V,U){const H=(0,i.fuzzyScore)(x.original,x.originalLowercase,V,M,M.toLowerCase(),U,!0);return H?[H[0],(0,i.createMatches)(H)]:w}const s=Object.freeze({score:0}),o=1<<18,p=1<<17,a=1<<16;function S(M,x,V,U){const H=U.values?U.values:[U];return(0,D.hash)({[U.normalized]:{values:H.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:M,description:x,allowNonContiguousMatches:V}})}function n(M,x,V,U,H){if(!M||!x.normalized)return s;const Y=U.getItemLabel(M);if(!Y)return s;const re=U.getItemDescription(M),K=S(Y,re,V,x),j=H[K];if(j)return j;const te=t(Y,re,U.getItemPath(M),x,V);return H[K]=te,te}e.scoreItemFuzzy=n;function t(M,x,V,U,H){const Y=!V||!U.containsPathSeparator;return V&&(P.isLinux?U.pathNormalized===V:(0,k.equalsIgnoreCase)(U.pathNormalized,V))?{score:o,labelMatch:[{start:0,end:M.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:U.values&&U.values.length>1?r(M,x,V,U.values,Y,H):l(M,x,V,U,Y,H)}function r(M,x,V,U,H,Y){let re=0;const K=[],j=[];for(const te of U){const{score:ae,labelMatch:ge,descriptionMatch:Ie}=l(M,x,V,te,H,Y);if(ae===C)return s;re+=ae,ge&&K.push(...ge),Ie&&j.push(...Ie)}return{score:re,labelMatch:m(K),descriptionMatch:m(j)}}function l(M,x,V,U,H,Y){if(H||!x){const[re,K]=L(M,U.normalized,U.normalizedLowercase,Y&&!U.expectContiguousMatch);if(re){const j=(0,i.matchesPrefix)(U.normalized,M);let te;return j?(te=p,te+=Math.round(U.normalized.length/M.length*100)):te=a,{score:te+re,labelMatch:j||d(K)}}}if(x){let re=x;V&&(re=`${x}${_.sep}`);const K=re.length,j=`${re}${M}`,[te,ae]=L(j,U.normalized,U.normalizedLowercase,Y&&!U.expectContiguousMatch);if(te){const ge=d(ae),Ie=[],Me=[];return ge.forEach(Ne=>{Ne.start<K&&Ne.end>K?(Ie.push({start:0,end:Ne.end-K}),Me.push({start:Ne.start,end:K})):Ne.start>=K?Ie.push({start:Ne.start-K,end:Ne.end-K}):Me.push(Ne)}),{score:te,labelMatch:Ie,descriptionMatch:Me}}}return s}function d(M){const x=[];if(!M)return x;let V;for(const U of M)V&&V.end===U?V.end+=1:(V={start:U,end:U+1},x.push(V));return x}function m(M){const x=M.sort((H,Y)=>H.start-Y.start),V=[];let U;for(const H of x)!U||!f(U,H)?(U=H,V.push(H)):(U.start=Math.min(U.start,H.start),U.end=Math.max(U.end,H.end));return V}function f(M,x){return!(M.end<x.start||x.end<M.start)}function u(M,x,V,U,H,Y){const re=n(M,V,U,H,Y),K=n(x,V,U,H,Y),j=re.score,te=K.score;if((j===o||te===o)&&j!==te)return j===o?-1:1;if(j>a||te>a){if(j!==te)return j>te?-1:1;if(j<p&&te<p){const J=A(re.labelMatch,K.labelMatch);if(J!==0)return J}const Ne=H.getItemLabel(M)||"",q=H.getItemLabel(x)||"";if(Ne.length!==q.length)return Ne.length-q.length}if(j!==te)return j>te?-1:1;const ae=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,ge=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(ae&&!ge)return-1;if(ge&&!ae)return 1;const Ie=y(M,re,H),Me=y(x,K,H);return Ie&&Me&&Ie!==Me?Me>Ie?-1:1:N(M,x,V,H)}e.compareItemsByFuzzyScore=u;function y(M,x,V){let U=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?U=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(U=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const Y=V.getItemDescription(M);Y&&(H+=Y.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-U}function A(M,x){if(!M&&!x||(!M||!M.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!M||!M.length)return 1;const V=M[0].start,H=M[M.length-1].end-V,Y=x[0].start,K=x[x.length-1].end-Y;return H===K?0:K<H?1:-1}function N(M,x,V,U){const H=U.getItemLabel(M)||"",Y=U.getItemLabel(x)||"",re=U.getItemDescription(M),K=U.getItemDescription(x),j=H.length+(re?re.length:0),te=Y.length+(K?K.length:0);if(j!==te)return j-te;const ae=U.getItemPath(M),ge=U.getItemPath(x);return ae&&ge&&ae.length!==ge.length?ae.length-ge.length:H!==Y?(0,g.compareAnything)(H,Y,V.normalized):re&&K&&re!==K?(0,g.compareAnything)(re,K,V.normalized):ae&&ge&&ae!==ge?(0,g.compareAnything)(ae,ge,V.normalized):0}function B(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function O(M){typeof M!="string"&&(M="");const x=M.toLowerCase(),{pathNormalized:V,normalized:U,normalizedLowercase:H}=z(M),Y=V.indexOf(_.sep)>=0,re=B(M);let K;const j=M.split(F);if(j.length>1)for(const te of j){const ae=B(te),{pathNormalized:ge,normalized:Ie,normalizedLowercase:Me}=z(te);Ie&&(K||(K=[]),K.push({original:te,originalLowercase:te.toLowerCase(),pathNormalized:ge,normalized:Ie,normalizedLowercase:Me,expectContiguousMatch:ae}))}return{original:M,originalLowercase:x,pathNormalized:V,normalized:U,normalizedLowercase:H,values:K,containsPathSeparator:Y,expectContiguousMatch:re}}e.prepareQuery=O;function z(M){let x;P.isWindows?x=M.replace(/\//g,_.sep):x=M.replace(/\\/g,_.sep);const V=(0,k.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:V,normalizedLowercase:V.toLowerCase()}}function W(M){return Array.isArray(M)?O(M.map(x=>x.original).join(F)):O(M.original)}e.pieceToQuery=W}),define(Ee[31],Se([0,1,18,30,24,9,8]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const C="**",I="/",L="[/\\\\]",T="[^/\\\\]",c=/\//g;function E(U){switch(U){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}|${L}${T}+)*?`}}function h(U,H){if(!U)return[];const Y=[];let re=!1,K=!1,j="";for(const te of U){switch(te){case H:if(!re&&!K){Y.push(j),j="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":K=!0;break;case"]":K=!1;break}j+=te}return j&&Y.push(j),Y}e.splitGlobAware=h;function w(U){if(!U)return"";let H="";const Y=h(U,I);if(Y.every(re=>re===C))H=".*";else{let re=!1;Y.forEach((K,j)=>{if(K===C){re||(H+=E(2),re=!0);return}let te=!1,ae="",ge=!1,Ie="";for(const Me of K){if(Me!=="}"&&te){ae+=Me;continue}if(ge&&(Me!=="]"||!Ie)){let Ne;Me==="-"?Ne=Me:(Me==="^"||Me==="!")&&!Ie?Ne="^":Me===I?Ne="":Ne=P.escapeRegExpCharacters(Me),Ie+=Ne;continue}switch(Me){case"{":te=!0;continue;case"[":ge=!0;continue;case"}":{H+=`(?:${h(ae,",").map(J=>w(J)).join("|")})`,te=!1,ae="";break}case"]":H+="["+Ie+"]",ge=!1,Ie="";break;case"?":H+=T;continue;case"*":H+=E(1);continue;default:H+=P.escapeRegExpCharacters(Me)}}j<Y.length-1&&(Y[j+1]!==C||j+2<Y.length)&&(H+=L),re=!1})}return H}const v=/^\*\*\/\*\.[\w\.-]+$/,R=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new D.LRUCache(1e4),S=function(){return!1},n=function(){return null};function t(U,H){if(!U)return n;let Y;typeof U!="string"?Y=U.pattern:Y=U,Y=Y.trim();const re=`${Y}_${!!H.trimForExclusions}`;let K=a.get(re);if(K)return r(K,U);let j;if(v.test(Y)){const te=Y.substr(4);K=function(ae,ge){return typeof ae=="string"&&ae.endsWith(te)?Y:null}}else(j=R.exec(l(Y,H)))?K=d(j[1],Y):(H.trimForExclusions?s:b).test(Y)?K=m(Y,H):(j=o.exec(l(Y,H)))?K=f(j[1].substr(1),Y,!0):(j=p.exec(l(Y,H)))?K=f(j[1],Y,!1):K=u(Y);return a.set(re,K),r(K,U)}function r(U,H){return typeof H=="string"?U:function(Y,re){return i.isEqualOrParent(Y,H.base)?U(_.relative(H.base,Y),re):null}}function l(U,H){return H.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function d(U,H){const Y=`/${U}`,re=`\\${U}`,K=function(te,ae){return typeof te!="string"?null:ae?ae===U?H:null:te===U||te.endsWith(Y)||te.endsWith(re)?H:null},j=[U];return K.basenames=j,K.patterns=[H],K.allBasenames=j,K}function m(U,H){const Y=V(U.slice(1,-1).split(",").map(ae=>t(ae,H)).filter(ae=>ae!==n),U),re=Y.length;if(!re)return n;if(re===1)return Y[0];const K=function(ae,ge){for(let Ie=0,Me=Y.length;Ie<Me;Ie++)if(Y[Ie](ae,ge))return U;return null},j=Y.find(ae=>!!ae.allBasenames);j&&(K.allBasenames=j.allBasenames);const te=Y.reduce((ae,ge)=>ge.allPaths?ae.concat(ge.allPaths):ae,[]);return te.length&&(K.allPaths=te),K}function f(U,H,Y){const re=_.sep===_.posix.sep,K=re?U:U.replace(c,_.sep),j=_.sep+K,te=_.posix.sep+U,ae=Y?function(ge,Ie){return typeof ge=="string"&&(ge===K||ge.endsWith(j)||!re&&(ge===U||ge.endsWith(te)))?H:null}:function(ge,Ie){return typeof ge=="string"&&(ge===K||!re&&ge===U)?H:null};return ae.allPaths=[(Y?"*/":"./")+U],ae}function u(U){try{const H=new RegExp(`^${w(U)}$`);return function(Y){return H.lastIndex=0,typeof Y=="string"&&H.test(Y)?U:null}}catch{return n}}function y(U,H,Y){return!U||typeof H!="string"?!1:A(U)(H,void 0,Y)}e.match=y;function A(U,H={}){if(!U)return S;if(typeof U=="string"||O(U)){const Y=t(U,H);if(Y===n)return S;const re=function(K,j){return!!Y(K,j)};return Y.allBasenames&&(re.allBasenames=Y.allBasenames),Y.allPaths&&(re.allPaths=Y.allPaths),re}return M(U,H)}e.parse=A;function N(U){if(!U)return;let H;return Y=>(H||(H=(U()||Promise.resolve([])).then(re=>re?F(re):{})),H.then(re=>!!re[Y]))}e.hasSiblingPromiseFn=N;function B(U){if(!U)return;let H;return Y=>{if(!H){const re=U();H=re?F(re):{}}return!!H[Y]}}e.hasSiblingFn=B;function F(U){const H={};for(const Y of U)H[Y]=!0;return H}function O(U){const H=U;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=O;function z(U){return U.allBasenames||[]}e.getBasenameTerms=z;function W(U){return U.allPaths||[]}e.getPathTerms=W;function M(U,H){const Y=V(Object.getOwnPropertyNames(U).map(ae=>x(ae,U[ae],H)).filter(ae=>ae!==n)),re=Y.length;if(!re)return n;if(!Y.some(ae=>!!ae.requiresSiblings)){if(re===1)return Y[0];const ae=function(Me,Ne){for(let q=0,J=Y.length;q<J;q++){const ne=Y[q](Me,Ne);if(ne)return ne}return null},ge=Y.find(Me=>!!Me.allBasenames);ge&&(ae.allBasenames=ge.allBasenames);const Ie=Y.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Ie.length&&(ae.allPaths=Ie),ae}const K=function(ae,ge,Ie){let Me;for(let Ne=0,q=Y.length;Ne<q;Ne++){const J=Y[Ne];J.requiresSiblings&&Ie&&(ge||(ge=_.basename(ae)),Me||(Me=ge.substr(0,ge.length-_.extname(ae).length)));const ne=J(ae,ge,Me,Ie);if(ne)return ne}return null},j=Y.find(ae=>!!ae.allBasenames);j&&(K.allBasenames=j.allBasenames);const te=Y.reduce((ae,ge)=>ge.allPaths?ae.concat(ge.allPaths):ae,[]);return te.length&&(K.allPaths=te),K}function x(U,H,Y){if(H===!1)return n;const re=t(U,Y);if(re===n)return n;if(typeof H=="boolean")return re;if(H){const K=H.when;if(typeof K=="string"){const j=(te,ae,ge,Ie)=>{if(!Ie||!re(te,ae))return null;const Me=K.replace("$(basename)",ge),Ne=Ie(Me);return(0,g.isThenable)(Ne)?Ne.then(q=>q?U:null):Ne?U:null};return j.requiresSiblings=!0,j}}return re}function V(U,H){const Y=U.filter(ae=>!!ae.basenames);if(Y.length<2)return U;const re=Y.reduce((ae,ge)=>{const Ie=ge.basenames;return Ie?ae.concat(Ie):ae},[]);let K;if(H){K=[];for(let ae=0,ge=re.length;ae<ge;ae++)K.push(H)}else K=Y.reduce((ae,ge)=>{const Ie=ge.patterns;return Ie?ae.concat(Ie):ae},[]);const j=function(ae,ge){if(typeof ae!="string")return null;if(!ge){let Me;for(Me=ae.length;Me>0;Me--){const Ne=ae.charCodeAt(Me-1);if(Ne===47||Ne===92)break}ge=ae.substr(Me)}const Ie=re.indexOf(ge);return Ie!==-1?K[Ie]:null};j.basenames=re,j.patterns=K,j.allBasenames=re;const te=U.filter(ae=>!ae.basenames);return te.push(j),te}}),define(Ee[80],Se([0,1,30,10,9,12,23,8,2]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(t,r,l){if(typeof t=="string"&&(t=C.URI.file(t)),l){const m=l.getWorkspaceFolder(t);if(m){const f=l.getWorkspace().folders.length>1;let u;if((0,P.isEqual)(m.uri,t)?u="":u=(0,P.relativePath)(m.uri,t),f){const y=m.name?m.name:(0,P.basename)(m.uri);u=u?y+" \u2022 "+u:y}return u}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,D.normalize)(T(t.fsPath));let d=(0,D.normalize)(t.fsPath);return!_.isWindows&&r?.userHome&&(d=E(d,r.userHome.fsPath)),d}e.getPathLabel=I;function L(t){if(!t)return;typeof t=="string"&&(t=C.URI.file(t));const r=(0,P.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return _.isWindows&&(0,g.isRootOrDriveLetter)(r)?T(r):r}e.getBaseLabel=L;function T(t,r){return(0,g.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=T;let c=Object.create(null);function E(t,r){if(_.isWindows||!t||!r)return t;let l=c.original===r?c.normalized:void 0;return l||(l=`${(0,k.rtrim)(r,D.posix.sep)}${D.posix.sep}`,c={original:r,normalized:l}),(_.isLinux?t.startsWith(l):(0,k.startsWithIgnoreCase)(t,l))&&(t=`~/${t.substr(l.length)}`),t}e.tildify=E;function h(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=h;const w="\u2026",v="\\\\",R="~";function b(t,r=D.sep){const l=new Array(t.length);let d=!1;for(let m=0;m<t.length;m++){let f=t[m];if(f===""){l[m]=`.${r}`;continue}if(!f){l[m]=f;continue}d=!0;let u="";f.indexOf(v)===0?(u=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(r)===0?(u=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(R)===0&&(u=f.substr(0,f.indexOf(R)+R.length),f=f.substr(f.indexOf(R)+R.length));const y=f.split(r);for(let A=1;d&&A<=y.length;A++)for(let N=y.length-A;d&&N>=0;N--){d=!1;let B=y.slice(N,N+A).join(r);for(let F=0;!d&&F<t.length;F++)if(F!==m&&t[F]&&t[F].indexOf(B)>-1){const O=N+A===y.length,z=N>0&&t[F].indexOf(r)>-1?r+B:B,W=t[F].endsWith(z);d=!O||W}if(!d){let F="";(y[0].endsWith(":")||u!=="")&&(N===1&&(N=0,A++,B=y[0]+r+B),N>0&&(F=y[0]+r),F=u+F),N>0&&(F=F+w+r),F=F+B,N+A<y.length&&(F=F+r+w),l[m]=F}}d&&(l[m]=f)}return l}e.shorten=b;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(t,r=Object.create(null)){const l=[];let d=!1,m="";for(const f of t)if(f==="$"||d&&f==="{")m&&l.push({value:m,type:s.TEXT}),m="",d=!0;else if(f==="}"&&d){const u=r[m];if(typeof u=="string")u.length&&l.push({value:u,type:s.VARIABLE});else if(u){const y=l[l.length-1];(!y||y.type!==s.SEPARATOR)&&l.push({value:u.label,type:s.SEPARATOR})}m="",d=!1}else m+=f;return m&&!d&&l.push({value:m,type:s.TEXT}),l.filter((f,u)=>{if(f.type===s.SEPARATOR){const y=l[u-1],A=l[u+1];return[y,A].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=o;function p(t,r){return _.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function a(t,r){return _.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):_.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function S(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=S;function n(t){const r=t.indexOf("/")!==-1?D.posix:D.win32,l=r.basename(t),d=r.dirname(t);return l.length?{name:l,parentPath:d}:{name:d,parentPath:""}}e.splitName=n}),define(Ee[102],Se([0,1,31,10,9,23,8]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let C=[],I=[],L=[];function T(t,r=!1){const l=c(t);C.push(l),l.userConfigured?L.push(l):I.push(l),r&&!l.userConfigured&&C.forEach(d=>{d.mime===l.mime||d.userConfigured||(l.extension&&d.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&d.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&d.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&d.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=T;function c(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function E(t){t?(C=C.filter(r=>!r.userConfigured),L=[]):(C=[],I=[],L=[])}e.clearTextMimes=E;function h(t,r){let l;if(t)switch(t.scheme){case i.Schemas.file:l=t.fsPath;break;case i.Schemas.data:{l=_.DataUri.parseMetaData(t).get(_.DataUri.META_DATA_LABEL);break}default:l=t.path}if(!l)return[k.unknown];l=l.toLowerCase();const d=(0,D.basename)(l),m=w(l,d,L);if(m)return[m,k.text];const f=w(l,d,I);if(f)return[f,k.text];if(r){const u=v(r);if(u)return[u,k.text]}return[k.unknown]}e.guessMimeTypes=h;function w(t,r,l){let d=null,m=null,f=null;for(let u=l.length-1;u>=0;u--){const y=l[u];if(r===y.filenameLowercase){d=y;break}if(y.filepattern&&(!m||y.filepattern.length>m.filepattern.length)){const A=y.filepatternOnPath?t:r;y.filepatternLowercase?.(A)&&(m=y)}y.extension&&(!f||y.extension.length>f.extension.length)&&r.endsWith(y.extensionLowercase)&&(f=y)}return d?d.mime:m?m.mime:f?f.mime:null}function v(t){if((0,P.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let r=C.length-1;r>=0;r--){const l=C[r];if(!l.firstline)continue;const d=t.match(l.firstline);if(d&&d.length>0)return l.mime}return null}function R(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&R(t[0]):!0}e.isUnspecific=R;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(t){const r=(0,D.extname)(t),l=b[r.toLowerCase()];return l!==void 0?l:p(t)}e.getMediaOrTextMime=o;function p(t){const r=(0,D.extname)(t);return s[r.toLowerCase()]}e.getMediaMime=p;function a(t){for(const r in s)if(s[r]===t)return r}e.getExtensionForMimeType=a;const S=/^(.+)\/(.+?)(;.+)?$/;function n(t,r){const l=S.exec(t);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:r?void 0:t}e.normalizeMimeType=n}),define(Ee[103],Se([0,1,2]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class D{constructor(T){this._uriTransformer=T}transformIncoming(T){const c=this._uriTransformer.transformIncoming(T);return c===T?T:i(g.URI.from(c))}transformOutgoing(T){const c=this._uriTransformer.transformOutgoing(T);return c===T?T:i(g.URI.from(c))}transformOutgoingURI(T){const c=this._uriTransformer.transformOutgoing(T);return c===T?T:g.URI.from(c)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function _(L,T,c){if(!L||c>200)return null;if(typeof L=="object"){if(L instanceof g.URI)return T.transformOutgoing(L);for(let E in L)if(Object.hasOwnProperty.call(L,E)){const h=_(L[E],T,c+1);h!==null&&(L[E]=h)}}return null}function P(L,T){const c=_(L,T,0);return c===null?L:c}e.transformOutgoingURIs=P;function k(L,T,c,E){if(!L||E>200)return null;if(typeof L=="object"){if(L.$mid===1)return c?g.URI.revive(T.transformIncoming(L)):T.transformIncoming(L);for(let h in L)if(Object.hasOwnProperty.call(L,h)){const w=k(L[h],T,c,E+1);w!==null&&(L[h]=w)}}return null}function C(L,T){const c=k(L,T,!1,0);return c===null?L:c}e.transformIncomingURIs=C;function I(L,T){const c=k(L,T,!0,0);return c===null?L:c}e.transformAndReviveIncomingURIs=I}),define(Ee[33],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(C){return g.test(C)}e.isUUID=i;const D=new Uint8Array(16),_=[];for(let C=0;C<256;C++)_.push(C.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(C){for(let I=0;I<C.length;I++)C[I]=Math.floor(Math.random()*256);return C};function k(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let C=0,I="";return I+=_[D[C++]],I+=_[D[C++]],I+=_[D[C++]],I+=_[D[C++]],I+="-",I+=_[D[C++]],I+=_[D[C++]],I+="-",I+=_[D[C++]],I+=_[D[C++]],I+="-",I+=_[D[C++]],I+=_[D[C++]],I+="-",I+=_[D[C++]],I+=_[D[C++]],I+=_[D[C++]],I+=_[D[C++]],I+=_[D[C++]],I+=_[D[C++]],I}e.generateUuid=k}),define(Ee[143],Se([0,1,104]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(_="utf8"){this.stringDecoder=new g.StringDecoder(_),this.remaining=null}write(_){const P=[],k=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(k.length<1)return P;let C=0,I,L=C;for(;L<k.length;)if(I=k.charCodeAt(L),I===13||I===10){if(P.push(k.substring(C,L)),L++,L<k.length){const T=I;I=k.charCodeAt(L),(T===13&&I===10||T===10&&I===13)&&L++}C=L}else L++;return this.remaining=C<k.length?k.substr(C):null,P}end(){return this.remaining}}e.LineDecoder=i}),define(Ee[28],Se([0,1,60,81,290,18,30,79,9,12,23,2]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var c;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(c=e.RimRafMode||(e.RimRafMode={}));async function E(O,z=c.UNLINK){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===c.UNLINK?w(O):h(O)}async function h(O){try{const z=(0,P.randomPath)((0,i.tmpdir)());try{await e.Promises.rename(O,z)}catch{return w(O)}w(z).catch(W=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function w(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function v(O){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(O,{recursive:!0})}e.rimrafSync=v;async function R(O,z){return o(await(z?b(O):(0,D.promisify)(g.readdir)(O)))}async function b(O){try{return await(0,D.promisify)(g.readdir)(O,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const z=[],W=await R(O);for(const M of W){let x=!1,V=!1,U=!1;try{const H=await e.Promises.lstat((0,C.join)(O,M));x=H.isFile(),V=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}z.push({name:M,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>U})}return z}function s(O){return o(g.readdirSync(O))}e.readdirSync=s;function o(O){return O.map(z=>typeof z=="string"?I.isMacintosh?(0,k.normalizeNFC)(z):z:(z.name=I.isMacintosh?(0,k.normalizeNFC)(z.name):z.name,z))}async function p(O){const z=await R(O),W=[];for(const M of z)await S.existsDirectory((0,C.join)(O,M))&&W.push(M);return W}function a(O,z=1e3){return new Promise(W=>{let M=!1;const x=setInterval(()=>{M||(M=!0,g.access(O,V=>{M=!1,V&&(clearInterval(x),W(void 0))}))},z)})}e.whenDeleted=a;var S;(function(O){async function z(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(I.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw H}throw U}}O.stat=z;async function W(x){try{const{stat:V,symbolicLink:U}=await O.stat(x);return V.isFile()&&U?.dangling!==!0}catch{}return!1}O.existsFile=W;async function M(x){try{const{stat:V,symbolicLink:U}=await O.stat(x);return V.isDirectory()&&U?.dangling!==!0}catch{}return!1}O.existsDirectory=M})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new _.ResourceQueue;function t(O,z,W){return n.queueFor(T.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const M=m(W);return new Promise((x,V)=>l(O,z,M,U=>U?V(U):x()))})}let r=!0;function l(O,z,W,M){if(!r)return g.writeFile(O,z,{mode:W.mode,flag:W.flag},M);g.open(O,W.flag,W.mode,(x,V)=>{if(x)return M(x);g.writeFile(V,z,U=>{if(U)return g.close(V,()=>M(U));g.fdatasync(V,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),r=!1),g.close(V,Y=>M(Y))))})})}function d(O,z,W){const M=m(W);if(!r)return g.writeFileSync(O,z,{mode:M.mode,flag:M.flag});const x=g.openSync(O,M.flag,M.mode);try{g.writeFileSync(x,z);try{g.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r=!1}}finally{g.closeSync(x)}}e.writeFileSync=d;function m(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function f(O,z){if(O===z)return;async function W(M){try{const x=await e.Promises.lstat(M);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(M,x.atime,new Date)}catch{}}try{await e.Promises.rename(O,z),await W(z)}catch(M){if(O.toLowerCase()!==z.toLowerCase()&&M.code==="EXDEV"||O.endsWith("."))await u(O,z,{preserveSymlinks:!1}),await E(O,c.MOVE),await W(z);else throw M}}async function u(O,z,W){return A(O,z,{root:{source:O,target:z},options:W,handledSourcePaths:new Set})}const y=511;async function A(O,z,W){if(W.handledSourcePaths.has(O))return;W.handledSourcePaths.add(O);const{stat:M,symbolicLink:x}=await S.stat(O);if(x){if(W.options.preserveSymlinks)try{return await F(O,z,W)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return M.isDirectory()?N(O,z,M.mode&y,W):B(O,z,M.mode&y)}async function N(O,z,W,M){await e.Promises.mkdir(z,{recursive:!0,mode:W});const x=await R(O);for(const V of x)await A((0,C.join)(O,V),(0,C.join)(z,V),M)}async function B(O,z,W){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,W)}async function F(O,z,W){let M=await e.Promises.readlink(O);(0,P.isEqualOrParent)(M,W.root.source,!I.isLinux)&&(M=(0,C.join)(W.root.target,M.substr(W.root.source.length+1))),await e.Promises.symlink(M,z)}e.Promises=new class{get access(){return(0,D.promisify)(g.access)}get stat(){return(0,D.promisify)(g.stat)}get lstat(){return(0,D.promisify)(g.lstat)}get utimes(){return(0,D.promisify)(g.utimes)}get read(){return(0,D.promisify)(g.read)}get readFile(){return(0,D.promisify)(g.readFile)}get write(){return(0,D.promisify)(g.write)}get appendFile(){return(0,D.promisify)(g.appendFile)}get fdatasync(){return(0,D.promisify)(g.fdatasync)}get truncate(){return(0,D.promisify)(g.truncate)}get rename(){return(0,D.promisify)(g.rename)}get copyFile(){return(0,D.promisify)(g.copyFile)}get open(){return(0,D.promisify)(g.open)}get close(){return(0,D.promisify)(g.close)}get symlink(){return(0,D.promisify)(g.symlink)}get readlink(){return(0,D.promisify)(g.readlink)}get chmod(){return(0,D.promisify)(g.chmod)}get mkdir(){return(0,D.promisify)(g.mkdir)}get unlink(){return(0,D.promisify)(g.unlink)}get rmdir(){return(0,D.promisify)(g.rmdir)}get realpath(){return(0,D.promisify)(g.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return R}get readDirsInDir(){return p}get writeFile(){return t}get rm(){return E}get move(){return f}get copy(){return u}}}),define(Ee[105],Se([0,1,60,9,8,28]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(L){const T=(0,i.dirname)(L);if(L===T)return L;const c=((0,i.basename)(L)||L).toLowerCase();try{const h=(0,_.readdirSync)(T).filter(w=>w.toLowerCase()===c);if(h.length===1){const w=P(T);if(w)return(0,i.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(c);if(w>=0){const v=P(T);if(v)return(0,i.join)(v,h[w])}}}catch{}return null}e.realcaseSync=P;async function k(L){try{return await _.Promises.realpath(L)}catch{const c=I(L);return await _.Promises.access(c,g.constants.R_OK),c}}e.realpath=k;function C(L){try{return g.realpathSync(L)}catch{const c=I(L);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=C;function I(L){return(0,D.rtrim)((0,i.normalize)(L),i.sep)}});var je=this&&this.__decorate||function(X,e,g,i){var D=arguments.length,_=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,g):i,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(X,e,g,i);else for(var k=X.length-1;k>=0;k--)(P=X[k])&&(_=(D<3?P(_):D>3?P(e,g,_):P(e,g))||_);return D>3&&_&&Object.defineProperty(e,g,_),_};define(Ee[106],Se([0,1,16,18,22,21,57,15,3,6,59,8,13]),function(X,e,g,i,D,_,P,k,C,I,L,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function v(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(R||(R={}));class b{constructor(U){this.buffer=U,this.pos=0}read(U){const H=this.buffer.slice(this.pos,this.pos+U);return this.pos+=H.byteLength,H}}class s{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(o||(o={}));function p(V){const U=D.VSBuffer.alloc(4);return U.writeUInt32BE(V,0),U}function a(V){return V.read(4).readUInt32BE(0)}function S(V){const U=D.VSBuffer.alloc(1);return U.writeUInt8(V,0),U}const n={Undefined:S(o.Undefined),String:S(o.String),Buffer:S(o.Buffer),VSBuffer:S(o.VSBuffer),Array:S(o.Array),Object:S(o.Object)},t=typeof Buffer!="undefined";function r(V,U){if(typeof U=="undefined")V.write(n.Undefined);else if(typeof U=="string"){const H=D.VSBuffer.fromString(U);V.write(n.String),V.write(p(H.byteLength)),V.write(H)}else if(t&&Buffer.isBuffer(U)){const H=D.VSBuffer.wrap(U);V.write(n.Buffer),V.write(p(H.byteLength)),V.write(H)}else if(U instanceof D.VSBuffer)V.write(n.VSBuffer),V.write(p(U.byteLength)),V.write(U);else if(Array.isArray(U)){V.write(n.Array),V.write(p(U.length));for(const H of U)r(V,H)}else{const H=D.VSBuffer.fromString(JSON.stringify(U));V.write(n.Object),V.write(p(H.byteLength)),V.write(H)}}function l(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(a(V)).toString();case o.Buffer:return V.read(a(V)).buffer;case o.VSBuffer:return V.read(a(V));case o.Array:{const H=a(V),Y=[];for(let re=0;re<H;re++)Y.push(l(V));return Y}case o.Object:return JSON.parse(V.read(a(V)).toString())}}class d{constructor(U,H,Y=null,re=1e3){this.protocol=U,this.ctx=H,this.logger=Y,this.timeoutDelay=re,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(U,H){this.channels.set(U,H),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const H=this.send([U.type]);this.logger&&this.logger.logOutgoing(H,0,1,v(U.type));return}case 201:case 202:case 204:case 203:{const H=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(H,U.id,1,v(U.type),U.data);return}}}send(U,H=void 0){const Y=new s;return r(Y,U),r(Y,H),this.sendBuffer(Y.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const H=new b(U),Y=l(H),re=l(H),K=Y[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${h(K)}: ${Y[2]}.${Y[3]}`,re),this.onPromise({type:K,id:Y[1],channelName:Y[2],name:Y[3],arg:re});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${h(K)}: ${Y[2]}.${Y[3]}`,re),this.onEventListen({type:K,id:Y[1],channelName:Y[2],name:Y[3],arg:re});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:Y[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:Y[1]})}}onPromise(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const Y=new _.CancellationTokenSource;let re;try{re=H.call(this.ctx,U.name,U.arg,Y.token)}catch(te){re=Promise.reject(te)}const K=U.id;re.then(te=>{this.sendResponse({id:K,data:te,type:201}),this.activeRequests.delete(U.id)},te=>{te instanceof Error?this.sendResponse({id:K,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.sendResponse({id:K,data:te,type:203}),this.activeRequests.delete(U.id)});const j=(0,I.toDisposable)(()=>Y.cancel());this.activeRequests.set(U.id,j)}onEventListen(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const Y=U.id,K=H.listen(this.ctx,U.name,U.arg)(j=>this.sendResponse({id:Y,data:j,type:204}));this.activeRequests.set(U.id,K)}disposeActiveRequest(U){const H=this.activeRequests.get(U.id);H&&(H.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let H=this.pendingRequests.get(U.channelName);H||(H=[],this.pendingRequests.set(U.channelName,H));const Y=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:U,timeoutTimer:Y})}flushPendingRequests(U){const H=this.pendingRequests.get(U);if(H){for(const Y of H)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var m;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(U,H=null){this.protocol=U,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=H}getChannel(U){const H=this;return{call(Y,re,K){return H.isDisposed?Promise.reject(k.canceled()):H.requestPromise(U,Y,re,K)},listen(Y,re){return H.isDisposed?Promise.reject(k.canceled()):H.requestEvent(U,Y,re)}}}requestPromise(U,H,Y,re=_.CancellationToken.None){const K=this.lastRequestId++,te={id:K,type:100,channelName:U,name:H,arg:Y};if(re.isCancellationRequested)return Promise.reject(k.canceled());let ae;return new Promise((Ie,Me)=>{if(re.isCancellationRequested)return Me(k.canceled());const Ne=()=>{const he=ee=>{switch(ee.type){case 201:this.handlers.delete(K),Ie(ee.data);break;case 202:{this.handlers.delete(K);const oe=new Error(ee.data.message);oe.stack=ee.data.stack,oe.name=ee.data.name,Me(oe);break}case 203:this.handlers.delete(K),Me(ee.data);break}};this.handlers.set(K,he),this.sendRequest(te)};let q=null;this.state===R.Idle?Ne():(q=(0,i.createCancelablePromise)(he=>this.whenInitialized()),q.then(()=>{q=null,Ne()}));const J=()=>{q?(q.cancel(),q=null):this.sendRequest({id:K,type:101}),Me(k.canceled())},ne=re.onCancellationRequested(J);ae=(0,I.combinedDisposable)((0,I.toDisposable)(J),ne),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(U,H,Y){const re=this.lastRequestId++,j={id:re,type:102,channelName:U,name:H,arg:Y};let te=null;const ae=new C.Emitter({onFirstListenerAdd:()=>{te=(0,i.createCancelablePromise)(Ie=>this.whenInitialized()),te.then(()=>{te=null,this.activeRequests.add(ae),this.sendRequest(j)})},onLastListenerRemove:()=>{te?(te.cancel(),te=null):(this.activeRequests.delete(ae),this.sendRequest({id:re,type:103}))}}),ge=Ie=>ae.fire(Ie.data);return this.handlers.set(re,ge),ae.event}sendRequest(U){switch(U.type){case 100:case 102:{const H=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(H,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(H,U.id,0,h(U.type));return}}}send(U,H=void 0){const Y=new s;return r(Y,U),r(Y,H),this.sendBuffer(Y.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const H=new b(U),Y=l(H),re=l(H),K=Y[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,v(K)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],0,v(K),re),this.onResponse({type:Y[0],id:Y[1],data:re})}}onResponse(U){if(U.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(U.id);H&&H(U)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}je([P.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class u{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:H,onDidClientDisconnect:Y})=>{C.Event.once(H.onMessage)(K=>{const j=new b(K),te=l(j),ae=new d(H,te),ge=new f(H);this.channels.forEach((Me,Ne)=>ae.registerChannel(Ne,Me));const Ie={channelServer:ae,channelClient:ge,ctx:te};this._connections.add(Ie),this._onDidAddConnection.fire(Ie),Y(()=>{ae.dispose(),ge.dispose(),this._connections.delete(Ie),this._onDidRemoveConnection.fire(Ie)})})})}get connections(){const U=[];return this._connections.forEach(H=>U.push(H)),U}getChannel(U,H){const Y=this;return{call(re,K,j){let te;if((0,c.isFunction)(H)){let ge=(0,g.getRandomElement)(Y.connections.filter(H));te=ge?Promise.resolve(ge):C.Event.toPromise(C.Event.filter(Y.onDidAddConnection,H))}else te=H.routeCall(Y,re,K);const ae=te.then(ge=>ge.channelClient.getChannel(U));return A(ae).call(re,K,j)},listen(re,K){if((0,c.isFunction)(H))return Y.getMulticastEvent(U,H,re,K);const j=H.routeEvent(Y,re,K).then(te=>te.channelClient.getChannel(U));return A(j).listen(re,K)}}}getMulticastEvent(U,H,Y,re){const K=this;let j=new I.DisposableStore;const te=new C.Emitter({onFirstListenerAdd:()=>{j=new I.DisposableStore;const ae=new C.EventMultiplexer,ge=new Map,Ie=Ne=>{const J=Ne.channelClient.getChannel(U).listen(Y,re),ne=ae.add(J);ge.set(Ne,ne)},Me=Ne=>{const q=ge.get(Ne);!q||(q.dispose(),ge.delete(Ne))};K.connections.filter(H).forEach(Ie),C.Event.filter(K.onDidAddConnection,H)(Ie,void 0,j),K.onDidRemoveConnection(Me,void 0,j),ae.event(te.fire,te,j),j.add(ae)},onLastListenerRemove:()=>{j.dispose()}});return te.event}registerChannel(U,H){this.channels.set(U,H),this._connections.forEach(Y=>{Y.channelServer.registerChannel(U,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=u;class y{constructor(U,H,Y=null){const re=new s;r(re,H),U.send(re.buffer),this.channelClient=new f(U,Y),this.channelServer=new d(U,H,Y)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,H){this.channelServer.registerChannel(U,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=y;function A(V){return{call(U,H,Y){return V.then(re=>re.call(U,H,Y))},listen(U,H){const Y=new C.Relay;return V.then(re=>Y.input=re.listen(U,H)),Y.event}}}e.getDelayedChannel=A;function N(V){let U=!1;return{call(H,Y,re){return U?V.call(H,Y,re):(0,i.timeout)(0).then(()=>U=!0).then(()=>V.call(H,Y,re))},listen(H,Y){if(U)return V.listen(H,Y);const re=new C.Relay;return(0,i.timeout)(0).then(()=>U=!0).then(()=>re.input=V.listen(H,Y)),re.event}}}e.getNextTickChannel=N;class B{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const H of U.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await C.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=B;var F;(function(V){function U(K,j){const te=K,ae=j&&j.disableMarshalling,ge=new Map;for(const Ie in te)Y(Ie)&&ge.set(Ie,C.Event.buffer(te[Ie],!0));return new class{listen(Ie,Me,Ne){const q=ge.get(Me);if(q)return q;if(re(Me)){const J=te[Me];if(typeof J=="function")return J.call(te,Ne)}throw new Error(`Event not found: ${Me}`)}call(Ie,Me,Ne){const q=te[Me];if(typeof q=="function"){if(!ae&&Array.isArray(Ne))for(let J=0;J<Ne.length;J++)Ne[J]=(0,L.revive)(Ne[J]);return q.apply(te,Ne)}throw new Error(`Method not found: ${Me}`)}}}V.fromService=U;function H(K,j){const te=j&&j.disableMarshalling;return new Proxy({},{get(ae,ge){if(typeof ge=="string")return j?.properties?.has(ge)?j.properties.get(ge):re(ge)?function(Ie){return K.listen(ge,Ie)}:Y(ge)?K.listen(ge):async function(...Ie){let Me;j&&!(0,c.isUndefinedOrNull)(j.context)?Me=[j.context,...Ie]:Me=Ie;const Ne=await K.call(ge,Me);return te?Ne:(0,L.revive)(Ne)};throw new Error(`Property not found: ${String(ge)}`)}})}V.toService=H;function Y(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function re(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let U=V.toString();if(U!=="[object Object]")return U}return V}function W(V){return Array.isArray(V)?V.map(z):z(V)}function M(V,U,H,Y,re,K,j){j=W(j);const te=O[re],ae=te[Y%te.length];let ge=[`%c[${V}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(K)?(ge=ge.concat(j),ge.push(")")):ge.push(j),console.log.apply(console,ge)}e.logWithColors=M;class x{constructor(U,H){this._outgoingPrefix=U,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,H,Y,re,K){this._totalOutgoing+=U,M(this._outgoingPrefix,this._totalOutgoing,U,H,Y,re,K)}logIncoming(U,H,Y,re,K){this._totalIncoming+=U,M(this._incomingPrefix,this._totalIncoming,U,H,Y,re,K)}}e.IPCLogger=x}),define(Ee[107],Se([0,1,22,3,6,106]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let l=0;function d(f,u){if(!r.has(f)){const y=String(++l);r.set(f,y)}return r.get(f)}function m(f,u,y,A){if(!t.enableDiagnostics)return;const N=d(f,u);if(A instanceof g.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const B=g.VSBuffer.alloc(A.byteLength);B.set(A),t.records.push({timestamp:Date.now(),id:N,label:u,type:y,buff:B})}else t.records.push({timestamp:Date.now(),id:N,label:u,type:y,data:A})}t.traceSocketEvent=m})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function L(){return I||(I=g.VSBuffer.alloc(0)),I}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const u=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),u}if(this._chunks[0].byteLength>r){const u=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),u}let d=g.VSBuffer.alloc(r),m=0,f=0;for(;r>0;){const u=this._chunks[f];if(u.byteLength>r){const y=u.slice(0,r);d.set(y,m),m+=r,l&&(this._chunks[f]=u.slice(r),this._totalLength-=r),r-=r}else d.set(u,m),m+=u.byteLength,l?(this._chunks.shift(),this._totalLength-=u.byteLength):f++,r-=u.byteLength}return d}}e.ChunkStream=T;var c;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(c||(c={}));function E(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(r,l,d,m){this.type=r,this.id=l,this.ack=d,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(r){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const d=this._state.messageType,m=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new w(d,m,f,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class R{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=g.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(l,r.data)}_bufferAdd(r,l){const d=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,d}_bufferTake(){const r=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class b extends D.Disposable{constructor(r){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new R(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new w(1,0,0,r))}}e.Protocol=b;class s extends _.IPCClient{constructor(r,l,d=null){super(r,l,d);this.protocol=r}static fromSocket(r,l){return new s(new b(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=s;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class p{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,d=this._first;for(;d;)r[l++]=d.data,d=d.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new p(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class S{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<S._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=S._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const r=Date.now(),l=(1+S._HISTORY_LENGTH)*1e3;let d=0;for(let m=0;m<S._HISTORY_LENGTH;m++)r-this.lastRuns[m]<=l&&d++;return 1-d/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class n{constructor(r,l=null,d=S.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),l&&this._socketReader.acceptChunk(l)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new w(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new w(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new w(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new w(3,0,this._incomingAckId,L());this._socketWriter.write(r);const l=this._outgoingUnackMsg.toArray();for(let d=0,m=l.length;d<m;d++)this._socketWriter.write(l[d]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new w(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let d=0,m=l.length;d<m;d++)this._socketWriter.write(l[d]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new w(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(r){const l=new w(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime,d=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&d>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-l,2e4-d,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new w(3,0,this._incomingAckId,L());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(Ee[108],Se([0,1,99]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(k){let C=(0,g.toUint8)(k);this._defaultValue=C,this._asciiMap=i._createAsciiMap(C),this._map=new Map}static _createAsciiMap(k){let C=new Uint8Array(256);for(let I=0;I<256;I++)C[I]=k;return C}set(k,C){let I=(0,g.toUint8)(C);k>=0&&k<256?this._asciiMap[k]=I:this._map.set(k,I)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=i;var D;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(D||(D={}));class _{constructor(){this._actual=new i(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=_}),define(Ee[144],Se([0,1,108]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends g.CharacterClassifier{constructor(k){super(0);for(let C=0,I=k.length;C<I;C++)this.set(k.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function _(P){let k={};return C=>(k.hasOwnProperty(C)||(k[C]=P(C)),k[C])}e.getMapForWordSeparators=_(P=>new D(P))}),define(Ee[49],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(D,_){this.lineNumber=D,this.column=_}with(D=this.lineNumber,_=this.column){return D===this.lineNumber&&_===this.column?this:new g(D,_)}delta(D=0,_=0){return this.with(this.lineNumber+D,this.column+_)}equals(D){return g.equals(this,D)}static equals(D,_){return!D&&!_?!0:!!D&&!!_&&D.lineNumber===_.lineNumber&&D.column===_.column}isBefore(D){return g.isBefore(this,D)}static isBefore(D,_){return D.lineNumber<_.lineNumber?!0:_.lineNumber<D.lineNumber?!1:D.column<_.column}isBeforeOrEqual(D){return g.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,_){return D.lineNumber<_.lineNumber?!0:_.lineNumber<D.lineNumber?!1:D.column<=_.column}static compare(D,_){let P=D.lineNumber|0,k=_.lineNumber|0;if(P===k){let C=D.column|0,I=_.column|0;return C-I}return P-k}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new g(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=g}),define(Ee[41],Se([0,1,49]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(_,P,k,C){_>k||_===k&&P>C?(this.startLineNumber=k,this.startColumn=C,this.endLineNumber=_,this.endColumn=P):(this.startLineNumber=_,this.startColumn=P,this.endLineNumber=k,this.endColumn=C)}isEmpty(){return i.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return i.containsPosition(this,_)}static containsPosition(_,P){return!(P.lineNumber<_.startLineNumber||P.lineNumber>_.endLineNumber||P.lineNumber===_.startLineNumber&&P.column<_.startColumn||P.lineNumber===_.endLineNumber&&P.column>_.endColumn)}static strictContainsPosition(_,P){return!(P.lineNumber<_.startLineNumber||P.lineNumber>_.endLineNumber||P.lineNumber===_.startLineNumber&&P.column<=_.startColumn||P.lineNumber===_.endLineNumber&&P.column>=_.endColumn)}containsRange(_){return i.containsRange(this,_)}static containsRange(_,P){return!(P.startLineNumber<_.startLineNumber||P.endLineNumber<_.startLineNumber||P.startLineNumber>_.endLineNumber||P.endLineNumber>_.endLineNumber||P.startLineNumber===_.startLineNumber&&P.startColumn<_.startColumn||P.endLineNumber===_.endLineNumber&&P.endColumn>_.endColumn)}strictContainsRange(_){return i.strictContainsRange(this,_)}static strictContainsRange(_,P){return!(P.startLineNumber<_.startLineNumber||P.endLineNumber<_.startLineNumber||P.startLineNumber>_.endLineNumber||P.endLineNumber>_.endLineNumber||P.startLineNumber===_.startLineNumber&&P.startColumn<=_.startColumn||P.endLineNumber===_.endLineNumber&&P.endColumn>=_.endColumn)}plusRange(_){return i.plusRange(this,_)}static plusRange(_,P){let k,C,I,L;return P.startLineNumber<_.startLineNumber?(k=P.startLineNumber,C=P.startColumn):P.startLineNumber===_.startLineNumber?(k=P.startLineNumber,C=Math.min(P.startColumn,_.startColumn)):(k=_.startLineNumber,C=_.startColumn),P.endLineNumber>_.endLineNumber?(I=P.endLineNumber,L=P.endColumn):P.endLineNumber===_.endLineNumber?(I=P.endLineNumber,L=Math.max(P.endColumn,_.endColumn)):(I=_.endLineNumber,L=_.endColumn),new i(k,C,I,L)}intersectRanges(_){return i.intersectRanges(this,_)}static intersectRanges(_,P){let k=_.startLineNumber,C=_.startColumn,I=_.endLineNumber,L=_.endColumn,T=P.startLineNumber,c=P.startColumn,E=P.endLineNumber,h=P.endColumn;return k<T?(k=T,C=c):k===T&&(C=Math.max(C,c)),I>E?(I=E,L=h):I===E&&(L=Math.min(L,h)),k>I||k===I&&C>L?null:new i(k,C,I,L)}equalsRange(_){return i.equalsRange(this,_)}static equalsRange(_,P){return!!_&&!!P&&_.startLineNumber===P.startLineNumber&&_.startColumn===P.startColumn&&_.endLineNumber===P.endLineNumber&&_.endColumn===P.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(_){return new g.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(_){return new g.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,P){return new i(this.startLineNumber,this.startColumn,_,P)}setStartPosition(_,P){return new i(_,P,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(_){return new i(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,P=_){return new i(_.lineNumber,_.column,P.lineNumber,P.column)}static lift(_){return _?new i(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,P){return!(_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn||P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn)}static areIntersecting(_,P){return!(_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn||P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,P){if(_&&P){const I=_.startLineNumber|0,L=P.startLineNumber|0;if(I===L){const T=_.startColumn|0,c=P.startColumn|0;if(T===c){const E=_.endLineNumber|0,h=P.endLineNumber|0;if(E===h){const w=_.endColumn|0,v=P.endColumn|0;return w-v}return E-h}return T-c}return I-L}return(_?1:0)-(P?1:0)}static compareRangesUsingEnds(_,P){return _.endLineNumber===P.endLineNumber?_.endColumn===P.endColumn?_.startLineNumber===P.startLineNumber?_.startColumn-P.startColumn:_.startLineNumber-P.startLineNumber:_.endColumn-P.endColumn:_.endLineNumber-P.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=i}),define(Ee[145],Se([0,1,49,41]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class _ extends i.Range{constructor(k,C,I,L){super(k,C,I,L);this.selectionStartLineNumber=k,this.selectionStartColumn=C,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return _.selectionsEqual(this,k)}static selectionsEqual(k,C){return k.selectionStartLineNumber===C.selectionStartLineNumber&&k.selectionStartColumn===C.selectionStartColumn&&k.positionLineNumber===C.positionLineNumber&&k.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,C){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,k,C):new _(k,C,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new g.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,C){return this.getDirection()===0?new _(k,C,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,k,C)}static fromPositions(k,C=k){return new _(k.lineNumber,k.column,C.lineNumber,C.column)}static fromRange(k,C){return C===0?new _(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new _(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new _(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,C){if(k&&!C||!k&&C)return!1;if(!k&&!C)return!0;if(k.length!==C.length)return!1;for(let I=0,L=k.length;I<L;I++)if(!this.selectionsEqual(k[I],C[I]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,C,I,L,T){return T===0?new _(k,C,I,L):new _(I,L,k,C)}}e.Selection=_}),define(Ee[109],Se([0,1,25]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var _;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class I{constructor(v,R){this._findMatchBrand=void 0,this.range=v,this.matches=R}}e.FindMatch=I;var L;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(T=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class E{constructor(v,R,b,s,o,p){this.identifier=v,this.range=R,this.text=b,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=o,this._isTracked=p}}e.ValidAnnotatedEditOperation=E;class h{constructor(v,R,b){this.reverseEdits=v,this.changes=R,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=h}),define(Ee[146],Se([0,1,8,144,49,41,109]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class C{constructor(s,o,p,a){this.searchString=s,this.isRegex=o,this.matchCase=p,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=I(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!o)return null;let p=!this.isRegex&&!s;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new L(o,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=C;function I(b){if(!b||b.length===0)return!1;for(let s=0,o=b.length;s<o;s++)if(b.charCodeAt(s)===92){if(s++,s>=o)break;const a=b.charCodeAt(s);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=I;class L{constructor(s,o,p){this.regex=s,this.wordSeparators=o,this.simpleSearch=p}}e.SearchData=L;function T(b,s,o){if(!o)return new P.FindMatch(b,null);let p=[];for(let a=0,S=s.length;a<S;a++)p[a]=s[a];return new P.FindMatch(b,p)}e.createFindMatch=T;class c{constructor(s){let o=[],p=0;for(let a=0,S=s.length;a<S;a++)s.charCodeAt(a)===10&&(o[p++]=a);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(s){const o=this._lineFeedsOffsets;let p=0,a=o.length-1;if(a===-1||s<=o[0])return 0;for(;p<a;){const S=p+((a-p)/2>>0);o[S]>=s?a=S-1:o[S+1]>=s?(p=S,a=S):p=S+1}return p+1}}class E{static findMatches(s,o,p,a,S){const n=o.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(s,p,new R(n.wordSeparators,n.regex),a,S):this._doFindMatchesLineByLine(s,p,n,a,S):[]}static _getMultilineMatchRange(s,o,p,a,S,n){let t,r=0;a?(r=a.findLineFeedCountBeforeOffset(S),t=o+S+r):t=o+S;let l;if(a){let u=a.findLineFeedCountBeforeOffset(S+n.length)-r;l=t+n.length+u}else l=t+n.length;const d=s.getPositionAt(t),m=s.getPositionAt(l);return new _.Range(d.lineNumber,d.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(s,o,p,a,S){const n=s.getOffsetAt(o.getStartPosition()),t=s.getValueInRange(o,1),r=s.getEOL()===`\r
`?new c(t):null,l=[];let d=0,m;for(p.reset(0);m=p.next(t);)if(l[d++]=T(this._getMultilineMatchRange(s,n,t,r,m.index,m[0]),m,a),d>=S)return l;return l}static _doFindMatchesLineByLine(s,o,p,a,S){const n=[];let t=0;if(o.startLineNumber===o.endLineNumber){const l=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return t=this._findMatchesInLine(p,l,o.startLineNumber,o.startColumn-1,t,n,a,S),n}const r=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);t=this._findMatchesInLine(p,r,o.startLineNumber,o.startColumn-1,t,n,a,S);for(let l=o.startLineNumber+1;l<o.endLineNumber&&t<S;l++)t=this._findMatchesInLine(p,s.getLineContent(l),l,0,t,n,a,S);if(t<S){const l=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);t=this._findMatchesInLine(p,l,o.endLineNumber,0,t,n,a,S)}return n}static _findMatchesInLine(s,o,p,a,S,n,t,r){const l=s.wordSeparators;if(!t&&s.simpleSearch){const f=s.simpleSearch,u=f.length,y=o.length;let A=-u;for(;(A=o.indexOf(f,A+u))!==-1;)if((!l||v(l,o,y,A,u))&&(n[S++]=new P.FindMatch(new _.Range(p,A+1+a,p,A+1+u+a),null),S>=r))return S;return S}const d=new R(s.wordSeparators,s.regex);let m;d.reset(0);do if(m=d.next(o),m&&(n[S++]=T(new _.Range(p,m.index+1+a,p,m.index+1+m[0].length+a),m,t),S>=r))return S;while(m);return S}static findNextMatch(s,o,p,a){const S=o.parseSearchRequest();if(!S)return null;const n=new R(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(s,p,n,a):this._doFindNextMatchLineByLine(s,p,n,a)}static _doFindNextMatchMultiline(s,o,p,a){const S=new D.Position(o.lineNumber,1),n=s.getOffsetAt(S),t=s.getLineCount(),r=s.getValueInRange(new _.Range(S.lineNumber,S.column,t,s.getLineMaxColumn(t)),1),l=s.getEOL()===`\r
`?new c(r):null;p.reset(o.column-1);let d=p.next(r);return d?T(this._getMultilineMatchRange(s,n,r,l,d.index,d[0]),d,a):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(s,new D.Position(1,1),p,a):null}static _doFindNextMatchLineByLine(s,o,p,a){const S=s.getLineCount(),n=o.lineNumber,t=s.getLineContent(n),r=this._findFirstMatchInLine(p,t,n,o.column,a);if(r)return r;for(let l=1;l<=S;l++){const d=(n+l-1)%S,m=s.getLineContent(d+1),f=this._findFirstMatchInLine(p,m,d+1,1,a);if(f)return f}return null}static _findFirstMatchInLine(s,o,p,a,S){s.reset(a-1);const n=s.next(o);return n?T(new _.Range(p,n.index+1,p,n.index+1+n[0].length),n,S):null}static findPreviousMatch(s,o,p,a){const S=o.parseSearchRequest();if(!S)return null;const n=new R(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(s,p,n,a):this._doFindPreviousMatchLineByLine(s,p,n,a)}static _doFindPreviousMatchMultiline(s,o,p,a){const S=this._doFindMatchesMultiline(s,new _.Range(1,1,o.lineNumber,o.column),p,a,10*k);if(S.length>0)return S[S.length-1];const n=s.getLineCount();return o.lineNumber!==n||o.column!==s.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(s,new D.Position(n,s.getLineMaxColumn(n)),p,a):null}static _doFindPreviousMatchLineByLine(s,o,p,a){const S=s.getLineCount(),n=o.lineNumber,t=s.getLineContent(n).substring(0,o.column-1),r=this._findLastMatchInLine(p,t,n,a);if(r)return r;for(let l=1;l<=S;l++){const d=(S+n-l-1)%S,m=s.getLineContent(d+1),f=this._findLastMatchInLine(p,m,d+1,a);if(f)return f}return null}static _findLastMatchInLine(s,o,p,a){let S=null,n;for(s.reset(0);n=s.next(o);)S=T(new _.Range(p,n.index+1,p,n.index+1+n[0].length),n,a);return S}}e.TextModelSearch=E;function h(b,s,o,p,a){if(p===0)return!0;const S=s.charCodeAt(p-1);if(b.get(S)!==0||S===13||S===10)return!0;if(a>0){const n=s.charCodeAt(p);if(b.get(n)!==0)return!0}return!1}function w(b,s,o,p,a){if(p+a===o)return!0;const S=s.charCodeAt(p+a);if(b.get(S)!==0||S===13||S===10)return!0;if(a>0){const n=s.charCodeAt(p+a-1);if(b.get(n)!==0)return!0}return!1}function v(b,s,o,p,a){return h(b,s,o,p,a)&&w(b,s,o,p,a)}e.isValidMatch=v;class R{constructor(s,o){this._wordSeparators=s,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const o=s.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(p=this._searchRegex.exec(s),!p))return null;const a=p.index,S=p[0].length;if(a===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){g.getNextCodePoint(s,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=S,!this._wordSeparators||v(this._wordSeparators,s,o,a,S))return p}while(p);return null}}e.Searcher=R}),define(Ee[110],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(k=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)k.indexOf(I)>=0||(C+="\\"+I);return C+="\\s]+)",new RegExp(C,"g")}e.DEFAULT_WORD_REGEXP=g();function i(k){let C=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)C=k;else{let I="g";k.ignoreCase&&(I+="i"),k.multiline&&(I+="m"),k.unicode&&(I+="u"),C=new RegExp(k.source,I)}return C.lastIndex=0,C}e.ensureValidWordDefinition=i;const D={maxLen:1e3,windowSize:15,timeBudget:150};function _(k,C,I,L,T=D){if(I.length>T.maxLen){let v=k-T.maxLen/2;return v<0?v=0:L+=v,I=I.substring(v,k+T.maxLen/2),_(k,C,I,L,T)}const c=Date.now(),E=k-1-L;let h=-1,w=null;for(let v=1;!(Date.now()-c>=T.timeBudget);v++){const R=E-T.windowSize*v;C.lastIndex=Math.max(0,R);const b=P(C,I,E,h);if(!b&&w||(w=b,R<=0))break;h=R}if(w){let v={word:w[0],startColumn:L+1+w.index,endColumn:L+1+w.index+w[0].length};return C.lastIndex=0,v}return null}e.getWordAtText=_;function P(k,C,I,L){let T;for(;T=k.exec(C);){const c=T.index||0;if(c<=I&&k.lastIndex>=I)return T;if(L>0&&c>L)return null}return null}}),define(Ee[147],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class i{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let C=0,I=k.notIn.length;C<I;C++)switch(k.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,C){if(k.getTokenCount()===0)return!0;const I=k.findTokenIndexAtOffset(C-2),L=k.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(k,C){for(let I=k;I<=C;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of k)_(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),_(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),_(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),_(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&_(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=D;function _(P,k,C){P.has(k)?P.get(k).push(C):P.set(k,[C])}}),define(Ee[82],Se([0,1,31,9]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(_,P,k,C){if(Array.isArray(_)){let I=0;for(const L of _){const T=D(L,P,k,C);if(T===10)return T;T>I&&(I=T)}return I}else{if(typeof _=="string")return C?_==="*"?5:_===k?10:0:0;if(_){const{language:I,pattern:L,scheme:T,hasAccessToAllModels:c}=_;if(!C&&!c)return 0;let E=0;if(T)if(T===P.scheme)E=10;else if(T==="*")E=5;else return 0;if(I)if(I===k)E=10;else if(I==="*")E=Math.max(E,5);else return 0;if(L){let h;if(typeof L=="string"?h=L:h={...L,base:(0,i.normalize)(L.base)},h===P.fsPath||(0,g.match)(h,P.fsPath))E=10;else return 0}return E}else return 0}}e.score=D}),define(Ee[148],Se([0,1,108]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class D{constructor(h,w,v){const R=new Uint8Array(h*w);for(let b=0,s=h*w;b<s;b++)R[b]=v;this._data=R,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,v){this._data[h*this.cols+w]=v}}e.Uint8Matrix=D;class _{constructor(h){let w=0,v=0;for(let b=0,s=h.length;b<s;b++){let[o,p,a]=h[b];p>w&&(w=p),o>v&&(v=o),a>v&&(v=a)}w++,v++;let R=new D(v,w,0);for(let b=0,s=h.length;b<s;b++){let[o,p,a]=h[b];R.set(o,p,a)}this._states=R,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=_;let P=null;function k(){return P===null&&(P=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var C;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(C||(C={}));let I=null;function L(){if(I===null){I=new g.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<E.length;w++)I.set(E.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)I.set(h.charCodeAt(w),2)}return I}class T{static _createLink(h,w,v,R,b){let s=b-1;do{const o=w.charCodeAt(s);if(h.get(o)!==2)break;s--}while(s>R);if(R>0){const o=w.charCodeAt(R-1),p=w.charCodeAt(s);(o===40&&p===41||o===91&&p===93||o===123&&p===125)&&s--}return{range:{startLineNumber:v,startColumn:R+1,endLineNumber:v,endColumn:s+2},url:w.substring(R,s+1)}}static computeLinks(h,w=k()){const v=L();let R=[];for(let b=1,s=h.getLineCount();b<=s;b++){const o=h.getLineContent(b),p=o.length;let a=0,S=0,n=0,t=1,r=!1,l=!1,d=!1,m=!1;for(;a<p;){let f=!1;const u=o.charCodeAt(a);if(t===13){let y;switch(u){case 40:r=!0,y=0;break;case 41:y=r?0:1;break;case 91:d=!0,l=!0,y=0;break;case 93:d=!1,y=l?0:1;break;case 123:m=!0,y=0;break;case 125:y=m?0:1;break;case 39:y=n===34||n===96?0:1;break;case 34:y=n===39||n===96?0:1;break;case 96:y=n===39||n===34?0:1;break;case 42:y=n===42?1:0;break;case 124:y=n===124?1:0;break;case 32:y=d?0:1;break;default:y=v.get(u)}y===1&&(R.push(T._createLink(v,o,b,S,a)),f=!0)}else if(t===12){let y;u===91?(l=!0,y=0):y=v.get(u),y===1?f=!0:t=13}else t=w.nextState(t,u),t===0&&(f=!0);f&&(t=1,r=!1,l=!1,m=!1,S=a+1,n=u),a++}t===13&&R.push(T._createLink(v,o,b,S,p))}return R}}e.LinkComputer=T;function c(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:T.computeLinks(E)}e.computeLinks=c}),define(Ee[149],Se([0,1,3,6]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,k){return this._map.set(P,k),this.fire([P]),(0,i.toDisposable)(()=>{this._map.get(P)===k&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,k){let C=null,I=!1;return this._promises.set(P,k.then(L=>{this._promises.delete(P),!(I||!L)&&(C=this.register(P,L))})),(0,i.toDisposable)(()=>{I=!0,C&&C.dispose()})}getPromise(P){const k=this.get(P);if(k)return Promise.resolve(k);const C=this._promises.get(P);return C?C.then(I=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(Ee[111],Se([0,1,22,12]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(D||(D={}));function _(T){for(let c=0,E=T.length;c<E;c+=4){const h=T[c+0],w=T[c+1],v=T[c+2],R=T[c+3];T[c+0]=R,T[c+1]=v,T[c+2]=w,T[c+3]=h}}function P(T){const c=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return i.isLittleEndian()||_(c),g.VSBuffer.wrap(c)}function k(T){const c=T.buffer;if(i.isLittleEndian()||_(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const E=new Uint8Array(c.byteLength);return E.set(c),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function C(T){const c=new Uint32Array(I(T));let E=0;if(c[E++]=T.id,T.type==="full")c[E++]=1,c[E++]=T.data.length,c.set(T.data,E),E+=T.data.length;else{c[E++]=2,c[E++]=T.deltas.length;for(const h of T.deltas)c[E++]=h.start,c[E++]=h.deleteCount,h.data?(c[E++]=h.data.length,c.set(h.data,E),E+=h.data.length):c[E++]=0}return P(c)}e.encodeSemanticTokensDto=C;function I(T){let c=0;if(c+=1+1,T.type==="full")c+=1+T.data.length;else{c+=1,c+=(1+1+1)*T.deltas.length;for(const E of T.deltas)E.data&&(c+=E.data.length)}return c}function L(T){const c=k(T);let E=0;const h=c[E++];if(c[E++]===1){const b=c[E++],s=c.subarray(E,E+b);return E+=b,{id:h,type:"full",data:s}}const v=c[E++];let R=[];for(let b=0;b<v;b++){const s=c[E++],o=c[E++],p=c[E++];let a;p>0&&(a=c.subarray(E,E+p),E+=p),R[b]={start:s,deleteCount:o,data:a}}return{id:h,type:"delta",deltas:R}}e.decodeSemanticTokensDto=L}),define(Ee[112],Se([0,1,16,99]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,I){C=(0,i.toUint32)(C);const L=this.values,T=this.prefixSum,c=I.length;return c===0?!1:(this.values=new Uint32Array(L.length+c),this.values.set(L.subarray(0,C),0),this.values.set(L.subarray(C),C+c),this.values.set(I,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(C,I){return C=(0,i.toUint32)(C),I=(0,i.toUint32)(I),this.values[C]===I?!1:(this.values[C]=I,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,I){C=(0,i.toUint32)(C),I=(0,i.toUint32)(I);const L=this.values,T=this.prefixSum;if(C>=L.length)return!1;let c=L.length-C;return I>=c&&(I=c),I===0?!1:(this.values=new Uint32Array(L.length-I),this.values.set(L.subarray(0,C),0),this.values.set(L.subarray(C+I),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(C){return C<0?0:(C=(0,i.toUint32)(C),this._getPrefixSum(C))}_getPrefixSum(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),C>=this.values.length&&(C=this.values.length-1);for(let L=I;L<=C;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalSum();let I=0,L=this.values.length-1,T=0,c=0,E=0;for(;I<=L;)if(T=I+(L-I)/2|0,c=this.prefixSum[T],E=c-this.values[T],C<E)L=T-1;else if(C>=c)I=T+1;else break;return new P(T,C-E)}}e.PrefixSumComputer=D;class _{constructor(C){this._values=C,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(C){return this._ensureValid(),C===0?0:this._prefixSum[C-1]}getIndexOf(C){this._ensureValid();const I=this._indexBySum[C],L=I>0?this._prefixSum[I-1]:0;return new P(I,C-L)}removeValues(C,I){this._values.splice(C,I),this._invalidate(C)}insertValues(C,I){this._values=(0,g.arrayInsert)(this._values,C,I),this._invalidate(C)}_invalidate(C){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,C-1)}_ensureValid(){if(!this._isValid){for(let C=this._validEndIndex+1,I=this._values.length;C<I;C++){const L=this._values[C],T=C>0?this._prefixSum[C-1]:0;this._prefixSum[C]=T+L;for(let c=0;c<L;c++)this._indexBySum[T+c]=C}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(C,I){this._values[C]!==I&&(this._values[C]=I,this._invalidate(C))}}e.ConstantTimePrefixSumComputer=_;class P{constructor(C,I){this.index=C,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=C,this.remainder=I}}e.PrefixSumIndexOfResult=P}),define(Ee[150],Se([0,1,8,49,112]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(k,C,I,L){this._uri=k,this._lines=C,this._eol=I,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const C=k.changes;for(const I of C)this._acceptDeleteRange(I.range),this._acceptInsertText(new i.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,C=this._lines.length,I=new Uint32Array(C);for(let L=0;L<C;L++)I[L]=this._lines[L].length+k;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(k,C){this._lines[k]=C,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,C){if(C.length===0)return;let I=(0,g.splitLines)(C);if(I.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}I[I.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]);let L=new Uint32Array(I.length-1);for(let T=1;T<I.length;T++)this._lines.splice(k.lineNumber+T-1,0,I[T]),L[T-1]=I[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,L)}}e.MirrorTextModel=_}),define(Ee[151],Se([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(Ee[152],Se([0,1,151]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,_=D*24,P=_*7,k=_*30,C=_*365;function I(T,c){typeof T!="number"&&(T=T.getTime());const E=Math.round((new Date().getTime()-T)/1e3);if(E<-30)return(0,g.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,g.localize)(1,null);let h;return E<i?(h=E,c?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):E<D?(h=Math.floor(E/i),c?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):E<_?(h=Math.floor(E/D),c?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):E<P?(h=Math.floor(E/_),c?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):E<k?(h=Math.floor(E/P),c?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):E<C?(h=Math.floor(E/k),c?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(E/C),c?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=I;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ee[153],Se([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(Ee[50],Se([0,1,16,13,153]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(I,L){return L&&(I.stack||I.stacktrace)?D.localize(0,null,k(I),P(I.stack)||P(I.stacktrace)):k(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function k(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function C(I=null,L=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const T=g.coalesce(I),c=C(T[0],L);return T.length>1?D.localize(4,null,c,T.length):c}if(i.isString(I))return I;if(I.detail){const T=I.detail;if(T.error)return _(T.error,L);if(T.exception)return _(T.exception,L)}return I.stack?_(I,L):I.message?I.message:D.localize(5,null)}e.toErrorMessage=C}),define(Ee[154],Se([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(Ee[113],Se([0,1,37,30,10,25,9,12,40,95,13,143,28,154]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(a,S){if(k.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};S&&(n.cwd=S);const t=g.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(r=>{t.once("error",l=>{r({success:!1,error:l})}),t.once("exit",(l,d)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(k.isLinux||k.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{g.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,l,d)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function v(a){!a||(delete a.DEBUG,k.isMacintosh&&delete a.DYLD_LIBRARY_PATH,k.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function R(a=C.env){return a.comspec||"cmd.exe"}e.getWindowsShell=R;class b{constructor(S,n,t,r){if(n!==void 0&&t!==void 0&&r!==void 0)this.cmd=S,this.args=n,this.shell=t,this.options=r;else{const l=S;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(C.env).forEach(d=>{l[d]=C.env[d]}),Object.keys(this.options.env).forEach(d=>{l[d]=this.options.env[d]}),this.options.env=l}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const n=S.lastIndexOf(P.sep);return n!==-1&&(S=S.substring(n+1)),b.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(C.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let t,r;const l=new Promise((d,m)=>{t=d,r=m});if(n){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=g.exec(d,this.options,(m,f,u)=>{this.childProcess=null;const y=m;y&&y.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:u.toString()}):this.handleExec(t,S,m,f,u)})}else{let d=null;const m=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,t,S,r);const u={terminated:this.terminateRequested};L.isNumber(f)&&(u.cmdCode=f),t(u)};if(this.shell&&k.isWindows){const f=_.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let u=!1,y=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),u=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),A.push(N.value),y=y&&N.quoted});const B=["/s","/c"];u?y?B.push('"'+A.join(" ")+'"'):A.length>1?B.push('"'+A[0]+'" '+A.slice(1).join(" ")):B.push('"'+A[0]+'"'):B.push(A.join(" ")),d=g.spawn(R(),B,f)}else this.cmd&&(d=g.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(L.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),d.pid&&(this.childProcess.on("close",m),this.handleSpawn(d,t,S,r,!0)))}return l})}handleClose(S,n,t,r){}ensureQuotes(S){return b.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,w(S,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const n=g.spawn(R(),["/s","/c"]);n.on("error",t=>S(!0)),n.on("exit",t=>S(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class s extends b{constructor(S,n,t,r){super(S,n,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,n,t,r,l){[r,l].forEach((d,m)=>{const f=new T.LineDecoder;f.write(d).forEach(A=>{n({line:A,source:m===0?0:1})});const y=f.end();y&&n({line:y,source:m===0?0:1})}),S({terminated:this.terminateRequested,error:t})}handleSpawn(S,n,t,r,l){const d=new T.LineDecoder,m=new T.LineDecoder;S.stdout.on("data",f=>{d.write(f).forEach(y=>t({line:y,source:0}))}),S.stderr.on("data",f=>{m.write(f).forEach(y=>t({line:y,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=m}handleClose(S,n,t,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&t({line:l,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&t({line:d,source:1})}}e.LineProcess=s;function o(a){let S=[],n=!1;const t=function(r){if(n){S.push(r);return}(!a.send(r,d=>{if(d&&console.error(d),n=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(f=>t(f))}})||k.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=o;var p;(function(a){async function S(n,t,r){if(P.isAbsolute(n))return n;if(t===void 0&&(t=C.cwd()),P.dirname(n)!=="."||(r===void 0&&L.isString(C.env.PATH)&&(r=C.env.PATH.split(P.delimiter)),r===void 0||r.length===0))return P.join(t,n);async function d(m){if(await c.Promises.exists(m)){let f;try{f=await c.Promises.stat(m)}catch(u){u.message.startsWith("EACCES")&&(f=await c.Promises.lstat(m))}return f?!f.isDirectory():!1}return!1}for(let m of r){let f;if(P.isAbsolute(m)?f=P.join(m,n):f=P.join(t,m,n),await d(f))return f;let u=f+".com";if(await d(u)||(u=f+".exe",await d(u)))return u}return P.join(t,n)}a.findExecutable=S})(p=e.win32||(e.win32={}))}),define(Ee[155],Se([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(Ee[114],Se([0,1,155,12,110,16,25]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=C;class I{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,be){this._values[ie]=be}}e.ValidatedEditorOptions=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(ie,be,ze,Qe){this.id=ie,this.name=be,this.defaultValue=ze,this.schema=Qe}applyUpdate(ie,be){return E(ie,be)}compute(ie,be,ze){return ze}}class c{constructor(ie,be){this.newValue=ie,this.didChange=be}}e.ApplyUpdateResult=c;function E(Z,ie){if(typeof Z!="object"||typeof ie!="object"||!Z||!ie)return new c(ie,Z!==ie);if(Array.isArray(Z)||Array.isArray(ie)){const ze=Array.isArray(Z)&&Array.isArray(ie)&&_.equals(Z,ie);return new c(ie,ze)}let be=!1;for(let ze in ie)if(ie.hasOwnProperty(ze)){const Qe=E(Z[ze],ie[ze]);Qe.didChange&&(Z[ze]=Qe.newValue,be=!0)}return new c(Z,be)}class h{constructor(ie){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0}applyUpdate(ie,be){return E(ie,be)}validate(ie){return this.defaultValue}}class w{constructor(ie,be,ze,Qe){this.id=ie,this.name=be,this.defaultValue=ze,this.schema=Qe}applyUpdate(ie,be){return E(ie,be)}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,be,ze){return ze}}function v(Z,ie){return typeof Z=="undefined"?ie:Z==="false"?!1:Boolean(Z)}e.boolean=v;class R extends w{constructor(ie,be,ze,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="boolean",Qe.default=ze);super(ie,be,ze,Qe)}validate(ie){return v(ie,this.defaultValue)}}function b(Z,ie,be,ze){if(typeof Z=="undefined")return ie;let Qe=parseInt(Z,10);return isNaN(Qe)?ie:(Qe=Math.max(be,Qe),Qe=Math.min(ze,Qe),Qe|0)}e.clampedInt=b;class s extends w{constructor(ie,be,ze,Qe,me,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=ze,Ce.minimum=Qe,Ce.maximum=me);super(ie,be,ze,Ce);this.minimum=Qe,this.maximum=me}static clampedInt(ie,be,ze,Qe){return b(ie,be,ze,Qe)}validate(ie){return s.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class o extends w{constructor(ie,be,ze,Qe,me){typeof me!="undefined"&&(me.type="number",me.default=ze);super(ie,be,ze,me);this.validationFn=Qe}static clamp(ie,be,ze){return ie<be?be:ie>ze?ze:ie}static float(ie,be){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return be;const ze=parseFloat(ie);return isNaN(ze)?be:ze}validate(ie){return this.validationFn(o.float(ie,this.defaultValue))}}class p extends w{static string(ie,be){return typeof ie!="string"?be:ie}constructor(ie,be,ze,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.default=ze);super(ie,be,ze,Qe)}validate(ie){return p.string(ie,this.defaultValue)}}function a(Z,ie,be){return typeof Z!="string"||be.indexOf(Z)===-1?ie:Z}e.stringSet=a;class S extends w{constructor(ie,be,ze,Qe,me=void 0){typeof me!="undefined"&&(me.type="string",me.enum=Qe,me.default=ze);super(ie,be,ze,me);this._allowedValues=Qe}validate(ie){return a(ie,this.defaultValue,this._allowedValues)}}class n extends T{constructor(ie,be,ze,Qe,me,Ce,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=me,$e.default=Qe);super(ie,be,ze,$e);this._allowedValues=me,this._convert=Ce}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function t(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,be,ze){return ze===0?ie.accessibilitySupport:ze}}class l extends T{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{insertSpace:v(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var d;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(d=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(Z){switch(Z){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function y(Z){switch(Z){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class A extends h{constructor(){super(127)}compute(ie,be,ze){const Qe=["monaco-editor"];return be.get(33)&&Qe.push(be.get(33)),ie.extraEditorClassName&&Qe.push(ie.extraEditorClassName),be.get(65)==="default"?Qe.push("mouse-default"):be.get(65)==="copy"&&Qe.push("mouse-copy"),be.get(99)&&Qe.push("showUnused"),be.get(125)&&Qe.push("showDeprecated"),Qe.join(" ")}}class N extends R{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ie,be,ze){return ze&&ie.emptySelectionClipboard}}class B extends T{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:g.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:g.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{cursorMoveOnType:v(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":a(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":a(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(be.loop,this.defaultValue.loop)}}}class F extends T{constructor(){super(44,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?F.OFF:ie==="true"?F.ON:ie:Boolean(ie)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class O extends h{constructor(){super(43)}compute(ie,be,ze){return ie.fontInfo}}class z extends w{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ie){let be=o.float(ie,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(be,6,100)}compute(ie,be,ze){return ie.fontInfo.fontSize}}class W extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(s.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class M extends T{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...be},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...be},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...be},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:ze,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:ze,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:ze,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:ze,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:ze,description:g.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{multiple:a(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??a(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??a(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??a(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??a(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??a(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends T{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:g.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:v(be.enabled,this.defaultValue.enabled),delay:s.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:v(be.sticky,this.defaultValue.sticky),above:v(be.above,this.defaultValue.above)}}}var V;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class U extends h{constructor(){super(130)}compute(ie,be,ze){return U.computeLayout(be,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const be=ie.height/ie.lineHeight,ze=ie.scrollBeyondLastLine?be-1:0,Qe=(ie.viewLineCount+ze)/(ie.pixelRatio*ie.height),me=Math.floor(ie.viewLineCount/Qe);return{typicalViewportLineCount:be,extraLinesBeyondLastLine:ze,desiredRatio:Qe,minimapLineCount:me}}static _computeMinimapLayout(ie,be){const ze=ie.outerWidth,Qe=ie.outerHeight,me=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(me*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const Ce=be.stableMinimapLayoutInput,$e=Ce&&ie.outerHeight===Ce.outerHeight&&ie.lineHeight===Ce.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ce.pixelRatio&&ie.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&ie.minimap.enabled===Ce.minimap.enabled&&ie.minimap.side===Ce.minimap.side&&ie.minimap.size===Ce.minimap.size&&ie.minimap.showSlider===Ce.minimap.showSlider&&ie.minimap.renderCharacters===Ce.minimap.renderCharacters&&ie.minimap.maxColumn===Ce.minimap.maxColumn&&ie.minimap.scale===Ce.minimap.scale&&ie.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&ie.isViewportWrapping===Ce.isViewportWrapping,Pe=ie.lineHeight,De=ie.typicalHalfwidthCharacterWidth,ye=ie.scrollBeyondLastLine,le=ie.minimap.renderCharacters;let de=me>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const we=ie.minimap.maxColumn,ve=ie.minimap.size,Re=ie.minimap.side,Ge=ie.verticalScrollbarWidth,We=ie.viewLineCount,Xe=ie.remainingWidth,st=ie.isViewportWrapping,ot=le?2:3;let fe=Math.floor(me*Qe);const ke=fe/me;let ue=!1,Q=!1,Te=ot*de,Oe=de/me,Ze=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:_t,desiredRatio:Ot,minimapLineCount:It}=U.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:ye,height:Qe,lineHeight:Pe,pixelRatio:me});if(We/It>1)ue=!0,Q=!0,de=1,Te=1,Oe=de/me;else{let Lt=!1,St=de+1;if(ve==="fit"){const Mt=Math.ceil((We+_t)*Te);st&&$e&&Xe<=be.stableFitRemainingWidth?(Lt=!0,St=be.stableFitMaxMinimapScale):Lt=Mt>fe}if(ve==="fill"||Lt){ue=!0;const Mt=de;Te=Math.min(Pe*me,Math.max(1,Math.floor(1/Ot))),st&&$e&&Xe<=be.stableFitRemainingWidth&&(St=be.stableFitMaxMinimapScale),de=Math.min(St,Math.max(1,Math.floor(Te/ot))),de>Mt&&(Ze=Math.min(2,de/Mt)),Oe=de/me/Ze,fe=Math.ceil(Math.max(vt,We+_t)*Te),st?(be.stableMinimapLayoutInput=ie,be.stableFitRemainingWidth=Xe,be.stableFitMaxMinimapScale=de):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const qe=Math.floor(we*Oe),ht=Math.min(qe,Math.max(0,Math.floor((Xe-Ge-2)*Oe/(De+Oe)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(me*ht);const yt=wt/me;wt=Math.floor(wt*Ze);const bt=le?1:2,mt=Re==="left"?0:ze-ht-Ge;return{renderMinimap:bt,minimapLeft:mt,minimapWidth:ht,minimapHeightIsEditorHeight:ue,minimapIsSampling:Q,minimapScale:de,minimapLineHeight:Te,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:fe,minimapCanvasOuterWidth:yt,minimapCanvasOuterHeight:ke}}static computeLayout(ie,be){const ze=be.outerWidth|0,Qe=be.outerHeight|0,me=be.lineHeight|0,Ce=be.lineNumbersDigitCount|0,$e=be.typicalHalfwidthCharacterWidth,Pe=be.maxDigitWidth,De=be.pixelRatio,ye=be.viewLineCount,le=ie.get(122),de=le==="inherit"?ie.get(121):le,we=de==="inherit"?ie.get(117):de,ve=ie.get(120),Re=ie.get(2),Ge=be.isDominatedByLongLines,We=ie.get(49),Xe=ie.get(59).renderType!==0,st=ie.get(60),ot=ie.get(93),fe=ie.get(64),ke=ie.get(91),ue=ke.verticalScrollbarSize,Q=ke.verticalHasArrows,Te=ke.arrowSize,Oe=ke.horizontalScrollbarSize,Ze=ie.get(57),qe=ie.get(37);let ht;if(typeof Ze=="string"&&/^\d+(\.\d+)?ch$/.test(Ze)){const Wt=parseFloat(Ze.substr(0,Ze.length-2));ht=s.clampedInt(Wt*$e,0,0,1e3)}else ht=s.clampedInt(Ze,0,0,1e3);qe&&(ht+=16);let wt=0;if(Xe){const Wt=Math.max(Ce,st);wt=Math.round(Wt*Pe)}let yt=0;We&&(yt=me);let bt=0,mt=bt+yt,vt=mt+wt,_t=vt+ht;const Ot=ze-yt-wt-ht;let It=!1,Tt=!1,Lt=-1;Re!==2&&(de==="inherit"&&Ge?(It=!0,Tt=!0):we==="on"||we==="bounded"?Tt=!0:we==="wordWrapColumn"&&(Lt=ve));const St=U._computeMinimapLayout({outerWidth:ze,outerHeight:Qe,lineHeight:me,typicalHalfwidthCharacterWidth:$e,pixelRatio:De,scrollBeyondLastLine:ot,minimap:fe,verticalScrollbarWidth:ue,viewLineCount:ye,remainingWidth:Ot,isViewportWrapping:Tt},be.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(bt+=St.minimapWidth,mt+=St.minimapWidth,vt+=St.minimapWidth,_t+=St.minimapWidth);const Mt=Ot-St.minimapWidth,Nt=Math.max(1,Math.floor((Mt-ue-2)/$e)),Et=Q?Te:0;return Tt&&(Lt=Math.max(1,Nt),we==="bounded"&&(Lt=Math.min(Lt,ve))),{width:ze,height:Qe,glyphMarginLeft:bt,glyphMarginWidth:yt,lineNumbersLeft:mt,lineNumbersWidth:wt,decorationsLeft:vt,decorationsWidth:ht,contentLeft:_t,contentWidth:Mt,minimap:St,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Tt,wrappingColumn:Lt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:Oe,overviewRuler:{top:Et,width:ue,height:Qe-2*Et,right:0}}}}e.EditorLayoutInfoComputer=U;class H extends T{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:g.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:v(ie.enabled,this.defaultValue.enabled)}}}class Y extends T{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:v(be.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(be.fontFamily,this.defaultValue.fontFamily)}}}class re extends o{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>o.clamp(ie,0,150),{markdownDescription:g.localize(47,null)})}compute(ie,be,ze){return ie.fontInfo.lineHeight}}class K extends T{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ie.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:g.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:v(be.enabled,this.defaultValue.enabled),size:a(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(be.side,this.defaultValue.side,["right","left"]),showSlider:a(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(be.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(be.scale,1,1,3),maxColumn:s.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(Z){return Z==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class te extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{top:s.clampedInt(be.top,0,0,1e3),bottom:s.clampedInt(be.bottom,0,0,1e3)}}}class ae extends T{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:g.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:v(be.enabled,this.defaultValue.enabled),cycle:v(be.cycle,this.defaultValue.cycle)}}}class ge extends h{constructor(){super(128)}compute(ie,be,ze){return ie.pixelRatio}}class Ie extends T{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:g.localize(63,null)},other:{type:"boolean",default:ie.other,description:g.localize(64,null)}}}],default:ie,description:g.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const be=ie,ze={other:v(be.other,this.defaultValue.other),comments:v(be.comments,this.defaultValue.comments),strings:v(be.strings,this.defaultValue.strings)};return ze.other&&ze.comments&&ze.strings?!0:!ze.other&&!ze.comments&&!ze.strings?!1:ze}return this.defaultValue}}var Me;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ie){let be=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(be=4,ze=ie):ie==="interval"?be=3:ie==="relative"?be=2:ie==="on"?be=1:be=0),{renderType:be,renderFn:ze}}}function q(Z){const ie=Z.get(86);return ie==="editable"?Z.get(80):ie!=="on"}e.filterValidationDecorations=q;class J extends T{constructor(){const ie=[],be={type:"number",description:g.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ie,description:g.localize(73,null)})}validate(ie){if(Array.isArray(ie)){let be=[];for(let ze of ie)if(typeof ze=="number")be.push({column:s.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const Qe=ze;be.push({column:s.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return be.sort((ze,Qe)=>ze.column-Qe.column),be}return this.defaultValue}}function ne(Z,ie){if(typeof Z!="string")return ie;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class he extends T{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:g.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie,ze=s.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=s.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ne(be.vertical,this.defaultValue.vertical),horizontal:ne(be.horizontal,this.defaultValue.horizontal),useShadows:v(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:s.clampedInt(be.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:s.clampedInt(be.verticalSliderSize,Qe,0,1e3),scrollByPage:v(be.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends T{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:g.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:g.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:g.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:g.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeStrings,description:g.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:g.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ie.allowedLocales,description:g.localize(91,null)}})}applyUpdate(ie,be){let ze=!1;be.allowedCharacters&&(P.equals(ie.allowedCharacters,be.allowedCharacters)||(ie={...ie,allowedCharacters:be.allowedCharacters},ze=!0)),be.allowedLocales&&(P.equals(ie.allowedLocales,be.allowedLocales)||(ie={...ie,allowedLocales:be.allowedLocales},ze=!0));const Qe=super.applyUpdate(ie,be);return ze?new c(Qe.newValue,!0):Qe}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{nonBasicASCII:Ve(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ve(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ve(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ie.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ie.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ie,be){if(typeof ie!="object"||!ie)return be;const ze={};for(const[Qe,me]of Object.entries(ie))me===!0&&(ze[Qe]=!0);return ze}}class oe extends T{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:g.localize(92,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:v(be.enabled,this.defaultValue.enabled),mode:a(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class _e extends T{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:g.localize(93,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:v(ie.enabled,this.defaultValue.enabled)}}}class Ue extends T{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(94,null),g.localize(95,null),g.localize(96,null)],default:ie.bracketPairs,description:g.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(98,null),g.localize(99,null),g.localize(100,null)],default:ie.bracketPairsHorizontal,description:g.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:g.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:g.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:g.localize(104,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{bracketPairs:Ve(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ve(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ve(Z,ie,be){const ze=be.indexOf(Z);return ze===-1?ie:be[ze]}class Ke extends T{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(105,null),g.localize(106,null)],default:ie.insertMode,description:g.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:g.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:g.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:g.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:g.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:g.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:g.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:g.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:g.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(146,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{insertMode:a(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(be.showIcons,this.defaultValue.showIcons),showStatusBar:v(be.showStatusBar,this.defaultValue.showStatusBar),preview:v(be.preview,this.defaultValue.preview),previewMode:a(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(be.showMethods,this.defaultValue.showMethods),showFunctions:v(be.showFunctions,this.defaultValue.showFunctions),showConstructors:v(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(be.showDeprecated,this.defaultValue.showDeprecated),showFields:v(be.showFields,this.defaultValue.showFields),showVariables:v(be.showVariables,this.defaultValue.showVariables),showClasses:v(be.showClasses,this.defaultValue.showClasses),showStructs:v(be.showStructs,this.defaultValue.showStructs),showInterfaces:v(be.showInterfaces,this.defaultValue.showInterfaces),showModules:v(be.showModules,this.defaultValue.showModules),showProperties:v(be.showProperties,this.defaultValue.showProperties),showEvents:v(be.showEvents,this.defaultValue.showEvents),showOperators:v(be.showOperators,this.defaultValue.showOperators),showUnits:v(be.showUnits,this.defaultValue.showUnits),showValues:v(be.showValues,this.defaultValue.showValues),showConstants:v(be.showConstants,this.defaultValue.showConstants),showEnums:v(be.showEnums,this.defaultValue.showEnums),showEnumMembers:v(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(be.showKeywords,this.defaultValue.showKeywords),showWords:v(be.showWords,this.defaultValue.showWords),showColors:v(be.showColors,this.defaultValue.showColors),showFiles:v(be.showFiles,this.defaultValue.showFiles),showReferences:v(be.showReferences,this.defaultValue.showReferences),showFolders:v(be.showFolders,this.defaultValue.showFolders),showTypeParameters:v(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(be.showSnippets,this.defaultValue.showSnippets),showUsers:v(be.showUsers,this.defaultValue.showUsers),showIssues:v(be.showIssues,this.defaultValue.showIssues)}}}class Je extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(147,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class it extends h{constructor(){super(129)}compute(ie,be,ze){return be.get(80)?!0:ie.tabFocusMode}}var at;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(at=e.WrappingIndent||(e.WrappingIndent={}));function et(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class nt extends h{constructor(){super(131)}compute(ie,be,ze){const Qe=be.get(130);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}const ct="Consolas, 'Courier New', monospace",dt="Menlo, Monaco, 'Courier New', monospace",Pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?dt:i.isLinux?Pt:ct,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function xe(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var Rt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.guides=13]="guides",Z[Z.codeLens=14]="codeLens",Z[Z.codeLensFontFamily=15]="codeLensFontFamily",Z[Z.codeLensFontSize=16]="codeLensFontSize",Z[Z.colorDecorators=17]="colorDecorators",Z[Z.columnSelection=18]="columnSelection",Z[Z.comments=19]="comments",Z[Z.contextmenu=20]="contextmenu",Z[Z.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=22]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=24]="cursorStyle",Z[Z.cursorSurroundingLines=25]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=27]="cursorWidth",Z[Z.disableLayerHinting=28]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Z[Z.domReadOnly=30]="domReadOnly",Z[Z.dragAndDrop=31]="dragAndDrop",Z[Z.emptySelectionClipboard=32]="emptySelectionClipboard",Z[Z.extraEditorClassName=33]="extraEditorClassName",Z[Z.fastScrollSensitivity=34]="fastScrollSensitivity",Z[Z.find=35]="find",Z[Z.fixedOverflowWidgets=36]="fixedOverflowWidgets",Z[Z.folding=37]="folding",Z[Z.foldingStrategy=38]="foldingStrategy",Z[Z.foldingHighlight=39]="foldingHighlight",Z[Z.foldingImportsByDefault=40]="foldingImportsByDefault",Z[Z.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=42]="fontFamily",Z[Z.fontInfo=43]="fontInfo",Z[Z.fontLigatures=44]="fontLigatures",Z[Z.fontSize=45]="fontSize",Z[Z.fontWeight=46]="fontWeight",Z[Z.formatOnPaste=47]="formatOnPaste",Z[Z.formatOnType=48]="formatOnType",Z[Z.glyphMargin=49]="glyphMargin",Z[Z.gotoLocation=50]="gotoLocation",Z[Z.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",Z[Z.hover=52]="hover",Z[Z.inDiffEditor=53]="inDiffEditor",Z[Z.inlineSuggest=54]="inlineSuggest",Z[Z.letterSpacing=55]="letterSpacing",Z[Z.lightbulb=56]="lightbulb",Z[Z.lineDecorationsWidth=57]="lineDecorationsWidth",Z[Z.lineHeight=58]="lineHeight",Z[Z.lineNumbers=59]="lineNumbers",Z[Z.lineNumbersMinChars=60]="lineNumbersMinChars",Z[Z.linkedEditing=61]="linkedEditing",Z[Z.links=62]="links",Z[Z.matchBrackets=63]="matchBrackets",Z[Z.minimap=64]="minimap",Z[Z.mouseStyle=65]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=67]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=69]="multiCursorModifier",Z[Z.multiCursorPaste=70]="multiCursorPaste",Z[Z.occurrencesHighlight=71]="occurrencesHighlight",Z[Z.overviewRulerBorder=72]="overviewRulerBorder",Z[Z.overviewRulerLanes=73]="overviewRulerLanes",Z[Z.padding=74]="padding",Z[Z.parameterHints=75]="parameterHints",Z[Z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=78]="quickSuggestions",Z[Z.quickSuggestionsDelay=79]="quickSuggestionsDelay",Z[Z.readOnly=80]="readOnly",Z[Z.renameOnType=81]="renameOnType",Z[Z.renderControlCharacters=82]="renderControlCharacters",Z[Z.renderFinalNewline=83]="renderFinalNewline",Z[Z.renderLineHighlight=84]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=86]="renderValidationDecorations",Z[Z.renderWhitespace=87]="renderWhitespace",Z[Z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",Z[Z.roundedSelection=89]="roundedSelection",Z[Z.rulers=90]="rulers",Z[Z.scrollbar=91]="scrollbar",Z[Z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=93]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=94]="scrollPredominantAxis",Z[Z.selectionClipboard=95]="selectionClipboard",Z[Z.selectionHighlight=96]="selectionHighlight",Z[Z.selectOnLineNumbers=97]="selectOnLineNumbers",Z[Z.showFoldingControls=98]="showFoldingControls",Z[Z.showUnused=99]="showUnused",Z[Z.snippetSuggestions=100]="snippetSuggestions",Z[Z.smartSelect=101]="smartSelect",Z[Z.smoothScrolling=102]="smoothScrolling",Z[Z.stickyTabStops=103]="stickyTabStops",Z[Z.stopRenderingLineAfter=104]="stopRenderingLineAfter",Z[Z.suggest=105]="suggest",Z[Z.suggestFontSize=106]="suggestFontSize",Z[Z.suggestLineHeight=107]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",Z[Z.suggestSelection=109]="suggestSelection",Z[Z.tabCompletion=110]="tabCompletion",Z[Z.tabIndex=111]="tabIndex",Z[Z.unicodeHighlighting=112]="unicodeHighlighting",Z[Z.unusualLineTerminators=113]="unusualLineTerminators",Z[Z.useShadowDOM=114]="useShadowDOM",Z[Z.useTabStops=115]="useTabStops",Z[Z.wordSeparators=116]="wordSeparators",Z[Z.wordWrap=117]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=120]="wordWrapColumn",Z[Z.wordWrapOverride1=121]="wordWrapOverride1",Z[Z.wordWrapOverride2=122]="wordWrapOverride2",Z[Z.wrappingIndent=123]="wrappingIndent",Z[Z.wrappingStrategy=124]="wrappingStrategy",Z[Z.showDeprecated=125]="showDeprecated",Z[Z.inlayHints=126]="inlayHints",Z[Z.editorClassName=127]="editorClassName",Z[Z.pixelRatio=128]="pixelRatio",Z[Z.tabFocusMode=129]="tabFocusMode",Z[Z.layoutInfo=130]="layoutInfo",Z[Z.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:xe(new R(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(148,null)})),acceptSuggestionOnEnter:xe(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(149,null),""],markdownDescription:g.localize(150,null)})),accessibilitySupport:xe(new r),accessibilityPageSize:xe(new s(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(151,null)})),ariaLabel:xe(new p(4,"ariaLabel",g.localize(152,null))),autoClosingBrackets:xe(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoClosingDelete:xe(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(156,null),""],description:g.localize(157,null)})),autoClosingOvertype:xe(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(158,null),""],description:g.localize(159,null)})),autoClosingQuotes:xe(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(160,null),g.localize(161,null),""],description:g.localize(162,null)})),autoIndent:xe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[g.localize(163,null),g.localize(164,null),g.localize(165,null),g.localize(166,null),g.localize(167,null)],description:g.localize(168,null)})),automaticLayout:xe(new R(10,"automaticLayout",!1)),autoSurround:xe(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(169,null),g.localize(170,null),g.localize(171,null),""],description:g.localize(172,null)})),bracketPairColorization:xe(new _e),bracketPairGuides:xe(new Ue),stickyTabStops:xe(new R(103,"stickyTabStops",!1,{description:g.localize(173,null)})),codeLens:xe(new R(14,"codeLens",!0,{description:g.localize(174,null)})),codeLensFontFamily:xe(new p(15,"codeLensFontFamily","",{description:g.localize(175,null)})),codeLensFontSize:xe(new s(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(176,null)})),colorDecorators:xe(new R(17,"colorDecorators",!0,{description:g.localize(177,null)})),columnSelection:xe(new R(18,"columnSelection",!1,{description:g.localize(178,null)})),comments:xe(new l),contextmenu:xe(new R(20,"contextmenu",!0)),copyWithSyntaxHighlighting:xe(new R(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(179,null)})),cursorBlinking:xe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:g.localize(180,null)})),cursorSmoothCaretAnimation:xe(new R(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(181,null)})),cursorStyle:xe(new n(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],y,{description:g.localize(182,null)})),cursorSurroundingLines:xe(new s(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(183,null)})),cursorSurroundingLinesStyle:xe(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),cursorWidth:xe(new s(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(187,null)})),disableLayerHinting:xe(new R(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:xe(new R(29,"disableMonospaceOptimizations",!1)),domReadOnly:xe(new R(30,"domReadOnly",!1)),dragAndDrop:xe(new R(31,"dragAndDrop",!0,{description:g.localize(188,null)})),emptySelectionClipboard:xe(new N),extraEditorClassName:xe(new p(33,"extraEditorClassName","")),fastScrollSensitivity:xe(new o(34,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:g.localize(189,null)})),find:xe(new B),fixedOverflowWidgets:xe(new R(36,"fixedOverflowWidgets",!1)),folding:xe(new R(37,"folding",!0,{description:g.localize(190,null)})),foldingStrategy:xe(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(191,null),g.localize(192,null)],description:g.localize(193,null)})),foldingHighlight:xe(new R(39,"foldingHighlight",!0,{description:g.localize(194,null)})),foldingImportsByDefault:xe(new R(40,"foldingImportsByDefault",!1,{description:g.localize(195,null)})),unfoldOnClickAfterEndOfLine:xe(new R(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(196,null)})),fontFamily:xe(new p(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(197,null)})),fontInfo:xe(new O),fontLigatures2:xe(new F),fontSize:xe(new z),fontWeight:xe(new W),formatOnPaste:xe(new R(47,"formatOnPaste",!1,{description:g.localize(198,null)})),formatOnType:xe(new R(48,"formatOnType",!1,{description:g.localize(199,null)})),glyphMargin:xe(new R(49,"glyphMargin",!0,{description:g.localize(200,null)})),gotoLocation:xe(new M),hideCursorInOverviewRuler:xe(new R(51,"hideCursorInOverviewRuler",!1,{description:g.localize(201,null)})),hover:xe(new x),inDiffEditor:xe(new R(53,"inDiffEditor",!1)),letterSpacing:xe(new o(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>o.clamp(Z,-5,20),{description:g.localize(202,null)})),lightbulb:xe(new H),lineDecorationsWidth:xe(new w(57,"lineDecorationsWidth",10)),lineHeight:xe(new re),lineNumbers:xe(new Ne),lineNumbersMinChars:xe(new s(60,"lineNumbersMinChars",5,1,300)),linkedEditing:xe(new R(61,"linkedEditing",!1,{description:g.localize(203,null)})),links:xe(new R(62,"links",!0,{description:g.localize(204,null)})),matchBrackets:xe(new S(63,"matchBrackets","always",["always","near","never"],{description:g.localize(205,null)})),minimap:xe(new K),mouseStyle:xe(new S(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:xe(new o(66,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:g.localize(206,null)})),mouseWheelZoom:xe(new R(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(207,null)})),multiCursorMergeOverlapping:xe(new R(68,"multiCursorMergeOverlapping",!0,{description:g.localize(208,null)})),multiCursorModifier:xe(new n(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[g.localize(209,null),g.localize(210,null)],markdownDescription:g.localize(211,null)})),multiCursorPaste:xe(new S(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(212,null),g.localize(213,null)],markdownDescription:g.localize(214,null)})),occurrencesHighlight:xe(new R(71,"occurrencesHighlight",!0,{description:g.localize(215,null)})),overviewRulerBorder:xe(new R(72,"overviewRulerBorder",!0,{description:g.localize(216,null)})),overviewRulerLanes:xe(new s(73,"overviewRulerLanes",3,0,3)),padding:xe(new te),parameterHints:xe(new ae),peekWidgetDefaultFocus:xe(new S(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(217,null),g.localize(218,null)],description:g.localize(219,null)})),definitionLinkOpensInPeek:xe(new R(77,"definitionLinkOpensInPeek",!1,{description:g.localize(220,null)})),quickSuggestions:xe(new Ie),quickSuggestionsDelay:xe(new s(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(221,null)})),readOnly:xe(new R(80,"readOnly",!1)),renameOnType:xe(new R(81,"renameOnType",!1,{description:g.localize(222,null),markdownDeprecationMessage:g.localize(223,null)})),renderControlCharacters:xe(new R(82,"renderControlCharacters",!0,{description:g.localize(224,null),restricted:!0})),renderFinalNewline:xe(new R(83,"renderFinalNewline",!0,{description:g.localize(225,null)})),renderLineHighlight:xe(new S(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(226,null)],description:g.localize(227,null)})),renderLineHighlightOnlyWhenFocus:xe(new R(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(228,null)})),renderValidationDecorations:xe(new S(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:xe(new S(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(229,null),g.localize(230,null),g.localize(231,null),""],description:g.localize(232,null)})),revealHorizontalRightPadding:xe(new s(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:xe(new R(89,"roundedSelection",!0,{description:g.localize(233,null)})),rulers:xe(new J),scrollbar:xe(new he),scrollBeyondLastColumn:xe(new s(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(234,null)})),scrollBeyondLastLine:xe(new R(93,"scrollBeyondLastLine",!0,{description:g.localize(235,null)})),scrollPredominantAxis:xe(new R(94,"scrollPredominantAxis",!0,{description:g.localize(236,null)})),selectionClipboard:xe(new R(95,"selectionClipboard",!0,{description:g.localize(237,null),included:i.isLinux})),selectionHighlight:xe(new R(96,"selectionHighlight",!0,{description:g.localize(238,null)})),selectOnLineNumbers:xe(new R(97,"selectOnLineNumbers",!0)),showFoldingControls:xe(new S(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),showUnused:xe(new R(99,"showUnused",!0,{description:g.localize(242,null)})),showDeprecated:xe(new R(125,"showDeprecated",!0,{description:g.localize(243,null)})),inlayHints:xe(new Y),snippetSuggestions:xe(new S(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null),g.localize(247,null)],description:g.localize(248,null)})),smartSelect:xe(new Je),smoothScrolling:xe(new R(102,"smoothScrolling",!1,{description:g.localize(249,null)})),stopRenderingLineAfter:xe(new s(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:xe(new Ke),inlineSuggest:xe(new oe),suggestFontSize:xe(new s(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(250,null)})),suggestLineHeight:xe(new s(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(251,null)})),suggestOnTriggerCharacters:xe(new R(108,"suggestOnTriggerCharacters",!0,{description:g.localize(252,null)})),suggestSelection:xe(new S(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(253,null),g.localize(254,null),g.localize(255,null)],description:g.localize(256,null)})),tabCompletion:xe(new S(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(257,null),g.localize(258,null),g.localize(259,null)],description:g.localize(260,null)})),tabIndex:xe(new s(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:xe(new ee),unusualLineTerminators:xe(new S(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),useShadowDOM:xe(new R(114,"useShadowDOM",!0)),useTabStops:xe(new R(115,"useTabStops",!0,{description:g.localize(265,null)})),wordSeparators:xe(new p(116,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:g.localize(266,null)})),wordWrap:xe(new S(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(267,null),g.localize(268,null),g.localize(269,null),g.localize(270,null)],description:g.localize(271,null)})),wordWrapBreakAfterCharacters:xe(new p(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:xe(new p(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:xe(new s(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(272,null)})),wordWrapOverride1:xe(new S(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:xe(new S(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:xe(new n(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],et,{enumDescriptions:[g.localize(273,null),g.localize(274,null),g.localize(275,null),g.localize(276,null)],description:g.localize(277,null)})),wrappingStrategy:xe(new S(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(278,null),g.localize(279,null)],description:g.localize(280,null)})),editorClassName:xe(new A),pixelRatio:xe(new ge),tabFocusMode:xe(new it),layoutInfo:xe(new U),wrappingInfo:xe(new nt)}}),define(Ee[156],Se([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[157],Se([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[158],Se([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[159],Se([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[160],Se([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(Ee[161],Se([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(Ee[162],Se([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(Ee[163],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[164],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[165],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[166],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[167],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[168],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[169],Se([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[170],Se([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[171],Se([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ee[172],Se([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(Ee[173],Se([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[174],Se([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[175],Se([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[176],Se([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[177],Se([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[178],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var i;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var D;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[179],Se([0,1,158]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function _(c){return c=c.trim(),c==="*"||i.test(c)}e.isValidVersionStr=_;function P(c){if(!_(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(i);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=P;function k(c){if(!c)return null;let E=c.majorBase,h=c.majorMustEqual,w=c.minorBase,v=c.minorMustEqual,R=c.patchBase,b=c.patchMustEqual;c.hasCaret&&(E===0||(v=!1),b=!1);let s=0;if(c.preRelease){const o=D.exec(c.preRelease);if(o){const[,p,a,S]=o;s=Date.UTC(Number(p),Number(a)-1,Number(S))}}return{majorBase:E,majorMustEqual:h,minorBase:w,minorMustEqual:v,patchBase:R,patchMustEqual:b,isMinimum:c.hasGreaterEquals,notBefore:s}}e.normalizeVersion=k;function C(c,E,h){let w;typeof c=="string"?w=k(P(c)):w=c;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let R;if(typeof h=="string"?R=k(P(h)):R=h,!w||!R)return!1;let b=w.majorBase,s=w.minorBase,o=w.patchBase,p=R.majorBase,a=R.minorBase,S=R.patchBase,n=R.notBefore,t=R.majorMustEqual,r=R.minorMustEqual,l=R.patchMustEqual;return R.isMinimum?b>p?!0:b<p?!1:s>a?!0:s<a||v&&v<n?!1:o>=S:(b===1&&p===0&&(!t||!r||!l)&&(p=1,a=0,S=0,t=!0,r=!1,l=!1),b<p?!1:b>p?!t:s<a?!1:s>a?!r:o<S?!1:o>S?!l:!(v&&v<n))}e.isValidVersion=C;function I(c,E,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:T(c,E,h.engines.vscode,w)}e.isValidExtensionVersion=I;function L(c,E,h){return c==="*"||T(E,h,c)}e.isEngineValid=L;function T(c,E,h,w=[]){let v=k(P(h));if(!v)return w.push(g.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return w.push(g.localize(1,null,h)),!1}else if(!v.majorMustEqual)return w.push(g.localize(2,null,h)),!1;return C(c,E,v)?!0:(w.push(g.localize(3,null,c,h)),!1)}}),define(Ee[115],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(D,_=[],P=!1){this.ctor=D,this.staticArguments=_,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=g}),define(Ee[83],Se([0,1,115]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function D(P,k,C){k instanceof g.SyncDescriptor||(k=new g.SyncDescriptor(k,[],C)),i.push([P,k])}e.registerSingleton=D;function _(){return i}e.getSingletonServiceDescriptors=_}),define(Ee[180],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=g;class i{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let P of this._nodes.values())P.outgoing.size===0&&_.push(P);return _}insertEdge(_,P){const k=this.lookupOrInsertNode(_),C=this.lookupOrInsertNode(P);k.outgoing.set(this._hashFn(P),C),C.incoming.set(this._hashFn(_),k)}removeNode(_){const P=this._hashFn(_);this._nodes.delete(P);for(let k of this._nodes.values())k.outgoing.delete(P),k.incoming.delete(P)}lookupOrInsertNode(_){const P=this._hashFn(_);let k=this._nodes.get(P);return k||(k=new g(_),this._nodes.set(P,k)),k}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[P,k]of this._nodes)_.push(`${P}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,P]of this._nodes){const k=new Set([_]),C=this._findCycle(P,k);if(C)return C}}_findCycle(_,P){for(let[k,C]of _.outgoing){if(P.has(k))return[...P,k].join(" -> ");P.add(k);const I=this._findCycle(C,P);if(I)return I;P.delete(k)}}}e.Graph=i}),define(Ee[4],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function k(C){return C[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=k})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(P,k,C,I){k[g.DI_TARGET]===k?k[g.DI_DEPENDENCIES].push({id:P,index:C,optional:I}):(k[g.DI_DEPENDENCIES]=[{id:P,index:C,optional:I}],k[g.DI_TARGET]=k)}function D(P){if(g.serviceIds.has(P))return g.serviceIds.get(P);const k=function(C,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(k,C,L,!1)};return k.toString=()=>P,g.serviceIds.set(P,k),k}e.createDecorator=D;function _(P){return P}e.refineServiceDecorator=_}),define(Ee[181],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function i(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=i}),define(Ee[182],Se([0,1,3,47,6,24,78,82,181]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(I):!!w.exclusive}class L{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(v,R){let b={selector:v,provider:R,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(b){let s=this._entries.indexOf(b);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const R=[];for(let b of this._entries)b._score>0&&R.push(b.provider);return R}ordered(v){const R=[];return this._orderedForEach(v,b=>R.push(b.provider)),R}orderedGroups(v){const R=[];let b,s;return this._orderedForEach(v,o=>{b&&s===o._score?b.push(o.provider):(s=o._score,b=[o.provider],R.push(b))}),R}_orderedForEach(v,R){if(!!v){this._updateScores(v);for(const b of this._entries)b._score>0&&R(b)}}_updateScores(v){let R={uri:v.uri.toString(),language:v.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let b of this._entries)if(b._score=(0,k.score)(b.selector,v.uri,v.getLanguageId(),(0,C.shouldSynchronizeModel)(v)),I(b.selector)&&b._score>0){for(let s of this._entries)s._score=0;b._score=1e3;break}this._entries.sort(L._compareByScoreAndTime)}}static _compareByScoreAndTime(v,R){return v._score<R._score?1:v._score>R._score?-1:v._time<R._time?1:v._time>R._time?-1:0}}e.LanguageFeatureRegistry=L;const T=new WeakMap;let c=0;function E(w){let v=T.get(w);return v===void 0&&(v=++c,T.set(w,v)),v}class h{constructor(v,R,b=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=R,this.max=b,this._cache=new _.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((R,b)=>(0,i.doHash)(E(b),R),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const R=this._key(v),b=this._cache.get(R);return this._clamp(b?.value)}update(v,R){const b=this._key(v);let s=this._cache.get(b);return s||(s=new P.MovingAverage,this._cache.set(b,s)),s.update(R),this.get(v)}}e.LanguageFeatureRequestDelays=h}),define(Ee[84],Se([0,1,2,41,182,149,73]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var C;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline",u[u.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var I;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(I=e.ColorId||(e.ColorId={}));var L;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=3]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var T;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=1024]="ITALIC_MASK",u[u.BOLD_MASK=2048]="BOLD_MASK",u[u.UNDERLINE_MASK=4096]="UNDERLINE_MASK",u[u.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(T=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&768)>>>8}static getFontStyle(y){return(y&15360)>>>10}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let A=this.getForeground(y),N="mtk"+A,B=this.getFontStyle(y);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(y,A){const N=this.getForeground(y),B=this.getFontStyle(y);let F=`color: ${A[N]};`;return B&1&&(F+="font-style: italic;"),B&2&&(F+="font-weight: bold;"),B&4&&(F+="text-decoration: underline;"),F}}e.TokenMetadata=c;var E;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var h;(function(u){const y=new Map;y.set(0,P.Codicon.symbolMethod),y.set(1,P.Codicon.symbolFunction),y.set(2,P.Codicon.symbolConstructor),y.set(3,P.Codicon.symbolField),y.set(4,P.Codicon.symbolVariable),y.set(5,P.Codicon.symbolClass),y.set(6,P.Codicon.symbolStruct),y.set(7,P.Codicon.symbolInterface),y.set(8,P.Codicon.symbolModule),y.set(9,P.Codicon.symbolProperty),y.set(10,P.Codicon.symbolEvent),y.set(11,P.Codicon.symbolOperator),y.set(12,P.Codicon.symbolUnit),y.set(13,P.Codicon.symbolValue),y.set(15,P.Codicon.symbolEnum),y.set(14,P.Codicon.symbolConstant),y.set(15,P.Codicon.symbolEnum),y.set(16,P.Codicon.symbolEnumMember),y.set(17,P.Codicon.symbolKeyword),y.set(27,P.Codicon.symbolSnippet),y.set(18,P.Codicon.symbolText),y.set(19,P.Codicon.symbolColor),y.set(20,P.Codicon.symbolFile),y.set(21,P.Codicon.symbolReference),y.set(22,P.Codicon.symbolCustomColor),y.set(23,P.Codicon.symbolFolder),y.set(24,P.Codicon.symbolTypeParameter),y.set(25,P.Codicon.account),y.set(26,P.Codicon.issues);function A(F){let O=y.get(F);return O||(console.info("No codicon found for CompletionItemKind "+F),O=P.Codicon.symbolProperty),O}u.toIcon=A;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(F,O){let z=N.get(F);return typeof z=="undefined"&&!O&&(z=9),z}u.fromString=B})(h=e.CompletionItemKinds||(e.CompletionItemKinds={}));var w;(function(u){u[u.Deprecated=1]="Deprecated"})(w=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var R;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(u){return u&&g.URI.isUri(u.uri)&&i.Range.isIRange(u.range)&&(i.Range.isIRange(u.originSelectionRange)||i.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=a;var S;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var n;(function(u){u[u.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var t;(function(u){const y=new Map;y.set(0,P.Codicon.symbolFile),y.set(1,P.Codicon.symbolModule),y.set(2,P.Codicon.symbolNamespace),y.set(3,P.Codicon.symbolPackage),y.set(4,P.Codicon.symbolClass),y.set(5,P.Codicon.symbolMethod),y.set(6,P.Codicon.symbolProperty),y.set(7,P.Codicon.symbolField),y.set(8,P.Codicon.symbolConstructor),y.set(9,P.Codicon.symbolEnum),y.set(10,P.Codicon.symbolInterface),y.set(11,P.Codicon.symbolFunction),y.set(12,P.Codicon.symbolVariable),y.set(13,P.Codicon.symbolConstant),y.set(14,P.Codicon.symbolString),y.set(15,P.Codicon.symbolNumber),y.set(16,P.Codicon.symbolBoolean),y.set(17,P.Codicon.symbolArray),y.set(18,P.Codicon.symbolObject),y.set(19,P.Codicon.symbolKey),y.set(20,P.Codicon.symbolNull),y.set(21,P.Codicon.symbolEnumMember),y.set(22,P.Codicon.symbolStruct),y.set(23,P.Codicon.symbolEvent),y.set(24,P.Codicon.symbolOperator),y.set(25,P.Codicon.symbolTypeParameter);function A(N){let B=y.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=P.Codicon.symbolProperty),B}u.toIcon=A})(t=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(y){this.value=y}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var m;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistryImpl;var f;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(f=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[116],Se([0,1,13,2,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function _(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationOverrides=_;function P(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||g.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=P;var k;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function I(v,R){const b=Object.create(null);for(let s in v)L(b,s,v[s],R);return b}e.toValuesTree=I;function L(v,R,b,s){const o=R.split("."),p=o.pop();let a=v;for(let S=0;S<o.length;S++){let n=o[S],t=a[n];switch(typeof t){case"undefined":t=a[n]=Object.create(null);break;case"object":break;default:s(`Ignoring ${R} as ${o.slice(0,S+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[p]=b}catch{s(`Ignoring ${R} as ${o.join(".")} is ${JSON.stringify(a)}`)}else s(`Ignoring ${R} as ${o.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=L;function T(v,R){const b=R.split(".");c(v,b)}e.removeFromValueTree=T;function c(v,R){const b=R.shift();if(R.length===0){delete v[b];return}if(Object.keys(v).indexOf(b)!==-1){const s=v[b];typeof s=="object"&&!Array.isArray(s)&&(c(s,R),Object.keys(s).length===0&&delete v[b])}}function E(v,R,b){function s(a,S){let n=a;for(const t of S){if(typeof n!="object"||n===null)return;n=n[t]}return n}const o=R.split("."),p=s(v,o);return typeof p=="undefined"?b:p}e.getConfigurationValue=E;function h(v,R,b){Object.keys(R).forEach(s=>{s!=="__proto__"&&(s in v?g.isObject(v[s])&&g.isObject(R[s])?h(v[s],R[s],b):b&&(v[s]=R[s]):v[s]=R[s])})}e.merge=h;function w(v,R,b){const s=v.inspect(R),o=v.inspect(b);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:s.defaultValue}e.getMigratedSettingValue=w}),define(Ee[61],Se([0,1,12,8,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=g.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",g.isMacintosh),P.set("isLinux",g.isLinux),P.set("isWindows",g.isWindows),P.set("isWeb",g.isWeb),P.set("isMacNative",g.isMacintosh&&!g.isWeb),P.set("isEdge",_.indexOf("Edg/")>=0),P.set("isFirefox",_.indexOf("Firefox")>=0),P.set("isChrome",_.indexOf("Chrome")>=0),P.set("isSafari",_.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var C;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return c.INSTANCE}static true(){return E.INSTANCE}static has(F){return h.create(F)}static equals(F,O){return w.create(F,O)}static notEquals(F,O){return b.create(F,O)}static regex(F,O){return t.create(F,O)}static in(F,O){return v.create(F,O)}static not(F){return s.create(F)}static and(...F){return d.create(F,null)}static or(...F){return m.create(F,null,!0)}static greater(F,O){return p.create(F,O)}static greaterEquals(F,O){return a.create(F,O)}static smaller(F,O){return S.create(F,O)}static smallerEquals(F,O){return n.create(F,O)}static deserialize(F,O=!1){if(!!F)return this._deserializeOrExpression(F,O)}static _deserializeOrExpression(F,O){let z=F.split("||");return m.create(z.map(W=>this._deserializeAndExpression(W,O)),null,!0)}static _deserializeAndExpression(F,O){let z=F.split("&&");return d.create(z.map(W=>this._deserializeOne(W,O)),null)}static _deserializeOne(F,O){if(F=F.trim(),F.indexOf("!=")>=0){let z=F.split("!=");return b.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("==")>=0){let z=F.split("==");return w.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("=~")>=0){let z=F.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(F.indexOf(" in ")>=0){let z=F.split(" in ");return v.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const z=F.split(">=");return a.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const z=F.split(">");return p.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const z=F.split("<=");return n.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const z=F.split("<");return S.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,O){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let z=/^'([^']*)'$/.exec(F);return z?z[1].trim():F}static _deserializeRegexValue(F,O){if((0,i.isFalsyOrWhitespace)(F)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=F.indexOf("/"),W=F.lastIndexOf("/");if(z===W||z<0){if(O)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let M=F.slice(z+1,W),x=F[W+1]==="i"?"i":"";try{return new RegExp(M,x)}catch(V){if(O)throw new Error(`bad regexp-value '${F}', parse error: ${V}`);return console.warn(`bad regexp-value '${F}', parse error: ${V}`),null}}}e.ContextKeyExpr=I;function L(B,F){const O=B?B.substituteConstants():void 0,z=F?F.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=L;function T(B,F){return B.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class E{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(F,O){this.key=F,this.negated=O,this.type=2}static create(F,O=null){const z=P.get(F);return typeof z=="boolean"?z?E.INSTANCE:c.INSTANCE:new h(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:u(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?E.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=4}static create(F,O,z=null){if(typeof O=="boolean")return O?h.create(F,z):s.create(F,z);const W=P.get(F);return typeof W=="boolean"?O===(W?"true":"false")?E.INSTANCE:c.INSTANCE:new w(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?E.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class v{constructor(F,O){this.key=F,this.valueKey=O,this.type=10,this.negated=null}static create(F,O){return new v(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const O=F.getValue(this.valueKey),z=F.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?k.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=R.create(this)),this.negated}}e.ContextKeyInExpr=v;class R{constructor(F){this._actual=F,this.type=11}static create(F){return new R(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new R(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=R;class b{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=5}static create(F,O,z=null){if(typeof O=="boolean")return O?s.create(F,z):h.create(F,z);const W=P.get(F);return typeof W=="boolean"?O===(W?"true":"false")?c.INSTANCE:E.INSTANCE:new b(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?c.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class s{constructor(F,O){this.key=F,this.negated=O,this.type=3}static create(F,O=null){const z=P.get(F);return typeof z=="boolean"?z?c.INSTANCE:E.INSTANCE:new s(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:u(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:E.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function o(B,F){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?F(B):c.INSTANCE}class p{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=12}static create(F,O,z=null){return o(O,W=>new p(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class a{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=13}static create(F,O,z=null){return o(O,W=>new a(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class S{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=14}static create(F,O,z=null){return o(O,W=>new S(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class n{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=15}static create(F,O,z=null){return o(O,W=>new n(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,O){this.key=F,this.regexp=O,this.type=7,this.negated=null}static create(F,O){return new t(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return O<z?-1:O>z?1:0}equals(F){if(F.type===this.type){const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return this.key===F.key&&O===z}return!1}substituteConstants(){return this}evaluate(F){let O=F.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{constructor(F){this._actual=F,this.type=8}static create(F){return new r(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new r(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function l(B){let F=null;for(let O=0,z=B.length;O<z;O++){const W=B[O].substituteConstants();if(B[O]!==W&&F===null){F=[];for(let M=0;M<O;M++)F[M]=B[M]}F!==null&&(F[O]=W)}return F===null?B:F}class d{constructor(F,O){this.expr=F,this.negated=O,this.type=6}static create(F,O){return d._normalizeArr(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const W=T(this.expr[O],F.expr[O]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:d.create(F,this.negated)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(F))return!1;return!0}static _normalizeArr(F,O){const z=[];let W=!1;for(const M of F)if(!!M){if(M.type===1){W=!0;continue}if(M.type===0)return c.INSTANCE;if(M.type===6){z.push(...M.expr);continue}z.push(M)}if(z.length===0&&W)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(T);for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];for(;z.length>1;){const M=z[z.length-1];if(M.type!==9)break;z.pop();const x=z.pop(),V=z.length===0,U=m.create(M.expr.map(H=>d.create([H,x],null)),null,V);U&&(z.push(U),z.sort(T))}return z.length===1?z[0]:new d(z,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new d(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){const F=[];for(let O of this.expr)F.push(O.negate());this.negated=m.create(F,this,!0)}return this.negated}}class m{constructor(F,O){this.expr=F,this.negated=O,this.type=9}static create(F,O,z){return m._normalizeArr(F,O,z)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const W=T(this.expr[O],F.expr[O]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:m.create(F,this.negated,!1)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(F))return!0;return!1}static _normalizeArr(F,O,z){let W=[],M=!1;if(F){for(let x=0,V=F.length;x<V;x++){const U=F[x];if(!!U){if(U.type===0){M=!0;continue}if(U.type===1)return E.INSTANCE;if(U.type===9){W=W.concat(U.expr);continue}W.push(U)}}if(W.length===0&&M)return c.INSTANCE;W.sort(T)}if(W.length!==0){if(W.length===1)return W[0];for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];if(z){for(let x=0;x<W.length;x++)for(let V=x+1;V<W.length;V++)A(W[x],W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0]}return new m(W,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new m(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){let F=[];for(let O of this.expr)F.push(O.negate());for(;F.length>1;){const O=F.shift(),z=F.shift(),W=[];for(const x of N(O))for(const V of N(z))W.push(d.create([x,V],null));const M=F.length===0;F.unshift(m.create(W,null,M))}this.negated=F[0]}return this.negated}}class f extends h{constructor(F,O,z){super(F,null);this._defaultValue=O,typeof z=="object"?f._info.push({...z,key:F}):z!==!0&&f._info.push({key:F,description:z,type:O!=null?typeof O:void 0})}static all(){return f._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(B,F){return B<F?-1:B>F?1:0}function y(B,F,O,z){return B<O?-1:B>O?1:F<z?-1:F>z?1:0}function A(B,F){if(F.type===6&&B.type!==9&&B.type!==6){for(const W of F.expr)if(B.equals(W))return!0}const O=B.negate(),z=N(O).concat(N(F));z.sort(T);for(let W=0;W<z.length;W++){const x=z[W].negate();for(let V=W+1;V<z.length;V++){const U=z[V];if(x.equals(U))return!0}}return!1}e.implies=A;function N(B){return B.type===9?B.expr:[B]}}),define(Ee[183],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[184],Se([0,1,10,157,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function P(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function C(s,o){switch(s){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function I(s,o){return o==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function L(s,o,p){return I(o,p)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===p?!0:T(p).includes(s)}e.isTargetPlatformCompatible=L;function T(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function c(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=c;var E;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(s){s.Install="install",s.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var R;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(R=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(o,p){super(o);this.code=p,this.name=p}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Ee[185],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(Ee[186],Se([0,1,37,10,9,12,95,28,113,159,185]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=I.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends c{openTerminal(o,p){return this.spawnTerminal(g,o,C.getWindowsShell(),p)}spawnTerminal(o,p,a,S){const n=p.windowsExec||E.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const t=D.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return o.spawn(n,S?[S]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return n.indexOf(" ")>=0&&r.push('""'),r.push(n),(t==="wt"||t==="wt.exe")&&r.push("-d ."),new Promise((l,d)=>{const m=v(process),f=o.spawn(a,r,{cwd:S,env:m});f.on("error",d),f.on("exit",()=>l())})}runInTerminal(o,p,a,S,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:E.getDefaultTerminalWindows();return new Promise((r,l)=>{const d=`"${p} - ${T}"`,m=`""${a.join('" "')}" & pause"`,f=["/c","start",d,"/wait",t,"/c",m],u=Object.assign({},v(process),S);Object.keys(u).filter(N=>u[N]===null).forEach(N=>delete u[N]);const y={cwd:p,env:u,windowsVerbatimArguments:!0};g.spawn(E.CMD,f,y).on("error",N=>{l(R(N))}),r(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class h extends c{openTerminal(o,p){return this.spawnTerminal(g,o,p)}runInTerminal(o,p,a,S,n){const t=n.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(t===L.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const d=t===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,X).fsPath,"-t",o||T,"-w",p];for(let A of a)f.push("-a"),f.push(A);if(S){const A=Object.assign({},v(process),S);for(let N in A){const B=A[N];B===null?(f.push("-u"),f.push(N)):(f.push("-e"),f.push(`${N}=${B}`))}}let u="";const y=g.spawn(h.OSASCRIPT,f);y.on("error",A=>{l(R(A))}),y.stderr.on("data",A=>{u+=A.toString()}),y.on("exit",A=>{if(A===0)r(void 0);else if(u){const N=u.split(`
`,1);l(new Error(N[0]))}else l(new Error(I.localize(1,null,d,A)))})}else l(new Error(I.localize(2,null,t)))})}spawnTerminal(o,p,a){const S=p.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const r=["-a",S];a&&r.push(a);const l=v(process),d=o.spawn("/usr/bin/open",r,{cwd:a,env:l});d.on("error",t),d.on("exit",()=>n())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends c{openTerminal(o,p){return this.spawnTerminal(g,o,p)}runInTerminal(o,p,a,S,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{let d=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const f=`${b(a)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;d.push(`''${f}''`);const u=Object.assign({},v(process),S);Object.keys(u).filter(B=>u[B]===null).forEach(B=>delete u[B]);const y={cwd:p,env:u};let A="";const N=g.spawn(m,d,y);N.on("error",B=>{l(R(B))}),N.stderr.on("data",B=>{A+=B.toString()}),N.on("exit",B=>{if(B===0)r(void 0);else if(A){const F=A.split(`
`,1);l(new Error(F[0]))}else l(new Error(I.localize(4,null,m,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{o?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,p,a){const S=p.linuxExec?Promise.resolve(p.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{S.then(r=>{const l=v(process),d=o.spawn(r,[],{cwd:a,env:l});d.on("error",t),d.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=I.localize(3,null);function v(s){const o={...s.env};return(0,P.sanitizeProcessEnvironment)(o),o}function R(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(5,null,s.path)):s}function b(s){let o="";for(let p of s)p.indexOf(" ")>=0?o+='"'+p+'"':o+=p,o+=" ";return o}}),define(Ee[42],Se([0,1,24,9,8,13,2,160,4]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function I(W){return W.create===!0}e.isFileOpenForWriteOptions=I;var L;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var T;(function(W){W[W.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var c;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=E;function h(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function v(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=v;function R(W){return E(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var b;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class s extends Error{constructor(M,x){super(M);this.code=x}}e.FileSystemProviderError=s;function o(W,M){const x=new s(W.toString(),M);return a(x,M),x}e.createFileSystemProviderError=o;function p(W){return W||o((0,k.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=p;function a(W,M){return W.name=M?`${M} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=a;function S(W){if(!W)return b.Unknown;if(W instanceof s)return W.code;const M=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!M)return b.Unknown;switch(M[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=S;function n(W){if(W instanceof f)return W.fileOperationResult;switch(S(W)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(M,x,V){this.resource=M,this.operation=x,this.target=V}isOperation(M){return this.operation===M}}e.FileOperationEvent=r;var l;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class d{constructor(M,x){this.added=void 0,this.updated=void 0,this.deleted=void 0;const V=new Map;for(const U of M){const H=V.get(U.type);H?H.push([U.resource,U]):V.set(U.type,[[U.resource,U]])}for(const[U,H]of V)switch(U){case 1:this.added=g.TernarySearchTree.forUris(()=>x),this.added.fill(H);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>x),this.updated.fill(H);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>x),this.deleted.fill(H);break}}contains(M,...x){return this.doContains(M,{includeChildren:!1},...x)}affects(M,...x){return this.doContains(M,{includeChildren:!0},...x)}doContains(M,x,...V){if(!M)return!1;const U=V.length>0;return!!((!U||V.includes(1))&&(this.added?.get(M)||x.includeChildren&&this.added?.findSuperstr(M))||(!U||V.includes(0))&&(this.updated?.get(M)||x.includeChildren&&this.updated?.findSuperstr(M))||(!U||V.includes(2))&&(this.deleted?.findSubstr(M)||x.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function m(W,M,x){return!W||!M||W===M||M.length>W.length?!1:(M.charAt(M.length-1)!==i.sep&&(M+=i.sep),x?(0,D.startsWithIgnoreCase)(W,M):W.indexOf(M)===0)}e.isParent=m;class f extends Error{constructor(M,x,V){super(M);this.fileOperationResult=x,this.options=V}}e.FileOperationError=f;class u extends f{constructor(M,x,V){super(M,2,V);this.stat=x}}e.NotModifiedSinceFileOperationError=u;var y;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=N;async function B(W,M){if(!M.hasProvider(P.URI.from({scheme:W.scheme})))return new Promise(x=>{const V=M.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===W.scheme&&U.added&&(V.dispose(),x())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(M){return(0,_.isNumber)(M)||(M=0),M<F.KB?(0,k.localize)(1,null,M.toFixed(0)):M<F.MB?(0,k.localize)(2,null,(M/F.KB).toFixed(2)):M<F.GB?(0,k.localize)(3,null,(M/F.MB).toFixed(2)):M<F.TB?(0,k.localize)(4,null,(M/F.GB).toFixed(2)):(0,k.localize)(5,null,(M/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var O;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(W){return{maxFileSize:W===0?300*F.MB:16*F.GB,maxHeapSize:W===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=z}),define(Ee[85],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[_,P]of D)this.set(_,P)}set(D,_){const P=this._entries.get(D);return this._entries.set(D,_),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(Ee[187],Se([0,1,18,15,115,180,4,85]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class L{constructor(h=new k.ServiceCollection,w=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=v,this._services.set(P.IInstantiationService,this)}createChild(h){return new L(h,this._strict,this)}invokeFunction(h,...w){let v=c.traceInvocation(h),R=!1;try{return h({get:s=>{if(R)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(s,v);if(!o)throw new Error(`[invokeFunction] unknown service '${s}'`);return o}},...w)}finally{R=!0,v.stop()}}createInstance(h,...w){let v,R;return h instanceof D.SyncDescriptor?(v=c.traceCreation(h.ctor),R=this._createInstance(h.ctor,h.staticArguments.concat(w),v)):(v=c.traceCreation(h),R=this._createInstance(h,w,v)),v.stop(),R}_createInstance(h,w=[],v){let R=P._util.getServiceDependencies(h).sort((o,p)=>o.index-p.index),b=[];for(const o of R){let p=this._getOrCreateServiceInstance(o.id,v);if(!p&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);b.push(p)}let s=R.length>0?R[0].index:w.length;if(w.length!==s){console.warn(`[createInstance] First service dependency of ${h.name} at position ${s+1} conflicts with ${w.length} static arguments`);let o=s-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,s)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,w.branch(h,!0)):(w.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,w,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,v){const R=new _.Graph(o=>o.id.toString());let b=0;const s=[{id:h,desc:w,_trace:v}];for(;s.length;){const o=s.pop();if(R.lookupOrInsertNode(o),b++>1e3)throw new I(R);for(let p of P._util.getServiceDependencies(o.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(p.id);if(!a&&!p.optional&&console.warn(`[createInstance] ${h} depends on ${p.id} which is NOT registered.`),a instanceof D.SyncDescriptor){const S={id:p.id,desc:a,_trace:o._trace.branch(p.id,!0)};R.insertEdge(o,S),s.push(S)}}}for(;;){const o=R.roots();if(o.length===0){if(!R.isEmpty())throw new I(R);break}for(const{data:p}of o){if(this._getServiceInstanceOrDescriptor(p.id)instanceof D.SyncDescriptor){const S=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,S)}R.removeNode(p)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,v=[],R,b){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(w,v,R,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,v,R,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],v,R){if(v){const b=new g.IdleValue(()=>this._createInstance(h,w,R));return new Proxy(Object.create(null),{get(s,o){if(o in s)return s[o];let p=b.value,a=p[o];return typeof a!="function"||(a=a.bind(p),s[o]=a),a},set(s,o,p){return b.value[o]=p,!0}})}else return this._createInstance(h,w,R)}}e.InstantiationService=L;var T;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(T||(T={}));class c{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return C?new c(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(h){return C?new c(0,h.name):c._None}branch(h,w){let v=new c(2,h.toString());return this._dep.push([h,w,v]),v}stop(){let h=Date.now()-this._start;c._totals+=h;let w=!1;function v(b,s){let o=[],p=new Array(b+1).join("	");for(const[a,S,n]of s._dep)if(S&&n){w=!0,o.push(`${p}CREATES -> ${a}`);let t=v(b+1,n);t&&o.push(t)}else o.push(`${p}uses -> ${a}`);return o.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(R.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(Ee[11],Se([0,1,50,3,6,12,4]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function k(){return new Date().toISOString()}var C;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function I(S,n,t){switch(n){case C.Trace:S.trace(t);break;case C.Debug:S.debug(t);break;case C.Info:S.info(t);break;case C.Warning:S.warn(t);break;case C.Error:S.error(t);break;case C.Critical:S.critical(t);break;default:throw new Error("Invalid log level")}}e.log=I;function L(S){let n="";for(let t=0;t<S.length;t++){let r=S[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(t>0?" ":"")+r}return n}e.format=L;class T extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class c extends T{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,L([n,...t]))}debug(n,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,L([n,...t]))}info(n,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,L([n,...t]))}warn(n,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,L([n,...t]))}error(n,...t){if(this.checkLogLevel(C.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(C.Error,L(r))}else this.log(C.Error,L([n,...t]))}critical(n,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,L([n,...t]))}flush(){}}e.AbstractMessageLogger=c;class E extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!_.isWindows}trace(n,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class h extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends T{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,g.toErrorMessage)(n,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class v extends T{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const r of this.logServices)r.trace(n,...t)}debug(n,...t){for(const r of this.logServices)r.debug(n,...t)}info(n,...t){for(const r of this.logServices)r.info(n,...t)}warn(n,...t){for(const r of this.logServices)r.warn(n,...t)}error(n,...t){for(const r of this.logServices)r.error(n,...t)}critical(n,...t){for(const r of this.logServices)r.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class R extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=R;class b extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,t?.always?C.Trace:this.logLevel,t),this.loggers.set(n.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class s{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return C.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=s;function o(S){if(S.verbose)return C.Trace;if(typeof S.logLevel=="string"){const n=p(S.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function p(S){switch(S){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=p;function a(S){switch(S){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=a}),define(Ee[188],Se([0,1,42,11]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(k,C,I,L,T){try{const c=await new Promise((h,w)=>{X(["spdlog"],h,w)});c.setFlushOn(i.LogLevel.Trace);const E=await c.createAsyncRotatingLogger(k,C,I,L);return T&&E.clearFormatters(),E}catch(c){console.error(c)}return null}function _(k,C,I){switch(C){case i.LogLevel.Trace:k.trace(I);break;case i.LogLevel.Debug:k.debug(I);break;case i.LogLevel.Info:k.info(I);break;case i.LogLevel.Warning:k.warn(I);break;case i.LogLevel.Error:k.error(I);break;case i.LogLevel.Critical:k.critical(I);break;default:throw new Error("Invalid log level")}}class P extends i.AbstractMessageLogger{constructor(C,I,L,T,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(C,I,L,T),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(C,I,L,T){const c=L?6:1,E=30/c*g.ByteSize.MB,h=await D(C,I,E,c,T);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:w,message:v}of this.buffer)_(this._logger,w,v);this.buffer=[]}}log(C,I){this._logger?_(this._logger,C,I):this.getLevel()<=C&&this.buffer.push({level:C,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(Ee[117],Se([0,1,48,161,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var P;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function I(h,w){return w-h}C.compare=I;const L=Object.create(null);L[C.Error]=(0,i.localize)(0,null),L[C.Warning]=(0,i.localize)(1,null),L[C.Info]=(0,i.localize)(2,null);function T(h){return L[h]||""}C.toString=T;function c(h){switch(h){case g.default.Error:return C.Error;case g.default.Warning:return C.Warning;case g.default.Info:return C.Info;case g.default.Ignore:return C.Hint}}C.fromSeverity=c;function E(h){switch(h){case C.Error:return g.default.Error;case C.Warning:return g.default.Warning;case C.Info:return g.default.Info;case C.Hint:return g.default.Ignore}}C.toSeverity=E}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(C){const I="";function L(c){return T(c,!0)}C.makeKey=L;function T(c,E){let h=[I];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(I),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(I),c.severity!==void 0&&c.severity!==null?h.push(P.toString(c.severity)):h.push(I),c.message&&E?h.push(c.message.replace("\xA6","\\\xA6")):h.push(I),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(I),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(I),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(I),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(I),h.push(I),h.join("\xA6")}C.makeKeyOptionalMessage=T})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ee[189],Se([0,1,3,48,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,D.createDecorator)("notificationService");var _;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new C,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=k;class C{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=C}),define(Ee[190],Se([0,1,6,8,2,4]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function P(C,I){return D.URI.isUri(C)?(0,i.equalsIgnoreCase)(C.scheme,I):(0,i.startsWithIgnoreCase)(C,I+":")}e.matchesScheme=P;function k(C,...I){return I.some(L=>P(C,L))}e.matchesSomeScheme=k}),define(Ee[191],Se([0,1,10,12,40,23]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const k=i.globals.vscode.context.configuration();if(k)P=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const k=(0,_.dirname)(g.FileAccess.asFileUri("",X));P=X.__$__nodeRequire((0,_.joinPath)(k,"product.json").fsPath);const C=X.__$__nodeRequire((0,_.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:C.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P});var He=this&&this.__param||function(X,e){return function(g,i){e(g,i,X)}};define(Ee[118],Se([0,1,18,21,6,4]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let C=class extends D.Disposable{constructor(T,c){super();this.deferred=new g.DeferredPromise,c.withProgress(T,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};C=je([He(1,e.IProgressService)],C),e.UnmanagedProgress=C;class I extends D.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(T){this.stop();const c=++this.currentOperationId,E=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:E.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(Ee[51],Se([0,1,56,13]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,k){g.ok(i.isString(P)),g.ok(i.isObject(k)),g.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,k)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Ee[192],Se([0,1,3,51]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class _{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,I){this.schemasById[D(C)]=I,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new _;i.Registry.add(e.Extensions.JSONContribution,P)}),define(Ee[119],Se([0,1,16,3,13,156,192,51]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=k.Registry.as(P.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(p,a=!0){this.registerConfigurations([p],a)}registerConfigurations(p,a=!0){const S=this.doRegisterConfigurations(p,a);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(p){const a=this.doDeregisterConfigurations(p);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:p,remove:a}){const S=[];S.push(...this.doDeregisterConfigurations(a)),S.push(...this.doRegisterConfigurations(p,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,g.distinct)(S)})}registerDefaultConfigurations(p){const a=[],S=[];for(const{overrides:n,source:t}of p)for(const r in n)if(a.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const l={...this.configurationDefaultsOverrides.get(r)?.value||{},...n[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:l});const d={type:"object",default:l,description:_.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:D.isString(t)?void 0:t};S.push(...h(r)),this.configurationProperties[r]=d,this.defaultLanguageConfigurationOverridesNode.properties[r]=d}else{this.configurationDefaultsOverrides.set(r,{value:n[r],source:t});const l=this.configurationProperties[r];l&&(this.updatePropertyDefaultValue(r,l),this.updateSchema(r,l))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(p){const a=[];for(const{overrides:S,source:n}of p)for(const t in S){const r=this.configurationDefaultsOverrides.get(t),l=D.isString(n)?n:n?.id,d=D.isString(r?.source)?r?.source:r?.source?.id;if(l===d)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const m=this.configurationProperties[t];m&&(this.updatePropertyDefaultValue(t,m),this.updateSchema(t,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const a of p)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(p,a){const S=[];return p.forEach(n=>{S.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),S}doDeregisterConfigurations(p){const a=[],S=n=>{if(n.properties)for(const t in n.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>S(t))};for(const n of p){S(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(p,a=!0,S,n,t=3){t=D.isUndefinedOrNull(p.scope)?t:p.scope;let r=[],l=p.properties;if(l)for(let m in l){if(a&&b(m)){delete l[m];continue}const f=l[m];if(f.source=S,f.defaultDefaultValue=l[m].default,this.updatePropertyDefaultValue(m,f),e.OVERRIDE_PROPERTY_REGEX.test(m)?f.scope=void 0:(f.scope=D.isUndefinedOrNull(f.scope)?t:f.scope,f.restricted=D.isUndefinedOrNull(f.restricted)?!!n?.includes(m):f.restricted),l[m].hasOwnProperty("included")&&!l[m].included){this.excludedConfigurationProperties[m]=l[m],delete l[m];continue}else this.configurationProperties[m]=l[m];!l[m].deprecationMessage&&l[m].markdownDeprecationMessage&&(l[m].deprecationMessage=l[m].markdownDeprecationMessage),r.push(m)}let d=p.allOf;if(d)for(let m of d)r.push(...this.validateAndRegisterProperties(m,a,S,n,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(p){const a=S=>{let n=S.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let t=S.allOf;t&&t.forEach(a)};a(p)}updateSchema(p,a){switch(e.allSettings.properties[p]=a,a.scope){case 1:e.applicationSettings.properties[p]=a;break;case 2:e.machineSettings.properties[p]=a;break;case 6:e.machineOverridableSettings.properties[p]=a;break;case 3:e.windowSettings.properties[p]=a;break;case 4:e.resourceSettings.properties[p]=a;break;case 5:e.resourceSettings.properties[p]=a,this.resourceLanguageSettingsSchema.properties[p]=a;break}}removeFromSchema(p,a){switch(delete e.allSettings.properties[p],a.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p],delete this.resourceLanguageSettingsSchema.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const a=`[${p}]`,S={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,S),e.allSettings.properties[a]=S,e.applicationSettings.properties[a]=S,e.machineSettings.properties[a]=S,e.machineOverridableSettings.properties[a]=S,e.windowSettings.properties[a]=S,e.resourceSettings.properties[a]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const p={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=p,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=p,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=p,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=p,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=p,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=p,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,a){const S=this.configurationDefaultsOverrides.get(p);let n=S?.value,t=S?.source;D.isUndefined(n)&&(n=a.defaultDefaultValue,t=void 0),D.isUndefined(n)&&(n=v(a.type)),a.default=n,a.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(o){const p=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let a=E.exec(o);for(;a?.length;){const S=a[1].trim();S&&p.push(S),a=E.exec(o)}}return(0,g.distinct)(p)}e.overrideIdentifiersFromKey=h;function w(o){return o.reduce((p,a)=>`${p}[${a}]`,"")}e.keyFromOverrideIdentifiers=w;function v(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const R=new T;k.Registry.add(e.Extensions.Configuration,R);function b(o){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?_.localize(7,null,o):R.getConfigurationProperties()[o]!==void 0?_.localize(8,null,o):null:_.localize(6,null)}e.validateProperty=b;function s(){const o=[],p=R.getConfigurationProperties();for(const a of Object.keys(p))o.push([a,p[a].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=s}),define(Ee[193],Se([0,1,16,3,58,6,24,25,13,2,116,119,51]),function(X,e,g,i,D,_,P,k,C,I,L,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,L.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,L.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return g.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return g.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=k.deepClone(this.contents),r=k.deepClone(this.overrides),l=[...this.keys];for(const d of n){this.mergeContents(t,d.contents);for(const m of d.overrides){const[f]=r.filter(u=>g.equals(u.identifiers,m.identifiers));f?(this.mergeContents(f.contents,m.contents),f.keys.push(...m.keys),f.keys=g.distinct(f.keys)):r.push(k.deepClone(m))}for(const m of d.keys)l.indexOf(m)===-1&&l.push(m)}return new E(t,l,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const l of g.distinct([...Object.keys(this.contents),...Object.keys(t)])){let d=this.contents[l],m=t[l];m&&(typeof d=="object"&&typeof m=="object"?(d=k.deepClone(d),this.mergeContents(d,m)):d=m),r[l]=d}return new E(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&C.isObject(n[r])&&C.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=k.deepClone(t[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const l=d=>{d&&(r?this.mergeContents(r,d):r=k.deepClone(d))};for(const d of this.overrides)g.equals(d.identifiers,[n])?t=d.contents:d.identifiers.includes(n)&&l(d.contents);return l(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,L.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,L.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(n={}){const t=c.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),l=Object.create(null),d=[];for(const m in t){const f=n[m],u=f!==void 0?f:t[m].default;(0,L.addToValueTree)(l,m,u,y=>console.error(`Conflict in default settings: ${y}`))}for(const m of Object.keys(l))T.OVERRIDE_PROPERTY_REGEX.test(m)&&d.push({identifiers:(0,T.overrideIdentifiersFromKey)(m),keys:Object.keys(l[m]),contents:(0,L.toValuesTree)(l[m],f=>console.error(`Conflict in default settings file: ${f}`))});super(l,r,d)}}e.DefaultConfigurationModel=h;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!C.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:l,overrides:d,restricted:m}=this.doParseRaw(n,t);this._configurationModel=new E(r,l,d),this._restrictedConfigurations=m||[]}doParseContent(n){let t={},r=null,l=[],d=[],m=[];function f(y){Array.isArray(l)?l.push(y):r!==null&&(l[r]=y)}let u={onObjectBegin:()=>{let y={};f(y),d.push(l),l=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{let y=[];f(y),d.push(l),l=y,r=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:f,onError:(y,A,N)=>{m.push({error:y,offset:A,length:N})}};if(n)try{D.visit(n,u),t=l[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return t}doParseRaw(n,t){const r=c.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),l=this.filter(n,r,!0,t);n=l.raw;const d=(0,L.toValuesTree)(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),m=Object.keys(n),f=this.toOverrides(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:d,keys:m,overrides:f,restricted:l.restricted}}filter(n,t,r,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:n,restricted:[]};const d={},m=[];for(let f in n)if(T.OVERRIDE_PROPERTY_REGEX.test(f)&&r){const u=this.filter(n[f],t,!1,l);d[f]=u.raw,m.push(...u.restricted)}else{const u=t[f],y=u?typeof u.scope!="undefined"?u.scope:3:void 0;u?.restricted&&m.push(f),(y===void 0||l.scopes===void 0||l.scopes.includes(y))&&(l.skipRestricted&&u?.restricted||(d[f]=n[f]))}return{raw:d,restricted:m}}toOverrides(n,t){const r=[];for(const l of Object.keys(n))if(T.OVERRIDE_PROPERTY_REGEX.test(l)){const d={};for(const m in n[l])d[m]=n[l][m];r.push({identifiers:(0,T.overrideIdentifiersFromKey)(l),keys:Object.keys(d),contents:(0,L.toValuesTree)(d,t)})}return r}}e.ConfigurationModelParser=w;class v extends _.Disposable{constructor(n,t,r,l){super();this.userSettingsResource=n,this.scopes=t,this.fileService=l,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class R{constructor(n,t,r=new E,l=new E,d=new P.ResourceMap,m=new E,f=new P.ResourceMap,u=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=l,this._folderConfigurations=d,this._memoryConfiguration=m,this._memoryConfigurationByResource=f,this._freeze=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(n)}updateValue(n,t,r={}){let l;r.resource?(l=this._memoryConfigurationByResource.get(r.resource),l||(l=new E,this._memoryConfigurationByResource.set(r.resource,l))):l=this._memoryConfiguration,t===void 0?l.removeValue(n):l.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const l=this.getConsolidateConfigurationModel(t,r),d=this.getFolderConfigurationModelForResource(t.resource,r),m=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,f=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),u=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),y=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,B=d?t.overrideIdentifier?d.freeze().override(t.overrideIdentifier).getValue(n):d.freeze().getValue(n):void 0,F=t.overrideIdentifier?m.override(t.overrideIdentifier).getValue(n):m.getValue(n),O=l.getValue(n),z=g.distinct(g.flatten(l.overrides.map(W=>W.identifiers))).filter(W=>l.getOverrideValue(n,W)!==void 0);return{defaultValue:f,userValue:u,userLocalValue:y,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:B,memoryValue:F,value:O,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:u!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:d?.freeze().getValue(n),override:t.overrideIdentifier?d?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:m.getValue(n),override:t.overrideIdentifier?m.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:l,updated:d,removed:m}=p(this._defaultConfiguration,n);t=[...l,...d,...m]}for(const l of t)for(const d of(0,T.overrideIdentifiersFromKey)(l)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(d),f=n.getKeysForOverrideIdentifier(d),u=[...f.filter(y=>m.indexOf(y)===-1),...m.filter(y=>f.indexOf(y)===-1),...m.filter(y=>!k.equals(this._defaultConfiguration.override(d).getValue(y),n.override(d).getValue(y)))];r.push([d,u])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:l,overrides:d}=p(this.localUserConfiguration,n),m=[...t,...r,...l];return m.length&&this.updateLocalUserConfiguration(n),{keys:m,overrides:d}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:l,overrides:d}=p(this.remoteUserConfiguration,n);let m=[...t,...r,...l];return m.length&&this.updateRemoteUserConfiguration(n),{keys:m,overrides:d}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:l,overrides:d}=p(this.workspaceConfiguration,n);let m=[...t,...r,...l];return m.length&&this.updateWorkspaceConfiguration(n),{keys:m,overrides:d}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:l,updated:d,removed:m,overrides:f}=p(r,t);let u=[...l,...d,...m];return(u.length||!r)&&this.updateFolderConfiguration(n,t),{keys:u,overrides:f}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:l,removed:d,overrides:m}=p(t,void 0);return{keys:[...r,...l,...d],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const l=t.getFolder(n);l&&(r=this.getFolderConsolidatedConfiguration(l.uri)||r);const d=this._memoryConfigurationByResource.get(n);d&&(r=r.merge(d))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(n);l?(t=r.merge(l),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:l,keys:d}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:l,keys:d}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(l=>t.add(l))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),l=this.parseConfigurationModel(n.workspace),d=n.folders.reduce((m,f)=>(m.set(I.URI.revive(f[0]),this.parseConfigurationModel(f[1])),m),new P.ResourceMap);return new R(t,r,new E,l,d,new E,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=R;function b(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const n=new Set,t=new Map;for(const l of S)l.keys.forEach(d=>n.add(d)),l.overrides.forEach(([d,m])=>{const f=(0,P.getOrSet)(t,d,new Set);m.forEach(u=>f.add(u))});const r=[];return t.forEach((l,d)=>r.push([d,[...l.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=b;class s{constructor(n,t,r,l){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=l,this._previousConfiguration=void 0;const d=new Set;n.keys.forEach(f=>d.add(f)),n.overrides.forEach(([,f])=>f.forEach(u=>d.add(u))),this.affectedKeys=[...d.values()];const m=new E;this.affectedKeys.forEach(f=>m.setValue(f,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!k.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,L.toValuesTree)({[t]:!0},()=>{}),l;for(;typeof r=="object"&&(l=Object.keys(r)[0]);){if(n=n[l],!n)return!1;r=r[l]}return!0}}e.ConfigurationChangeEvent=s;class o extends s{constructor(n,t,r,l){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=o;function p(S,n){const{added:t,removed:r,updated:l}=a(n,S),d=[],m=S?.getAllOverrideIdentifiers()||[],f=n?.getAllOverrideIdentifiers()||[];if(n){const u=f.filter(y=>!m.includes(y));for(const y of u)d.push([y,n.getKeysForOverrideIdentifier(y)])}if(S){const u=m.filter(y=>!f.includes(y));for(const y of u)d.push([y,S.getKeysForOverrideIdentifier(y)])}if(n&&S){for(const u of m)if(f.includes(u)){const y=a({contents:S.getOverrideValue(void 0,u)||{},keys:S.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});d.push([u,[...y.added,...y.removed,...y.updated]])}}return{added:t,removed:r,updated:l,overrides:d}}function a(S,n){const t=S?n?S.keys.filter(d=>n.keys.indexOf(d)===-1):[...S.keys]:[],r=n?S?n.keys.filter(d=>S.keys.indexOf(d)===-1):[...n.keys]:[],l=[];if(S&&n){for(const d of n.keys)if(S.keys.indexOf(d)!==-1){const m=(0,L.getConfigurationValue)(n.contents,d),f=(0,L.getConfigurationValue)(S.contents,d);k.equals(m,f)||l.push(d)}}return{added:t,removed:r,updated:l}}}),define(Ee[120],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var i;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,k=i.Unknown,C){super(P);this._message=P,this._code=k,this._detail=C,this.isHandled=k===i.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===i.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===i.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Ee[62],Se([0,1,10]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(I){return I.scheme===g.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=i;function D(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=D;function _(I){return I.scheme!==g.Schemas.file&&I.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=_;function P(I){if(I.folders.length)return I.folders.every(L=>_(L.uri))?I.folders[0].uri:void 0;if(I.configuration&&_(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=P;function k(I){return P(I)?.scheme}e.getVirtualWorkspaceScheme=k;function C(I){return P(I)!==void 0}e.isVirtualWorkspace=C}),define(Ee[27],Se([0,1,8,4,62]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=_;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let w=typeof E=="string"?E:E.value,v=typeof h=="string"?h:h.value;return g.equalsIgnoreCase(w,v)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=C;function I(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function L(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function T(c,E){if(E){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(E)}`;return c.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[194],Se([0,1,8,27]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,g.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=D;class _{constructor(w,v){this.version=v,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof _?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=_;function P(h,w){return`${h}.${w}`}e.getExtensionId=P;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function C(h,w){return k(P(h,w))}e.getGalleryExtensionId=C;function I(h,w){const v=[],R=b=>{for(const s of v)if(s.some(o=>D(w(o),w(b))))return s;return null};for(const b of h){const s=R(b);s?s.push(b):v.push([b])}return v}e.groupByExtension=I;function L(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function T(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function c(h){const w=new Set;if(h.malicious)for(const v of h.malicious)w.add(v.id);return w}e.getMaliciousExtensionsSet=c;function E(h,w){const v=[],R=w.manifest.extensionDependencies?.slice(0)??[];for(;R.length;){const b=R.shift();if(b&&v.every(s=>!D(s.identifier,{id:b}))){const s=h.filter(o=>D(o.identifier,{id:b}));s.length===1&&(v.push(s[0]),R.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=E}),define(Ee[121],Se([0,1,3,12,4,11]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var P;(function(h){h.Http="http",h.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=T;function c(h,w){return w?w!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=c;let E=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,v){return this._tunnelProvider=w,w?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],v=Array.from(this._tunnels.values());for(let R of v){const b=Array.from(R.values());for(let s of b){const o=await s.value;o&&w.push(o)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:v}of w.values())await v.then(R=>R?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,v,R,b,s=!1,o=k.Private,p){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${R} on local port ${b}.`),!w)return;v||(v="localhost");const a=this.retainOrCreateTunnel(w,v,R,b,s,o,p);return a?a.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,R);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(S);return(S.tunnelRemoteHost!==v||S.tunnelRemotePort!==R)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const v=this._tunnels.get(w.tunnelRemoteHost);if(v){const R=v.get(w.tunnelRemotePort);R&&(R.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,R))}}}}async tryDisposeTunnel(w,v,R){if(R.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${v}.`);const b=R.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(v),b}}async closeTunnel(w,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${v} `);const R=this._tunnels.get(w);if(R&&R.has(v)){const b=R.get(v);b.refcount=0,await this.tryDisposeTunnel(w,v,b)}}addTunnelToMap(w,v,R){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(v,{refcount:1,value:R})}async removeEmptyTunnelFromMap(w,v){const R=this._tunnels.get(w);R&&(await R.get(v)||R.delete(v),R.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,v){let R=[w];L(w)?(R.push(...e.LOCALHOST_ADDRESSES),R.push(...e.ALL_INTERFACES_ADDRESSES)):T(w)&&R.push(...e.ALL_INTERFACES_ADDRESSES);const b=R.map(s=>this._tunnels.get(s));for(const s of b){const o=s?.get(v);if(o)return o}}canTunnel(w){return!!I(w)}createWithProvider(w,v,R,b,s,o,p){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${R} on local port ${b}.`);const S={elevationRequired:s?c(b===void 0?R:b):!1},n={remoteAddress:{host:v,port:R},localAddressPort:b,privacy:o,public:o!==k.Private,protocol:p},t=w.forwardPort(n,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,R,t),t}};E=je([He(0,_.ILogService)],E),e.AbstractTunnelService=E}),define(Ee[195],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((D,_)=>X(["vsda"],D,_))}async createNewMessage(D){try{const _=await this.vsda(),P=new _.validator;if(P){const k=String(g._nextId++);return this.validators.set(k,P),{id:k,data:P.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,_){if(!D.id)return!0;const P=this.validators.get(D.id);if(!P)return!1;this.validators.delete(D.id);try{return P.validate(_)==="ok"}catch{return!1}}async sign(D){try{const _=await this.vsda(),P=new _.signer;if(P)return P.sign(D)}catch{}return D}}e.SignService=g,g._nextId=1}),define(Ee[196],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,_,P=5){let k;return k=_(C=>{const I=typeof C=="string"?C:C.data;let L=this._terminalBufferMap.get(D);if(L){L.data.push(I);return}const T=setTimeout(()=>this.flushBuffer(D),P);L={data:[I],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,L)}),k}stopBuffering(D){const _=this._terminalBufferMap.get(D);_&&_.dispose()}flushBuffer(D){const _=this._terminalBufferMap.get(D);_&&(this._terminalBufferMap.delete(D),this._callback(D,_.data.join("")))}}e.TerminalDataBufferer=g}),define(Ee[197],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[86],Se([0,1,73,3,6,4,51,197]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(v){function R(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=R})(C=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var L;(function(v){function R(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}v.isThemeIcon=R;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function s(t){const r=b.exec(t);if(!r)return;let[,l]=r;return{id:l}}v.fromString=s;function o(t){return{id:t}}v.fromId=o;function p(t,r){let l=t.id;const d=l.lastIndexOf("~");return d!==-1&&(l=l.substring(0,d)),r&&(l=`${l}~${r}`),{id:l}}v.modify=p;function a(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}v.getModifier=a;function S(t,r){return t.id===r.id&&t.color?.id===r.color?.id}v.isEqual=S;function n(t,r){return{id:t.id,color:r?I(r):void 0}}v.asThemeIcon=n,v.asClassNameArray=g.CSSIcon.asClassNameArray,v.asClassName=g.CSSIcon.asClassName,v.asCSSSelector=g.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function T(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(R){return this.themingParticipants.push(R),this.onThemingParticipantAddedEmitter.fire(R),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(R);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new c;P.Registry.add(e.Extensions.ThemingContribution,E);function h(v){return E.onColorThemeChange(v)}e.registerThemingParticipant=h;class w extends D.Disposable{constructor(R){super();this.themeService=R,this.theme=R.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(R){this.theme=R,this.updateStyles()}updateStyles(){}getColor(R,b){let s=this.theme.getColor(R);return s&&b&&(s=b(s,this.theme)),s?s.toString():null}}e.Themable=w}),define(Ee[43],Se([0,1,24,23,2,4]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,_.createDecorator)("contextService");var P;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function k(c){const E=c;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=k;function C(c){const E=c;return!!(E&&typeof E=="object"&&D.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=C;class I{constructor(E,h,w,v,R){this._id=E,this._transient=w,this._configuration=v,this._ignorePathCasing=R,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=I;class L{constructor(E,h){this.raw=h,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,i.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function T(c){return new L({uri:c,index:0,name:(0,i.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=T}),define(Ee[198],Se([0,1,30,58,140,80,10,9,12,23,2,162,4,62,43]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(M){return(typeof M=="string"?(0,k.extname)(M):(0,I.extname)(M))===w}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function R(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=R;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function o(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=o;function p(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=p;function a(M){const x=M;return typeof x?.id=="string"&&L.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=a;function S(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=S;function n(M){const x=M;return typeof x?.id=="string"&&L.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=n;function t(M){const x=M;if(x?.uri)return{id:x.id,uri:L.URI.revive(x.uri)};const V=M;if(V?.configPath)return{id:V.id,configPath:L.URI.revive(V.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=t;function r(M,x){return I.extUriBiasedIgnorePathCase.isEqualOrParent(M,x.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function l(M){return d(M)||m(M)}e.isStoredWorkspaceFolder=l;function d(M){const x=M;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=d;function m(M){const x=M;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=m;function f(M,x,V,U,H=!C.isWindows,Y){if(M.scheme!==U.scheme)return{name:V,uri:M.toString(!0)};let re=x?void 0:Y.relativePath(U,M);if(re!==void 0)re.length===0?re=".":C.isWindows&&M.scheme===P.Schemas.file&&!H&&(re=re.replace(/\//g,"\\"));else if(M.scheme===P.Schemas.file)re=M.fsPath,C.isWindows&&(re=(0,_.normalizeDriveLetter)(re),H&&(re=(0,g.toSlashes)(re)));else{if(!Y.isEqualAuthority(M.authority,U.authority))return{name:V,uri:M.toString(!0)};re=M.path}return{name:V,path:re}}e.getStoredWorkspaceFolder=f;function u(M,x,V){let U=[],H=new Set;const Y=V.dirname(x);for(let re of M){let K;if(d(re))re.path&&(K=V.resolvePath(Y,re.path));else if(m(re))try{K=L.URI.parse(re.uri),K.path[0]!=="/"&&(K=K.with({path:"/"+K.path}))}catch(j){console.warn(j)}if(K){let j=V.getComparisonKey(K);if(!H.has(j)){H.add(j);const te=re.name||V.basenameOrAuthority(K);U.push(new h.WorkspaceFolder({uri:K,name:te,index:U.length},re))}}}return U}e.toWorkspaceFolders=u;function y(M,x,V,U,H){let Y=A(x,M);const re=H.dirname(x),K=H.dirname(U),j=[],te=N(Y.folders);for(const Me of Y.folders){const Ne=d(Me)?H.resolvePath(re,Me.path):L.URI.parse(Me.uri);let q;V?q=!1:q=!d(Me)||(0,k.isAbsolute)(Me.path),j.push(f(Ne,q,Me.name,K,te,H))}const ae={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},ge=D.setProperty(M,["folders"],j,ae);let Ie=D.applyEdits(M,ge);return(0,I.isEqualAuthority)(Y.remoteAuthority,(0,E.getRemoteAuthority)(U))&&(Ie=D.applyEdits(Ie,D.removeProperty(Ie,["remoteAuthority"],ae))),Ie}e.rewriteWorkspaceFileForNewLocation=y;function A(M,x){let V=i.parse(x);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(U=>l(U));else throw new Error(`${M} looks like an invalid workspace file.`);return V}function N(M){return C.isWindows?M.some(x=>d(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function B(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function z(M,x){const V={workspaces:[],files:[]};if(M){const U=function(Y,re){for(let K=0;K<Y.length;K++)try{re(Y[K],K)}catch(j){x.warn(`Error restoring recent entry ${JSON.stringify(Y[K])}: ${j.toString()}. Skip entry.`)}},H=M;if(Array.isArray(H.entries))U(H.entries,Y=>{const re=Y.label,K=Y.remoteAuthority;B(Y)?V.workspaces.push({label:re,remoteAuthority:K,workspace:{id:Y.workspace.id,configPath:L.URI.parse(Y.workspace.configPath)}}):F(Y)?V.workspaces.push({label:re,remoteAuthority:K,folderUri:L.URI.parse(Y.folderUri)}):O(Y)&&V.files.push({label:re,remoteAuthority:K,fileUri:L.URI.parse(Y.fileUri)})});else{const Y=M;Array.isArray(Y.workspaces3)&&U(Y.workspaces3,(re,K)=>{const j=Array.isArray(Y.workspaceLabels)&&Y.workspaceLabels[K]||void 0;typeof re=="object"&&typeof re.id=="string"&&typeof re.configURIPath=="string"?V.workspaces.push({label:j,workspace:{id:re.id,configPath:L.URI.parse(re.configURIPath)}}):typeof re=="string"&&V.workspaces.push({label:j,folderUri:L.URI.parse(re)})}),Array.isArray(Y.files2)&&U(Y.files2,(re,K)=>{const j=Array.isArray(Y.fileLabels)&&Y.fileLabels[K]||void 0;typeof re=="string"&&V.files.push({label:j,fileUri:L.URI.parse(re)})})}}return V}e.restoreRecentlyOpened=z;function W(M){const x={entries:[]};for(const V of M.workspaces)b(V)?x.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):x.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of M.files)x.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return x}e.toStoreData=W}),define(Ee[87],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const _=this._idPool++;return this._data.set(_,D),this.logDebugInfo(),_}get(D,_){return this._data.has(D)?this._data.get(D)[_]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(Ee[44],Se([0,1,10,23,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class _{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(k=>{const C=this._providerInfo.get(k.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(k,C){C===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,C)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=_,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[26],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(Ee[199],Se([0,1,18]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(P,k,C){this._deferredPromises=new Map,this._id=P,this._shared=k,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const T of I.values())T.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,k){let C=this._value[P];return typeof C=="undefined"&&(C=k),C}update(P,k){this._value[P]=k;let C=this._deferredPromises.get(P);if(C!==void 0)return C.p;const I=new g.DeferredPromise;return this._deferredPromises.set(P,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class D extends i{constructor(P,k){super(P.identifier.value,!0,k);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=D}),define(Ee[200],Se([0,1,3,2,11]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(k,C){this._logService=k,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,C,I){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptModelChanged(C.value,I)}$acceptDirtyStateChanged(k,C){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptDirty(C)}$acceptModelSaved(k){const C=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(k,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,C);const I=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));I.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};_=je([He(0,D.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(Ee[14],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class i{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[201],Se([0,1,27,3]),function(X,e,g,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(k,C){D.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(k.identifier),tt(this,D,C,"f"),Fe(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(k){return Fe(this,D,"f").get(this._id,k)}store(k,C){return Fe(this,D,"f").store(this._id,k,C)}delete(k){return Fe(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=_,D=new WeakMap}),define(Ee[122],Se([0,1,4,3]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(Ee[63],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,D=(b,s)=>{const o={controllerId:s};return i.set(b,o),o};e.createPrivateApiFor=D;const _=b=>i.get(b);e.getPrivateApiFor=_;const P=(b,s,o,p)=>{let a=o;return{enumerable:!0,configurable:!1,get(){return a},set(S){if(!p(a,S)){const n=a;a=S,b.listener?.({op:3,key:s,value:S,previous:n})}}}},k=(b,s)=>b===s,C={range:(b,s)=>b===s?!0:!b||!s?!1:b.isEqual(s),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(b,s)=>!(b.length!==s.length||b.some(o=>!s.find(p=>o.id===p.id)))},I=Object.keys(C),L=(b,s)=>({range:P(b,"range",void 0,C.range),label:P(b,"label",s,C.label),description:P(b,"description",void 0,C.description),canResolveChildren:P(b,"canResolveChildren",!1,C.canResolveChildren),busy:P(b,"busy",!1,C.busy),error:P(b,"error",void 0,C.error),tags:P(b,"tags",[],C.tags)}),T=(b,s)=>{const o=new Map;for(const p of I)C[p](b[p],s[p])||o.set(p,s[p]);return o};e.diffTestItems=T;class c extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=c;class E extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class h extends Error{constructor(s,o,p){super(`TestItem with ID "${s}" is from controller "${o}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=h;const w=b=>{const s=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(p,a){for(const S of o.values())p.call(a,S,this)},replace(p){const a=new Map,S=new Set(o.keys()),n={op:4,ops:[]};for(const t of p){if(!(t instanceof v))throw new E(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==s.controllerId)throw new h(t.id,r,s.controllerId);if(a.has(t.id))throw new c(t.id);a.set(t.id,t),S.delete(t.id),n.ops.push({op:0,item:t})}for(const t of S.keys())n.ops.push({op:1,id:t});s.listener?.(n),o=a},add(p){if(!(p instanceof v))throw new E(p.id);o.set(p.id,p),s.listener?.({op:0,item:p})},delete(p){o.delete(p)&&s.listener?.({op:1,id:p})},get(p){return o.get(p)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class v{constructor(s,o,p,a){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const S=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof R?void 0:S.parent}},children:{value:w(this),enumerable:!0,writable:!1},...L(S,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class R extends v{constructor(s,o){super(s,s,o,void 0)}}e.TestItemRootImpl=R}),define(Ee[52],Se([0,1,4,121,3,14]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(C){function I(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:T.protocol}}C.fromApiTunnel=I;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==i.TunnelPrivacyId.ConstantPrivate&&T.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}C.fromServiceTunnel=L})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let k=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,T,c,E){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([He(0,_.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[7],Se([0,1,16,15,98,24,102,8,13,2,33,42,120]),function(X,e,g,i,D,_,P,k,C,I,L,T,c){"use strict";var E,h,w,v,R,b,s,o,p,a,S,n,t,r,l,d,m,f,u,y;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(G){function $(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf($,G),Object.setPrototypeOf($.prototype,G.prototype),$}let N=R=class{constructor($){E.set(this,void 0),tt(this,E,$,"f")}static from(...$){let ce=$;return new R(function(){if(ce){for(const Ae of ce)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();ce=void 0}})}dispose(){typeof Fe(this,E,"f")=="function"&&(Fe(this,E,"f").call(this),tt(this,E,void 0,"f"))}};E=new WeakMap,N=R=je([A],N),e.Disposable=N;let B=b=class{constructor($,ce){if($<0)throw(0,i.illegalArgument)("line must be non-negative");if(ce<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=$,this._character=ce}static Min(...$){if($.length===0)throw new TypeError;let ce=$[0];for(let Ae=1;Ae<$.length;Ae++){const Ye=$[Ae];Ye.isBefore(ce)&&(ce=Ye)}return ce}static Max(...$){if($.length===0)throw new TypeError;let ce=$[0];for(let Ae=1;Ae<$.length;Ae++){const Ye=$[Ae];Ye.isAfter(ce)&&(ce=Ye)}return ce}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;let{line:ce,character:Ae}=$;return typeof ce=="number"&&typeof Ae=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ce=0){if($===null||ce===null)throw(0,i.illegalArgument)();let Ae;return typeof $=="undefined"?Ae=0:typeof $=="number"?Ae=$:(Ae=typeof $.lineDelta=="number"?$.lineDelta:0,ce=typeof $.characterDelta=="number"?$.characterDelta:0),Ae===0&&ce===0?this:new b(this.line+Ae,this.character+ce)}with($,ce=this.character){if($===null||ce===null)throw(0,i.illegalArgument)();let Ae;return typeof $=="undefined"?Ae=this.line:typeof $=="number"?Ae=$:(Ae=typeof $.line=="number"?$.line:this.line,ce=typeof $.character=="number"?$.character:this.character),Ae===this.line&&ce===this.character?this:new b(Ae,ce)}toJSON(){return{line:this.line,character:this.character}}};B=b=je([A],B),e.Position=B;let F=s=class{constructor($,ce,Ae,Ye){let rt,lt;if(typeof $=="number"&&typeof ce=="number"&&typeof Ae=="number"&&typeof Ye=="number"?(rt=new B($,ce),lt=new B(Ae,Ye)):$ instanceof B&&ce instanceof B&&(rt=$,lt=ce),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange($){return $ instanceof s?!0:$?B.isPosition($.start)&&B.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof s?this.contains($._start)&&this.contains($._end):$ instanceof B?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ce=B.Max($.start,this._start),Ae=B.Min($.end,this._end);if(!ce.isAfter(Ae))return new s(ce,Ae)}union($){if(this.contains($))return this;if($.contains(this))return $;const ce=B.Min($.start,this._start),Ae=B.Max($.end,this.end);return new s(ce,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ce=this.end){if($===null||ce===null)throw(0,i.illegalArgument)();let Ae;return $?B.isPosition($)?Ae=$:(Ae=$.start||this.start,ce=$.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&ce.isEqual(this.end)?this:new s(Ae,ce)}toJSON(){return[this.start,this.end]}};F=s=je([A],F),e.Range=F;let O=o=class extends F{constructor($,ce,Ae,Ye){let rt,lt;if(typeof $=="number"&&typeof ce=="number"&&typeof Ae=="number"&&typeof Ye=="number"?(rt=new B($,ce),lt=new B(Ae,Ye)):$ instanceof B&&ce instanceof B&&(rt=$,lt=ce),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection($){return $ instanceof o?!0:$?F.isRange($)&&B.isPosition($.anchor)&&B.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=o=je([A],O),e.Selection=O;class z{constructor($,ce,Ae){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,i.illegalArgument)("port");if(typeof Ae!="undefined"&&(typeof Ae!="string"||Ae.length===0||!/^[0-9A-Za-z\-]+$/.test(Ae)))throw(0,i.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(ce),this.connectionToken=Ae}}e.ResolvedAuthority=z;class W extends Error{constructor($,ce=c.RemoteAuthorityResolverErrorCode.Unknown,Ae){super($);this._message=$,this._code=ce,this._detail=Ae,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable($,ce){return new W($,c.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable($){return new W($,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var M;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(M=e.EndOfLine||(e.EndOfLine={}));var x;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=p=class{constructor($,ce){this._range=$,this._newText=ce}static isTextEdit($){return $ instanceof p?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,ce){return new p($,ce)}static insert($,ce){return p.replace(new F($,$),ce)}static delete($){return p.replace($,"")}static setEndOfLine($){const ce=new p(new F(new B(0,0),new B(0,0)),"");return ce.newEol=$,ce}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,i.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,i.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,i.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=p=je([A],V),e.TextEdit=V;var U;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ce,Ae,Ye){this._edits.push({_type:1,from:$,to:ce,options:Ae,metadata:Ye})}createFile($,ce,Ae){this._edits.push({_type:1,from:void 0,to:$,options:ce,metadata:Ae})}deleteFile($,ce,Ae){this._edits.push({_type:1,from:$,to:void 0,options:ce,metadata:Ae})}replaceNotebookMetadata($,ce,Ae){this._edits.push({_type:3,metadata:Ae,uri:$,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells($,ce,Ae,Ye,rt){let lt,ft,kt=[],Ft;if(Be.isNotebookRange(ce)&&Bt.isNotebookCellDataArray(Ae)&&!Bt.isNotebookCellDataArray(Ye)?(lt=ce.start,ft=ce.end,kt=Ae,Ft=Ye):typeof ce=="number"&&typeof Ae=="number"&&Bt.isNotebookCellDataArray(Ye)&&(lt=ce,ft=Ae,kt=Ye,Ft=rt),lt===void 0||ft===void 0)throw new Error("Invalid arguments");(lt!==ft||kt.length>0)&&this._edits.push({_type:5,uri:$,index:lt,count:ft-lt,cells:kt,metadata:Ft})}replaceNotebookCellMetadata($,ce,Ae,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:ce,metadata:Ae}})}replace($,ce,Ae,Ye){this._edits.push({_type:2,uri:$,edit:new V(ce,Ae),metadata:Ye})}insert($,ce,Ae,Ye){this.replace($,new F(ce,ce),Ae,Ye)}delete($,ce,Ae){this.replace($,ce,"",Ae)}has($){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===$.toString())}set($,ce){if(ce)for(const Ae of ce)Ae&&this._edits.push({_type:2,uri:$,edit:Ae});else{for(let Ae=0;Ae<this._edits.length;Ae++){const Ye=this._edits[Ae];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Ae]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get($){const ce=[];for(let Ae of this._edits)Ae._type===2&&Ae.uri.toString()===$.toString()&&ce.push(Ae.edit);return ce}entries(){const $=new _.ResourceMap;for(let ce of this._edits)if(ce._type===2){let Ae=$.get(ce.uri);Ae||(Ae=[ce.uri,[]],$.set(ce.uri,Ae)),Ae[1].push(ce.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=je([A],H),e.WorkspaceEdit=H;let Y=a=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ce=this._tabstop++){if(typeof $=="function"){const Ae=new a;Ae._tabstop=this._tabstop,$(Ae),this._tabstop=Ae._tabstop,$=Ae.value}else $=a._escape($);return this.value+="${",this.value+=ce,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ce=this._tabstop++){const Ae=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable($,ce){if(typeof ce=="function"){const Ae=new a;Ae._tabstop=this._tabstop,ce(Ae),this._tabstop=Ae._tabstop,ce=Ae.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};Y=a=je([A],Y),e.SnippetString=Y;var re;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(re=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let j=S=class{constructor($,ce){if(this.uri=$,ce)if(ce instanceof F)this.range=ce;else if(ce instanceof B)this.range=new F(ce,ce);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof S?!0:$?F.isRange($.range)&&I.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};j=S=je([A],j),e.Location=j;let te=class{constructor($,ce){this.location=$,this.message=ce}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&I.URI.isUri($.location.uri):!1}static isEqual($,ce){return $===ce?!0:!$||!ce?!1:$.message===ce.message&&$.location.range.isEqual(ce.location.range)&&$.location.uri.toString()===ce.location.uri.toString()}};te=je([A],te),e.DiagnosticRelatedInformation=te;let ae=class{constructor($,ce,Ae=K.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=$,this.message=ce,this.severity=Ae}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ce){return $===ce?!0:!$||!ce?!1:$.message===ce.message&&$.severity===ce.severity&&$.code===ce.code&&$.severity===ce.severity&&$.source===ce.source&&$.range.isEqual(ce.range)&&(0,g.equals)($.tags,ce.tags)&&(0,g.equals)($.relatedInformation,ce.relatedInformation,te.isEqual)}};ae=je([A],ae),e.Diagnostic=ae;let ge=class{constructor($,ce){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=ce}};ge=je([A],ge),e.Hover=ge;var Ie;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor($,ce=Ie.Text){this.range=$,this.kind=ce}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Me=je([A],Me),e.DocumentHighlight=Me;var Ne;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var q;(function(G){G[G.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let J=n=class{constructor($,ce,Ae,Ye,rt){this.name=$,this.kind=ce,this.containerName=rt,typeof Ae=="string"&&(this.containerName=Ae),Ye instanceof j?this.location=Ye:Ae instanceof F&&(this.location=new j(Ye,Ae)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};J=n=je([A],J),e.SymbolInformation=J;let ne=t=class{constructor($,ce,Ae,Ye,rt){this.name=$,this.detail=ce,this.kind=Ae,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};ne=t=je([A],ne),e.DocumentSymbol=ne;var he;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(he=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor($,ce){this.title=$,this.kind=ce}};ee=je([A],ee),e.CodeAction=ee;let oe=r=class{constructor($){this.value=$}append($){return new r(this.value?this.value+r.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+r.sep)}};oe.sep=".",oe=r=je([A],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let _e=class{constructor($,ce){if(this.range=$,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=je([A],_e),e.SelectionRange=_e;class Ue{constructor($,ce,Ae,Ye,rt,lt){this.kind=$,this.name=ce,this.detail=Ae,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Ue;class Ve{constructor($,ce){this.fromRanges=ce,this.from=$}}e.CallHierarchyIncomingCall=Ve;class Ke{constructor($,ce){this.fromRanges=ce,this.to=$}}e.CallHierarchyOutgoingCall=Ke;var Je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor($,ce){this.range=$,this.command=ce}get isResolved(){return!!this.command}};it=je([A],it),e.CodeLens=it;let at=l=class{constructor($,ce=!1){h.set(this,void 0),tt(this,h,new D.MarkdownString($,{supportThemeIcons:ce}),"f")}static isMarkdownString($){return $ instanceof l?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Fe(this,h,"f").value}set value($){Fe(this,h,"f").value=$}get isTrusted(){return Fe(this,h,"f").isTrusted}set isTrusted($){Fe(this,h,"f").isTrusted=$}get supportThemeIcons(){return Fe(this,h,"f").supportThemeIcons}set supportThemeIcons($){Fe(this,h,"f").supportThemeIcons=$}get supportHtml(){return Fe(this,h,"f").supportHtml}set supportHtml($){Fe(this,h,"f").supportHtml=$}appendText($){return Fe(this,h,"f").appendText($),this}appendMarkdown($){return Fe(this,h,"f").appendMarkdown($),this}appendCodeblock($,ce){return Fe(this,h,"f").appendCodeblock(ce??"",$),this}};h=new WeakMap,at=l=je([A],at),e.MarkdownString=at;let et=class{constructor($,ce){this.label=$,this.documentation=ce}};et=je([A],et),e.ParameterInformation=et;let nt=class{constructor($,ce){this.label=$,this.documentation=ce,this.parameters=[]}};nt=je([A],nt),e.SignatureInformation=nt;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=je([A],ct),e.SignatureHelp=ct;var dt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(dt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Pt;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Pt=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor($,ce,Ae){this.text=$,this.position=ce,this.kind=Ae}};xe=je([A],xe),e.InlayHint=xe;var Rt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(G){G[G.Deprecated=1]="Deprecated"})(ie=e.CompletionItemTag||(e.CompletionItemTag={}));let be=class{constructor($,ce){this.label=$,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};be=je([A],be),e.CompletionItem=be;let ze=class{constructor($=[],ce=!1){this.items=$,this.isIncomplete=ce}};ze=je([A],ze),e.CompletionList=ze;let Qe=class{constructor($,ce,Ae){this.text=$,this.range=ce,this.command=Ae}};Qe=je([A],Qe),e.InlineSuggestion=Qe;let me=class{constructor($){this.items=$}};me=je([A],me),e.InlineSuggestions=me;var Ce;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Ce=e.ViewColumn||(e.ViewColumn={}));var $e;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})($e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function $(ce){switch(ce){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=$}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor($,ce){if(ce&&!I.URI.isUri(ce))throw(0,i.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.target=ce}};ve=je([A],ve),e.DocumentLink=ve;let Re=class{constructor($,ce,Ae,Ye){this.red=$,this.green=ce,this.blue=Ae,this.alpha=Ye}};Re=je([A],Re),e.Color=Re;let Ge=class{constructor($,ce){if(ce&&!(ce instanceof Re))throw(0,i.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.color=ce}};Ge=je([A],Ge),e.ColorInformation=Ge;let We=class{constructor($){if(!$||typeof $!="string")throw(0,i.illegalArgument)("label");this.label=$}};We=je([A],We),e.ColorPresentation=We;var Xe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var st;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor($,ce,Ae){if(this.startIndex=$,this.length=ce,this.tooltip=Ae,typeof $!="number"||$<0)throw(0,i.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,i.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=ot;var fe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(fe=e.TerminalLocation||(e.TerminalLocation={}));class ke{constructor($){this.options=$,typeof $!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=ke;var ue;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=d=class{constructor($,ce){if(this.label=ce,typeof $!="string"||typeof ce!="string")throw(0,i.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Te.Clean=new d("clean","Clean"),Te.Build=new d("build","Build"),Te.Rebuild=new d("rebuild","Rebuild"),Te.Test=new d("test","Test"),Te=d=je([A],Te),e.TaskGroup=Te;function Oe(G){let $="";for(let ce=0;ce<G.length;ce++)$+=G[ce].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,ce,Ae){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=$,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=Ae):this._options=ce)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ce of this._args)$.push(ce);return Oe($)}};Ze=je([A],Ze),e.ProcessExecution=Ze;let qe=class{constructor($,ce,Ae){if(this._args=[],Array.isArray(ce)){if(!$)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$,this._args=ce,this._options=Ae}else{if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$,this._options=ce}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ce of this._args)$.push(typeof ce=="string"?ce:ce.value);return Oe($)}};qe=je([A],qe),e.ShellExecution=qe;var ht;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(ht=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class yt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=yt;let bt=m=class{constructor($,ce,Ae,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=$;let ft;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=Ae,this.execution=Ye,ft=rt,this.__deprecated=!0):ce===wt.Global||ce===wt.Workspace?(this.target=ce,this._name=this.name=Ae,this._source=this.source=Ye,this.execution=rt,ft=lt):(this.target=ce,this._name=this.name=Ae,this._source=this.source=Ye,this.execution=rt,ft=lt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ce=this._definition.type;(m.EmptyType===ce||m.ProcessType===ce||m.ShellType===ce||m.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=m=je([A],bt),e.Task=bt;var mt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,ce=_t.None){this.collapsibleState=ce,I.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=je([A],vt),e.TreeItem=vt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Ot=je([A],Ot),e.TreeDataTransferItem=Ot;let It=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,ce){this._items.set($,ce)}forEach($){this._items.forEach($)}};It=je([A],It),e.TreeDataTransfer=It;let Tt=class{constructor($,ce){this.id=$,this.color=ce}};Tt=je([A],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Lt=class{constructor($){this.id=$}};Lt=je([A],Lt),e.ThemeColor=Lt;var St;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor($,ce){if(typeof $!="string"&&(!$||!I.URI.isUri($)&&!I.URI.isUri($.uri)))throw(0,i.illegalArgument)("base");if(typeof ce!="string")throw(0,i.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=I.URI.file($),this.base=$):I.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=ce}};Mt=je([A],Mt),e.RelativePattern=Mt;let Nt=class{constructor($,ce,Ae,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof ce=="string"&&(this.condition=ce),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Nt=je([A],Nt),e.Breakpoint=Nt;let Et=class extends Nt{constructor($,ce,Ae,Ye,rt){super(ce,Ae,Ye,rt);if($===null)throw(0,i.illegalArgument)("location");this.location=$}};Et=je([A],Et),e.SourceBreakpoint=Et;let Wt=class extends Nt{constructor($,ce,Ae,Ye,rt){super(ce,Ae,Ye,rt);this.functionName=$}};Wt=je([A],Wt),e.FunctionBreakpoint=Wt;let jt=class extends Nt{constructor($,ce,Ae,Ye,rt,lt,ft){super(Ye,rt,lt,ft);if(!ce)throw(0,i.illegalArgument)("dataId");this.label=$,this.dataId=ce,this.canPersist=Ae}};jt=je([A],jt),e.DataBreakpoint=jt;let si=class{constructor($,ce,Ae){this.command=$,this.args=ce||[],this.options=Ae}};si=je([A],si),e.DebugAdapterExecutable=si;let oi=class{constructor($,ce){this.port=$,this.host=ce}};oi=je([A],oi),e.DebugAdapterServer=oi;let At=class{constructor($){this.path=$}};At=je([A],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor($){this.implementation=$}};Xt=je([A],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor($,ce){this.range=$,this.expression=ce}};ai=je([A],ai),e.EvaluatableExpression=ai;var Yt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor($,ce){this.range=$,this.text=ce}};Vt=je([A],Vt),e.InlineValueText=Vt;let pt=class{constructor($,ce,Ae=!0){this.range=$,this.variableName=ce,this.caseSensitiveLookup=Ae}};pt=je([A],pt),e.InlineValueVariableLookup=pt;let ci=class{constructor($,ce){this.range=$,this.expression=ce}};ci=je([A],ci),e.InlineValueEvaluatableExpression=ci;let Ut=class{constructor($,ce){this.frameId=$,this.stoppedLocation=ce}};Ut=je([A],Ut),e.InlineValueContext=Ut;var qt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=f=class extends Error{constructor($,ce=T.FileSystemProviderErrorCode.Unknown,Ae){super(I.URI.isUri($)?$.toString(!0):$);this.code=Ae?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}static FileExists($){return new f($,T.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound($){return new f($,T.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory($){return new f($,T.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory($){return new f($,T.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions($){return new f($,T.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable($){return new f($,T.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};Jt=f=je([A],Jt),e.FileSystemError=Jt;let li=class{constructor($,ce,Ae){this.start=$,this.end=ce,this.kind=Ae}};li=je([A],li),e.FoldingRange=li;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor($,ce=[]){this.tokenTypes=$,this.tokenModifiers=ce}}e.SemanticTokensLegend=Zt;function Si(G){return typeof G=="undefined"||(0,C.isStringArray)(G)}class Gt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ce=0,Ae=$.tokenTypes.length;ce<Ae;ce++)this._tokenTypeStrToInt.set($.tokenTypes[ce],ce);for(let ce=0,Ae=$.tokenModifiers.length;ce<Ae;ce++)this._tokenModifierStrToInt.set($.tokenModifiers[ce],ce)}}push($,ce,Ae,Ye,rt){if(typeof $=="number"&&typeof ce=="number"&&typeof Ae=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,ce,Ae,Ye,rt);if(F.isRange($)&&typeof ce=="string"&&Si(Ae))return this._push($,ce,Ae);throw(0,i.illegalArgument)()}_push($,ce,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,rt=$.start.character,lt=$.end.character-$.start.character,ft=this._tokenTypeStrToInt.get(ce);let kt=0;if(Ae)for(const Ft of Ae){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Ft);kt|=1<<xt>>>0}this._pushEncoded(Ye,rt,lt,ft,kt)}_pushEncoded($,ce,Ae,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Ft=0,xt=0;for(let $t=0;$t<kt;$t++){let Ht=this._data[5*$t],di=this._data[5*$t+1];Ht===0?(Ht=Ft,di+=xt):Ht+=Ft,this._data[5*$t]=Ht,this._data[5*$t+1]=di,Ft=Ht,xt=di}}let lt=$,ft=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=ce}static _sortAndDeltaEncode($){let ce=[];const Ae=$.length/5|0;for(let ft=0;ft<Ae;ft++)ce[ft]=ft;ce.sort((ft,kt)=>{const Ft=$[5*ft],xt=$[5*kt];if(Ft===xt){const $t=$[5*ft+1],Ht=$[5*kt+1];return $t-Ht}return Ft-xt});const Ye=new Uint32Array($.length);let rt=0,lt=0;for(let ft=0;ft<Ae;ft++){const kt=5*ce[ft],Ft=$[kt+0],xt=$[kt+1],$t=$[kt+2],Ht=$[kt+3],di=$[kt+4],$i=Ft-rt,Xi=$i===0?xt-lt:xt,hi=5*ft;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=$t,Ye[hi+3]=Ht,Ye[hi+4]=di,rt=Ft,lt=xt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),$):new Kt(Gt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Gt;class Kt{constructor($,ce){this.resultId=ce,this.data=$}}e.SemanticTokens=Kt;class _i{constructor($,ce,Ae){this.start=$,this.deleteCount=ce,this.data=Ae}}e.SemanticTokensEdit=_i;class Ci{constructor($,ce){this.resultId=ce,this.edits=$}}e.SemanticTokensEdits=Ci;var Qt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},ei=je([A],ei),e.QuickInputButtons=ei;var Di;(function(G){G[G.Separator=-1]="Separator",G[G.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,ce,Ae){this.badge=$,this.tooltip=ce,this.color=Ae}static validate($){if($.badge){let ce=(0,k.nextCharLength)($.badge,0);if(ce<$.badge.length&&(ce+=(0,k.nextCharLength)($.badge,ce)),$.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor($){this.kind=$}};ti=je([A],ti),e.ColorTheme=ti;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Be{constructor($,ce){if($<0)throw(0,i.illegalArgument)("start must be positive");if(ce<0)throw(0,i.illegalArgument)("end must be positive");$<=ce?(this._start=$,this._end=ce):(this._start=ce,this._end=$)}static isNotebookRange($){return $ instanceof Be?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ce=this._start,Ae=this._end;return $.start!==void 0&&(ce=$.start),$.end!==void 0&&(Ae=$.end),ce===this._start&&Ae===this._end?this:new Be(ce,Ae)}}e.NotebookRange=Be;class Bt{constructor($,ce,Ae,Ye,rt,lt,ft){this.kind=$,this.value=ce,this.languageId=Ae,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ft,Bt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ce=>Bt.isNotebookCellData(ce))}static isNotebookCellData($){return!0}}e.NotebookCellData=Bt;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class gt{constructor($,ce){this.data=$,this.mime=ce;const Ae=(0,P.normalizeMimeType)(ce,!0);if(!Ae)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}static isNotebookCellOutputItem($){return $ instanceof gt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const ce={name:$.name,message:$.message,stack:$.stack};return gt.json(ce,"application/vnd.code.notebook.error")}static stdout($){return gt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return gt.text($,"application/vnd.code.notebook.stderr")}static bytes($,ce="application/octet-stream"){return new gt($,ce)}static text($,ce=P.Mimes.text){const Ae=Fe(gt,w,"f",v).encode(String($));return new gt(Ae,ce)}static json($,ce="application/json"){const Ae=JSON.stringify($,void 0,"	");return gt.text(Ae,ce)}}e.NotebookCellOutputItem=gt,w=gt,v={value:new TextEncoder};class ii{constructor($,ce,Ae){this.items=ii.ensureUniqueMimeTypes($,!0),typeof ce=="string"?(this.id=ce,this.metadata=Ae):(this.id=(0,L.generateUuid)(),this.metadata=ce??Ae)}static isNotebookCellOutput($){return $ instanceof ii?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,C.isArray)($.items)}static ensureUniqueMimeTypes($,ce=!1){const Ae=new Set,Ye=new Set;for(let rt=0;rt<$.length;rt++){const lt=$[rt],ft=(0,P.normalizeMimeType)(lt.mime);if(!Ae.has(ft)){Ae.add(ft);continue}Ye.add(rt),ce&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ii;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,ce){this.text=$,this.alignment=ce}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,ce=[]){this.uri=$,this.provides=(0,g.asArray)(ce)}}e.NotebookRendererScript=Ri;let ni=class{constructor($,ce){this.label=$,this.timestamp=ce}};ni=je([A],ni),e.TimelineItem=ni;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,ce){this.ranges=$,this.wordPattern=ce}}e.LinkedEditingRanges=Oi;class Ni{constructor($,ce){this._port=$,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var se;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(se=e.TestResultState||(e.TestResultState={}));var pe;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pe=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Le=class{constructor($=void 0,ce=void 0,Ae=void 0){this.include=$,this.exclude=ce,this.profile=Ae}};Le=je([A],Le),e.TestRunRequest=Le;let ut=u=class{constructor($){this.message=$}static diff($,ce,Ae){const Ye=new u($);return Ye.expectedOutput=ce,Ye.actualOutput=Ae,Ye}};ut=u=je([A],ut),e.TestMessage=ut;let Ct=class{constructor($){this.id=$}};Ct=je([A],Ct),e.TestTag=Ct;let Dt=class{constructor($,ce){this.covered=$,this.total=ce}};Dt=je([A],Dt),e.CoveredCount=Dt;let Ui=y=class{constructor($,ce,Ae,Ye){this.uri=$,this.statementCoverage=ce,this.branchCoverage=Ae,this.functionCoverage=Ye}static fromDetails($,ce){const Ae=new Dt(0,0),Ye=new Dt(0,0),rt=new Dt(0,0);for(const ft of ce)if("branches"in ft){Ae.total+=1,Ae.covered+=ft.executionCount>0?1:0;for(const kt of ft.branches)Ye.total+=1,Ye.covered+=kt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ft.executionCount>0?1:0;const lt=new y($,Ae,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ce,lt}};Ui=y=je([A],Ui),e.FileCoverage=Ui;let Bi=class{constructor($,ce,Ae=[]){this.executionCount=$,this.location=ce,this.branches=Ae}};Bi=je([A],Bi),e.StatementCoverage=Bi;let xi=class{constructor($,ce){this.executionCount=$,this.location=ce}};xi=je([A],xi),e.BranchCoverage=xi;let Wi=class{constructor($,ce){this.executionCount=$,this.location=ce}};Wi=je([A],Wi),e.FunctionCoverage=Wi;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,ce,Ae,Ye,rt,lt){this.kind=$,this.name=ce,this.detail=Ae,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(Ee[123],Se([0,1,56,10,8,150,110,7,16]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function L(h,w){w?I.set(h,w):I.delete(h)}e.setWordDefinitionFor=L;function T(h){return I.get(h)}e.getWordDefinitionFor=T;class c extends _.MirrorTextModel{constructor(w,v,R,b,s,o,p,a){super(v,R,b,s);this._proxy=w,this._languageId=o,this._isDirty=p,this._notebook=a,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,C.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===i.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(v){return v?w._getTextInRange(v):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(v){return w._lineAt(v)},offsetAt(v){return w._offsetAt(v)},positionAt(v){return w._positionAt(v)},validateRange(v){return w._validateRange(v)},validatePosition(v){return w._validatePosition(v)},getWordRangeAtPosition(v,R){return w._getWordRangeAtPosition(v,R)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const v=this._validateRange(w);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const R=this._eol,b=v.start.line,s=v.end.line,o=[];o.push(this._lines[b].substring(v.start.character));for(let p=b+1;p<s;p++)o.push(this._lines[p]);return o.push(this._lines[s].substring(0,v.end.character)),o.join(R)}_lineAt(w){let v;if(w instanceof k.Position?v=w.line:typeof w=="number"&&(v=w),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new E(v,this._lines[v],v===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(w),R=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,R))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(w.start),R=this._validatePosition(w.end);return v===w.start&&R===w.end?w:new k.Range(v.line,v.character,R.line,R.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:v,character:R}=w,b=!1;if(v<0)v=0,R=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,R=this._lines[v].length,b=!0;else{const s=this._lines[v].length;R<0?(R=0,b=!0):R>s&&(R=s,b=!0)}return b?new k.Position(v,R):w}_getWordRangeAtPosition(w,v){const R=this._validatePosition(w);if(!v)v=T(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,P.getWordAtText)(R.character+1,(0,P.ensureValidWordDefinition)(v),this._lines[R.line],0);if(b)return new k.Range(R.line,b.startColumn-1,R.line,b.endColumn-1)}}e.ExtHostDocumentData=c;class E{constructor(w,v,R){this._line=w,this._text=v,this._isLastLine=R}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Ee[202],Se([0,1,7,3,112,6,82,24,2,33]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(c,E,h,w){this._notebook=h,this._selector=w,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(R=>{const b=this._cellUris.get(R.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=R=>{R===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(R=>v(R.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const c=[],E=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),c.push(h.document.getText().length+1),E.push(h.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(c){if(!c){let b="";for(const s of this._cells)b+=s.document.getText()+`
`;return b=b.slice(0,-1),b}if(c.isEmpty)return"";const E=this.locationAt(c.start),h=this.locationAt(c.end),w=this._cellUris.get(E.uri),v=this._cellUris.get(h.uri);if(w===void 0||v===void 0)return"";if(w===v)return this._cells[w].document.getText(new g.Range(E.range.start,h.range.end));const R=[this._cells[w].document.getText(new g.Range(E.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<v;b++)R.push(this._cells[b].document.getText());return R.push(this._cells[v].document.getText(new g.Range(new g.Position(0,0),h.range.end))),R.join(`
`)}offsetAt(c){const E=this._cellLines.getIndexOf(c.line),h=this._cellLengths.getPrefixSum(E.index-1),w=this._cells[E.index].document.offsetAt(c.with(E.remainder));return h+w}positionAt(c){if(typeof c=="number"){const h=this._cellLengths.getIndexOf(c),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const E=this._cellUris.get(c.uri);if(E!==void 0){const h=this._cellLines.getPrefixSum(E-1);return new g.Position(h+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const E=this._cellLines.getIndexOf(c.start.line);let h=E;c.isEmpty||(h=this._cellLines.getIndexOf(c.end.line));const w=new g.Position(E.remainder,c.start.character),v=new g.Position(h.remainder,c.end.character),R=new g.Range(w,v),b=this._cells[E.index];return new g.Location(b.document.uri,b.document.validateRange(R))}contains(c){return this._cellUris.has(c)}validateRange(c){const E=this.validatePosition(c.start),h=this.validatePosition(c.end);return c.with(E,h)}validatePosition(c){const E=this._cellLines.getIndexOf(c.line),h=new g.Position(E.remainder,c.character),w=this._cells[E.index].document.validatePosition(h),v=this._cellLines.getPrefixSum(E.index-1);return new g.Position(v+w.line,w.character)}}e.ExtHostNotebookConcatDocument=L}),define(Ee[203],Se([0,1,7,14,3]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(k){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let C=k==="light"?g.ColorThemeKind.Light:k==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=je([He(0,i.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(Ee[64],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class i{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=i}),define(Ee[204],Se([0,1,22]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(C){let I=this.buffers.indexOf(C);return I<0&&(I=this.buffers.length,this.buffers.push(C)),I}}function D(k,C){if(C.serializeBuffersForPostMessage){const I=new i,L=(E,h)=>{if(h instanceof ArrayBuffer){const w=I.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=_(h);if(w){const v=I.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},T=JSON.stringify(k,L),c=I.buffers.map(E=>{const h=new Uint8Array(E);return g.VSBuffer.wrap(h)});return{message:T,buffers:c}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function _(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(k,C){const I=C.map(c=>{const E=new ArrayBuffer(c.byteLength);return new Uint8Array(E).set(c.buffer),E}),L=C.length?(c,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const h=E,{index:w}=h,v=I[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(v,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return E}:void 0;return{message:JSON.parse(k,L),arrayBuffers:I}}e.deserializeWebviewMessage=P}),define(Ee[205],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(i){function D(P){const k=new Map;return P.types.forEach((C,I)=>{k.set(C,{asString:async()=>P.items[I].asString})}),k}i.toITreeDataTransfer=D;async function _(P){const k={types:[],items:[]},C=Array.from(P.entries());for(const I of C)k.types.push(I[0]),k.items.push({asString:await I[1].asString()});return k}i.toTreeDataTransferDTO=_})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[88],Se([0,1,10,2]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(k,C){return k.scheme===g.Schemas.http||k.scheme===g.Schemas.https?k:(C&&C.authority&&C.isRemote&&k.scheme===g.Schemas.file&&(k=i.URI.from({scheme:g.Schemas.vscodeRemote,authority:C.authority,path:k.path})),i.URI.from({scheme:g.Schemas.https,authority:`${k.scheme}+${_(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function _(k){return k.replace(/./g,C=>{const I=C.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?C:"-"+I.toString(16).padStart(4,"0")})}function P(k){return k.replace(/-([0-9a-f]{4})/g,(C,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=P}),define(Ee[206],Se([0,1,3,6,88]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(k,C,I){this._proxy=k,this._editors=C,this._initData=I,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const L=C.getVisibleTextEditors();for(const T of this._insets.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,C,I,L,T){let c;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===k){c=s;break}if(!c)throw new Error("not a visible editor");const E=this,h=this._handlePool++,w=new g.Emitter,v=new g.Emitter,R=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,D.asWebviewUri)(s,E._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(s){this._options=s,E._proxy.$setOptions(h,s)}get options(){return this._options}set html(s){this._html=s,E._proxy.$setHtml(h,s)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(s){return E._proxy.$postMessage(h,s)}},b=new class{constructor(){this.editor=k,this.line=C,this.height=I,this.webview=R,this.onDidDispose=v.event}dispose(){E._insets.has(h)&&(E._insets.delete(h),E._proxy.$disposeEditorInset(h),v.fire(),v.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,C+1,I,L||{},T.identifier,T.extensionLocation),this._insets.set(h,{editor:k,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(k){const C=this._insets.get(k);C&&C.inset.dispose()}$onDidReceiveMessage(k,C){const I=this._insets.get(k);I&&I.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=_}),define(Ee[207],Se([0,1,172,13,2,6,4,61,51,42,16,10]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(F,O,z){for(const W of z.visibleEditorPanes)if(W.group.id===O&&F.matches(W.input))return W.getViewState()}e.findViewStateForEditor=c;function E(F){if(p(F))return!1;const O=F;return D.URI.isUri(O?.resource)}e.isResourceEditorInput=E;function h(F){if(p(F))return!1;const O=F;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=h;function w(F){if(p(F)||h(F))return!1;const O=F;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function v(F){if(p(F))return!1;const O=F;return O?O.resource===void 0||O.resource.scheme===T.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var R;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(R=e.Verbosity||(e.Verbosity={}));var b;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var s;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends _.Disposable{}e.AbstractEditorInput=o;function p(F){return F instanceof o}e.isEditorInput=p;function a(F){const O=F;return D.URI.isUri(O?.preferredResource)}function S(F){const O=F;return p(O?.primary)&&p(O?.secondary)}e.isSideBySideEditorInput=S;function n(F){const O=F;return p(O?.modified)&&p(O?.original)}e.isDiffEditorInput=n;function t(F){return p(F?.editor)}e.isEditorInputWithOptions=t;function r(F){const O=F;return t(F)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function l(F){const O=F;return typeof O?.groupId=="number"&&p(O.editor)}e.isEditorIdentifier=l;var d;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(d=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(m=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:x}=this.getSideEditors(O);if(M&&x){if(z?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===f.ANY)return this.getOriginalUri(M,{filterByScheme:z.filterByScheme})??this.getOriginalUri(x,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===f.PRIMARY?M:x}}if(h(O)||w(O))return;const W=a(O)?O.preferredResource:O.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}getSideEditors(O){return S(O)||w(O)?{primary:O.primary,secondary:O.secondary}:n(O)||h(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:x}=this.getSideEditors(O);if(M&&x){if(z?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===f.ANY)return this.getCanonicalUri(M,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(x,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===f.PRIMARY?M:x}}if(h(O)||w(O))return;const W=O.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some(W=>O.scheme===W))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new u;var y;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(y=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(P.IInstantiationService);for(const[W,M]of this.editorSerializerConstructors)this.createEditorSerializer(W,M,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,W){const M=W.createInstance(z);this.editorSerializerInstances.set(O,M)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new A);async function N(F,O){if(!F||!F.length)return[];const z=await Promise.all(F.map(async W=>{const M=D.URI.revive(W.fileUri);if(!M||!await O.canHandleResource(M))return;let V=W.exists,U=W.type;if(typeof V!="boolean"||typeof U!="number")try{U=(await O.resolve(M)).isDirectory?I.FileType.Directory:I.FileType.Unknown,V=!0}catch{V=!1}if(!V&&W.openOnlyIfExists||U===I.FileType.Directory)return;const H={selection:V?W.selection:void 0,pinned:!0,override:W.editorOverrideId};let Y;return V?Y={resource:M,options:H}:Y={resource:M,options:H,forceUntitled:!0},Y}));return(0,L.coalesce)(z)}e.pathsToEditors=N;var B;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[124],Se([0,1,3,18,173]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,C,I,L){const T={command:k};if(C&&Object.keys(C).length>0&&(T.arguments=C),this.internalSend("request",T),typeof L=="number"){const c=setTimeout(()=>{clearTimeout(c);const E=this.pendingRequests.get(T.seq);if(E){this.pendingRequests.delete(T.seq);const h={type:"response",seq:0,request_seq:T.seq,success:!1,command:k,message:(0,D.localize)(0,null,L,k)};E(h)}},L)}return I&&this.pendingRequests.set(T.seq,I),T.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,C){return k.type!=="event"||C.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,i.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const C=k,I=this.pendingRequests.get(C.request_seq);I&&(this.pendingRequests.delete(C.request_seq),I(C));break}}}}internalSend(k,C){C.type=k,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((C,I)=>k.set(I,C)),await(0,i.timeout)(500),k.forEach((C,I)=>{C({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(Ee[208],Se([0,1,8,2,9,25,10]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function C(n,t,r){return n.replace(k,function(l,d){return t&&d.length>0&&d[0]!=="_"?l:r&&r.hasOwnProperty(d)?r[d]:l})}e.formatPII=C;function I(n){const t={};for(const r of Object.keys(n))r.startsWith("!")||(t[r]=n[r]);return t}e.filterExceptionsFromTelemetry=I;function L(n){return n.configuration.request==="attach"&&!T(n)&&(!n.parentSession||L(n.parentSession))}e.isSessionAttach=L;function T(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?T(n.parentSession):void 0}e.getExtensionHostDebugSession=T;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function E(n,t,r){let l,d=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,f=null;for(;f=m.exec(n);){let u=f.index+1,y=u+f[0].length;if(u<=t&&y>=r){l=f[0],d=u;break}}if(l){let u=/\w+/g,y=null;for(;(y=u.exec(l))&&!(y.index+1+d+y[0].length>=r););y&&(l=l.substring(0,u.lastIndex))}return l?{start:d,end:d+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(n){return!!(n&&n.match(h))}e.isUri=w;function v(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(w(n.path))return i.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return i.URI.file(n.path)}return n.path}function R(n){if(typeof n.path=="object"){const t=i.URI.revive(n.path);if(t)return t.scheme===P.Schemas.file?t.fsPath:t.toString()}return n.path}function b(n,t){const r=t?v:R,l=(0,_.deepClone)(n);return o(l,(d,m)=>{d&&m&&(m.path=r(m))}),l}e.convertToDAPaths=b;function s(n,t){const r=t?v:R,l=(0,_.deepClone)(n);return o(l,(d,m)=>{!d&&m&&(m.path=r(m))}),l}e.convertToVSCPaths=s;function o(n,t){switch(n.type){case"event":{const r=n;switch(r.event){case"output":t(!1,r.body.source);break;case"loadedSource":t(!1,r.body.source);break;case"breakpoint":t(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=n;switch(r.command){case"setBreakpoints":t(!0,r.arguments.source);break;case"breakpointLocations":t(!0,r.arguments.source);break;case"source":t(!0,r.arguments.source);break;case"gotoTargets":t(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(l=>t(!1,l));break;default:break}break}case"response":{const r=n;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(l=>t(!1,l.source));break;case"loadedSources":r.body.sources.forEach(l=>t(!1,l));break;case"scopes":r.body.scopes.forEach(l=>t(!1,l.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(l=>t(!1,l.source));break;case"setBreakpoints":r.body.breakpoints.forEach(l=>t(!1,l.source));break;default:break}break}}}function p(n){return n.filter(t=>!t.presentation?.hidden).sort((t,r)=>t.presentation?r.presentation?t.presentation.group?r.presentation.group?t.presentation.group!==r.presentation.group?t.presentation.group.localeCompare(r.presentation.group):a(t.presentation.order,r.presentation.order):-1:r.presentation.group?1:a(t.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=p;function a(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function S(n,t){const r=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(r!=="none"&&(await t.saveAll(),r==="allEditorsInActiveGroup")){const l=t.activeEditorPane;l&&await t.save({editor:l.input,groupId:l.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(Ee[209],Se([0,1,28,37,174,125,9,8,25,12,184,124]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends T.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const s=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${c.TWO_CRLF}${s}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.rawData.indexOf(c.TWO_CRLF);if(s!==-1){const p=this.rawData.toString("utf8",0,s).split(c.HEADER_LINESEPARATOR);for(const a of p){const S=a.split(c.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(s+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class E extends c{startSession(){return new Promise((b,s)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",p=>{o?this._onError.fire(p):s(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class h extends E{constructor(b){super();this.adapterServer=b}createConnection(b){return _.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class w extends E{constructor(b){super();this.adapterServer=b}createConnection(b){return _.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class v extends c{constructor(b,s,o){super();this.adapterExecutable=b,this.debugType=s,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,s=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(P.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(D.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let p=process.env;if(o.env&&Object.keys(o.env).length>0&&(p=C.mixin(C.deepClone(process.env),o.env)),b==="node")if(Array.isArray(s)&&s.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:p,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(n.cwd=o.cwd);const t=i.fork(s[0],s.slice(1),n);if(!t.pid)throw new Error(D.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const S={env:p};o.cwd&&(S.cwd=o.cwd),this.serverProcess=i.spawn(b,s,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,n)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const a=this.outputService;if(a){const S=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=a.getChannel(L.ExtensionsChannelId);t&&t.append(S(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((b,s)=>{const o=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,a,S){if(p)return s(p)});o.on("exit",b),o.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,s){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=P.join(s,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(P.isAbsolute(b.program)?o.program=b.program:o.program=P.join(s,b.program)),b.args&&(o.args=b.args);const p=b;return p.win&&(o.win=v.extract(p.win,s)),p.winx86&&(o.winx86=v.extract(p.winx86,s)),p.windows&&(o.windows=v.extract(p.windows,s)),p.osx&&(o.osx=v.extract(p.osx,s)),p.linux&&(o.linux=v.extract(p.linux,s)),o}static platformAdapterExecutable(b,s){let o=Object.create(null);s=s.toLowerCase();for(const r of b)if(r.contributes){const l=r.contributes.debuggers;l&&l.length>0&&l.filter(d=>typeof d.type=="string"&&k.equalsIgnoreCase(d.type,s)).forEach(d=>{const m=v.extract(d,r.extensionLocation.fsPath);o=C.mixin(o,m,r.isBuiltin)})}let p;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=o.winx86||o.win||o.windows:I.isWindows?p=o.win||o.windows:I.isMacintosh?p=o.osx:I.isLinux&&(p=o.linux),p=p||o;let a=p.program||o.program;const S=p.args||o.args;let n=p.runtime||o.runtime;const t=p.runtimeArgs||o.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(S||[])};if(a)return{type:"executable",command:a,args:S||[]}}}e.ExecutableDebugAdapter=v}),define(Ee[210],Se([0,1,37,12,30,186]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function P(c,E){return new Promise((h,w)=>{let v="";const R=g.spawn(c,E);R.pid&&R.stdout.on("data",b=>{v+=b.toString()}),R.on("error",b=>{w(b)}),R.on("close",b=>{h(v)})})}let k;function C(c,E){if(!k)if(i.isWindows)k=new _.WindowsExternalTerminalService;else if(i.isMacintosh)k=new _.MacExternalTerminalService;else if(i.isLinux)k=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=E.getConfiguration("terminal");return k.runInTerminal(c.title,c.cwd,c.args,c.env||{},h.external||{})}e.runInExternalTerminal=C;async function I(c){if(c)if(i.isWindows){const E=await new Promise((h,w)=>{X(["windows-process-tree"],h,w)});return new Promise(h=>{E.getProcessTree(c,w=>{h(w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(c)]).then(E=>{const h=E.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var L;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(L||(L={}));function T(c,E,h,w){c=c.trim().toLowerCase();let v;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?v=1:c.indexOf("cmd.exe")>=0?v=0:c.indexOf("bash")>=0?v=2:i.isWindows?v=0:v=2;let R,b=" ";switch(v){case 1:if(R=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,D.getDriveLetter)(h);s&&(b+=`${s}:; `),b+=`cd ${R(h)}; `}if(w)for(let s in w){const o=w[s];o===null?b+=`Remove-Item env:${s}; `:b+=`\${env:${s}}='${o}'; `}if(E.length>0){const s=R(E.shift());b+=s[0]==="'"?`& ${s} `:`${s} `;for(let o of E)b+=`${R(o)} `}break;case 0:if(R=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,D.getDriveLetter)(h);s&&(b+=`${s}: && `),b+=`cd ${R(h)} && `}if(w){b+='cmd /C "';for(let s in w){let o=w[s];o===null?b+=`set "${s}=" && `:(o=o.replace(/[\^\&\|\<\>]/g,p=>`^${p}`),b+=`set "${s}=${o}" && `)}}for(let s of E)b+=`${R(s)} `;w&&(b+='"');break;case 2:{R=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const s=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(h&&(b+=`cd ${R(h)} ; `),w){b+="/usr/bin/env";for(let o in w){const p=w[o];p===null?b+=` -u ${s(o)}`:b+=` ${s(`${o}=${p}`)}`}b+=" "}for(let o of E)b+=`${R(o)} `;break}}return b}e.prepareCommand=T}),define(Ee[126],Se([0,1,31,77,102,10,9,12,61]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(u){u[u.Markup=1]="Markup",u[u.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var T;(function(u){u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(T=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(u){u.Always="always",u.Never="never",u.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",u[u.ChangeCellMime=13]="ChangeCellMime",u[u.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata",u[u.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var R;(function(u){u.scheme=_.Schemas.vscodeNotebookCell;const y=/^ch(\d{7,})/;function A(W,M){return W.with({scheme:u.scheme,fragment:`ch${M.toString().padStart(7,"0")}${W.scheme!==_.Schemas.file?W.scheme:""}`})}u.generate=A;function N(W){if(W.scheme!==u.scheme)return;const M=y.exec(W.fragment);return M?{handle:Number(M[1]),notebook:W.with({scheme:W.fragment.substr(M[0].length)||_.Schemas.file,fragment:null})}:void 0}u.parse=N;function B(W,M,x){return W.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`ch${M.toString().padStart(7,"0")},${x??""},${W.scheme!==_.Schemas.file?W.scheme:""}`})}u.generateCellOutputUri=B;function F(W){if(W.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const M=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!M)return;const x=Number(M[1]),V=M[2]&&M[2]!==""?M[2]:void 0,U=M[3];return{handle:x,outputId:V,notebook:W.with({scheme:U||_.Schemas.file,fragment:null})}}u.parseCellOutputUri=F;function O(W,M,x){return W.with({scheme:x,fragment:`ch${M.toString().padStart(7,"0")}${W.scheme!==_.Schemas.file?W.scheme:""}`})}u.generateCellUri=O;function z(W,M){if(W.scheme!==M)return;const x=y.exec(W.fragment);return x?{handle:Number(x[1]),notebook:W.with({scheme:W.fragment.substr(x[0].length)||_.Schemas.file,fragment:null})}:void 0}u.parseCellUri=z})(R=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(u){return b.get(u)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function o(u){return b.get(u)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function p(u){return b.get(u)?.mergeable??!1}e.mimeTypeIsMergeable=p;const a=u=>k.isWindows?u.replace(/\//g,"\\"):u;class S{constructor(y=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(y)].map(N=>({pattern:N,matches:g.parse(a(N))}))}sort(y){const A=new Map(i.Iterable.map(y,B=>[B,a(B)]));let N=[];for(const{matches:B}of this.order)for(const[F,O]of A)if(B(O)){N.push(F),A.delete(F);break}return A.size&&(N=N.concat([...A.keys()].sort((B,F)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(F)))),N}prioritize(y,A){const N=this.findIndex(y);if(N===-1){this.order.unshift({pattern:y,matches:g.parse(a(y))});return}const B=new Set(A.map(O=>this.findIndex(O,N)));B.delete(-1);const F=Array.from(B).sort();this.order.splice(N+1,0,...F.map(O=>this.order[O]));for(let O=F.length-1;O>=0;O--)this.order.splice(F[O],1)}toArray(){return this.order.map(y=>y.pattern)}findIndex(y,A=this.order.length){const N=a(y);for(let B=0;B<A;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=S;function n(u,y,A,N=(B,F)=>B===F){const B=[];function F(W,M,x){if(M===0&&x.length===0)return;const V=B[B.length-1];V&&V.start+V.deleteCount===W?(V.deleteCount+=M,V.toInsert.push(...x)):B.push({start:W,deleteCount:M,toInsert:x})}let O=0,z=0;for(;;){if(O===u.length){F(O,0,y.slice(z));break}if(z===y.length){F(O,u.length-O,[]);break}const W=u[O],M=y[z];if(N(W,M)){O+=1,z+=1;continue}A(M)?(F(O,1,[]),O+=1):(F(O,0,[M]),z+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(u){u.default="default",u.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(u){const y=u;return!!((typeof y.include=="string"||g.isRelativePattern(y.include))&&(typeof y.exclude=="string"||g.isRelativePattern(y.exclude)))}e.isDocumentExcludePattern=r;function l(u,y,A){if(Array.isArray(u.viewType)&&u.viewType.indexOf(y)>=0||u.viewType===y)return!0;if(u.filenamePattern){let N=r(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,B=r(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(g.match(N,(0,P.basename)(A.fsPath).toLowerCase()))return!(B&&g.match(B,(0,P.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class d{constructor(y){this.textModel=y}getElements(){const y=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)y[A]=this.textModel.cells[A].getHashValue();return y}}e.CellSequence=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var m;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(y){return`${f._prefix}${y}`}static parse(y){if(y.startsWith(f._prefix))return y.substr(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(Ee[211],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(Ee[212],Se([0,1,4,61]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,g.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[213],Se([0,1,176,4,61]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[214],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=g;function i(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=i}),define(Ee[127],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var i;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable"})(i=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(T){T[T.Error=0]="Error",T[T.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var _;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(T,c)=>{c.expand!==void 0&&(T.expand=c.expand),c.item!==void 0&&(T.item=T.item?Object.assign(T.item,c.item):c.item)};e.applyTestItemUpdate=P;var k;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var C;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.Remove=2]="Remove",T[T.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",T[T.Retire=4]="Retire",T[T.AddTag=5]="AddTag",T[T.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(c){}update(c){}remove(c,E){}complete(){}}e.IncrementalChangeCollector=I;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const E=this.createChangeCollector();for(const h of c)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const v=this.items.get(w.parent);v.children.add(w.item.extId);const R=this.createItem(w,v);this.items.set(w.item.extId,R),E.add(R)}}else{const v=this.createItem(w);this.roots.add(v),this.items.set(w.item.extId,v),E.add(v)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],v=this.items.get(w.extId);if(!v)break;w.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,w),E.update(v);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const v=[[h[1]]];for(;v.length;)for(const R of v.pop()){const b=this.items.get(R);b&&(v.push(b.children),this.items.delete(R),E.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}E.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=L}),define(Ee[89],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(_){_.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(_){_[_.IsSame=0]="IsSame",_[_.Disconnected=1]="Disconnected",_[_.IsChild=2]="IsChild",_[_.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class D{constructor(P,k=P.length){if(this.path=P,this.viewEnd=k,P.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,k,C=P.parent){if(P.id===k)return new D([k]);let I=[P.id];for(let L=C;L&&L.id!==k;L=L.parent)I.push(L.id);return I.push(k),new D(I.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new D(P.split("\0"))}static join(P,k){return new D([...P.path,k])}static joinToString(P,k){return P.toString()+"\0"+k}static compare(P,k){return P===k?0:k.startsWith(P+"\0")?2:P.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new D(this.path,P)}compare(P){if(typeof P=="string")return D.compare(this.toString(),P);for(let k=0;k<P.viewEnd&&k<this.viewEnd;k++)if(P.path[k]!==this.path[k])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=D}),define(Ee[215],Se([0,1,9,40,13,25,12,80,177]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(T,c,E){this._contributedVariables=new Map,this._context=T,this._labelService=c,E&&(this._envVariablesPromise=E.then(h=>this.prepareEnv(h)))}prepareEnv(T){if(P.isWindows){const c=Object.create(null);return Object.keys(T).forEach(E=>{c[E.toLowerCase()]=T[E]}),c}return T}resolveWithEnvironment(T,c,E){return this.recursiveResolve(this.prepareEnv(T),c?c.uri:void 0,E)}async resolveAsync(T,c){return this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,c)}async resolveAnyBase(T,c,E,h){const w=_.deepClone(c);return P.isWindows&&w.windows?Object.keys(w.windows).forEach(v=>w[v]=w.windows[v]):P.isMacintosh&&w.osx?Object.keys(w.osx).forEach(v=>w[v]=w.osx[v]):P.isLinux&&w.linux&&Object.keys(w.linux).forEach(v=>w[v]=w.linux[v]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,w,E,h)}async resolveAnyAsync(T,c,E){return this.resolveAnyBase(T,c,E)}async resolveAnyMap(T,c,E){const h=new Map;return{newConfig:await this.resolveAnyBase(T,c,E,h),resolvedVariables:h}}resolveWithInteractionReplace(T,c,E,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,c,E,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,c){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,c)}recursiveResolve(T,c,E,h,w){if(D.isString(E))return this.resolveString(T,c,E,h,w);if(D.isArray(E))return E.map(v=>this.recursiveResolve(T,c,v,h,w));if(D.isObject(E)){let v=Object.create(null);return Object.keys(E).forEach(R=>{const b=this.resolveString(T,c,R,h,w);v[b]=this.recursiveResolve(T,c,E[R],h,w)}),v}return E}resolveString(T,c,E,h,w){return E.replace(I.VARIABLE_REGEXP,(R,b)=>{if(b.includes(I.VARIABLE_LHS))return R;let s=this.evaluateSingleVariable(T,R,b,c,h);return w&&w.set(b,s),s!==R&&D.isString(s)&&s.match(I.VARIABLE_REGEXP)&&(s=this.resolveString(T,c,s,h,w)),s})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,c,E,h,w){let v;const R=E.split(":");R.length>1&&(E=R[0],v=R[1]);const b=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,C.localize)(0,null,c))},s=()=>{const p=b();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,C.localize)(1,null,c,g.basename(p)))},o=()=>{if(v){const p=this._context.getFolderUri(v);if(p)return p;throw new Error((0,C.localize)(2,null,c,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,c)):new Error((0,C.localize)(4,null,c))};switch(E){case"env":if(v){if(T){const p=T[P.isWindows?v.toLowerCase():v];if(D.isString(p))return p}return""}throw new Error((0,C.localize)(5,null,c));case"config":if(v){const p=this._context.getConfigurationValue(h,v);if(D.isUndefinedOrNull(p))throw new Error((0,C.localize)(6,null,c,v));if(D.isObject(p))throw new Error((0,C.localize)(7,null,c,v));return p}throw new Error((0,C.localize)(8,null,c));case"command":return this.resolveFromMap(c,v,w,"command");case"input":return this.resolveFromMap(c,v,w,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return h||v?(0,k.normalizeDriveLetter)(this.fsPath(o())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(o()));case"lineNumber":{const p=this._context.getLineNumber();if(p)return p;throw new Error((0,C.localize)(9,null,c))}case"selectedText":{const p=this._context.getSelectedText();if(p)return p;throw new Error((0,C.localize)(10,null,c))}case"file":return b();case"fileWorkspaceFolder":return s();case"relativeFile":return h||v?g.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":{const p=g.dirname(b());if(h||v){const a=g.relative(this.fsPath(o()),p);return a.length===0?".":a}return p}case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":{const p=g.basename(b());return p.slice(0,p.length-g.extname(p).length)}case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":{const p=this._context.getExecPath();return p||c}case"execInstallFolder":{const p=this._context.getAppRoot();return p||c}case"pathSeparator":return g.sep;default:try{const p=v?`${E}:${v}`:E;return this.resolveFromMap(c,p,w,void 0)}catch{return c}}}}resolveFromMap(T,c,E,h){if(c&&E){const w=h===void 0?E[c]:E[h+":"+c];if(typeof w=="string")return w;throw new Error((0,C.localize)(11,null,T))}return T}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[128],Se([0,1,4,207]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var D;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var _;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var k;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function I(h){const w=h;return(0,i.isEditorInput)(w?.editor)&&(0,i.isEditorInput)(w?.replacement)}e.isEditorReplacement=I;var L;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function c(h){const w=h;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=c;function E(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Ee[216],Se([0,1,4,128]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(_){const P=_;return typeof _=="number"||(0,i.isEditorGroup)(P)}e.isPreferredGroup=D}),define(Ee[17],Se([0,1,16,22,98,291,59,25,13,2,41,84,178,117,63,126,89,216,7]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(fe){function ke(Q){const{selectionStartLineNumber:Te,selectionStartColumn:Oe,positionLineNumber:Ze,positionColumn:qe}=Q,ht=new b.Position(Te-1,Oe-1),wt=new b.Position(Ze-1,qe-1);return new b.Selection(ht,wt)}fe.to=ke;function ue(Q){const{anchor:Te,active:Oe}=Q;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}fe.from=ue})(s=e.Selection||(e.Selection={}));var o;(function(fe){function ke(Q){if(!Q)return;const{start:Te,end:Oe}=Q;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}fe.from=ke;function ue(Q){if(!Q)return;const{startLineNumber:Te,startColumn:Oe,endLineNumber:Ze,endColumn:qe}=Q;return new b.Range(Te-1,Oe-1,Ze-1,qe-1)}fe.to=ue})(o=e.Range||(e.Range={}));var p;(function(fe){function ke(ue){switch(ue){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 3:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}fe.to=ke})(p=e.TokenType||(e.TokenType={}));var a;(function(fe){function ke(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}fe.to=ke;function ue(Q){return{lineNumber:Q.line+1,column:Q.character+1}}fe.from=ue})(a=e.Position||(e.Position={}));var S;(function(fe){function ke(Te,Oe){return(0,g.coalesce)((0,g.asArray)(Te).map(Ze=>ue(Ze,Oe)))}fe.from=ke;function ue(Te,Oe){if(typeof Te=="string")return{$serialized:!0,language:Te};if(Te)return{$serialized:!0,language:Te.language,scheme:Q(Te.scheme,Oe),pattern:typeof Te.pattern=="undefined"?void 0:Z.from(Te.pattern),exclusive:Te.exclusive}}function Q(Te,Oe){return Oe&&typeof Te=="string"?Oe.transformOutgoingScheme(Te):Te}})(S=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(fe){function ke(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}fe.from=ke;function ue(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}fe.to=ue})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(fe){function ke(Q){let Te;return Q.code&&((0,C.isString)(Q.code)||(0,C.isNumber)(Q.code)?Te=String(Q.code):Te={value:String(Q.code.value),target:Q.code.target}),{...o.from(Q.range),message:Q.message,source:Q.source,code:Te,severity:l.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(r.from),tags:Array.isArray(Q.tags)?(0,g.coalesce)(Q.tags.map(n.from)):void 0}}fe.from=ke;function ue(Q){const Te=new b.Diagnostic(o.to(Q),Q.message,l.to(Q.severity));return Te.source=Q.source,Te.code=(0,C.isString)(Q.code)?Q.code:Q.code?.value,Te.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(r.to),Te.tags=Q.tags&&(0,g.coalesce)(Q.tags.map(n.to)),Te}fe.to=ue})(t=e.Diagnostic||(e.Diagnostic={}));var r;(function(fe){function ke(Q){return{...o.from(Q.location.range),message:Q.message,resource:Q.location.uri}}fe.from=ke;function ue(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,o.to(Q)),Q.message)}fe.to=ue})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(fe){function ke(Q){switch(Q){case b.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}fe.from=ke;function ue(Q){switch(Q){case E.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}fe.to=ue})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(fe){function ke(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}fe.from=ke;function ue(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}fe.to=ue})(d=e.ViewColumn||(e.ViewColumn={}));function m(fe){return typeof fe.range!="undefined"}function f(fe){return fe.length===0?!0:!!m(fe[0])}e.isDecorationOptionsArr=f;var u;(function(fe){function ke(qe){return qe.map(fe.from)}fe.fromMany=ke;function ue(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let ht;if(ue(qe)){const{language:mt,value:vt}=qe;ht={value:"```"+mt+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?ht={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?ht={value:qe}:ht={value:""};const wt=Object.create(null);ht.uris=wt;const yt=mt=>{try{let vt=I.URI.parse(mt,!0);vt=vt.with({query:Te(vt.query,wt)}),wt[mt]=vt}catch{}return""},bt=new _.Renderer;return bt.link=yt,bt.image=mt=>yt(D.parseHrefAndDimensions(mt).href),_(ht.value,{renderer:bt}),ht}fe.from=Q;function Te(qe,ht){if(!qe)return qe;let wt;try{wt=(0,P.parse)(qe)}catch{}if(!wt)return qe;let yt=!1;return wt=(0,k.cloneAndChange)(wt,bt=>{if(I.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[mt]=bt,yt=!0,mt}else return}),yt?JSON.stringify(wt):qe}function Oe(qe){const ht=new b.MarkdownString(qe.value,qe.supportThemeIcons);return ht.isTrusted=qe.isTrusted,ht.supportHtml=qe.supportHtml,ht}fe.to=Oe;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:fe.from(qe)}fe.fromStrict=Ze})(u=e.MarkdownString||(e.MarkdownString={}));function y(fe){return f(fe)?fe.map(ke=>({range:o.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?u.fromMany(ke.hoverMessage):ke.hoverMessage?u.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):fe.map(ke=>({range:o.from(ke)}))}e.fromRangeOrRangeWithMessage=y;function A(fe){return typeof fe=="undefined"?fe:typeof fe=="string"?I.URI.file(fe):fe}e.pathOrURIToURI=A;var N;(function(fe){function ke(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?A(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}fe.from=ke})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(fe){function ke(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?A(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?N.from(ue.before):void 0,after:ue.after?N.from(ue.after):void 0}}fe.from=ke})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(fe){function ke(ue){if(typeof ue=="undefined")return ue;switch(ue){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}fe.from=ke})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(fe){function ke(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?F.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?B.from(ue.light):void 0,dark:ue.dark?B.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?A(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?N.from(ue.before):void 0,after:ue.after?N.from(ue.after):void 0}}fe.from=ke})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(fe){function ke(Q){return{text:Q.newText,eol:Q.newEol&&ct.from(Q.newEol),range:o.from(Q.range)}}fe.from=ke;function ue(Q){const Te=new b.TextEdit(o.to(Q.range),Q.text);return Te.newEol=typeof Q.eol=="undefined"?void 0:ct.to(Q.eol),Te}fe.to=ue})(z=e.TextEdit||(e.TextEdit={}));var W;(function(fe){function ke(Q,Te,Oe){const Ze={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let qe of Q._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const ht=Te?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:z.from(qe.edit),modelVersionId:ht?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Oe?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ce.from)}});return Ze}fe.from=ke;function ue(Q){const Te=new b.WorkspaceEdit;for(const Oe of Q.edits)Oe.edit?Te.replace(I.URI.revive(Oe.resource),o.to(Oe.edit.range),Oe.edit.text):Te.renameFile(I.URI.revive(Oe.oldUri),I.URI.revive(Oe.newUri),Oe.options);return Te}fe.to=ue})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(fe){const ke=Object.create(null);ke[b.SymbolKind.File]=0,ke[b.SymbolKind.Module]=1,ke[b.SymbolKind.Namespace]=2,ke[b.SymbolKind.Package]=3,ke[b.SymbolKind.Class]=4,ke[b.SymbolKind.Method]=5,ke[b.SymbolKind.Property]=6,ke[b.SymbolKind.Field]=7,ke[b.SymbolKind.Constructor]=8,ke[b.SymbolKind.Enum]=9,ke[b.SymbolKind.Interface]=10,ke[b.SymbolKind.Function]=11,ke[b.SymbolKind.Variable]=12,ke[b.SymbolKind.Constant]=13,ke[b.SymbolKind.String]=14,ke[b.SymbolKind.Number]=15,ke[b.SymbolKind.Boolean]=16,ke[b.SymbolKind.Array]=17,ke[b.SymbolKind.Object]=18,ke[b.SymbolKind.Key]=19,ke[b.SymbolKind.Null]=20,ke[b.SymbolKind.EnumMember]=21,ke[b.SymbolKind.Struct]=22,ke[b.SymbolKind.Event]=23,ke[b.SymbolKind.Operator]=24,ke[b.SymbolKind.TypeParameter]=25;function ue(Te){return typeof ke[Te]=="number"?ke[Te]:6}fe.from=ue;function Q(Te){for(const Oe in ke)if(ke[Oe]===Te)return Number(Oe);return b.SymbolKind.Property}fe.to=Q})(M=e.SymbolKind||(e.SymbolKind={}));var x;(function(fe){function ke(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}fe.from=ke;function ue(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}fe.to=ue})(x=e.SymbolTag||(e.SymbolTag={}));var V;(function(fe){function ke(Q){return{name:Q.name,kind:M.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}fe.from=ke;function ue(Q){const Te=new b.SymbolInformation(Q.name,M.to(Q.kind),Q.containerName,K.to(Q.location));return Te.tags=Q.tags&&Q.tags.map(x.to),Te}fe.to=ue})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(fe){function ke(Q){const Te={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),kind:M.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Te.children=Q.children.map(ke)),Te}fe.from=ke;function ue(Q){const Te=new b.DocumentSymbol(Q.name,Q.detail,M.to(Q.kind),o.to(Q.range),o.to(Q.selectionRange));return(0,g.isNonEmptyArray)(Q.tags)&&(Te.tags=Q.tags.map(x.to)),Q.children&&(Te.children=Q.children.map(ue)),Te}fe.to=ue})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(fe){function ke(Q){const Te=new b.CallHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",I.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Te._sessionId=Q._sessionId,Te._itemId=Q._itemId,Te}fe.to=ke;function ue(Q,Te,Oe){if(Te=Te??Q._sessionId,Oe=Oe??Q._itemId,Te===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Oe,name:Q.name,detail:Q.detail,kind:M.from(Q.kind),uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}fe.from=ue})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Y;(function(fe){function ke(ue){return new b.CallHierarchyIncomingCall(H.to(ue.from),ue.fromRanges.map(Q=>o.to(Q)))}fe.to=ke})(Y=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var re;(function(fe){function ke(ue){return new b.CallHierarchyOutgoingCall(H.to(ue.to),ue.fromRanges.map(Q=>o.to(Q)))}fe.to=ke})(re=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(fe){function ke(Q){return{range:Q.range&&o.from(Q.range),uri:Q.uri}}fe.from=ke;function ue(Q){return new b.Location(I.URI.revive(Q.uri),o.to(Q.range))}fe.to=ue})(K=e.location||(e.location={}));var j;(function(fe){function ke(Q){const Te=Q,Oe=Q;return{originSelectionRange:Te.originSelectionRange?o.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Oe.uri,range:o.from(Te.targetRange?Te.targetRange:Oe.range),targetSelectionRange:Te.targetSelectionRange?o.from(Te.targetSelectionRange):void 0}}fe.from=ke;function ue(Q){return{targetUri:I.URI.revive(Q.uri),targetRange:o.to(Q.range),targetSelectionRange:Q.targetSelectionRange?o.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?o.to(Q.originSelectionRange):void 0}}fe.to=ue})(j=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(fe){function ke(Q){return{range:o.from(Q.range),contents:u.fromMany(Q.contents)}}fe.from=ke;function ue(Q){return new b.Hover(Q.contents.map(u.to),o.to(Q.range))}fe.to=ue})(te=e.Hover||(e.Hover={}));var ae;(function(fe){function ke(Q){return{range:o.from(Q.range),expression:Q.expression}}fe.from=ke;function ue(Q){return new b.EvaluatableExpression(o.to(Q.range),Q.expression)}fe.to=ue})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(fe){function ke(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:o.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}fe.from=ke;function ue(Q){switch(Q.type){case"text":return{range:o.to(Q.range),text:Q.text};case"variable":return{range:o.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:o.to(Q.range),expression:Q.expression}}}fe.to=ue})(ge=e.InlineValue||(e.InlineValue={}));var Ie;(function(fe){function ke(Q){return{frameId:Q.frameId,stoppedLocation:o.from(Q.stoppedLocation)}}fe.from=ke;function ue(Q){return new b.InlineValueContext(Q.frameId,o.to(Q.stoppedLocation))}fe.to=ue})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(fe){function ke(Q){return{range:o.from(Q.range),kind:Q.kind}}fe.from=ke;function ue(Q){return new b.DocumentHighlight(o.to(Q.range),Q.kind)}fe.to=ue})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var Ne;(function(fe){function ke(ue){switch(ue){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}fe.to=ke})(Ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(fe){function ke(ue){return{triggerKind:Ne.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}fe.to=ke})(q=e.CompletionContext||(e.CompletionContext={}));var J;(function(fe){function ke(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}fe.from=ke;function ue(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}fe.to=ue})(J=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(fe){const ke=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ue(Oe){return ke.get(Oe)??9}fe.from=ue;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Te(Oe){return Q.get(Oe)??b.CompletionItemKind.Property}fe.to=Te})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var he;(function(fe){function ke(ue,Q){const Te=new b.CompletionItem(ue.label);return Te.insertText=ue.insertText,Te.kind=ne.to(ue.kind),Te.tags=ue.tags?.map(J.to),Te.detail=ue.detail,Te.documentation=D.isMarkdownString(ue.documentation)?u.to(ue.documentation):ue.documentation,Te.sortText=ue.sortText,Te.filterText=ue.filterText,Te.preselect=ue.preselect,Te.commitCharacters=ue.commitCharacters,L.Range.isIRange(ue.range)?Te.range=o.to(ue.range):typeof ue.range=="object"&&(Te.range={inserting:o.to(ue.range.insert),replacing:o.to(ue.range.replace)}),Te.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Te.insertText=new b.SnippetString(ue.insertText):(Te.insertText=ue.insertText,Te.textEdit=Te.range instanceof b.Range?new b.TextEdit(Te.range,Te.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Te.additionalTextEdits=ue.additionalTextEdits.map(Oe=>z.to(Oe))),Te.command=Q&&ue.command?Q.fromInternal(ue.command):void 0,Te}fe.to=ke})(he=e.CompletionItem||(e.CompletionItem={}));var ee;(function(fe){function ke(Q){return{label:Q.label,documentation:Q.documentation?u.fromStrict(Q.documentation):void 0}}fe.from=ke;function ue(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?u.to(Q.documentation):Q.documentation}}fe.to=ue})(ee=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(fe){function ke(Q){return{label:Q.label,documentation:Q.documentation?u.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ee.from):[],activeParameter:Q.activeParameter}}fe.from=ke;function ue(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?u.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ee.to):[],activeParameter:Q.activeParameter}}fe.to=ue})(oe=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(fe){function ke(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(oe.from):[]}}fe.from=ke;function ue(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(oe.to):[]}}fe.to=ue})(_e=e.SignatureHelp||(e.SignatureHelp={}));var Ue;(function(fe){function ke(Q){return{text:Q.text,position:a.from(Q.position),kind:Ve.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}fe.from=ke;function ue(Q){const Te=new b.InlayHint(Q.text,a.to(Q.position),Ve.to(Q.kind));return Te.whitespaceAfter=Q.whitespaceAfter,Te.whitespaceBefore=Q.whitespaceBefore,Te}fe.to=ue})(Ue=e.InlayHint||(e.InlayHint={}));var Ve;(function(fe){function ke(Q){return Q}fe.from=ke;function ue(Q){return Q}fe.to=ue})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(fe){function ke(Q){return{range:o.from(Q.range),url:Q.target,tooltip:Q.tooltip}}fe.from=ke;function ue(Q){let Te;if(Q.url)try{Te=typeof Q.url=="string"?I.URI.parse(Q.url,!0):I.URI.revive(Q.url)}catch{}return new b.DocumentLink(o.to(Q.range),Te)}fe.to=ue})(Ke=e.DocumentLink||(e.DocumentLink={}));var Je;(function(fe){function ke(Q){const Te=new b.ColorPresentation(Q.label);return Q.textEdit&&(Te.textEdit=z.to(Q.textEdit)),Q.additionalTextEdits&&(Te.additionalTextEdits=Q.additionalTextEdits.map(Oe=>z.to(Oe))),Te}fe.to=ke;function ue(Q){return{label:Q.label,textEdit:Q.textEdit?z.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Te=>z.from(Te)):void 0}}fe.from=ue})(Je=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(fe){function ke(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}fe.to=ke;function ue(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}fe.from=ue})(it=e.Color||(e.Color={}));var at;(function(fe){function ke(Q){return{range:o.from(Q.range)}}fe.from=ke;function ue(Q){return new b.SelectionRange(o.to(Q.range))}fe.to=ue})(at=e.SelectionRange||(e.SelectionRange={}));var et;(function(fe){function ke(ue){switch(ue){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}fe.to=ke})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(fe){function ke(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}fe.from=ke;function ue(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}fe.to=ue})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(fe){function ke(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}fe.from=ke;function ue(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}fe.to=ue})(ct=e.EndOfLine||(e.EndOfLine={}));var dt;(function(fe){function ke(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}fe.from=ke})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(fe){function ke(ue){const Q={start:ue.start+1,end:ue.end+1};return ue.kind&&(Q.kind=xe.from(ue.kind)),Q}fe.from=ke})(Pt=e.FoldingRange||(e.FoldingRange={}));var xe;(function(fe){function ke(ue){if(ue)switch(ue){case b.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}fe.from=ke})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(fe){function ke(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?o.from(ue.selection):void 0,override:typeof ue.override=="boolean"?c.EditorResolution.DISABLED:void 0}}fe.from=ke})(Rt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Z;(function(fe){function ke(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:ue(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}fe.from=ke;function ue(Q){const Te=Q;return Te&&typeof Te.base=="string"&&typeof Te.pattern=="string"}})(Z=e.GlobPattern||(e.GlobPattern={}));var ie;(function(fe){function ke(ue){if(ue){if(Array.isArray(ue))return ue.map(ke);if(typeof ue=="string")return ue;{const Q=ue;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Z.from(Q.pattern),exclusive:Q.exclusive}}}else return}fe.from=ke})(ie=e.LanguageSelector||(e.LanguageSelector={}));var be;(function(fe){function ke(Q){return{start:Q.start,end:Q.end}}fe.from=ke;function ue(Q){return new b.NotebookRange(Q.start,Q.end)}fe.to=ue})(be=e.NotebookRange||(e.NotebookRange={}));var ze;(function(fe){function ke(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}fe.to=ke;function ue(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}fe.from=ue})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Qe;(function(fe){function ke(Q){switch(Q){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}fe.from=ke;function ue(Q){switch(Q){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}fe.to=ue})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var me;(function(fe){function ke(Q){const Te={metadata:Q.metadata??Object.create(null),cells:[]};for(let Oe of Q.cells)b.NotebookCellData.validate(Oe),Te.cells.push(Ce.from(Oe));return Te}fe.from=ke;function ue(Q){const Te=new b.NotebookData(Q.cells.map(Ce.to));return(0,C.isEmptyObject)(Q.metadata)||(Te.metadata=Q.metadata),Te}fe.to=ue})(me=e.NotebookData||(e.NotebookData={}));var Ce;(function(fe){function ke(Q){return{cellKind:Qe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ze.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Pe.from):[]}}fe.from=ke;function ue(Q){return new b.NotebookCellData(Qe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Pe.to):void 0,Q.metadata,Q.internalMetadata?ze.to(Q.internalMetadata):void 0)}fe.to=ue})(Ce=e.NotebookCellData||(e.NotebookCellData={}));var $e;(function(fe){function ke(Q){return{mime:Q.mime,valueBytes:i.VSBuffer.wrap(Q.data)}}fe.from=ke;function ue(Q){return new b.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}fe.to=ue})($e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(fe){function ke(Q){return{outputId:Q.id,items:Q.items.map($e.from),metadata:Q.metadata}}fe.from=ke;function ue(Q){const Te=Q.items.map($e.to);return new b.NotebookCellOutput(Te,Q.outputId,Q.metadata)}fe.to=ue})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(fe){function ke(Oe){if(Oe!=null){if(Oe instanceof b.RelativePattern||typeof Oe=="string")return Oe;if(Te(Oe))return new b.RelativePattern(Oe.base,Oe.pattern);if(Q(Oe))return{include:Z.from(Oe.include)||void 0,exclude:Z.from(Oe.exclude)||void 0}}}fe.from=ke;function ue(Oe){return typeof Oe=="string"?Oe:Te(Oe)?{base:Oe.base,pattern:Oe.pattern}:{include:Oe.include,exclude:Oe.exclude}}fe.to=ue;function Q(Oe){const Ze=Oe,qe=Z.from(Ze.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const ht=Z.from(Ze.exclude);return!!(ht&&ht instanceof b.RelativePattern||typeof ht=="string")}function Te(Oe){const Ze=Oe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(fe){function ke(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?N.from(ue.top):void 0}}fe.from=ke})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var le;(function(fe){function ke(ue,Q,Te){const Oe=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Oe,Te),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}fe.from=ke})(le=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(fe){function ke(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{}}}fe.from=ke})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(fe){function ke(Q){return{uri:Q.uri,provides:Q.provides}}fe.from=ke;function ue(Q){return new b.NotebookRendererScript(I.URI.revive(Q.uri),Q.provides)}fe.to=ue})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ve;(function(fe){function ke(Q){return{message:u.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}fe.from=ke;function ue(Q){const Te=new b.TestMessage(typeof Q.message=="string"?Q.message:u.to(Q.message));return Te.actualOutput=Q.actual,Te.expectedOutput=Q.expected,Te.location=Q.location?K.to(Q.location):void 0,Te}fe.to=ue})(ve=e.TestMessage||(e.TestMessage={}));var Re;(function(fe){let ke;(function(ue){ue.Delimiter="\0"})(ke||(ke={})),fe.namespace=(ue,Q)=>ue+"\0"+Q,fe.denamespace=ue=>{const Q=ue.indexOf("\0");return{ctrlId:ue.slice(0,Q),tagId:ue.slice(Q+1)}}})(Re=e.TestTag||(e.TestTag={}));var Ge;(function(fe){function ke(Oe){const Ze=(0,h.getPrivateApiFor)(Oe).controllerId;return{extId:v.TestId.fromExtHostTestItem(Oe,Ze).toString(),label:Oe.label,uri:Oe.uri,tags:Oe.tags.map(qe=>Re.namespace(Ze,qe.id)),range:o.from(Oe.range)||null,description:Oe.description||null,error:Oe.error&&u.fromStrict(Oe.error)||null}}fe.from=ke;function ue(Oe){return{parent:void 0,error:void 0,id:v.TestId.fromString(Oe.extId).localId,label:Oe.label,uri:I.URI.revive(Oe.uri),tags:(Oe.tags||[]).map(Ze=>{const{tagId:qe}=Re.denamespace(Ze);return new b.TestTag(qe)}),range:o.to(Oe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Oe.description||void 0}}fe.toPlain=ue;function Q(Oe){const Ze=v.TestId.fromString(Oe.extId),qe=new h.TestItemImpl(Ze.controllerId,Ze.localId,Oe.label,I.URI.revive(Oe.uri));return qe.range=o.to(Oe.range||void 0),qe.description=Oe.description||void 0,qe}function Te(Oe){let Ze;for(const qe of Oe.tests){const ht=Q(qe.item);(0,h.getPrivateApiFor)(ht).parent=Ze,Ze=ht}return Ze}fe.toItemFromContext=Te})(Ge=e.TestItem||(e.TestItem={})),function(fe){function ke(Q){return{id:Q.id}}fe.from=ke;function ue(Q){return new b.TestTag(Q.id)}fe.to=ue}(Re=e.TestTag||(e.TestTag={}));var We;(function(fe){const ke=(Q,Te)=>{const Oe={...Ge.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(ve.to)})),children:Q.children.map(Ze=>Te.get(Ze)).filter(C.isDefined).map(Ze=>ke(Ze,Te))};for(const Ze of Oe.children)Ze.parent=Oe;return Oe};function ue(Q){const Te=[],Oe=new Map;for(const Ze of Q.items)Oe.set(Ze.item.extId,Ze),Q.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&Te.push(Ze);return{completedAt:Q.completedAt,results:Te.map(Ze=>ke(Ze,Oe))}}fe.to=ue})(We=e.TestResults||(e.TestResults={}));var Xe;(function(fe){function ke(Oe){return{covered:Oe.covered,total:Oe.covered}}function ue(Oe){return"line"in Oe?a.from(Oe):o.from(Oe)}function Q(Oe){return"branches"in Oe?{count:Oe.executionCount,location:ue(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ue(Ze.location)})):void 0}:{type:0,count:Oe.executionCount,location:ue(Oe.location)}}fe.fromDetailed=Q;function Te(Oe){return{uri:Oe.uri,statement:ke(Oe.statementCoverage),branch:Oe.branchCoverage&&ke(Oe.branchCoverage),function:Oe.functionCoverage&&ke(Oe.functionCoverage),details:Oe.detailedCoverage?.map(Q)}}fe.fromFile=Te})(Xe=e.TestCoverage||(e.TestCoverage={}));var st;(function(fe){function ke(ue){switch(ue){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}fe.to=ke})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(fe){function ke(Q){const Te=new b.TypeHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",I.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Te._sessionId=Q._sessionId,Te._itemId=Q._itemId,Te}fe.to=ke;function ue(Q,Te,Oe){if(Te=Te??Q._sessionId,Oe=Oe??Q._itemId,Te===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Oe,kind:M.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}fe.from=ue})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[217],Se([0,1,2,15,7,17,94]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(I,L,T,c={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=T,this._thresholds=c,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,T,c)=>{const h={dispose:this._callbacks.push([L,T,I])};return Array.isArray(c)&&c.push(h),h}}async $participateInSave(I,L){const T=g.URI.revive(I);let c=!1;const E=setTimeout(()=>c=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(c)break;const v=this._documents.getDocument(T),R=await this._deliverEventAsyncAndBlameBadListeners(w,{document:v,reason:_.TextDocumentSaveReason.to(L)});h.push(R)}}finally{clearTimeout(E)}return h}_deliverEventAsyncAndBlameBadListeners([I,L,T],c){const E=this._badListeners.get(I);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,I,L,c).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(I);this._badListeners.set(I,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,T,c){const E=[],h=Date.now(),{document:w,reason:v}=c,{version:R}=w,b=Object.freeze({document:w,reason:v,waitUntil(s){if(Object.isFrozen(E))throw(0,i.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(s))}});try{L.apply(T,[b])}catch(s){return Promise.reject(s)}return Object.freeze(E),new Promise((s,o)=>{const p=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(p),s(a)}).catch(a=>{clearTimeout(p),o(a)})}).then(s=>{const o={edits:[]};for(const p of s)if(Array.isArray(p)&&p.every(a=>a instanceof D.TextEdit))for(const{newText:a,newEol:S,range:n}of p)o.edits.push({_type:2,resource:w.uri,edit:{range:n&&_.Range.from(n),text:a,eol:S&&_.EndOfLine.from(S)}});if(o.edits.length!==0)return R===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(Ee[218],Se([0,1,3,31,2,17,7]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(L,T,c,E,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),E&&(this._config+=2),h&&(this._config+=4);const w=(0,i.parse)(T),v=L(R=>{if(!c)for(let b of R.created){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidCreate.fire(s)}if(!E)for(let b of R.changed){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidChange.fire(s)}if(!h)for(let b of R.deleted){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(L,T,c){this._logService=T,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(L,T,c,E){return new k(this._onFileSystemEvent.event,L,T,c,E)}$onFileEvent(L){this._onFileSystemEvent.fire(L)}$onDidRunFileOperation(L,T){switch(L){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(c=>({oldUri:D.URI.revive(c.source),newUri:D.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(c=>D.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:T.map(c=>D.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(L){return this._createWillExecuteEvent(L,this._onWillRenameFile)}getOnWillCreateFileEvent(L){return this._createWillExecuteEvent(L,this._onWillCreateFile)}getOnWillDeleteFileEvent(L){return this._createWillExecuteEvent(L,this._onWillDeleteFile)}_createWillExecuteEvent(L,T){return(c,E,h)=>{const w=function(R){c.call(E,R)};return w.extension=L,T.event(w,void 0,h)}}async $onWillRunFileOperation(L,T,c,E){switch(L){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(h=>({oldUri:D.URI.revive(h.source),newUri:D.URI.revive(h.target)}))},c,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(h=>D.URI.revive(h.target))},c,E);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(h=>D.URI.revive(h.target))},c,E)}}async _fireWillEvent(L,T,c,E){const h=new Set,w=[];if(await L.fireAsync(T,E,async(R,b)=>{const s=Date.now(),o=await Promise.resolve(R);o instanceof P.WorkspaceEdit&&(w.push(o),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-s>c&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),E.isCancellationRequested||w.length===0)return;const v={edits:[]};for(let R of w){let{edits:b}=_.WorkspaceEdit.from(R,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(b)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=C}),define(Ee[219],Se([0,1,10,25,2,17,7,126]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(c,E,h,w){this.start=c,this.deletedCount=E,this.deletedItems=h,this.items=w}static asApiEvents(c){return c.map(E=>({start:E.start,deletedCount:E.deletedCount,deletedItems:E.deletedItems,items:E.items.map(h=>h.apiCell)}))}}class I{constructor(c,E,h){this.notebook=c,this._extHostDocument=E,this._cellData=h,this.handle=h.handle,this.uri=D.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(c,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return c._mime},set mime(h){c._mime=h},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(_.NotebookCellOutput.to)}setOutputItems(c,E,h){const w=h.map(_.NotebookCellOutputItem.to),v=this._outputs.find(R=>R.id===c);v&&(E||(v.items.length=0),v.items.push(...w))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=I;class L{constructor(c,E,h,w,v,R){this._proxy=c,this._textDocumentsAndEditors=E,this._textDocuments=h,this._emitter=w,this.uri=v,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=R.viewType,this._metadata=Object.freeze(R.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,R.cells]],!0),this._versionId=R.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(E){return E=c._validateIndex(E),c._cells[E].apiCell},getCells(E){return(E?c._getCells(E):c._cells).map(w=>w.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,E){this._versionId=c.versionId,this._isDirty=E;for(const h of c.rawEvents)h.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===k.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let E=c.start|0,h=c.end|0;return E<0&&(E=0),h>this._cells.length&&(h=this._cells.length),c.with({start:E,end:h})}_getCells(c){c=this._validateRange(c);const E=[];for(let h=c.start;h<c.end;h++)E.push(this._cells[h]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,E){if(this._disposed)return;const h=[],w=[],v=[];c.reverse().forEach(R=>{const s=R[2].map(a=>{const S=new I(this,this._textDocumentsAndEditors,a);return E||w.push(I.asModelAddData(this.apiNotebook,a)),S}),o=new C(R[0],R[1],[],s),p=this._cells.splice(R[0],R[1],...s);for(const a of p)v.push(a.uri),o.deletedItems.push(a.apiCell);h.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:v}),E||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(h)}))}_moveCell(c,E){const h=this._cells.splice(c,1);this._cells.splice(E,0,...h);const w=[new C(c,1,h.map(v=>v.apiCell),[]),new C(E,0,[],h)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(w)}))}_setCellOutputs(c,E){const h=this._cells[c];h.setOutputs(E),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(c,E,h,w){const v=this._cells[c];v.setOutputItems(E,h,w),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(c,E){const h=this._cells[c];h.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelModeChanged(h.uri,E)}_changeCellMime(c,E){const h=this._cells[c];h.apiCell.mime=E}_changeCellMetadata(c,E){const h=this._cells[c],w=h.apiCell.metadata;h.setMetadata(E);const v=h.apiCell.metadata;(0,i.equals)(w,v)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(c,E){const h=this._cells[c],w=h.internalMetadata;if(h.setInternalMetadata(E),w.runState!==E.runState){const v=E.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:v}))}}getCellFromApiCell(c){return this._cells.find(E=>E.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(E=>E.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(Ee[129],Se([0,1,7,17,15]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:I})}replaceCells(C,I,L){this._throwIfFinalized(),!(C===I&&L.length===0)&&this._collectedEdits.push({editType:1,index:C,count:I-C,cells:L.map(i.NotebookCellData.from)})}}class P{constructor(C,I,L,T,c,E){this.id=C,this._proxy=I,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=T,this._viewColumn=E}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(I){if(!Array.isArray(I)||!I.every(g.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");C._selections=I,C._trySetSelections(I)},get visibleRanges(){return C._visibleRanges},revealRange(I,L){C._proxy.$tryRevealRange(C.id,i.NotebookRange.from(I),L??g.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(I){const L=new _(this.document.version);return I(L),C._applyEdit(L.finalize())},setDecorations(I,L){return C.setDecorations(I,L)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(i.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const I=[];let L=-1;for(let T=0;T<C.cellEdits.length;T++){if(L<0){I.push(C.cellEdits[T]),L++;continue}const E=I[L],h=C.cellEdits[T];if(E.editType===1&&h.editType===1&&E.index===h.index){E.cells.push(...C.cellEdits[T].cells),E.count+=C.cellEdits[T].count;continue}I.push(C.cellEdits[T]),L++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,I)}setDecorations(C,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return I.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(I),C.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(Ee[220],Se([0,1,17,118,165,21,57,15]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,E,h){const w=this._handles++,{title:v,location:R,cancellable:b}=E,s={label:(0,D.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(R),title:v,source:s,cancellable:b},c).catch(k.onUnexpectedExternalError),this._withProgress(w,h,!!b)}_withProgress(c,E,h){let w;h&&(w=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,w));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let R;try{R=E(new L(this._proxy,c),h&&w?w.token:_.CancellationToken.None)}catch(b){throw v(c),b}return R.then(b=>v(c),b=>v(c)),R}$acceptProgressCanceled(c){const E=this._mapHandleToCancellationSource.get(c);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=C;function I(T,c){return T.message=c.message,typeof c.increment=="number"&&(typeof T.increment=="number"?T.increment+=c.increment:T.increment=c.increment),T}class L extends i.Progress{constructor(c,E){super(h=>this.throttledReport(h));this._proxy=c,this._handle=E}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}je([(0,P.throttle)(100,(T,c)=>I(T,c),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ee[130],Se([0,1,56,15,76,17,7]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(c,E,h){const w=k._Keys.nextId();c.$registerTextEditorDecorationType(E.identifier,w,_.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){c.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class C{constructor(c,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,E){this._throwIfFinalized();let h=null;if(c instanceof P.Position)h=new P.Range(c,c);else if(c instanceof P.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,E,!1)}insert(c,E){this._throwIfFinalized(),this._pushEdit(new P.Range(c,c),E,!0)}delete(c){this._throwIfFinalized();let E=null;if(c instanceof P.Range)E=c;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(c,E,h){const w=this._document.validateRange(c);this._collectedEdits.push({range:w,text:E,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==P.EndOfLine.LF&&c!==P.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=C;class I{constructor(c,E,h,w){this._proxy=c,this._id=E,this._accept(h),this._logService=w;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(R){v._setTabSize(R)},get insertSpaces(){return v._insertSpaces},set insertSpaces(R){v._setInsertSpaces(R)},get cursorStyle(){return v._cursorStyle},set cursorStyle(R){v._setCursorStyle(R)},get lineNumbers(){return v._lineNumbers},set lineNumbers(R){v._setLineNumbers(R)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const E=Math.floor(c);return E>0?E:null}if(typeof c=="string"){const E=parseInt(c,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(c){const E=this._validateTabSize(c);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const E=this._validateInsertSpaces(c);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(c)})))}assign(c){const E={};let h=!1;if(typeof c.tabSize!="undefined"){const w=this._validateTabSize(c.tabSize);w==="auto"?(h=!0,E.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,E.tabSize=w)}if(typeof c.insertSpaces!="undefined"){const w=this._validateInsertSpaces(c.insertSpaces);w==="auto"?(h=!0,E.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,E.insertSpaces=w)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,E.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,E.lineNumbers=_.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(c,E){E.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=I;class L{constructor(c,E,h,w,v,R,b,s){this.id=c,this._proxy=E,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new I(this._proxy,this.id,R,h),this._visibleRanges=b,this._viewColumn=s;const o=this;this.value=Object.freeze({get document(){return w.getValue()},set document(p){throw(0,i.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(p){if(!(p instanceof P.Selection))throw(0,i.illegalArgument)("selection");o._selections=[p],o._trySetSelection()},get selections(){return o._selections},set selections(p){if(!Array.isArray(p)||p.some(a=>!(a instanceof P.Selection)))throw(0,i.illegalArgument)("selections");o._selections=p,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(p){throw(0,i.readonly)("visibleRanges")},get options(){return o._options.value},set options(p){o._disposed||o._options.assign(p)},get viewColumn(){return o._viewColumn},set viewColumn(p){throw(0,i.readonly)("viewColumn")},edit(p,a={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new C(w.getValue(),a);return p(S),o._applyEdit(S)},insertSnippet(p,a,S={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!a||Array.isArray(a)&&a.length===0)n=o._selections.map(t=>_.Range.from(t));else if(a instanceof P.Position){const{lineNumber:t,column:r}=_.Position.from(a);n=[{startLineNumber:t,startColumn:r,endLineNumber:t,endColumn:r}]}else if(a instanceof P.Range)n=[_.Range.from(a)];else{n=[];for(const t of a)if(t instanceof P.Range)n.push(_.Range.from(t));else{const{lineNumber:r,column:l}=_.Position.from(t);n.push({startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l})}}return E.$tryInsertSnippet(c,p.value,n,S)},setDecorations(p,a){const S=a.length===0;S&&!o._hasDecorationsForKey.has(p.key)||(S?o._hasDecorationsForKey.delete(p.key):o._hasDecorationsForKey.add(p.key),o._runOnProxy(()=>{if(_.isDecorationOptionsArr(a))return E.$trySetDecorations(c,p.key,_.fromRangeOrRangeWithMessage(a));{const n=new Array(4*a.length);for(let t=0,r=a.length;t<r;t++){const l=a[t];n[4*t]=l.start.line+1,n[4*t+1]=l.start.character+1,n[4*t+2]=l.end.line+1,n[4*t+3]=l.end.character+1}return E.$trySetDecorationsFast(c,p.key,n)}}))},revealRange(p,a){o._runOnProxy(()=>E.$tryRevealRange(c,_.Range.from(p),a||P.TextEditorRevealType.Default))},show(p){E.$tryShowEditor(c,_.ViewColumn.from(p))},hide(){E.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const E=c.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const h=E.edits.map(v=>v.range);h.sort((v,R)=>v.end.line===R.end.line?v.end.character===R.end.character?v.start.line===R.start.line?v.start.character-R.start.character:v.start.line-R.start.line:v.end.character-R.end.character:v.end.line-R.end.line);for(let v=0,R=h.length-1;v<R;v++){const b=h[v].end;if(h[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=E.edits.map(v=>({range:_.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,w,{setEndOfLine:typeof E.setEndOfLine=="number"?_.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=L}),define(Ee[221],Se([0,1,168,23,2,3,6,18,7,13,16,17,21,205]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(R,b){if((0,I.isString)(R))return{label:R};if(R&&typeof R=="object"&&typeof R.label=="string"){let s;return Array.isArray(R.highlights)&&(s=R.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),s=s.length?s:void 0),{label:R.label,highlights:s}}}class w{constructor(b,s,o){this._proxy=b,this.commands=s,this.logService=o,this.treeViews=new Map;function p(a){return a&&a.$treeViewId&&a.$treeItemHandle}s.registerArgumentProcessor({processArgument:a=>p(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(S=>p(S)?this.convertArgument(S):S):a})}registerTreeDataProvider(b,s,o){const p=this.createTreeView(b,{treeDataProvider:s},o);return{dispose:()=>p.dispose()}}createTreeView(b,s,o){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const p=s.dragAndDropController?.supportedMimeTypes,a=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:p}),S=this.createExtHostTreeView(b,s,o);return{get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get message(){return S.message},set message(n){S.message=n},get title(){return S.title},set title(n){S.title=n},get description(){return S.description},set description(n){S.description=n},reveal:(n,t)=>S.reveal(n,t),dispose:async()=>{await a,this.treeViews.delete(b),S.dispose()}}}$getChildren(b,s){const o=this.treeViews.get(b);return o?o.getChildren(s):Promise.reject(new Error((0,g.localize)(0,null,b)))}async $onDrop(b,s,o,p,a){const S=this.treeViews.get(b);if(!S)return Promise.reject(new Error((0,g.localize)(1,null,b)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(s);if(p===b&&a){const t=await S.onWillDrop(a);t&&t.forEach((r,l)=>{r&&n.set(l,r)})}return S.onDrop(n,o)}async $hasResolve(b){const s=this.treeViews.get(b);if(!s)throw new Error((0,g.localize)(2,null,b));return s.hasResolve}$resolve(b,s,o){const p=this.treeViews.get(b);if(!p)throw new Error((0,g.localize)(3,null,b));return p.resolveTreeItem(s,o)}$setExpanded(b,s,o){const p=this.treeViews.get(b);if(!p)throw new Error((0,g.localize)(4,null,b));p.setExpanded(s,o)}$setSelection(b,s){const o=this.treeViews.get(b);if(!o)throw new Error((0,g.localize)(5,null,b));o.setSelection(s)}$setVisible(b,s){const o=this.treeViews.get(b);if(!o)throw new Error((0,g.localize)(6,null,b));o.setVisible(s)}createExtHostTreeView(b,s,o){const p=new v(b,s,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(b,p),p}convertArgument(b){const s=this.treeViews.get(b.$treeViewId);return s?s.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=w;class v extends P.Disposable{constructor(b,s,o,p,a,S){super();if(this.viewId=b,this.proxy=o,this.commands=p,this.logService=a,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,S.contributes&&S.contributes.views)for(const r in S.contributes.views)for(const l of S.contributes.views[r])l.id===b&&(this._title=l.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,t;this._register(_.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(d=>t=d),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(l.element)?r.elements.push(...l.element):r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=t;return n=null,this.refresh(l).then(()=>d())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,I.isUndefinedOrNull)(b))}async getChildren(b){const s=b?this.getExtensionElement(b):void 0;if(b&&!s)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(b);return o||(o=await this.fetchChildrenNodes(s)),o?o.map(p=>p.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,s){s=s||{select:!0,focus:!1};const o=(0,I.isUndefinedOrNull)(s.select)?!0:s.select,p=(0,I.isUndefinedOrNull)(s.focus)?!1:s.focus,a=(0,I.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(S=>this.resolveTreeNode(b,S[S.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:S.map(t=>t.item)},{select:o,focus:p,expand:a})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:p,expand:a})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,s){const o=this.getExtensionElement(b);o&&(s?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(b){(0,L.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(b){const s=[];for(const o of b){const p=this.getExtensionElement(o);p&&s.push(p)}if(!(!this.dndController?.onWillDrop||s.length===0))return this.dndController.onWillDrop(s)}async onDrop(b,s){const o=this.getExtensionElement(s);if(!!o)return(0,k.asPromise)(()=>this.dndController?.onDrop(b,o))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,s){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(b);if(o){const p=this.nodes.get(o);if(p){const a=await this.dataProvider.resolveTreeItem(p.extensionItem,o,s)??p.extensionItem;return p.item.tooltip=this.getTooltip(a.tooltip),p.item.command=this.getCommand(p.disposableStore,a.command),p.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(s=>s?this.resolveUnknownParentChain(s).then(o=>this.resolveTreeNode(s,o[o.length-1]).then(p=>(o.push(p),o))):Promise.resolve([]))}resolveParent(b){const s=this.nodes.get(b);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,s){const o=this.nodes.get(b);return o?Promise.resolve(o):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(p=>this.createHandle(b,p,s,!0)).then(p=>this.getChildren(s?s.item.handle:void 0).then(()=>{const a=this.getExtensionElement(p);if(a){const S=this.nodes.get(a);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${p}`)}))}getChildrenNodes(b){if(b){let s;if(typeof b=="string"){const o=this.getExtensionElement(b);s=o?this.nodes.get(o):void 0}else s=b;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const s=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=b?this.nodes.get(b):void 0,p=await this.dataProvider.getChildren(b);if(s.token.isCancellationRequested)return;const a=await Promise.all((0,L.coalesce)(p||[]).map(async S=>{const n=await this.dataProvider.getTreeItem(S);return n&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(S,n,o):null}));return s.token.isCancellationRequested?void 0:(0,L.coalesce)(a)}finally{s.dispose()}}refresh(b){if(b.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(b);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const s=new Set,o=b.map(a=>this.nodes.get(a));for(const a of o)if(a&&!s.has(a.item.handle)){let S=a;for(;S&&S.parent&&o.findIndex(n=>S&&S.parent&&n&&n.item.handle===S.parent.item.handle)===-1;){const n=this.elements.get(S.parent.item.handle);S=n?this.nodes.get(n):void 0}S&&!S.parent&&s.add(a.item.handle)}const p=[];return s.forEach(a=>{const S=this.elements.get(a);if(S){const n=this.nodes.get(S);n&&(!n.parent||!s.has(n.parent.item.handle))&&p.push(a)}}),p}refreshHandles(b){const s={};return Promise.all(b.map(o=>this.refreshNode(o).then(p=>{p&&(s[o]=p.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(b){const s=this.getExtensionElement(b);if(s){const o=this.nodes.get(s);if(o)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(p=>{if(p){const a=this.createTreeNode(s,p,o.parent);return this.updateNodeCache(s,a,o,o.parent),o.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,s,o){const p=this.createTreeNode(b,s,o);if(s.id&&this.elements.has(p.item.handle))throw new Error((0,g.localize)(7,null,s.id));return this.addNodeToCache(b,p),this.addNodeToParentCache(p,o),p}getTooltip(b){return C.MarkdownString.isMarkdownString(b)?T.MarkdownString.from(b):b}getCommand(b,s){return s?this.commands.toInternal(s,b):void 0}createTreeNode(b,s,o){const p=new P.DisposableStore,a=this.createHandle(b,s,o),S=this.getLightIconPath(s);return{item:{handle:a,parentHandle:o?o.item.handle:void 0,label:h(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(p,s.command),contextValue:s.contextValue,icon:S,iconDark:this.getDarkIconPath(s)||S,themeIcon:this.getThemeIcon(s),collapsibleState:(0,I.isUndefinedOrNull)(s.collapsibleState)?C.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:o,children:void 0,disposableStore:p,dispose(){p.dispose()}}}getThemeIcon(b){return b.iconPath instanceof C.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:s,label:o,resourceUri:p},a,S){if(s)return`${v.ID_HANDLE_PREFIX}/${s}`;const n=h(o,this.extension),t=a?a.item.handle:v.LABEL_HANDLE_PREFIX;let r=n?n.label:p?(0,i.basename)(p):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,d=this.getChildrenNodes(a)||[];let m,f=0;do{if(m=`${t}/${f}:${r}`,S||!this.elements.has(m)||l===m)break;f++}while(f<=d.length);return m}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof C.ThemeIcon))return typeof b.iconPath=="string"||D.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof C.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return D.URI.isUri(b)?b:D.URI.file(b)}addNodeToCache(b,s){this.elements.set(s.item.handle,b),this.nodes.set(b,s)}updateNodeCache(b,s,o,p){this.elements.delete(s.item.handle),this.nodes.delete(b),s.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(b,s);const a=this.getChildrenNodes(p)||[],S=a.filter(n=>n.item.handle===o.item.handle)[0];S&&a.splice(a.indexOf(S),1,s)}addNodeToParentCache(b,s){s?(s.children||(s.children=[]),s.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const s=this.nodes.get(b);if(s){if(s.children)for(const o of s.children){const p=this.elements.get(o.item.handle);p&&this.clear(p)}s.children=void 0}}else this.clearAll()}clear(b){const s=this.nodes.get(b);if(s){if(s.children)for(const o of s.children){const p=this.elements.get(o.item.handle);p&&this.clear(p)}this.nodes.delete(b),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ee[222],Se([0,1,18,3,6,13,63,17,127,89]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends D.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const E=this.diff[this.diff.length-1];if(E&&c[0]===1){if(E[0]===1&&E[1].extId===c[1].extId){(0,C.applyTestItemUpdate)(E[1],c[1]);return}if(E[0]===0&&E[1].item.extId===c[1].extId){(0,C.applyTestItemUpdate)(E[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,E){const h=this.tree.get(c);if(!!h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,E-1):w.wait().then(()=>this.expandChildren(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,E-1)):this.expandChildren(h,E-1)}}dispose(){for(const c of this.tree.values())(0,P.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,E){switch(E.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(c.fullId,E.id));break;case 0:this.upsertItem(E.item,c);break;case 4:for(const h of E.ops)this.onTestItemEvent(c,h);break;case 3:{const{key:h,value:w,previous:v}=E,R=c.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(w,v,R);break;case"range":this.pushDiff([1,{extId:R,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:R,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:R,item:{[h]:w??null}}]);break}break}default:(0,_.assertNever)(E)}}upsertItem(c,E){if(!(c instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const h=I.TestId.fromExtHostTestItem(c,this.root.id,E?.actual),w=(0,P.getPrivateApiFor)(c);w.parent&&w.parent!==E?.actual&&w.parent.children.delete(c.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:c,parent:E?h.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(c,E),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:k.TestItem.from(c)}]),this.connectItemAndChildren(c,v,E);return}if(v.actual===c){this.connectItem(c,v,E);return}const R=v.actual.children,b=v.actual,s=(0,P.diffTestItems)(b,c);(0,P.getPrivateApiFor)(b).listener=void 0,v.actual=c,v.expand=0;for(const[o,p]of s)this.onTestItemEvent(v,{op:3,key:o,value:p,previous:b[o]});this.connectItemAndChildren(c,v,E);for(const o of R)c.children.get(o.id)||this.removeItem(I.TestId.joinToString(h,o.id))}diffTagRefs(c,E,h){const w=new Set(E.map(v=>v.id));for(const v of c)w.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:h,item:{tags:c.map(v=>k.TestTag.namespace(this.controllerId,v.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const E=this.tags.get(c.id);E?E.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const E=this.tags.get(c);E&&!--E.refCount&&(this.tags.delete(c),this.pushDiff([6,k.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,E){(0,P.getPrivateApiFor)(c).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(c,E,h){this.setItemParent(c,h);const w=(0,P.getPrivateApiFor)(c);w.parent=h?.actual,w.listener=v=>this.onTestItemEvent(E,v),this.updateExpandability(E)}connectItemAndChildren(c,E,h){this.connectItem(c,E,h);for(const w of c.children)this.upsertItem(w,E)}updateExpandability(c){let E;this._resolveHandler?c.resolveBarrier?E=c.resolveBarrier.isOpen()?3:2:E=c.actual.canResolveChildren?1:0:E=0,E!==c.expand&&(c.expand=E,this.pushDiff([1,{extId:c.fullId.toString(),expand:E}]),E===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,E){if(E<0)return;const h=[];for(const w of c.actual.children){const v=this.expand(I.TestId.joinToString(c.fullId,w.id),E);(0,g.isThenable)(v)&&h.push(v)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const v=new g.Barrier;return v.open(),v}c.expand=2,this.pushExpandStateUpdate(c);const E=c.resolveBarrier=new g.Barrier,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=v.stack||v.message||String(v))};let w;try{w=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(v){h(v)}return(0,g.isThenable)(w)?w.catch(h).then(()=>{E.open(),this.updateExpandability(c)}):(E.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const E=this.tree.get(c);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const h=[E];for(;h.length;){const w=h.pop();if(!!w){(0,P.getPrivateApiFor)(w.actual).listener=void 0;for(const v of w.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(w.fullId.toString());for(const v of w.actual.children)h.push(this.tree.get(I.TestId.joinToString(w.fullId,v.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=L}),define(Ee[223],Se([0,1,4,183]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(i.IEnvironmentService)}),define(Ee[224],Se([0,1,27,3,9]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=_;class P{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let T of L.activationEvents)T==="onUri"&&(T=`onUri:${g.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(L)}}keepOnly(L){const T=new Set;L.forEach(c=>T.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>T.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,T){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const c=P._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(c.map(E=>E.identifier)),T.length>0){const E=new Set;T.forEach(h=>E.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!E.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(c)}static _findLoopingExtensions(L){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,R){this.addNode(v),this.addNode(R),this._arcs.has(v)?this._arcs.get(v).push(R):this._arcs.set(v,[R])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,R){const b=T.getArcs(v);for(let s=0;s<b.length;s++)if(!R.has(b[s]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let v of L){const R=g.ExtensionIdentifier.toKey(v.identifier);if(c.set(R,v),v.extensionDependencies)for(let b of v.extensionDependencies){const s=g.ExtensionIdentifier.toKey(b);T.addArc(R,s)}}let E=new Set;T.getNodes().filter(v=>T.getArcs(v).length===0).forEach(v=>E.add(v));let h=T.getNodes().filter(v=>!E.has(v)),w;do{w=!1;for(let v=0;v<h.length;v++){const R=h[v];T.hasOnlyGoodArcs(R,E)&&(h.splice(v,1),v--,E.add(R),w=!0)}}while(w);return h.map(v=>c.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const T=this._activationMap.get(L);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const T=this._extensionsMap.get(g.ExtensionIdentifier.toKey(L));return T||void 0}}e.ExtensionDescriptionRegistry=P;var k;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(k||(k={}));function C(I,L){const T=I.isBuiltin?0:I.isUnderDevelopment?2:1,c=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(T!==c)return T-c;const E=D.posix.basename(I.extensionLocation.path),h=D.posix.basename(L.extensionLocation.path);return E<h?-1:E>h?1:0}}),define(Ee[225],Se([0,1,22]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var i;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(i=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function _(k){const C=g.VSBuffer.alloc(1);switch(k){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=_;function P(k,C){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=P}),define(Ee[29],Se([0,1,3,2,4,27,194]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var k;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class I{constructor(p){this.dependency=p}}e.MissingExtensionDependency=I;var L;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=T;function c(o,p){return o.enabledApiProposals?o.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=c;function E(o,p){if(!c(o,p))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=E;class h{constructor(p,a,S,n){this.codeLoadingTime=p,this.activateCallTime=a,this.activateResolvedTime=S,this.activationReason=n}}e.ActivationTimes=h;class w{constructor(p,a){this.description=p,this.value=a}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var v;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function R(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=R;function b(o,p){return{identifier:new _.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!p,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class s{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(p){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(p,a){return Promise.resolve()}_onWillActivateExtension(p){}_onDidActivateExtension(p,a,S,n,t){}_onDidActivateExtensionError(p,a){}_onExtensionRuntimeError(p,a){}_onExtensionHostExit(p){}}e.NullExtensionService=s}),define(Ee[226],Se([0,1,15,27,29,11]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class k{constructor(w,v,R,b){this.startup=w,this.codeLoadingTime=v,this.activateCallTime=R,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class C{constructor(w){this._startup=w,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(w,v){return w===-1||v===-1?-1:v-w}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class I{constructor(w,v,R,b,s,o){this.activationFailed=w,this.activationFailedError=v,this.activationTimes=R,this.module=b,this.exports=s,this.subscriptions=o}}e.ActivatedExtension=I;class L extends I{constructor(w){super(!1,null,w,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class T extends I{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=T;class c extends I{constructor(w){super(!0,w,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let E=class{constructor(w,v,R,b,s){this._logService=s,this._isDisposed=!1,this._registry=w,this._resolvedExtensionsSet=new Set,v.forEach(o=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,R.forEach(o=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(o),o)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(w){const v=i.ExtensionIdentifier.toKey(w);return this._activatedExtensions.has(v)}getActivatedExtension(w){const v=i.ExtensionIdentifier.toKey(w),R=this._activatedExtensions.get(v);if(!R)throw new Error("Extension `"+w.value+"` is not known or not activated");return R}activateByEvent(w,v){if(this._alreadyActivatedEvents[w])return P;const R=this._registry.getExtensionDescriptionsForActivationEvent(w);return this._activateExtensions(R.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:w}}))).then(()=>{this._alreadyActivatedEvents[w]=!0})}activateById(w,v){const R=this._registry.getExtensionDescription(w);if(!R)throw new Error("Extension `"+w+"` is not known");return this._activateExtensions([{id:R.identifier,reason:v}])}_handleActivateRequest(w,v,R){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(w.id))){v[i.ExtensionIdentifier.toKey(w.id)]=w;return}const b=this._registry.getExtensionDescription(w.id);if(!b){const p=new Error(`Cannot activate unknown extension '${w.id.value}'`);this._host.onExtensionActivationError(w.id,p,new D.MissingExtensionDependency(w.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(w.id),new c(p));return}const s=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let o=!0;for(let p=0,a=s.length;p<a;p++){const S=s[p];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(S)))continue;const n=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(S));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const d=b.displayName||b.identifier.value,m=this._registry.getExtensionDescription(S),f=m&&m.displayName||S,u=new Error(`Cannot activate the '${d}' extension because its dependency '${f}' failed to activate`);u.detail=n.activationFailedError,this._host.onExtensionActivationError(b.identifier,u,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(b.identifier),new c(u));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(S))){o=!1,v[i.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(S)),reason:w.reason};continue}const t=this._registry.getExtensionDescription(S);if(t){if(!t.main&&!t.browser)continue;o=!1,v[i.ExtensionIdentifier.toKey(S)]={id:t.identifier,reason:w.reason};continue}const r=b.displayName||b.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(b.identifier,l,new D.MissingExtensionDependency(S)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(b.identifier),new c(l));return}o?v[i.ExtensionIdentifier.toKey(b.identifier)]=w:R.push(w)}_activateExtensions(w){if(w.length===0||(w=w.filter(s=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(s.id))),w.length===0))return Promise.resolve(void 0);const v=Object.create(null),R=[];for(let s=0,o=w.length;s<o;s++)this._handleActivateRequest(w[s],v,R);for(let s=0,o=R.length;s<o;s++){const p=i.ExtensionIdentifier.toKey(R[s].id);v[p]&&delete v[p]}const b=Object.keys(v).map(s=>v[s]);return R.length===0?Promise.all(b.map(s=>this._activateExtension(s.id,s.reason))).then(s=>{}):this._activateExtensions(b).then(s=>this._activateExtensions(R))}_activateExtension(w,v){const R=i.ExtensionIdentifier.toKey(w);if(this._activatedExtensions.has(R))return Promise.resolve(void 0);const b=this._activatingExtensions.get(R);if(b)return b;const s=this._host.actualActivateExtension(w,v).then(void 0,o=>{const p=new Error;return o&&o.name&&(p.name=o.name),o&&o.message?p.message=`Activating extension '${w.value}' failed: ${o.message}.`:p.message=`Activating extension '${w.value}' failed: ${o}.`,o&&o.stack&&(p.stack=o.stack),this._isDisposed&&g.isPromiseCanceledError(o)?new c(o):(this._host.onExtensionActivationError(w,p,null),this._logService.error(`Activating extension ${w.value} failed due to an error:`),this._logService.error(o),new c(o))}).then(o=>{this._activatedExtensions.set(R,o),this._activatingExtensions.delete(R)});return this._activatingExtensions.set(R,s),s}};E=je([He(4,_.ILogService)],E),e.ExtensionsActivator=E}),define(Ee[227],Se([0,1,11,26,29]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends g.LogService{constructor(k,C){super(k.createLogger(C.logFile,{name:D.ExtensionHostLogFileName}))}};_=je([He(0,g.ILoggerService),He(1,i.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(Ee[228],Se([0,1,15]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,P)=>{this._actualOk=_,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,g.onUnexpectedError)(_))}then(_,P){return this._ensureActual().then(_,P)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=i}),define(Ee[53],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(I,L){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=L,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const i=[];function D(C){const I=new g(!0,C);return i[I.nid]=I,I}e.createMainContextProxyIdentifier=D;function _(C){const I=new g(!1,C);return i[I.nid]=I,I}e.createExtHostContextProxyIdentifier=_;function P(C){return i[C].sid}e.getStringIdentifierForProxy=P;class k{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=k}),define(Ee[5],Se([0,1,59,2,53]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var P;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(s){s.name="$ident";function o(a,S){return Object.defineProperty(a,s.name,{value:S,enumerable:!0}),a}s.mixin=o;function p(a){return a[s.name]}s.of=p})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(o){return o._id=E._n++,o}}e.IdObject=E,E._n=0;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function R(s){if(s&&s.edits)for(const o of s.edits)typeof o.resource=="object"?o.resource=i.URI.revive(o.resource):(o.newUri=i.URI.revive(o.newUri),o.oldUri=i.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,g.revive)(o.metadata));return s}e.reviveWorkspaceEditDto=R;var b;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[90],Se([0,1,5,3,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(k){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,C){return this._proxy.$getPassword(k,C)}store(k,C,I){return this._proxy.$setPassword(k,C,I)}delete(k,C){return this._proxy.$deletePassword(k,C)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Ee[65],Se([0,1,4,11,5,14]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(C,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(D.MainContext.MainThreadTelemetry)}report(C,I,L){const T=this.getUsageKey(C,I);this._reportedUsages.has(T)||(this._reportedUsages.add(T),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:C}))}getUsageKey(C,I){return`${C}-${I.identifier.value}`}};P=je([He(0,_.IExtHostRpcService),He(1,i.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(k,C,I){}})}),define(Ee[229],Se([0,1,3,5,7,27]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,I,L,T={}){const c=_.ExtensionIdentifier.toKey(C.identifier),E=this._inFlightRequests.get(c)||[],h=[...L].sort().join(" ");let w=E.find(v=>v.scopes===h);if(w)return w.result;{const v=this._getSession(C,c,I,L,T);w={scopes:h,result:v},E.push(w),this._inFlightRequests.set(c,E);try{await v}finally{const R=E.findIndex(b=>b.scopes===h);R>-1&&(E.splice(R),this._inFlightRequests.set(c,E))}return v}}async _getSession(C,I,L,T,c={}){await this._proxy.$ensureProvider(L);const E=C.displayName||C.name;return this._proxy.$getSession(L,T,I,E,c)}async removeSession(C,I){const L=this._authenticationProviders.get(C);return L?L.provider.removeSession(I):this._proxy.$removeSession(C,I)}registerAuthenticationProvider(C,I,L,T){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:I,provider:L,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===C)||this._providers.push({id:C,label:I});const c=L.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(C,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,I,T?.supportsMultipleAccounts??!1),new D.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(C);const E=this._providers.findIndex(h=>h.id===C);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,I){const L=this._authenticationProviders.get(C);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,I){const L=this._authenticationProviders.get(C);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,I){const L=this._authenticationProviders.get(C);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,I){return this._onDidChangeSessions.fire({provider:{id:C,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(Ee[230],Se([0,1,5,14,17]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(k,C){this._extHostDocumentsAndEditors=C,this._proxy=k.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const C=D.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};_=je([He(0,i.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(Ee[231],Se([0,1,5]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(_){const P=_.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(k){return P.$writeText(k)}})}}e.ExtHostClipboard=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[38],Se([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,63,22,53,50]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(l,d){o.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,tt(this,o,l.getProxy(P.MainContext.MainThreadCommands),"f"),this._logService=d,this.converter=new a(this,m=>{const f=this._apiCommands.get(m);return f?.result===n.Void?f:void 0},d),this._argumentProcessors=[{processArgument(m){return(0,I.revive)(m)}},{processArgument(m){return(0,_.cloneAndChange)(m,function(f){if(L.Range.isIRange(f))return D.Range.to(f);if(T.Position.isIPosition(f))return D.Position.to(f);if(L.Range.isIRange(f.range)&&c.URI.isUri(f.uri))return D.location.to(f);if(f instanceof R.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const d=this.registerCommand(!1,l.id,async(...m)=>{const f=l.args.map((y,A)=>{if(!y.validate(m[A]))throw new Error(`Invalid argument '${y.name}' when running '${l.id}', received: ${m[A]}`);return y.convert(m[A])}),u=await this.executeCommand(l.internalId,...f);return l.result.convert(u,m,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new i.Disposable(()=>{d.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,d,m,f,u,y){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:m,thisArg:f,description:u,extension:y}),l&&Fe(this,o,"f").$registerCommand(d),new i.Disposable(()=>{this._commands.delete(d)&&l&&Fe(this,o,"f").$unregisterCommand(d)})}executeCommand(l,...d){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,d,!0)}async _doExecuteCommand(l,d,m){if(this._commands.has(l))return this._executeContributedCommand(l,d,!1);{let f=!1;const u=(0,_.cloneAndChange)(d,function(y){if(y instanceof i.Position)return D.Position.from(y);if(y instanceof i.Range)return D.Range.from(y);if(y instanceof i.Location)return D.location.from(y);if(i.NotebookRange.isNotebookRange(y))return D.NotebookRange.from(y);if(y instanceof ArrayBuffer)return f=!0,R.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return f=!0,R.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await Fe(this,o,"f").$executeCommand(l,f?new b.SerializableObjectWithBuffers(u):u,m);return(0,I.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(l,d,!1);throw y}}}async _executeContributedCommand(l,d,m){const f=this._commands.get(l);if(!f)throw new Error("Unknown command");let{callback:u,thisArg:y,description:A}=f;if(A)for(let N=0;N<A.args.length;N++)try{(0,g.validateConstraint)(d[N],A.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${A.args[N].name}' - ${A.args[N].description}`)}try{return await u.apply(y,d)}catch(N){if(l===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...d);B&&(l=B.command)}throw this._logService.error(N,l,f.extension?.identifier),m?new class extends Error{constructor(){super((0,s.toErrorMessage)(N));this.id=l,this.source=f.extension?.displayName??f.extension?.name}}:N}}$executeContributedCommand(l,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(d=d.map(m=>this._argumentProcessors.reduce((f,u)=>u.processArgument(f),m)),this._executeContributedCommand(l,d,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),Fe(this,o,"f").$getCommands().then(d=>(l&&(d=d.filter(m=>m[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[d,m]of this._commands){let{description:f}=m;f&&(l[d]=f)}return Promise.resolve(l)}};o=new WeakMap,p=je([He(0,w.IExtHostRpcService),He(1,C.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class a{constructor(l,d,m){this._commands=l,this._lookupApiCommand=d,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,d){if(!l)return;const m={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return m;const f=this._lookupApiCommand(l.command);if(f)m.id=f.internalId,m.arguments=f.args.map((u,y)=>u.convert(l.arguments&&l.arguments[y]));else if((0,k.isNonEmptyArray)(l.arguments)){const u=++this._cachIdPool;this._cache.set(u,l),d.add((0,E.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),m.$ident=u,m.id=this.delegatingCommandId,m.arguments=[u],this._logService.trace("CommandsConverter#CREATE",l.command,u)}return m}fromInternal(l){const d=P.ObjectIdentifier.of(l);return typeof d=="number"?this._cache.get(d):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const d=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class S{constructor(l,d,m,f){this.name=l,this.description=d,this.validate=m,this.convert=f}optional(){return new S(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,d){return new S(l??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",r=>c.URI.isUri(r),r=>r),S.Position=new S("position","A position in a text document",r=>i.Position.isPosition(r),D.Position.from),S.Range=new S("range","A range in a text document",r=>i.Range.isRange(r),D.Range.from),S.Selection=new S("selection","A selection in a text document",r=>i.Selection.isSelection(r),D.Selection.from),S.Number=new S("number","",r=>typeof r=="number",r=>r),S.String=new S("string","",r=>typeof r=="string",r=>r),S.CallHierarchyItem=new S("item","A call hierarchy item",r=>r instanceof i.CallHierarchyItem,D.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",r=>r instanceof i.TypeHierarchyItem,D.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,D.TestItem.from);class n{constructor(l,d){this.description=l,this.convert=d}}e.ApiCommandResult=n,n.Void=new n("no result",r=>r);class t{constructor(l,d,m,f,u){this.id=l,this.internalId=d,this.description=m,this.args=f,this.result=u}}e.ApiCommand=t}),define(Ee[232],Se([0,1,17,7,84,38,16,111]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(g.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,E)=>{if((0,P.isFalsyOrEmpty)(c))return;class h extends i.SymbolInformation{static to(v){const R=new h(v.name,g.SymbolKind.to(v.kind),v.containerName||"",new i.Location(E[0],g.Range.to(v.range)));return R.detail=v.detail,R.range=R.location.range,R.selectionRange=g.Range.to(v.selectionRange),R.children=v.children?v.children.map(h.to):[],R}}return c.map(h.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(g.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(g.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(g.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(g.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(g.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(E=>i.Position.isPosition(E)),c=>c.map(g.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(E=>{let h;for(const w of E.reverse())h=new i.SelectionRange(g.Range.to(w),h);return h}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(g.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:g.Range.to(c.range),placeholder:c.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const E=(0,k.decodeSemanticTokensDto)(c);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const E=(0,k.decodeSemanticTokensDto)(c);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,E,h)=>{if(!c)return new i.CompletionList([]);const w=c.suggestions.map(v=>g.CompletionItem.to(v,h));return new i.CompletionList(w,c.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,E,h)=>L(w=>new i.CodeLens(g.Range.to(w.range),w.command&&h.fromInternal(w.command)))(c))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>i.Range.isRange(c),c=>i.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,E,h)=>L(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const v=new i.CodeAction(w.title,w.kind?new i.CodeActionKind(w.kind):void 0);return w.edit&&(v.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(v.command=h.fromInternal(w.command)),v.isPreferred=w.isPreferred,v}})(c))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(E=>new i.ColorInformation(g.Range.to(E.range),g.Color.to(E.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",c=>c instanceof i.Color,g.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(E=>g.NotebookExclusiveDocumentPattern.to(E))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void)];class I{static register(E){C.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=I;function L(c){return E=>{if(Array.isArray(E))return E.map(c)}}function T(c){if(!Array.isArray(c))return;const E=[];for(const h of c)D.isLocationLink(h)?E.push(g.DefinitionLink.to(h)):E.push(g.location.to(h));return E}}),define(Ee[233],Se([0,1,18,57,3,6,2,84,27,17,7,5]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(E,h,w){const v=E.getProxy(T.MainContext.MainThreadComments);class R{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const r=this._commentControllers.get(t.handle);return r||t}else if(t&&t.$mid===7){const r=this._commentControllers.get(t.commentControlHandle);if(!r)return t;const l=r.getCommentThread(t.commentThreadHandle);return l||t}else if(t&&t.$mid===8){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const l=r.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l,text:t.text}:t}else if(t&&t.$mid===9){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const l=r.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let d=t.commentUniqueId,m=l.getCommentByUniqueId(d);return m||t}else if(t&&t.$mid===10){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const l=r.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let d=t.text,m=t.commentUniqueId,f=l.getCommentByUniqueId(m);return f?(f.body=d,f):t}return t}})}createCommentController(t,r,l){const d=R.handlePool++,m=new s(t,d,r,l);this._commentControllers.set(m.handle,m);const f=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(t.identifier))||[];return f.push(m),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(t.identifier),f),m.value}$createCommentThreadTemplate(t,r,l){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(r,l)}async $updateCommentThreadTemplate(t,r,l){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(r,l)}$deleteCommentThread(t,r){const l=this._commentControllers.get(t);l&&l.$deleteCommentThread(r)}$provideCommentingRanges(t,r,l){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(P.URI.revive(r));return(0,g.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(m,l)).then(f=>f?f.map(u=>I.Range.from(u)):void 0)}$toggleReaction(t,r,l,d,m){const f=this._commentControllers.get(t);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const u=f.getCommentThread(r);if(u){const y=u.getCommentByUniqueId(d.uniqueIdInThread);if(f!==void 0&&y&&f.reactionHandler)return f.reactionHandler(y,a(m))}return Promise.resolve(void 0)})}dispose(){}}R.handlePool=0;class b{constructor(t,r,l,d,m,f,u){this._commentControllerHandle=r,this._id=l,this._uri=d,this._range=m,this._comments=f,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),v.$createCommentThread(r,this.handle,this._id,this._uri,I.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(r,this.handle)}});const y=this;this.value={get uri(){return y.uri},get range(){return y.range},set range(A){y.range=A},get comments(){return y.comments},set comments(A){y.comments=A},get collapsibleState(){return y.collapsibleState},set collapsibleState(A){y.collapsibleState=A},get canReply(){return y.canReply},set canReply(A){y.canReply=A},get contextValue(){return y.contextValue},set contextValue(A){y.contextValue=A},get label(){return y.label},set label(A){y.label=A},dispose:()=>{y.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),r={};t("range")&&(r.range=I.Range.from(this._range)),t("label")&&(r.label=this.label),t("contextValue")&&(r.contextValue=this.contextValue??null),t("comments")&&(r.comments=this._comments.map(l=>o(this,l,this._commentsMap))),t("collapsibleState")&&(r.collapseState=S(this._collapseState)),t("canReply")&&(r.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(t){for(let r of this._commentsMap){let l=r[0],d=r[1];if(t===d)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,je([(0,i.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,r,l,d){this._extension=t,this._handle=r,this._id=l,this._label=d,this._threads=new Map,v.$registerCommentController(this.handle,l,d);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(f){m.options=f},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(f){m.commentingRangeProvider=f},get reactionHandler(){return m.reactionHandler},set reactionHandler(f){m.reactionHandler=f},createCommentThread(f,u,y){return m.createCommentThread(f,u,y).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,r,l,d){if(typeof t=="string"){const m=new b(this.id,this.handle,t,r,l,d,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new b(this.id,this.handle,void 0,t,r,l,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,r){const l=new b(this.id,this.handle,void 0,P.URI.revive(t),I.Range.to(r),[],this._extension.identifier);return l.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,r){let l=this._threads.get(t);l&&(l.range=I.Range.to(r))}$deleteCommentThread(t){let r=this._threads.get(t);r&&r.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function o(n,t,r){let l=r.get(t);l||(l=++n.commentHandle,r.set(t,l));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:I.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>p(m)):void 0}}function p(n){return{label:n.label,iconPath:n.iconPath?I.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function a(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?P.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function S(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new R}e.createExtHostComments=c}),define(Ee[131],Se([0,1,2,5,7,4,14,11,16,8,9]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class bi{constructor(E,h){this._logService=h,this._provider=new Map,this._proxy=E.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,h){const w=bi._handlePool++;this._provider.set(w,{provider:E,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const v=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(R=>{if(!R){this._proxy.$onDidChange(w,null);return}let b=(0,C.asArray)(R);if(b.length<=bi._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const s=b.map(a=>({uri:a,rank:(0,I.count)(a.path,"/")})),o=(0,C.groupBy)(s,(a,S)=>a.rank-S.rank||(0,I.compare)(a.uri.path,S.uri.path));let p=[];e:for(let a of o){let S;for(let n of a){let t=(0,L.dirname)(n.uri.path);if(S!==t&&(S=t,p.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(w,p)});return new D.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(E,h,w){if(!this._provider.has(E))return Object.create(null);const v=Object.create(null),{provider:R,extensionId:b}=this._provider.get(E);return await Promise.all(h.map(async s=>{try{const{uri:o,id:p}=s,a=await Promise.resolve(R.provideFileDecoration(g.URI.revive(o),w));if(!a)return;try{D.FileDecoration.validate(a),v[p]=[a.propagate,a.tooltip,a.badge,a.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${b.value}': ${S}`)}}catch(o){this._logService.error(o)}})),v}};T._handlePool=0,T._maxEventSize=250,T=je([He(0,P.IExtHostRpcService),He(1,k.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[234],Se([0,1,163,117,2,5,7,17,3,11,24,44]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";var c,E,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(b,s,o,p,a,S){this._name=b,this._owner=s,this._maxDiagnosticsPerFile=o,c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,tt(this,h,new L.ResourceMap(n=>p.getComparisonKey(n)),"f"),tt(this,c,a,"f"),tt(this,E,S,"f")}dispose(){this._isDisposed||(Fe(this,E,"f").fire([...Fe(this,h,"f").keys()]),Fe(this,c,"f")&&Fe(this,c,"f").$clear(this._owner),Fe(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,s){if(!b){this.clear();return}this._checkDisposed();let o=[];if(D.URI.isUri(b)){if(!s){this.delete(b);return}Fe(this,h,"f").set(b,s.slice()),o=[b]}else if(Array.isArray(b)){o=[];let a;b=[...b].sort(w._compareIndexedTuplesByUri);for(const S of b){const[n,t]=S;if((!a||n.toString()!==a.toString())&&(a&&Fe(this,h,"f").get(a).length===0&&Fe(this,h,"f").delete(a),a=n,o.push(n),Fe(this,h,"f").set(n,[])),t){const r=Fe(this,h,"f").get(n);r&&r.push(...t)}else{const r=Fe(this,h,"f").get(n);r&&(r.length=0)}}}if(Fe(this,E,"f").fire(o),!Fe(this,c,"f"))return;const p=[];for(let a of o){let S=[];const n=Fe(this,h,"f").get(a);if(n)if(n.length>this._maxDiagnosticsPerFile){S=[];const t=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let l of n)if(l.severity===t[r]&&S.push(k.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;S.push({severity:i.MarkerSeverity.Info,message:(0,g.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=n.map(t=>k.Diagnostic.from(t));p.push([a,S])}Fe(this,c,"f").$changeMany(this._owner,p)}delete(b){this._checkDisposed(),Fe(this,E,"f").fire([b]),Fe(this,h,"f").delete(b),Fe(this,c,"f")&&Fe(this,c,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Fe(this,E,"f").fire([...Fe(this,h,"f").keys()]),Fe(this,h,"f").clear(),Fe(this,c,"f")&&Fe(this,c,"f").$clear(this._owner)}forEach(b,s){this._checkDisposed();for(let o of Fe(this,h,"f").keys())b.apply(s,[o,this.get(o),this])}get(b){this._checkDisposed();const s=Fe(this,h,"f").get(b);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Fe(this,h,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,s){return b[0].toString()<s[0].toString()?-1:b[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=w,c=new WeakMap,E=new WeakMap,h=new WeakMap;let v=class ri{constructor(b,s,o){this._logService=s,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=b.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(b){const s=new L.ResourceMap;for(const o of b)s.set(o,o);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(b,s){const{_collections:o,_proxy:p,_onDidChangeDiagnostics:a,_logService:S,_fileSystemInfoService:n}=this,t=new class{$changeMany(d,m){p.$changeMany(d,m),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,d,m.length===0?"CLEARING":m)}$clear(d){p.$clear(d),S.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,d)}dispose(){p.dispose()}};let r;if(!s)s="_generated_diagnostic_collection_name_#"+ri._idPool++,r=s;else if(!o.has(s))r=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do r=s+ri._idPool++;while(o.has(r))}return new class extends w{constructor(){super(s,r,ri._maxDiagnosticsPerFile,n.extUri,t,a);o.set(r,this)}dispose(){super.dispose(),o.delete(r)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const s=new Map,o=[];for(const p of this._collections.values())p.forEach((a,S)=>{let n=s.get(a.toString());typeof n=="undefined"&&(n=o.length,s.set(a.toString(),n),o.push([a,[]])),o[n][1]=o[n][1].concat(...S)});return o}}_getDiagnostics(b){let s=[];for(let o of this._collections.values())o.has(b)&&(s=s.concat(o.get(b)));return s}$acceptMarkersChange(b){if(!this._mirrorCollection){const s="_generated_mirror",o=new w(s,s,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,o),this._mirrorCollection=o}for(const[s,o]of b)this._mirrorCollection.set(D.URI.revive(s),o.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([He(1,I.ILogService),He(2,T.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(Ee[235],Se([0,1,2,5]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(P){this._proxy=P.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(k=>k?k.map(C=>g.URI.revive(C)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(k=>k?g.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(Ee[236],Se([0,1,15,2,7,5,10,21,8]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(T,c,E){this._documentsAndEditors=c,this._logService=E,this._documentContentProviders=new Map,this._proxy=T.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,c){if(Object.keys(P.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const E=I._handlePool++;this._documentContentProviders.set(E,c),this._proxy.$registerTextContentProvider(E,T);let h;return typeof c.onDidChange=="function"&&(h=c.onDidChange(w=>{if(w.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(E,w).then(v=>{if(!v&&typeof v!="string")return;const R=this._documentsAndEditors.getDocument(w);if(!R)return;const b=(0,C.splitLines)(v);if(!R.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,v)},g.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(T,c){const E=this._documentContentProviders.get(T);return E?Promise.resolve(E.provideTextDocumentContent(i.URI.revive(c),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(Ee[237],Se([0,1,3,6,2,5,123,17,13,25,7]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(E,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const v of w)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const v of w)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const h=this._documentsAndEditors.getDocument(E);if(h)return h}getDocument(E){const h=this.getDocumentData(E);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return h.document}ensureDocumentData(E){const h=this._documentsAndEditors.getDocument(E);if(h)return Promise.resolve(h);let w=this._documentLoader.get(E.toString());return w||(w=this._proxy.$tryOpenDocument(E).then(v=>{this._documentLoader.delete(E.toString());const R=D.URI.revive(v);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(R))},v=>(this._documentLoader.delete(E.toString()),Promise.reject(v))),this._documentLoader.set(E.toString(),w)),w}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(h=>D.URI.revive(h))}$acceptModelModeChanged(E,h){const w=D.URI.revive(E),v=this._documentsAndEditors.getDocument(w);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(h),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(E){const h=D.URI.revive(E),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(E,h){const w=D.URI.revive(E),v=this._documentsAndEditors.getDocument(w);if(!v)throw new Error("unknown document");v._acceptIsDirty(h),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,h,w){const v=D.URI.revive(E),R=this._documentsAndEditors.getDocument(v);if(!R)throw new Error("unknown document");R._acceptIsDirty(w),R.onEvents(h);let b;h.isUndoing?b=L.TextDocumentChangeReason.Undo:h.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:R.document,contentChanges:h.changes.map(s=>({range:k.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:b}))}setWordDefinitionFor(E,h){(0,P.setWordDefinitionFor)(E,h)}}e.ExtHostDocuments=T}),define(Ee[45],Se([0,1,56,3,6,2,4,5,123,14,130,17,11,24,10,77,93]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class R{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,p){this._extHostRpc=o,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const p=[],a=[],S=[];if(o.removedDocuments)for(const n of o.removedDocuments){const t=_.URI.revive(n),r=this._documents.get(t);r?.unref()&&(this._documents.delete(t),p.push(r.value))}if(o.addedDocuments)for(const n of o.addedDocuments){const t=_.URI.revive(n.uri);let r=this._documents.get(t);if(r&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);r||(r=new R(new C.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,r),a.push(r.value)),r.ref()}if(o.removedEditors)for(const n of o.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&S.push(t)}if(o.addedEditors)for(const n of o.addedEditors){const t=_.URI.revive(n.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const r=this._documents.get(t).value,l=new L.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),n.selections.map(T.Selection.to),n.options,n.visibleRanges.map(d=>T.Range.to(d)),typeof n.editorPosition=="number"?T.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,l)}o.newActiveEditor!==void 0&&(g.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,D.dispose)(p),(0,D.dispose)(S),o.removedDocuments&&this._onDidRemoveDocuments.fire(p),o.addedDocuments&&this._onDidAddDocuments.fire(a),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return o?p:p?.value}allEditors(){return[...this._editors.values()]}};b=je([He(0,I.IExtHostRpcService),He(1,c.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[54],Se([0,1,17,5,2,3,4,14,18]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let I=class{constructor(T){this._onDidChangeTabs=new _.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new _.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=T.getProxy(i.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(T){let c=-1;this._tabs=T.map((h,w)=>(h.isActive&&(c=w),Object.freeze({label:h.label,viewColumn:g.ViewColumn.to(h.viewColumn),index:w,resource:D.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:v,viewId:R})=>({resource:D.URI.revive(v),viewId:R})),viewId:h.editorId,isActive:h.isActive,move:async(v,R)=>{this._proxy.$moveTab(h,v,g.ViewColumn.from(R)),await(0,C.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,C.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const E=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};I=je([He(0,k.IExtHostRpcService)],I),e.ExtHostEditorTabs=I}),define(Ee[238],Se([0,1,2,5,6,7,17,148,8,22,29]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const w=this._schemes.indexOf(h);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),w=[];let v,R,b=14,s=14;for(const o of h){let p=v?(0,C.commonPrefixLength)(v,o):0;for(p===0?R=1:R=s;p<o.length;p++)p+1===o.length?(b=s,s=9):s+=1,w.push([R,o.toUpperCase().charCodeAt(p),s]),w.push([R,o.toLowerCase().charCodeAt(p),s]),R=s;v=o,s=b}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new k.StateMachine(w)}}provideDocumentLinks(h){this._initStateMachine();const w=[],v=k.LinkComputer.computeLinks({getLineContent(R){return h.lineAt(R-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const R of v){const b=P.DocumentLink.to(R);b.target&&w.push(b)}return w}}class c{constructor(h,w){this._extHostLanguageFeatures=w,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,w,v,R={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(b,v);let s=2;R.isCaseSensitive&&(s+=1024),R.isReadonly&&(s+=2048),typeof v.copy=="function"&&(s+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(h,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(b,w,s).catch(p=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${w}`),console.error(p)});const o=v.onDidChangeFile(p=>{const a=[];for(const S of p){let{uri:n,type:t}=S;if(n.scheme!==w)continue;let r;switch(t){case _.FileChangeType.Changed:r=0;break;case _.FileChangeType.Created:r=1;break;case _.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:r})}this._proxy.$onFileSystemChange(b,a)});return(0,D.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(h){const{type:w,ctime:v,mtime:R,size:b,permissions:s}=h;return{type:w,ctime:v,mtime:R,size:b,permissions:s}}$stat(h,w){return Promise.resolve(this._getFsProvider(h).stat(g.URI.revive(w))).then(v=>c._asIStat(v))}$readdir(h,w){return Promise.resolve(this._getFsProvider(h).readDirectory(g.URI.revive(w)))}$readFile(h,w){return Promise.resolve(this._getFsProvider(h).readFile(g.URI.revive(w))).then(v=>I.VSBuffer.wrap(v))}$writeFile(h,w,v,R){return Promise.resolve(this._getFsProvider(h).writeFile(g.URI.revive(w),v.buffer,R))}$delete(h,w,v){return Promise.resolve(this._getFsProvider(h).delete(g.URI.revive(w),v))}$rename(h,w,v,R){return Promise.resolve(this._getFsProvider(h).rename(g.URI.revive(w),g.URI.revive(v),R))}$copy(h,w,v,R){const b=this._getFsProvider(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(w),g.URI.revive(v),R))}$mkdir(h,w){return Promise.resolve(this._getFsProvider(h).createDirectory(g.URI.revive(w)))}$watch(h,w,v,R){const b=this._getFsProvider(h).watch(g.URI.revive(v),R);this._watches.set(w,b)}$unwatch(h,w){const v=this._watches.get(w);v&&(v.dispose(),this._watches.delete(w))}$open(h,w,v){const R=this._getFsProvider(h);if(!R.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(R.open(g.URI.revive(w),v))}$close(h,w){const v=this._getFsProvider(h);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(w))}$read(h,w,v,R){const b=this._getFsProvider(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const s=I.VSBuffer.alloc(R);return Promise.resolve(b.read(w,v,s.buffer,0,R)).then(o=>s.slice(0,o))}$write(h,w,v,R){const b=this._getFsProvider(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(w,v,R.buffer,0,R.byteLength))}_getFsProvider(h){const w=this._fsProvider.get(h);if(!w){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return w}}e.ExtHostFileSystem=c}),define(Ee[66],Se([0,1,5,42,7,22,4,14,44,6]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class zt{constructor(c,E){this._fileSystemProvider=new Map,this._proxy=c.getProxy(g.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(w){try{const v=h._fileSystemProvider.get(w.scheme);if(!v)return await h._proxy.$stat(w);await h._proxy.$ensureActivation(w.scheme);const R=await v.stat(w);return{type:R.type,ctime:R.ctime,mtime:R.mtime,size:R.size,permissions:R.permissions}}catch(v){zt._handleError(v)}},async readDirectory(w){try{const v=h._fileSystemProvider.get(w.scheme);return v?(await h._proxy.$ensureActivation(w.scheme),(await v.readDirectory(w)).slice()):await h._proxy.$readdir(w)}catch(v){return zt._handleError(v)}},async createDirectory(w){try{return await h._proxy.$mkdir(w)}catch(v){return zt._handleError(v)}},async readFile(w){try{const v=h._fileSystemProvider.get(w.scheme);return v?(await h._proxy.$ensureActivation(w.scheme),(await v.readFile(w)).slice()):(await h._proxy.$readFile(w)).buffer}catch(v){return zt._handleError(v)}},async writeFile(w,v){try{return await h._proxy.$writeFile(w,_.VSBuffer.wrap(v))}catch(R){return zt._handleError(R)}},async delete(w,v){try{const R=h._fileSystemProvider.get(w.scheme);return R?(await h._proxy.$ensureActivation(w.scheme),await R.delete(w,{recursive:!1,...v})):await h._proxy.$delete(w,{recursive:!1,useTrash:!1,...v})}catch(R){return zt._handleError(R)}},async rename(w,v,R){try{return await h._proxy.$rename(w,v,{overwrite:!1,...R})}catch(b){return zt._handleError(b)}},async copy(w,v,R){try{return await h._proxy.$copy(w,v,{overwrite:!1,...R})}catch(b){return zt._handleError(b)}},isWritableFileSystem(w){const v=E.getCapabilities(w);if(typeof v=="number")return!(v&2048)}})}static _handleError(c){if(c instanceof D.FileSystemError)throw c;if(!(c instanceof Error))throw new D.FileSystemError(String(c));if(c.name==="ENOPRO")throw D.FileSystemError.Unavailable(c.message);switch(c.name){case i.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(c.message);case i.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(c.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(c.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(c.message);case i.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(c.message);case i.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(c.message);default:throw new D.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,E){return this._fileSystemProvider.set(c,E),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(c))}};L=je([He(0,k.IExtHostRpcService),He(1,C.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[239],Se([0,1,2,38]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(P,k,C,I){this._extHostNotebooks=k,this._textDocumentsAndEditors=C,this._commands=I;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new i.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new i.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new i.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new i.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:g.URI.revive(T.notebookUri),inputUri:g.URI.revive(T.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(T.notebookUri),inputUri:g.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(P,k,C,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:C,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=D}),define(Ee[240],Se([0,1,6,5]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(P){this._handlePool=0,this._proxy=P.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,P),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(Ee[241],Se([0,1,2,25,17,7,5,8,41,16,13,145,6,111,76,87,46,15,3]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentSymbols(q,J){const ne=this._documents.getDocument(q),he=await this._provider.provideDocumentSymbols(ne,J);if(!(0,I.isFalsyOrEmpty)(he))return he[0]instanceof _.DocumentSymbol?he.map(D.DocumentSymbol.from):s._asDocumentSymbolTree(he)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((he,ee)=>{let oe=he.location.range.start.compareTo(ee.location.range.start);return oe===0&&(oe=ee.location.range.end.compareTo(he.location.range.end)),oe});const J=[],ne=[];for(const he of q){const ee={name:he.name||"!!MISSING: name!!",kind:D.SymbolKind.from(he.kind),tags:he.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:he.containerName,range:D.Range.from(he.location.range),selectionRange:D.Range.from(he.location.range),children:[]};for(;;){if(ne.length===0){ne.push(ee),J.push(ee);break}const oe=ne[ne.length-1];if(C.Range.containsRange(oe.range,ee.range)&&!C.Range.equalsRange(oe.range,ee.range)){oe.children&&oe.children.push(ee),ne.push(ee);break}ne.pop()}}return J}}class o{constructor(q,J,ne){this._documents=q,this._commands=J,this._provider=ne,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,J){const ne=this._documents.getDocument(q),he=await this._provider.provideCodeLenses(ne,J);if(!he||J.isCancellationRequested)return;const ee=this._cache.add(he),oe=new c.DisposableStore;this._disposables.set(ee,oe);const _e={cacheId:ee,lenses:[]};for(let Ue=0;Ue<he.length;Ue++)_e.lenses.push({cacheId:[ee,Ue],range:D.Range.from(he[Ue].range),command:this._commands.toInternal(he[Ue].command,oe)});return _e}async resolveCodeLens(q,J){const ne=q.cacheId&&this._cache.get(...q.cacheId);if(!ne)return;let he;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?he=ne:he=await this._provider.resolveCodeLens(ne,J),he||(he=ne),J.isCancellationRequested)return;const ee=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ee)return q.command=this._commands.toInternal(he.command??o._badCmd,ee),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(Ne){return Array.isArray(Ne)?Ne.map(D.DefinitionLink.from):Ne?[D.DefinitionLink.from(Ne)]:[]}class a{constructor(q,J){this._documents=q,this._provider=J}async provideDefinition(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideDefinition(he,ee,ne);return p(oe)}}class S{constructor(q,J){this._documents=q,this._provider=J}async provideDeclaration(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideDeclaration(he,ee,ne);return p(oe)}}class n{constructor(q,J){this._documents=q,this._provider=J}async provideImplementation(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideImplementation(he,ee,ne);return p(oe)}}class t{constructor(q,J){this._documents=q,this._provider=J}async provideTypeDefinition(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideTypeDefinition(he,ee,ne);return p(oe)}}class r{constructor(q,J){this._documents=q,this._provider=J}async provideHover(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideHover(he,ee,ne);if(!(!oe||(0,I.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=he.getWordRangeAtPosition(ee)),oe.range||(oe.range=new _.Range(ee,ee)),D.Hover.from(oe)}}class l{constructor(q,J){this._documents=q,this._provider=J}async provideEvaluatableExpression(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideEvaluatableExpression(he,ee,ne);if(oe)return D.EvaluatableExpression.from(oe)}}class d{constructor(q,J){this._documents=q,this._provider=J}async provideInlineValues(q,J,ne,he){const ee=this._documents.getDocument(q),oe=await this._provider.provideInlineValues(ee,D.Range.to(J),D.InlineValueContext.to(ne),he);if(Array.isArray(oe))return oe.map(_e=>D.InlineValue.from(_e))}}class m{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentHighlights(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideDocumentHighlights(he,ee,ne);if(Array.isArray(oe))return oe.map(D.DocumentHighlight.from)}}class f{constructor(q,J){this._documents=q,this._provider=J}async provideLinkedEditingRanges(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.provideLinkedEditingRanges(he,ee,ne);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,I.coalesce)(oe.ranges.map(D.Range.from)),wordPattern:oe.wordPattern}}}class u{constructor(q,J){this._documents=q,this._provider=J}async provideReferences(q,J,ne,he){const ee=this._documents.getDocument(q),oe=D.Position.to(J),_e=await this._provider.provideReferences(ee,oe,ne,he);if(Array.isArray(_e))return _e.map(D.location.from)}}class y{constructor(q,J,ne,he,ee,oe,_e){this._documents=q,this._commands=J,this._diagnostics=ne,this._provider=he,this._logService=ee,this._extension=oe,this._apiDeprecation=_e,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,J,ne,he){const ee=this._documents.getDocument(q),oe=T.Selection.isISelection(J)?D.Selection.to(J):D.Range.to(J),_e=[];for(const at of this._diagnostics.getDiagnostics(q))if(oe.intersection(at.range)&&_e.push(at)>y._maxCodeActionsPerFile)break;const Ue={diagnostics:_e,only:ne.only?new _.CodeActionKind(ne.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ne.trigger)},Ve=await this._provider.provideCodeActions(ee,oe,Ue,he);if(!(0,I.isNonEmptyArray)(Ve)||he.isCancellationRequested)return;const Ke=this._cache.add(Ve),Je=new c.DisposableStore;this._disposables.set(Ke,Je);const it=[];for(let at=0;at<Ve.length;at++){const et=Ve[at];!et||(y._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Ue.only&&(et.kind?Ue.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ke,at],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(D.Diagnostic.from),edit:et.edit&&D.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ke,actions:it}}async resolveCodeAction(q,J){const[ne,he]=q,ee=this._cache.get(ne,he);if(!ee||y._isCommand(ee)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(ee,J)??ee;return oe?.edit?D.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}y._maxCodeActionsPerFile=1e3;class A{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentFormattingEdits(q,J,ne){const he=this._documents.getDocument(q),ee=await this._provider.provideDocumentFormattingEdits(he,J,ne);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class N{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentRangeFormattingEdits(q,J,ne,he){const ee=this._documents.getDocument(q),oe=D.Range.to(J),_e=await this._provider.provideDocumentRangeFormattingEdits(ee,oe,ne,he);if(Array.isArray(_e))return _e.map(D.TextEdit.from)}}class B{constructor(q,J){this._documents=q,this._provider=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,J,ne,he,ee){const oe=this._documents.getDocument(q),_e=D.Position.to(J),Ue=await this._provider.provideOnTypeFormattingEdits(oe,_e,ne,he,ee);if(Array.isArray(Ue))return Ue.map(D.TextEdit.from)}}class F{constructor(q,J){this._provider=q,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,J){const ne=P.IdObject.mixin({symbols:[]}),he=await this._provider.provideWorkspaceSymbols(q,J);if((0,I.isNonEmptyArray)(he))for(const ee of he){if(!ee)continue;if(!ee.name){this._logService.warn("INVALID SymbolInformation, lacks name",ee);continue}const oe=P.IdObject.mixin(D.WorkspaceSymbol.from(ee));this._symbolCache.set(oe._id,ee),ne.symbols.push(oe)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(q,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const ne=this._symbolCache.get(q._id);if(ne){const he=await this._provider.resolveWorkspaceSymbol(ne,J);return he&&(0,i.mixin)(q,D.WorkspaceSymbol.from(he),!0)}}releaseWorkspaceSymbols(q){const J=this._resultCache.get(q);if(J){for(let[ne,he]=J;ne<=he;ne++)this._symbolCache.delete(ne);this._resultCache.delete(q)}}}class O{constructor(q,J,ne){this._documents=q,this._provider=J,this._logService=ne}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,J,ne,he){const ee=this._documents.getDocument(q),oe=D.Position.to(J);try{const _e=await this._provider.provideRenameEdits(ee,oe,ne,he);return _e?D.WorkspaceEdit.from(_e):void 0}catch(_e){const Ue=O._asMessage(_e);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(_e)}}async resolveRenameLocation(q,J,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const he=this._documents.getDocument(q),ee=D.Position.to(J);try{const oe=await this._provider.prepareRename(he,ee,ne);let _e,Ue;if(_.Range.isRange(oe)?(_e=oe,Ue=he.getText(oe)):(0,L.isObject)(oe)&&(_e=oe.range,Ue=oe.placeholder),!_e||!Ue)return;if(_e.start.line>ee.line||_e.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(_e),text:Ue}}catch(oe){const _e=O._asMessage(oe);return _e?{rejectReason:_e,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class z{constructor(q,J){this.resultId=q,this.tokens=J}}class W{constructor(q,J){this._documents=q,this._provider=J,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,J,ne){const he=this._documents.getDocument(q),ee=J!==0?this._previousResults.get(J):null;let oe=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(he,ee.resultId,ne):await this._provider.provideDocumentSemanticTokens(he,ne);return ee&&this._previousResults.delete(J),oe?(oe=W._fixProvidedSemanticTokens(oe),this._send(W._convertToEdits(ee,oe),oe)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return W._isSemanticTokens(q)?W._isCorrectSemanticTokens(q)?q:new _.SemanticTokens(new Uint32Array(q.data),q.resultId):W._isSemanticTokensEdits(q)?W._isCorrectSemanticTokensEdits(q)?q:new _.SemanticTokensEdits(q.edits.map(J=>new _.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const J of q.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,J){if(!W._isSemanticTokens(J)||!q||!q.tokens)return J;const ne=q.tokens,he=ne.length,ee=J.data,oe=ee.length;let _e=0;const Ue=Math.min(he,oe);for(;_e<Ue&&ne[_e]===ee[_e];)_e++;if(_e===he&&_e===oe)return new _.SemanticTokensEdits([],J.resultId);let Ve=0;const Ke=Ue-_e;for(;Ve<Ke&&ne[he-Ve-1]===ee[oe-Ve-1];)Ve++;return new _.SemanticTokensEdits([{start:_e,deleteCount:he-_e-Ve,data:ee.subarray(_e,oe-Ve)}],J.resultId)}_send(q,J){if(W._isSemanticTokens(q)){const ne=this._nextResultId++;return this._previousResults.set(ne,new z(q.resultId,q.data)),(0,E.encodeSemanticTokensDto)({id:ne,type:"full",data:q.data})}if(W._isSemanticTokensEdits(q)){const ne=this._nextResultId++;return W._isSemanticTokens(J)?this._previousResults.set(ne,new z(J.resultId,J.data)):this._previousResults.set(ne,new z(q.resultId)),(0,E.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(q.edits||[]).map(he=>({start:he.start,deleteCount:he.deleteCount,data:he.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class M{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentRangeSemanticTokens(q,J,ne){const he=this._documents.getDocument(q),ee=await this._provider.provideDocumentRangeSemanticTokens(he,D.Range.to(J),ne);return ee?this._send(ee):null}_send(q){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=M;class x{constructor(q,J,ne,he,ee){this._documents=q,this._commands=J,this._provider=ne,this._apiDeprecation=he,this._extension=ee,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,J,ne,he){const ee=this._documents.getDocument(q),oe=D.Position.to(J),_e=ee.getWordRangeAtPosition(oe)||new _.Range(oe,oe),Ue=_e.with({end:oe}),Ve=new v.StopWatch(!0),Ke=await this._provider.provideCompletionItems(ee,oe,he,D.CompletionContext.to(ne));if(!Ke||he.isCancellationRequested)return;const Je=Array.isArray(Ke)?new _.CompletionList(Ke):Ke,it=x.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),at=new c.DisposableStore;this._disposables.set(it,at);const et=[],nt={x:it,b:et,a:{replace:D.Range.from(_e),insert:D.Range.from(Ue)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const dt=Je.items[ct],Pt=this._convertCompletionItem(dt,[it,ct],Ue,_e);et.push(Pt)}return nt}async resolveCompletionItem(q,J){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...q);if(!ne)return;const he=await this._provider.resolveCompletionItem(ne,J);if(!!he)return this._convertCompletionItem(he,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,J,ne,he){const ee=this._disposables.get(J[0]);if(!ee)throw Error("DisposableStore is missing...");const oe={x:J,a:q.label,b:q.kind!==void 0?D.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(D.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(q.command,ee)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=q.textEdit.newText):typeof q.insertText=="string"?oe.h=q.insertText:q.insertText instanceof _.SnippetString&&(oe.h=q.insertText.value,oe.i|=4);let _e;return q.textEdit?_e=q.textEdit.range:q.range&&(_e=q.range),_.Range.isRange(_e)?oe.j=D.Range.from(_e):_e&&(!ne?.isEqual(_e.inserting)||!he?.isEqual(_e.replacing))&&(oe.j={insert:D.Range.from(_e.inserting),replace:D.Range.from(_e.replacing)}),oe}}class V{constructor(q,J,ne){this._documents=q,this._provider=J,this._commands=ne,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,J,ne,he){const ee=this._documents.getDocument(q),oe=D.Position.to(J),_e=await this._provider.provideInlineCompletionItems(ee,oe,{selectedCompletionInfo:ne.selectedSuggestionInfo?{range:D.Range.to(ne.selectedSuggestionInfo.range),text:ne.selectedSuggestionInfo.text,isSnippetText:ne.selectedSuggestionInfo.isSnippetText,completionKind:D.CompletionItemKind.to(ne.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:ne.triggerKind},he);if(!_e||he.isCancellationRequested)return;const Ue=(0,L.isArray)(_e)?{items:_e}:_e,Ve=this._cache.add(Ue.items);let Ke;return{pid:Ve,items:Ue.items.map((Je,it)=>{let at;return Je.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(Ve,Ke)),at=this._commands.toInternal(Je.command,Ke)),{text:Je.text,range:Je.range?D.Range.from(Je.range):void 0,command:at,idx:it}})}}disposeCompletions(q){this._cache.delete(q);const J=this._disposables.get(q);J&&J.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,J){const ne=this._cache.get(q,J);ne&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let J=U.map.get(q);return J||(J=new U,U.map.set(q,J)),J}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=U,U.map=new WeakMap;class H{constructor(q,J){this._documents=q,this._provider=J,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(q,J,ne,he){const ee=this._documents.getDocument(q),oe=D.Position.to(J),_e=this.reviveContext(ne),Ue=await this._provider.provideSignatureHelp(ee,oe,he,_e);if(Ue){const Ve=this._cache.add([Ue]);return{...D.SignatureHelp.from(Ue),id:Ve}}}reviveContext(q){let J;if(q.activeSignatureHelp){const ne=D.SignatureHelp.to(q.activeSignatureHelp),he=this._cache.get(q.activeSignatureHelp.id,0);he?(J=he,J.activeSignature=ne.activeSignature,J.activeParameter=ne.activeParameter):J=ne}return{...q,activeSignatureHelp:J}}releaseSignatureHelp(q){this._cache.delete(q)}}class Y{constructor(q,J){this._documents=q,this._provider=J}async provideInlayHints(q,J,ne){const he=this._documents.getDocument(q),ee=await this._provider.provideInlayHints(he,D.Range.to(J),ne);return ee?{hints:ee.map(D.InlayHint.from)}:void 0}}class re{constructor(q,J){this._documents=q,this._provider=J,this._cache=new w.Cache("DocumentLink")}async provideLinks(q,J){const ne=this._documents.getDocument(q),he=await this._provider.provideDocumentLinks(ne,J);if(!(!Array.isArray(he)||he.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:he.filter(re._validateLink).map(D.DocumentLink.from)};{const ee=this._cache.add(he),oe={links:[],id:ee};for(let _e=0;_e<he.length;_e++){if(!re._validateLink(he[_e]))continue;const Ue=D.DocumentLink.from(he[_e]);Ue.cacheId=[ee,_e],oe.links.push(Ue)}return oe}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,J){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...q);if(!ne)return;const he=await this._provider.resolveDocumentLink(ne,J);if(!(!he||!re._validateLink(he)))return D.DocumentLink.from(he)}releaseLinks(q){this._cache.delete(q)}}class K{constructor(q,J){this._documents=q,this._provider=J}async provideColors(q,J){const ne=this._documents.getDocument(q),he=await this._provider.provideDocumentColors(ne,J);return Array.isArray(he)?he.map(oe=>({color:D.Color.from(oe.color),range:D.Range.from(oe.range)})):[]}async provideColorPresentations(q,J,ne){const he=this._documents.getDocument(q),ee=D.Range.to(J.range),oe=D.Color.to(J.color),_e=await this._provider.provideColorPresentations(oe,{document:he,range:ee},ne);if(!!Array.isArray(_e))return _e.map(D.ColorPresentation.from)}}class j{constructor(q,J){this._documents=q,this._provider=J}async provideFoldingRanges(q,J,ne){const he=this._documents.getDocument(q),ee=await this._provider.provideFoldingRanges(he,J,ne);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class te{constructor(q,J,ne){this._documents=q,this._provider=J,this._logService=ne}async provideSelectionRanges(q,J,ne){const he=this._documents.getDocument(q),ee=J.map(D.Position.to),oe=await this._provider.provideSelectionRanges(he,ee,ne);if(!(0,I.isNonEmptyArray)(oe))return[];if(oe.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const _e=[];for(let Ue=0;Ue<ee.length;Ue++){const Ve=[];_e.push(Ve);let Ke=ee[Ue],Je=oe[Ue];for(;;){if(!Je.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(D.SelectionRange.from(Je)),!Je.parent)break;Ke=Je.range,Je=Je.parent}}return _e}}class ae{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.prepareCallHierarchy(he,ee,ne);if(!oe)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(oe)?oe.map(Ue=>this._cacheAndConvertItem(_e,Ue)):[this._cacheAndConvertItem(_e,oe)]}async provideCallsTo(q,J,ne){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(he,ne);if(!!ee)return ee.map(oe=>({from:this._cacheAndConvertItem(q,oe.from),fromRanges:oe.fromRanges.map(_e=>D.Range.from(_e))}))}async provideCallsFrom(q,J,ne){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(he,ne);if(!!ee)return ee.map(oe=>({to:this._cacheAndConvertItem(q,oe.to),fromRanges:oe.fromRanges.map(_e=>D.Range.from(_e))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){const ne=this._cache.get(q),he=D.CallHierarchyItem.from(J,q,ne.size.toString(36));return ne.set(he._itemId,J),he}_itemFromCache(q,J){return this._cache.get(q)?.get(J)}}class ge{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,ne){const he=this._documents.getDocument(q),ee=D.Position.to(J),oe=await this._provider.prepareTypeHierarchy(he,ee,ne);if(!oe)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(oe)?oe.map(Ue=>this._cacheAndConvertItem(_e,Ue)):[this._cacheAndConvertItem(_e,oe)]}async provideSupertypes(q,J,ne){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(he,ne);if(!!ee)return ee.map(oe=>this._cacheAndConvertItem(q,oe))}async provideSubtypes(q,J,ne){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(he,ne);if(!!ee)return ee.map(oe=>this._cacheAndConvertItem(q,oe))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){const ne=this._cache.get(q),he=D.TypeHierarchyItem.from(J,q,ne.size.toString(36));return ne.set(he._itemId,J),he}_itemFromCache(q,J){return this._cache.get(q)?.get(J)}}class Ie{constructor(q,J){this.adapter=q,this.extension=J}}class Me{constructor(q,J,ne,he,ee,oe,_e){this._adapter=new Map,this._uriTransformer=J,this._proxy=q.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=he,this._diagnostics=ee,this._logService=oe,this._apiDeprecation=_e}_transformDocumentSelector(q){return D.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new _.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Me._handlePool++}_withAdapter(q,J,ne,he,ee=!1){const oe=this._adapter.get(q);if(!oe)return Promise.resolve(he);if(oe.adapter instanceof J){let _e;oe.extension&&(_e=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${J.name}'`));const Ue=ne(oe.adapter,oe.extension),Ve=oe.extension;return Ve&&Promise.resolve(Ue).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-_e}ms`),Ke=>{ee&&Ke instanceof R.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Ue}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,J){const ne=this._nextHandle();return this._adapter.set(ne,new Ie(q,J)),ne}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,J,ne,he){const ee=this._addNewAdapter(new s(this._documents,ne),q),oe=he&&he.label||Me._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(J),oe),this._createDisposable(ee)}$provideDocumentSymbols(q,J,ne){return this._withAdapter(q,s,he=>he.provideDocumentSymbols(g.URI.revive(J),ne),void 0)}registerCodeLensProvider(q,J,ne){const he=this._nextHandle(),ee=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(he,new Ie(new o(this._documents,this._commands.converter,ne),q)),this._proxy.$registerCodeLensSupport(he,this._transformDocumentSelector(J),ee);let oe=this._createDisposable(he);if(ee!==void 0){const _e=ne.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(ee));oe=_.Disposable.from(oe,_e)}return oe}$provideCodeLenses(q,J,ne){return this._withAdapter(q,o,he=>he.provideCodeLenses(g.URI.revive(J),ne),void 0)}$resolveCodeLens(q,J,ne){return this._withAdapter(q,o,he=>he.resolveCodeLens(J,ne),void 0)}$releaseCodeLenses(q,J){this._withAdapter(q,o,ne=>Promise.resolve(ne.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(q,J,ne){const he=this._addNewAdapter(new a(this._documents,ne),q);return this._proxy.$registerDefinitionSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDefinition(q,J,ne,he){return this._withAdapter(q,a,ee=>ee.provideDefinition(g.URI.revive(J),ne,he),[])}registerDeclarationProvider(q,J,ne){const he=this._addNewAdapter(new S(this._documents,ne),q);return this._proxy.$registerDeclarationSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDeclaration(q,J,ne,he){return this._withAdapter(q,S,ee=>ee.provideDeclaration(g.URI.revive(J),ne,he),[])}registerImplementationProvider(q,J,ne){const he=this._addNewAdapter(new n(this._documents,ne),q);return this._proxy.$registerImplementationSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideImplementation(q,J,ne,he){return this._withAdapter(q,n,ee=>ee.provideImplementation(g.URI.revive(J),ne,he),[])}registerTypeDefinitionProvider(q,J,ne){const he=this._addNewAdapter(new t(this._documents,ne),q);return this._proxy.$registerTypeDefinitionSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideTypeDefinition(q,J,ne,he){return this._withAdapter(q,t,ee=>ee.provideTypeDefinition(g.URI.revive(J),ne,he),[])}registerHoverProvider(q,J,ne,he){const ee=this._addNewAdapter(new r(this._documents,ne),q);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(J)),this._createDisposable(ee)}$provideHover(q,J,ne,he){return this._withAdapter(q,r,ee=>ee.provideHover(g.URI.revive(J),ne,he),void 0)}registerEvaluatableExpressionProvider(q,J,ne,he){const ee=this._addNewAdapter(new l(this._documents,ne),q);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(J)),this._createDisposable(ee)}$provideEvaluatableExpression(q,J,ne,he){return this._withAdapter(q,l,ee=>ee.provideEvaluatableExpression(g.URI.revive(J),ne,he),void 0)}registerInlineValuesProvider(q,J,ne,he){const ee=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,ne),q);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(J),ee);let _e=this._createDisposable(oe);if(ee!==void 0){const Ue=ne.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(ee));_e=_.Disposable.from(_e,Ue)}return _e}$provideInlineValues(q,J,ne,he,ee){return this._withAdapter(q,d,oe=>oe.provideInlineValues(g.URI.revive(J),ne,he,ee),void 0)}registerDocumentHighlightProvider(q,J,ne){const he=this._addNewAdapter(new m(this._documents,ne),q);return this._proxy.$registerDocumentHighlightProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDocumentHighlights(q,J,ne,he){return this._withAdapter(q,m,ee=>ee.provideDocumentHighlights(g.URI.revive(J),ne,he),void 0)}registerLinkedEditingRangeProvider(q,J,ne){const he=this._addNewAdapter(new f(this._documents,ne),q);return this._proxy.$registerLinkedEditingRangeProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideLinkedEditingRanges(q,J,ne,he){return this._withAdapter(q,f,async ee=>{const oe=await ee.provideLinkedEditingRanges(g.URI.revive(J),ne,he);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Me._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(q,J,ne){const he=this._addNewAdapter(new u(this._documents,ne),q);return this._proxy.$registerReferenceSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideReferences(q,J,ne,he,ee){return this._withAdapter(q,u,oe=>oe.provideReferences(g.URI.revive(J),ne,he,ee),void 0)}registerCodeActionProvider(q,J,ne,he){const ee=new c.DisposableStore,oe=this._addNewAdapter(new y(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(J),{providedKinds:he?.providedCodeActionKinds?.map(_e=>_e.value),documentation:he?.documentation?.map(_e=>({kind:_e.kind.value,command:this._commands.converter.toInternal(_e.command,ee)}))},Me._extLabel(q),Boolean(ne.resolveCodeAction)),ee.add(this._createDisposable(oe)),ee}$provideCodeActions(q,J,ne,he,ee){return this._withAdapter(q,y,oe=>oe.provideCodeActions(g.URI.revive(J),ne,he,ee),void 0)}$resolveCodeAction(q,J,ne){return this._withAdapter(q,y,he=>he.resolveCodeAction(J,ne),void 0)}$releaseCodeActions(q,J){this._withAdapter(q,y,ne=>Promise.resolve(ne.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(q,J,ne){const he=this._addNewAdapter(new A(this._documents,ne),q);return this._proxy.$registerDocumentFormattingSupport(he,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(he)}$provideDocumentFormattingEdits(q,J,ne,he){return this._withAdapter(q,A,ee=>ee.provideDocumentFormattingEdits(g.URI.revive(J),ne,he),void 0)}registerDocumentRangeFormattingEditProvider(q,J,ne){const he=this._addNewAdapter(new N(this._documents,ne),q);return this._proxy.$registerRangeFormattingSupport(he,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(he)}$provideDocumentRangeFormattingEdits(q,J,ne,he,ee){return this._withAdapter(q,N,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(J),ne,he,ee),void 0)}registerOnTypeFormattingEditProvider(q,J,ne,he){const ee=this._addNewAdapter(new B(this._documents,ne),q);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(J),he,q.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(q,J,ne,he,ee,oe){return this._withAdapter(q,B,_e=>_e.provideOnTypeFormattingEdits(g.URI.revive(J),ne,he,ee,oe),void 0)}registerWorkspaceSymbolProvider(q,J){const ne=this._addNewAdapter(new F(J,this._logService),q);return this._proxy.$registerNavigateTypeSupport(ne,typeof J.resolveWorkspaceSymbol=="function"),this._createDisposable(ne)}$provideWorkspaceSymbols(q,J,ne){return this._withAdapter(q,F,he=>he.provideWorkspaceSymbols(J,ne),{symbols:[]})}$resolveWorkspaceSymbol(q,J,ne){return this._withAdapter(q,F,he=>he.resolveWorkspaceSymbol(J,ne),void 0)}$releaseWorkspaceSymbols(q,J){this._withAdapter(q,F,ne=>ne.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(q,J,ne){const he=this._addNewAdapter(new O(this._documents,ne,this._logService),q);return this._proxy.$registerRenameSupport(he,this._transformDocumentSelector(J),O.supportsResolving(ne)),this._createDisposable(he)}$provideRenameEdits(q,J,ne,he,ee){return this._withAdapter(q,O,oe=>oe.provideRenameEdits(g.URI.revive(J),ne,he,ee),void 0)}$resolveRenameLocation(q,J,ne,he){return this._withAdapter(q,O,ee=>ee.resolveRenameLocation(g.URI.revive(J),ne,he),void 0)}registerDocumentSemanticTokensProvider(q,J,ne,he){const ee=this._nextHandle(),oe=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ee,new Ie(new W(this._documents,ne),q)),this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(J),he,oe);let _e=this._createDisposable(ee);if(oe){const Ue=ne.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(oe));_e=_.Disposable.from(_e,Ue)}return _e}$provideDocumentSemanticTokens(q,J,ne,he){return this._withAdapter(q,W,ee=>ee.provideDocumentSemanticTokens(g.URI.revive(J),ne,he),null,!0)}$releaseDocumentSemanticTokens(q,J){this._withAdapter(q,W,ne=>ne.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(q,J,ne,he){const ee=this._addNewAdapter(new M(this._documents,ne),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(J),he),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(q,J,ne,he){return this._withAdapter(q,M,ee=>ee.provideDocumentRangeSemanticTokens(g.URI.revive(J),ne,he),null,!0)}registerCompletionItemProvider(q,J,ne,he){const ee=this._addNewAdapter(new x(this._documents,this._commands.converter,ne,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(ee,this._transformDocumentSelector(J),he,x.supportsResolving(ne),`${q.identifier.value}(${he.join("")})`),this._createDisposable(ee)}$provideCompletionItems(q,J,ne,he,ee){return this._withAdapter(q,x,oe=>oe.provideCompletionItems(g.URI.revive(J),ne,he,ee),void 0)}$resolveCompletionItem(q,J,ne){return this._withAdapter(q,x,he=>he.resolveCompletionItem(J,ne),void 0)}$releaseCompletionItems(q,J){this._withAdapter(q,x,ne=>ne.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(q,J,ne){const he=this._addNewAdapter(new V(this._documents,ne,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideInlineCompletions(q,J,ne,he,ee){return this._withAdapter(q,V,oe=>oe.provideInlineCompletions(g.URI.revive(J),ne,he,ee),void 0)}$handleInlineCompletionDidShow(q,J,ne){this._withAdapter(q,V,async he=>{he.handleDidShowCompletionItem(J,ne)},void 0)}$freeInlineCompletionsList(q,J){this._withAdapter(q,V,async ne=>{ne.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(q,J,ne,he){const ee=Array.isArray(he)?{triggerCharacters:he,retriggerCharacters:[]}:he,oe=this._addNewAdapter(new H(this._documents,ne),q);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(J),ee),this._createDisposable(oe)}$provideSignatureHelp(q,J,ne,he,ee){return this._withAdapter(q,H,oe=>oe.provideSignatureHelp(g.URI.revive(J),ne,he,ee),void 0)}$releaseSignatureHelp(q,J){this._withAdapter(q,H,ne=>ne.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(q,J,ne){const he=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new Y(this._documents,ne),q);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(J),he);let oe=this._createDisposable(ee);if(he!==void 0){const _e=ne.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(he));oe=_.Disposable.from(oe,_e)}return oe}$provideInlayHints(q,J,ne,he){return this._withAdapter(q,Y,ee=>ee.provideInlayHints(g.URI.revive(J),ne,he),void 0)}registerDocumentLinkProvider(q,J,ne){const he=this._addNewAdapter(new re(this._documents,ne),q);return this._proxy.$registerDocumentLinkProvider(he,this._transformDocumentSelector(J),typeof ne.resolveDocumentLink=="function"),this._createDisposable(he)}$provideDocumentLinks(q,J,ne){return this._withAdapter(q,re,he=>he.provideLinks(g.URI.revive(J),ne),void 0)}$resolveDocumentLink(q,J,ne){return this._withAdapter(q,re,he=>he.resolveLink(J,ne),void 0)}$releaseDocumentLinks(q,J){this._withAdapter(q,re,ne=>ne.releaseLinks(J),void 0)}registerColorProvider(q,J,ne){const he=this._addNewAdapter(new K(this._documents,ne),q);return this._proxy.$registerDocumentColorProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDocumentColors(q,J,ne){return this._withAdapter(q,K,he=>he.provideColors(g.URI.revive(J),ne),[])}$provideColorPresentations(q,J,ne,he){return this._withAdapter(q,K,ee=>ee.provideColorPresentations(g.URI.revive(J),ne,he),void 0)}registerFoldingRangeProvider(q,J,ne){const he=this._nextHandle(),ee=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(he,new Ie(new j(this._documents,ne),q)),this._proxy.$registerFoldingRangeProvider(he,this._transformDocumentSelector(J),ee);let oe=this._createDisposable(he);if(ee!==void 0){const _e=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));oe=_.Disposable.from(oe,_e)}return oe}$provideFoldingRanges(q,J,ne,he){return this._withAdapter(q,j,ee=>ee.provideFoldingRanges(g.URI.revive(J),ne,he),void 0)}registerSelectionRangeProvider(q,J,ne){const he=this._addNewAdapter(new te(this._documents,ne,this._logService),q);return this._proxy.$registerSelectionRangeProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideSelectionRanges(q,J,ne,he){return this._withAdapter(q,te,ee=>ee.provideSelectionRanges(g.URI.revive(J),ne,he),[])}registerCallHierarchyProvider(q,J,ne){const he=this._addNewAdapter(new ae(this._documents,ne),q);return this._proxy.$registerCallHierarchyProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$prepareCallHierarchy(q,J,ne,he){return this._withAdapter(q,ae,ee=>Promise.resolve(ee.prepareSession(g.URI.revive(J),ne,he)),void 0)}$provideCallHierarchyIncomingCalls(q,J,ne,he){return this._withAdapter(q,ae,ee=>ee.provideCallsTo(J,ne,he),void 0)}$provideCallHierarchyOutgoingCalls(q,J,ne,he){return this._withAdapter(q,ae,ee=>ee.provideCallsFrom(J,ne,he),void 0)}$releaseCallHierarchy(q,J){this._withAdapter(q,ae,ne=>Promise.resolve(ne.releaseSession(J)),void 0)}registerTypeHierarchyProvider(q,J,ne){const he=this._addNewAdapter(new ge(this._documents,ne),q);return this._proxy.$registerTypeHierarchyProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$prepareTypeHierarchy(q,J,ne,he){return this._withAdapter(q,ge,ee=>Promise.resolve(ee.prepareSession(g.URI.revive(J),ne,he)),void 0)}$provideTypeHierarchySupertypes(q,J,ne,he){return this._withAdapter(q,ge,ee=>ee.provideSupertypes(J,ne,he),void 0)}$provideTypeHierarchySubtypes(q,J,ne,he){return this._withAdapter(q,ge,ee=>ee.provideSubtypes(J,ne,he),void 0)}$releaseTypeHierarchy(q,J){this._withAdapter(q,ge,ne=>Promise.resolve(ne.releaseSession(J)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,k.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Me._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Me._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Me._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Me._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Me._serializeRegExp(q.beforeText),afterText:q.afterText?Me._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Me._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Me._serializeOnEnterRule)}setLanguageConfiguration(q,J,ne){let{wordPattern:he}=ne;if(he&&(0,k.regExpLeadsToEndlessLoop)(he))throw new Error(`Invalid language configuration: wordPattern '${he}' is not allowed to match the empty string.`);he?this._documents.setWordDefinitionFor(J,he):this._documents.setWordDefinitionFor(J,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const ee=this._nextHandle(),oe={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Me._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Me._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Me._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ee,J,oe),this._createDisposable(ee)}$setWordDefinitions(q){for(const J of q)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Me,Me._handlePool=0}),define(Ee[242],Se([0,1,5,17,7,48,18,6]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(L,T,c,E){this._documents=T,this._commands=c,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,T){await this._proxy.$changeLanguage(L,T);const c=this._documents.getDocumentData(L);if(!c)throw new Error(`document '${L.toString}' NOT found`);return c.document}async tokenAtPosition(L,T){const c=L.version,E=i.Position.from(T),h=await this._proxy.$tokensAtPosition(L.uri,E),w={type:D.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new D.Range(T.line,T.character,T.line,T.character)};if(!h)return w;const v={range:i.Range.to(h.range),type:i.TokenType.to(h.type)};return!v.range.contains(T)||c!==L.version?w:v}createLanguageStatusItem(L,T,c){const E=this._handlePool++,h=this._proxy,w=this._ids,v=`${L.identifier.value}/${T}`;if(w.has(v))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);w.add(v);const R={selector:c,id:T,name:L.displayName??L.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,s=new k.DisposableStore;const o=()=>{b?.dispose(),b=(0,P.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(E,{id:v,name:R.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(R.selector,this._uriTransformer),label:R.text,detail:R.detail??"",severity:R.severity===D.LanguageStatusSeverity.Error?_.default.Error:R.severity===D.LanguageStatusSeverity.Warning?_.default.Warning:_.default.Info,command:R.command&&this._commands.toInternal(R.command,s),accessibilityInfo:R.accessibilityInformation,busy:R.busy})},0)},p={dispose(){s.dispose(),b?.dispose(),h.$removeLanguageStatus(E),w.delete(v)},get id(){return R.id},get name(){return R.name},set name(a){R.name=a,o()},get selector(){return R.selector},set selector(a){R.selector=a,o()},get text(){return R.text},set text(a){R.text=a,o()},get detail(){return R.detail},set detail(a){R.detail=a,o()},get severity(){return R.severity},set severity(a){R.severity=a,o()},get accessibilityInformation(){return R.accessibilityInformation},set accessibilityInformation(a){R.accessibilityInformation=a,o()},get command(){return R.command},set command(a){R.command=a,o()},get busy(){return R.busy},set busy(a){R.busy=a,o()}};return o(),p}}e.ExtHostLanguages=C}),define(Ee[132],Se([0,1,11,5,26,14,3]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends g.AbstractLoggerService{constructor(L,T){const c=new P.Emitter;super(T.logLevel,c.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,T,c){return new C(this._proxy,L,T,c)}};k=je([He(0,_.IExtHostRpcService),He(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class C extends g.AbstractMessageLogger{constructor(L,T,c,E){super(E?.always);this.proxy=L,this.file=T,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(T,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,T){const c=[[L,T]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(L){this.proxy.$log(this.file,L)}}}),define(Ee[243],Se([0,1,5,11,29]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(k){return k&&k.title}let P=class{constructor(C,I){this._logService=I,this._proxy=C.getProxy(g.MainContext.MainThreadMessageService)}showMessage(C,I,L,T,c){const E={extension:C};let h;typeof T=="string"||_(T)?h=[T,...c]:(E.modal=T?.modal,E.useCustom=T?.useCustom,E.detail=T?.detail,h=c),E.useCustom&&(0,D.checkProposedApiEnabled)(C,"resolvers");const w=[];for(let v=0;v<h.length;v++){const R=h[v];if(typeof R=="string")w.push({title:R,handle:v,isCloseAffordance:!1});else if(typeof R=="object"){let{title:b,isCloseAffordance:s}=R;w.push({title:b,isCloseAffordance:!!s,handle:v})}else this._logService.warn("Invalid message item:",R)}return this._proxy.$showMessage(I,L,E,w).then(v=>{if(typeof v=="number")return h[v]})}};P=je([He(1,i.ILogService)],P),e.ExtHostMessageService=P}),define(Ee[244],Se([0,1,22,3,47,6,24,8,13,2,87,5,17,7,53,219,129]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class R{constructor(s,o,p,a,S){this._textDocumentsAndEditors=p,this._textDocuments=a,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new i.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,r=n.cell.handle,d=this._documents.get(t)?.getCell(r);if(d)return d.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,p]of this._editors)if(p.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const p=this._documents.get(s);if(!p&&!o)throw new Error(`NO notebook document for '${s}'`);return p}_getProviderData(s){const o=this._notebookContentProviders.get(s);if(!o)throw new Error(`NO provider for '${s}'`);return o}registerNotebookContentProvider(s,o,p,a,S){if((0,k.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:s,provider:p});let n;return p.onDidChangeNotebookContentOptions&&(n=p.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(o,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},o,c.NotebookDocumentContentOptions.from(a),R._convertNotebookRegistrationData(s,S)),new E.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(s,o){if(!o)return;const p=o.filenamePattern.map(a=>c.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(o.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:p,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,p){const a=R._notebookStatusBarItemProviderHandlePool++,S=typeof p.onDidChangeCellStatusBarItems=="function"?R._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,S,o);let n;return S!==void 0&&(n=p.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(S))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,S),n&&n.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&c.NotebookData.from(s.content)});return I.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(s),a=this._documents.get(I.URI.revive(p));return(0,C.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(s,o){I.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let p;typeof o=="object"?p={position:c.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(c.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:p={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,p),S=a&&this._editors.get(a)?.apiEditor;if(S)return S;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,p,a){const S=this._notebookStatusBarItemProviders.get(s),n=I.URI.revive(o),t=this._documents.get(n);if(!t||!S)return;const r=t.getCellFromIndex(p);if(!r)return;const l=await S.provideCellStatusBarItems(r.apiCell,a);if(!l)return;const d=new _.DisposableStore,m=this._statusBarCache.add([d]),u=(Array.isArray(l)?l:[l]).map(y=>c.NotebookStatusBarItem.from(y,this._commandsConverter,d));return{cacheId:m,items:u}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,p,a,S){if((0,k.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,p),this._notebookProxy.$registerNotebookSerializer(n,{id:s.identifier,location:s.extensionLocation},o,c.NotebookDocumentContentOptions.from(a),R._convertNotebookRegistrationData(s,S)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(s,o,p){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const S=await a.deserializeNotebook(o.buffer,p);return new h.SerializableObjectWithBuffers(c.NotebookData.from(S))}async $notebookToData(s,o,p){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const S=await a.serializeNotebook(c.NotebookData.to(o.value),p);return g.VSBuffer.wrap(S)}async $openNotebook(s,o,p,a,S){const{provider:n}=this._getProviderData(s),t=await n.openNotebook(I.URI.revive(o),{backupId:p,untitledDocumentData:a?.buffer},S);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(s,o,p){const a=this.getNotebookDocument(I.URI.revive(o)),{provider:S}=this._getProviderData(s);return await S.saveNotebook(a.apiNotebook,p),!0}async $saveNotebookAs(s,o,p,a){const S=this.getNotebookDocument(I.URI.revive(o)),{provider:n}=this._getProviderData(s);return await n.saveNotebookAs(I.URI.revive(p),S.apiNotebook,a),!0}async $backupNotebook(s,o,p){const a=this.getNotebookDocument(I.URI.revive(o)),S=this._getProviderData(s),n=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),t=String((0,D.hash)([a.uri.toString(),this._backupIdPool++])),r=I.URI.joinPath(n,t),l=await S.provider.backupNotebook(a.apiNotebook,{destination:r},p);return a.updateBackup(l),l.id}_createExtHostEditor(s,o,p){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const a=new v.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,p.visibleRanges.map(c.NotebookRange.to),p.selections.map(c.NotebookRange.to),typeof p.viewColumn=="number"?c.ViewColumn.to(p.viewColumn):void 0);this._editors.set(o,a)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const p of s.value.removedDocuments){const a=I.URI.revive(p),S=this._documents.get(a);S&&(S.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===a.toString()&&this._editors.delete(n.id)}if(s.value.addedDocuments){const p=[];for(const a of s.value.addedDocuments){const S=I.URI.revive(a.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const n=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){n._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){n._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){n._onDidChangeCellMetadata.fire(r)},emitCellExecutionStateChange(r){n._onDidChangeCellExecutionState.fire(r)}},S,a);p.push(...a.cells.map(r=>w.ExtHostCell.asModelAddData(t.apiNotebook,r))),this._documents.get(S)?.dispose(),this._documents.set(S,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const p of s.value.addedEditors){if(this._editors.has(p.id))return;const a=I.URI.revive(p.documentUri),S=this._documents.get(a);S&&this._createExtHostEditor(S,p.id,p)}const o=[];if(s.value.removedEditors)for(const p of s.value.removedEditors){const a=this._editors.get(p);a&&(this._editors.delete(p),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),o.push(a))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const p=new Set;this._visibleNotebookEditors.forEach(a=>p.add(a.id));for(const a of this._editors.values()){const S=p.has(a.id);a._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=R,R._notebookStatusBarItemProviderHandlePool=0}),define(Ee[245],Se([0,1,3,76,11,5,14,17]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(T,c){const E=C._Keys.nextId();T.$registerNotebookEditorDecorationType(E,k.NotebookDecorationRenderOptions.from(c)),this.value={key:E,dispose(){T.$removeNotebookEditorDecorationType(E)}}}}C._Keys=new i.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(T,c,E){this._logService=T,this._extHostRpc=c,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new C(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,c);const E=this._notebooksAndEditors.getEditorById(T);c.visibleRanges&&E._acceptVisibleRanges(c.visibleRanges.ranges.map(k.NotebookRange.to)),c.selections&&E._acceptSelections(c.selections.selections.map(k.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const c in T)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(k.ViewColumn.to(T[c]))}};I=je([He(0,D.ILogService),He(1,P.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(Ee[246],Se([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,211,29,53]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(n,t,r,l,d){this._initData=t,this._extHostNotebook=r,this._commands=l,this._logService=d,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(T.MainContext.MainThreadNotebookKernels);const m=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",f=>!0,f=>{if(f&&"notebookEditor"in f&&"id"in f){const u=this._extHostNotebook.getIdByEditor(f.notebookEditor);return{id:f.id,extension:f.extension,notebookEditorId:u}}else if(f&&"notebookEditor"in f){const u=this._extHostNotebook.getIdByEditor(f.notebookEditor);if(u===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${f.notebookEditor.document.uri.toString()}`);return{notebookEditorId:u}}return f})],c.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(n,t,r,l,d,m){for(let H of this._kernelData.values())if(H.controller.id===t&&I.ExtensionIdentifier.equals(n.identifier,H.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const f=this._handlePool++,u=this;this._logService.trace(`NotebookController[${f}], CREATED by ${n.identifier.value}, ${t}`);const y=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${n.identifier}'`);let A=!1;const N=new P.DisposableStore,B=new _.Emitter,F=new _.Emitter,O={id:`${n.identifier.value}/${t}`,notebookType:r,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:l||n.identifier.value,preloads:m?m.map(E.NotebookRendererScript.from):[]};let z=d??y,W;this._proxy.$addKernel(f,O).catch(H=>{console.log(H),A=!0});let M=0;const x=()=>{if(A)return;const H=++M;Promise.resolve().then(()=>{H===M&&this._proxy.$updateKernel(f,O)})},V=new k.ResourceMap,U={get id(){return t},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return O.label},set label(H){O.label=H??n.displayName??n.name,x()},get detail(){return O.detail??""},set detail(H){O.detail=H,x()},get description(){return O.description??""},set description(H){O.description=H,x()},get kind(){return(0,R.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind??""},set kind(H){(0,R.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind=H,x()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(H){O.supportedLanguages=H,x()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(H){O.supportsExecutionOrder=H,x()},get rendererScripts(){return O.preloads?O.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(H){z=H??y},get interruptHandler(){return W},set interruptHandler(H){W=H,O.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(A)throw new Error("notebook controller is DISPOSED");if(!V.has(H.notebook.uri))throw u._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return u._createNotebookCellExecution(H)},dispose:()=>{A||(this._logService.trace(`NotebookController[${f}], DISPOSED`),A=!0,this._kernelData.delete(f),N.dispose(),B.dispose(),F.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(H,Y){u._proxy.$updateNotebookPriority(f,H.uri,Y)},onDidReceiveMessage:F.event,postMessage(H,Y){return(0,R.checkProposedApiEnabled)(n,"notebookMessaging"),u._proxy.$postMessage(f,Y&&u._extHostNotebook.getIdByEditor(Y),H)},asWebviewUri(H){return(0,R.checkProposedApiEnabled)(n,"notebookMessaging"),(0,w.asWebviewUri)(H,u._initData.remote)}};return this._kernelData.set(f,{extensionId:n.identifier,controller:U,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:V}),U}$acceptNotebookAssociation(n,t,r){const l=this._kernelData.get(n);if(l){const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(t));r?l.associatedNotebooks.set(d.uri,!0):l.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,d.uri.toString(),r),l.onDidChangeSelection.fire({selected:r,notebook:d.apiNotebook})}}async $executeCells(n,t,r){const l=this._kernelData.get(n);if(!l)return;const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(t)),m=[];for(let f of r){const u=d.getCell(f);u&&m.push(u.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,d.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,d.apiNotebook,l.controller)}catch(f){this._logService.error(`NotebookController[${n}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(n,t,r){const l=this._kernelData.get(n);if(!l)return;const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(t));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,d.apiNotebook);else for(let m of r){const f=d.getCell(m);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,r){const l=this._kernelData.get(n);if(!l)return;const d=this._extHostNotebook.getEditorById(t);l.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:r}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const l=new p(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,l);const d=l.onDidChangeState(()=>{l.state===o.Resolved&&(l.dispose(),d.dispose(),this._activeExecutions.delete(r.uri))});return l.asApiObject()}};s=je([He(4,L.ILogService)],s),e.ExtHostNotebookKernels=s;var o;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(o||(o={}));class p extends P.Disposable{constructor(n,t,r){super();this._document=n,this._cell=t,this._proxy=r,this._handle=p.HANDLE++,this._onDidChangeState=new _.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new a(10,l=>this.update(l)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const r=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return r===t.items?E.NotebookCellOutput.from(t):E.NotebookCellOutput.from({items:r,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,r){const l=this.cellIndexToHandle(t),d=this.validateAndConvertOutputs((0,g.asArray)(n));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:r,outputs:d})}async updateOutputItems(n,t,r){return n=h.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(n),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(E.NotebookCellOutputItem.from),outputId:t.id,append:r})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(r){n._executionOrder=r,n.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(r){if(n._state===o.Resolved||n._state===o.Started)throw new Error("Cannot call start again");n._state=o.Started,n._onDidChangeState.fire(),n.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:r})},end(r,l){if(n._state===o.Resolved)throw new Error("Cannot call resolve twice");n._state=o.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:l,lastRunSuccess:r}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(r){return n.verifyStateForOutput(),n.updateOutputs([],r,!1)},appendOutput(r,l){return n.verifyStateForOutput(),n.updateOutputs(r,l,!0)},replaceOutput(r,l){return n.verifyStateForOutput(),n.updateOutputs(r,l,!1)},appendOutputItems(r,l){return n.verifyStateForOutput(),n.updateOutputItems(r,l,!0)},replaceOutputItems(r,l){return n.verifyStateForOutput(),n.updateOutputItems(r,l,!1)}})}}p.HANDLE=0;class a{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(Ee[247],Se([0,1,3,5,129,29]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(C,I){this._extHostNotebook=I,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,I,L){const T=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(I)?.fire({editor:T.apiEditor,message:L})}createRendererMessaging(C,I){if(!C.contributes?.notebookRenderer?.some(E=>E.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);const L=(0,_.isProposedApiEnabled)(C,"notebookEditor"),T=new WeakMap;return{onDidReceiveMessage:(E,h,w)=>{const v=L?E:R=>{const b={};T.set(b,R.editor),E({editor:b,message:R.message})};return this.getOrCreateEmitterFor(I).event(v,h,w)},postMessage:(E,h)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,h]=[h,E]);const w=L?h:T.get(h),v=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(v?.id,I,E)}}}getOrCreateEmitterFor(C){let I=this._rendererMessageEmitters.get(C);return I||(I=new g.Emitter({onLastListenerRemove:()=>{I?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,I),I)}}e.ExtHostNotebookRenderers=P}),define(Ee[133],Se([0,1,5,6,4,14,11,212,66,26,44,152,22]),function(X,e,g,i,D,_,P,k,C,I,L,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends i.Disposable{constructor(v,R,b,s){super();this.id=v,this.name=R,this.logger=b,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(v){this.append(v+`
`)}append(v){this.write(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,v)}replace(v){const R=this.offset;this.write(v),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,R),this.visible&&this.logger.flush()}show(v,R){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:R))}hide(){this.proxy.$close(this.id)}write(v){this.offset+=c.VSBuffer.fromString(v).byteLength,this.logger.info(v)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let h=class{constructor(v,R,b,s,o){this.extHostFileSystem=b,this.extHostFileSystemInfo=s,this.loggerService=o,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(g.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(R.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[R,b]of this.channels)b.visible=R===this.visibleChannelId}createOutputChannel(v,R){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(v,R);return b.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(v,b)}async doCreateOutputChannel(v,R){const b=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),p=await this.proxy.$register(v,!1,s,R.identifier.value);return new E(p,v,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(v,R){let b=!1;const s=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return v},append(o){s(),R.then(p=>p.append(o))},appendLine(o){s(),R.then(p=>p.appendLine(o))},clear(){s(),R.then(o=>o.clear())},replace(o){s(),R.then(p=>p.replace(o))},show(o,p){s(),R.then(a=>a.show(o,p))},hide(){s(),R.then(o=>o.hide())},dispose(){b=!0,R.then(o=>o.dispose())}}}};h=je([He(0,_.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,C.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,P.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(Ee[248],Se([0,1,18,21,3,6,5,2,7,15,16,48,86,29]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(w,v,R){const b=w.getProxy(P.MainContext.MainThreadQuickOpen);class s{constructor(d,m){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=m}showQuickPick(d,m,f=i.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(d),y=++this._instances,A=b.$show(y,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},f),N={},B=A.then(()=>N);return Promise.race([B,u]).then(F=>{if(F!==N)return u.then(O=>{const z=[];for(let W=0;W<O.length;W++){const M=O[W];typeof M=="string"?z.push({label:M,handle:W}):M.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:M.label}):z.push({label:M.label,description:M.description,detail:M.detail,picked:M.picked,alwaysShow:M.alwaysShow,handle:W})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{m.onDidSelectItem(O[W])}),b.$setItems(y,z),A.then(W=>{if(typeof W=="number")return O[W];if(Array.isArray(W))return W.map(M=>O[M])})})}).then(void 0,F=>{if(!(0,I.isPromiseCanceledError)(F))return b.$setError(y,F),Promise.reject(F)})}$onItemSelected(d){this._onDidSelectItem&&this._onDidSelectItem(d)}showInput(d,m=i.CancellationToken.None){return this._validateInput=d?d.validateInput:void 0,b.$input(d,typeof this._validateInput=="function",m).then(void 0,f=>{if(!(0,I.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(d){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(d)):Promise.resolve(void 0)}async showWorkspaceFolderPick(d,m=i.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!f)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(y=>y.uri.toString()===f.uri.toString())}createQuickPick(d){const m=new t(d,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(d){const m=new r(d,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(d,m){const f=this._sessions.get(d);f&&f._fireDidChangeValue(m)}$onDidAccept(d){const m=this._sessions.get(d);m&&m._fireDidAccept()}$onDidChangeActive(d,m){const f=this._sessions.get(d);f instanceof t&&f._fireDidChangeActive(m)}$onDidChangeSelection(d,m){const f=this._sessions.get(d);f instanceof t&&f._fireDidChangeSelection(m)}$onDidTriggerButton(d,m){const f=this._sessions.get(d);f&&f._fireDidTriggerButton(m)}$onDidTriggerItemButton(d,m,f){const u=this._sessions.get(d);u instanceof t&&u._fireDidTriggerItemButton(m,f)}$onDidHide(d){const m=this._sessions.get(d);m&&m._fireDidHide()}}class o{constructor(d,m){this._extensionId=d,this._onDidDispose=m,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((m,f)=>{const u=m===C.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(u,m)}),this.update({buttons:d.map((m,f)=>({...n(m),tooltip:m.tooltip,handle:m===C.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const m=this._handlesToButtons.get(d);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(d){if(!this._disposed){for(const m of Object.keys(d)){const f=d[m];this._pendingUpdate[m]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function p(l){if(l instanceof C.ThemeIcon)return{id:l.id};const d=S(l),m=a(l);return{dark:typeof d=="string"?k.URI.file(d):d,light:typeof m=="string"?k.URI.file(m):m}}function a(l){return typeof l=="object"&&"light"in l?l.light:l}function S(l){return typeof l=="object"&&"dark"in l?l.dark:l}function n(l){const d=p(l.iconPath);let m,f;return"id"in d?f=c.ThemeIcon.asClassName(d):m=d,{iconPath:m,iconClass:f}}class t extends o{constructor(d,m){super(d.identifier,m);this.extension=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){d.some(f=>f.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((f,u)=>{this._handlesToItems.set(u,f),this._itemsToHandles.set(f,u)});const m=[];for(let f=0;f<d.length;f++){const u=d[f];u.kind===C.QuickPickItemKind.Separator?m.push({type:"separator",label:u.label}):m.push({handle:f,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((y,A)=>({...n(y),tooltip:y.tooltip,handle:A}))})}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(d){this._keepScrollPosition=d,this.update({keepScrollPosition:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(d){const m=(0,L.coalesce)(d.map(f=>this._handlesToItems.get(f)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(d){const m=(0,L.coalesce)(d.map(f=>this._handlesToItems.get(f)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(d,m){const f=this._handlesToItems.get(d);if(!f||!f.buttons||!f.buttons.length)return;const u=f.buttons[m];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:f})}}class r extends o{constructor(d,m){super(d,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,this.update({validationMessage:d,severity:d?T.default.Error:T.default.Ignore})}}return new s(v,R)}e.createExtHostQuickOpen=h});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[249],Se([0,1,2,3,57,6,18,5,16,100,11,27,86,17,29]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h){"use strict";var w,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function R(m){if(m)return typeof m.iconPath=="string"?g.URI.file(m.iconPath):g.URI.isUri(m.iconPath)||c.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function b(m,f){if(!m.iconPath&&!f.iconPath)return 0;if(m.iconPath){if(!f.iconPath)return 1}else return-1;const u=typeof m.iconPath=="string"?m.iconPath:g.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,y=typeof f.iconPath=="string"?f.iconPath:g.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,I.comparePaths)(u,y)}function s(m,f){let u=0;if(m.strikeThrough!==f.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==f.faded)return m.faded?1:-1;if(m.tooltip!==f.tooltip)return(m.tooltip||"").localeCompare(f.tooltip||"");if(u=b(m,f),u!==0)return u;if(m.light&&f.light)u=b(m.light,f.light);else{if(m.light)return 1;if(f.light)return-1}if(u!==0)return u;if(m.dark&&f.dark)u=b(m.dark,f.dark);else{if(m.dark)return 1;if(f.dark)return-1}return u}function o(m,f){if(m.command!==f.command)return m.command<f.command?-1:1;if(m.title!==f.title)return m.title<f.title?-1:1;if(m.tooltip!==f.tooltip){if(m.tooltip!==void 0&&f.tooltip!==void 0)return m.tooltip<f.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(m.arguments===f.arguments)return 0;if(m.arguments)if(f.arguments){if(m.arguments.length!==f.arguments.length)return m.arguments.length-f.arguments.length}else return 1;else return-1;for(let u=0;u<m.arguments.length;u++){const y=m.arguments[u],A=f.arguments[u];if(y!==A)return y<A?-1:1}return 0}function p(m,f){let u=(0,I.comparePaths)(m.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(u!==0)return u;if(m.command&&f.command)u=o(m.command,f.command);else{if(m.command)return 1;if(f.command)return-1}if(u!==0)return u;if(m.decorations&&f.decorations)u=s(m.decorations,f.decorations);else{if(m.decorations)return 1;if(f.decorations)return-1}return u}function a(m,f){for(let u=0;u<m.length;u++)if(m[u]!==f[u])return!1;return!0}function S(m,f){return m.command===f.command&&m.title===f.title&&m.tooltip===f.tooltip&&(m.arguments&&f.arguments?a(m.arguments,f.arguments):m.arguments===f.arguments)}function n(m,f){return(0,C.equals)(m,f,S)}class t{constructor(f,u,y){this._extension=f,this._sourceControlHandle=y,w.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0,tt(this,w,u,"f")}get value(){return this._value}set value(f){f=f??"",Fe(this,w,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Fe(this,w,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Fe(this,w,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Fe(this,w,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,u){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),Fe(this,w,"f").$showValidationMessage(this._sourceControlHandle,f,u)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=t,w=new WeakMap;class r{constructor(f,u,y,A,N){this._proxy=f,this._commands=u,this._sourceControlHandle=y,this._id=A,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,u){const y=this._resourceStatesCommandsMap.get(f);return y?(0,P.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],u)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(p),y=(0,C.sortedDiff)(this._resourceSnapshot,f,p).map(B=>{const F=B.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const W=O.resourceUri;let M;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const ae=new _.DisposableStore;M=this._commands.converter.toInternal(O.command,ae),this._resourceStatesDisposablesMap.set(z,ae)}else this._resourceStatesCommandsMap.set(z,O.command);const x=R(O.decorations),V=O.decorations&&R(O.decorations.light)||x,U=O.decorations&&R(O.decorations.dark)||x,H=[V,U],Y=O.decorations&&O.decorations.tooltip||"",re=O.decorations&&!!O.decorations.strikeThrough,K=O.decorations&&!!O.decorations.faded,j=O.contextValue||"";return{rawResource:[z,W,H,Y,re,K,j,M],handle:z}});return{start:B.start,deleteCount:B.deleteCount,toInsert:F}}),A=y.map(({start:B,deleteCount:F,toInsert:O})=>[B,F,O.map(z=>z.rawResource)]),N=y.reverse();for(const{start:B,deleteCount:F,toInsert:O}of N){const z=O.map(M=>M.handle),W=this._handlesSnapshot.splice(B,F,...z);for(const M of W)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=f,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class l{constructor(f,u,y,A,N,B){this._extension=f,this._commands=y,this._id=A,this._label=N,this._rootUri=B,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new _.MutableDisposable,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=l._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,v,u,"f"),this._inputBox=new t(f,Fe(this,v,"f"),this.handle),Fe(this,v,"f").$registerSourceControl(this.handle,A,N,B)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Fe(this,v,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Fe(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Fe(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=f;const u=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Fe(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:u})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new _.DisposableStore,this._actionButton=f;const u=f!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Fe(this,v,"f").$updateSourceControl(this.handle,{actionButton:u??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&n(this._statusBarCommands,f))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=f;const u=(f||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));Fe(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:u})}get selected(){return this._selected}createResourceGroup(f,u){const y=new r(Fe(this,v,"f"),this._commands,this.handle,f,u),A=i.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,A),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const f=[],u=[];for(const[y,A]of this.createdResourceGroups){A.dispose();const N=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});i.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),N.dispose(),this._groups.delete(y.handle),Fe(this,v,"f").$unregisterGroup(this.handle,y.handle)}),f.push([y.handle,y.id,y.label,y.features]);const B=y._takeResourceStateSnapshot();B.length>0&&u.push([y.handle,B]),this._groups.set(y.handle,y)}Fe(this,v,"f").$registerGroups(this.handle,f,u),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(u=>{const y=u._takeResourceStateSnapshot();y.length!==0&&f.push([u.handle,y])}),f.length>0&&Fe(this,v,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Fe(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,l._handlePool=0,je([(0,D.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let d=class Hi{constructor(f,u,y){this._commands=u,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=f.getProxy(k.MainContext.MainThreadSCM),this._telemetry=f.getProxy(k.MainContext.MainThreadTelemetry),u.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const N=this._sourceControls.get(A.sourceControlHandle);if(!N)return A;const B=N.getResourceGroup(A.groupHandle);return B?B.getResourceState(A.handle):A}else if(A&&A.$mid===4){const N=this._sourceControls.get(A.sourceControlHandle);return N?N.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const N=this._sourceControls.get(A.handle);return N||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,u,y,A){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,u,y,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const N=Hi._handlePool++,B=new l(f,this._proxy,this._commands,u,y,A);this._sourceControls.set(N,B);const F=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(B),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(f.identifier),F),B}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const u=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(f.identifier)),y=u&&u[u.length-1];return y&&y.inputBox}$provideOriginalResource(f,u,y){const A=g.URI.revive(u);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,A.toString());const N=this._sourceControls.get(f);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(A,y)).then(B=>B||null)}$onInputBoxValueChange(f,u){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const y=this._sourceControls.get(f);return y&&y.inputBox.$onInputBoxValueChange(u),Promise.resolve(void 0)}$executeResourceCommand(f,u,y,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,u,y);const N=this._sourceControls.get(f);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(u);return B?B.$executeResourceCommand(y,A):Promise.resolve(void 0)}$validateInput(f,u,y){this.logService.trace("ExtHostSCM#$validateInput",f);const A=this._sourceControls.get(f);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>A.inputBox.validateInput(u,y)).then(N=>{if(!N)return Promise.resolve(void 0);const B=E.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};d._handlePool=0,d=je([He(2,L.ILogService)],d),e.ExtHostSCM=d});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[250],Se([0,1,7,5,166,6,17,13]),function(X,e,g,i,D,_,P,k){"use strict";var C,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(h,w,v,R,b=g.StatusBarAlignment.Left,s){C.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,tt(this,C,h,"f"),tt(this,I,w,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=R,this._alignment=b,this._priority=this.validatePriority(s)}validatePriority(h){if(!!(0,k.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!L.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Fe(this,I,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Fe(this,I,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const R=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Fe(this,C,"f").$setEntry(this._entryId,h,w,this._text,R,this._command?.internal,v,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,C=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const v=this._messages.indexOf(w);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(h,w){this._proxy=h.getProxy(i.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new T(this)}createStatusBarEntry(h,w,v,R){return new L(this._proxy,this._commands,h,w,v,R)}setStatusBarMessage(h,w){const v=this._statusMessage.setMessage(h);let R;return typeof w=="number"?R=setTimeout(()=>v.dispose(),w):typeof w!="undefined"&&w.then(()=>v.dispose(),()=>v.dispose()),new g.Disposable(()=>{v.dispose(),clearTimeout(R)})}}e.ExtHostStatusBar=c}),define(Ee[91],Se([0,1,5,3,4]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(k){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,C){this._proxy.$registerExtensionStorageKeysToSync(k,C)}getValue(k,C,I){return this._proxy.$getValue(k,C).then(L=>L||I)}setValue(k,C,I){return this._proxy.$setValue(k,C,I)}$acceptValue(k,C,I){this._onDidChangeStorage.fire({shared:k,key:C,value:I})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ee[67],Se([0,1,4,26,11,66,2]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let k=class{constructor(I,L,T){this._logService=L,this._extHostFileSystem=T,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(I){return P.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(I){if(this._value)return P.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return P.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([He(0,i.IExtHostInitDataService),He(1,D.ILogService),He(2,_.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(Ee[34],Se([0,1,3,5,4,2,14,6,7,167,15,214,21,33,196,86,13,18]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class b{constructor(l,d,m,f){this._proxy=l,this._id=d,this._creationOptions=m,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(y=>this._pidPromiseComplete=y);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},get state(){return u._state},sendText(y,A=!0){u._checkDisposed(),u._proxy.$sendText(u._id,y,A)},show(y){u._checkDisposed(),u._proxy.$show(u._id,y)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(l,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,v.withNullAsUndefined)(l.shellPath),shellArgs:(0,v.withNullAsUndefined)(l.shellArgs),cwd:(0,v.withNullAsUndefined)(l.cwd),env:(0,v.withNullAsUndefined)(l.env),icon:(0,v.withNullAsUndefined)(n(l.iconPath)),color:w.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,v.withNullAsUndefined)(l.message),strictEnv:(0,v.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(l.location,d?.resolvedExtHostIdentifier),disablePersistence:(0,v.withNullAsUndefined)(l.disablePersistence)})}async createExtensionTerminal(l,d,m,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(l,d),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,d){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,d){return l===this._cols&&d===this._rows||l===0||d===0?!1:(this._cols=l,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=b;class s{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new g.Emitter,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${d}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput?.(l)}resize(l,d){this._pty.setDimensions?.({columns:l,rows:d})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose?.((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions?.(d=>{d&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this._pty.onDidChangeName?.(d=>{this._onDidChangeProperty.fire({type:"title",value:d})}),this._pty.open(l||void 0),l&&this._pty.setDimensions?.(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let o=1,p=class extends k.Disposable{constructor(l,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[m,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,d){const m=new b(this._proxy,(0,E.generateUuid)(),l,l.name),f=new s(l.pty);return m.createExtensionTerminal(l.location,this._serializeParentTerminal(l,d).resolvedExtHostIdentifier,n(l.iconPath),t(l.color)).then(u=>{const y=this._setupExtHostProcessListeners(u,f);this._terminalProcessDisposables[u]=y}),this._terminals.push(m),m.value}_serializeParentTerminal(l,d){if(d=d||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const m=l.location.parentTerminal;if(m){const f=this._terminals.find(u=>u.value===m);f&&(d.resolvedExtHostIdentifier=f._id)}}else l.location&&typeof l.location!="object"?d.location=l.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(l,d){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const f=new s(d),u=this._setupExtHostProcessListeners(l,f);this._terminalProcessDisposables[l]=u}async $acceptActiveTerminalChanged(l){const d=this._activeTerminal;if(l===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(l);m&&(this._activeTerminal=m,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,d){const m=this._getTerminalById(l);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:d})}async $acceptTerminalDimensions(l,d,m){const f=this._getTerminalById(l);f&&f.setDimensions(d,m)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(l,d,m){this._terminalProcesses.get(l)?.resize(d,m)}async $acceptTerminalTitleChange(l,d){const m=this._getTerminalById(l);m&&(m.name=d)}async $acceptTerminalClosed(l,d){const m=this._getTerminalObjectIndexById(this._terminals,l);if(m!==null){const f=this._terminals.splice(m,1)[0];f.setExitCode(d),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(l,d,m,f){if(d){const A=this._getTerminalObjectIndexById(this._terminals,d);if(A!==null){this._terminals[A]._id=l,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const u={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:_.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},y=new b(this._proxy,l,u,m);this._terminals.push(y),this._onDidOpenTerminal.fire(y.value),y.isOpen=!0}async $acceptTerminalProcessId(l,d){const m=this._getTerminalById(l);m&&m._setProcessId(d)}async $startExtensionTerminal(l,d){const m=this._getTerminalById(l);if(!m)return{message:(0,I.localize)(0,null,l)};m.isOpen||await new Promise(u=>{const y=this.onDidOpenTerminal(async A=>{A===m.value&&(y.dispose(),u())})});const f=this._terminalProcesses.get(l);f?f.startSendingEvents(d):this._extensionTerminalAwaitingStart[l]={initialDimensions:d}}_setupExtHostProcessListeners(l,d){const m=new k.DisposableStore;m.add(d.onProcessReady(u=>this._proxy.$sendProcessReady(l,u.pid,u.cwd))),m.add(d.onDidChangeProperty(u=>this._proxy.$sendProcessProperty(l,u))),this._bufferer.startBuffering(l,d.onProcessData),m.add(d.onProcessExit(u=>this._onProcessExit(l,u))),this._terminalProcesses.set(l,d);const f=this._extensionTerminalAwaitingStart[l];return f&&d instanceof s&&(d.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),m}$acceptProcessAckDataEvent(l,d){this._terminalProcesses.get(l)?.acknowledgeDataEvent(d)}$acceptProcessInput(l,d){this._terminalProcesses.get(l)?.input(d)}$acceptTerminalInteraction(l){const d=this._getTerminalById(l);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(l,d,m){try{this._terminalProcesses.get(l)?.resize(d,m)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(l,d){this._terminalProcesses.get(l)?.shutdown(d)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(d=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(d=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:d}))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,d,m){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,m),this._proxy.$registerProfileProvider(d,l.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(l,d){const m=new c.CancellationTokenSource().token;let f=await this._profileProviders.get(l)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,d);return}this.createTerminalFromOptions(f.options,d)}}async $provideLinks(l,d){const m=this._getTerminalById(l);if(!m)return[];this._terminalLinkCache.delete(l);const f=this._terminalLinkCancellationSource.get(l);f&&f.dispose(!0);const u=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,u);const y=[],A={terminal:m.value,line:d},N=[];for(const O of this._linkProviders)N.push(R.Promises.withAsyncBody(async z=>{u.token.onCancellationRequested(()=>z({provider:O,links:[]}));const W=await O.provideTerminalLinks(A,u.token)||[];u.token.isCancellationRequested||z({provider:O,links:W})}));const B=await Promise.all(N);if(u.token.isCancellationRequested)return[];const F=new Map;for(const O of B)O&&O.links.length>0&&y.push(...O.links.map(z=>{const W={id:o++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return F.set(W.id,{provider:O.provider,link:z}),W}));return this._terminalLinkCache.set(l,F),y}$activateLink(l,d){const m=this._terminalLinkCache.get(l)?.get(d);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(l,d){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const m=this._terminalProcessDisposables[l];m&&(m.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,d)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,d){const m=this._getTerminalObjectIndexById(l,d);return m!==null?l[m]:null}_getTerminalObjectIndexById(l,d){let m=null;return l.some((f,u)=>f._id===d?(m=u,!0):!1),m}getEnvironmentVariableCollection(l){let d=this._environmentVariableCollections.get(l.identifier.value);return d||(d=new a,this._setEnvironmentVariableCollection(l.identifier.value,d)),d}_syncEnvironmentVariableCollection(l,d){const m=(0,T.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(l,d.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(l){l.forEach(d=>{const m=d[0],f=new a(d[1]);this._setEnvironmentVariableCollection(m,f)})}$acceptDefaultProfile(l,d){this._defaultProfile=l,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(l,d){this._environmentVariableCollections.set(l,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,d)})}};p=je([He(1,P.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class a{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,d){this._setIfDiffers(l,{value:d,type:C.EnvironmentVariableMutatorType.Replace})}append(l,d){this._setIfDiffers(l,{value:d,type:C.EnvironmentVariableMutatorType.Append})}prepend(l,d){this._setIfDiffers(l,{value:d,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,d){const m=this.map.get(l);(!m||m.value!==d.value||m.type!==d.type)&&(this.map.set(l,d),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,d){this.map.forEach((m,f)=>l.call(d,f,m,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let S=class extends p{constructor(l){super(!1,l)}createTerminal(l,d,m){throw new L.NotSupportedError}createTerminalFromOptions(l,d){throw new L.NotSupportedError}};S=je([He(0,P.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function n(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function t(r){return w.ThemeColor.isThemeColor(r)?r:void 0}});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[251],Se([0,1,16,22,21,3,75,47,6,25,13,33,5,14,63,17,7,222,127,89]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(A,N){this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(c.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new S(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?w.TestItem.toItemFromContext(B):B})}createTestController(A,N){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const B=new C.DisposableStore,F=B.add(new R.SingleUseTestCollection(A));F.root.label=N;const O=new Map,z=this.proxy,W={items:F.root.children,get label(){return N},set label(x){N=x,F.root.label=x,z.$updateControllerLabel(A,N)},get id(){return A},createRunProfile:(x,V,U,H,Y)=>{let re=(0,k.hash)(x);for(;O.has(re);)re++;const K=new f(this.proxy,A,re,x,V,U,H,Y);return O.set(re,K),K},createTestItem(x,V,U){return new h.TestItemImpl(A,x,V,U)},createTestRun:(x,V,U=!0)=>this.runTracker.createTestRun(A,F,x,V,U),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};W.createRunConfiguration=W.createRunProfile,z.$registerTestController(A,N),B.add((0,C.toDisposable)(()=>z.$unregisterTestController(A)));const M={controller:W,collection:F,profiles:O};return this.controllers.set(A,M),B.add((0,C.toDisposable)(()=>this.controllers.delete(A))),B.add(F.onDidGenerateDiff(x=>z.$publishDiff(A,x))),W}createTestObserver(){return this.observer.checkout()}async runTests(A,N=D.CancellationToken.None){const B=n(A);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(B.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(O=>O.id)??[F.collection.root.id],profileGroup:u[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:A.exclude?.map(O=>O.id)},N)}$provideFileCoverage(A,N,B){return(0,g.mapFind)(this.runTracker.trackers,O=>O.id===A?O.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(A,N,B,F){return(0,g.mapFind)(this.runTracker.trackers,z=>z.id===A?z.getCoverage(N):void 0)?.resolveFileCoverage(B,F)??Promise.resolve([])}$configureRunProfile(A,N){this.controllers.get(A)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(N=>(0,I.deepFreeze)(w.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,N){const B=this.controllers.get(s.TestId.fromString(A).controllerId)?.collection;B&&(await B.expand(A,N<0?1/0:N),B.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,N){const B=this.controllers.get(A.controllerId);if(!B)return;const{collection:F,profiles:O}=B,z=O.get(A.profileId);if(!z)return;const W=A.testIds.map(U=>F.tree.get(U)).filter(L.isDefined),M=A.excludeExtIds.map(U=>B.collection.tree.get(U)).filter(L.isDefined).filter(U=>W.some(H=>H.fullId.compare(U.fullId)===2));if(!W.length)return;const x=new v.TestRunRequest(W.some(U=>U.actual instanceof h.TestItemRootImpl)?void 0:W.map(U=>U.actual),M.map(U=>U.actual),z),V=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(A,B.collection),N);try{await z.runHandler(x,N)}finally{V.isRunning&&!N.isCancellationRequested&&await _.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};p=je([He(0,E.IExtHostRpcService)],p),e.ExtHostTesting=p;class a extends C.Disposable{constructor(A,N,B){super();this.dto=A,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const N=this.dto.id,B=this.dto.controllerId,F=(0,T.generateUuid)(),O=new r(this.proxy,N,F),z=V=>(U,...H)=>{if(M){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),V(U,...H))},W=(V,U)=>{const H=U instanceof Array?U.map(w.TestMessage.from):[w.TestMessage.from(U)];if(V.uri&&V.range){const Y={range:w.Range.from(V.range),uri:V.uri};for(const re of H)re.location=re.location||Y}this.proxy.$appendTestMessagesInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),H)};let M=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return O.coverageProvider},set coverageProvider(V){O.coverageProvider=V},enqueued:z(V=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),1)}),skipped:z(V=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),5)}),started:z(V=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),2)}),errored:z((V,U,H)=>{W(V,U),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),6,H)}),failed:z((V,U,H)=>{W(V,U),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),4,H)}),passed:z((V,U)=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,U)}),appendOutput:(V,U,H)=>{M||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(N,F,i.VSBuffer.fromString(V),U&&w.location.from(U),H&&s.TestId.fromExtHostTestItem(H,B).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:O}),this.proxy.$startedTestRunTask(N,{id:F,name:A,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof h.TestItemImpl))throw new h.InvalidTestItemError(A.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const F=w.TestItem.from(A);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),A===B))break;A=A.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class S{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,N,B){return this.getTracker(A,N,B)}cancelRunById(A){for(const N of this.tracked.values())if(N.id===A){N.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,N,B,F,O){const z=this.tracked.get(B);if(z)return z.createRun(F);const W=t.fromPublic(A,N,B,O),M=n(B);this.proxy.$startedExtensionTestRun({controllerId:A,profile:M&&{group:u[M.kind],id:M.profileId},exclude:B.exclude?.map(V=>V.id)??[],id:W.id,include:B.include?.map(V=>V.id)??[N.root.id],persist:O});const x=this.getTracker(B,W);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),x.createRun(F)}getTracker(A,N,B){const F=new a(N,this.proxy,B);return this.tracked.set(A,F),F.onEnd(()=>this.tracked.delete(A)),F}}e.TestRunCoordinator=S;const n=y=>{if(!!y.profile){if(!(y.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return y.profile}};class t{constructor(A,N,B,F,O,z){this.controllerId=A,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=B.map(W=>W+"\0"),this.excludePrefix=F.map(W=>W+"\0")}static fromPublic(A,N,B,F){return new t(A,(0,T.generateUuid)(),B.include?.map(O=>s.TestId.fromExtHostTestItem(O,A).toString())??[A],B.exclude?.map(O=>s.TestId.fromExtHostTestItem(O,A).toString())??[],F,N)}static fromInternal(A,N){return new t(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,N)}isIncluded(A){const N=s.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=t;class r{constructor(A,N,B){this.proxy=A,this.runId=N,this.taskId=B}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(A,N){const B=await this.fileCoverage;let F=B?.[A];return!this._coverageProvider||!B||!F?[]:(F.detailedCoverage||(F=B[A]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class l extends b.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,w.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:N,removed:B}=this;return{get added(){return[...A].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...B].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,N){return{...A,revived:w.TestItem.toPlain(A.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=d;class m{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(N=>N.revived)},dispose:(0,P.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class f{constructor(A,N,B,F,O,z,W=!1,M=void 0){this.controllerId=N,this.profileId=B,this._label=F,this.kind=O,this.runHandler=z,this._isDefault=W,this._tag=M,o.set(this,void 0),tt(this,o,A,"f");const x=u[O];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);Fe(this,o,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:M?w.TestTag.namespace(this.controllerId,M.id):null,label:F,group:x,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Fe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Fe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Fe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?w.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Fe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Fe(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,o=new WeakMap;const u={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(Ee[252],Se([0,1,3,16,5,130,17,7]),function(X,e,g,i,D,_,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(L,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const T=this._extHostDocumentsAndEditors.allEditors();return L?T:T.map(c=>c.value)}async showTextDocument(L,T,c){let E;typeof T=="number"?E={position:P.ViewColumn.from(T),preserveFocus:c}:typeof T=="object"?E={position:P.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?P.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:E={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(L.uri,E),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new _.TextEditorDecorationType(this._proxy,L,T).value}$acceptEditorPropertiesChanged(L,T){const c=this._extHostDocumentsAndEditors.getEditor(L);if(!c)throw new Error("unknown text editor");if(T.options&&c._acceptOptions(T.options),T.selections){const E=T.selections.selections.map(P.Selection.to);c._acceptSelections(E)}if(T.visibleRanges){const E=i.coalesce(T.visibleRanges.map(P.Range.to));c._acceptVisibleRanges(E)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...T.options,lineNumbers:P.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const E=k.TextEditorSelectionChangeKind.fromValue(T.selections.source),h=T.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:h,kind:E})}if(T.visibleRanges){const E=i.coalesce(T.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const T in L){const c=this._extHostDocumentsAndEditors.getEditor(T);if(!c)throw new Error("Unknown text editor");const E=P.ViewColumn.to(L[T]);c.value.viewColumn!==E&&(c._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=C}),define(Ee[253],Se([0,1,2,4,5,6,7]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class k{constructor(L,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(D.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const E=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(C(E))?.get(c.handle)}return c}})}async $getTimeline(L,T,c,E,h){return this._providers.get(L)?.provideTimeline(g.URI.revive(T),c,E,h)}registerTimelineProvider(L,T,c,E){const h=new _.DisposableStore,w=this.convertTimelineItem(T.id,E,h).bind(this);let v;T.onDidChange&&(v=T.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:T.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:L,onDidChange:void 0,async provideTimeline(b,s,o,p){p?.resetCache&&(h.clear(),R.get(T.id)?.clear());const a=await T.provideTimeline(b,s,o);if(a==null)return;const S=w(b,p);return{...a,source:T.id,items:a.items.map(S)}},dispose(){for(const b of R.values())b.get(T.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(L,T,c){return(E,h)=>{let w;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(L);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(L,v));const R=C(E);w=v.get(R),w===void 0&&(w=new Map,v.set(R,w))}return v=>{const{iconPath:R,...b}=v,s=`${L}|${v.id??v.timestamp}`;w?.set(s,v);let o,p,a;return v.iconPath&&(R instanceof P.ThemeIcon?a={id:R.id,color:R.color}:g.URI.isUri(R)?(o=R,p=R):{light:o,dark:p}=R),{...b,id:b.id??void 0,handle:s,source:L,command:v.command?T.toInternal(v.command,c):void 0,icon:o,iconDark:p,themeIcon:a,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,_.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=k;function C(I){return I?.toString()}}),define(Ee[254],Se([0,1,6,10,2,5]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(C){this._openers=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,I,L,T){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const c=T.schemes.find(E=>!P.supportedSchemes.has(E));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,T.schemes,C,T.label),(0,g.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(C,I,L){const T=this._openers.get(C);if(!T)throw new Error(`Unknown opener with id: ${C}`);const c=D.URI.revive(I);return T.canOpenExternalUri(c,L)}async $openUri(C,I,L){const T=this._openers.get(C);if(!T)throw new Error(`Unknown opener id: '${C}'`);return T.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(Ee[255],Se([0,1,5,2,6,15,27]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(P.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const T=k.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(I)),this.handlers.set(T,L),this._proxy.$registerUriHandler(T,I),(0,D.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(I)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(I,L){const T=this.handlers.get(I);if(!T)return Promise.resolve(void 0);try{T.handleUri(i.URI.revive(L))}catch(c){(0,_.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(I){return i.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[68],Se([0,1,3,10,2,179,204,88,5]),function(X,e,g,i,D,_,P,k,C){"use strict";var I,L,T,c,E,h,w,v,R,b,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(m,f,u,y,A,N,B){I.set(this,void 0),L.set(this,void 0),T.set(this,void 0),c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),w.set(this,""),v.set(this,void 0),R.set(this,!1),b.set(this,!1),s.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new g.Emitter),this._onDidDispose=Fe(this,o,"f").event,tt(this,I,m,"f"),tt(this,L,f,"f"),tt(this,v,u,"f"),tt(this,c,y,"f"),tt(this,E,A,"f"),tt(this,h,N,"f"),tt(this,s,a(N),"f"),tt(this,T,B,"f")}dispose(){tt(this,R,!0,"f"),Fe(this,o,"f").fire(),Fe(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return tt(this,b,!0,"f"),(0,k.asWebviewUri)(m,Fe(this,c,"f").remote)}get cspSource(){const m=Fe(this,h,"f").extensionLocation;if(m.scheme===i.Schemas.https||m.scheme===i.Schemas.http){let f=m.toString();return f.endsWith("/")||(f+="/"),f+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,w,"f")}set html(m){this.assertNotDisposed(),Fe(this,w,"f")!==m&&(tt(this,w,m,"f"),!Fe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(tt(this,b,!0,"f"),Fe(this,T,"f").report("Webview vscode-resource: uris",Fe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,L,"f").$setHtml(Fe(this,I,"f"),m))}get options(){return this.assertNotDisposed(),Fe(this,v,"f")}set options(m){this.assertNotDisposed(),Fe(this,L,"f").$setOptions(Fe(this,I,"f"),t(Fe(this,h,"f"),Fe(this,E,"f"),m)),tt(this,v,m,"f")}async postMessage(m){if(Fe(this,R,"f"))return!1;const f=(0,P.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Fe(this,s,"f")});return Fe(this,L,"f").$postMessage(Fe(this,I,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Fe(this,R,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,I=new WeakMap,L=new WeakMap,T=new WeakMap,c=new WeakMap,E=new WeakMap,h=new WeakMap,w=new WeakMap,v=new WeakMap,R=new WeakMap,b=new WeakMap,s=new WeakMap,o=new WeakMap;function a(d){try{const m=(0,_.normalizeVersion)((0,_.parseVersion)(d.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class S{constructor(m,f,u,y,A){this.initData=f,this.workspace=u,this._logService=y,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=m.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(m,f,u){const y=this.getWebview(m);if(y){const{message:A}=(0,P.deserializeWebviewMessage)(f,u.value);y._onMessageEmitter.fire(A)}}$onMissingCsp(m,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,f,u){const y=new p(m,this._webviewProxy,r(f),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(m,y),y._onDidDispose(()=>{this._webviews.delete(m)}),y}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=S;function n(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=n;function t(d,m,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||l(d,m)}}e.serializeWebviewOptions=t;function r(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(m=>D.URI.from(m))}}e.reviveOptions=r;function l(d,m){return[...(m?.getWorkspaceFolders()||[]).map(f=>f.uri),d.extensionLocation]}}),define(Ee[256],Se([0,1,21,47,6,10,23,2,17,68,87,5,7]),function(X,e,g,i,D,_,P,k,C,I,L,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(a,S){this.document=a,this._storagePath=S,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,S){await this.getEdit(a).undo(),S||this.disposeBackup()}async redo(a,S){await this.getEdit(a).redo(),S||this.disposeBackup()}disposeEdits(a){for(const S of a)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=o(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const S=this._edits.get(a,0);if(!S)throw new Error("No edit found");return S}}class h{constructor(){this._documents=new Map}get(a,S){return this._documents.get(this.key(a,S))}add(a,S,n){const t=this.key(a,S.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${S.uri}`);const r=new E(S,n);return this._documents.set(t,r),r}delete(a,S){const n=this.key(a,S.uri);this._documents.delete(n)}key(a,S){return`${a}@@@${S}`}}var w;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(w||(w={}));class v{constructor(){this._providers=new Map}addTextProvider(a,S,n){return this.add(0,a,S,n)}addCustomProvider(a,S,n){return this.add(1,a,S,n)}get(a){return this._providers.get(a)}add(a,S,n,t){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:a,extension:n,provider:t}),new c.Disposable(()=>this._providers.delete(S))}}class R{constructor(a,S,n,t,r){this._extHostDocuments=S,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new h,this._proxy=a.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,S,n,t){const r=new D.DisposableStore;return b(n)?(r.add(this._editorProviders.addTextProvider(S,a,n)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(a),S,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(a))):(r.add(this._editorProviders.addCustomProvider(S,a,n)),this.supportEditing(n)&&r.add(n.onDidChangeCustomDocument(l=>{const d=this.getCustomDocumentEntry(S,l.document.uri);if(s(l)){const m=d.addEdit(l);this._proxy.$onDidEdit(l.document.uri,S,m,l.label)}else this._proxy.$onContentChange(l.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(a),S,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(a))),c.Disposable.from(r,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(a,S,n,t,r){const l=this._editorProviders.get(S);if(!l)throw new Error(`No provider found for '${S}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${S}'`);const d=k.URI.revive(a),m=await l.provider.openCustomDocument(d,{backupId:n,untitledDocumentData:t?.buffer},r);let f;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(S,m,f),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(a,S){const n=this._editorProviders.get(S);if(!n)throw new Error(`No provider found for '${S}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${S}'`);const t=k.URI.revive(a),{document:r}=this.getCustomDocumentEntry(S,t);this._documents.delete(S,r),r.dispose()}async $resolveWebviewEditor(a,S,n,t,r,l){const d=this._editorProviders.get(n);if(!d)throw new Error(`No provider found for '${n}'`);const m=C.ViewColumn.to(r),f=this._extHostWebview.createNewWebview(S,t.webviewOptions,d.extension),u=this._extHostWebviewPanels.createNewWebviewPanel(S,n,t.title,m,t.panelOptions,f),y=k.URI.revive(a);switch(d.type){case 1:{const{document:A}=this.getCustomDocumentEntry(n,y);return d.provider.resolveCustomEditor(A,u,l)}case 0:{const A=this._extHostDocuments.getDocument(y);return d.provider.resolveCustomTextEditor(A,u,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,S,n){this.getCustomDocumentEntry(S,a).disposeEdits(n)}async $onMoveCustomEditor(a,S,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const r=this._extHostWebviewPanels.getWebviewPanel(a);if(!r)throw new Error("No webview found");const l=k.URI.revive(S),d=this._extHostDocuments.getDocument(l);await t.provider.moveCustomTextEditor(d,r,g.CancellationToken.None)}async $undo(a,S,n,t){return this.getCustomDocumentEntry(S,a).undo(n,t)}async $redo(a,S,n,t){return this.getCustomDocumentEntry(S,a).redo(n,t)}async $revert(a,S,n){const t=this.getCustomDocumentEntry(S,a);await this.getCustomEditorProvider(S).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(a,S,n){const t=this.getCustomDocumentEntry(S,a);await this.getCustomEditorProvider(S).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(a,S,n,t){const r=this.getCustomDocumentEntry(S,a);return this.getCustomEditorProvider(S).saveCustomDocumentAs(r.document,k.URI.revive(n),t)}async $backup(a,S,n){const t=this.getCustomDocumentEntry(S,a),l=await this.getCustomEditorProvider(S).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(l),l.id}getCustomDocumentEntry(a,S){const n=this._documents.get(a,k.URI.revive(S));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(a){const n=this._editorProviders.get(a)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=R;function b(p){return typeof p.resolveCustomTextEditor=="function"}function s(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function o(p){const a=p.scheme===_.Schemas.file||p.scheme===_.Schemas.untitled?p.fsPath:p.toString();return(0,i.hash)(a)+""}});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[257],Se([0,1,3,6,2,33,17,68,5,7]),function(X,e,g,i,D,_,P,k,C,I){"use strict";var L,T,c,E,h,w,v,R,b,s,o,p,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends i.Disposable{constructor(l,d,m,f,u,y,A){super();L.set(this,void 0),T.set(this,void 0),c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),w.set(this,void 0),v.set(this,void 0),R.set(this,void 0),b.set(this,!0),s.set(this,!0),o.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=Fe(this,p,"f").event,a.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Fe(this,a,"f").event,tt(this,L,l,"f"),tt(this,T,d,"f"),tt(this,c,m,"f"),tt(this,h,y,"f"),tt(this,R,u,"f"),tt(this,w,f,"f"),tt(this,E,A,"f")}dispose(){Fe(this,o,"f")||(tt(this,o,!0,"f"),Fe(this,p,"f").fire(),Fe(this,T,"f").$disposeWebview(Fe(this,L,"f")),Fe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,c,"f")}get title(){return this.assertNotDisposed(),Fe(this,w,"f")}set title(l){this.assertNotDisposed(),Fe(this,w,"f")!==l&&(tt(this,w,l,"f"),Fe(this,T,"f").$setTitle(Fe(this,L,"f"),l))}get iconPath(){return this.assertNotDisposed(),Fe(this,v,"f")}set iconPath(l){this.assertNotDisposed(),Fe(this,v,"f")!==l&&(tt(this,v,l,"f"),Fe(this,T,"f").$setIconPath(Fe(this,L,"f"),D.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Fe(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,R,"f")=="number"&&Fe(this,R,"f")<0))return Fe(this,R,"f")}get active(){return this.assertNotDisposed(),Fe(this,s,"f")}get visible(){return this.assertNotDisposed(),Fe(this,b,"f")}_updateViewState(l){Fe(this,o,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,s,l.active,"f"),tt(this,b,l.visible,"f"),tt(this,R,l.viewColumn,"f"),Fe(this,a,"f").fire({webviewPanel:this}))}reveal(l,d){this.assertNotDisposed(),Fe(this,T,"f").$reveal(Fe(this,L,"f"),{viewColumn:l?P.ViewColumn.from(l):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Fe(this,o,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,c=new WeakMap,E=new WeakMap,h=new WeakMap,w=new WeakMap,v=new WeakMap,R=new WeakMap,b=new WeakMap,s=new WeakMap,o=new WeakMap,p=new WeakMap,a=new WeakMap;class n{constructor(l,d,m){this.webviews=d,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(l,d,m,f,u={}){const y=typeof f=="object"?f.viewColumn:f,A={viewColumn:P.ViewColumn.from(y),preserveFocus:typeof f=="object"&&!!f.preserveFocus},N=(0,k.shouldSerializeBuffersForPostMessage)(l),B=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(l),B,d,{title:m,panelOptions:t(u),webviewOptions:(0,k.serializeWebviewOptions)(l,this.workspace,u),serializeBuffersForPostMessage:N},A);const F=this.webviews.createNewWebview(B,u,l);return this.createNewWebviewPanel(B,d,m,y,u,F)}$onDidChangeWebviewPanelViewStates(l){const d=Object.keys(l);d.sort((m,f)=>{const u=l[m],y=l[f];return u.active?1:y.active?-1:+u.visible-+y.visible});for(const m of d){const f=this.getWebviewPanel(m);if(!f)continue;const u=l[m];f._updateViewState({active:u.active,visible:u.visible,viewColumn:P.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,d,m){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:m,extension:l}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(l)}),new I.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(l,d,m,f){const u=this._serializers.get(d);if(!u)throw new Error(`No serializer found for '${d}'`);const{serializer:y,extension:A}=u,N=this.webviews.createNewWebview(l,m.webviewOptions,A),B=this.createNewWebviewPanel(l,d,m.title,f,m.panelOptions,N);await y.deserializeWebviewPanel(B,m.state)}createNewWebviewPanel(l,d,m,f,u,y){const A=new S(l,this._proxy,d,m,f,u,y);return this._webviewPanels.set(l,A),A}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=n;function t(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[258],Se([0,1,3,6,68,5,7]),function(X,e,g,i,D,_,P){"use strict";var k,C,I,L,T,c,E,h,w,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class R extends i.Disposable{constructor(o,p,a,S,n,t){super();k.set(this,void 0),C.set(this,void 0),I.set(this,void 0),L.set(this,void 0),T.set(this,!1),c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Fe(this,w,"f").event,v.set(this,this._register(new g.Emitter)),this.onDidDispose=Fe(this,v,"f").event,tt(this,I,a,"f"),tt(this,E,S,"f"),tt(this,k,o,"f"),tt(this,C,p,"f"),tt(this,L,n,"f"),tt(this,c,t,"f")}dispose(){Fe(this,T,"f")||(tt(this,T,!0,"f"),Fe(this,v,"f").fire(),Fe(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,E,"f")}set title(o){this.assertNotDisposed(),Fe(this,E,"f")!==o&&(tt(this,E,o,"f"),Fe(this,C,"f").$setWebviewViewTitle(Fe(this,k,"f"),o))}get description(){return this.assertNotDisposed(),Fe(this,h,"f")}set description(o){this.assertNotDisposed(),Fe(this,h,"f")!==o&&(tt(this,h,o,"f"),Fe(this,C,"f").$setWebviewViewDescription(Fe(this,k,"f"),o))}get visible(){return Fe(this,c,"f")}get webview(){return Fe(this,L,"f")}get viewType(){return Fe(this,I,"f")}_setVisible(o){o===Fe(this,c,"f")||Fe(this,T,"f")||(tt(this,c,o,"f"),Fe(this,w,"f").fire())}show(o){this.assertNotDisposed(),Fe(this,C,"f").$show(Fe(this,k,"f"),!!o)}assertNotDisposed(){if(Fe(this,T,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,C=new WeakMap,I=new WeakMap,L=new WeakMap,T=new WeakMap,c=new WeakMap,E=new WeakMap,h=new WeakMap,w=new WeakMap,v=new WeakMap;class b{constructor(o,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,p,a,S){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:a,extension:o}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(o),p,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(o,p,a,S,n){const t=this._viewProviders.get(p);if(!t)throw new Error(`No view provider found for '${p}'`);const{provider:r,extension:l}=t,d=this._extHostWebview.createNewWebview(o,{},l),m=new R(o,this._proxy,p,a,d,!0);this._webviewViews.set(o,m),await r.resolveWebviewView(m,{state:S},n)}async $onDidChangeWebviewViewVisibility(o,p){this.getWebviewView(o)._setVisible(p)}async $disposeWebviewView(o){const p=this.getWebviewView(o);this._webviewViews.delete(o),p.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const p=this._webviewViews.get(o);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=b}),define(Ee[134],Se([0,1,3,5,2,10,8,4,14]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class zi{constructor(T){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=T.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,c){let E;if(typeof T=="string"){E=T;try{T=D.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,P.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,E,c)}async asExternalUri(T,c){if((0,P.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(T,c);return D.URI.from(E)}};I.InitialState={focused:!0},I=je([He(0,C.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(Ee[259],Se([0,1,9,81,33,38,6,5,2,14]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(c,E){super();const h=c.getProxy(k.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async w=>{const v=C.URI.file((0,g.join)((0,i.tmpdir)(),(0,D.generateUuid)()));return await h.$download(w,v),v})}};L=je([He(0,I.IExtHostRpcService),He(1,_.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Ee[260],Se([0,1,132,10,188,33]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends g.ExtHostLoggerService{doCreateLogger(C,I,L){return C.scheme===i.Schemas.file?new D.SpdLogLogger(L?.name||(0,_.generateUuid)(),C.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.doCreateLogger(C,I,L)}}e.ExtHostLoggerService=P}),define(Ee[261],Se([0,1,60,9,2,67,6,10,18,28]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends _.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const S=await super._getWorkspaceStorageURI(a);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const n=S.fsPath;let t=0;do{let r;t===0?r=n:r=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await T(r);const l=i.join(r,"vscode.lock"),d=await w(this._logService,l,!1);if(d)return this._workspaceStorageLock=d,process.on("exit",()=>{d.dispose()}),D.URI.file(r);t++}while(t<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(p){try{await I.Promises.stat(p);return}catch{}try{await I.Promises.mkdir(p,{recursive:!0})}catch{}}const c=1e3,E=10*60*1e3;class h extends P.Disposable{constructor(a,S){super();this.logService=a,this.filename=S,this._timer=this._register(new C.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await v(a,S);(!n||n.pid!==process.pid)&&(a.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(S,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${S}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+a};await I.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function w(p,a,S){try{const t={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){p.error(t)}const n=await v(p,a);return!n||n.pid!==process.pid?S?(p.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),s(p,a)):(p.info(`Lock '${a}': Lock acquired.`),new h(p,a))}async function v(p,a){let S;try{S=await I.Promises.readFile(a)}catch(n){return p.error(n),null}try{return JSON.parse(String(S))}catch(n){return p.error(n),null}}async function R(p,a){let S;try{S=await I.Promises.stat(a)}catch(n){return p.error(n),0}return S.mtime.getTime()}function b(p){try{return process.kill(p,0),!0}catch{return!1}}async function s(p,a){const S=await v(p,a);if(!S)return p.info(`Lock '${a}': Could not read pid of lock holder.`),o(p,a);if(S.willReleaseAt){let d=S.willReleaseAt-Date.now();if(d<5e3){for(d>0?p.info(`Lock '${a}': The lockfile is scheduled to be released in ${d} ms.`):p.info(`Lock '${a}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,C.timeout)(Math.min(100,d)),await R(p,a)===0)return o(p,a);d=S.willReleaseAt-Date.now()}return o(p,a)}}if(!b(S.pid))return p.info(`Lock '${a}': The pid ${S.pid} appears to be gone.`),o(p,a);const n=await R(p,a),t=Date.now()-n;if(t<=E)return p.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;p.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,C.timeout)(2e3);const r=await R(p,a),l=Date.now()-r;return l<=E?(p.info(`Lock '${a}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(p.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),o(p,a))}async function o(p,a){p.info(`Lock '${a}': Deleting a stale lock.`);try{await I.Promises.unlink(a)}catch{}return w(p,a,!0)}}),define(Ee[262],Se([0,1,33,14,34]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let _=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,C,I){return this.createTerminalFromOptions({name:k,shellPath:C,shellArgs:I})}createTerminalFromOptions(k,C){const I=new D.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),k,k.name);return this._terminals.push(I),I.create(k,this._serializeParentTerminal(k,C)),I.value}};_=je([He(0,i.IExtHostRpcService)],_),e.ExtHostTerminalService=_}),define(Ee[263],Se([0,1,5,14,171,6,26,2,37,23,28,7,12,52,3,121,78,11]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,f,u){this.remoteAddress=m,this.localAddress=f,this._dispose=u,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(d){const m=d.trim().split(`
`),f=[];return m.forEach(y=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(y);A&&A.length>=3&&f.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),f.reduce((y,A)=>(y[A.socket]=A,y),{})}e.getSockets=s;function o(...d){const m=[].concat(...d.map(a));return[...new Map(m.filter(f=>f.st==="0A").map(f=>{const u=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:p(u[0]),port:parseInt(u[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=o;function p(d){let m="";if(d.length===8)for(let f=d.length-2;f>=0;f-=2)m+=parseInt(d.substr(f,2),16),f!==0&&(m+=".");else for(let f=d.length-4;f>=0;f-=4)m+=parseInt(d.substr(f,4),16).toString(16),f!==0&&(m+=":");return m}e.parseIpAddress=p;function a(d){const m=d.trim().split(`
`),f=m.shift().trim().split(/\s+/).filter(y=>y!=="rx_queue"&&y!=="tm->when");return m.map(y=>y.trim().split(/\s+/).reduce((A,N,B)=>(A[f[B]||B]=N,A),{}))}e.loadConnectionTable=a;function S(d){return!!d.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||d.indexOf("out/vs/server/main.js")!==-1||d.indexOf("_productName=VSCode")!==-1}function n(d){const m=d.trim().split(`
`),f=[];return m.forEach(u=>{const y=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(u);y&&y.length>=4&&f.push({pid:parseInt(y[1],10),ppid:parseInt(y[2]),cmd:y[3]})}),f}e.getRootProcesses=n;async function t(d,m,f){const u=f.reduce((A,N)=>(A[N.pid]=N,A),{}),y=[];return d.forEach(({socket:A,ip:N,port:B})=>{const F=m[A]?m[A].pid:void 0,O=F?u[F]?.cmd:void 0;F&&O&&!S(O)&&y.push({host:N,port:B,detail:O,pid:F})}),y}e.findPorts=t;function r(d,m,f){const u=new Map,y=n(m);for(const A of d){const N=f.get(A.port);if(N){u.set(A.port,N);continue}const B=y.find(F=>F.cmd.includes(`${A.port}`));if(B){let F=B,O;do O=y.find(z=>z.ppid===F.pid),O&&(F=O);while(O);u.set(A.port,{host:A.ip,port:A.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else u.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return u}e.tryFindRootPorts=r;let l=class extends _.Disposable{constructor(m,f,u){super();this.logService=u,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),c.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const u=await this._proxy.$openTunnel(f,m.displayName);if(u){const y=new b(u.remoteAddress,u.localAddress,()=>this._proxy.$closeTunnel(u.remoteAddress));return this._register(y),y}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,f){const u=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(u,{selector:m,provider:f}),this._proxy.$registerPortsAttributesProvider(m,u),new T.Disposable(()=>{this._portAttributesProviders.delete(u),this._proxy.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(m,f,u,y,A){const N=[];for(const F of m){const O=this._portAttributesProviders.get(F);if(!O)return[];N.push(...await Promise.all(f.map(async z=>O.provider.providePortAttributes(z,u,y,A))))}const B=N.filter(F=>!!F);return B.length>0?B.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let f=new v.MovingAverage,u;for(;this._candidateFindingEnabled;){const y=new Date().getTime(),A=(await this.findCandidatePorts()).filter(B=>(0,w.isLocalhost)(B.host)||(0,w.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-y;f.update(N),(!u||JSON.stringify(u)!==JSON.stringify(A))&&(u=A,await this._proxy.$onFoundNewCandidates(u)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(f.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let f=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:f})}}else this._forwardPortProvider=void 0;return(0,_.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,f){if(this._extensionTunnels.has(m.host)){const u=this._extensionTunnels.get(m.host);u.has(m.port)&&(f&&u.get(m.port).disposeListener.dispose(),await u.get(m.port).tunnel.dispose(),u.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this._forwardPortProvider(m,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const y=await u;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const A=this._register(y.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(y.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:y,disposeListener:A}),E.TunnelDto.fromApiTunnel(y)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const f=await Promise.all(m.map(y=>this._showCandidatePort(y.host,y.port,y.detail??""))),u=m.filter((y,A)=>f[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(y=>y.port).join(", ")} to ${u.map(y=>y.port).join(", ")}`),u}async findCandidatePorts(){let m="",f="";try{m=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const u=o(m,f),y=await new Promise(M=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,V,U)=>{M(V)})}),A=s(y),N=await L.Promises.readdir("/proc"),B=[];for(let M of N)try{const x=Number(M),V=I.joinPath(k.URI.file("/proc"),M);if((await L.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(x)){const H=await L.Promises.readlink(I.joinPath(V,"cwd").fsPath),Y=await L.Promises.readFile(I.joinPath(V,"cmdline").fsPath,"utf8");B.push({pid:x,cwd:H,cmd:Y})}}catch{}const F=[],O=u.filter(M=>{const x=A[M.socket];return x||F.push(M),x}),z=t(O,A,B);let W;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const M=await new Promise(x=>{(0,C.exec)("ps -F -A -l | grep root",(V,U,H)=>{x(U)})});this._foundRootPorts=r(F,M,this._foundRootPorts),W=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.join(", ")}`)}return z.then(M=>W?M.concat(W):M)}};l=je([He(0,i.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,R.ILogService)],l),e.ExtHostTunnelService=l}),define(Ee[264],Se([0,1,18,22,21,15,3,6,103,228,53]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(u,y){try{return JSON.stringify(u,y)}catch{return"null"}}const E="$$ref$$",h={[E]:-1};class w{constructor(y,A){this.jsonString=y,this.referencedBuffers=A}}function v(u,y=null,A=!1){const N=[];return{jsonString:(A?c:JSON.stringify)(u,(F,O)=>{if(typeof O=="undefined")return h;if(typeof O=="object"){if(O instanceof i.VSBuffer){const z=N.push(O)-1;return{[E]:z}}if(y)return y(F,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=v;function R(u,y,A){return JSON.parse(u,(N,B)=>{if(B){const F=B[E];if(typeof F=="number")return y[F];if(A&&B.$mid===1)return A.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=R;function b(u,y){return JSON.stringify(u,y)}function s(u){return u?(y,A)=>A&&A.$mid===1?u.transformOutgoing(A):A:null}var o;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},S=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(y,A=null,N=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=y,this._logger=A,this._uriTransformer=N,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,F=L.ProxyIdentifier.count;B<F;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(y=>{this._pendingRPCReplies[y].resolveErr(_.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(y){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(y){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(y){this._responsiveState!==y&&(this._responsiveState=y,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(y){return this._uriTransformer?(0,C.transformIncomingURIs)(y,this._uriTransformer):y}getProxy(y){const{nid:A,sid:N}=y;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,N)),this._proxies[A]}_createProxy(y,A){let N={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===36&&(B[F]=(...O)=>this._remoteCall(y,F,O)),F===n?A:B[F])};return new Proxy(Object.create(null),N)}set(y,A){return this._locals[y.nid]=A,A}assertRegistered(y){for(let A=0,N=y.length;A<N;A++){const B=y[A];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(y){if(this._isDisposed)return;const A=y.byteLength,N=r.read(y,0),B=N.readUInt8(),F=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:O,method:z,args:W}=d.deserializeRequestJSONArgs(N);this._uriTransformer&&(W=(0,C.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(A,F,O,z,W,B===2);break}case 3:case 4:{let{rpcId:O,method:z,args:W}=d.deserializeRequestMixedArgs(N);this._uriTransformer&&(W=(0,C.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(A,F,O,z,W,B===4);break}case 5:{this._logger&&this._logger.logIncoming(A,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(A,F);break}case 7:{this._receiveReply(A,F,void 0);break}case 9:{let O=d.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(A,F,O);break}case 10:{const O=d.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(A,F,O);break}case 8:{let O=d.deserializeReplyOKVSBuffer(N);this._receiveReply(A,F,O);break}case 11:{let O=d.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(A,F,O);break}case 12:{this._receiveReplyErr(A,F,void 0);break}default:console.error("received unexpected message"),console.error(y)}}_receiveRequest(y,A,N,B,F,O){this._logger&&this._logger.logIncoming(y,A,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${B}(`,F);const z=String(A);let W,M;if(O){const V=new D.CancellationTokenSource;F.push(V.token),W=this._invokeHandler(N,B,F),M=()=>V.cancel()}else W=this._invokeHandler(N,B,F),M=a;this._cancelInvokedHandlers[z]=M;const x=d.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(x.byteLength,A,1,"ack"),this._protocol.send(x),W.then(V=>{delete this._cancelInvokedHandlers[z];const U=d.serializeReplyOK(A,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,A,1,"reply:",V),this._protocol.send(U)},V=>{delete this._cancelInvokedHandlers[z];const U=d.serializeReplyErr(A,V);this._logger&&this._logger.logOutgoing(U.byteLength,A,1,"replyErr:",V),this._protocol.send(U)})}_receiveCancel(y,A){this._logger&&this._logger.logIncoming(y,A,1,"receiveCancel");const N=String(A);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(y,A,N){this._logger&&this._logger.logIncoming(y,A,0,"receiveReply:",N);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],F.resolveOk(N)}_receiveReplyErr(y,A,N){this._logger&&this._logger.logIncoming(y,A,0,"receiveReplyErr:",N);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),F.resolveErr(O)}_invokeHandler(y,A,N){try{return Promise.resolve(this._doInvokeHandler(y,A,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(y,A,N){const B=this._locals[y];if(!B)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(y));let F=B[A];if(typeof F!="function")throw new Error("Unknown method "+A+" on actor "+(0,L.getStringIdentifierForProxy)(y));return F.apply(B,N)}_remoteCall(y,A,N){if(this._isDisposed)return Promise.reject(_.canceled());let B=null;if(N.length>0&&D.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(_.canceled());const F=d.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),W=new I.LazyPromise;B&&B.onCancellationRequested(()=>{const x=d.serializeCancel(O);this._logger&&this._logger.logOutgoing(x.byteLength,O,0,"cancel"),this._protocol.send(d.serializeCancel(O))}),this._pendingRPCReplies[z]=W,this._onWillSendRequest(O);const M=d.serializeRequest(O,y,A,F,!!B);return this._logger&&this._logger.logOutgoing(M.byteLength,O,0,`request: ${(0,L.getStringIdentifierForProxy)(y)}.${A}(`,N),this._protocol.send(M),W}}e.RPCProtocol=t,T=S,t.UNRESPONSIVE_TIME=3*1e3;class r{constructor(y,A){this._buff=y,this._offset=A}static alloc(y,A,N){let B=new r(i.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(y),B.writeUInt32(A),B}static read(y,A){return new r(y,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(y){this._buff.writeUInt8(y,this._offset),this._offset+=1}readUInt8(){const y=this._buff.readUInt8(this._offset);return this._offset+=1,y}writeUInt32(y){this._buff.writeUInt32BE(y,this._offset),this._offset+=4}readUInt32(){const y=this._buff.readUInt32BE(this._offset);return this._offset+=4,y}static sizeShortString(y){return 1+y.byteLength}writeShortString(y){this._buff.writeUInt8(y.byteLength,this._offset),this._offset+=1,this._buff.set(y,this._offset),this._offset+=y.byteLength}readShortString(){const y=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+y).toString();return this._offset+=y,N}static sizeLongString(y){return 4+y.byteLength}writeLongString(y){this._buff.writeUInt32BE(y.byteLength,this._offset),this._offset+=4,this._buff.set(y,this._offset),this._offset+=y.byteLength}readLongString(){const y=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+y).toString();return this._offset+=y,N}writeBuffer(y){this._buff.writeUInt32BE(y.byteLength,this._offset),this._offset+=4,this._buff.set(y,this._offset),this._offset+=y.byteLength}static sizeVSBuffer(y){return 4+y.byteLength}writeVSBuffer(y){this._buff.writeUInt32BE(y.byteLength,this._offset),this._offset+=4,this._buff.set(y,this._offset),this._offset+=y.byteLength}readVSBuffer(){const y=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+y);return this._offset+=y,A}static sizeMixedArray(y){let A=0;A+=1;for(let N=0,B=y.length;N<B;N++){const F=y[N];switch(A+=1,F.type){case 1:A+=this.sizeLongString(F.value);break;case 2:A+=this.sizeVSBuffer(F.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(F.value);for(let O=0;O<F.buffers.length;++O)A+=this.sizeVSBuffer(F.buffers[O]);break;case 4:break}}return A}writeMixedArray(y){this._buff.writeUInt8(y.length,this._offset),this._offset+=1;for(let A=0,N=y.length;A<N;A++){const B=y[A];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const y=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(y);for(let N=0;N<y;N++)switch(this.readUInt8()){case 1:A[N]=this.readLongString();break;case 2:A[N]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),O=this.readLongString(),z=[];for(let W=0;W<F;++W)z.push(this.readVSBuffer());A[N]=new L.SerializableObjectWithBuffers(R(O,z,null));break}case 4:A[N]=void 0;break}return A}}r.sizeUInt32=4;var l;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(l||(l={}));class d{static _useMixedArgSerialization(y){for(let A=0,N=y.length;A<N;A++)if(y[A]instanceof i.VSBuffer||y[A]instanceof L.SerializableObjectWithBuffers||typeof y[A]=="undefined")return!0;return!1}static serializeRequestArguments(y,A){if(this._useMixedArgSerialization(y)){const N=[];for(let B=0,F=y.length;B<F;B++){const O=y[B];if(O instanceof i.VSBuffer)N[B]={type:2,value:O};else if(typeof O=="undefined")N[B]={type:4};else if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:W}=v(O.value,A);N[B]={type:3,value:i.VSBuffer.fromString(z),buffers:W}}else N[B]={type:1,value:i.VSBuffer.fromString(b(O,A))}}return{type:1,args:N}}return{type:0,args:b(y,A)}}static serializeRequest(y,A,N,B,F){switch(B.type){case 0:return this._requestJSONArgs(y,A,N,B.args,F);case 1:return this._requestMixedArgs(y,A,N,B.args,F)}}static _requestJSONArgs(y,A,N,B,F){const O=i.VSBuffer.fromString(N),z=i.VSBuffer.fromString(B);let W=0;W+=r.sizeUInt8(),W+=r.sizeShortString(O),W+=r.sizeLongString(z);let M=r.alloc(F?2:1,y,W);return M.writeUInt8(A),M.writeShortString(O),M.writeLongString(z),M.buffer}static deserializeRequestJSONArgs(y){const A=y.readUInt8(),N=y.readShortString(),B=y.readLongString();return{rpcId:A,method:N,args:JSON.parse(B)}}static _requestMixedArgs(y,A,N,B,F){const O=i.VSBuffer.fromString(N);let z=0;z+=r.sizeUInt8(),z+=r.sizeShortString(O),z+=r.sizeMixedArray(B);let W=r.alloc(F?4:3,y,z);return W.writeUInt8(A),W.writeShortString(O),W.writeMixedArray(B),W.buffer}static deserializeRequestMixedArgs(y){const A=y.readUInt8(),N=y.readShortString(),B=y.readMixedArray(),F=new Array(B.length);for(let O=0,z=B.length;O<z;O++){const W=B[O];typeof W=="string"?F[O]=JSON.parse(W):F[O]=W}return{rpcId:A,method:N,args:F}}static serializeAcknowledged(y){return r.alloc(5,y,0).buffer}static serializeCancel(y){return r.alloc(6,y,0).buffer}static serializeReplyOK(y,A,N){if(typeof A=="undefined")return this._serializeReplyOKEmpty(y);if(A instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(y,A);if(A instanceof L.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:F}=v(A.value,N,!0);return this._serializeReplyOKJSONWithBuffers(y,B,F)}else return this._serializeReplyOKJSON(y,c(A,N))}static _serializeReplyOKEmpty(y){return r.alloc(7,y,0).buffer}static _serializeReplyOKVSBuffer(y,A){let N=0;N+=r.sizeVSBuffer(A);let B=r.alloc(8,y,N);return B.writeVSBuffer(A),B.buffer}static deserializeReplyOKVSBuffer(y){return y.readVSBuffer()}static _serializeReplyOKJSON(y,A){const N=i.VSBuffer.fromString(A);let B=0;B+=r.sizeLongString(N);let F=r.alloc(9,y,B);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(y,A,N){const B=i.VSBuffer.fromString(A);let F=0;F+=r.sizeUInt32,F+=r.sizeLongString(B);for(const z of N)F+=r.sizeVSBuffer(z);let O=r.alloc(10,y,F);O.writeUInt32(N.length),O.writeLongString(B);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(y){const A=y.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(y,A){const N=y.readUInt32(),B=y.readLongString(),F=[];for(let O=0;O<N;++O)F.push(y.readVSBuffer());return new L.SerializableObjectWithBuffers(R(B,F,A))}static serializeReplyErr(y,A){return A?this._serializeReplyErrEror(y,A):this._serializeReplyErrEmpty(y)}static _serializeReplyErrEror(y,A){const N=i.VSBuffer.fromString(c(_.transformErrorForSerialization(A),null));let B=0;B+=r.sizeLongString(N);let F=r.alloc(11,y,B);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(y){const A=y.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(y){return r.alloc(12,y,0).buffer}}var m;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var f;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(f||(f={}))}),define(Ee[265],Se([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(Ee[266],Se([0,1,10,9,12,2,4,62,43,223,265]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let T=class Vi{constructor(E,h,w,v){this.localUserHome=E,this.remoteAgentService=h,this.environmentService=w,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const R=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=R?.userHome||E})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,h){if(E.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const R=h.getWorkspace().configuration;return R?R.scheme:g.Schemas.file}async userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?i.win32:i.posix)}async fileURI(E){let h="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const v=E.indexOf("/",2);v===-1?(h=E.substring(2),E="/"):(h=E.substring(2,v),E=E.substring(v)||"/")}return _.URI.from({scheme:g.Schemas.file,authority:h,path:E,query:"",fragment:""})}};T=je([He(1,L.IRemoteAgentService),He(2,I.IWorkbenchEnvironmentService),He(3,C.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ee[69],Se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(P,k){this.line=P,this.character=k}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,k){return new g(0,0)}with(P){return new g(0,0)}}e.Position=g;class i{constructor(P,k,C,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(P,k),this.end=new g(C,I)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new i(0,0,0,0)}with(P){return new i(0,0,0,0)}}e.Range=i;var D;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[32],Se([0,1,16,31,25,30,8,4,9,15,69,13]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",E=" characters skipped \u27EB",h=(c.length+E.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function R(x){return!!x.preview}e.resultIsMatch=R;function b(x){return!!x.resource}e.isFileMatch=b;function s(x){return!!x.message}e.isProgressMessage=s;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=p;class a{constructor(V,U,H){this.ranges=U;const Y=Array.isArray(U)?U:[U];if(H&&H.matchLines===1&&S(Y)){V=(0,P.getNLines)(V,H.matchLines);let re="",K=0,j=0;const te=Math.floor(H.charsPerLine/5),ae=[];for(const ge of Y){const Ie=Math.max(ge.startColumn-te,0),Me=ge.startColumn+H.charsPerLine;if(Ie>j+te+h){const Ne=c+(Ie-j)+E;re+=Ne+V.slice(Ie,Me),K+=Ie-(j+Ne.length)}else re+=V.slice(j,Me);ae.push(new t(0,ge.startColumn-K,ge.endColumn-K)),j=Me}this.preview={text:re,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const re=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:V,matches:(0,g.mapArrayOrNot)(U,K=>new n(K.startLineNumber-re,K.startColumn,K.endLineNumber-re,K.endColumn))}}}}e.TextSearchMatch=a;function S(x){const V=x[0].startLineNumber;for(const U of x)if(U.startLineNumber!==V||U.endLineNumber!==V)return!1;return!0}class n{constructor(V,U,H,Y){this.startLineNumber=V,this.startColumn=U,this.endLineNumber=H,this.endColumn=Y}}e.SearchRange=n;class t extends n{constructor(V,U,H){super(V,U,V,H)}}e.OneLineRange=t;var r;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function l(x,V=!0){const U=x&&x.files&&x.files.exclude,H=V&&x&&x.search&&x.search.exclude;if(!U&&!H)return;if(!U||!H)return U||H;let Y=Object.create(null);return Y=D.mixin(Y,D.deepClone(U)),Y=D.mixin(Y,D.deepClone(H),!0),Y}e.getExcludes=l;function d(x,V){return x.excludePattern&&i.match(x.excludePattern,V)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&i.match(x.includePattern,V)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(U=>{const H=U.folder.fsPath;if(_.isEqualOrParent(V,H)){const Y=C.relative(H,V);return!U.includePattern||!!i.match(U.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(V,U){super(V);this.code=U}}e.SearchError=f;function u(x){const V=x.message;if((0,I.isPromiseCanceledError)(x))return new f(V,m.canceled);try{const U=JSON.parse(V);return new f(U.message,U.code)}catch{return new f(V,m.other)}}e.deserializeSearchError=u;function y(x){const V={message:x.message,code:x.code};return new Error(JSON.stringify(V))}e.serializeSearchError=y;function A(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=A;function N(x){return x.type==="success"}e.isSerializedSearchSuccess=N;function B(x){return!!x.path}e.isSerializedFileMatch=B;function F(x,V){const U=x.searchPath?x.searchPath:x.relativePath;return(0,P.fuzzyContains)(U,V)}e.isFilePatternMatch=F;class O{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(x,V){const U={...x||{},...V||{}};return Object.keys(U).filter(H=>{const Y=U[H];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=z;class W{constructor(V,U){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let H=V.includePattern;U.includePattern&&(H?H={...H,...U.includePattern}:H=U.includePattern),H&&(this._parsedIncludeExpression=i.parse(H))}matchesExcludesSync(V,U,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,U,H))}includedInQuerySync(V,U,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,U,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,U,H))}includedInQuery(V,U,H){const Y=this._parsedExcludeExpression(V,U,H),re=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,U,H):!0;return(0,T.isPromise)(Y)?Y.then(K=>K?!1:re()):re()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=W;function M(x){for(const V in x)if(typeof x[V]!="boolean")return!0;return!1}}),define(Ee[35],Se([0,1,16,18,21,3,24,10,78,23,8,13,2,169,4,11,189,43,44,26,14,7,32,5]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s,o,p,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(y,A,N){return new I.ExtUri(B=>d(B,N)).isEqual(y,A)}function t(y,A,N){return n(y.uri,A.uri,N)?0:(0,L.compare)(y.uri.toString(),A.uri.toString())}function r(y,A,N){return y.index!==A.index?y.index<A.index?-1:1:n(y.uri,A.uri,N)?(0,L.compare)(y.name,A.name):(0,L.compare)(y.uri.toString(),A.uri.toString())}function l(y,A,N,B){const F=y.slice(0).sort((z,W)=>N(z,W,B)),O=A.slice(0).sort((z,W)=>N(z,W,B));return(0,g.delta)(F,O,(z,W)=>N(z,W,B))}function d(y,A){const N=A.getCapabilities(y.scheme);return!(N&&N&1024)}class m extends R.Workspace{constructor(A,N,B,F,O,z,W){super(A,B.map(M=>new R.WorkspaceFolder(M)),F,O,W);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(W),B.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(A,N,B,F){if(!A)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:W,configuration:M,transient:x,isUntitled:V}=A,U=[],H=N;N?W.forEach((j,te)=>{const ae=c.URI.revive(j.uri),ge=m._findFolder(B||N,ae,F);ge?(ge.name=j.name,ge.index=j.index,U.push(ge)):U.push({uri:ae,name:j.name,index:te})}):U.push(...W.map(({uri:j,name:te,index:ae})=>({uri:c.URI.revive(j),name:te,index:ae}))),U.sort((j,te)=>j.index<te.index?-1:1);const Y=new m(O,z,U,!!x,M?c.URI.revive(M):null,!!V,j=>d(j,F)),{added:re,removed:K}=l(H?H.workspaceFolders:[],Y.workspaceFolders,t,F);return{workspace:Y,added:re,removed:K}}static _findFolder(A,N,B){for(let F=0;F<A.folders.length;F++){const O=A.workspaceFolders[F];if(n(O.uri,N,B))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,N){return N&&this._structure.get(A)&&(A=(0,I.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let f=class{constructor(A,N,B,F){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=B,this._requestIdProvider=new C.Counter,this._barrier=new i.Barrier,this._proxy=A.getProxy(S.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(S.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new m(O.id,O.name,[],!!O.transient,O.configuration?c.URI.revive(O.configuration):null,!!O.isUntitled,z=>d(z,B)):void 0}$initializeWorkspace(A,N){this._trusted=N,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,N,B,...F){const O=[];if(Array.isArray(F)&&F.forEach(V=>{c.URI.isUri(V.uri)&&!O.some(U=>n(U.uri,V.uri,this._extHostFileSystemInfo))&&O.push({uri:V.uri,name:V.name||(0,I.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[N,B].some(V=>typeof V!="number"||V<0)||B===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>z.length)return!1;const W=z.slice(0);W.splice(N,B,...O.map(V=>({uri:V.uri,name:V.name||(0,I.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<W.length;V++){const U=W[V];if(W.some((H,Y)=>Y!==V&&n(U.uri,H.uri,this._extHostFileSystemInfo)))return!1}W.forEach((V,U)=>V.index=U);const{added:M,removed:x}=l(z,W,r,this._extHostFileSystemInfo);if(M.length===0&&x.length===0)return!1;if(this._proxy){const V=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(V,N,B,O).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,E.localize)(0,null,V,U.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(A,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async getWorkspaceFolder2(A,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,N){let B,F="";if(typeof A=="string"?(B=c.URI.file(A),F=A):typeof A!="undefined"&&(B=A,F=A.fsPath),!B)return F;const O=this.getWorkspaceFolder(B,!0);if(!O)return F;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,I.relativePath)(O.uri,B);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:N,added:B,removed:F}=m.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:F}))}findFiles(A,N,B,F,O=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:M}=u(A);return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(W),(0,T.withUndefinedAsNull)(M),(0,T.withUndefinedAsNull)(z),(0,T.withUndefinedAsNull)(B),O).then(x=>Array.isArray(x)?x.map(V=>c.URI.revive(V)):[])}async findTextInFiles(A,N,B,F,O=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),W=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:M,folder:x}=u(N.include),V=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,U={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:W,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:M,excludePattern:V},H=!1;if(this._activeSearchCallbacks[z]=Y=>{if(H)return;const re=c.URI.revive(Y.resource);Y.results.forEach(K=>{(0,a.resultIsMatch)(K)?B({uri:re,preview:{text:K.preview.text,matches:(0,g.mapArrayOrNot)(K.preview.matches,j=>new p.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))},ranges:(0,g.mapArrayOrNot)(K.ranges,j=>new p.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))}):B({uri:re,text:K.text,lineNumber:K.lineNumber})})},O.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(A,(0,T.withUndefinedAsNull)(x),U,z,O);return delete this._activeSearchCallbacks[z],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[z],Y}}$handleTextSearchResult(A,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};f=je([He(0,o.IExtHostRpcService),He(1,s.IExtHostInitDataService),He(2,b.IExtHostFileSystemInfo),He(3,w.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function u(y){let A,N;return y&&(typeof y=="string"?A=y:(A=y.pattern,N=y.baseFolder||c.URI.file(y.base))),{includePattern:A,folder:N}}}),define(Ee[36],Se([0,1,25,3,35,5,7,193,119,13,18,4,14,11,2]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(S,n){if(n){const t=n.split(".");let r=S;for(let l=0;r&&l<t.length;l++)r=r[t[l]];return r}}function v(S){return S instanceof h.URI}function R(S){return S&&S.uri instanceof h.URI&&S.languageId&&typeof S.languageId=="string"}function b(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function s(S){return S&&S.uri instanceof h.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function o(S){if(v(S))return{resource:S};if(R(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(b(S))return{overrideIdentifier:S.languageId};if(s(S))return{resource:S.uri};if(S===null)return{resource:null}}let p=class{constructor(n,t,r){this._proxy=n.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new a(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(n,t))}};p=je([He(0,c.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,E.ILogService)],p),e.ExtHostConfiguration=p;class a{constructor(n,t,r,l){this._onDidChangeConfiguration=new i.Emitter,this._proxy=n,this._logService=l,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,r))}getConfiguration(n,t,r){const l=o(t)||{},d=this._toReadonlyValue(n?w(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,l,r?.identifier);function m(u){if(u==null)return null;if(typeof u=="boolean")return u?1:4;switch(u){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(u){return typeof w(d,u)!="undefined"},get:(u,y)=>{this._validateConfigurationAccess(n?`${n}.${u}`:u,l,r?.identifier);let A=w(d,u);if(typeof A=="undefined")A=y;else{let N;const B=(F,O)=>{let z;const W=()=>{N=N||(0,g.deepClone)(d),z=z||w(N,O)};return(0,I.isObject)(F)?new Proxy(F,{get:(M,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return W(),()=>z;if(N)return z=z||w(N,O),z[x];const V=M[x];return typeof x=="string"?B(V,`${O}.${x}`):V},set:(M,x,V)=>(W(),z&&(z[x]=V),!0),deleteProperty:(M,x)=>(W(),z&&delete z[x],!0),defineProperty:(M,x,V)=>(W(),z&&Object.defineProperty(z,x,V),!0)}):F};A=B(A,u)}return A},update:(u,y,A,N)=>{u=n?`${n}.${u}`:u;const B=m(A);return y!==void 0?this._proxy.$updateConfigurationOption(B,u,y,l,N):this._proxy.$removeConfigurationOption(B,u,l,N)},inspect:u=>{u=n?`${n}.${u}`:u;const y=(0,g.deepClone)(this._configuration.inspect(u,l,this._extHostWorkspace.workspace));if(y)return{key:u,defaultValue:y.default?.value,globalValue:y.user?.value,workspaceValue:y.workspace?.value,workspaceFolderValue:y.workspaceFolder?.value,defaultLanguageValue:y.default?.override,globalLanguageValue:y.user?.override,workspaceLanguageValue:y.workspace?.override,workspaceFolderLanguageValue:y.workspaceFolder?.override,languageIds:y.overrideIdentifiers}}};return typeof d=="object"&&(0,g.mixin)(f,d,!1),Object.freeze(f)}_toReadonlyValue(n){const t=r=>(0,I.isObject)(r)?new Proxy(r,{get:(l,d)=>t(l[d]),set:(l,d,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(l,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(l,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return t(n)}_validateConfigurationAccess(n,t,r){const l=C.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),d=r?`[${r.value}] `:"";if(l===4){typeof t?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){t?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const r=new k.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,d)=>r.affectsConfiguration(l,o(d))})}_toMap(n){return n.reduce((t,r)=>(t.set(r[0],r[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[70],Se([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,213,15]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s,o){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(O){function z(x){if(x){const V=x;return V&&!!V.process}else return!1}O.is=z;function W(x){if(x==null)return;const V={process:x.process,args:x.args};return x.options&&(V.options=n.from(x.options)),V}O.from=W;function M(x){if(x!=null)return new P.ProcessExecution(x.process,x.args,x.options)}O.to=M})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(O){function z(x){if(x){const V=x;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=z;function W(x){if(x==null)return;const V={};return x.commandLine!==void 0?V.commandLine=x.commandLine:(V.command=x.command,V.args=x.args),x.options&&(V.options=r.from(x.options)),V}O.from=W;function M(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new P.ShellExecution(x.commandLine,x.options):new P.ShellExecution(x.command,x.args?x.args:[],x.options)}O.to=M})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(O){function z(x){if(x){let V=x;return V&&V.customExecution==="customExecution"}else return!1}O.is=z;function W(x){return{customExecution:"customExecution"}}O.from=W;function M(x,V){return V.get(x)}O.to=M})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(O){function z(W,M){let x;return W.scope!==void 0&&typeof W.scope!="number"?x=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===P.TaskScope.Workspace&&M&&M.workspaceFile?x=M.workspaceFile:x=s.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:x}}O.from=z})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(O){function z(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}O.from=z})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var u;(function(O){function z(x,V){if(x==null)return[];const U=[];for(let H of x){const Y=W(H,V);Y&&U.push(Y)}return U}O.fromMany=z;function W(x,V){if(x==null)return;let U;x.execution instanceof P.ProcessExecution?U=t.from(x.execution):x.execution instanceof P.ShellExecution?U=l.from(x.execution):x.execution&&x.execution instanceof P.CustomExecution&&(U=d.from(x.execution));const H=a.from(x.definition);let Y;return x.scope?typeof x.scope=="number"?Y=x.scope:Y=x.scope.uri:Y=P.TaskScope.Workspace,!H||!Y?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:V.identifier.value,label:x.source,scope:Y},execution:U,isBackground:x.isBackground,group:f.from(x.group),presentationOptions:S.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}O.from=W;async function M(x,V,U){if(x==null)return;let H;t.is(x.execution)?H=t.to(x.execution):l.is(x.execution)?H=l.to(x.execution):d.is(x.execution)&&(H=d.to(x._id,U));const Y=a.to(x.definition);let re;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?re=x.source.scope:re=await V.resolveWorkspaceFolder(g.URI.revive(x.source.scope)):re=P.TaskScope.Workspace),!Y||!re)return;const K=new P.Task(Y,re,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=P.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new P.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=S.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}O.to=M})(u=e.TaskDTO||(e.TaskDTO={}));var y;(function(O){function z(M){return M}O.from=z;function W(M){if(!!M)return Object.assign(Object.create(null),M)}O.to=W})(y=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(z,W,M){this._id=W,this._task=M,p.set(this,void 0),tt(this,p,z,"f")}get task(){return this._task}terminate(){Fe(this,p,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}p=new WeakMap;var N;(function(O){function z(W){return{id:W._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,W,M,x,V,U,H,Y){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=z.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=x,this._configurationService=V,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,W,M){if(!M)return new P.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:W,provider:M,extension:z}),this._proxy.$registerTaskProvider(x,W),new P.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(z,W){this._proxy.$registerTaskSystem(z,W)}fetchTasks(z){return this._proxy.$fetchTasks(y.from(z)).then(async W=>{const M=[];for(let x of W){const V=await u.to(x,this._workspaceProvider,this._providedCustomExecutions2);V&&M.push(V)}return M})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(W=>z.push(W)),z}terminateTask(z){if(!(z instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,W,M){const x=this._providedCustomExecutions2.get(z.id);x&&(this._activeCustomExecutions2.set(z.id,x),this._terminalService.attachPtyToTerminal(W,await x.callback(M))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const W=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const W=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:W,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const W=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:z.exitCode})}$provideTasks(z,W){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));const x=[],V=(0,i.asPromise)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(U=>this.provideTasksInternal(W,x,M,U));return new Promise(U=>{V.then(H=>{Promise.all(x).then(()=>{U(H)})})})}async $resolveTask(z,W){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));if(W.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${M.type}].`);const x=await u.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const V=await M.provider.resolveTask(x,L.CancellationToken.None);if(!V)return;this.checkDeprecation(V,M);const U=u.from(V,M.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(U.execution)&&await this.addCustomExecution(U,V,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,W,M){const x=await this._proxy.$createTaskId(z);!M&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,W.execution)),this._providedCustomExecutions2.set(x,W.execution)}async getTaskExecution(z,W){if(typeof z=="string"){const V=this._taskExecutionPromises.get(z);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let M=this._taskExecutionPromises.get(z.id);if(M)return M;const x=new Promise((V,U)=>{function H(Y,re,K){K?V(new A(Y,re.id,K)):U("Unexpected: Task does not exist.")}W?H(this,z,W):u.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>H(this,z,Y))});return this._taskExecutionPromises.set(z.id,x),x.then(V=>(this._taskExecutions.set(z.id,V),V),V=>Promise.reject(V))}checkDeprecation(z,W){z._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let M=this._notProvidedCustomExecutions.values(),x=M.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=M.next()}};B=je([He(0,c.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,R.ILogService),He(7,b.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let F=class extends B{constructor(z,W,M,x,V,U,H,Y){super(z,W,M,x,V,U,H,Y);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(z,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const M=u.from(W,z);if(M===void 0)throw new Error("Task is not valid");if(d.is(M.execution))await this.addCustomExecution(M,W,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),W);return this._proxy.$executeTask(M).catch(V=>{throw new Error(V)}),x}provideTasksInternal(z,W,M,x){const V=[];if(x)for(let U of x){this.checkDeprecation(U,M),(!U.definition||!z[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const H=u.from(U,M.extension);H&&d.is(H.execution)?(V.push(H),W.push(this.addCustomExecution(H,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:M.extension}}async resolveTaskInternal(z){if(d.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,W,M){}};F=je([He(0,c.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,R.ILogService),He(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(Ee[267],Se([0,1,16,74,31,80,24,10,9,23,8,13,2,146,175,116,43,128,266,32]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(m,f,u,y){this.configurationService=m,this.workspaceContextService=f,this.editorGroupsService=u,this.pathService=y}text(m,f,u={}){m=this.getContentPattern(m,u);const y=this.configurationService.getValue(),A=f&&f.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(f?.map(v.toWorkspaceFolder),u),type:2,contentPattern:m,previewOptions:u.previewOptions,maxFileSize:u.maxFileSize,usePCRE2:y.search.usePCRE2||A||!1,beforeContext:u.beforeContext,afterContext:u.afterContext,userDisabledExcludesAndIgnoreFiles:u.disregardExcludeSettings&&u.disregardIgnoreFiles}}getContentPattern(m,f){const u=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const y={...m,wordSeparators:u.editor.wordSeparators};return this.isCaseSensitive(m,f)&&(y.isCaseSensitive=!0),this.isMultiline(m)&&(y.isMultiline=!0),y}file(m,f={}){return{...this.commonQuery(m,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(m,f){return m?(m=Array.isArray(m)?m.map(t):t(m),f?this.parseSearchPaths(m):{pattern:a(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],f={}){const u=this.handleIncludeExclude(f.includePattern,f.expandPatterns),y=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),A=m.length>1,N=(u.searchPaths&&u.searchPaths.length?u.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,f,y)):m.map(O=>this.getFolderQueryForRoot(O,f,y,A))).filter(O=>!!O),B={_reason:f._reason,folderQueries:N,usingSearchPaths:!!(u.searchPaths&&u.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:y.pattern,includePattern:u.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const z=g.coalesce(g.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(x=>x.resource)))).filter(M=>(0,s.pathIncludedInQuery)(B,M.fsPath)),W=this.commonQueryFromFileList(z);return{...B,...W}}const F=f.extraFileResources&&f.extraFileResources.filter(O=>(0,s.pathIncludedInQuery)(B,O.fsPath));return B.extraFileResources=F&&F.length?F:void 0,B}commonQueryFromFileList(m){const f=[],u=new P.ResourceMap,y={};let A=!1;return m.forEach(N=>{if(N.scheme===k.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(N)){const F=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:C.dirname(N.fsPath)});let O=u.get(F);O||(A=!0,O={folder:F,includePattern:{}},f.push(O),u.set(F,O));const z=C.relative(F.fsPath,N.fsPath);(0,T.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(A=!0,y[N.fsPath]=!0)}),{folderQueries:f,includePattern:y,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(m,f){if(f.isSmartCase){if(m.isRegExp){if(L.containsUppercaseCharacter(m.pattern,!0))return!0}else if(L.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,E.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const f=W=>C.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),y=(Array.isArray(m)?m:S(m)).map(W=>{const M=this.pathService.resolvedUserHome;return M?(0,_.untildify)(W,M.scheme===k.Schemas.file?M.fsPath:M.path):W}),A=i.groupBy(y,W=>f(W)?"searchPaths":"exprSegments"),N=(A.exprSegments||[]).map(W=>L.rtrim(W,"/")).map(W=>L.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),B={},F=this.expandSearchPathPatterns(A.searchPaths||[]);F&&F.length&&(B.searchPaths=F);const O=g.flatten(N),z=a(...O);return z&&(B.pattern=z),B}getExcludesForFolder(m,f){return f.disregardExcludeSettings?void 0:(0,s.getExcludes)(m,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const f=g.flatten(m.map(y=>{let{pathPortion:A,globPortion:N}=p(y);N&&(N=r(N));const B=this.expandOneSearchPath(A);return g.flatten(B.map(F=>this.resolveOneSearchPathPattern(F,N)))})),u=new Map;return f.forEach(y=>{const A=y.searchPath.toString(),N=u.get(A);N?y.pattern&&(N.pattern=N.pattern||{},N.pattern[y.pattern]=!0):u.set(A,{searchPath:y.searchPath,pattern:y.pattern?a(y.pattern):void 0})}),Array.from(u.values())}expandOneSearchPath(m){if(C.isAbsolute(m)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:m})}]:[{searchPath:c.URI.file(C.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=t(m),m.startsWith("../")||m===".."){const y=C.posix.resolve(f.path,m);return[{searchPath:f.with({path:y})}]}const u=r(m);return[{searchPath:f,pattern:u}]}else{if(m==="./"||m===".\\")return[];{const f=m.replace(/^\.[\/\\]/,""),y=this.workspaceContextService.getWorkspace().folders.map(A=>{const N=f.match(new RegExp(`^${L.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return N?{match:N,folder:A}:null}).filter(T.isDefined);if(y.length)return y.map(A=>{const N=A.match[1];return{searchPath:A.folder.uri,pattern:N&&r(N)}});{const A=m.match(/\.[\/\\](.+)[\/\\]?/),N=A?A[1]:m,B=h.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(m,f){const u=m.pattern&&f?`${m.pattern}/${f}`:m.pattern||f,y=[{searchPath:m.searchPath,pattern:u}];return u&&!u.endsWith("**")&&y.push({searchPath:m.searchPath,pattern:u+"/**"}),y}getFolderQueryForSearchPath(m,f,u){const y=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(m.searchPath),f,u,!1);return y?{...y,includePattern:m.pattern}:null}getFolderQueryForRoot(m,f,u,y){let A;const N=c.URI.isUri(m)?m:m.uri;if(u.searchPaths){const W=u.searchPaths.filter(M=>(0,I.isEqual)(M.searchPath,N))[0];if(W&&!W.pattern)return null;W&&(A=W.pattern)}const B=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(B,f)||{},...A||{}},z=c.URI.isUri(m)?(0,I.basename)(m):m.name;return{folder:N,folderName:y?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!B.search.followSymlinks}}};o=je([He(0,w.IConfigurationService),He(1,v.IWorkspaceContextService),He(2,R.IEditorGroupsService),He(3,b.IPathService)],o),e.QueryBuilder=o;function p(d){const m=d.match(/[\*\{\}\(\)\[\]\?]/);if(m){const f=m.index,u=d.substr(0,f).match(/[/|\\][^/\\]*$/);if(u){let y=d.substr(0,u.index);return y.match(/[/\\]/)||(y+="/"),{pathPortion:y,globPortion:d.substr((u.index||0)+1)}}}return{pathPortion:d}}function a(...d){return d.length?d.reduce((m,f)=>(m[f]=!0,m),Object.create(null)):void 0}function S(d){return D.splitGlobAware(d,",").map(m=>m.trim()).filter(m=>!!m.length)}function n(d){return[`**/${d}/**`,`**/${d}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function t(d){return d.replace(/\\/g,"/")}function r(d){return t(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(d,m){d=g.distinct(d,y=>y.toString());const f=[],u=m.getWorkspace();return d&&d.forEach(y=>{let A;if(m.getWorkbenchState()===2)A=(0,I.relativePath)(u.folders[0].uri,y),A&&A!=="."&&(A="./"+A);else{const N=m.getWorkspaceFolder(y);if(N){const B=N.name;if(u.folders.filter(O=>O.name===B).length===1){const O=(0,I.relativePath)(N.uri,y);O===""?A=`./${N.name}`:A=`./${N.name}/${O}`}else A=y.fsPath}}A&&f.push(A)}),f}e.resolveResourcesForSearchIncludes=l}),define(Ee[268],Se([0,1,23,2,21,15,4,267,32,43]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(w,v){const R=v.activationEvents;if(!R)return Promise.resolve(void 0);const b=[],s=[];for(const t of R)if(/^workspaceContains:/.test(t)){const r=t.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||w.forceUsingSearch?s.push(r):b.push(r)}if(b.length===0&&s.length===0)return Promise.resolve(void 0);let o;const p=new Promise((t,r)=>{o=t}),a=t=>o({activationEvent:t}),S=Promise.all(b.map(t=>c(w,t,a))).then(()=>{}),n=E(w,v.identifier,s,a);return Promise.all([S,n]).then(()=>{o(void 0)}),p}e.checkActivateWorkspaceContainsExtension=T;async function c(w,v,R){for(const b of w.folders)if(await w.exists(g.joinPath(i.URI.revive(b),v))){R(`workspaceContains:${v}`);return}}async function E(w,v,R,b){if(R.length===0)return Promise.resolve(void 0);const s=new D.CancellationTokenSource,o=w.checkExists(w.folders,R,s.token),p=setTimeout(async()=>{s.cancel(),w.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${R.join(",")}`)},L);let a=!1;try{a=await o}catch(S){_.isPromiseCanceledError(S)||_.onUnexpectedError(S)}s.dispose(),clearTimeout(p),a&&b(`workspaceContains:${R.join(",")}`)}function h(w,v,R,b){const s=w.get(P.IInstantiationService),o=w.get(C.ISearchService),a=s.createInstance(k.QueryBuilder).file(v.map(S=>(0,I.toWorkspaceFolder)(i.URI.revive(S))),{_reason:"checkExists",includePattern:R,exists:!0});return o.fileSearch(a,b).then(S=>!!S.limitHit,S=>_.isPromiseCanceledError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=h});var tt=this&&this.__classPrivateFieldSet||function(X,e,g,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(X,g):D?D.value=g:e.set(X,g),g},Fe=this&&this.__classPrivateFieldGet||function(X,e,g,i){if(g==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?i:g==="a"?i.call(X):i?i.value:e.get(X)};define(Ee[39],Se([0,1,164,9,71,23,18,6,24,2,11,5,36,226,91,35,29,224,15,27,22,199,7,120,4,26,67,14,85,52,34,3,268,90,201,10]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s,o,p,a,S,n,t,r,l,d,m,f,u,y,A,N,B){"use strict";var F,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let W=class ji extends k.Disposable{constructor(U,H,Y,re,K,j,te,ae,ge,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=Y,this._initData=te,this._extHostWorkspace=re,this._extHostConfiguration=K,this._logService=j,this._extHostTunnelService=ge,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new R.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=ae,this._instaService=U.createChild(new d.ServiceCollection([h.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Me=new Set;this._initData.hostExtensions.forEach(Ne=>Me.add(s.ExtensionIdentifier.toKey(Ne))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ne,q,J)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ne,b.transformErrorForSerialization(q),J)},actualActivateExtension:async(Ne,q)=>{if(Me.has(s.ExtensionIdentifier.toKey(Ne)))return await this._mainThreadExtensionsProxy.$activateExtension(Ne,q),new E.HostExtension;const J=this._registry.getExtensionDescription(Ne);return this._activateExtension(J,q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){b.onUnexpectedError(U)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let U=[];try{U=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,H){return this._activator.activateByEvent(U,H)}_activateById(U,H){return this._activator.activateById(U,H)}activateByIdWithErrors(U,H){return this._activateById(U,H).then(()=>{const Y=this._activator.getActivatedExtension(U);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}async _realPathExtensionUri(U){if(U.scheme!==B.Schemas.file)return U;const H=await this._hostUtils.realpath(U.fsPath);return I.URI.file(H)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const U=C.TernarySearchTree.forUris(H=>_.extUriBiasedIgnorePathCase.ignorePathCasing(H));for(const H of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(H)){const Y=await this._realPathExtensionUri(H.extensionLocation);U.set(Y,H)}return U})()),this._extensionPathIndex}_deactivate(U){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return H;const Y=this._activator.getActivatedExtension(U);if(!Y)return H;try{typeof Y.module.deactivate=="function"&&(H=Promise.resolve(Y.module.deactivate()).then(void 0,re=>(this._logService.error(re),Promise.resolve(void 0))))}catch(re){this._logService.error(`An error occurred when deactivating the extension '${U.value}':`),this._logService.error(re)}try{(0,k.dispose)(Y.subscriptions)}catch(re){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this._logService.error(re)}return H}async _activateExtension(U,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,H).then(Y=>{const re=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,H),this._logExtensionActivationTimes(U,H,"success",re),Y},Y=>{throw this._logExtensionActivationTimes(U,H,"failure"),Y})}_logExtensionActivationTimes(U,H,Y,re){const K=M(U,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...re||{},outcome:Y})}_doActivateExtension(U,H){const Y=M(U,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const re=this._getEntryPoint(U);if(!re)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${U.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const K=new E.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,_.joinPath)(U.extensionLocation,re),K),this._loadExtensionContext(U)]).then(j=>(D.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ji._callActivate(this._logService,U.identifier,j[0],j[1],K))).then(j=>(D.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),j))}_loadExtensionContext(U){const H=new p.ExtensionGlobalMemento(U,this._storage),Y=new p.ExtensionMemento(U.identifier.value,!1,this._storage),re=new N.ExtensionSecrets(U,this._secretState),K=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,j=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([H.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const te=this;let ae;return Object.freeze({globalState:H,workspaceState:Y,secrets:re,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(ge){return i.join(U.extensionLocation.fsPath,ge)},get storagePath(){return te._storagePath.workspaceValue(U)?.fsPath},get globalStoragePath(){return te._storagePath.globalValue(U).fsPath},get logPath(){return i.join(te._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return I.URI.joinPath(te._initData.logsLocation,U.identifier.value)},get storageUri(){return te._storagePath.workspaceValue(U)},get globalStorageUri(){return te._storagePath.globalValue(U)},get extensionMode(){return K},get extension(){return ae===void 0&&(ae=new x(te,U.identifier,U,j)),ae},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(U,"extensionRuntime"),te.extensionRuntime},get environmentVariableCollection(){return te._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,H,Y,re,K){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,H,Y,re,K).then(j=>new E.ActivatedExtension(!1,null,K.build(),Y,j,re.subscriptions))}static _callActivateOptional(U,H,Y,re,K){if(typeof Y.activate=="function")try{K.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${H.value}`);const j=typeof global=="object"?global:self,te=Y.activate.apply(j,[re]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(te).then(ae=>(K.activateResolveStop(),ae))}catch(j){return Promise.reject(j)}else return Promise.resolve(Y)}_activateOneStartupFinished(U,H){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:H}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const H of U.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(U,H)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(H),re=Promise.all([U,Y]).then(()=>{});return Promise.race([re,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(U,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,H){if(this.isActivated(H.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={logService:this._logService,folders:U.map(j=>j.uri),forceUsingSearch:Y,exists:j=>this._hostUtils.exists(j.fsPath),checkExists:(j,te,ae)=>this._mainThreadWorkspaceProxy.$checkExists(j,te,ae)},K=await(0,y.checkActivateWorkspaceContainsExtension)(re,H);if(!!K)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:K.activationEvent}).then(void 0,j=>this._logService.error(j))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:H}=this._initData.environment;if(!U||!H)throw new Error(g.localize(0,null));const Y=await this._loadCommonJSModule(null,H,new E.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(g.localize(1,null,H.toString()));return new Promise((re,K)=>{const j=(ge,Ie)=>{ge?K(ge):re(typeof Ie=="number"&&Ie>0?1:0)},te=(0,_.originalFSPath)(H),ae=Y.run(te,j);ae&&ae.then&&ae.then(()=>{re(0)}).catch(ge=>{K(ge.toString())})})}async $extensionTestsExit(U){this._logService.info(`Extension host terminating: test runner requested exit with code ${U}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,H){return this._resolvers[U]=H,(0,k.toDisposable)(()=>{delete this._resolvers[U]})}async _activateAndGetResolver(U){const H=U.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const Y=U.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(U,H){const{authorityPrefix:Y,resolver:re}=await this._activateAndGetResolver(U);if(!re)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(re)),D.mark(`code/extHost/willResolveAuthority/${Y}`);const K=await re.resolve(U,{resolveAttempt:H});D.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const j={authority:U,host:K.host,port:K.port,connectionToken:K.connectionToken},te={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:j,options:te,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(D.mark(`code/extHost/didResolveAuthorityError/${Y}`),K instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(U,H){const{authorityPrefix:Y,resolver:re}=await this._activateAndGetResolver(U);if(!re)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Y}`);const K=I.URI.revive(H);if(typeof re.getCanonicalURI=="undefined")return K;const j=await(0,P.asPromise)(()=>re.getCanonicalURI(K));return j||K}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,H){return H===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(U,!1))}async $activate(U,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,H),!0):!1}async $deltaExtensions(U,H){U.forEach(re=>re.extensionLocation=I.URI.revive(re.extensionLocation));const Y=await this.getExtensionPathIndex();return await Promise.all(H.map(async re=>{const K=this._registry.getExtensionDescription(re);K&&Y.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(U.map(async re=>{const K=await this._realPathExtensionUri(re.extensionLocation);Y.set(K,re)})),this._registry.deltaExtensions(U,H),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let H=o.VSBuffer.alloc(U),Y=Math.random()%256;for(let re=0;re<U;re++)H.writeUInt8(Y,re);return H}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};W=je([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,l.IExtHostRpcService),He(3,w.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,L.ILogService),He(6,t.IExtHostInitDataService),He(7,r.IExtensionStoragePaths),He(8,m.IExtHostTunnelService),He(9,f.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function M(V,U){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class x{constructor(U,H,Y,re){F.set(this,void 0),O.set(this,void 0),z.set(this,void 0),tt(this,F,U,"f"),tt(this,O,H,"f"),tt(this,z,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=i.normalize((0,_.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=re}get isActive(){return Fe(this,F,"f").isActivated(Fe(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Fe(this,F,"f").getExtensionExports(Fe(this,z,"f"))}activate(){return Fe(this,F,"f").activateByIdWithErrors(Fe(this,z,"f"),{startup:!1,extensionId:Fe(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,O=new WeakMap,z=new WeakMap}),define(Ee[55],Se([0,1,9,2,3,18,5,7,124,35,39,45,215,36,208,14,4,13,40,54]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let o=class{constructor(d,m,f,u,y,A){this._workspaceService=m,this._extensionService=f,this._editorsService=u,this._configurationService=y,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=d.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,m){const f=d;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let u=`debug:${encodeURIComponent(f.path||"")}`,y="?";return m&&(u+=`${y}session=${encodeURIComponent(m.id)}`,y="&"),u+=`${y}ref=${f.sourceReference}`,i.URI.parse(u)}else{if(f.path)return i.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const m=[];for(const f of d.getAllExtensionDescriptions())if(f.contributes){const u=f.contributes.debuggers;if(u&&u.length>0)for(const y of u)(0,h.isDebuggerMainContribution)(y)&&m.push(y.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(m=>d.push(m)),d}addBreakpoints(d){this.startBreakpoints();const m=d.filter(y=>{const A=y.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,y),!0)});this.fireBreakpointChanges(m,[],[]);const f=[],u=new Map;for(const y of m)if(y instanceof k.SourceBreakpoint){let A=u.get(y.location.uri.toString());A||(A={type:"sourceMulti",uri:y.location.uri,lines:[]},u.set(y.location.uri.toString(),A),f.push(A)),A.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character})}else y instanceof k.FunctionBreakpoint&&f.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(d){this.startBreakpoints();const m=d.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],m,[]);const f=m.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),u=m.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),y=m.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(f,u,y)}startDebugging(d,m,f){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,m,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,m,f){if(!m)return new k.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:u,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,f,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,u),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(y=>y.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(d,m,f){if(!f)return new k.Disposable(()=>{});if(!this.definesDebugType(d,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:u,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,u),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(y=>y.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(d,m){if(!m)return new k.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:f,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==m)})}async $runInTerminal(d,m){return Promise.resolve(void 0)}async $substituteVariables(d,m){if(!this._variableResolver){const[y,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(y||[],this._editorsService,A)}let f;const u=await this.getFolder(d);return u&&(f={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,m)}createDebugAdapter(d,m){if(d.type==="implementation")return new t(d.implementation)}createSignService(){}async $startDASession(d,m){const f=this,u=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const A=this.convertToDto(y),N=this.createDebugAdapter(A,u);if(!N)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const B=N;return this._debugAdapters.set(d,B),this.getDebugAdapterTrackers(u).then(F=>(F&&this._debugAdaptersTrackers.set(d,F),B.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,W={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(z.arguments.value);W.body={signature:M},B.sendResponse(W)}else throw new Error("no signer")}catch(M){W.success=!1,W.message=M.message,B.sendResponse(W)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(O),O=(0,h.convertToVSCPaths)(O,!0),f._debugServiceProxy.$acceptDAMessage(d,O)}),B.onError(O=>{F&&F.onError&&F.onError(O),this._debugServiceProxy.$acceptDAError(d,O.name,O.message,O.stack)}),B.onExit(O=>{F&&F.onExit&&F.onExit((0,R.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,R.withNullAsUndefined)(O),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),B.startSession()))})}$sendDAMessage(d,m){m=(0,h.convertToDAPaths)(m,!1);const f=this._debugAdaptersTrackers.get(d);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(m);const u=this._debugAdapters.get(d);u&&u.sendMessage(m)}$stopDASession(d){const m=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),m&&m.onWillStopSession&&m.onWillStopSession();const f=this._debugAdapters.get(d);return this._debugAdapters.delete(d),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const m=[],f=[],u=[];if(d.added)for(const y of d.added){const A=y.id;if(A&&!this._breakpoints.has(A)){let N;if(y.type==="function")N=new k.FunctionBreakpoint(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage);else if(y.type==="data")N=new k.DataBreakpoint(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage);else{const B=i.URI.revive(y.uri);N=new k.SourceBreakpoint(new k.Location(B,new k.Position(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage)}N._id=A,this._breakpoints.set(A,N),m.push(N)}}if(d.removed)for(const y of d.removed){const A=this._breakpoints.get(y);A&&(this._breakpoints.delete(y),f.push(A))}if(d.changed){for(const y of d.changed)if(y.id){const A=this._breakpoints.get(y.id);if(A){if(A instanceof k.FunctionBreakpoint&&y.type==="function"){const N=A;N.enabled=y.enabled,N.condition=y.condition,N.hitCondition=y.hitCondition,N.logMessage=y.logMessage,N.functionName=y.functionName}else if(A instanceof k.SourceBreakpoint&&y.type==="source"){const N=A;N.enabled=y.enabled,N.condition=y.condition,N.hitCondition=y.hitCondition,N.logMessage=y.logMessage,N.location=new k.Location(i.URI.revive(y.uri),new k.Position(y.line,y.character))}u.push(A)}}}this.fireBreakpointChanges(m,f,u)}$provideDebugConfigurations(d,m,f){return(0,_.asPromise)(async()=>{const u=this.getConfigProviderByHandle(d);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.getFolder(m);return u.provideDebugConfigurations(y,f)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(d,m,f,u){return(0,_.asPromise)(async()=>{const y=this.getConfigProviderByHandle(d);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(m);return y.resolveDebugConfiguration(A,f,u)})}$resolveDebugConfigurationWithSubstitutedVariables(d,m,f,u){return(0,_.asPromise)(async()=>{const y=this.getConfigProviderByHandle(d);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(m);return y.resolveDebugConfigurationWithSubstitutedVariables(A,f,u)})}async $provideDebugAdapter(d,m){const f=this.getAdapterDescriptorFactoryByHandle(d);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(m);return this.getAdapterDescriptor(f,u).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(y)})}async $acceptDebugSessionStarted(d){const m=await this.getSession(d);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(d){const m=await this.getSession(d);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,m){const f=await this.getSession(d);f&&f._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(d,m){const u={session:await this.getSession(d),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(d){if(d instanceof k.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof k.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const m=this._adapterFactories.filter(f=>f.type===d);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(d){const m=this._adapterFactories.filter(f=>f.handle===d);if(m.length>0)return m[0].factory}getConfigProviderByHandle(d){const m=this._configProviders.filter(f=>f.handle===d);if(m.length>0)return m[0].provider}definesDebugType(d,m){if(d.contributes){const f=d.contributes.debuggers;if(f&&f.length>0){for(const u of f)if(u.label&&u.type&&u.type===m)return!0}}return!1}getDebugAdapterTrackers(d){const f=d.configuration.type,u=this._trackerFactories.filter(y=>y.type===f||y.type==="*").map(y=>(0,_.asPromise)(()=>y.factory.createDebugAdapterTracker(d)).then(A=>A,A=>null));return Promise.race([Promise.all(u).then(y=>{const A=y.filter(N=>!!N);if(A.length>0)return new n(A)}),new Promise((y,A)=>{const N=setTimeout(()=>{clearTimeout(N),A(new Error("timeout"))},1e3)})]).catch(y=>{})}async getAdapterDescriptor(d,m){const f=m.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.DebugAdapterServer(f));if(d){const y=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>d.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,y))).then(A=>{if(A)return A})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,u))}daExecutableFromPackage(d,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,m,f){(d.length>0||m.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:m,changed:f}))}async getSession(d){if(d)if(typeof d=="string"){const m=this._debugSessions.get(d);if(m)return m}else{let m=this._debugSessions.get(d.id);if(!m){const f=await this.getFolder(d.folderUri),u=d.parent?this._debugSessions.get(d.parent):void 0;m=new p(this._debugServiceProxy,d.id,d.type,d.name,f,d.configuration,u),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(d){if(d){const m=i.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};o=je([He(0,w.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,L.IExtHostExtensionService),He(3,T.IExtHostDocumentsAndEditors),He(4,E.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class p{constructor(d,m,f,u,y,A,N){this._debugServiceProxy=d,this._id=m,this._type=f,this._name=u,this._workspaceFolder=y,this._configuration=A,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,m)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class a{constructor(d){this.value=Object.freeze({append(m){d.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=a;class S extends c.AbstractVariableResolverService{constructor(d,m,f,u,y){function A(){if(m){const N=m.activeEditor();if(N)return N.document.uri;const B=u.tabs.filter(F=>F.isActive);if(B.length>0){const F=B[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=d.filter(F=>F.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(N,B)=>f.getConfiguration(void 0,N).get(B),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=A();if(N)return g.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(y){const N=A();if(N){const B=y.getWorkspaceFolder(N);if(B)return g.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(m){const N=m.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(m){const N=m.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=S;class n{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(m=>m.onError?m.onError(d):void 0)}onExit(d,m){this.trackers.forEach(f=>f.onExit?f.onExit(d,m):void 0)}}class t extends C.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(d,m,f,u,y,A){super(d,m,f,u,y,A)}createVariableResolver(d,m,f){return new S(d,m,f,this._editorTabs)}};r=je([He(0,w.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,L.IExtHostExtensionService),He(3,T.IExtHostDocumentsAndEditors),He(4,E.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(Ee[269],Se([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(s,o,p,a,S,n,t){this._apiFactory=s,this._extensionRegistry=o,this._instaService=p,this._extHostConfiguration=a,this._extHostExtensionService=S,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,o,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(v,o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(R,o,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let o of s.nodeModuleName)this._factories.set(o,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(o=>s.alternativeModuleName(o))}};h=je([He(2,L.IInstantiationService),He(3,_.IExtHostConfiguration),He(4,T.IExtHostExtensionService),He(5,I.IExtHostInitDataService),He(6,E.ILogService)],h),e.RequireInterceptor=h;class w{constructor(s,o,p,a,S){this._apiFactory=s,this._extensionPaths=o,this._extensionRegistry=p,this._configProvider=a,this._logService=S,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,o){const p=this._extensionPaths.findSubstr(o);if(p){let a=this._extApiImpl.get(k.ExtensionIdentifier.toKey(p.identifier));return a||(a=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(p.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((S,n)=>a+=`	${n} -> ${S.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(s,o,p){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(D.MainContext.MainThreadTelemetry);const{environment:a}=p,S=o.getProxy(D.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>S.$getPassword(n,t),setPassword:(n,t,r)=>S.$setPassword(n,t,r),deletePassword:(n,t)=>S.$deletePassword(n,t),findPassword:n=>S.$findPassword(n),findCredentials(n){return S.$findCredentials(n)}}}load(s,o){const p=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:p?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const o=s.length;if(o<=7||!this.alternativeNames)return;const p=o-7;if((s.charAt(p)==="/"||s.charAt(p)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};v=je([He(1,C.IExtHostRpcService),He(2,I.IExtHostInitDataService)],v);let R=class{constructor(s,o,p){this._extensionPaths=s,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(D.MainContext.MainThreadTelemetry);const a=p.getProxy(D.MainContext.MainThreadWindow);this._impl=(S,n)=>{const t=i.URI.parse(S);return n?this.callOriginal(S,n):t.scheme==="http"||t.scheme==="https"?a.$openUri(t,S,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?a.$openUri(t,S,{}):this.callOriginal(S,n)}}load(s,o,p){const a=this._extensionPaths.findSubstr(o);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=p(s),this._impl}callOriginal(s,o){return this.sendNoForwardTelemetry(),this._original(s,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};R=je([He(2,C.IExtHostRpcService)],R)}),define(Ee[270],Se([0,1,170,12,7,209,35,39,45,36,34,14,55,195,18,210,54]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let R=class extends c.ExtHostDebugServiceBase{constructor(o,p,a,S,n,t,r){super(o,p,a,S,n,r);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(o,p){switch(o.type){case"server":return new _.SocketDebugAdapter(o);case"pipeServer":return new _.NamedPipeDebugAdapter(o);case"executable":return new _.ExecutableDebugAdapter(o,p.type)}return super.createDebugAdapter(o,p)}daExecutableFromPackage(o,p){const a=_.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),o.type);if(a)return new D.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new E.SignService}async $runInTerminal(o,p){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const a=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=o.title||g.localize(0,null),r=JSON.stringify({shell:S,shellArgs:n});let l=await this._integratedTerminalInstances.checkout(r,t),d,m=!1;if(l)d=o.cwd;else{const A={shellPath:S,shellArgs:n,cwd:o.cwd,name:t,iconPath:new D.ThemeIcon("debug")};m=!0,l=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,r)}l.show(!0);const f=await l.processId;m?await new Promise(A=>setTimeout(A,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?l.sendText("cls"):S.indexOf("bash")>=0?l.sendText("clear"):i.isWindows?l.sendText("cls"):l.sendText("clear"));const u=(0,w.prepareCommand)(S,o.args,d,o.env);l.sendText(u);const y=this.onDidTerminateDebugSession(A=>{A.id===p&&(this._integratedTerminalInstances.free(l),y.dispose())});return f}else if(o.kind==="external")return(0,w.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,p)}createVariableResolver(o,p,a){return new c.ExtHostVariableResolverService(o,p,a,this._editorTabs,this._workspaceService)}};R=je([He(0,T.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,L.IExtHostTerminalService),He(6,v.IExtHostEditorTabs)],R),e.ExtHostDebugService=R;class b{constructor(){this._terminalInstances=new Map}async checkout(o,p){const S=[...this._terminalInstances.entries()].map(([n,t])=>(0,h.createCancelablePromise)(async r=>{if(n.name!==p||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await n.processId))return null;const l=Date.now();return t.lastUsedAt+b.minUseDelay>l||r.isCancellationRequested||t.config!==o?null:(t.lastUsedAt=l,n)}));return await(0,h.firstParallel)(S,n=>!!n)}insert(o,p){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:p})}free(o){const p=this._terminalInstances.get(o);p&&(p.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}b.minUseDelay=1e3}),define(Ee[271],Se([0,1,9,2,113,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends E.ExtHostTaskBase{constructor(a,S,n,t,r,l,d,m,f){super(a,S,n,t,r,l,d,m);this.workspaceService=n,this.editorTabs=f,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,S){const n=S;if(!S.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=E.TaskHandleDTO.from(n,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(r,S);return this._proxy.$executeTask(t).catch(()=>{}),l}else{const t=E.TaskDTO.from(S,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,S,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),S);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(a,S,n,t){const r=[];if(t)for(let l of t){this.checkDeprecation(l,n),(!l.definition||!a[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const d=E.TaskDTO.from(l,n.extension);d&&(r.push(d),E.CustomExecutionDTO.is(d.execution)&&S.push(this.addCustomExecution(d,l,!0)))}return{tasks:r,extension:n.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(a,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(a){let S=a&&a.length>0?a[0]:void 0;if(!S){const n=i.URI.file((0,s.homedir)());S=new I.WorkspaceFolder({uri:n,name:b.basename(n),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,S){const n=i.URI.revive(a),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(n),l=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(l),m=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(let f of S.variables)t.variables[f]=await d.resolveAsync(m,f);if(S.process!==void 0){let f;if(S.process.path!==void 0){f=S.process.path.split(g.delimiter);for(let u=0;u<f.length;u++)f[u]=await d.resolveAsync(m,f[u])}t.process=await D.win32.findExecutable(await d.resolveAsync(m,S.process.name),S.process.cwd!==void 0?await d.resolveAsync(m,S.process.cwd):void 0,f)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,S,n){return D.win32.findExecutable(a,S,n)}};o=je([He(0,T.IExtHostRpcService),He(1,c.IExtHostInitDataService),He(2,_.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,L.IExtHostTerminalService),He(6,w.ILogService),He(7,v.IExtHostApiDeprecationService),He(8,R.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(Ee[272],Se([0,1,18,15,71,6,2,5,264,11,83,85,26,187,14,64,39,34]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,p,a,S){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new C.RPCProtocol(o,null,S),p=b._transform(p,this._rpcProtocol);const n=new T.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());n.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...p}),n.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),n.set(w.IURITransformerService,new w.URITransformerService(S)),n.set(v.IHostUtils,a);const t=new E.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(m=>m.get(R.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(m=>m.get(v.IExtHostExtensionService))),this._logService=t.invokeFunction(m=>m.get(I.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",p),this._extensionService=t.invokeFunction(m=>m.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(f,u)=>{let y="",A,N;for(const B of u)y+=`
	at ${B.toString()}`,N=B.getFileName(),!A&&N&&(A=m.findSubstr(P.URI.file(N)));return r.set(f,A),`${f.name||"Error"}: ${f.message||""}${y}`}});const l=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(m=>{const f=i.transformErrorForSerialization(m),u=r.get(m);u?l.$onExtensionRuntimeError(u.identifier,f):d.$onUnexpectedError(f)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();Promise.race([(0,g.timeout)(5e3),p]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(o,p){o.extensions.forEach(S=>S.extensionLocation=P.URI.revive(p.transformIncomingURIs(S.extensionLocation))),o.environment.appRoot=P.URI.revive(p.transformIncomingURIs(o.environment.appRoot));const a=o.environment.extensionDevelopmentLocationURI;return a&&(o.environment.extensionDevelopmentLocationURI=a.map(S=>P.URI.revive(p.transformIncomingURIs(S)))),o.environment.extensionTestsLocationURI=P.URI.revive(p.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=P.URI.revive(p.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=P.URI.revive(p.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=P.URI.revive(p.transformIncomingURIs(o.logsLocation)),o.logFile=P.URI.revive(p.transformIncomingURIs(o.logFile)),o.workspace=p.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(Ee[273],Se([0,1,9,21,50,31,23,46,32]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(c,E,h){this.config=c,this.provider=E,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&_.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&_.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const E=this.config.folderQueries||[];return new Promise((h,w)=>{const v=R=>{this.resultCount++,c(R)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(R=>{const b=R.toString(),s=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,s)||this.matchFile(v,{base:R,basename:s})}),Promise.all(E.map(R=>this.searchInFolder(R,v))).then(R=>{h({limitHit:this.isLimitHit,stats:R[0]||void 0})},R=>{w(new Error((0,D.toErrorMessage)(R)))})})}async searchInFolder(c,E){const h=new i.CancellationTokenSource,w=this.getSearchOptionsForFolder(c),v=this.initDirectoryTree(),R=new C.QueryGlobTester(this.config,c),b=!R.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(h),s=k.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),p=s.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(S=>{const n=g.posix.relative(c.folder.path,S.path);if(b){const t=g.basename(S.path);this.matchFile(E,{base:c.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(v,c.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,R,E),{providerTime:p,postProcessTime:a.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const E=(0,C.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,C.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:E,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},E,h,w){if(h===this.filePattern){const R=g.basename(this.filePattern);this.matchFile(w,{base:E,relativePath:this.filePattern,basename:R})}function v(R){const b=g.basename(R),s=g.dirname(R);let o=c[s];o||(o=c[s]=[],v(s)),o.push({base:E,relativePath:R,basename:b})}v(h)}matchDirectoryTree({rootEntries:c,pathToEntries:E},h,w){const v=this,R=this.filePattern;function b(s){const o=_.hasSiblingFn(()=>s.map(p=>p.basename));for(let p=0,a=s.length;p<a;p++){const S=s[p],{relativePath:n,basename:t}=S;if(h.matchesExcludesSync(n,t,R!==t?o:void 0))continue;const r=E[n];if(r)b(r);else{if(n===R)continue;v.matchFile(w,S)}if(v.isLimitHit)break}}b(c)}matchFile(c,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(E))}}class L{constructor(){this.sessions=new Map}fileSearch(c,E,h,w){const v=this.getSessionTokenSource(c.cacheKey),R=new I(c,E,v&&v.token);let b=0;const s=o=>{b+=o.length,h(o.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(R,L.BATCH_SIZE,s,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(c){const E=this.getSessionTokenSource(c);E&&E.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new i.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:P.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,E,h,w){w.onCancellationRequested(()=>{c.cancel()});const v=b=>{b&&(R.push(b),E>0&&R.length>=E&&(h(R),R=[]))};let R=[];return c.search(v).then(b=>(R.length&&h(R),b),b=>(R.length&&h(R),Promise.reject(b)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(Ee[135],Se([0,1,16,21,50,31,10,9,23,13,2,32]),function(X,e,g,i,D,_,P,k,C,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(s,o,p,a){this.query=s,this.provider=o,this.fileUtils=p,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,o){const p=this.query.folderQueries||[],a=new i.CancellationTokenSource;return o.onCancellationRequested(()=>a.cancel()),new Promise((S,n)=>{this.collector=new h(s);let t=!1;const r=(l,d)=>{if(!t&&!this.isLimitHit){const m=this.resultSize(l);v(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,t=!0,a.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const f=this.resultSize(l);this.resultCount+=f,(f>0||!v(l))&&this.collector.add(l,d)}};Promise.all(p.map((l,d)=>this.searchInFolder(l,m=>r(m,d),a.token))).then(l=>{a.dispose(),this.collector.flush();const d=l.some(m=>!!m&&!!m.limitHit);S({limitHit:this.isLimitHit||d,messages:(0,g.flatten)(l.map(m=>m?.message?(0,I.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},l=>{a.dispose();const d=(0,D.toErrorMessage)(l);n(new Error(d))})})}resultSize(s){return v(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,o){const p=Array.isArray(s.ranges)?s.ranges:[s.ranges],a=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:p.slice(0,o),preview:{matches:a.slice(0,o),text:s.preview.text},uri:s.uri}}async searchInFolder(s,o,p){const a=new T.QueryGlobTester(this.query,s),S=[],n={report:l=>{if(!this.validateProviderResult(l))return;const d=s.folder.scheme===P.Schemas.file?_.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(l.uri))):void 0,m=C.relativePath(s.folder,l.uri);if(m){const f=a.includedInQuery(m,k.basename(m),d);(0,I.isPromise)(f)?S.push(f.then(u=>{u&&o(l)})):f&&o(l)}}},t=this.getSearchOptionsForFolder(s),r=await this.provider.provideTextSearchResults(E(this.query.contentPattern),t,n,p);return S.length&&await Promise.all(S),r}validateProviderResult(s){if(v(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const o=(0,T.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),p=(0,T.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),a={folder:L.URI.from(s.folder),excludes:p,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=c;function E(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new R(512,o=>this.sendItems(o))}add(s,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!C.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(w(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=h;function w(b){return v(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function v(b){return!!b.preview}e.extensionResultIsMatch=v;class R{constructor(s,o){this.maxBatchSize=s,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,o){!s||this.addItemToBatch(s,o)}addItems(s,o){!s||this.addItemsToBatch(s,o)}addItemToBatch(s,o){this.batch.push(s),this.batchSize+=o,this.onUpdate()}addItemsToBatch(s,o){this.batch=this.batch.concat(s),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<R.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},R.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=R,R.TIMEOUT=4e3,R.START_BATCH_AFTER_COUNT=50}),define(Ee[72],Se([0,1,6,5,4,273,14,64,11,2,135]),function(X,e,g,i,D,_,P,k,C,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let T=class{constructor(w,v,R){this.extHostRpc=w,this._uriTransformer=v,this._logService=R,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,v){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const R=this._handlePool++;return this._textSearchProvider.set(R,v),this._proxy.$registerTextSearchProvider(R,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}registerFileSearchProvider(w,v){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const R=this._handlePool++;return this._fileSearchProvider.set(R,v),this._proxy.$registerFileSearchProvider(R,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}$provideFileSearchResults(w,v,R,b){const s=c(R),o=this._fileSearchProvider.get(w);if(o)return this._fileSearchManager.fileSearch(s,o,p=>{this._proxy.$handleFileMatch(w,v,p.map(a=>a.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,v,R,b){const s=this._textSearchProvider.get(w);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=c(R);return this.createTextSearchManager(o,s).search(a=>this._proxy.$handleTextMatch(w,v,a),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,v){return new L.TextSearchManager(w,v,{readdir:R=>Promise.resolve([]),toCanonicalName:R=>R},"textSearchProvider")}};T=je([He(0,P.IExtHostRpcService),He(1,k.IURITransformerService),He(2,C.ILogService)],T),e.ExtHostSearch=T;function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(E),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>I.URI.revive(w))}}e.reviveQuery=c;function E(h){return{...h,folder:I.URI.revive(h.folder)}}}),define(Ee[274],Se([0,1,21,15,3,48,2,114,109,147,82,42,5,232,231,38,233,36,234,235,236,217,237,45,39,238,218,241,242,243,133,220,248,249,250,91,34,252,221,17,7,255,68,134,35,74,206,240,62,131,70,55,72,11,64,14,26,244,203,52,65,229,253,202,67,66,258,256,257,230,44,251,254,90,54,122,246,69,247,10,190,245,200,239,6,29]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s,o,p,a,S,n,t,r,l,d,m,f,u,y,A,N,B,F,O,z,W,M,x,V,U,H,Y,re,K,j,te,ae,ge,Ie,Me,Ne,q,J,ne,he,ee,oe,_e,Ue,Ve,Ke,Je,it,at,et,nt,ct,dt,Pt,xe,Rt,Z,ie,be,ze,Qe,me,Ce,$e,Pe,De,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function le(de){const we=de.get(J.IExtHostInitDataService),ve=de.get(ct.IExtHostFileSystemInfo),Re=de.get(Je.IExtHostConsumerFileSystem),Ge=de.get(n.IExtHostExtensionService),We=de.get(H.IExtHostWorkspace),Xe=de.get(Z.IExtHostTelemetry),st=de.get(R.IExtHostConfiguration),ot=de.get(Ne.IURITransformerService),fe=de.get(q.IExtHostRpcService),ke=de.get(B.IExtHostStorage),ue=de.get(Ke.IExtensionStoragePaths),Q=de.get(Me.ILoggerService),Te=de.get(Me.ILogService),Oe=de.get(ee.IExtHostTunnelService),Ze=de.get(oe.IExtHostApiDeprecationService),qe=de.get(U.IExtHostWindow),ht=de.get(xe.IExtHostSecretState),wt=de.get(Rt.IExtHostEditorTabs);fe.set(c.ExtHostContext.ExtHostFileSystemInfo,ve),fe.set(c.ExtHostContext.ExtHostLogLevelServiceShape,Q),fe.set(c.ExtHostContext.ExtHostWorkspace,We),fe.set(c.ExtHostContext.ExtHostConfiguration,st),fe.set(c.ExtHostContext.ExtHostExtensionService,Ge),fe.set(c.ExtHostContext.ExtHostStorage,ke),fe.set(c.ExtHostContext.ExtHostTunnelService,Oe),fe.set(c.ExtHostContext.ExtHostWindow,qe),fe.set(c.ExtHostContext.ExtHostSecretState,ht),fe.set(c.ExtHostContext.ExtHostTelemetry,Xe),fe.set(c.ExtHostContext.ExtHostEditorTabs,wt);const yt=fe.set(c.ExtHostContext.ExtHostDecorations,de.get(te.IExtHostDecorations)),bt=fe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),mt=fe.set(c.ExtHostContext.ExtHostCommands,de.get(w.IExtHostCommands)),vt=fe.set(c.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),_t=fe.set(c.ExtHostContext.ExtHostDebugService,de.get(ge.IExtHostDebugService)),Ot=fe.set(c.ExtHostContext.ExtHostSearch,de.get(Ie.IExtHostSearch)),It=fe.set(c.ExtHostContext.ExtHostTask,de.get(ae.IExtHostTask)),Tt=fe.set(c.ExtHostContext.ExtHostOutputService,de.get(f.IExtHostOutputService)),Lt=fe.set(c.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(fe)),St=fe.set(c.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(fe,bt)),Mt=fe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(fe,bt,Te)),Nt=fe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(Te,St,fe.getProxy(c.MainContext.MainThreadBulkEdits))),Et=fe.set(c.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(fe,mt,bt,St,ue)),Wt=fe.set(c.ExtHostContext.ExtHostNotebookDocuments,new $e.ExtHostNotebookDocuments(Te,Et)),jt=fe.set(c.ExtHostContext.ExtHostNotebookEditors,new Ce.ExtHostNotebookEditors(Te,fe,Et)),si=fe.set(c.ExtHostContext.ExtHostNotebookKernels,new ie.ExtHostNotebookKernels(fe,we,Et,mt,Te)),oi=fe.set(c.ExtHostContext.ExtHostNotebookRenderers,new ze.ExtHostNotebookRenderers(fe,Et)),At=fe.set(c.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(fe,bt)),Xt=fe.set(c.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(fe.getProxy(c.MainContext.MainThreadTreeViews),mt,Te)),ai=fe.set(c.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(fe.getProxy(c.MainContext.MainThreadEditorInsets),At,we)),Yt=fe.set(c.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(fe,Te,ve)),Vt=fe.set(c.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(fe,St,mt.converter,ot)),pt=fe.set(c.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(fe,ot,St,mt,Yt,Te,Ze)),ci=fe.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(fe,pt)),Ut=fe.set(c.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(fe,Te,bt)),qt=fe.set(c.ExtHostContext.ExtHostQuickOpen,(0,y.createExtHostQuickOpen)(fe,We,mt)),Jt=fe.set(c.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(fe,mt,Te)),li=fe.set(c.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(fe,mt,St)),fi=fe.set(c.ExtHostContext.ExtHostProgress,new u.ExtHostProgress(fe.getProxy(c.MainContext.MainThreadProgress))),Ei=fe.set(c.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(fe)),mi=fe.set(c.ExtHostContext.ExtHostTheming,new he.ExtHostTheming(fe)),Zt=fe.set(c.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(fe)),Si=fe.set(c.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(fe,mt)),Gt=fe.set(c.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(fe,{remote:we.remote},We,Te,Ze)),Kt=fe.set(c.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(fe,Gt,We)),_i=fe.set(c.ExtHostContext.ExtHostCustomEditors,new at.ExtHostCustomEditors(fe,St,ue,Gt,Kt)),Ci=fe.set(c.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews(fe,Gt)),Qt=fe.set(c.ExtHostContext.ExtHostTesting,new dt.ExtHostTesting(fe,mt)),yi=fe.set(c.ExtHostContext.ExtHostUriOpeners,new Pt.ExtHostUriOpeners(fe));fe.set(c.ExtHostContext.ExtHostInteractive,new Pe.ExtHostInteractive(fe,Et,bt,mt));const ei=(0,Y.values)(c.ExtHostContext);fe.assertRegistered(ei);const Di=new nt.ExtHostBulkEdits(fe,bt),ki=new h.ExtHostClipboard(fe),ui=new m.ExtHostMessageService(fe,Te),ti=new s.ExtHostDialogs(fe),gi=new N.ExtHostStatusBar(fe,mt.converter);return E.ExtHostApiCommands.register(mt),function(Be,Bt,pi){const gt=function(){let se=!Be.isUnderDevelopment;function pe(){se||(Te.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Le(ut){if(Array.isArray(ut))ut.forEach(Le);else if(typeof ut=="string")pe();else{const Ct=ut;typeof Ct.scheme=="undefined"&&pe(),typeof Ct.exclusive=="boolean"&&(0,ye.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return ut}}(),ii={getSession(se,pe,Le){return Zt.getSession(Be,se,pe,Le)},async hasSession(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"authSession"),!!await Zt.getSession(Be,se,pe,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,pe,Le,ut){return Zt.registerAuthenticationProvider(se,pe,Le,ut)}},Ii={registerCommand(se,pe,Le){return mt.registerCommand(!0,se,pe,Le,void 0,Be)},registerTextEditorCommand(se,pe,Le){return mt.registerCommand(!0,se,(...ut)=>{const Ct=At.getActiveTextEditor();if(!Ct){Te.warn("Cannot execute "+se+" because there is no active text editor.");return}return Ct.edit(Dt=>{pe.apply(Le,[Ct,Dt,...ut])}).then(Dt=>{Dt||Te.warn("Edits from command "+se+" were not applied.")},Dt=>{Te.warn("An error occurred while running command "+se,Dt)})},void 0,void 0,Be)},registerDiffInformationCommand:(se,pe,Le)=>((0,ye.checkProposedApiEnabled)(Be,"diffCommand"),mt.registerCommand(!0,se,async(...ut)=>{const Ct=bt.activeEditor(!0);if(!Ct){Te.warn("Cannot execute "+se+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(Ct.id);pe.apply(Le,[Dt,...ut])},void 0,void 0,Be)),executeCommand(se,...pe){return mt.executeCommand(se,...pe)},getCommands(se=!1){return mt.getCommands(se)}},vi={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Xe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Xe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const se=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,pe){return qe.openUri(se,{allowTunneling:!!we.remote.authority,allowContributedOpeners:pe?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===we.environment.appUriScheme)return Lt.createAppUri(se);try{return await qe.asExternalUri(se,{allowTunneling:!!we.remote.authority})}catch(pe){if((0,me.matchesScheme)(se,Qe.Schemas.http)||(0,me.matchesScheme)(se,Qe.Schemas.https))return se;throw pe}},get remoteName(){return(0,j.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,ye.checkProposedApiEnabled)(Be,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=we.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pi={createTestController(se,pe){return Qt.createTestController(se,pe)},createTestObserver(){return(0,ye.checkProposedApiEnabled)(Be,"testObserver"),Qt.createTestObserver()},runTests(se){return(0,ye.checkProposedApiEnabled)(Be,"testObserver"),Qt.runTests(se)},get onDidChangeTestResults(){return(0,ye.checkProposedApiEnabled)(Be,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ye.checkProposedApiEnabled)(Be,"testObserver"),Qt.results}},Ti={getExtension(se){const pe=Bt.getExtensionDescription(se);if(pe)return new n.Extension(Ge,Be.identifier,pe,wi)},get all(){return Bt.getAllExtensionDescriptions().map(se=>new n.Extension(Ge,Be.identifier,se,wi))},get onDidChange(){return Bt.onDidChange}},Ai={createDiagnosticCollection(se){return Yt.createDiagnosticCollection(Be.identifier,se)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:se=>Yt.getDiagnostics(se),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(se,pe){return Vt.changeLanguage(se.uri,pe)},match(se,pe){return(0,L.score)(W.LanguageSelector.from(se),pe.uri,pe.languageId,!0)},registerCodeActionsProvider(se,pe,Le){return pt.registerCodeActionProvider(Be,gt(se),pe,Le)},registerCodeLensProvider(se,pe){return pt.registerCodeLensProvider(Be,gt(se),pe)},registerDefinitionProvider(se,pe){return pt.registerDefinitionProvider(Be,gt(se),pe)},registerDeclarationProvider(se,pe){return pt.registerDeclarationProvider(Be,gt(se),pe)},registerImplementationProvider(se,pe){return pt.registerImplementationProvider(Be,gt(se),pe)},registerTypeDefinitionProvider(se,pe){return pt.registerTypeDefinitionProvider(Be,gt(se),pe)},registerHoverProvider(se,pe){return pt.registerHoverProvider(Be,gt(se),pe,Be.identifier)},registerEvaluatableExpressionProvider(se,pe){return pt.registerEvaluatableExpressionProvider(Be,gt(se),pe,Be.identifier)},registerInlineValuesProvider(se,pe){return pt.registerInlineValuesProvider(Be,gt(se),pe,Be.identifier)},registerDocumentHighlightProvider(se,pe){return pt.registerDocumentHighlightProvider(Be,gt(se),pe)},registerLinkedEditingRangeProvider(se,pe){return pt.registerLinkedEditingRangeProvider(Be,gt(se),pe)},registerReferenceProvider(se,pe){return pt.registerReferenceProvider(Be,gt(se),pe)},registerRenameProvider(se,pe){return pt.registerRenameProvider(Be,gt(se),pe)},registerDocumentSymbolProvider(se,pe,Le){return pt.registerDocumentSymbolProvider(Be,gt(se),pe,Le)},registerWorkspaceSymbolProvider(se){return pt.registerWorkspaceSymbolProvider(Be,se)},registerDocumentFormattingEditProvider(se,pe){return pt.registerDocumentFormattingEditProvider(Be,gt(se),pe)},registerDocumentRangeFormattingEditProvider(se,pe){return pt.registerDocumentRangeFormattingEditProvider(Be,gt(se),pe)},registerOnTypeFormattingEditProvider(se,pe,Le,...ut){return pt.registerOnTypeFormattingEditProvider(Be,gt(se),pe,[Le].concat(ut))},registerDocumentSemanticTokensProvider(se,pe,Le){return pt.registerDocumentSemanticTokensProvider(Be,gt(se),pe,Le)},registerDocumentRangeSemanticTokensProvider(se,pe,Le){return pt.registerDocumentRangeSemanticTokensProvider(Be,gt(se),pe,Le)},registerSignatureHelpProvider(se,pe,Le,...ut){return typeof Le=="object"?pt.registerSignatureHelpProvider(Be,gt(se),pe,Le):pt.registerSignatureHelpProvider(Be,gt(se),pe,typeof Le=="undefined"?[]:[Le,...ut])},registerCompletionItemProvider(se,pe,...Le){return pt.registerCompletionItemProvider(Be,gt(se),pe,Le)},registerInlineCompletionItemProvider(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"inlineCompletions"),pt.registerInlineCompletionsProvider(Be,gt(se),pe)},registerDocumentLinkProvider(se,pe){return pt.registerDocumentLinkProvider(Be,gt(se),pe)},registerColorProvider(se,pe){return pt.registerColorProvider(Be,gt(se),pe)},registerFoldingRangeProvider(se,pe){return pt.registerFoldingRangeProvider(Be,gt(se),pe)},registerSelectionRangeProvider(se,pe){return pt.registerSelectionRangeProvider(Be,se,pe)},registerCallHierarchyProvider(se,pe){return pt.registerCallHierarchyProvider(Be,se,pe)},registerTypeHierarchyProvider(se,pe){return pt.registerTypeHierarchyProvider(Be,se,pe)},setLanguageConfiguration:(se,pe)=>pt.setLanguageConfiguration(Be,se,pe),getTokenInformationAtPosition(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"tokenInformation"),Vt.tokenAtPosition(se,pe)},registerInlayHintsProvider(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"inlayHints"),pt.registerInlayHintsProvider(Be,se,pe)},createLanguageStatusItem(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"languageStatus"),Vt.createLanguageStatusItem(Be,se,pe)}},Ri={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(se,pe,Le){const ut=await(P.URI.isUri(se)?Promise.resolve(ni.openTextDocument(se)):Promise.resolve(se));return At.showTextDocument(ut,pe,Le)},createTextEditorDecorationType(se){return At.createTextEditorDecorationType(Be,se)},onDidChangeActiveTextEditor(se,pe,Le){return At.onDidChangeActiveTextEditor(se,pe,Le)},onDidChangeVisibleTextEditors(se,pe,Le){return At.onDidChangeVisibleTextEditors(se,pe,Le)},onDidChangeTextEditorSelection(se,pe,Le){return At.onDidChangeTextEditorSelection(se,pe,Le)},onDidChangeTextEditorOptions(se,pe,Le){return At.onDidChangeTextEditorOptions(se,pe,Le)},onDidChangeTextEditorVisibleRanges(se,pe,Le){return At.onDidChangeTextEditorVisibleRanges(se,pe,Le)},onDidChangeTextEditorViewColumn(se,pe,Le){return At.onDidChangeTextEditorViewColumn(se,pe,Le)},onDidCloseTerminal(se,pe,Le){return vt.onDidCloseTerminal(se,pe,Le)},onDidOpenTerminal(se,pe,Le){return vt.onDidOpenTerminal(se,pe,Le)},onDidChangeActiveTerminal(se,pe,Le){return vt.onDidChangeActiveTerminal(se,pe,Le)},onDidChangeTerminalDimensions(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"terminalDimensions"),vt.onDidChangeTerminalDimensions(se,pe,Le)},onDidChangeTerminalState(se,pe,Le){return vt.onDidChangeTerminalState(se,pe,Le)},onDidWriteTerminalData(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(se,pe,Le)},get state(){return qe.state},onDidChangeWindowState(se,pe,Le){return qe.onDidChangeWindowState(se,pe,Le)},showInformationMessage(se,...pe){return ui.showMessage(Be,_.default.Info,se,pe[0],pe.slice(1))},showWarningMessage(se,...pe){return ui.showMessage(Be,_.default.Warning,se,pe[0],pe.slice(1))},showErrorMessage(se,...pe){return ui.showMessage(Be,_.default.Error,se,pe[0],pe.slice(1))},showQuickPick(se,pe,Le){return Array.isArray(se)&&se.some(ut=>ut.kind===M.QuickPickItemKind.Separator)&&(0,ye.checkProposedApiEnabled)(Be,"quickPickSeparators"),qt.showQuickPick(se,pe,Le)},showWorkspaceFolderPick(se){return qt.showWorkspaceFolderPick(se)},showInputBox(se,pe){return qt.showInput(se,pe)},showOpenDialog(se){return ti.showOpenDialog(se)},showSaveDialog(se){return ti.showSaveDialog(se)},createStatusBarItem(se,pe,Le){let ut,Ct,Dt;return typeof se=="string"?(ut=se,Ct=pe,Dt=Le):(Ct=se,Dt=pe),gi.createStatusBarEntry(Be,ut,Ct,Dt)},setStatusBarMessage(se,pe){return gi.setStatusBarMessage(se,pe)},withScmProgress(se){return Ze.report("window.withScmProgress",Be,"Use 'withProgress' instead."),fi.withProgress(Be,{location:M.ProgressLocation.SourceControl},(pe,Le)=>se({report(ut){}}))},withProgress(se,pe){return fi.withProgress(Be,se,pe)},createOutputChannel(se){return Tt.createOutputChannel(se,Be)},createWebviewPanel(se,pe,Le,ut){return Kt.createWebviewPanel(Be,se,pe,Le,ut)},createWebviewTextEditorInset(se,pe,Le,ut){return(0,ye.checkProposedApiEnabled)(Be,"editorInsets"),ai.createWebviewEditorInset(se,pe,Le,ut,Be)},createTerminal(se,pe,Le){return typeof se=="object"?"pty"in se?vt.createExtensionTerminal(se):vt.createTerminalFromOptions(se):vt.createTerminal(se,pe,Le)},registerTerminalLinkProvider(se){return vt.registerLinkProvider(se)},registerTerminalProfileProvider(se,pe){return vt.registerProfileProvider(Be,se,pe)},registerTreeDataProvider(se,pe){return Xt.registerTreeDataProvider(se,pe,Be)},createTreeView(se,pe){return Xt.createTreeView(se,pe,Be)},registerWebviewPanelSerializer:(se,pe)=>Kt.registerWebviewPanelSerializer(Be,se,pe),registerCustomEditorProvider:(se,pe,Le={})=>_i.registerCustomEditorProvider(Be,se,pe,Le),registerFileDecorationProvider(se){return yt.registerFileDecorationProvider(se,Be.identifier)},registerUriHandler(se){return Lt.registerUriHandler(Be.identifier,se)},createQuickPick(){return qt.createQuickPick(Be)},createInputBox(){return qt.createInputBox(Be.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(se,pe,Le){return mi.onDidChangeActiveColorTheme(se,pe,Le)},registerWebviewViewProvider(se,pe,Le){return Ci.registerWebviewViewProvider(Be,se,pe,Le?.webviewOptions)},get activeNotebookEditor(){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(se,pe,Le)},get visibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(se,pe,Le)},onDidChangeNotebookEditorVisibleRanges(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(se,pe,Le)},showNotebookDocument(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.showNotebookDocument(se,pe)},registerExternalUriOpener(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"externalUriOpener"),yi.registerExternalUriOpener(Be.identifier,se,pe,Le)},get tabs(){return(0,ye.checkProposedApiEnabled)(Be,"tabs"),wt.tabs},get activeTab(){return(0,ye.checkProposedApiEnabled)(Be,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,ye.checkProposedApiEnabled)(Be,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ye.checkProposedApiEnabled)(Be,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(se){return(0,ye.checkProposedApiEnabled)(Be,"inlineCompletions"),l.InlineCompletionController.get(se)}},ni={get rootPath(){return Ze.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),We.getPath()},set rootPath(se){throw i.readonly()},getWorkspaceFolder(se){return We.getWorkspaceFolder(se)},get workspaceFolders(){return We.getWorkspaceFolders()},get name(){return We.name},set name(se){throw i.readonly()},get workspaceFile(){return We.workspaceFile},set workspaceFile(se){throw i.readonly()},updateWorkspaceFolders:(se,pe,...Le)=>We.updateWorkspaceFolders(Be,se,pe||0,...Le),onDidChangeWorkspaceFolders:function(se,pe,Le){return We.onDidChangeWorkspace(se,pe,Le)},asRelativePath:(se,pe)=>We.getRelativePath(se,pe),findFiles:(se,pe,Le,ut)=>We.findFiles(W.GlobPattern.from(se),W.GlobPattern.from(pe),Le,Be.identifier,ut),findTextInFiles:(se,pe,Le,ut)=>{(0,ye.checkProposedApiEnabled)(Be,"findTextInFiles");let Ct,Dt;return typeof pe=="object"?(Ct=pe,Dt=Le):(Ct={},Dt=pe,ut=Le),We.findTextInFiles(se,Ct||{},Dt,Be.identifier,ut)},saveAll:se=>We.saveAll(se),applyEdit(se){return Di.applyWorkspaceEdit(se)},createFileSystemWatcher:(se,pe,Le,ut)=>Ut.createFileSystemWatcher(W.GlobPattern.from(se),pe,Le,ut),get textDocuments(){return St.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw i.readonly()},openTextDocument(se){let pe;const Le=se;if(typeof se=="string")pe=Promise.resolve(P.URI.file(se));else if(P.URI.isUri(se))pe=Promise.resolve(se);else if(!Le||typeof Le=="object")pe=St.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return pe.then(ut=>St.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(se,pe,Le)=>St.onDidAddDocument(se,pe,Le),onDidCloseTextDocument:(se,pe,Le)=>St.onDidRemoveDocument(se,pe,Le),onDidChangeTextDocument:(se,pe,Le)=>St.onDidChangeDocument(se,pe,Le),onDidSaveTextDocument:(se,pe,Le)=>St.onDidSaveDocument(se,pe,Le),onWillSaveTextDocument:(se,pe,Le)=>Nt.getOnWillSaveTextDocumentEvent(Be)(se,pe,Le),get notebookDocuments(){return Et.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,pe){let Le;if(P.URI.isUri(se))Le=se,await Et.openNotebookDocument(se);else if(typeof se=="string")Le=P.URI.revive(await Et.createNotebookDocument({viewType:se,content:pe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Le).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(se,pe,Le,ut){return Et.registerNotebookSerializer(Be,se,pe,Le,(0,ye.isProposedApiEnabled)(Be,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(se,pe,Le,ut)=>((0,ye.checkProposedApiEnabled)(Be,"notebookContentProvider"),Et.registerNotebookContentProvider(Be,se,pe,Le,(0,ye.isProposedApiEnabled)(Be,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(se,pe,Le)=>pi.onDidChangeConfiguration(se,pe,Le),getConfiguration(se,pe){return pe=arguments.length===1?void 0:pe,pi.getConfiguration(se,pe,Be)},registerTextDocumentContentProvider(se,pe){return Mt.registerTextDocumentContentProvider(se,pe)},registerTaskProvider:(se,pe)=>(Ze.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Be,se,pe)),registerFileSystemProvider(se,pe,Le){return(0,De.combinedDisposable)(ci.registerFileSystemProvider(Be,se,pe,Le),Re.addFileSystemProvider(se,pe))},get fs(){return Re.value},registerFileSearchProvider:(se,pe)=>((0,ye.checkProposedApiEnabled)(Be,"fileSearchProvider"),Ot.registerFileSearchProvider(se,pe)),registerTextSearchProvider:(se,pe)=>((0,ye.checkProposedApiEnabled)(Be,"textSearchProvider"),Ot.registerTextSearchProvider(se,pe)),registerRemoteAuthorityResolver:(se,pe)=>((0,ye.checkProposedApiEnabled)(Be,"resolvers"),Ge.registerRemoteAuthorityResolver(se,pe)),registerResourceLabelFormatter:se=>((0,ye.checkProposedApiEnabled)(Be,"resolvers"),Ei.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,pe,Le)=>Ut.onDidCreateFile(se,pe,Le),onDidDeleteFiles:(se,pe,Le)=>Ut.onDidDeleteFile(se,pe,Le),onDidRenameFiles:(se,pe,Le)=>Ut.onDidRenameFile(se,pe,Le),onWillCreateFiles:(se,pe,Le)=>Ut.getOnWillCreateFileEvent(Be)(se,pe,Le),onWillDeleteFiles:(se,pe,Le)=>Ut.getOnWillDeleteFileEvent(Be)(se,pe,Le),onWillRenameFiles:(se,pe,Le)=>Ut.getOnWillRenameFileEvent(Be)(se,pe,Le),openTunnel:se=>((0,ye.checkProposedApiEnabled)(Be,"resolvers"),Oe.openTunnel(Be,se).then(pe=>{if(!pe)throw new Error("cannot open tunnel");return pe})),get tunnels(){return(0,ye.checkProposedApiEnabled)(Be,"resolvers"),Oe.getTunnels()},onDidChangeTunnels:(se,pe,Le)=>((0,ye.checkProposedApiEnabled)(Be,"resolvers"),Oe.onDidChangeTunnels(se,pe,Le)),registerPortAttributesProvider:(se,pe)=>((0,ye.checkProposedApiEnabled)(Be,"portsAttributes"),Oe.registerPortsAttributesProvider(se,pe)),registerTimelineProvider:(se,pe)=>((0,ye.checkProposedApiEnabled)(Be,"timeline"),Si.registerTimelineProvider(se,pe,Be.identifier,mt.converter)),get isTrusted(){return We.trusted},requestWorkspaceTrust:se=>((0,ye.checkProposedApiEnabled)(Be,"workspaceTrust"),We.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,pe,Le)=>We.onDidGrantWorkspaceTrust(se,pe,Le)},Li={get inputBox(){return Ze.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Be)},createSourceControl(se,pe,Le){return Jt.createSourceControl(Be,se,pe,Le)}},Fi={createCommentController(se,pe){return li.createCommentController(Be,se,pe)}},Mi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(se,pe,Le){return _t.onDidStartDebugSession(se,pe,Le)},onDidTerminateDebugSession(se,pe,Le){return _t.onDidTerminateDebugSession(se,pe,Le)},onDidChangeActiveDebugSession(se,pe,Le){return _t.onDidChangeActiveDebugSession(se,pe,Le)},onDidReceiveDebugSessionCustomEvent(se,pe,Le){return _t.onDidReceiveDebugSessionCustomEvent(se,pe,Le)},onDidChangeBreakpoints(se,pe,Le){return _t.onDidChangeBreakpoints(se,pe,Le)},registerDebugConfigurationProvider(se,pe,Le){return _t.registerDebugConfigurationProvider(se,pe,Le||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,pe){return _t.registerDebugAdapterDescriptorFactory(Be,se,pe)},registerDebugAdapterTrackerFactory(se,pe){return _t.registerDebugAdapterTrackerFactory(se,pe)},startDebugging(se,pe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?_t.startDebugging(se,pe,{parentSession:Le}):_t.startDebugging(se,pe,Le||{})},stopDebugging(se){return _t.stopDebugging(se)},addBreakpoints(se){return _t.addBreakpoints(se)},removeBreakpoints(se){return _t.removeBreakpoints(se)},asDebugSourceUri(se,pe){return _t.asDebugSourceUri(se,pe)}},Oi={registerTaskProvider:(se,pe)=>It.registerTaskProvider(Be,se,pe),fetchTasks:se=>It.fetchTasks(se),executeTask:se=>It.executeTask(Be,se),get taskExecutions(){return It.taskExecutions},onDidStartTask:(se,pe,Le)=>It.onDidStartTask(se,pe,Le),onDidEndTask:(se,pe,Le)=>It.onDidEndTask(se,pe,Le),onDidStartTaskProcess:(se,pe,Le)=>It.onDidStartTaskProcess(se,pe,Le),onDidEndTaskProcess:(se,pe,Le)=>It.onDidEndTaskProcess(se,pe,Le)},Ni={createNotebookController(se,pe,Le,ut,Ct){return si.createNotebookController(Be,se,pe,Le,ut,(0,ye.isProposedApiEnabled)(Be,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(se,pe)=>Et.registerNotebookCellStatusBarItemProvider(Be,se,pe),get onDidSaveNotebookDocument(){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(se){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(se)},createRendererMessaging(se){return oi.createRendererMessaging(Be,se)},onDidChangeNotebookDocumentMetadata(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(se,pe,Le)},onDidChangeNotebookCells(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeNotebookCells(se,pe,Le)},onDidChangeNotebookCellExecutionState(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(se,pe,Le)},onDidChangeCellOutputs(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellOutputs(se,pe,Le)},onDidChangeCellMetadata(se,pe,Le){return(0,ye.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellMetadata(se,pe,Le)},createConcatTextDocument(se,pe){return(0,ye.checkProposedApiEnabled)(Be,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(Et,St,se,pe)}};return{version:we.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:I.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:c.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:be.TextSearchCompleteMessageType,TreeDataTransfer:M.TreeDataTransfer,TreeDataTransferItem:M.TreeDataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=le}),define(Ee[275],Se([0,1,83,133,35,131,36,38,45,34,70,55,72,91,52,65,134,66,44,90,122,54,132,11,227]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b,s,o,p,a,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(S.ILoggerService,a.ExtHostLoggerService),(0,g.registerSingleton)(S.ILogService,n.ExtHostLogService),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,g.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,g.registerSingleton)(R.IExtHostConsumerFileSystem,R.ExtHostConsumerFileSystem),(0,g.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,g.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,g.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,g.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,g.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,g.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,g.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,g.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(Ee[92],Se([0,1,16,11,32,69]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=P;function k(T,c,E,h){const w=(0,g.mapArrayOrNot)(E,C),v=new D.TextSearchMatch(c,w,h),R=v.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,I),uri:T,preview:{text:v.preview.text,matches:(0,g.mapArrayOrNot)(R,I)}}}e.createTextSearchResult=k;function C(T){return new D.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function I(T){return new _.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(c,E){this.prefix=c,this.logService=E}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};L=je([He(1,i.ILogService)],L),e.OutputChannel=L}),define(Ee[276],Se([0,1,96,22]),function(X,e,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===n)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const _=512,P=512,k=512*8,C=512*128;var I;(function(n){n[n.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(t,r){super(t);this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class T{constructor(t){this.iconvLiteDecoder=t}static async create(t){let r;if(t!==e.UTF8)r=(await new Promise((d,m)=>{X(["iconv-lite-umd"],d,m)})).getDecoder(w(t));else{const l=new TextDecoder;r={write(d){return l.decode(d,{stream:!0})},end(){return l.decode()}}}return new T(r)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function c(n,t){const r=t.minBytesRequiredForDetection??t.guessEncoding?k:P;return new Promise((l,d)=>{const m=(0,g.newWriteableStream)(B=>B.join("")),f=[];let u=0,y,A;const N=async()=>{try{const B=await S({buffer:i.VSBuffer.concat(f),bytesRead:u},t.guessEncoding);if(B.seemsBinary&&t.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);B.encoding=await t.overwriteEncoding(B.encoding),y=await T.create(B.encoding);const F=y.write(i.VSBuffer.concat(f).buffer);m.write(F),f.length=0,u=0,l({stream:m,detected:B})}catch(B){A?.dispose(),m.destroy(),d(B)}};A=(0,g.listenStream)(n,{onData:async B=>{y?m.write(y.write(B.buffer)):(f.push(B),u+=B.byteLength,u>=r&&(n.pause(),await N(),setTimeout(()=>n.resume())))},onError:B=>m.error(B),onEnd:async()=>{y||await N(),m.end(y?.end())}})})}e.toDecodeStream=c;async function E(n,t,r){const d=(await new Promise((u,y)=>{X(["iconv-lite-umd"],u,y)})).getEncoder(w(t),r);let m=!1,f=!1;return{read(){if(f)return null;const u=n.read();if(typeof u!="string"){if(f=!0,!m&&r?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=d.end();return y&&y.length>0?(m=!0,i.VSBuffer.wrap(y)):null}return m=!0,i.VSBuffer.wrap(d.write(u))}}}e.toEncodeReadable=E;async function h(n){return(await new Promise((r,l)=>{X(["iconv-lite-umd"],r,l)})).encodingExists(w(n))}e.encodingExists=h;function w(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=w;function v(n,t){if(!n||t<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),l=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&l===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&l===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const d=n.readUInt8(2);return r===e.UTF8_BOM[0]&&l===e.UTF8_BOM[1]&&d===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const R=["ascii","utf-16","utf-32"];async function b(n){const t=await new Promise((f,u)=>{X(["jschardet"],f,u)}),r=n.slice(0,C),l=p(r.buffer),d=t.detect(l);if(!d||!d.encoding)return null;const m=d.encoding.toLowerCase();return 0<=R.indexOf(m)?null:o(d.encoding)}const s={ibm866:"cp866",big5:"cp950"};function o(n){const t=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[t]||t}function p(n){let t="";for(let r=0;r<n.length;r++)t+=String.fromCharCode(n[r]);return t}function a(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=n.match(/windows(\d+)/);return t?"windows-"+t[1]:n}}}e.toCanonicalName=a;function S({buffer:n,bytesRead:t},r){let l=v(n,t),d=!1;if(l!==e.UTF16be&&l!==e.UTF16le&&n){let m=!0,f=!0,u=!1;for(let y=0;y<t&&y<_;y++){const A=y%2==1,N=n.readUInt8(y)===0;if(N&&(u=!0),m&&(A&&!N||!A&&N)&&(m=!1),f&&(A&&N||!A&&!N)&&(f=!1),N&&!m&&!f)break}u&&(m?l=e.UTF16le:f?l=e.UTF16be:d=!0)}return r&&!d&&!l&&n?b(n.slice(0,t)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:d,encoding:l}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[136],Se([0,1,276,28,135]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class _ extends D.TextSearchManager{constructor(k,C,I=i,L="searchProcess"){super(k,C,{readdir:T=>I.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,g.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=_}),define(Ee[277],Se([0,1,278,292,293,2,294]),function(X,e,g,i,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(T,c,E,h,w,v){const R=v.environment.useHostProxy,b=typeof R=="boolean"?R:!v.remote.isRemote,s=(0,P.createProxyResolver)({resolveProxy:p=>T.resolveProxy(p),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(p,a,...S)=>{switch(p){case P.LogLevel.Trace:h.trace(a,...S);break;case P.LogLevel.Debug:h.debug(a,...S);break;case P.LogLevel.Info:h.info(a,...S);break;case P.LogLevel.Warning:h.warn(a,...S);break;case P.LogLevel.Error:h.error(a,...S);break;case P.LogLevel.Critical:h.critical(a,...S);break;case P.LogLevel.Off:break;default:n(p,a,S);break}function n(t,r,...l){h.error("Unknown log level",t),h.error(r,...l)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:p=>{w.$publicLog2("resolveProxy",p)},useHostProxy:b,env:process.env}),o=C(c,s);return L(E,o)}e.connectProxyResolver=k;function C(T,c){const E={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(w=>{E.config=T.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(w=>{h.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,P.createHttpPatch)(g,c,{config:"off"},h,!0)),on:Object.assign({},g,(0,P.createHttpPatch)(g,c,{config:"on"},h,!0)),override:Object.assign({},g,(0,P.createHttpPatch)(g,c,{config:"override"},h,!0)),onRequest:Object.assign({},g,(0,P.createHttpPatch)(g,c,E,h,!0)),default:Object.assign(g,(0,P.createHttpPatch)(g,c,E,h,!1))},https:{off:Object.assign({},i,(0,P.createHttpPatch)(i,c,{config:"off"},h,!0)),on:Object.assign({},i,(0,P.createHttpPatch)(i,c,{config:"on"},h,!0)),override:Object.assign({},i,(0,P.createHttpPatch)(i,c,{config:"override"},h,!0)),onRequest:Object.assign({},i,(0,P.createHttpPatch)(i,c,E,h,!0)),default:Object.assign(i,(0,P.createHttpPatch)(i,c,E,h,!1))},tls:Object.assign(D,(0,P.createTlsPatch)(D))}}const I=new Map;function L(T,c){return T.getExtensionPathIndex().then(E=>{const h=X.__$__nodeRequire("module"),w=h._load;h._load=function(R,b,s){if(R==="tls")return c.tls;if(R!=="http"&&R!=="https")return w.apply(this,arguments);const o=c[R],p=E.findSubstr(_.URI.file(b.filename));let a=I.get(p);if(a||I.set(p,a={}),!a[R]){let S=o.default;a[R]={...S}}return a[R]}})}}),define(Ee[279],Se([0,1,37,9,79,30,12,8,92,280]),function(X,e,g,i,D,_,P,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(s,o,p,a){const S=c(s,o,p,a),n=o.folder.fsPath;return{cmd:g.spawn(L,S.args,{cwd:n}),rgDiskPath:L,siblingClauses:S.siblingClauses,rgArgs:S,cwd:n}}e.spawnRipgrepCmd=T;function c(s,o,p,a){const S=["--files","--hidden","--case-sensitive"];h([o],p,!1).forEach(t=>{const r=(0,C.anchorGlob)(t);if(S.push("-g",r),P.isMacintosh){const l=(0,D.normalizeNFD)(r);l!==r&&S.push("-g",l)}});const n=E([o],a,void 0,!1);return n.globArgs.forEach(t=>{const r=`!${(0,C.anchorGlob)(t)}`;if(S.push("-g",r),P.isMacintosh){const l=(0,D.normalizeNFD)(r);l!==r&&S.push("-g",l)}}),o.disregardIgnoreFiles!==!1?S.push("--no-ignore"):S.push("--no-ignore-parent"),o.ignoreSymlinks||S.push("--follow"),s.exists&&S.push("--quiet"),S.push("--no-config"),o.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:n.siblingClauses}}function E(s,o,p,a=!0){const S=[];let n={};return s.forEach(t=>{const r=Object.assign({},t.excludePattern||{},o||{}),l=w(r,a?t.folder.fsPath:void 0,p);S.push(...l.globArgs),l.siblingClauses&&(n=Object.assign(n,l.siblingClauses))}),{globArgs:S,siblingClauses:n}}e.foldersToRgExcludeGlobs=E;function h(s,o,p=!0){const a=[];return s.forEach(S=>{const n=Object.assign({},o||{},S.includePattern||{}),t=w(n,p?S.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=h;function w(s,o,p){const a=[],S={};return Object.keys(s).forEach(n=>{if(p&&p.has(n)||!n)return;const t=s[n];n=R(o?v(o,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),a.push(b(n))):t&&t.when&&(S[n]=t)}),{globArgs:a,siblingClauses:S}}function v(s,o){return i.isAbsolute(o)?o:i.join(s,o)}e.getAbsoluteGlob=v;function R(s){return s=k.rtrim(s,"\\"),k.rtrim(s,"/")}function b(s){return _.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=b}),define(Ee[281],Se([0,1,37,60,9,104,16,50,31,79,30,12,46,8,13,28,32,279,101]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(n=>n())});class o{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&C.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&C.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(r=>{const l=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),d=r.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==d).forEach(m=>{(0,L.isEqualOrParent)(m,d)&&(l[D.relative(d,m)]=!0)}),this.folderExcludePatterns.set(d,new a(l,d))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,r,l,d,m){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);r.forEach(f=>{const u=D.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,u)||this.matchFile(l,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(f,u)=>{this.call(this.cmdTraversal,this,f,l,d,y=>{if(y){const A=(0,k.toErrorMessage)(y);console.error(A),this.errors.push(A),u(y,void 0)}else u(null,void 0)})},(f,u)=>{this.fileWalkSW.stop();const y=f?P.coalesce(f)[0]:null;m(y,this.isLimitHit)})}parallel(t,r,l){const d=new Array(t.length),m=new Array(t.length);let f=!1,u=0;if(t.length===0)return l(null,[]);t.forEach((y,A)=>{r(y,(N,B)=>{if(N?(f=!0,d[A]=null,m[A]=N):(d[A]=B,m[A]=null),++u===t.length)return l(f?m:null,d)})})}call(t,r,...l){try{t.apply(r,l)}catch(d){l[l.length-1](d)}}cmdTraversal(t,r,l,d){const m=t.folder.fsPath,f=T.isMacintosh;let u;const y=()=>u&&u.kill();s.add(y);let A=M=>{s.delete(y),A=()=>{},d(M)},N="";const B=this.initDirectoryTree();let F;const O=(0,R.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);u=O.cmd,F=!Object.keys(O.siblingClauses).length;const z=O.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let W=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),l({message:W}),this.cmdResultCount=0,this.collectStdout(u,"utf8",l,(M,x,V)=>{if(M){A(M);return}if(this.isLimitHit){A();return}const H=(N+(f?I.normalizeNFC(x||""):x)).split(`
`);if(V){const Y=H.length;H[Y-1]=H[Y-1].trim(),H[Y-1]||H.pop()}else N=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,F){for(const Y of H)if(this.matchFile(r,{base:m,relativePath:Y,searchPath:this.getSearchPath(t,Y)}),this.isLimitHit){y();break}(V||this.isLimitHit)&&A();return}this.addDirectoryEntries(t,B,m,H,r),V&&(this.matchDirectoryTree(B,m,r),A())})}spawnFindCmd(t){const r=this.folderExcludePatterns.get(t.folder.fsPath),l=r.getBasenameTerms(),d=r.getPathTerms(),m=["-L","."];if(l.length||d.length){m.push("-not","(","(");for(const f of l)m.push("-name",f),m.push("-o");for(const f of d)m.push("-path",f),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),g.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,r,l){let d="";this.collectStdout(t,r,()=>{},(m,f,u)=>{if(m){l(m);return}d+=f,u&&l(null,d)})}collectStdout(t,r,l,d){let m=(y,A,N)=>{(y||N)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),d(y,A,N)},f=!1;t.stdout?(this.forwardData(t.stdout,r,m),t.stdout.once("data",()=>f=!0)):l({message:"stdout is null"});let u;t.stderr?u=this.collectData(t.stderr):l({message:"stderr is null"}),t.on("error",y=>{m(y)}),t.on("close",y=>{let A;!f&&(A=this.decodeData(u,r))&&S(A)?m(new Error(`command failed with error code ${y}: ${this.decodeData(u,r)}`)):(this.exists&&y===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,r,l){const d=new _.StringDecoder(r);return t.on("data",m=>{l(null,d.write(m))}),d}collectData(t){const r=[];return t.on("data",l=>{r.push(l)}),r}decodeData(t,r){const l=new _.StringDecoder(r);return t.map(d=>l.write(d)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:r},l,d,m){d.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const f=u=>{const y=D.basename(u),A=D.dirname(u);let N=r[A];N||(N=r[A]=[],f(A)),N.push({base:l,relativePath:u,basename:y,searchPath:this.getSearchPath(t,u)})};d.forEach(f)}matchDirectoryTree({rootEntries:t,pathToEntries:r},l,d){const m=this,f=this.folderExcludePatterns.get(l),u=this.filePattern;function y(A){m.directoriesWalked++;const N=C.hasSiblingFn(()=>A.map(B=>B.basename));for(let B=0,F=A.length;B<F;B++){const O=A[B],{relativePath:z,basename:W}=O;if(f.test(z,W,u!==W?N:void 0))continue;const M=r[z];if(M)y(M);else{if(m.filesWalked++,z===u)continue;m.matchFile(d,O)}if(m.isLimitHit)break}}y(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,r,l,d,m){const f=t.folder,u=C.hasSiblingFn(()=>l);this.parallel(l,(y,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const N=r?[r,y].join(D.sep):y;if(this.folderExcludePatterns.get(t.folder.fsPath).test(N,y,this.config.filePattern!==y?u:void 0))return A(null);const B=[f.fsPath,N].join(D.sep);i.lstat(B,(F,O)=>{if(F||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(B,O,(z,W)=>z||this.isCanceled||this.isLimitHit?A(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(B,O,(M,x)=>M||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?A(null):(this.walkedPaths[x]=!0,w.Promises.readdir(B).then(V=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(t,N,V,d,U=>A(U||null))},V=>{A(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&h.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(d,{base:f.fsPath,relativePath:N,searchPath:this.getSearchPath(t,N)}),A(null,void 0)))})},y=>{const A=y&&P.coalesce(y);return m(A&&A.length>0?A[0]:void 0)})}matchFile(t,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,D.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(r))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,r,l){return r.isSymbolicLink()?i.stat(t,l):l(null,r)}realPathIfNeeded(t,r,l){return r.isSymbolicLink()?i.realpath(t,(d,m)=>d?l(d):l(null,m)):l(null,t)}getSearchPath(t,r){return t.folderName?D.join(t.folderName,r):r}}e.FileWalker=o;class p{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new o(t)}search(t,r,l){this.walker.walk(this.folderQueries,this.extraFiles,t,r,(d,m)=>{l(d,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class a{constructor(t,r){this.expression=t,this.root=r,this.init(t)}init(t){let r,l;Object.keys(t).filter(d=>t[d]).forEach(d=>{D.isAbsolute(d)?(r=r||C.getEmptyExpression(),r[d]=t[d]):(l=l||C.getEmptyExpression(),l[d]=t[d])}),this.absoluteParsedExpr=r&&C.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=l&&C.parse(l,{trimForExclusions:!0})}test(t,r,l){return this.relativeParsedExpr&&this.relativeParsedExpr(t,r,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),r,l)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...C.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...C.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...C.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...C.getPathTerms(this.relativeParsedExpr)),t}}function S(n){const t=n.trim().split(`
`),r=t[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return E.uppercaseFirstLetter(t[t.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=S}),define(Ee[137],Se([0,1,37,295,104,16,74,31,9,8,2,32,69,296,280,92]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class R{constructor(f){this.outputChannel=f}provideTextSearchResults(f,u,y,A){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...u,folder:u.folder.toString()})}`),new Promise((N,B)=>{A.onCancellationRequested(()=>U());const F=S(f,u),O=u.folder.fsPath,z=F.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");this.outputChannel.appendLine(`${v} ${z}
 - cwd: ${O}`);let W=g.spawn(v,F,{cwd:O});W.on("error",j=>{console.error(j),this.outputChannel.appendLine("Error: "+(j&&j.message)),B((0,T.serializeSearchError)(new T.SearchError(j&&j.message,T.SearchErrorCode.rgProcessError)))});let M=!1;const x=new o(u.maxResults,O,u.previewOptions);x.on("result",j=>{M=!0,Y="",y.report(j)});let V=!1;const U=()=>{V=!0,W&&W.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,U()});let Y="";W.stdout.on("data",j=>{x.handleData(j),M||(Y+=j)});let re=!1;W.stdout.once("data",()=>re=!0);let K="";W.stderr.on("data",j=>{const te=j.toString();this.outputChannel.appendLine(te),K+=te}),W.on("close",()=>{if(this.outputChannel.appendLine(re?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),Y&&this.outputChannel.appendLine(`Got data without result: ${Y}`),this.outputChannel.appendLine(""),V)N({limitHit:H});else{x.flush(),W=null;let j;K&&!re&&(j=b(K))?B((0,T.serializeSearchError)(new T.SearchError(j.message,j.code))):N({limitHit:H})}})})}}e.RipgrepTextSearchEngine=R;function b(m){const f=m.split(`
`),u=f[0].trim();if(f.some(A=>A.startsWith("regex parse error")))return new T.SearchError(s(f),T.SearchErrorCode.regexParseError);const y=u.match(/grep config error: unknown encoding: (.*)/);if(y)return new T.SearchError(`Unknown encoding: ${y[1]}`,T.SearchErrorCode.unknownEncoding);if(u.startsWith("error parsing glob"))return new T.SearchError(u.charAt(0).toUpperCase()+u.substr(1),T.SearchErrorCode.globParseError);if(u.startsWith("the literal"))return new T.SearchError(u.charAt(0).toUpperCase()+u.substr(1),T.SearchErrorCode.invalidLiteral);if(u.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(u,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function s(m){const f=["Regex parse error"],u=m.filter(y=>y.startsWith("PCRE2:"));if(u.length>=1){const y=u[0].replace("PCRE2:","");if(y.indexOf(":")!==-1&&y.split(":").length>=2){const A=y.split(":")[1];f.push(":"+A)}}return f.join("")}e.buildRegexParseError=s;class o extends i.EventEmitter{constructor(f,u,y){super();this.maxResults=f,this.rootFolder=u,this.previewOptions=y,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,u){return super.on(f,u),this}handleData(f){if(this.isDone)return;const u=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(u)}handleDecodedData(f){let u=f.indexOf(`
`);const y=this.remainder+f;if(u>=0)u+=this.remainder.length;else{this.remainder=y;return}let A=0;for(;u>=0;)this.handleLine(y.substring(A,u).trim()),A=u+1,u=y.indexOf(`
`,A);this.remainder=y.substring(A)}handleLine(f){if(this.isDone||!f)return;let u;try{u=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(u.type==="match"){const y=p(u.data.path),A=L.URI.file(C.join(this.rootFolder,y)),N=this.createTextSearchMatch(u.data,A);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(u.type==="context"){const y=p(u.data.path),A=L.URI.file(C.join(this.rootFolder,y));this.createTextSearchContext(u.data,A).forEach(B=>this.onResult(B))}}createTextSearchMatch(f,u){const y=f.line_number-1,A=p(f.lines),N=Buffer.from(A);let B=0,F=0,O=y;f.submatches.length===0&&f.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const z=(0,_.coalesce)(f.submatches.map((W,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=p(W.match),V=N.slice(B,W.start).toString().length,U=F+V,H=a(x),Y=O,re=H.numLines+Y,K=H.numLines>0?H.lastLineLength:H.lastLineLength+U;return B=W.end,F=K,O=re,new c.Range(Y,U,re,K)}));return(0,w.createTextSearchResult)(u,A,z,this.previewOptions)}createTextSearchContext(f,u){const y=p(f.lines),A=f.line_number;return y.replace(/\r?\n$/,"").split(`
`).map((N,B)=>({text:N,uri:u,lineNumber:A+B}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=o;function p(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function a(m){const f=/\n/g;let u=0,y=-1,A;for(;A=f.exec(m);)u++,y=A.index;const N=y>=0?m.length-y-1:m.length;return{numLines:u,lastLineLength:N}}function S(m,f){const u=["--hidden"];u.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:y,otherIncludes:A}=(0,P.groupBy)(f.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const B=new Set;A.forEach(F=>{B.add(F)}),u.push("-g","!*"),B.forEach(F=>{n(F).map(w.anchorGlob).forEach(O=>{u.push("-g",O)})})}y&&y.length&&y.forEach(B=>{u.push("-g",B)}),f.excludes.map(w.anchorGlob).forEach(B=>u.push("-g",`!${B}`)),f.maxFileSize&&u.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?u.push("--no-ignore-parent"):u.push("--no-ignore"),f.followSymlinks&&u.push("--follow"),f.encoding&&f.encoding!=="utf8"&&u.push("--encoding",f.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,I.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),f.usePCRE2&&u.push("--pcre2"),u.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),u.push("--auto-hybrid-regex"));let N;if(m.isWordMatch){const F=(0,I.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");u.push("--regexp",F)}else if(m.isRegExp){let B=l(m.pattern);B=d(B),u.push("--regexp",B)}else N=m.pattern,u.push("--fixed-strings");return u.push("--no-config"),f.useGlobalIgnoreFiles||u.push("--no-ignore-global"),u.push("--json"),m.isMultiline&&u.push("--multiline"),f.beforeContext&&u.push("--before-context",f.beforeContext+""),f.afterContext&&u.push("--after-context",f.afterContext+""),u.push("--"),N&&u.push(N),u.push("."),u}function n(m){const f=(0,k.splitGlobAware)(m,"/");return f.map((u,y)=>f.slice(0,y+1).join("/"))}e.spreadGlobComponents=n;function t(m){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(f);)m=m.replace(f,"$1\\x{$2}");const u=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(u);)m=m.replace(u,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const r=m=>m.type==="Assertion"&&m.kind==="lookbehind";function l(m){let f;try{f=new E.RegExpParser().parsePattern(m)}catch{return m}let u="",y=0;const A=(F,O,z)=>{u+=m.slice(y,F)+z,y=O},N=[];return new E.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const O=N[0];if(!O)A(F.start,F.end,"\\r?\\n");else if(!N.some(r))if(O.type==="CharacterClass")if(O.negate){const z=m.slice(O.start+2,F.start)+m.slice(F.end,O.end-1);if(O.parent?.type==="Quantifier"){const W=O.parent;A(W.start,W.end,(z?`[^${z}]`:".")+(W.greedy?"+":"*"))}else A(O.start,O.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=m.slice(O.start+1,F.start)+m.slice(F.end,O.end-1);A(O.start,O.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else O.type==="Quantifier"&&A(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){r(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(f),u+=m.slice(y),u}e.fixRegexNewline=l;function d(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(Ee[282],Se([0,1,21,137,118,10]),function(X,e,g,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,L,T,c){const E=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===_.Schemas.userData){const h={...L,folder:L.folder.with({scheme:_.Schemas.file})},w=new D.Progress(v=>T.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(c,v=>E.provideTextSearchResults(I,h,w,v))}else return this.withToken(c,h=>E.provideTextSearchResults(I,L,T,h))}async withToken(I,L){const T=k(I);this.inProgress.add(T);const c=await L(T.token);return this.inProgress.delete(T),c}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=P;function k(C){const I=new g.CancellationTokenSource;return C.onCancellationRequested(()=>I.cancel()),I}}),define(Ee[283],Se([0,1,28,137,136]),function(X,e,g,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class _{constructor(C){this.query=C}search(C,I,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(E){L({message:E})}},c=new D.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(T),g);return new Promise((E,h)=>c.search(w=>{I(w.map(P))},C).then(w=>E({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=_;function P(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((C,I)=>{if(I.ranges){const L=I;return C+(Array.isArray(L.ranges)?L.ranges.length:1)}else return C+1},0)}}}),define(Ee[284],Se([0,1,16,18,15,3,101,9,46,2,42,32,281,283]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(o="searchProcess"){this.processType=o,this.caches=Object.create(null)}fileSearch(o){let p;const a=R(o),S=new _.Emitter({onFirstListenerDidAdd:()=>{p=(0,i.createCancelablePromise)(n=>this.doFileSearchWithEngine(c.Engine,a,t=>S.fire(t),n)),p.then(n=>S.fire(n),n=>S.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{p.cancel()}});return S.event}textSearch(o){let p;const a=R(o),S=new _.Emitter({onFirstListenerDidAdd:()=>{p=(0,i.createCancelablePromise)(n=>this.ripgrepTextSearch(a,t=>S.fire(t),n)),p.then(n=>S.fire(n),n=>S.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{p.cancel()}});return S.event}ripgrepTextSearch(o,p,a){return o.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(o).search(a,p,p)}doFileSearch(o,p,a){return this.doFileSearchWithEngine(c.Engine,o,p,a)}doFileSearchWithEngine(o,p,a,S,n=h.BATCH_SIZE){let t=0;const r=d=>{Array.isArray(d)?(t+=d.length,a(d.map(m=>this.rawMatchToSearchItem(m)))):d.relativePath?(t++,a(this.rawMatchToSearchItem(d))):a(d)};if(p.sortByScore){let d=this.trySortedSearchFromCache(p,r,S);if(!d){const m=p.maxResults?Object.assign({},p,{maxResults:null}):p,f=new o(m);d=this.doSortedSearch(f,p,a,r,S)}return new Promise((m,f)=>{d.then(([u,y])=>{const A=y.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(A,a,n),m(u)},f)})}const l=new o(p);return this.doSearch(l,r,n,S).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(o){return{path:o.base?(0,k.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,p,a,S,n){const t=new _.Emitter;let r=(0,i.createCancelablePromise)(d=>{let m=[];const f=u=>{Array.isArray(u)?m=u:(S(u),t.fire(u))};return this.doSearch(o,f,-1,d).then(u=>[u,m])}),l;if(p.cacheKey){l=this.getOrCreateCache(p.cacheKey);const d={promise:r,event:t.event,resolved:!1};l.resultsToSearchCache[p.filePattern||""]=d,r.then(()=>{d.resolved=!0},m=>{delete l.resultsToSearchCache[p.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([d,m])=>{const f=l?l.scorerCache:Object.create(null),u=(typeof p.maxResults!="number"||p.maxResults>0)&&C.StopWatch.create(!1);return this.sortResults(p,m,f,n).then(y=>{const A=u?u.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:y.length},messages:d.messages,limitHit:d.limitHit||typeof p.maxResults=="number"&&m.length>p.maxResults},y]})})}getOrCreateCache(o){const p=this.caches[o];return p||(this.caches[o]=new w)}trySortedSearchFromCache(o,p,a){const S=o.cacheKey&&this.caches[o.cacheKey];if(!S)return;const n=this.getResultsFromCache(S,o.filePattern||"",p,a);if(n)return n.then(([t,r,l])=>{const d=C.StopWatch.create(!1);return this.sortResults(o,r,S.scorerCache,a).then(m=>{const f=d.elapsed(),u={fromCache:!0,detailStats:l,type:this.processType,resultCount:r.length,sortingTime:f};return[{type:"success",limitHit:t.limitHit||typeof o.maxResults=="number"&&r.length>o.maxResults,stats:u},m]})})}sortResults(o,p,a,S){const n=(0,P.prepareQuery)(o.filePattern||""),t=(l,d)=>(0,P.compareItemsByFuzzyScore)(l,d,n,!0,v,a),r=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return g.topAsync(p,t,r,1e4,S)}sendProgress(o,p,a){if(a&&a>0)for(let S=0;S<o.length;S+=a)p(o.slice(S,S+a));else p(o)}getResultsFromCache(o,p,a,S){const n=C.StopWatch.create(!1),t=p.indexOf(k.sep)>=0;let r;for(const f in o.resultsToSearchCache)if(p.startsWith(f)){if(t&&f.indexOf(k.sep)<0&&f!=="")continue;const u=o.resultsToSearchCache[f];r={promise:this.preventCancellation(u.promise),event:u.event,resolved:u.resolved};break}if(!r)return null;const l=n.elapsed(),d=C.StopWatch.create(!1),m=r.event(a);return S&&S.onCancellationRequested(()=>{m.dispose()}),r.promise.then(([f,u])=>{if(S&&S.isCancellationRequested)throw(0,D.canceled)();const y=[],A=(0,P.prepareQuery)(p).normalizedLowercase;for(const N of u)!(0,T.isFilePatternMatch)(N,A)||y.push(N);return[f,y,{cacheWasResolved:r.resolved,cacheLookupTime:l,cacheFilterTime:d.elapsed(),cacheEntryCount:u.length}]})}doSearch(o,p,a,S){return new Promise((n,t)=>{let r=[];S&&S.onCancellationRequested(()=>o.cancel()),o.search(l=>{l&&(a?(r.push(l),a>0&&r.length>=a&&(p(r),r=[])):p(l))},l=>{p(l)},(l,d)=>{r.length&&p(r),l?t(l):n(d)})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,a){return o.then(p,a)}catch(p){return this.then(void 0,p)}finally(p){return o.finally(p)}}}}e.SearchService=h,h.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(s){return(0,k.basename)(s.relativePath)}getItemDescription(s){return(0,k.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function R(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(b),extraFileResources:s.extraFileResources&&s.extraFileResources.map(o=>I.URI.revive(o))}}function b(s){return{...s,folder:I.URI.revive(s.folder)}}}),define(Ee[285],Se([0,1,6,10,2,28,11,26,14,72,64,32,284,282,92,136]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends I.ExtHostSearch{constructor(b,s,o,p){super(b,o,p);this._pfs=_,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new E.RipgrepSearchProvider(a)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new E.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(i.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,s){const o=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,s,o,p){const a=(0,I.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,s,a,p):super.$provideFileSearchResults(b,s,o,p)}doInternalFileSearch(b,s,o,p){const a=S=>{if((0,T.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(b,s,S.map(n=>D.URI.file(n.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,a,p)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,s){return new w.NativeTextSearchManager(b,s,void 0,"textSearchProvider")}};v=je([He(0,C.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,P.ILogService)],v),e.NativeExtHostSearch=v}),define(Ee[138],Se([0,1,297,125,81,22,15,3,6,9,12,33,106,107,298]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(u,y=""){this.debugLabel=y,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,P.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,y){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,y)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const y=A=>{this.traceSocketEvent("read",A),u(_.VSBuffer.wrap(A))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(u){const y=A=>{this.traceSocketEvent("close",{hadError:A}),u({type:0,hadError:A,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(u){const y=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,P.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,P.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=w;var v;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var R;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(R||(R={}));class b extends C.Disposable{constructor(u,y,A,N){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new s(this,y,A,N,this._onData,(B,F)=>this._write(B,F))),this._register(this._flowManager.onError(B=>{console.error(B),(0,P.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,y){this.socket.traceSocketEvent(u,y)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,y){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let A=2;u.byteLength<126?A+=0:u.byteLength<2**16?A+=2:A+=8;const N=_.VSBuffer.alloc(A);if(y?N.writeUInt8(194,0):N.writeUInt8(130,0),u.byteLength<126)N.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){N.writeUInt8(126,1);let B=1;N.writeUInt8(u.byteLength>>>8&255,++B),N.writeUInt8(u.byteLength>>>0&255,++B)}else{N.writeUInt8(127,1);let B=1;N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(u.byteLength>>>24&255,++B),N.writeUInt8(u.byteLength>>>16&255,++B),N.writeUInt8(u.byteLength>>>8&255,++B),N.writeUInt8(u.byteLength>>>0&255,++B)}this.socket.write(_.VSBuffer.concat([N,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),A=y.readUInt8(0),N=(A&128)>>>7,B=(A&64)>>>6,F=y.readUInt8(1),O=(F&128)>>>7,z=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),A=y.readUInt8(1),N=(A&128)>>>7;let B=A&127,F=1;B===126?B=y.readUInt8(++F)*2**8+y.readUInt8(++F):B===127&&(B=y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F));let O=0;N&&(O=y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F)),this._state.state=3,this._state.readLen=B,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),a(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class s extends C.Disposable{constructor(u,y,A,N,B,F){super();this._tracer=u,this._onData=B,this._writeFn=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new o(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const y=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(y,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,y){return new Promise((A,N)=>{u.write(y),u.flush(B=>A(B))})}acceptFrame(u,y,A){this._readQueue.push({data:u,isCompressed:y,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,y,A){return new Promise((N,B)=>{u.write(y),A&&u.write(_.VSBuffer.fromByteArray([0,0,255,255])),u.flush(F=>N(F))})}}class o extends C.Disposable{constructor(u,y,A,N){super();this._tracer=u,this._recordInflateBytes=y,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(_.VSBuffer.wrap(B))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(y)})}}class p extends C.Disposable{constructor(u,y){super();this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),u(y)})}}function a(f,u){if(u===0)return;let y=f.byteLength>>>2;for(let z=0;z<y;z++){const W=f.readUInt32BE(z*4);f.writeUInt32BE(W^u,z*4)}let A=y*4,N=f.byteLength-A;const B=u>>>24&255,F=u>>>16&255,O=u>>>8&255;N>=1&&f.writeUInt8(f.readUInt8(A)^B,A),N>=2&&f.writeUInt8(f.readUInt8(A+1)^F,A+1),N>=3&&f.writeUInt8(f.readUInt8(A+2)^O,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function n(){const f=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):u=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),r(u),u}e.createRandomIPCHandle=n;function t(f,u,y){const A=(0,g.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${y}-${u}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${y}-${u}.sock`):N=(0,I.join)(f,`${y}-${u}.sock`),r(N),N}e.createStaticIPCHandle=t;function r(f){const u=S[L.platform];typeof u=="number"&&f.length>=u&&console.warn(`WARNING: IPC handle "${f}" is longer than ${u} chars, try a shorter --user-data-dir`)}class l extends c.IPCServer{constructor(u){super(l.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const y=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(y,A=>({protocol:new E.Protocol(new w(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function d(f){return new Promise((u,y)=>{const A=(0,i.createServer)();A.on("error",y),A.listen(f,()=>{A.removeListener("error",y),u(new l(A))})})}e.serve=d;function m(f,u){return new Promise((y,A)=>{const N=(0,i.createConnection)(f,()=>{N.removeListener("error",A),y(E.Client.fromSocket(new w(N,`ipc-client${u}`),u))});N.once("error",A)})}e.connect=m}),define(Ee[286],Se([0,1,138,278,60,38,2,198,11]),function(X,e,g,i,D,_,P,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(c,E,h){this._commands=c,this.logService=E,this._ipcHandlePath=h,this._server=i.createServer((w,v)=>this.onRequest(w,v)),this.setup().catch(w=>(E.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,E){const h=[];c.setEncoding("utf8"),c.on("data",w=>h.push(w)),c.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,E);break;case"openExternal":this.openExternal(w,E);break;case"status":this.getStatus(w,E);break;case"extensionManagement":this.manageExtensions(w,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${w.type}`,v=>{v&&this.logService.error(v)}),E.end();break}})}open(c,E){const{fileURIs:h,folderURIs:w,forceNewWindow:v,diffMode:R,addMode:b,forceReuseWindow:s,gotoLineMode:o,waitMarkerFilePath:p,remoteAuthority:a}=c,S=[];if(Array.isArray(w))for(const l of w)try{S.push({folderUri:P.URI.parse(l)})}catch{}if(Array.isArray(h))for(const l of h)try{(0,k.hasWorkspaceFileExtension)(l)?S.push({workspaceUri:P.URI.parse(l)}):S.push({fileUri:P.URI.parse(l)})}catch{}const n=p?P.URI.file(p):void 0,r={forceNewWindow:v,diffMode:R,addMode:b,gotoLineMode:o,forceReuseWindow:s,preferNewWindow:!s&&!n&&!b,waitMarkerFileURI:n,remoteAuthority:a};this._commands.executeCommand("_remoteCLI.windowOpen",S,r),E.writeHead(200),E.end()}async openExternal(c,E){for(const h of c.uris){const w=P.URI.parse(h),v=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",v)}E.writeHead(200),E.end()}async manageExtensions(c,E){try{const h=R=>R?.map(b=>/\.vsix$/i.test(b)?P.URI.parse(b):b),w={list:c.list,install:h(c.install),uninstall:h(c.uninstall),force:c.force},v=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);E.writeHead(200),E.write(v)}catch(h){E.writeHead(500),E.write(String(h),w=>{w&&this.logService.error(w)})}E.end()}async getStatus(c,E){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(h),E.end()}catch(h){E.writeHead(500),E.write(String(h),w=>{w&&this.logService.error(w)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let L=class extends I{constructor(c,E){super(c,E,(0,g.createRandomIPCHandle)())}};L=je([He(0,_.IExtHostCommands),He(1,C.ILogService)],L),e.CLIServer=L}),define(Ee[287],Se([0,1,71,274,269,5,277,39,259,2,10,7,286,105]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends D.RequireInterceptor{_installInterceptor(){const R=this,b=X.__$__nodeRequire("module"),s=b._load;b._load=function(p,a,S){for(let n of R._alternatives){let t=n(p);if(t){p=t;break}}return R._factories.has(p)?R._factories.get(p).load(p,I.URI.file((0,E.realpathSync)(a.filename)),n=>s.apply(this,[n,a,S])):s.apply(this,arguments)}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const R=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(h,R,this._registry).install(),g.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const o=process.send,p=this._extHostContext.getProxy(_.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?o.apply(process,a):(p.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(R){return R.main}_loadCommonJSModule(R,b,s){if(b.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{R&&g.mark(`code/extHost/willLoadExtensionCode/${R.value}`),o=X.__$__nodeRequire(b.fsPath)}catch(p){return Promise.reject(p)}finally{R&&g.mark(`code/extHost/didLoadExtensionCode/${R.value}`),s.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(R){if(!!this._initData.remote.isRemote)for(const b in R){const s=R[b];s===null?delete process.env[b]:process.env[b]=s}}}e.ExtHostExtensionService=w}),define(Ee[288],Se([0,1,83,262,271,270,285,287,263,55,39,72,70,34,52,67,261,260,11]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(L.IExtHostExtensionService,k.ExtHostExtensionService),(0,g.registerSingleton)(b.ILoggerService,R.ExtHostLoggerService),(0,g.registerSingleton)(w.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,_.ExtHostDebugService),(0,g.registerSingleton)(T.IExtHostSearch,P.NativeExtHostSearch),(0,g.registerSingleton)(c.IExtHostTask,D.ExtHostTask),(0,g.registerSingleton)(E.IExtHostTerminalService,i.ExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,C.ExtHostTunnelService)}),define(Ee[289],Se([0,1,125,299,71,15,107,138,191,225,272,22,103,28,105,18,114,275,288]),function(X,e,g,i,D,_,P,k,C,I,L,T,c,E,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const R=i(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=X.__$__nodeRequire("module"),r=t._load;t._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function s(t){process.exit=function(r){if(t)b(r);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let o=function(t){b()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,r)=>{let l=null,d=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,f=3e5,u=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),m),y=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),f);process.on("message",(N,B)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=T.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let O;if(N.skipWebSocketFrames)O=new k.NodeSocket(B,"extHost-socket");else{const z=T.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));O=new k.WebSocketNodeSocket(new k.NodeSocket(B,"extHost-socket"),N.permessageDeflate,z,!1)}l?(u.cancel(),y.cancel(),l.beginAcceptReconnection(O,F),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(d),l=new P.PersistentProtocol(O,F),l.sendResume(),l.onDidDispose(()=>o("renderer disconnected")),t(l),l.onSocketClose(()=>{u.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(y.isScheduled())return;u.isScheduled()&&y.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,l)=>{const d=g.createConnection(t,()=>{d.removeListener("error",l),r(new P.PersistentProtocol(new k.NodeSocket(d,"extHost-renderer")))});d.once("error",l),d.on("close",()=>{o("renderer closed the socket")})})}}async function a(){const t=await p();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(r=>{(0,I.isMessageOfType)(r,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||t.send(r)}drain(){return t.drain()}}}function S(t){return new Promise(r=>{const l=t.onMessage(d=>{l.dispose();const m=JSON.parse(d.toString()),f=m.commit,u=C.default.commit;f&&u&&f!==u&&b(55);let y=0;setInterval(function(){try{process.kill(m.parentPid,0),y=0}catch(N){N&&N.code==="EPERM"?(y++,y>=3&&o(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):o(`parent process ${m.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let A;try{A=X.__$__nodeRequire("native-watchdog"),A.start(m.parentPid)}catch(N){(0,_.onUnexpectedError)(N)}t.send((0,I.createMessageOfType)(0)),r({protocol:t,initData:m})});t.send((0,I.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(y,A)=>{t.push(A),setTimeout(()=>{const N=t.indexOf(A);N>=0&&A.catch(B=>{t.splice(N,1),(0,_.isPromiseCanceledError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),y&&(0,_.onUnexpectedError)(y))})},1e3)}),process.on("rejectionHandled",y=>{const A=t.indexOf(y);A>=0&&t.splice(A,1)}),process.on("uncaughtException",function(y){(0,_.onUnexpectedError)(y)}),D.mark("code/extHost/willConnectToRenderer");const r=await a();D.mark("code/extHost/didConnectToRenderer");const l=await S(r);D.mark("code/extHost/didWaitForInitData");const{initData:d}=l;s(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=R.useHostProxy!==void 0?R.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,v.boolean)(R.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(A){b(A)}exists(A){return E.Promises.exists(A)}realpath(A){return(0,h.realpath)(A)}};let f=null;if(d.remote.authority&&R.uriTransformerPath)try{const A=X.__$__nodeRequire(R.uriTransformerPath)(d.remote.authority);f=new c.URITransformer(A)}catch(y){console.error(y)}const u=new L.ExtensionHostMain(l.protocol,d,m,f);o=y=>u.terminate(y)}e.startExtensionHostProcess=n}),define(Ee[300],Se([0,1,289]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e8a26d3ebf5095d4324ad4bf794787540ed3b33e/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
