/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],Ce=function(Z){for(var e=[],s=0,t=Z.length;s<t;s++)e[s]=ye[Z[s]];return e};define(ye[41],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(t,E){if(!t)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=s}),define(ye[51],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function s(k){return k?k.replace(/\$\((.*?)\)/g,(T,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=s;class t{constructor(T,S,R){this.id=T,this.definition=S,this.description=R,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function E(k,T){const S=["codicon","codicon-"+k];return T&&S.push("codicon-modifier-"+T),S}e.getClassNamesArray=E;var A;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function S(C){if(C instanceof t)return["codicon","codicon-"+C.id];const n=T.exec(C.id);if(!n)return S(t.error);let[,m,r]=n;const g=["codicon","codicon-"+m];return r&&g.push("codicon-modifier-"+r.substr(1)),g}k.asClassNameArray=S;function R(C){return S(C).join(" ")}k.asClassName=R;function F(C){return"."+S(C).join(".")}k.asCSSSelector=F})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ye[74],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function t(F){const C=[];for(let n in F)s.call(F,n)&&C.push(F[n]);return C}e.values=t;function E(F,C){for(let n in F)if(s.call(F,n)&&C({key:n,value:F[n]},function(){delete F[n]})===!1)return}e.forEach=E;function A(F,C){const n=Object.create(null);for(const m of F){const r=C(m);let g=n[r];g||(g=n[r]=[]),g.push(m)}return n}e.groupBy=A;function k(F){const C=Object.create(null);return F&&F.forEach((n,m)=>{C[m]=n}),C}e.fromMap=k;function T(F,C){const n=[],m=[];for(let r of F)C.has(r)||n.push(r);for(let r of C)F.has(r)||m.push(r);return{removed:n,added:m}}e.diffSets=T;function S(F,C){const n=[],m=[];for(let[r,g]of F)C.has(r)||n.push(g);for(let[r,g]of C)F.has(r)||m.push(g);return{removed:n,added:m}}e.diffMaps=S;class R{constructor(){this.map=new Map}add(C,n){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(n)}delete(C,n){const m=this.map.get(C);!m||(m.delete(n),m.size===0&&this.map.delete(C))}forEach(C,n){const m=this.map.get(C);!m||m.forEach(n)}}e.SetMap=R}),define(ye[52],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(k){return(T,S,R)=>{let F=null,C=null;if(typeof R.value=="function"?(F="value",C=R.value):typeof R.get=="function"&&(F="get",C=R.get),!C)throw new Error("not supported");R[F]=k(C,S)}}e.createDecorator=s;function t(k,T,S){let R=null,F=null;if(typeof S.value=="function"?(R="value",F=S.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(R="get",F=S.get),!F)throw new Error("not supported");const C=`$memoize$${T}`;S[R]=function(...n){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,n)}),this[C]}}e.memoize=t;function E(k,T,S){return s((R,F)=>{const C=`$debounce$${F}`,n=`$debounce$result$${F}`;return function(...m){this[n]||(this[n]=S?S():void 0),clearTimeout(this[C]),T&&(this[n]=T(this[n],...m),m=[this[n]]),this[C]=setTimeout(()=>{R.apply(this,m),this[n]=S?S():void 0},k)}})}e.debounce=E;function A(k,T,S){return s((R,F)=>{const C=`$throttle$timer$${F}`,n=`$throttle$result$${F}`,m=`$throttle$lastRun$${F}`,r=`$throttle$pending$${F}`;return function(...g){if(this[n]||(this[n]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),T&&(this[n]=T(this[n],...g)),this[r])return;const l=this[m]+k;l<=Date.now()?(this[m]=Date.now(),R.apply(this,[this[n]]),this[n]=S?S():void 0):(this[r]=!0,this[C]=setTimeout(()=>{this[r]=!1,this[m]=Date.now(),R.apply(this,[this[n]]),this[n]=S?S():void 0},l-Date.now()))}})}e.throttle=A}),define(ye[53],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(ye[100],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var t;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(c){c.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function k(c,M=!1){let o=0,i=c.length,f="",u=0,h=16,b=0;function v(L){let z=0,x=0;for(;z<L;){const B=c.charCodeAt(o);if(B>=48&&B<=57)x=x*16+B-48;else if(B>=65&&B<=70)x=x*16+B-65+10;else if(B>=97&&B<=102)x=x*16+B-97+10;else break;o++,z++}return z<L&&(x=-1),x}function a(L){o=L,f="",u=0,h=16,b=0}function _(){const L=o;if(c.charCodeAt(o)===48)o++;else for(o++;o<c.length&&R(c.charCodeAt(o));)o++;if(o<c.length&&c.charCodeAt(o)===46)if(o++,o<c.length&&R(c.charCodeAt(o)))for(o++;o<c.length&&R(c.charCodeAt(o));)o++;else return b=3,c.substring(L,o);let z=o;if(o<c.length&&(c.charCodeAt(o)===69||c.charCodeAt(o)===101))if(o++,(o<c.length&&c.charCodeAt(o)===43||c.charCodeAt(o)===45)&&o++,o<c.length&&R(c.charCodeAt(o))){for(o++;o<c.length&&R(c.charCodeAt(o));)o++;z=o}else b=3;return c.substring(L,z)}function P(){let L="",z=o;for(;;){if(o>=i){L+=c.substring(z,o),b=2;break}const x=c.charCodeAt(o);if(x===34){L+=c.substring(z,o),o++;break}if(x===92){if(L+=c.substring(z,o),o++,o>=i){b=2;break}switch(c.charCodeAt(o++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const j=v(4);j>=0?L+=String.fromCharCode(j):b=4;break}default:b=5}z=o;continue}if(x>=0&&x<=31)if(S(x)){L+=c.substring(z,o),b=2;break}else b=6;o++}return L}function N(){if(f="",b=0,u=o,o>=i)return u=i,h=17;let L=c.charCodeAt(o);if(T(L)){do o++,f+=String.fromCharCode(L),L=c.charCodeAt(o);while(T(L));return h=15}if(S(L))return o++,f+=String.fromCharCode(L),L===13&&c.charCodeAt(o)===10&&(o++,f+=`
`),h=14;switch(L){case 123:return o++,h=1;case 125:return o++,h=2;case 91:return o++,h=3;case 93:return o++,h=4;case 58:return o++,h=6;case 44:return o++,h=5;case 34:return o++,f=P(),h=10;case 47:{const z=o-1;if(c.charCodeAt(o+1)===47){for(o+=2;o<i&&!S(c.charCodeAt(o));)o++;return f=c.substring(z,o),h=12}if(c.charCodeAt(o+1)===42){o+=2;const x=i-1;let B=!1;for(;o<x;){if(c.charCodeAt(o)===42&&c.charCodeAt(o+1)===47){o+=2,B=!0;break}o++}return B||(o++,b=1),f=c.substring(z,o),h=13}return f+=String.fromCharCode(L),o++,h=16}case 45:if(f+=String.fromCharCode(L),o++,o===i||!R(c.charCodeAt(o)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=_(),h=11;default:for(;o<i&&$(L);)o++,L=c.charCodeAt(o);if(u!==o){switch(f=c.substring(u,o),f){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return f+=String.fromCharCode(L),o++,h=16}}function $(L){if(T(L)||S(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let L;do L=N();while(L>=12&&L<=15);return L}return{setPosition:a,getPosition:()=>o,scan:M?y:N,getToken:()=>h,getTokenValue:()=>f,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>b}}e.createScanner=k;function T(c){return c===32||c===9||c===11||c===12||c===160||c===5760||c>=8192&&c<=8203||c===8239||c===8287||c===12288||c===65279}function S(c){return c===10||c===13||c===8232||c===8233}function R(c){return c>=48&&c<=57}var F;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(F||(F={}));function C(c,M){const o=[],i=new Object;let f;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function b(v,a,_,P){u.value=v,u.offset=a,u.length=_,u.type=P,u.colonOffset=void 0,f=u}try{d(c,{onObjectBegin:(v,a)=>{if(M<=v)throw i;f=void 0,h=M>v,o.push("")},onObjectProperty:(v,a,_)=>{if(M<a||(b(v,a,_,"property"),o[o.length-1]=v,M<=a+_))throw i},onObjectEnd:(v,a)=>{if(M<=v)throw i;f=void 0,o.pop()},onArrayBegin:(v,a)=>{if(M<=v)throw i;f=void 0,o.push(0)},onArrayEnd:(v,a)=>{if(M<=v)throw i;f=void 0,o.pop()},onLiteralValue:(v,a,_)=>{if(M<a||(b(v,a,_,I(v)),M<=a+_))throw i},onSeparator:(v,a,_)=>{if(M<=a)throw i;if(v===":"&&f&&f.type==="property")f.colonOffset=a,h=!1,f=void 0;else if(v===","){const P=o[o.length-1];typeof P=="number"?o[o.length-1]=P+1:(h=!0,o[o.length-1]=""),f=void 0}}})}catch(v){if(v!==i)throw v}return{path:o,previousNode:f,isAtPropertyKey:h,matches:v=>{let a=0;for(let _=0;a<v.length&&_<o.length;_++)if(v[a]===o[_]||v[a]==="*")a++;else if(v[a]!=="**")return!1;return a===v.length}}}e.getLocation=C;function n(c,M=[],o=A.DEFAULT){let i=null,f=[];const u=[];function h(v){Array.isArray(f)?f.push(v):i!==null&&(f[i]=v)}return d(c,{onObjectBegin:()=>{const v={};h(v),u.push(f),f=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{f=u.pop()},onArrayBegin:()=>{const v=[];h(v),u.push(f),f=v,i=null},onArrayEnd:()=>{f=u.pop()},onLiteralValue:h,onError:(v,a,_)=>{M.push({error:v,offset:a,length:_})}},o),f[0]}e.parse=n;function m(c,M=[],o=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function u(v){return i.children.push(v),v}d(c,{onObjectBegin:v=>{i=u({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,a,_)=>{i=u({type:"property",offset:a,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:a,length:_,parent:i})},onObjectEnd:(v,a)=>{i.length=v+a-i.offset,i=i.parent,f(v+a)},onArrayBegin:(v,a)=>{i=u({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,a)=>{i.length=v+a-i.offset,i=i.parent,f(v+a)},onLiteralValue:(v,a,_)=>{u({type:I(v),offset:a,length:_,parent:i,value:v}),f(a+_)},onSeparator:(v,a,_)=>{i.type==="property"&&(v===":"?i.colonOffset=a:v===","&&f(a))},onError:(v,a,_)=>{M.push({error:v,offset:a,length:_})}},o);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=m;function r(c,M){if(!c)return;let o=c;for(let i of M)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let f=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===i){o=u.children[1],f=!0;break}if(!f)return}else{const f=i;if(o.type!=="array"||f<0||!Array.isArray(o.children)||f>=o.children.length)return;o=o.children[f]}return o}e.findNodeAtLocation=r;function g(c){if(!c.parent||!c.parent.children)return[];const M=g(c.parent);if(c.parent.type==="property"){const o=c.parent.children[0].value;M.push(o)}else if(c.parent.type==="array"){const o=c.parent.children.indexOf(c);o!==-1&&M.push(o)}return M}e.getNodePath=g;function l(c){switch(c.type){case"array":return c.children.map(l);case"object":{const M=Object.create(null);for(let o of c.children){const i=o.children[1];i&&(M[o.children[0].value]=l(i))}return M}case"null":case"string":case"number":case"boolean":return c.value;default:return}}e.getNodeValue=l;function D(c,M,o=!1){return M>=c.offset&&M<c.offset+c.length||o&&M===c.offset+c.length}e.contains=D;function w(c,M,o=!1){if(D(c,M,o)){const i=c.children;if(Array.isArray(i))for(let f=0;f<i.length&&i[f].offset<=M;f++){const u=w(i[f],M,o);if(u)return u}return c}}e.findNodeAtOffset=w;function d(c,M,o=A.DEFAULT){const i=k(c,!1);function f(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(ae){return ae?le=>ae(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=f(M.onObjectBegin),b=u(M.onObjectProperty),v=f(M.onObjectEnd),a=f(M.onArrayBegin),_=f(M.onArrayEnd),P=u(M.onLiteralValue),N=u(M.onSeparator),$=f(M.onComment),y=u(M.onError),L=o&&o.disallowComments,z=o&&o.allowTrailingComma;function x(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:L||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ae){case 12:case 13:L?B(10):$();break;case 16:B(1);break;case 15:case 14:break;default:return ae}}}function B(ae,le=[],Se=[]){if(y(ae),le.length+Se.length>0){let Ee=i.getToken();for(;Ee!==17;){if(le.indexOf(Ee)!==-1){x();break}else if(Se.indexOf(Ee)!==-1)break;Ee=x()}}}function j(ae){const le=i.getTokenValue();return ae?P(le):b(le),x(),!0}function ue(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&(B(2),ae=0)}catch{B(2)}P(ae);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return x(),!0}function K(){return i.getToken()!==10?(B(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(N(":"),x(),be()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function ne(){h(),x();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||B(4,[],[]),N(","),x(),i.getToken()===2&&z)break}else ae&&B(6,[],[]);K()||B(4,[],[2,5]),ae=!0}return v(),i.getToken()!==2?B(7,[2],[]):x(),!0}function pe(){a(),x();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||B(4,[],[]),N(","),x(),i.getToken()===4&&z)break}else ae&&B(6,[],[]);be()||B(4,[],[4,5]),ae=!0}return _(),i.getToken()!==4?B(8,[4],[]):x(),!0}function be(){switch(i.getToken()){case 3:return pe();case 1:return ne();case 10:return j(!0);default:return ue()}}return x(),i.getToken()===17?o.allowEmptyContent?!0:(B(4,[],[]),!1):be()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=d;function p(c,M){let o=k(c),i=[],f,u=0,h;do switch(h=o.getPosition(),f=o.scan(),f){case 12:case 13:case 17:u!==h&&i.push(c.substring(u,h)),M!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,M)),u=o.getPosition();break}while(f!==17);return i.join("")}e.stripComments=p;function I(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ae,De){for(var ve=0;ve<De.length;ve++){var re=De[ve];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Ae,re.key,re)}}function e(Ae,De,ve){return De&&Z(Ae.prototype,De),ve&&Z(Ae,ve),Ae}function s(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var ve=Object.prototype.toString.call(Ae).slice(8,-1);if(ve==="Object"&&Ae.constructor&&(ve=Ae.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ae);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var ve=0,re=new Array(De);ve<De;ve++)re[ve]=Ae[ve];return re}function E(Ae,De){var ve=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ve)return(ve=ve.call(Ae)).next.bind(ve);if(Array.isArray(Ae)||(ve=s(Ae))||De&&Ae&&typeof Ae.length=="number"){ve&&(Ae=ve);var re=0;return function(){return re>=Ae.length?{done:!0}:{done:!1,value:Ae[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Ae){A.exports.defaults=Ae}A.exports={defaults:k(),getDefaults:k,changeDefaults:T};var S=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(De){return n[De]};function r(Ae,De){if(De){if(S.test(Ae))return Ae.replace(R,m)}else if(F.test(Ae))return Ae.replace(C,m);return Ae}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(Ae){return Ae.replace(g,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var D=/(^|[^\[])\^/g;function w(Ae,De){Ae=Ae.source||Ae,De=De||"";var ve={replace:function(oe,he){return he=he.source||he,he=he.replace(D,"$1"),Ae=Ae.replace(oe,he),ve},getRegex:function(){return new RegExp(Ae,De)}};return ve}var d=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function I(Ae,De,ve){if(Ae){var re;try{re=decodeURIComponent(l(ve)).replace(d,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}De&&!p.test(ve)&&(ve=f(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var c={},M=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Ae,De){c[" "+Ae]||(M.test(Ae)?c[" "+Ae]=Ae+"/":c[" "+Ae]=v(Ae,"/",!0)),Ae=c[" "+Ae];var ve=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Ae.replace(o,"$1")+De:De.charAt(0)==="/"?ve?De:Ae.replace(i,"$1")+De:Ae+De}var u={exec:function(){}};function h(Ae){for(var De=1,ve,re;De<arguments.length;De++){ve=arguments[De];for(re in ve)Object.prototype.hasOwnProperty.call(ve,re)&&(Ae[re]=ve[re])}return Ae}function b(Ae,De){var ve=Ae.replace(/\|/g,function(he,me,Te){for(var We=!1,Le=me;--Le>=0&&Te[Le]==="\\";)We=!We;return We?"|":" |"}),re=ve.split(/ \|/),oe=0;if(re[0].trim()||re.shift(),re[re.length-1].trim()||re.pop(),re.length>De)re.splice(De);else for(;re.length<De;)re.push("");for(;oe<re.length;oe++)re[oe]=re[oe].trim().replace(/\\\|/g,"|");return re}function v(Ae,De,ve){var re=Ae.length;if(re===0)return"";for(var oe=0;oe<re;){var he=Ae.charAt(re-oe-1);if(he===De&&!ve)oe++;else if(he!==De&&ve)oe++;else break}return Ae.substr(0,re-oe)}function a(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var ve=Ae.length,re=0,oe=0;oe<ve;oe++)if(Ae[oe]==="\\")oe++;else if(Ae[oe]===De[0])re++;else if(Ae[oe]===De[1]&&(re--,re<0))return oe;return-1}function _(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ae,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Ae),De>>=1,Ae+=Ae;return ve+Ae}var N={escape:r,unescape:l,edit:w,cleanUrl:I,resolveUrl:f,noopTest:u,merge:h,splitCells:b,rtrim:v,findClosingBracket:a,checkSanitizeDeprecation:_,repeatString:P},$=A.exports.defaults,y=N.rtrim,L=N.splitCells,z=N.escape,x=N.findClosingBracket;function B(Ae,De,ve,re){var oe=De.href,he=De.title?z(De.title):null,me=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){re.state.inLink=!0;var Te={type:"link",raw:ve,href:oe,title:he,text:me,tokens:re.inlineTokens(me,[])};return re.state.inLink=!1,Te}else return{type:"image",raw:ve,href:oe,title:he,text:z(me)}}function j(Ae,De){var ve=Ae.match(/^(\s+)(?:```)/);if(ve===null)return De;var re=ve[1];return De.split(`
`).map(function(oe){var he=oe.match(/^\s+/);if(he===null)return oe;var me=he[0];return me.length>=re.length?oe.slice(re.length):oe}).join(`
`)}var ue=function(){function Ae(ve){this.options=ve||$}var De=Ae.prototype;return De.space=function(re){var oe=this.rules.block.newline.exec(re);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},De.code=function(re){var oe=this.rules.block.code.exec(re);if(oe){var he=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?he:y(he,`
`)}}},De.fences=function(re){var oe=this.rules.block.fences.exec(re);if(oe){var he=oe[0],me=j(he,oe[3]||"");return{type:"code",raw:he,lang:oe[2]?oe[2].trim():oe[2],text:me}}},De.heading=function(re){var oe=this.rules.block.heading.exec(re);if(oe){var he=oe[2].trim();if(/#$/.test(he)){var me=y(he,"#");(this.options.pedantic||!me||/ $/.test(me))&&(he=me.trim())}var Te={type:"heading",raw:oe[0],depth:oe[1].length,text:he,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(re){var oe=this.rules.block.hr.exec(re);if(oe)return{type:"hr",raw:oe[0]}},De.blockquote=function(re){var oe=this.rules.block.blockquote.exec(re);if(oe){var he=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},De.list=function(re){var oe=this.rules.block.list.exec(re);if(oe){var he,me,Te,We,Le,Ke,it,rt,ie,ge,ee=oe[1].trim(),W=ee.length>1,we={type:"list",raw:"",ordered:W,start:W?+ee.slice(0,-1):"",loose:!1,items:[]};ee=W?"\\d{1,9}\\"+ee.slice(-1):"\\"+ee,this.options.pedantic&&(ee=W?ee:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+ee+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");re&&!(this.rules.block.hr.test(re)||!(oe=Pe.exec(re)));){ie=oe[2].split(`
`),this.options.pedantic?(We=2,ge=ie[0].trimLeft()):(We=oe[2].search(/[^ ]/),We=oe[1].length+(We>4?1:We),ge=ie[0].slice(We-oe[1].length)),Ke=!1,he=oe[0],!ie[0]&&/^ *$/.test(ie[1])&&(he=oe[1]+ie.slice(0,2).join(`
`)+`
`,we.loose=!0,ie=[]);var Qe=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<ie.length;Le++){if(rt=ie[Le],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Qe.test(rt)){he=oe[1]+ie.slice(0,Le).join(`
`)+`
`;break}if(!Ke){rt.trim()||(Ke=!0),rt.search(/[^ ]/)>=We?ge+=`
`+rt.slice(We):ge+=`
`+rt;continue}if(rt.search(/[^ ]/)>=We||!rt.trim()){ge+=`
`+rt.slice(We);continue}else{he=oe[1]+ie.slice(0,Le).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(he)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Te=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:he,task:!!me,checked:Te,loose:!1,text:ge}),we.raw+=he,re=re.slice(he.length)}we.items[we.items.length-1].raw=he.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var Ue=we.items.length;for(Le=0;Le<Ue;Le++)this.lexer.state.top=!1,we.items[Le].tokens=this.lexer.blockTokens(we.items[Le].text,[]),we.items[Le].tokens.some(function(ut){return ut.type==="space"})&&(we.loose=!0,we.items[Le].loose=!0);return we}},De.html=function(re){var oe=this.rules.block.html.exec(re);if(oe){var he={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};return this.options.sanitize&&(he.type="paragraph",he.text=this.options.sanitizer?this.options.sanitizer(oe[0]):z(oe[0]),he.tokens=[],this.lexer.inline(he.text,he.tokens)),he}},De.def=function(re){var oe=this.rules.block.def.exec(re);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var he=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:oe[0],href:oe[2],title:oe[3]}}},De.table=function(re){var oe=this.rules.block.table.exec(re);if(oe){var he={type:"table",header:L(oe[1]).map(function(it){return{text:it}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=oe[0];var me=he.align.length,Te,We,Le,Ke;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(he.align[Te])?he.align[Te]="right":/^ *:-+: *$/.test(he.align[Te])?he.align[Te]="center":/^ *:-+ *$/.test(he.align[Te])?he.align[Te]="left":he.align[Te]=null;for(me=he.rows.length,Te=0;Te<me;Te++)he.rows[Te]=L(he.rows[Te],he.header.length).map(function(it){return{text:it}});for(me=he.header.length,We=0;We<me;We++)he.header[We].tokens=[],this.lexer.inlineTokens(he.header[We].text,he.header[We].tokens);for(me=he.rows.length,We=0;We<me;We++)for(Ke=he.rows[We],Le=0;Le<Ke.length;Le++)Ke[Le].tokens=[],this.lexer.inlineTokens(Ke[Le].text,Ke[Le].tokens);return he}}},De.lheading=function(re){var oe=this.rules.block.lheading.exec(re);if(oe){var he={type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},De.paragraph=function(re){var oe=this.rules.block.paragraph.exec(re);if(oe){var he={type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},De.text=function(re){var oe=this.rules.block.text.exec(re);if(oe){var he={type:"text",raw:oe[0],text:oe[0],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},De.escape=function(re){var oe=this.rules.inline.escape.exec(re);if(oe)return{type:"escape",raw:oe[0],text:z(oe[1])}},De.tag=function(re){var oe=this.rules.inline.tag.exec(re);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):z(oe[0]):oe[0]}},De.link=function(re){var oe=this.rules.inline.link.exec(re);if(oe){var he=oe[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var me=y(he.slice(0,-1),"\\");if((he.length-me.length)%2==0)return}else{var Te=x(oe[2],"()");if(Te>-1){var We=oe[0].indexOf("!")===0?5:4,Le=We+oe[1].length+Te;oe[2]=oe[2].substring(0,Te),oe[0]=oe[0].substring(0,Le).trim(),oe[3]=""}}var Ke=oe[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);rt&&(Ke=rt[1],it=rt[3])}else it=oe[3]?oe[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(he)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),B(oe,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},De.reflink=function(re,oe){var he;if((he=this.rules.inline.reflink.exec(re))||(he=this.rules.inline.nolink.exec(re))){var me=(he[2]||he[1]).replace(/\s+/g," ");if(me=oe[me.toLowerCase()],!me||!me.href){var Te=he[0].charAt(0);return{type:"text",raw:Te,text:Te}}return B(he,me,he[0],this.lexer)}},De.emStrong=function(re,oe,he){he===void 0&&(he="");var me=this.rules.inline.emStrong.lDelim.exec(re);if(!!me&&!(me[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(he===""||this.rules.inline.punctuation.exec(he))){var We=me[0].length-1,Le,Ke,it=We,rt=0,ie=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,oe=oe.slice(-1*re.length+We);(me=ie.exec(oe))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ke=Le.length,me[3]||me[4]){it+=Ke;continue}else if((me[5]||me[6])&&We%3&&!((We+Ke)%3)){rt+=Ke;continue}if(it-=Ke,!(it>0)){if(Ke=Math.min(Ke,Ke+it+rt),Math.min(We,Ke)%2){var ge=re.slice(1,We+me.index+Ke);return{type:"em",raw:re.slice(0,We+me.index+Ke+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var ee=re.slice(2,We+me.index+Ke-1);return{type:"strong",raw:re.slice(0,We+me.index+Ke+1),text:ee,tokens:this.lexer.inlineTokens(ee,[])}}}}}},De.codespan=function(re){var oe=this.rules.inline.code.exec(re);if(oe){var he=oe[2].replace(/\n/g," "),me=/[^ ]/.test(he),Te=/^ /.test(he)&&/ $/.test(he);return me&&Te&&(he=he.substring(1,he.length-1)),he=z(he,!0),{type:"codespan",raw:oe[0],text:he}}},De.br=function(re){var oe=this.rules.inline.br.exec(re);if(oe)return{type:"br",raw:oe[0]}},De.del=function(re){var oe=this.rules.inline.del.exec(re);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2],[])}},De.autolink=function(re,oe){var he=this.rules.inline.autolink.exec(re);if(he){var me,Te;return he[2]==="@"?(me=z(this.options.mangle?oe(he[1]):he[1]),Te="mailto:"+me):(me=z(he[1]),Te=me),{type:"link",raw:he[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(re,oe){var he;if(he=this.rules.inline.url.exec(re)){var me,Te;if(he[2]==="@")me=z(this.options.mangle?oe(he[0]):he[0]),Te="mailto:"+me;else{var We;do We=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(We!==he[0]);me=z(he[0]),he[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:he[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(re,oe){var he=this.rules.inline.text.exec(re);if(he){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]:me=z(this.options.smartypants?oe(he[0]):he[0]),{type:"text",raw:he[0],text:me}}},Ae}(),K=N.noopTest,ne=N.edit,pe=N.merge,be={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};be._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,be._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,be.def=ne(be.def).replace("label",be._label).replace("title",be._title).getRegex(),be.bullet=/(?:[*+-]|\d{1,9}[.)])/,be.listItemStart=ne(/^( *)(bull) */).replace("bull",be.bullet).getRegex(),be.list=ne(be.list).replace(/bull/g,be.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+be.def.source+")").getRegex(),be._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",be._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,be.html=ne(be.html,"i").replace("comment",be._comment).replace("tag",be._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),be.paragraph=ne(be._paragraph).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.blockquote=ne(be.blockquote).replace("paragraph",be.paragraph).getRegex(),be.normal=pe({},be),be.gfm=pe({},be.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),be.gfm.table=ne(be.gfm.table).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.pedantic=pe({},be.normal,{html:ne(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",be._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:ne(be.normal._paragraph).replace("hr",be.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",be.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=ne(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=ne(be._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=ne(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=ne(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=ne(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=ne(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=ne(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=ne(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=ne(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=ne(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=pe({},ae),ae.pedantic=pe({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ne(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:ne(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=pe({},ae.normal,{escape:ne(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=ne(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=pe({},ae.gfm,{br:ne(ae.br).replace("{2,}","*").getRegex(),text:ne(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:be,inline:ae},Se=ue,Ee=A.exports.defaults,Fe=le.block,$e=le.inline,Ve=N.repeatString;function je(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ae){var De="",ve,re,oe=Ae.length;for(ve=0;ve<oe;ve++)re=Ae.charCodeAt(ve),Math.random()>.5&&(re="x"+re.toString(16)),De+="&#"+re+";";return De}var G=function(){function Ae(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ee,this.options.tokenizer=this.options.tokenizer||new Se,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:Fe.normal,inline:$e.normal};this.options.pedantic?(re.block=Fe.pedantic,re.inline=$e.pedantic):this.options.gfm&&(re.block=Fe.gfm,this.options.breaks?re.inline=$e.breaks:re.inline=$e.gfm),this.tokenizer.rules=re}Ae.lex=function(re,oe){var he=new Ae(oe);return he.lex(re)},Ae.lexInline=function(re,oe){var he=new Ae(oe);return he.inlineTokens(re)};var De=Ae.prototype;return De.lex=function(re){re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},De.blockTokens=function(re,oe){var he=this;oe===void 0&&(oe=[]),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var me,Te,We,Le;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:he},re,oe))?(re=re.substring(me.raw.length),oe.push(me),!0):!1}))){if(me=this.tokenizer.space(re)){re=re.substring(me.raw.length),me.type&&oe.push(me);continue}if(me=this.tokenizer.code(re)){re=re.substring(me.raw.length),Te=oe[oe.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):oe.push(me);continue}if(me=this.tokenizer.fences(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.heading(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.hr(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.blockquote(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.list(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.html(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.def(re)){re=re.substring(me.raw.length),Te=oe[oe.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.lheading(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(We=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=re.slice(1),ie=void 0;he.options.extensions.startBlock.forEach(function(ge){ie=ge.call({lexer:this},rt),typeof ie=="number"&&ie>=0&&(it=Math.min(it,ie))}),it<1/0&&it>=0&&(We=re.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(We))){Te=oe[oe.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):oe.push(me),Le=We.length!==re.length,re=re.substring(me.raw.length);continue}if(me=this.tokenizer.text(re)){re=re.substring(me.raw.length),Te=oe[oe.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):oe.push(me);continue}if(re){var Ke="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,oe},De.inline=function(re,oe){this.inlineQueue.push({src:re,tokens:oe})},De.inlineTokens=function(re,oe){var he=this;oe===void 0&&(oe=[]);var me,Te,We,Le=re,Ke,it,rt;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)ie.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ee){return(me=ee.call({lexer:he},re,oe))?(re=re.substring(me.raw.length),oe.push(me),!0):!1}))){if(me=this.tokenizer.escape(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.tag(re)){re=re.substring(me.raw.length),Te=oe[oe.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):oe.push(me);continue}if(me=this.tokenizer.link(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(me.raw.length),Te=oe[oe.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):oe.push(me);continue}if(me=this.tokenizer.emStrong(re,Le,rt)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.codespan(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.br(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.del(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.autolink(re,H)){re=re.substring(me.raw.length),oe.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(re,H))){re=re.substring(me.raw.length),oe.push(me);continue}if(We=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ee=1/0,W=re.slice(1),we=void 0;he.options.extensions.startInline.forEach(function(Pe){we=Pe.call({lexer:this},W),typeof we=="number"&&we>=0&&(ee=Math.min(ee,we))}),ee<1/0&&ee>=0&&(We=re.substring(0,ee+1))}(),me=this.tokenizer.inlineText(We,je)){re=re.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(rt=me.raw.slice(-1)),it=!0,Te=oe[oe.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):oe.push(me);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return oe},e(Ae,null,[{key:"rules",get:function(){return{block:Fe,inline:$e}}}]),Ae}(),X=A.exports.defaults,se=N.cleanUrl,q=N.escape,te=function(){function Ae(ve){this.options=ve||X}var De=Ae.prototype;return De.code=function(re,oe,he){var me=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(re,me);Te!=null&&Te!==re&&(he=!0,re=Te)}return re=re.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(he?re:q(re,!0))+`</code></pre>
`:"<pre><code>"+(he?re:q(re,!0))+`</code></pre>
`},De.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},De.html=function(re){return re},De.heading=function(re,oe,he,me){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+me.slug(he)+'">'+re+"</h"+oe+`>
`:"<h"+oe+">"+re+"</h"+oe+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(re,oe,he){var me=oe?"ol":"ul",Te=oe&&he!==1?' start="'+he+'"':"";return"<"+me+Te+`>
`+re+"</"+me+`>
`},De.listitem=function(re){return"<li>"+re+`</li>
`},De.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(re){return"<p>"+re+`</p>
`},De.table=function(re,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+oe+`</table>
`},De.tablerow=function(re){return`<tr>
`+re+`</tr>
`},De.tablecell=function(re,oe){var he=oe.header?"th":"td",me=oe.align?"<"+he+' align="'+oe.align+'">':"<"+he+">";return me+re+"</"+he+`>
`},De.strong=function(re){return"<strong>"+re+"</strong>"},De.em=function(re){return"<em>"+re+"</em>"},De.codespan=function(re){return"<code>"+re+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(re){return"<del>"+re+"</del>"},De.link=function(re,oe,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<a href="'+q(re)+'"';return oe&&(me+=' title="'+oe+'"'),me+=">"+he+"</a>",me},De.image=function(re,oe,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<img src="'+re+'" alt="'+he+'"';return oe&&(me+=' title="'+oe+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(re){return re},Ae}(),fe=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(re){return re},De.em=function(re){return re},De.codespan=function(re){return re},De.del=function(re){return re},De.html=function(re){return re},De.text=function(re){return re},De.link=function(re,oe,he){return""+he},De.image=function(re,oe,he){return""+he},De.br=function(){return""},Ae}(),Re=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(re,oe){var he=re,me=0;if(this.seen.hasOwnProperty(he)){me=this.seen[re];do me++,he=re+"-"+me;while(this.seen.hasOwnProperty(he))}return oe||(this.seen[re]=me,this.seen[he]=0),he},De.slug=function(re,oe){oe===void 0&&(oe={});var he=this.serialize(re);return this.getNextSafeSlug(he,oe.dryrun)},Ae}(),xe=te,ze=fe,Xe=Re,et=A.exports.defaults,st=N.unescape,Je=function(){function Ae(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Xe}Ae.parse=function(re,oe){var he=new Ae(oe);return he.parse(re)},Ae.parseInline=function(re,oe){var he=new Ae(oe);return he.parseInline(re)};var De=Ae.prototype;return De.parse=function(re,oe){oe===void 0&&(oe=!0);var he="",me,Te,We,Le,Ke,it,rt,ie,ge,ee,W,we,Pe,Qe,Ue,ut,vt,St,wt,ht=re.length;for(me=0;me<ht;me++){if(ee=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ee.type]&&(wt=this.options.extensions.renderers[ee.type].call({parser:this},ee),wt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ee.type))){he+=wt||"";continue}switch(ee.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(ee.tokens),ee.depth,st(this.parseInline(ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(ee.text,ee.lang,ee.escaped);continue}case"table":{for(ie="",rt="",Le=ee.header.length,Te=0;Te<Le;Te++)rt+=this.renderer.tablecell(this.parseInline(ee.header[Te].tokens),{header:!0,align:ee.align[Te]});for(ie+=this.renderer.tablerow(rt),ge="",Le=ee.rows.length,Te=0;Te<Le;Te++){for(it=ee.rows[Te],rt="",Ke=it.length,We=0;We<Ke;We++)rt+=this.renderer.tablecell(this.parseInline(it[We].tokens),{header:!1,align:ee.align[We]});ge+=this.renderer.tablerow(rt)}he+=this.renderer.table(ie,ge);continue}case"blockquote":{ge=this.parse(ee.tokens),he+=this.renderer.blockquote(ge);continue}case"list":{for(W=ee.ordered,we=ee.start,Pe=ee.loose,Le=ee.items.length,ge="",Te=0;Te<Le;Te++)Ue=ee.items[Te],ut=Ue.checked,vt=Ue.task,Qe="",Ue.task&&(St=this.renderer.checkbox(ut),Pe?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=St+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=St+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:St}):Qe+=St),Qe+=this.parse(Ue.tokens,Pe),ge+=this.renderer.listitem(Qe,vt,ut);he+=this.renderer.list(ge,W,we);continue}case"html":{he+=this.renderer.html(ee.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(ee.tokens));continue}case"text":{for(ge=ee.tokens?this.parseInline(ee.tokens):ee.text;me+1<ht&&re[me+1].type==="text";)ee=re[++me],ge+=`
`+(ee.tokens?this.parseInline(ee.tokens):ee.text);he+=oe?this.renderer.paragraph(ge):ge;continue}default:{var gt='Token with "'+ee.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return he},De.parseInline=function(re,oe){oe=oe||this.renderer;var he="",me,Te,We,Le=re.length;for(me=0;me<Le;me++){if(Te=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(We=this.options.extensions.renderers[Te.type].call({parser:this},Te),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){he+=We||"";continue}switch(Te.type){case"escape":{he+=oe.text(Te.text);break}case"html":{he+=oe.html(Te.text);break}case"link":{he+=oe.link(Te.href,Te.title,this.parseInline(Te.tokens,oe));break}case"image":{he+=oe.image(Te.href,Te.title,Te.text);break}case"strong":{he+=oe.strong(this.parseInline(Te.tokens,oe));break}case"em":{he+=oe.em(this.parseInline(Te.tokens,oe));break}case"codespan":{he+=oe.codespan(Te.text);break}case"br":{he+=oe.br();break}case"del":{he+=oe.del(this.parseInline(Te.tokens,oe));break}case"text":{he+=oe.text(Te.text);break}default:{var Ke='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return he},Ae}(),nt=G,lt=Je,pt=ue,Ft=te,Oe=fe,Mt=Re,V=N.merge,Q=N.checkSanitizeDeprecation,de=N.escape,Ne=A.exports.getDefaults,qe=A.exports.changeDefaults,ot=A.exports.defaults;function Ye(Ae,De,ve){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=V({},Ye.defaults,De||{}),Q(De),ve){var re=De.highlight,oe;try{oe=nt.lex(Ae,De)}catch(We){return ve(We)}var he=function(Le){var Ke;if(!Le)try{De.walkTokens&&Ye.walkTokens(oe,De.walkTokens),Ke=lt.parse(oe,De)}catch(it){Le=it}return De.highlight=re,Le?ve(Le):ve(null,Ke)};if(!re||re.length<3||(delete De.highlight,!oe.length))return he();var me=0;Ye.walkTokens(oe,function(We){We.type==="code"&&(me++,setTimeout(function(){re(We.text,We.lang,function(Le,Ke){if(Le)return he(Le);Ke!=null&&Ke!==We.text&&(We.text=Ke,We.escaped=!0),me--,me===0&&he()})},0))}),me===0&&he();return}try{var Te=nt.lex(Ae,De);return De.walkTokens&&Ye.walkTokens(Te,De.walkTokens),lt.parse(Te,De)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+de(We.message+"",!0)+"</pre>";throw We}}Ye.options=Ye.setOptions=function(Ae){return V(Ye.defaults,Ae),qe(Ye.defaults),Ye},Ye.getDefaults=Ne,Ye.defaults=ot,Ye.use=function(){for(var Ae=this,De=arguments.length,ve=new Array(De),re=0;re<De;re++)ve[re]=arguments[re];var oe=V.apply(void 0,[{}].concat(ve)),he=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ke=he.renderers?he.renderers[Le.name]:null;Ke?he.renderers[Le.name]=function(){for(var it=arguments.length,rt=new Array(it),ie=0;ie<it;ie++)rt[ie]=arguments[ie];var ge=Le.renderer.apply(this,rt);return ge===!1&&(ge=Ke.apply(this,rt)),ge}:he.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Le.level]?he[Le.level].unshift(Le.tokenizer):he[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?he.startBlock?he.startBlock.push(Le.start):he.startBlock=[Le.start]:Le.level==="inline"&&(he.startInline?he.startInline.push(Le.start):he.startInline=[Le.start]))}Le.childTokens&&(he.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Ye.defaults.renderer||new Ft,Ke=function(ie){var ge=Le[ie];Le[ie]=function(){for(var ee=arguments.length,W=new Array(ee),we=0;we<ee;we++)W[we]=arguments[we];var Pe=Te.renderer[ie].apply(Le,W);return Pe===!1&&(Pe=ge.apply(Le,W)),Pe}};for(var it in Te.renderer)Ke(it);oe.renderer=Le}(),Te.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new pt,Ke=function(ie){var ge=Le[ie];Le[ie]=function(){for(var ee=arguments.length,W=new Array(ee),we=0;we<ee;we++)W[we]=arguments[we];var Pe=Te.tokenizer[ie].apply(Le,W);return Pe===!1&&(Pe=ge.apply(Le,W)),Pe}};for(var it in Te.tokenizer)Ke(it);oe.tokenizer=Le}(),Te.walkTokens){var We=Ye.defaults.walkTokens;oe.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),We&&We(Le)}}me&&(oe.extensions=he),Ye.setOptions(oe)})},Ye.walkTokens=function(Ae,De){for(var ve=function(){var me=oe.value;switch(De(me),me.type){case"table":{for(var Te=E(me.header),We;!(We=Te()).done;){var Le=We.value;Ye.walkTokens(Le.tokens,De)}for(var Ke=E(me.rows),it;!(it=Ke()).done;)for(var rt=it.value,ie=E(rt),ge;!(ge=ie()).done;){var ee=ge.value;Ye.walkTokens(ee.tokens,De)}break}case"list":{Ye.walkTokens(me.items,De);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(W){Ye.walkTokens(me[W],De)}):me.tokens&&Ye.walkTokens(me.tokens,De)}},re=E(Ae),oe;!(oe=re()).done;)ve()},Ye.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=V({},Ye.defaults,De||{}),Q(De);try{var ve=nt.lexInline(Ae,De);return De.walkTokens&&Ye.walkTokens(ve,De.walkTokens),lt.parseInline(ve,De)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+de(re.message+"",!0)+"</pre>";throw re}},Ye.Parser=lt,Ye.parser=lt.parse,Ye.Renderer=Ft,Ye.TextRenderer=Oe,Ye.Lexer=nt,Ye.lexer=nt.lex,Ye.Tokenizer=pt,Ye.Slugger=Mt,Ye.parse=Ye;var yt=Ye;return yt}),define(ye[75],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(k,T,S){return Math.min(Math.max(k,T),S)}e.clamp=s;function t(k,T){return(T+k%T)%T}e.rot=t;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function Z(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function k(S){A.push(S,Date.now())}function T(){const S=[];for(let R=0;R<A.length;R+=2)S.push({name:A[R],startTime:A[R+1]});return S}return{mark:k,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(E+k.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function s(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=s(t))}(),define(ye[101],Ce([0,1,15,6]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(d){const p=d;return p?[p.on,p.pause,p.resume,p.destroy].every(I=>typeof I=="function"):!1}e.isReadableStream=E;function A(d){const p=d;return p?E(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function k(d,p){return new T(d,p)}e.newWriteableStream=k;class T{constructor(p,I){this.reducer=p,this.options=I,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(I=>this.pendingWritePromises.push(I))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(I=>I(p))}emitError(p){this.listeners.error.length===0?(0,s.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(I=>I(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,I){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(I),this.resume();break;case"end":this.listeners.end.push(I),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(I),this.state.flowing&&this.flowErrors();break}}removeListener(p,I){if(this.state.destroyed)return;let c;switch(p){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const M=c.indexOf(I);M>=0&&c.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const I=[...this.pendingWritePromises];this.pendingWritePromises.length=0,I.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(d,p){const I=[];let c;for(;(c=d.read())!==null;)I.push(c);return p(I)}e.consumeReadable=S;function R(d,p,I){const c=[];let M;for(;(M=d.read())!==null&&c.length<I;)c.push(M);return M===null&&c.length>0?p(c):{read:()=>{if(c.length>0)return c.shift();if(typeof M!="undefined"){const o=M;return M=void 0,o}return d.read()}}}e.peekReadable=R;function F(d,p){return new Promise((I,c)=>{const M=[];C(d,{onData:o=>{p&&M.push(o)},onError:o=>{p?c(o):I(void 0)},onEnd:()=>{I(p?p(M):void 0)}})})}e.consumeStream=F;function C(d,p){let I=!1;return d.on("error",c=>{I||p.onError(c)}),d.on("end",()=>{I||p.onEnd()}),d.on("data",c=>{I||p.onData(c)}),(0,t.toDisposable)(()=>I=!0)}e.listenStream=C;function n(d,p){return new Promise((I,c)=>{const M=new t.DisposableStore,o=[],i=h=>{if(o.push(h),o.length>p)return M.dispose(),d.pause(),I({stream:d,buffer:o,ended:!1})},f=h=>c(h),u=()=>I({stream:d,buffer:o,ended:!0});M.add((0,t.toDisposable)(()=>d.removeListener("error",f))),d.on("error",f),M.add((0,t.toDisposable)(()=>d.removeListener("end",u))),d.on("end",u),M.add((0,t.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=n;function m(d,p){const I=k(p);return I.end(d),I}e.toStream=m;function r(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=r;function g(d){let p=!1;return{read:()=>p?null:(p=!0,d)}}e.toReadable=g;function l(d,p,I){const c=k(I);return C(d,{onData:M=>c.write(p.data(M)),onError:M=>c.error(p.error?p.error(M):M),onEnd:()=>c.end()}),c}e.transform=l;function D(d,p,I){let c=!1;return{read:()=>{const M=p.read();return c?M:(c=!0,M!==null?I([d,M]):d)}}}e.prefixedReadable=D;function w(d,p,I){let c=!1;const M=k(I);return C(p,{onData:o=>c?M.write(o):(c=!0,M.write(I([d,o]))),onError:o=>M.error(o),onEnd:()=>{c||(c=!0,M.write(d)),M.end()}}),M}e.prefixedStream=w}),define(ye[22],Ce([0,1,101]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let E,A;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return t?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,f){return!(f?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(i)):(E||(E=new TextEncoder),new k(E.encode(i)))}static fromByteArray(i){const f=k.alloc(i.length);for(let u=0,h=i.length;u<h;u++)f.buffer[u]=i[u];return f}static concat(i,f){if(typeof f=="undefined"){f=0;for(let b=0,v=i.length;b<v;b++)f+=i[b].byteLength}const u=k.alloc(f);let h=0;for(let b=0,v=i.length;b<v;b++){const a=i[b];u.set(a,h),h+=a.byteLength}return u}clone(){const i=k.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(i,f){return new k(this.buffer.subarray(i,f))}set(i,f){if(i instanceof k)this.buffer.set(i.buffer,f);else if(i instanceof Uint8Array)this.buffer.set(i,f);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),f);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),f);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return R(this.buffer,i)}writeUInt32BE(i,f){F(this.buffer,i,f)}readUInt32LE(i){return C(this.buffer,i)}writeUInt32LE(i,f){n(this.buffer,i,f)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,f){r(this.buffer,i,f)}}e.VSBuffer=k;function T(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0}e.readUInt16LE=T;function S(o,i,f){o[f+0]=i&255,i=i>>>8,o[f+1]=i&255}e.writeUInt16LE=S;function R(o,i){return o[i]*2**24+o[i+1]*2**16+o[i+2]*2**8+o[i+3]}e.readUInt32BE=R;function F(o,i,f){o[f+3]=i,i=i>>>8,o[f+2]=i,i=i>>>8,o[f+1]=i,i=i>>>8,o[f]=i}e.writeUInt32BE=F;function C(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0|o[i+2]<<16>>>0|o[i+3]<<24>>>0}e.readUInt32LE=C;function n(o,i,f){o[f+0]=i&255,i=i>>>8,o[f+1]=i&255,i=i>>>8,o[f+2]=i&255,i=i>>>8,o[f+3]=i&255}e.writeUInt32LE=n;function m(o,i){return o[i]}e.readUInt8=m;function r(o,i,f){o[f]=i}e.writeUInt8=r;function g(o){return s.consumeReadable(o,i=>k.concat(i))}e.readableToBuffer=g;function l(o){return s.toReadable(o)}e.bufferToReadable=l;function D(o){return s.consumeStream(o,i=>k.concat(i))}e.streamToBuffer=D;async function w(o){return o.ended?k.concat(o.buffer):k.concat([...o.buffer,await D(o.stream)])}e.bufferedStreamToBuffer=w;function d(o){return s.toStream(o,i=>k.concat(i))}e.bufferToStream=d;function p(o){return s.transform(o,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=p;function I(o){return s.newWriteableStream(i=>k.concat(i),o)}e.newWriteableBufferStream=I;function c(o,i){return s.prefixedReadable(o,i,f=>k.concat(f))}e.prefixedBufferReadable=c;function M(o,i){return s.prefixedStream(o,i,f=>k.concat(f))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[21],Ce([0,1,16,9]),function(Z,e,s,t){"use strict";var E,A,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(o,i,f){let u=o.get(i);return u===void 0&&(u=f,o.set(i,u)),u}e.getOrSet=T;function S(o){const i=[];return o.forEach((f,u)=>{i.push(`${u} => ${f}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=S;function R(o){const i=[];return o.forEach(f=>{i.push(f)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const f=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return f-u}value(){return this._value[this._pos]}}e.StringIterator=F;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class n{constructor(i=!0,f=!0){this._splitOnBackslash=i,this._caseSensitive=f}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let f=i.length-1;f>=0;f--,this._valueLen--){const u=this._value.charCodeAt(f);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(m||(m={}));class r{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var l;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(l||(l={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new r(i))}static forPaths(){return new D(new n)}static forStrings(){return new D(new F)}static forConfigKeys(){return new D(new C)}clear(){this._root=void 0}fill(i,f){if(f){const u=f.slice(0);(0,s.shuffle)(u);for(let h of u)this.set(h,i)}else{const u=i.slice(0);(0,s.shuffle)(u);for(let h of u)this.set(h[0],h[1])}}set(i,f){const u=this._iter.reset(i);let h;this._root||(this._root=new g,this._root.segment=u.value());const b=[];for(h=this._root;;){const a=u.cmp(h.segment);if(a>0)h.left||(h.left=new g,h.left.segment=u.value()),b.push([-1,h]),h=h.left;else if(a<0)h.right||(h.right=new g,h.right.segment=u.value()),b.push([1,h]),h=h.right;else if(u.hasNext())u.next(),h.mid||(h.mid=new g,h.mid.segment=u.value()),b.push([0,h]),h=h.mid;else break}const v=h.value;h.value=f,h.key=i;for(let a=b.length-1;a>=0;a--){const _=b[a][1];_.updateHeight();const P=_.balanceFactor();if(P<-1||P>1){const N=b[a][0],$=b[a+1][0];if(N===1&&$===1)b[a][1]=_.rotateLeft();else if(N===-1&&$===-1)b[a][1]=_.rotateRight();else if(N===1&&$===-1)_.right=b[a+1][1]=b[a+1][1].rotateRight(),b[a][1]=_.rotateLeft();else if(N===-1&&$===1)_.left=b[a+1][1]=b[a+1][1].rotateLeft(),b[a][1]=_.rotateRight();else throw new Error;if(a>0)switch(b[a-1][0]){case-1:b[a-1][1].left=b[a][1];break;case 1:b[a-1][1].right=b[a][1];break;case 0:b[a-1][1].mid=b[a][1];break}else this._root=b[0][1]}}return v}get(i){return this._getNode(i)?.value}_getNode(i){const f=this._iter.reset(i);let u=this._root;for(;u;){const h=f.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(f.hasNext())f.next(),u=u.mid;else break}return u}has(i){const f=this._getNode(i);return!(f?.value===void 0&&f?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,f){const u=this._iter.reset(i),h=[];let b=this._root;for(;b;){const v=u.cmp(b.segment);if(v>0)h.push([-1,b]),b=b.left;else if(v<0)h.push([1,b]),b=b.right;else if(u.hasNext())u.next(),h.push([0,b]),b=b.mid;else break}if(!!b){if(f?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const v=this._min(b.right),{key:a,value:_,segment:P}=v;this._delete(v.key,!1),b.key=a,b.value=_,b.segment=P}else{const v=b.left??b.right;if(h.length>0){const[a,_]=h[h.length-1];switch(a){case-1:_.left=v;break;case 0:_.mid=v;break;case 1:_.right=v;break}}else this._root=v}for(let v=h.length-1;v>=0;v--){const a=h[v][1];a.updateHeight();const _=a.balanceFactor();if(_>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),h[v][1]=a.rotateLeft()):_<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),h[v][1]=a.rotateRight()),v>0)switch(h[v-1][0]){case-1:h[v-1][1].left=h[v][1];break;case 1:h[v-1][1].right=h[v][1];break;case 0:h[v-1][1].mid=h[v][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const f=this._iter.reset(i);let u=this._root,h;for(;u;){const b=f.cmp(u.segment);if(b>0)u=u.left;else if(b<0)u=u.right;else if(f.hasNext())f.next(),h=u.value||h,u=u.mid;else break}return u&&u.value||h}findSuperstr(i){const f=this._iter.reset(i);let u=this._root;for(;u;){const h=f.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(f.hasNext())f.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[f,u]of this)i(u,f)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=f=>{if(!f)return!0;const u=f.balanceFactor();return u<-1||u>1?!1:i(f.left)&&i(f.right)};return i(this._root)}}e.TernarySearchTree=D;class w{constructor(i,f){this.uri=i,this.value=f}}class d{constructor(i,f){this[E]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=f??d.defaultToKey):(this.map=new Map,this.toKey=i??d.defaultToKey)}set(i,f){return this.map.set(this.toKey(i),new w(i,f)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,f){typeof f!="undefined"&&(i=i.bind(f));for(let[u,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=d,d.defaultToKey=o=>o.toString();var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class I{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,f=0){const u=this._map.get(i);if(!!u)return f!==0&&this.touch(u,f),u.value}set(i,f,u=0){let h=this._map.get(i);if(h)h.value=f,u!==0&&this.touch(h,u);else{switch(h={key:i,value:f,next:void 0,previous:void 0},u){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const f=this._map.get(i);if(!!f)return this._map.delete(i),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,f){const u=this._state;let h=this._head;for(;h;){if(f?i.bind(f)(h.value,h.key,this):i(h.value,h.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,f=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return h}values(){const i=this,f=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return h}entries(){const i=this,f=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return h}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let f=this._head,u=this.size;for(;f&&u>i;)this._map.delete(f.key),f=f.next,u--;this._head=f,this._size=u,f&&(f.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const f=i.next,u=i.previous;if(!f||!u)throw new Error("Invalid list");f.previous=u,u.next=f}i.next=void 0,i.previous=void 0,this._state++}touch(i,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(i===this._head)return;const u=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(u.previous=h,h.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(f===2){if(i===this._tail)return;const u=i.next,h=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=h,h.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((f,u)=>{i.push([u,f])}),i}fromJSON(i){this.clear();for(const[f,u]of i)this.set(f,u)}}e.LinkedMap=I;class c extends I{constructor(i,f=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,f=2){return super.get(i,f)}peek(i){return super.get(i,0)}set(i,f){return super.set(i,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class M{constructor(i){k.set(this,void 0),Ze(this,k,i,"f")}get size(){return Ie(this,k,"f").size}forEach(i,f){Ie(this,k,"f").forEach(i,f)}get(i){return Ie(this,k,"f").get(i)}has(i){return Ie(this,k,"f").has(i)}entries(){return Ie(this,k,"f").entries()}keys(){return Ie(this,k,"f").keys()}values(){return Ie(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ie(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(ye[102],Ce([0,1,21,9]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...q){return function(te,fe){for(let Re=0,xe=q.length;Re<xe;Re++){const ze=q[Re](te,fe);if(ze)return ze}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(q,te,fe){if(!fe||fe.length<te.length)return null;let Re;return q?Re=t.startsWithIgnoreCase(fe,te):Re=fe.indexOf(te)===0,Re?te.length>0?[{start:0,end:te.length}]:[]:null}function k(q,te){const fe=te.toLowerCase().indexOf(q.toLowerCase());return fe===-1?null:[{start:fe,end:fe+q.length}]}e.matchesContiguousSubString=k;function T(q,te){return S(q.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=T;function S(q,te,fe,Re){if(fe===q.length)return[];if(Re===te.length)return null;if(q[fe]===te[Re]){let xe=null;return(xe=S(q,te,fe+1,Re+1))?D({start:Re,end:Re+1},xe):null}return S(q,te,fe,Re+1)}function R(q){return 97<=q&&q<=122}function F(q){return 65<=q&&q<=90}e.isUpper=F;function C(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>m.add(q.charCodeAt(0)));function r(q){return n(q)||m.has(q)}function g(q,te){return q===te||r(q)&&r(te)}function l(q){return R(q)||F(q)||C(q)}function D(q,te){return te.length===0?te=[q]:q.end===te[0].start?te[0].start=q.start:te.unshift(q),te}function w(q,te){for(let fe=te;fe<q.length;fe++){const Re=q.charCodeAt(fe);if(F(Re)||C(Re)||fe>0&&!l(q.charCodeAt(fe-1)))return fe}return q.length}function d(q,te,fe,Re){if(fe===q.length)return[];if(Re===te.length)return null;if(q[fe]!==te[Re].toLowerCase())return null;{let xe=null,ze=Re+1;for(xe=d(q,te,fe+1,Re+1);!xe&&(ze=w(te,ze))<te.length;)xe=d(q,te,fe+1,ze),ze++;return xe===null?null:D({start:Re,end:Re+1},xe)}}function p(q){let te=0,fe=0,Re=0,xe=0,ze=0;for(let nt=0;nt<q.length;nt++)ze=q.charCodeAt(nt),F(ze)&&te++,R(ze)&&fe++,l(ze)&&Re++,C(ze)&&xe++;const Xe=te/q.length,et=fe/q.length,st=Re/q.length,Je=xe/q.length;return{upperPercent:Xe,lowerPercent:et,alphaPercent:st,numericPercent:Je}}function I(q){const{upperPercent:te,lowerPercent:fe}=q;return fe===0&&te>.6}function c(q){const{upperPercent:te,lowerPercent:fe,alphaPercent:Re,numericPercent:xe}=q;return fe>.2&&te<.8&&Re>.6&&xe<.2}function M(q){let te=0,fe=0,Re=0,xe=0;for(let ze=0;ze<q.length;ze++)Re=q.charCodeAt(ze),F(Re)&&te++,R(Re)&&fe++,n(Re)&&xe++;return(te===0||fe===0)&&xe===0?q.length<=30:te<=5}function o(q,te){if(!te||(te=te.trim(),te.length===0)||!M(q)||te.length>60)return null;const fe=p(te);if(!c(fe)){if(!I(fe))return null;te=te.toLowerCase()}let Re=null,xe=0;for(q=q.toLowerCase();xe<te.length&&(Re=d(q,te,0,xe))===null;)xe=w(te,xe+1);return Re}e.matchesCamelCase=o;function i(q,te,fe=!1){if(!te||te.length===0)return null;let Re=null,xe=0;for(q=q.toLowerCase(),te=te.toLowerCase();xe<te.length&&(Re=f(q,te,0,xe,fe))===null;)xe=u(te,xe+1);return Re}e.matchesWords=i;function f(q,te,fe,Re,xe){if(fe===q.length)return[];if(Re===te.length)return null;if(g(q.charCodeAt(fe),te.charCodeAt(Re))){let ze=null,Xe=Re+1;if(ze=f(q,te,fe+1,Re+1,xe),!xe)for(;!ze&&(Xe=u(te,Xe))<te.length;)ze=f(q,te,fe+1,Xe,xe),Xe++;return ze===null?null:D({start:Re,end:Re+1},ze)}else return null}function u(q,te){for(let fe=te;fe<q.length;fe++)if(r(q.charCodeAt(fe))||fe>0&&r(q.charCodeAt(fe-1)))return fe;return q.length}const h=E(e.matchesPrefix,o,k),b=E(e.matchesPrefix,o,T),v=new s.LRUCache(1e4);function a(q,te,fe=!1){if(typeof q!="string"||typeof te!="string")return null;let Re=v.get(q);Re||(Re=new RegExp(t.convertSimple2RegExpPattern(q),"i"),v.set(q,Re));const xe=Re.exec(te);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?b(q,te):h(q,te)}e.matchesFuzzy=a;function _(q,te){const fe=$e(q,q.toLowerCase(),0,te,te.toLowerCase(),0,!0);return fe?N(fe):null}e.matchesFuzzy2=_;function P(q,te,fe,Re,xe,ze){const Xe=Math.min(13,q.length);for(;fe<Xe;fe++){const et=$e(q,te,fe,Re,xe,ze,!1);if(et)return et}return[0,ze]}e.anyScore=P;function N(q){if(typeof q=="undefined")return[];const te=[],fe=q[1];for(let Re=q.length-1;Re>1;Re--){const xe=q[Re]+fe,ze=te[te.length-1];ze&&ze.end===xe?ze.end=xe+1:te.push({start:xe,end:xe+1})}return te}e.createMatches=N;const $=128;function y(){const q=[],te=[];for(let fe=0;fe<=$;fe++)te[fe]=0;for(let fe=0;fe<=$;fe++)q.push(te.slice(0));return q}function L(q){const te=[];for(let fe=0;fe<=q;fe++)te[fe]=0;return te}const z=L(2*$),x=L(2*$),B=y(),j=y(),ue=y(),K=!1;function ne(q,te,fe,Re,xe){function ze(et,st,Je=" "){for(;et.length<st;)et=Je+et;return et}let Xe=` |   |${Re.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=fe;et++)et===0?Xe+=" |":Xe+=`${te[et-1]}|`,Xe+=q[et].slice(0,xe+1).map(st=>ze(st.toString(),3)).join("|")+`
`;return Xe}function pe(q,te,fe,Re){q=q.substr(te),fe=fe.substr(Re),console.log(ne(j,q,q.length,fe,fe.length)),console.log(ne(ue,q,q.length,fe,fe.length)),console.log(ne(B,q,q.length,fe,fe.length))}function be(q,te){if(te<0||te>=q.length)return!1;const fe=q.codePointAt(te);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(fe)}}function ae(q,te){if(te<0||te>=q.length)return!1;switch(q.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function le(q,te,fe){return te[q]!==fe[q]}function Se(q,te,fe,Re,xe,ze,Xe=!1){for(;te<fe&&xe<ze;)q[te]===Re[xe]&&(Xe&&(z[te]=xe),te+=1),xe+=1;return te===fe}e.isPatternInWord=Se;var Ee;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Fe;(function(q){q.Default=[-100,0];function te(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}q.isDefault=te})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function $e(q,te,fe,Re,xe,ze,Xe){const et=q.length>$?$:q.length,st=Re.length>$?$:Re.length;if(fe>=et||ze>=st||et-fe>st-ze||!Se(te,fe,et,xe,ze,st,!0))return;Ve(et,st,fe,ze,te,xe);let Je=1,nt=1,lt=fe,pt=ze;const Ft=[!1];for(Je=1,lt=fe;lt<et;Je++,lt++){const de=z[lt],Ne=x[lt],qe=lt+1<et?x[lt+1]:st;for(nt=de-ze+1,pt=de;pt<qe;nt++,pt++){let ot=Number.MIN_SAFE_INTEGER,Ye=!1;pt<=Ne&&(ot=je(q,te,lt,fe,Re,xe,pt,st,ze,B[Je-1][nt-1]===0,Ft));let yt=0;ot!==Number.MAX_SAFE_INTEGER&&(Ye=!0,yt=ot+j[Je-1][nt-1]);const Ae=pt>de,De=Ae?j[Je][nt-1]+(B[Je][nt-1]>0?-5:0):0,ve=pt>de+1&&B[Je][nt-1]>0,re=ve?j[Je][nt-2]+(B[Je][nt-2]>0?-5:0):0;if(ve&&(!Ae||re>=De)&&(!Ye||re>=yt))j[Je][nt]=re,ue[Je][nt]=3,B[Je][nt]=0;else if(Ae&&(!Ye||De>=yt))j[Je][nt]=De,ue[Je][nt]=2,B[Je][nt]=0;else if(Ye)j[Je][nt]=yt,ue[Je][nt]=1,B[Je][nt]=B[Je-1][nt-1]+1;else throw new Error("not possible")}}if(K&&pe(q,fe,Re,ze),!Ft[0]&&!Xe)return;Je--,nt--;const Oe=[j[Je][nt],ze];let Mt=0,V=0;for(;Je>=1;){let de=nt;do{const Ne=ue[Je][de];if(Ne===3)de=de-2;else if(Ne===2)de=de-1;else break}while(de>=1);Mt>1&&te[fe+Je-1]===xe[ze+nt-1]&&!le(de+ze-1,Re,xe)&&Mt+1>B[Je][de]&&(de=nt),de===nt?Mt++:Mt=1,V||(V=de),Je--,nt=de-1,Oe.push(nt)}st===et&&(Oe[0]+=2);const Q=V-et;return Oe[0]-=Q,Oe}e.fuzzyScore=$e;function Ve(q,te,fe,Re,xe,ze){let Xe=q-1,et=te-1;for(;Xe>=fe&&et>=Re;)xe[Xe]===ze[et]&&(x[Xe]=et,Xe--),et--}function je(q,te,fe,Re,xe,ze,Xe,et,st,Je,nt){if(te[fe]!==ze[Xe])return Number.MIN_SAFE_INTEGER;let lt=1,pt=!1;return Xe===fe-Re?lt=q[fe]===xe[Xe]?7:5:le(Xe,xe,ze)&&(Xe===0||!le(Xe-1,xe,ze))?(lt=q[fe]===xe[Xe]?7:5,pt=!0):be(ze,Xe)&&(Xe===0||!be(ze,Xe-1))?lt=5:(be(ze,Xe-1)||ae(ze,Xe-1))&&(lt=5,pt=!0),lt>1&&fe===Re&&(nt[0]=!0),pt||(pt=le(Xe,xe,ze)||be(ze,Xe-1)||ae(ze,Xe-1)),fe===Re?Xe>st&&(lt-=pt?3:5):Je?lt+=pt?2:0:lt+=pt?0:1,Xe+1===et&&(lt-=pt?3:5),lt}function H(q,te,fe,Re,xe,ze,Xe){return X(q,te,fe,Re,xe,ze,!0,Xe)}e.fuzzyScoreGracefulAggressive=H;function G(q,te,fe,Re,xe,ze,Xe){return X(q,te,fe,Re,xe,ze,!1,Xe)}e.fuzzyScoreGraceful=G;function X(q,te,fe,Re,xe,ze,Xe,et){let st=$e(q,te,fe,Re,xe,ze,et);if(st&&!Xe)return st;if(q.length>=3){const Je=Math.min(7,q.length-1);for(let nt=fe+1;nt<Je;nt++){const lt=se(q,nt);if(lt){const pt=$e(lt,lt.toLowerCase(),fe,Re,xe,ze,et);pt&&(pt[0]-=3,(!st||pt[0]>st[0])&&(st=pt))}}}return st}function se(q,te){if(te+1>=q.length)return;const fe=q[te],Re=q[te+1];if(fe!==Re)return q.slice(0,te)+Re+fe+q.slice(te+2)}}),define(ye[103],Ce([0,1,51,102,9]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(s.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${A.source}`,"g");function S(l){return l.replace(T,(D,w)=>w?D:`\\${D}`)}e.escapeIcons=S;const R=new RegExp(`\\\\${A.source}`,"g");function F(l){return l.replace(R,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=F;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function n(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(C,(D,w,d,p)=>d?D:w||p||"")}e.stripIcons=n;function m(l){const D=l.indexOf(e.iconStartMarker);return D===-1?{text:l}:r(l,D)}e.parseLabelWithIcons=m;function r(l,D){const w=[];let d="";function p(h){if(h){d+=h;for(const b of h)w.push(M)}}let I=-1,c="",M=0,o,i,f=D;const u=l.length;for(p(l.substr(0,D));f<u;)o=l[f],i=l[f+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(I=f,p(c),c=e.iconStartMarker,f++):o===")"&&I!==-1?(M+=f-I+1,I=-1,c=""):I!==-1?k.test(o)?c+=o:(p(c),I=-1,c=""):p(o),f++;return p(c),{text:d,iconOffsets:w}}function g(l,D,w=!1){const{text:d,iconOffsets:p}=D;if(!p||p.length===0)return(0,t.matchesFuzzy)(l,d,w);const I=(0,E.ltrim)(d," "),c=d.length-I.length,M=(0,t.matchesFuzzy)(l,I,w);if(M)for(const o of M){const i=p[o.start+c]+c;o.start+=i,o.end+=i}return M}e.matchesFuzzyIconAware=g}),define(ye[76],Ce([0,1,15,103]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(m="",r=!1){if(this.value=m,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(m,r=0){return this.value+=R(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(g,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,r){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}}e.MarkdownString=A;function k(n){return T(n)?!n.value:Array.isArray(n)?n.every(k):!0}e.isEmptyMarkdownString=k;function T(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function S(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=S;function R(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=R;function F(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function C(n){const m=[],r=n.split("|").map(l=>l.trim());n=r[0];const g=r[1];if(g){const l=/height=(\d+)/.exec(g),D=/width=(\d+)/.exec(g),w=l?l[1]:"",d=D?D[1]:"",p=isFinite(parseInt(d)),I=isFinite(parseInt(w));p&&m.push(`width="${d}"`),I&&m.push(`height="${w}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=C}),define(ye[34],Ce([0,1,9]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(t||(t={})),function(E){const A="error",k="warning",T="warn",S="info",R="ignore";function F(n){return n?s.equalsIgnoreCase(A,n)?E.Error:s.equalsIgnoreCase(k,n)||s.equalsIgnoreCase(T,n)?E.Warning:s.equalsIgnoreCase(S,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=F;function C(n){switch(n){case E.Error:return A;case E.Warning:return k;case E.Info:return S;default:return R}}E.toString=C}(t||(t={})),e.default=t}),define(ye[42],Ce([0,1,17,23,9,11]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(f){return f===47||f===92}e.isPathSeparator=k;function T(f){return f.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=T;function S(f){return f.indexOf("/")===-1&&(f=T(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=S;function R(f,u=s.posix.sep){if(!f)return"";const h=f.length,b=f.charCodeAt(0);if(k(b)){if(k(f.charCodeAt(1))&&!k(f.charCodeAt(2))){let a=3;const _=a;for(;a<h&&!k(f.charCodeAt(a));a++);if(_!==a&&!k(f.charCodeAt(a+1))){for(a+=1;a<h;a++)if(k(f.charCodeAt(a)))return f.slice(0,a+1).replace(/[\\/]/g,u)}}return u}else if(D(b)&&f.charCodeAt(1)===58)return k(f.charCodeAt(2))?f.slice(0,2)+u:f.slice(0,2);let v=f.indexOf("://");if(v!==-1){for(v+=3;v<h;v++)if(k(f.charCodeAt(v)))return f.slice(0,v+1)}return""}e.getRoot=R;function F(f){if(!t.isWindows||!f||f.length<5)return!1;let u=f.charCodeAt(0);if(u!==92||(u=f.charCodeAt(1),u!==92))return!1;let h=2;const b=h;for(;h<f.length&&(u=f.charCodeAt(h),u!==92);h++);return!(b===h||(u=f.charCodeAt(h+1),isNaN(u)||u===92))}e.isUNC=F;const C=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(f,u=t.isWindows){const h=u?C:n;return!(!f||f.length===0||/^\s+$/.test(f)||(h.lastIndex=0,h.test(f))||u&&m.test(f)||f==="."||f===".."||u&&f[f.length-1]==="."||u&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=r;function g(f,u,h){const b=f===u;return!h||b?b:!f||!u?!1:(0,E.equalsIgnoreCase)(f,u)}e.isEqual=g;function l(f,u,h,b=s.sep){if(f===u)return!0;if(!f||!u||u.length>f.length)return!1;if(h){if(!(0,E.startsWithIgnoreCase)(f,u))return!1;if(u.length===f.length)return!0;let a=u.length;return u.charAt(u.length-1)===b&&a--,f.charAt(a)===b}return u.charAt(u.length-1)!==b&&(u+=b),f.indexOf(u)===0}e.isEqualOrParent=l;function D(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=D;function w(f,u){return t.isWindows&&f.endsWith(":")&&(f+=s.sep),(0,s.isAbsolute)(f)||(f=(0,s.join)(u,f)),f=(0,s.normalize)(f),t.isWindows?(f=(0,E.rtrim)(f,s.sep),f.endsWith(":")&&(f+=s.sep)):(f=(0,E.rtrim)(f,s.sep),f||(f=s.sep)),f}e.sanitizeFilePath=w;function d(f){const u=(0,s.normalize)(f);return t.isWindows?f.length>3?!1:p(u)&&(f.length===2||u.charCodeAt(2)===92):u===s.posix.sep}e.isRootOrDriveLetter=d;function p(f,u){return(u!==void 0?u:t.isWindows)?D(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function I(f){return p(f)?f[0]:void 0}e.getDriveLetter=I;function c(f,u,h){return u.length>f.length?-1:f===u?0:(h&&(f=f.toLowerCase(),u=u.toLowerCase()),f.indexOf(u))}e.indexOfPath=c;function M(f){const u=f.split(":");let h,b,v;if(u.forEach(a=>{const _=Number(a);(0,A.isNumber)(_)?b===void 0?b=_:v===void 0&&(v=_):h=h?[h,a].join(":"):a}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:b!==void 0?b:void 0,column:v!==void 0?v:b!==void 0?1:void 0}}e.parseLineAndColumnAware=M;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(f,u,h=8){let b="";for(let a=0;a<h;a++)b+=o.charAt(Math.floor(Math.random()*o.length));let v;return u?v=`${u}-${b}`:v=b,f?(0,s.join)(f,v):v}e.randomPath=i}),define(ye[54],Ce([0,1,22,9,2]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(F){return JSON.stringify(F,S)}e.stringify=A;function k(F){let C=JSON.parse(F);return C=R(C),C}e.parse=k;var T;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function S(F,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function R(F,C=0){if(!F||C>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return E.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof s.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let n=0;n<F.length;++n)F[n]=R(F[n],C+1);else for(const n in F)Object.hasOwnProperty.call(F,n)&&(F[n]=R(F[n],C+1))}return F}e.revive=R}),define(ye[10],Ce([0,1,23,2]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,R,F){this._hosts[S]=R,this._ports[S]=F}setConnectionToken(S,R){this._connectionTokens[S]=R}rewrite(S){if(this._delegate)return this._delegate(S);const R=S.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const C=this._ports[R],n=this._connectionTokens[R];let m=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),t.URI.from({scheme:s.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${F}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class k{asBrowserUri(S,R){const F=this.toUri(S,R);return F.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===E.file&&(s.isNative||typeof s.globals.importScripts=="function"&&s.globals.origin===`${E.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?F.with({scheme:E.vscodeFileResource,authority:F.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(S,R){const F=this.toUri(S,R);return F.scheme===E.vscodeFileResource?F.with({scheme:E.file,authority:F.authority!==k.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(S,R){return t.URI.isUri(S)?S:t.URI.parse(R.toUrl(S))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ye[24],Ce([0,1,42,10,17,23,9,2]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=S;class R{constructor(r){this._ignorePathCasing=r}compare(r,g,l=!1){return r===g?0:(0,k.compare)(this.getComparisonKey(r,l),this.getComparisonKey(g,l))}isEqual(r,g,l=!1){return r===g?!0:!r||!g?!1:this.getComparisonKey(r,l)===this.getComparisonKey(g,l)}getComparisonKey(r,g=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,g,l=!1){if(r.scheme===g.scheme){if(r.scheme===t.Schemas.file)return s.isEqualOrParent(S(r),S(g),this._ignorePathCasing(r))&&r.query===g.query&&(l||r.fragment===g.fragment);if((0,e.isEqualAuthority)(r.authority,g.authority))return s.isEqualOrParent(r.path,g.path,this._ignorePathCasing(r),"/")&&r.query===g.query&&(l||r.fragment===g.fragment)}return!1}joinPath(r,...g){return T.URI.joinPath(r,...g)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return E.posix.basename(r.path)}extname(r){return E.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let g;return r.scheme===t.Schemas.file?g=T.URI.file(E.dirname(S(r))).path:(g=E.posix.dirname(r.path),r.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),g="/")),r.with({path:g})}normalizePath(r){if(!r.path.length)return r;let g;return r.scheme===t.Schemas.file?g=T.URI.file(E.normalize(S(r))).path:g=E.posix.normalize(r.path),r.with({path:g})}relativePath(r,g){if(r.scheme!==g.scheme||!(0,e.isEqualAuthority)(r.authority,g.authority))return;if(r.scheme===t.Schemas.file){const w=E.relative(S(r),S(g));return A.isWindows?s.toSlashes(w):w}let l=r.path||"/",D=g.path||"/";if(this._ignorePathCasing(r)){let w=0;for(const d=Math.min(l.length,D.length);w<d&&!(l.charCodeAt(w)!==D.charCodeAt(w)&&l.charAt(w).toLowerCase()!==D.charAt(w).toLowerCase());w++);l=D.substr(0,w)+l.substr(w)}return E.posix.relative(l,D)}resolvePath(r,g){if(r.scheme===t.Schemas.file){const l=T.URI.file(E.resolve(S(r),g));return r.with({authority:l.authority,path:l.path})}return g=s.toPosixPath(g),r.with({path:E.posix.resolve(r.path,g)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,g){return r===g||r!==void 0&&g!==void 0&&(0,k.equalsIgnoreCase)(r,g)}hasTrailingPathSeparator(r,g=E.sep){if(r.scheme===t.Schemas.file){const l=S(r);return l.length>s.getRoot(l).length&&l[l.length-1]===g}else{const l=r.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,g=E.sep){return(0,e.hasTrailingPathSeparator)(r,g)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,g=E.sep){let l=!1;if(r.scheme===t.Schemas.file){const D=S(r);l=D!==void 0&&D.length===s.getRoot(D).length&&D[D.length-1]===g}else{g="/";const D=r.path;l=D.length===1&&D.charCodeAt(D.length-1)===47}return!l&&!(0,e.hasTrailingPathSeparator)(r,g)?r.with({path:r.path+"/"}):r}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(m=>m.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new R(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(m,r){const g=[];for(let l=0;l<m.length;l++){const D=r(m[l]);m.some((w,d)=>d===l?!1:(0,e.isEqualOrParent)(D,r(w)))||g.push(m[l])}return g}e.distinctParents=F;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function r(g){const l=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[p,I]=d.split(":");p&&I&&l.set(p,I)});const w=g.path.substring(0,g.path.indexOf(";"));return w&&l.set(m.META_DATA_MIME,w),l}m.parseMetaData=r})(C=e.DataUri||(e.DataUri={}));function n(m,r,g){if(r){let l=m.path;return l&&l[0]!==E.posix.sep&&(l=E.posix.sep+l),m.with({scheme:g,authority:r,path:l})}return m.with({scheme:g})}e.toLocalResource=n}),define(ye[14],Ce([0,1,20,15,4,6,24,23]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(ae){return!!ae&&typeof ae.then=="function"}e.isThenable=S;function R(ae){const le=new s.CancellationTokenSource,Se=ae(le.token),Ee=new Promise((Fe,$e)=>{const Ve=le.token.onCancellationRequested(()=>{Ve.dispose(),le.dispose(),$e((0,t.canceled)())});Promise.resolve(Se).then(je=>{Ve.dispose(),le.dispose(),Fe(je)},je=>{Ve.dispose(),le.dispose(),$e(je)})});return new class{cancel(){le.cancel()}then(Fe,$e){return Ee.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ee.finally(Fe)}}}e.createCancelablePromise=R;function F(ae,le,Se){return Promise.race([ae,new Promise(Ee=>le.onCancellationRequested(()=>Ee(Se)))])}e.raceCancellation=F;async function C(ae){let le=-1;const Se=ae.map((Fe,$e)=>Fe.then(Ve=>(le=$e,Ve))),Ee=await Promise.race(Se);return ae.forEach((Fe,$e)=>{$e!==le&&Fe.cancel()}),Ee}e.raceCancellablePromises=C;function n(ae,le,Se){let Ee;const Fe=setTimeout(()=>{Ee?.(void 0),Se?.()},le);return Promise.race([ae.finally(()=>clearTimeout(Fe)),new Promise($e=>Ee=$e)])}e.raceTimeout=n;function m(ae){return new Promise((le,Se)=>{const Ee=ae();S(Ee)?Ee.then(le,Se):le(Ee)})}e.asPromise=m;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(le){if(this.activePromise){if(this.queuedPromiseFactory=le,!this.queuedPromise){const Se=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(Se,Se).then(Ee)})}return new Promise((Se,Ee)=>{this.queuedPromise.then(Se,Ee)})}return this.activePromise=le(),new Promise((Se,Ee)=>{this.activePromise.then(Fe=>{this.activePromise=null,Se(Fe)},Fe=>{this.activePromise=null,Ee(Fe)})})}}e.Throttler=r;class g{constructor(){this.current=Promise.resolve(null)}queue(le){return this.current=this.current.then(()=>le(),()=>le())}}e.Sequencer=g;class l{constructor(){this.promiseMap=new Map}queue(le,Se){const Fe=(this.promiseMap.get(le)??Promise.resolve()).catch(()=>{}).then(Se).finally(()=>{this.promiseMap.get(le)===Fe&&this.promiseMap.delete(le)});return this.promiseMap.set(le,Fe),Fe}}e.SequencerByKey=l;const D=(ae,le)=>{let Se=!0;const Ee=setTimeout(()=>{Se=!1,le()},ae);return{isTriggered:()=>Se,dispose:()=>{clearTimeout(Ee),Se=!1}}},w=ae=>{let le=!0;return queueMicrotask(()=>{le&&(le=!1,ae())}),{isTriggered:()=>le,dispose:()=>{le=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(le){this.defaultDelay=le,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(le,Se=this.defaultDelay){this.task=le,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Se===e.MicrotaskDelay?w(Ee):D(Se,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class p{constructor(le){this.delayer=new d(le),this.throttler=new r}trigger(le,Se){return this.delayer.trigger(()=>this.throttler.queue(le),Se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class I{constructor(){this._isOpen=!1,this._promise=new Promise((le,Se)=>{this._completePromise=le})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class c extends I{constructor(le){super();this._timeout=setTimeout(()=>this.open(),le)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function M(ae,le){return le?new Promise((Se,Ee)=>{const Fe=setTimeout(()=>{$e.dispose(),Se()},ae),$e=le.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ee((0,t.canceled)())})}):R(Se=>M(ae,Se))}e.timeout=M;function o(ae,le=0){const Se=setTimeout(ae,le);return(0,A.toDisposable)(()=>clearTimeout(Se))}e.disposableTimeout=o;function i(ae){const le=[];let Se=0;const Ee=ae.length;function Fe(){return Se<Ee?ae[Se++]():null}function $e(Ve){Ve!=null&&le.push(Ve);const je=Fe();return je?je.then($e):Promise.resolve(le)}return Promise.resolve(null).then($e)}e.sequence=i;function f(ae,le=Ee=>!!Ee,Se=null){let Ee=0;const Fe=ae.length,$e=()=>{if(Ee>=Fe)return Promise.resolve(Se);const Ve=ae[Ee++];return Promise.resolve(Ve()).then(H=>le(H)?Promise.resolve(H):$e())};return $e()}e.first=f;function u(ae,le=Ee=>!!Ee,Se=null){if(ae.length===0)return Promise.resolve(Se);let Ee=ae.length;const Fe=()=>{Ee=-1;for(const $e of ae)$e.cancel?.()};return new Promise(($e,Ve)=>{for(const je of ae)je.then(H=>{--Ee>=0&&le(H)?(Fe(),$e(H)):Ee===0&&$e(Se)}).catch(H=>{--Ee>=0&&(Fe(),Ve(H))})})}e.firstParallel=u;class h{constructor(le){this._size=0,this.maxDegreeOfParalellism=le,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(le){return this._size++,new Promise((Se,Ee)=>{this.outstandingPromises.push({factory:le,c:Se,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const le=this.outstandingPromises.shift();this.runningPromises++;const Se=le.factory();Se.then(le.c,le.e),Se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class b extends h{constructor(){super(1)}}e.Queue=b;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const le=new j;return this.drainers.add(le),le.p}isDrained(){for(const[,le]of this.queues)if(le.size>0)return!1;return!0}queueFor(le,Se=k.extUri){const Ee=Se.getComparisonKey(le);let Fe=this.queues.get(Ee);return Fe||(Fe=new b,E.Event.once(Fe.onFinished)(()=>{Fe?.dispose(),this.queues.delete(Ee),this.onDidQueueFinish()}),this.queues.set(Ee,Fe)),Fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const le of this.drainers)le.complete();this.drainers.clear()}dispose(){for(const[,le]of this.queues)le.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class a{constructor(le,Se){this._token=-1,typeof le=="function"&&typeof Se=="number"&&this.setIfNotSet(le,Se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(le,Se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,le()},Se)}setIfNotSet(le,Se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,le()},Se))}}e.TimeoutTimer=a;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(le,Se){this.cancel(),this._token=setInterval(()=>{le()},Se)}}e.IntervalTimer=_;class P{constructor(le,Se){this.timeoutToken=-1,this.runner=le,this.timeout=Se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(le=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,le)}get delay(){return this.timeout}set delay(le){this.timeout=le}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class N{constructor(le,Se){Se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Se}ms is not a multiple of 1000ms.`),this.runner=le,this.timeout=Se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(le=this.timeout){le%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(le/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class $ extends P{constructor(le,Se){super(le,Se);this.units=[]}work(le){this.units.push(le),this.isScheduled()||this.schedule()}doRun(){const le=this.units;this.units=[],this.runner&&this.runner(le)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class y extends A.Disposable{constructor(le,Se,Ee,Fe){super();this.maxWorkChunkSize=le,this.maxPendingWork=Se,this.throttleDelay=Ee,this.handler=Fe,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(le){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+le.length>this.maxPendingWork)return!1}else if(this.pending+le.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...le),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ae=>{(0,T.setTimeout0)(()=>{if(le)return;const Se=Date.now()+15;ae(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Se-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.runWhenIdle=(ae,le)=>{const Se=requestIdleCallback(ae,typeof le=="number"?{timeout:le}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(Se))}}}}();class L{constructor(le){this._didRun=!1,this._executor=()=>{try{this._value=le()}catch(Se){this._error=Se}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function z(ae,le,Se){let Ee;for(let Fe=0;Fe<Se;Fe++)try{return await ae()}catch($e){Ee=$e,await M(le)}throw Ee}e.retry=z;class x{hasPending(le){return this._pending?typeof le=="number"?this._pending.taskId===le:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(le,Se,Ee){return this._pending={taskId:le,cancel:()=>Ee?.(),promise:Se},Se.then(()=>this.donePending(le),()=>this.donePending(le)),Se}donePending(le){this._pending&&le===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const le=this._next;this._next=void 0,le.run().then(le.promiseResolve,le.promiseReject)}}setNext(le){if(this._next)this._next.run=le;else{let Se,Ee;const Fe=new Promise(($e,Ve)=>{Se=$e,Ee=Ve});this._next={run:le,promise:Fe,promiseResolve:Se,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=x;class B{constructor(le,Se=()=>Date.now()){this.interval=le,this.nowFn=Se,this.lastIncrementTime=0,this.value=0}increment(){const le=this.nowFn();return le-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=le,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((le,Se)=>{this.completeCallback=le,this.errorCallback=Se})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(le){return new Promise(Se=>{this.completeCallback(le),this.resolved=!0,Se()})}error(le){return new Promise(Se=>{this.errorCallback(le),this.rejected=!0,Se()})}cancel(){new Promise(le=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,le()})}}e.DeferredPromise=j;var ue;(function(ae){async function le(Ee){let Fe;const $e=await Promise.all(Ee.map(Ve=>Ve.then(je=>je,je=>{Fe||(Fe=je)})));if(typeof Fe!="undefined")throw Fe;return $e}ae.settled=le;function Se(Ee){return new Promise(async(Fe,$e)=>{try{await Ee(Fe,$e)}catch(Ve){$e(Ve)}})}ae.withAsyncBody=Se})(ue=e.Promises||(e.Promises={}));var K;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(K||(K={}));class ne{constructor(le){this._state=0,this._results=[],this._error=null,this._onStateChanged=new E.Emitter,queueMicrotask(async()=>{const Se={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(le(Se)),this.resolve()}catch(Ee){this.reject(Ee)}finally{Se.emitOne=void 0,Se.emitMany=void 0,Se.reject=void 0}})}static fromArray(le){return new ne(Se=>{Se.emitMany(le)})}static fromPromise(le){return new ne(async Se=>{Se.emitMany(await le)})}static fromPromises(le){return new ne(async Se=>{await Promise.all(le.map(async Ee=>Se.emitOne(await Ee)))})}static merge(le){return new ne(async Se=>{await Promise.all(le.map(async Ee=>{for await(const Fe of Ee)Se.emitOne(Fe)}))})}[Symbol.asyncIterator](){let le=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(le<this._results.length)return{done:!1,value:this._results[le++]};if(this._state===1)return{done:!0,value:void 0};await E.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(le,Se){return new ne(async Ee=>{for await(const Fe of le)Ee.emitOne(Se(Fe))})}map(le){return ne.map(this,le)}static filter(le,Se){return new ne(async Ee=>{for await(const Fe of le)Se(Fe)&&Ee.emitOne(Fe)})}filter(le){return ne.filter(this,le)}static coalesce(le){return ne.filter(le,Se=>!!Se)}coalesce(){return ne.coalesce(this)}static async toPromise(le){const Se=[];for await(const Ee of le)Se.push(Ee);return Se}toPromise(){return ne.toPromise(this)}emitOne(le){this._state===0&&(this._results.push(le),this._onStateChanged.fire())}emitMany(le){this._state===0&&(this._results=this._results.concat(le),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(le){this._state===0&&(this._state=2,this._error=le,this._onStateChanged.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class pe extends ne{constructor(le,Se){super(Se);this._source=le}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function be(ae){const le=new s.CancellationTokenSource,Se=ae(le.token);return new pe(le,async Ee=>{const Fe=le.token.onCancellationRequested(()=>{Fe.dispose(),le.dispose(),Ee.reject((0,t.canceled)())});try{for await(const $e of Se){if(le.token.isCancellationRequested)return;Ee.emitOne($e)}Fe.dispose(),le.dispose()}catch($e){Fe.dispose(),le.dispose(),Ee.reject($e)}})}e.createCancelableAsyncIterable=be}),define(ye[104],Ce([0,1,14,17]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new s.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),A=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(v,a,_=!1){const P=v||"",N=a||"",$=E.value.collator.compare(P,N);return E.value.collatorIsNumeric&&$===0&&P!==N?P<N?-1:1:$}e.compareFileNames=T;function S(v,a){const _=A.value.collator;return v=v||"",a=a||"",I(_,v,a)}e.compareFileNamesDefault=S;function R(v,a){const _=A.value.collator;return v=v||"",a=a||"",i(v,a)||I(_,v,a)}e.compareFileNamesUpper=R;function F(v,a){const _=A.value.collator;return v=v||"",a=a||"",o(v,a)||I(_,v,a)}e.compareFileNamesLower=F;function C(v,a){return v=v||"",a=a||"",v===a?0:v<a?-1:1}e.compareFileNamesUnicode=C;function n(v,a,_=!1){_||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase());const[P,N]=d(v),[$,y]=d(a);return P!==$?P<$?-1:1:N===y?0:N<y?-1:1}e.noIntlCompareFileNames=n;function m(v,a){const[_,P]=d(v),[N,$]=d(a);let y=E.value.collator.compare(P,$);if(y===0){if(E.value.collatorIsNumeric&&P!==$)return P<$?-1:1;if(y=E.value.collator.compare(_,N),E.value.collatorIsNumeric&&y===0&&_!==N)return _<N?-1:1}return y}e.compareFileExtensions=m;function r(v,a){v=v||"",a=a||"";const _=p(v),P=p(a),N=A.value.collator,$=k.value.collator;return I($,_,P)||I(N,v,a)}e.compareFileExtensionsDefault=r;function g(v,a){v=v||"",a=a||"";const _=p(v),P=p(a),N=A.value.collator,$=k.value.collator;return I($,_,P)||i(v,a)||I(N,v,a)}e.compareFileExtensionsUpper=g;function l(v,a){v=v||"",a=a||"";const _=p(v),P=p(a),N=A.value.collator,$=k.value.collator;return I($,_,P)||o(v,a)||I(N,v,a)}e.compareFileExtensionsLower=l;function D(v,a){v=v||"",a=a||"";const _=p(v).toLowerCase(),P=p(a).toLowerCase();return _!==P?_<P?-1:1:v!==a?v<a?-1:1:0}e.compareFileExtensionsUnicode=D;const w=/^(.*?)(\.([^.]*))?$/;function d(v,a=!1){const _=v?w.exec(v):[];let P=[_&&_[1]||"",_&&_[3]||""];return a&&(!P[0]&&P[1]||P[0]&&P[0].charAt(0)===".")&&(P=[P[0]+"."+P[1],""]),P}function p(v){const a=v?w.exec(v):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function I(v,a,_){let P=v.compare(a,_);return P!==0?P:a.length!==_.length?a.length<_.length?-1:1:0}function c(v){const a=v.charAt(0);return a.toLocaleUpperCase()!==a}function M(v){const a=v.charAt(0);return a.toLocaleLowerCase()!==a}function o(v,a){return c(v)&&M(a)?-1:M(v)&&c(a)?1:0}function i(v,a){return M(v)&&c(a)?-1:c(v)&&M(a)?1:0}function f(v,a,_=!1){return _||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase()),v===a?0:v<a?-1:1}function u(v,a,_=!1){const P=v.split(t.sep),N=a.split(t.sep),$=P.length-1,y=N.length-1;let L,z;for(let x=0;;x++){if(L=$===x,z=y===x,L&&z)return T(P[x],N[x],_);if(L)return-1;if(z)return 1;const B=f(P[x],N[x],_);if(B!==0)return B}}e.comparePaths=u;function h(v,a,_){const P=v.toLowerCase(),N=a.toLowerCase(),$=b(v,a,_);if($)return $;const y=P.endsWith(_),L=N.endsWith(_);if(y!==L)return y?-1:1;const z=T(P,N);return z!==0?z:P.localeCompare(N)}e.compareAnything=h;function b(v,a,_){const P=v.toLowerCase(),N=a.toLowerCase(),$=P.startsWith(_),y=N.startsWith(_);if($!==y)return $?-1:1;if($&&y){if(P.length<N.length)return-1;if(P.length>N.length)return 1}return 0}e.compareByPrefix=b}),define(ye[29],Ce([0,1,14,42,21,17,9]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const S="**",R="/",F="[/\\\\]",C="[^/\\\\]",n=/\//g;function m(K){switch(K){case 0:return"";case 1:return`${C}*?`;default:return`(?:${F}|${C}+${F}|${F}${C}+)*?`}}function r(K,ne){if(!K)return[];const pe=[];let be=!1,ae=!1,le="";for(const Se of K){switch(Se){case ne:if(!be&&!ae){pe.push(le),le="";continue}break;case"{":be=!0;break;case"}":be=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}le+=Se}return le&&pe.push(le),pe}e.splitGlobAware=r;function g(K){if(!K)return"";let ne="";const pe=r(K,R);if(pe.every(be=>be===S))ne=".*";else{let be=!1;pe.forEach((ae,le)=>{if(ae===S){be||(ne+=m(2),be=!0);return}let Se=!1,Ee="",Fe=!1,$e="";for(const Ve of ae){if(Ve!=="}"&&Se){Ee+=Ve;continue}if(Fe&&(Ve!=="]"||!$e)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!$e?je="^":Ve===R?je="":je=k.escapeRegExpCharacters(Ve),$e+=je;continue}switch(Ve){case"{":Se=!0;continue;case"[":Fe=!0;continue;case"}":{ne+=`(?:${r(Ee,",").map(G=>g(G)).join("|")})`,Se=!1,Ee="";break}case"]":ne+="["+$e+"]",Fe=!1,$e="";break;case"?":ne+=C;continue;case"*":ne+=m(1);continue;default:ne+=k.escapeRegExpCharacters(Ve)}}le<pe.length-1&&(pe[le+1]!==S||le+2<pe.length)&&(ne+=F),be=!1})}return ne}const l=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new E.LRUCache(1e4),M=function(){return!1},o=function(){return null};function i(K,ne){if(!K)return o;let pe;typeof K!="string"?pe=K.pattern:pe=K,pe=pe.trim();const be=`${pe}_${!!ne.trimForExclusions}`;let ae=c.get(be);if(ae)return f(ae,K);let le;if(l.test(pe)){const Se=pe.substr(4);ae=function(Ee,Fe){return typeof Ee=="string"&&Ee.endsWith(Se)?pe:null}}else(le=D.exec(u(pe,ne)))?ae=h(le[1],pe):(ne.trimForExclusions?d:w).test(pe)?ae=b(pe,ne):(le=p.exec(u(pe,ne)))?ae=v(le[1].substr(1),pe,!0):(le=I.exec(u(pe,ne)))?ae=v(le[1],pe,!1):ae=a(pe);return c.set(be,ae),f(ae,K)}function f(K,ne){return typeof ne=="string"?K:function(pe,be){return t.isEqualOrParent(pe,ne.base)?K(A.relative(ne.base,pe),be):null}}function u(K,ne){return ne.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function h(K,ne){const pe=`/${K}`,be=`\\${K}`,ae=function(Se,Ee){return typeof Se!="string"?null:Ee?Ee===K?ne:null:Se===K||Se.endsWith(pe)||Se.endsWith(be)?ne:null},le=[K];return ae.basenames=le,ae.patterns=[ne],ae.allBasenames=le,ae}function b(K,ne){const pe=ue(K.slice(1,-1).split(",").map(Ee=>i(Ee,ne)).filter(Ee=>Ee!==o),K),be=pe.length;if(!be)return o;if(be===1)return pe[0];const ae=function(Ee,Fe){for(let $e=0,Ve=pe.length;$e<Ve;$e++)if(pe[$e](Ee,Fe))return K;return null},le=pe.find(Ee=>!!Ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Se=pe.reduce((Ee,Fe)=>Fe.allPaths?Ee.concat(Fe.allPaths):Ee,[]);return Se.length&&(ae.allPaths=Se),ae}function v(K,ne,pe){const be=A.sep===A.posix.sep,ae=be?K:K.replace(n,A.sep),le=A.sep+ae,Se=A.posix.sep+K,Ee=pe?function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||Fe.endsWith(le)||!be&&(Fe===K||Fe.endsWith(Se)))?ne:null}:function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||!be&&Fe===K)?ne:null};return Ee.allPaths=[(pe?"*/":"./")+K],Ee}function a(K){try{const ne=new RegExp(`^${g(K)}$`);return function(pe){return ne.lastIndex=0,typeof pe=="string"&&ne.test(pe)?K:null}}catch{return o}}function _(K,ne,pe){return!K||typeof ne!="string"?!1:P(K)(ne,void 0,pe)}e.match=_;function P(K,ne={}){if(!K)return M;if(typeof K=="string"||L(K)){const pe=i(K,ne);if(pe===o)return M;const be=function(ae,le){return!!pe(ae,le)};return pe.allBasenames&&(be.allBasenames=pe.allBasenames),pe.allPaths&&(be.allPaths=pe.allPaths),be}return B(K,ne)}e.parse=P;function N(K){if(!K)return;let ne;return pe=>(ne||(ne=(K()||Promise.resolve([])).then(be=>be?y(be):{})),ne.then(be=>!!be[pe]))}e.hasSiblingPromiseFn=N;function $(K){if(!K)return;let ne;return pe=>{if(!ne){const be=K();ne=be?y(be):{}}return!!ne[pe]}}e.hasSiblingFn=$;function y(K){const ne={};for(const pe of K)ne[pe]=!0;return ne}function L(K){const ne=K;return ne&&typeof ne.base=="string"&&typeof ne.pattern=="string"}e.isRelativePattern=L;function z(K){return K.allBasenames||[]}e.getBasenameTerms=z;function x(K){return K.allPaths||[]}e.getPathTerms=x;function B(K,ne){const pe=ue(Object.getOwnPropertyNames(K).map(Ee=>j(Ee,K[Ee],ne)).filter(Ee=>Ee!==o)),be=pe.length;if(!be)return o;if(!pe.some(Ee=>!!Ee.requiresSiblings)){if(be===1)return pe[0];const Ee=function(Ve,je){for(let H=0,G=pe.length;H<G;H++){const X=pe[H](Ve,je);if(X)return X}return null},Fe=pe.find(Ve=>!!Ve.allBasenames);Fe&&(Ee.allBasenames=Fe.allBasenames);const $e=pe.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return $e.length&&(Ee.allPaths=$e),Ee}const ae=function(Ee,Fe,$e){let Ve;for(let je=0,H=pe.length;je<H;je++){const G=pe[je];G.requiresSiblings&&$e&&(Fe||(Fe=A.basename(Ee)),Ve||(Ve=Fe.substr(0,Fe.length-A.extname(Ee).length)));const X=G(Ee,Fe,Ve,$e);if(X)return X}return null},le=pe.find(Ee=>!!Ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Se=pe.reduce((Ee,Fe)=>Fe.allPaths?Ee.concat(Fe.allPaths):Ee,[]);return Se.length&&(ae.allPaths=Se),ae}function j(K,ne,pe){if(ne===!1)return o;const be=i(K,pe);if(be===o)return o;if(typeof ne=="boolean")return be;if(ne){const ae=ne.when;if(typeof ae=="string"){const le=(Se,Ee,Fe,$e)=>{if(!$e||!be(Se,Ee))return null;const Ve=ae.replace("$(basename)",Fe),je=$e(Ve);return(0,s.isThenable)(je)?je.then(H=>H?K:null):je?K:null};return le.requiresSiblings=!0,le}}return be}function ue(K,ne){const pe=K.filter(Ee=>!!Ee.basenames);if(pe.length<2)return K;const be=pe.reduce((Ee,Fe)=>{const $e=Fe.basenames;return $e?Ee.concat($e):Ee},[]);let ae;if(ne){ae=[];for(let Ee=0,Fe=be.length;Ee<Fe;Ee++)ae.push(ne)}else ae=pe.reduce((Ee,Fe)=>{const $e=Fe.patterns;return $e?Ee.concat($e):Ee},[]);const le=function(Ee,Fe){if(typeof Ee!="string")return null;if(!Fe){let Ve;for(Ve=Ee.length;Ve>0;Ve--){const je=Ee.charCodeAt(Ve-1);if(je===47||je===92)break}Fe=Ee.substr(Ve)}const $e=be.indexOf(Fe);return $e!==-1?ae[$e]:null};le.basenames=be,le.patterns=ae,le.allBasenames=be;const Se=K.filter(Ee=>!Ee.basenames);return Se.push(le),Se}}),define(ye[77],Ce([0,1,42,10,17,23,24,9,2]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,f,u){if(typeof i=="string"&&(i=S.URI.file(i)),u){const b=u.getWorkspaceFolder(i);if(b){const v=u.getWorkspace().folders.length>1;let a;if((0,k.isEqual)(b.uri,i)?a="":a=(0,k.relativePath)(b.uri,i),v){const _=b.name?b.name:(0,k.basename)(b.uri);a=a?_+" \u2022 "+a:_}return a}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,s.hasDriveLetter)(i.fsPath))return(0,E.normalize)(C(i.fsPath));let h=(0,E.normalize)(i.fsPath);return!A.isWindows&&f?.userHome&&(h=m(h,f.userHome.fsPath)),h}e.getPathLabel=R;function F(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const f=(0,k.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return A.isWindows&&(0,s.isRootOrDriveLetter)(f)?C(f):f}e.getBaseLabel=F;function C(i,f){return(0,s.hasDriveLetter)(i,f)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let n=Object.create(null);function m(i,f){if(A.isWindows||!i||!f)return i;let u=n.original===f?n.normalized:void 0;return u||(u=`${(0,T.rtrim)(f,E.posix.sep)}${E.posix.sep}`,n={original:f,normalized:u}),(A.isLinux?i.startsWith(u):(0,T.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=m;function r(i,f){return i.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=r;const g="\u2026",l="\\\\",D="~";function w(i,f=E.sep){const u=new Array(i.length);let h=!1;for(let b=0;b<i.length;b++){let v=i[b];if(v===""){u[b]=`.${f}`;continue}if(!v){u[b]=v;continue}h=!0;let a="";v.indexOf(l)===0?(a=v.substr(0,v.indexOf(l)+l.length),v=v.substr(v.indexOf(l)+l.length)):v.indexOf(f)===0?(a=v.substr(0,v.indexOf(f)+f.length),v=v.substr(v.indexOf(f)+f.length)):v.indexOf(D)===0&&(a=v.substr(0,v.indexOf(D)+D.length),v=v.substr(v.indexOf(D)+D.length));const _=v.split(f);for(let P=1;h&&P<=_.length;P++)for(let N=_.length-P;h&&N>=0;N--){h=!1;let $=_.slice(N,N+P).join(f);for(let y=0;!h&&y<i.length;y++)if(y!==b&&i[y]&&i[y].indexOf($)>-1){const L=N+P===_.length,z=N>0&&i[y].indexOf(f)>-1?f+$:$,x=i[y].endsWith(z);h=!L||x}if(!h){let y="";(_[0].endsWith(":")||a!=="")&&(N===1&&(N=0,P++,$=_[0]+f+$),N>0&&(y=_[0]+f),y=a+y),N>0&&(y=y+g+f),y=y+$,N+P<_.length&&(y=y+f+g),u[b]=y}}h&&(u[b]=v)}return u}e.shorten=w;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function p(i,f=Object.create(null)){const u=[];let h=!1,b="";for(const v of i)if(v==="$"||h&&v==="{")b&&u.push({value:b,type:d.TEXT}),b="",h=!0;else if(v==="}"&&h){const a=f[b];if(typeof a=="string")a.length&&u.push({value:a,type:d.VARIABLE});else if(a){const _=u[u.length-1];(!_||_.type!==d.SEPARATOR)&&u.push({value:a.label,type:d.SEPARATOR})}b="",h=!1}else b+=v;return b&&!h&&u.push({value:b,type:d.TEXT}),u.filter((v,a)=>{if(v.type===d.SEPARATOR){const _=u[a-1],P=u[a+1];return[_,P].every(N=>N&&(N.type===d.VARIABLE||N.type===d.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=p;function I(i,f){return A.isMacintosh||f?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function c(i,f){return A.isMacintosh||f?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function o(i){const f=i.indexOf("/")!==-1?E.posix:E.win32,u=f.basename(i),h=f.dirname(i);return u.length?{name:u,parentPath:h}:{name:h,parentPath:""}}e.splitName=o}),define(ye[78],Ce([0,1,29,10,17,24,9]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let S=[],R=[],F=[];function C(i,f=!1){const u=n(i);S.push(u),u.userConfigured?F.push(u):R.push(u),f&&!u.userConfigured&&S.forEach(h=>{h.mime===u.mime||h.userConfigured||(u.extension&&h.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&h.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&h.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&h.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=C;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,s.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(E.posix.sep)>=0:!1}}function m(i){i?(S=S.filter(f=>!f.userConfigured),F=[]):(S=[],R=[],F=[])}e.clearTextMimes=m;function r(i,f){let u;if(i)switch(i.scheme){case t.Schemas.file:u=i.fsPath;break;case t.Schemas.data:{u=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break}default:u=i.path}if(!u)return[T.unknown];u=u.toLowerCase();const h=(0,E.basename)(u),b=g(u,h,F);if(b)return[b,T.text];const v=g(u,h,R);if(v)return[v,T.text];if(f){const a=l(f);if(a)return[a,T.text]}return[T.unknown]}e.guessMimeTypes=r;function g(i,f,u){let h=null,b=null,v=null;for(let a=u.length-1;a>=0;a--){const _=u[a];if(f===_.filenameLowercase){h=_;break}if(_.filepattern&&(!b||_.filepattern.length>b.filepattern.length)){const P=_.filepatternOnPath?i:f;_.filepatternLowercase?.(P)&&(b=_)}_.extension&&(!v||_.extension.length>v.extension.length)&&f.endsWith(_.extensionLowercase)&&(v=_)}return h?h.mime:b?b.mime:v?v.mime:null}function l(i){if((0,k.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let f=S.length-1;f>=0;f--){const u=S[f];if(!u.firstline)continue;const h=i.match(u.firstline);if(h&&h.length>0)return u.mime}return null}function D(i){return i?typeof i=="string"?i===T.binary||i===T.text||i===T.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(i){const f=(0,E.extname)(i),u=w[f.toLowerCase()];return u!==void 0?u:I(i)}e.getMediaOrTextMime=p;function I(i){const f=(0,E.extname)(i);return d[f.toLowerCase()]}e.getMediaMime=I;function c(i){for(const f in d)if(d[f]===i)return f}e.getExtensionForMimeType=c;const M=/^(.+)\/(.+?)(;.+)?$/;function o(i,f){const u=M.exec(i);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:f?void 0:i}e.normalizeMimeType=o}),define(ye[105],Ce([0,1,2]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class E{constructor(C){this._uriTransformer=C}transformIncoming(C){const n=this._uriTransformer.transformIncoming(C);return n===C?C:t(s.URI.from(n))}transformOutgoing(C){const n=this._uriTransformer.transformOutgoing(C);return n===C?C:t(s.URI.from(n))}transformOutgoingURI(C){const n=this._uriTransformer.transformOutgoing(C);return n===C?C:s.URI.from(n)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function A(F,C,n){if(!F||n>200)return null;if(typeof F=="object"){if(F instanceof s.URI)return C.transformOutgoing(F);for(let m in F)if(Object.hasOwnProperty.call(F,m)){const r=A(F[m],C,n+1);r!==null&&(F[m]=r)}}return null}function k(F,C){const n=A(F,C,0);return n===null?F:n}e.transformOutgoingURIs=k;function T(F,C,n,m){if(!F||m>200)return null;if(typeof F=="object"){if(F.$mid===1)return n?s.URI.revive(C.transformIncoming(F)):C.transformIncoming(F);for(let r in F)if(Object.hasOwnProperty.call(F,r)){const g=T(F[r],C,n,m+1);g!==null&&(F[r]=g)}}return null}function S(F,C){const n=T(F,C,!1,0);return n===null?F:n}e.transformIncomingURIs=S;function R(F,C){const n=T(F,C,!0,0);return n===null?F:n}e.transformAndReviveIncomingURIs=R}),define(ye[35],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(S){return s.test(S)}e.isUUID=t;const E=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let R=0;R<S.length;R++)S[R]=Math.floor(Math.random()*256);return S};function T(){k(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let S=0,R="";return R+=A[E[S++]],R+=A[E[S++]],R+=A[E[S++]],R+=A[E[S++]],R+="-",R+=A[E[S++]],R+=A[E[S++]],R+="-",R+=A[E[S++]],R+=A[E[S++]],R+="-",R+=A[E[S++]],R+=A[E[S++]],R+="-",R+=A[E[S++]],R+=A[E[S++]],R+=A[E[S++]],R+=A[E[S++]],R+=A[E[S++]],R+=A[E[S++]],R}e.generateUuid=T}),define(ye[106],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let S=0,R=T.notIn.length;S<R;S++)switch(T.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const R=T.findTokenIndexAtOffset(S-2),F=T.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(T,S){for(let R=T;R<=S;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class E{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=E;function A(k,T,S){k.has(T)?k.get(T).push(S):k.set(T,[S])}}),define(ye[55],Ce([0,1,29,17]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,k,T,S){if(Array.isArray(A)){let R=0;for(const F of A){const C=E(F,k,T,S);if(C===10)return C;C>R&&(R=C)}return R}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:R,pattern:F,scheme:C,hasAccessToAllModels:n}=A;if(!S&&!n)return 0;let m=0;if(C)if(C===k.scheme)m=10;else if(C==="*")m=5;else return 0;if(R)if(R===T)m=10;else if(R==="*")m=Math.max(m,5);else return 0;if(F){let r;if(typeof F=="string"?r=F:r={...F,base:(0,t.normalize)(F.base)},r===k.fsPath||(0,s.match)(r,k.fsPath))m=10;else return 0}return m}else return 0}}e.score=E}),define(ye[107],Ce([0,1,4,6]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new s.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,T){return this._map.set(k,T),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===T&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,T){let S=null,R=!1;return this._promises.set(k,T.then(F=>{this._promises.delete(k),!(R||!F)&&(S=this.register(k,F))})),(0,t.toDisposable)(()=>{R=!0,S&&S.dispose()})}getPromise(k){const T=this.get(k);if(T)return Promise.resolve(T);const S=this._promises.get(k);return S?S.then(R=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(ye[79],Ce([0,1,22,23]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(E||(E={}));function A(C){for(let n=0,m=C.length;n<m;n+=4){const r=C[n+0],g=C[n+1],l=C[n+2],D=C[n+3];C[n+0]=D,C[n+1]=l,C[n+2]=g,C[n+3]=r}}function k(C){const n=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return t.isLittleEndian()||A(n),s.VSBuffer.wrap(n)}function T(C){const n=C.buffer;if(t.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function S(C){const n=new Uint32Array(R(C));let m=0;if(n[m++]=C.id,C.type==="full")n[m++]=1,n[m++]=C.data.length,n.set(C.data,m),m+=C.data.length;else{n[m++]=2,n[m++]=C.deltas.length;for(const r of C.deltas)n[m++]=r.start,n[m++]=r.deleteCount,r.data?(n[m++]=r.data.length,n.set(r.data,m),m+=r.data.length):n[m++]=0}return k(n)}e.encodeSemanticTokensDto=S;function R(C){let n=0;if(n+=1+1,C.type==="full")n+=1+C.data.length;else{n+=1,n+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(n+=m.data.length)}return n}function F(C){const n=T(C);let m=0;const r=n[m++];if(n[m++]===1){const w=n[m++],d=n.subarray(m,m+w);return m+=w,{id:r,type:"full",data:d}}const l=n[m++];let D=[];for(let w=0;w<l;w++){const d=n[m++],p=n[m++],I=n[m++];let c;I>0&&(c=n.subarray(m,m+I),m+=I),D[w]={start:d,deleteCount:p,data:c}}return{id:r,type:"delta",deltas:D}}e.decodeSemanticTokensDto=F}),define(ye[108],Ce([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ye[109],Ce([0,1,108]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,E=t*60,A=E*24,k=A*7,T=A*30,S=A*365;function R(C,n){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,s.localize)(0,null,R(new Date().getTime()+m*1e3,!1));if(m<30)return(0,s.localize)(1,null);let r;return m<t?(r=m,n?r===1?(0,s.localize)(2,null,r):(0,s.localize)(3,null,r):r===1?(0,s.localize)(4,null,r):(0,s.localize)(5,null,r)):m<E?(r=Math.floor(m/t),n?r===1?(0,s.localize)(6,null,r):(0,s.localize)(7,null,r):r===1?(0,s.localize)(8,null,r):(0,s.localize)(9,null,r)):m<A?(r=Math.floor(m/E),n?r===1?(0,s.localize)(10,null,r):(0,s.localize)(11,null,r):r===1?(0,s.localize)(12,null,r):(0,s.localize)(13,null,r)):m<k?(r=Math.floor(m/A),n?r===1?(0,s.localize)(14,null,r):(0,s.localize)(15,null,r):r===1?(0,s.localize)(16,null,r):(0,s.localize)(17,null,r)):m<T?(r=Math.floor(m/k),n?r===1?(0,s.localize)(18,null,r):(0,s.localize)(19,null,r):r===1?(0,s.localize)(20,null,r):(0,s.localize)(21,null,r)):m<S?(r=Math.floor(m/T),n?r===1?(0,s.localize)(22,null,r):(0,s.localize)(23,null,r):r===1?(0,s.localize)(24,null,r):(0,s.localize)(25,null,r)):(r=Math.floor(m/S),n?r===1?(0,s.localize)(26,null,r):(0,s.localize)(27,null,r):r===1?(0,s.localize)(28,null,r):(0,s.localize)(29,null,r))}e.fromNow=R;function F(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(ye[110],Ce([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ye[43],Ce([0,1,16,11,110]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(R,F){return F&&(R.stack||R.stacktrace)?E.localize(0,null,T(R),k(R.stack)||k(R.stacktrace)):T(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function T(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?E.localize(1,null,R.message):R.message||E.localize(2,null)}function S(R=null,F=!1){if(!R)return E.localize(3,null);if(Array.isArray(R)){const C=s.coalesce(R),n=S(C[0],F);return C.length>1?E.localize(4,null,n,C.length):n}if(t.isString(R))return R;if(R.detail){const C=R.detail;if(C.error)return A(C.error,F);if(C.exception)return A(C.exception,F)}return R.stack?A(R,F):R.message?R.message:E.localize(5,null)}e.toErrorMessage=S}),define(ye[111],Ce([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ye[112],Ce([0,1,111,23,113,16,26]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=S;class R{constructor(){this._values=[]}_read(Q){return this._values[Q]}get(Q){return this._values[Q]}_write(Q,de){this._values[Q]=de}}e.ValidatedEditorOptions=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class C{constructor(Q,de,Ne,qe){this.id=Q,this.name=de,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,de){return m(Q,de)}compute(Q,de,Ne){return Ne}}class n{constructor(Q,de){this.newValue=Q,this.didChange=de}}e.ApplyUpdateResult=n;function m(V,Q){if(typeof V!="object"||typeof Q!="object"||!V||!Q)return new n(Q,V!==Q);if(Array.isArray(V)||Array.isArray(Q)){const Ne=Array.isArray(V)&&Array.isArray(Q)&&A.equals(V,Q);return new n(Q,Ne)}let de=!1;for(let Ne in Q)if(Q.hasOwnProperty(Ne)){const qe=m(V[Ne],Q[Ne]);qe.didChange&&(V[Ne]=qe.newValue,de=!0)}return new n(V,de)}class r{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,de){return m(Q,de)}validate(Q){return this.defaultValue}}class g{constructor(Q,de,Ne,qe){this.id=Q,this.name=de,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,de){return m(Q,de)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,de,Ne){return Ne}}function l(V,Q){return typeof V=="undefined"?Q:V==="false"?!1:Boolean(V)}e.boolean=l;class D extends g{constructor(Q,de,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ne);super(Q,de,Ne,qe)}validate(Q){return l(Q,this.defaultValue)}}function w(V,Q,de,Ne){if(typeof V=="undefined")return Q;let qe=parseInt(V,10);return isNaN(qe)?Q:(qe=Math.max(de,qe),qe=Math.min(Ne,qe),qe|0)}e.clampedInt=w;class d extends g{constructor(Q,de,Ne,qe,ot,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ne,Ye.minimum=qe,Ye.maximum=ot);super(Q,de,Ne,Ye);this.minimum=qe,this.maximum=ot}static clampedInt(Q,de,Ne,qe){return w(Q,de,Ne,qe)}validate(Q){return d.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class p extends g{constructor(Q,de,Ne,qe,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne);super(Q,de,Ne,ot);this.validationFn=qe}static clamp(Q,de,Ne){return Q<de?de:Q>Ne?Ne:Q}static float(Q,de){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return de;const Ne=parseFloat(Q);return isNaN(Ne)?de:Ne}validate(Q){return this.validationFn(p.float(Q,this.defaultValue))}}class I extends g{static string(Q,de){return typeof Q!="string"?de:Q}constructor(Q,de,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ne);super(Q,de,Ne,qe)}validate(Q){return I.string(Q,this.defaultValue)}}function c(V,Q,de){return typeof V!="string"||de.indexOf(V)===-1?Q:V}e.stringSet=c;class M extends g{constructor(Q,de,Ne,qe,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=qe,ot.default=Ne);super(Q,de,Ne,ot);this._allowedValues=qe}validate(Q){return c(Q,this.defaultValue,this._allowedValues)}}class o extends C{constructor(Q,de,Ne,qe,ot,Ye,yt=void 0){typeof yt!="undefined"&&(yt.type="string",yt.enum=ot,yt.default=qe);super(Q,de,Ne,yt);this._allowedValues=ot,this._convert=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,de,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class u extends C{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertSpace:l(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var h;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(h=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function b(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(V){switch(V){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function _(V){switch(V){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class P extends r{constructor(){super(127)}compute(Q,de,Ne){const qe=["monaco-editor"];return de.get(33)&&qe.push(de.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),de.get(65)==="default"?qe.push("mouse-default"):de.get(65)==="copy"&&qe.push("mouse-copy"),de.get(99)&&qe.push("showUnused"),de.get(125)&&qe.push("showDeprecated"),qe.join(" ")}}class N extends D{constructor(){super(32,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Q,de,Ne){return Ne&&Q.emptySelectionClipboard}}class $ extends C{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:s.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:s.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{cursorMoveOnType:l(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":c(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":c(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(de.loop,this.defaultValue.loop)}}}class y extends C{constructor(){super(44,"fontLigatures",y.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?y.OFF:Q==="true"?y.ON:Q:Boolean(Q)?y.ON:y.OFF}}e.EditorFontLigatures=y,y.OFF='"liga" off, "calt" off',y.ON='"liga" on, "calt" on';class L extends r{constructor(){super(43)}compute(Q,de,Ne){return Q.fontInfo}}class z extends g{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Q){let de=p.float(Q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(de,6,100)}compute(Q,de,Ne){return Q.fontInfo.fontSize}}class x extends C{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(d.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class B extends C{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:s.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{multiple:c(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??c(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??c(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??c(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??c(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??c(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends C{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:s.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:l(de.enabled,this.defaultValue.enabled),delay:d.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:l(de.sticky,this.defaultValue.sticky),above:l(de.above,this.defaultValue.above)}}}var ue;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(ue=e.RenderMinimap||(e.RenderMinimap={}));class K extends r{constructor(){super(130)}compute(Q,de,Ne){return K.computeLayout(de,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const de=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?de-1:0,qe=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Ne,desiredRatio:qe,minimapLineCount:ot}}static _computeMinimapLayout(Q,de){const Ne=Q.outerWidth,qe=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const Ye=de.stableMinimapLayoutInput,yt=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,Ae=Q.lineHeight,De=Q.typicalHalfwidthCharacterWidth,ve=Q.scrollBeyondLastLine,re=Q.minimap.renderCharacters;let oe=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const he=Q.minimap.maxColumn,me=Q.minimap.size,Te=Q.minimap.side,We=Q.verticalScrollbarWidth,Le=Q.viewLineCount,Ke=Q.remainingWidth,it=Q.isViewportWrapping,rt=re?2:3;let ie=Math.floor(ot*qe);const ge=ie/ot;let ee=!1,W=!1,we=rt*oe,Pe=oe/ot,Qe=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:_t,desiredRatio:Lt,minimapLineCount:It}=K.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:ve,height:qe,lineHeight:Ae,pixelRatio:ot});if(Le/It>1)ee=!0,W=!0,oe=1,we=1,Pe=oe/ot;else{let At=!1,Et=oe+1;if(me==="fit"){const Ot=Math.ceil((Le+_t)*we);it&&yt&&Ke<=de.stableFitRemainingWidth?(At=!0,Et=de.stableFitMaxMinimapScale):At=Ot>ie}if(me==="fill"||At){ee=!0;const Ot=oe;we=Math.min(Ae*ot,Math.max(1,Math.floor(1/Lt))),it&&yt&&Ke<=de.stableFitRemainingWidth&&(Et=de.stableFitMaxMinimapScale),oe=Math.min(Et,Math.max(1,Math.floor(we/rt))),oe>Ot&&(Qe=Math.min(2,oe/Ot)),Pe=oe/ot/Qe,ie=Math.ceil(Math.max(gt,Le+_t)*we),it?(de.stableMinimapLayoutInput=Q,de.stableFitRemainingWidth=Ke,de.stableFitMaxMinimapScale=oe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Ue=Math.floor(he*Pe),ut=Math.min(Ue,Math.max(0,Math.floor((Ke-We-2)*Pe/(De+Pe)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(ot*ut);const St=vt/ot;vt=Math.floor(vt*Qe);const wt=re?1:2,ht=Te==="left"?0:Ne-ut-We;return{renderMinimap:wt,minimapLeft:ht,minimapWidth:ut,minimapHeightIsEditorHeight:ee,minimapIsSampling:W,minimapScale:oe,minimapLineHeight:we,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:ie,minimapCanvasOuterWidth:St,minimapCanvasOuterHeight:ge}}static computeLayout(Q,de){const Ne=de.outerWidth|0,qe=de.outerHeight|0,ot=de.lineHeight|0,Ye=de.lineNumbersDigitCount|0,yt=de.typicalHalfwidthCharacterWidth,Ae=de.maxDigitWidth,De=de.pixelRatio,ve=de.viewLineCount,re=Q.get(122),oe=re==="inherit"?Q.get(121):re,he=oe==="inherit"?Q.get(117):oe,me=Q.get(120),Te=Q.get(2),We=de.isDominatedByLongLines,Le=Q.get(49),Ke=Q.get(59).renderType!==0,it=Q.get(60),rt=Q.get(93),ie=Q.get(64),ge=Q.get(91),ee=ge.verticalScrollbarSize,W=ge.verticalHasArrows,we=ge.arrowSize,Pe=ge.horizontalScrollbarSize,Qe=Q.get(57),Ue=Q.get(37);let ut;if(typeof Qe=="string"&&/^\d+(\.\d+)?ch$/.test(Qe)){const $t=parseFloat(Qe.substr(0,Qe.length-2));ut=d.clampedInt($t*yt,0,0,1e3)}else ut=d.clampedInt(Qe,0,0,1e3);Ue&&(ut+=16);let vt=0;if(Ke){const $t=Math.max(Ye,it);vt=Math.round($t*Ae)}let St=0;Le&&(St=ot);let wt=0,ht=wt+St,gt=ht+vt,_t=gt+ut;const Lt=Ne-St-vt-ut;let It=!1,Pt=!1,At=-1;Te!==2&&(oe==="inherit"&&We?(It=!0,Pt=!0):he==="on"||he==="bounded"?Pt=!0:he==="wordWrapColumn"&&(At=me));const Et=K._computeMinimapLayout({outerWidth:Ne,outerHeight:qe,lineHeight:ot,typicalHalfwidthCharacterWidth:yt,pixelRatio:De,scrollBeyondLastLine:rt,minimap:ie,verticalScrollbarWidth:ee,viewLineCount:ve,remainingWidth:Lt,isViewportWrapping:Pt},de.memory||new F);Et.renderMinimap!==0&&Et.minimapLeft===0&&(wt+=Et.minimapWidth,ht+=Et.minimapWidth,gt+=Et.minimapWidth,_t+=Et.minimapWidth);const Ot=Lt-Et.minimapWidth,Nt=Math.max(1,Math.floor((Ot-ee-2)/yt)),bt=W?we:0;return Pt&&(At=Math.max(1,Nt),he==="bounded"&&(At=Math.min(At,me))),{width:Ne,height:qe,glyphMarginLeft:wt,glyphMarginWidth:St,lineNumbersLeft:ht,lineNumbersWidth:vt,decorationsLeft:gt,decorationsWidth:ut,contentLeft:_t,contentWidth:Ot,minimap:Et,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Pt,wrappingColumn:At,verticalScrollbarWidth:ee,horizontalScrollbarHeight:Pe,overviewRuler:{top:bt,width:ee,height:qe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=K;class ne extends C{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:s.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:l(Q.enabled,this.defaultValue.enabled)}}}class pe extends C{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:s.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:s.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:l(de.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(de.fontFamily,this.defaultValue.fontFamily)}}}class be extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>p.clamp(Q,0,150),{markdownDescription:s.localize(47,null)})}compute(Q,de,Ne){return Q.fontInfo.lineHeight}}class ae extends C{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:s.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(49,null),s.localize(50,null),s.localize(51,null)],default:Q.size,description:s.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:s.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:s.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:s.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:s.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:l(de.enabled,this.defaultValue.enabled),size:c(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(de.side,this.defaultValue.side,["right","left"]),showSlider:c(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(de.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(de.scale,1,1,3),maxColumn:d.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(V){return V==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends C{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{top:d.clampedInt(de.top,0,0,1e3),bottom:d.clampedInt(de.bottom,0,0,1e3)}}}class Ee extends C{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:s.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:l(de.enabled,this.defaultValue.enabled),cycle:l(de.cycle,this.defaultValue.cycle)}}}class Fe extends r{constructor(){super(128)}compute(Q,de,Ne){return Q.pixelRatio}}class $e extends C{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:s.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:s.localize(63,null)},other:{type:"boolean",default:Q.other,description:s.localize(64,null)}}}],default:Q,description:s.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const de=Q,Ne={other:l(de.other,this.defaultValue.other),comments:l(de.comments,this.defaultValue.comments),strings:l(de.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Ve;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class je extends C{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(66,null),s.localize(67,null),s.localize(68,null),s.localize(69,null)],default:"on",description:s.localize(70,null)})}validate(Q){let de=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(de=4,Ne=Q):Q==="interval"?de=3:Q==="relative"?de=2:Q==="on"?de=1:de=0),{renderType:de,renderFn:Ne}}}function H(V){const Q=V.get(86);return Q==="editable"?V.get(80):Q!=="on"}e.filterValidationDecorations=H;class G extends C{constructor(){const Q=[],de={type:"number",description:s.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(72,null),format:"color-hex"}}}]},default:Q,description:s.localize(73,null)})}validate(Q){if(Array.isArray(Q)){let de=[];for(let Ne of Q)if(typeof Ne=="number")de.push({column:d.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const qe=Ne;de.push({column:d.clampedInt(qe.column,0,0,1e4),color:qe.color})}return de.sort((Ne,qe)=>Ne.column-qe.column),de}return this.defaultValue}}function X(V,Q){if(typeof V!="string")return Q;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class se extends C{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null)],default:"auto",description:s.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"auto",description:s.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:s.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:s.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:s.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q,Ne=d.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=d.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:X(de.vertical,this.defaultValue.vertical),horizontal:X(de.horizontal,this.defaultValue.horizontal),useShadows:l(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:d.clampedInt(de.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:d.clampedInt(de.verticalSliderSize,qe,0,1e3),scrollByPage:l(de.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends C{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:s.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:s.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:s.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:s.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:s.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:s.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:s.localize(91,null)}})}applyUpdate(Q,de){let Ne=!1;de.allowedCharacters&&(k.equals(Q.allowedCharacters,de.allowedCharacters)||(Q={...Q,allowedCharacters:de.allowedCharacters},Ne=!0)),de.allowedLocales&&(k.equals(Q.allowedLocales,de.allowedLocales)||(Q={...Q,allowedLocales:de.allowedLocales},Ne=!0));const qe=super.applyUpdate(Q,de);return Ne?new n(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{nonBasicASCII:xe(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:xe(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:xe(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,de){if(typeof Q!="object"||!Q)return de;const Ne={};for(const[qe,ot]of Object.entries(Q))ot===!0&&(Ne[qe]=!0);return Ne}}class te extends C{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:s.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:l(de.enabled,this.defaultValue.enabled),mode:c(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class fe extends C{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:s.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:l(Q.enabled,this.defaultValue.enabled)}}}class Re extends C{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:Q.bracketPairs,description:s.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(98,null),s.localize(99,null),s.localize(100,null)],default:Q.bracketPairsHorizontal,description:s.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:s.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:s.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:s.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{bracketPairs:xe(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:xe(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:l(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function xe(V,Q,de){const Ne=de.indexOf(V);return Ne===-1?Q:de[Ne]}class ze extends C{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(105,null),s.localize(106,null)],default:Q.insertMode,description:s.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:s.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:s.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:s.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:s.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:s.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:s.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:s.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:s.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertMode:c(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(de.showIcons,this.defaultValue.showIcons),showStatusBar:l(de.showStatusBar,this.defaultValue.showStatusBar),preview:l(de.preview,this.defaultValue.preview),previewMode:c(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(de.showMethods,this.defaultValue.showMethods),showFunctions:l(de.showFunctions,this.defaultValue.showFunctions),showConstructors:l(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(de.showDeprecated,this.defaultValue.showDeprecated),showFields:l(de.showFields,this.defaultValue.showFields),showVariables:l(de.showVariables,this.defaultValue.showVariables),showClasses:l(de.showClasses,this.defaultValue.showClasses),showStructs:l(de.showStructs,this.defaultValue.showStructs),showInterfaces:l(de.showInterfaces,this.defaultValue.showInterfaces),showModules:l(de.showModules,this.defaultValue.showModules),showProperties:l(de.showProperties,this.defaultValue.showProperties),showEvents:l(de.showEvents,this.defaultValue.showEvents),showOperators:l(de.showOperators,this.defaultValue.showOperators),showUnits:l(de.showUnits,this.defaultValue.showUnits),showValues:l(de.showValues,this.defaultValue.showValues),showConstants:l(de.showConstants,this.defaultValue.showConstants),showEnums:l(de.showEnums,this.defaultValue.showEnums),showEnumMembers:l(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(de.showKeywords,this.defaultValue.showKeywords),showWords:l(de.showWords,this.defaultValue.showWords),showColors:l(de.showColors,this.defaultValue.showColors),showFiles:l(de.showFiles,this.defaultValue.showFiles),showReferences:l(de.showReferences,this.defaultValue.showReferences),showFolders:l(de.showFolders,this.defaultValue.showFolders),showTypeParameters:l(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(de.showSnippets,this.defaultValue.showSnippets),showUsers:l(de.showUsers,this.defaultValue.showUsers),showIssues:l(de.showIssues,this.defaultValue.showIssues)}}}class Xe extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class et extends r{constructor(){super(129)}compute(Q,de,Ne){return de.get(80)?!0:Q.tabFocusMode}}var st;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(st=e.WrappingIndent||(e.WrappingIndent={}));function Je(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class nt extends r{constructor(){super(131)}compute(Q,de,Ne){const qe=de.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const lt="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?pt:t.isLinux?Ft:lt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Oe(V){return e.editorOptionsRegistry[V.id]=V,V}var Mt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(Mt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new D(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(148,null)})),acceptSuggestionOnEnter:Oe(new M(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(149,null),""],markdownDescription:s.localize(150,null)})),accessibilitySupport:Oe(new f),accessibilityPageSize:Oe(new d(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(151,null)})),ariaLabel:Oe(new I(4,"ariaLabel",s.localize(152,null))),autoClosingBrackets:Oe(new M(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(153,null),s.localize(154,null),""],description:s.localize(155,null)})),autoClosingDelete:Oe(new M(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(156,null),""],description:s.localize(157,null)})),autoClosingOvertype:Oe(new M(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(158,null),""],description:s.localize(159,null)})),autoClosingQuotes:Oe(new M(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(160,null),s.localize(161,null),""],description:s.localize(162,null)})),autoIndent:Oe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[s.localize(163,null),s.localize(164,null),s.localize(165,null),s.localize(166,null),s.localize(167,null)],description:s.localize(168,null)})),automaticLayout:Oe(new D(10,"automaticLayout",!1)),autoSurround:Oe(new M(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(169,null),s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),bracketPairColorization:Oe(new fe),bracketPairGuides:Oe(new Re),stickyTabStops:Oe(new D(103,"stickyTabStops",!1,{description:s.localize(173,null)})),codeLens:Oe(new D(14,"codeLens",!0,{description:s.localize(174,null)})),codeLensFontFamily:Oe(new I(15,"codeLensFontFamily","",{description:s.localize(175,null)})),codeLensFontSize:Oe(new d(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(176,null)})),colorDecorators:Oe(new D(17,"colorDecorators",!0,{description:s.localize(177,null)})),columnSelection:Oe(new D(18,"columnSelection",!1,{description:s.localize(178,null)})),comments:Oe(new u),contextmenu:Oe(new D(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new D(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(179,null)})),cursorBlinking:Oe(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(180,null)})),cursorSmoothCaretAnimation:Oe(new D(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(181,null)})),cursorStyle:Oe(new o(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],_,{description:s.localize(182,null)})),cursorSurroundingLines:Oe(new d(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(183,null)})),cursorSurroundingLinesStyle:Oe(new M(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(184,null),s.localize(185,null)],description:s.localize(186,null)})),cursorWidth:Oe(new d(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(187,null)})),disableLayerHinting:Oe(new D(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new D(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new D(30,"domReadOnly",!1)),dragAndDrop:Oe(new D(31,"dragAndDrop",!0,{description:s.localize(188,null)})),emptySelectionClipboard:Oe(new N),extraEditorClassName:Oe(new I(33,"extraEditorClassName","")),fastScrollSensitivity:Oe(new p(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:s.localize(189,null)})),find:Oe(new $),fixedOverflowWidgets:Oe(new D(36,"fixedOverflowWidgets",!1)),folding:Oe(new D(37,"folding",!0,{description:s.localize(190,null)})),foldingStrategy:Oe(new M(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(191,null),s.localize(192,null)],description:s.localize(193,null)})),foldingHighlight:Oe(new D(39,"foldingHighlight",!0,{description:s.localize(194,null)})),foldingImportsByDefault:Oe(new D(40,"foldingImportsByDefault",!1,{description:s.localize(195,null)})),unfoldOnClickAfterEndOfLine:Oe(new D(41,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(196,null)})),fontFamily:Oe(new I(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(197,null)})),fontInfo:Oe(new L),fontLigatures2:Oe(new y),fontSize:Oe(new z),fontWeight:Oe(new x),formatOnPaste:Oe(new D(47,"formatOnPaste",!1,{description:s.localize(198,null)})),formatOnType:Oe(new D(48,"formatOnType",!1,{description:s.localize(199,null)})),glyphMargin:Oe(new D(49,"glyphMargin",!0,{description:s.localize(200,null)})),gotoLocation:Oe(new B),hideCursorInOverviewRuler:Oe(new D(51,"hideCursorInOverviewRuler",!1,{description:s.localize(201,null)})),hover:Oe(new j),inDiffEditor:Oe(new D(53,"inDiffEditor",!1)),letterSpacing:Oe(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>p.clamp(V,-5,20),{description:s.localize(202,null)})),lightbulb:Oe(new ne),lineDecorationsWidth:Oe(new g(57,"lineDecorationsWidth",10)),lineHeight:Oe(new be),lineNumbers:Oe(new je),lineNumbersMinChars:Oe(new d(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new D(61,"linkedEditing",!1,{description:s.localize(203,null)})),links:Oe(new D(62,"links",!0,{description:s.localize(204,null)})),matchBrackets:Oe(new M(63,"matchBrackets","always",["always","near","never"],{description:s.localize(205,null)})),minimap:Oe(new ae),mouseStyle:Oe(new M(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new p(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:s.localize(206,null)})),mouseWheelZoom:Oe(new D(67,"mouseWheelZoom",!1,{markdownDescription:s.localize(207,null)})),multiCursorMergeOverlapping:Oe(new D(68,"multiCursorMergeOverlapping",!0,{description:s.localize(208,null)})),multiCursorModifier:Oe(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[s.localize(209,null),s.localize(210,null)],markdownDescription:s.localize(211,null)})),multiCursorPaste:Oe(new M(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(212,null),s.localize(213,null)],markdownDescription:s.localize(214,null)})),occurrencesHighlight:Oe(new D(71,"occurrencesHighlight",!0,{description:s.localize(215,null)})),overviewRulerBorder:Oe(new D(72,"overviewRulerBorder",!0,{description:s.localize(216,null)})),overviewRulerLanes:Oe(new d(73,"overviewRulerLanes",3,0,3)),padding:Oe(new Se),parameterHints:Oe(new Ee),peekWidgetDefaultFocus:Oe(new M(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(217,null),s.localize(218,null)],description:s.localize(219,null)})),definitionLinkOpensInPeek:Oe(new D(77,"definitionLinkOpensInPeek",!1,{description:s.localize(220,null)})),quickSuggestions:Oe(new $e),quickSuggestionsDelay:Oe(new d(79,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(221,null)})),readOnly:Oe(new D(80,"readOnly",!1)),renameOnType:Oe(new D(81,"renameOnType",!1,{description:s.localize(222,null),markdownDeprecationMessage:s.localize(223,null)})),renderControlCharacters:Oe(new D(82,"renderControlCharacters",!0,{description:s.localize(224,null),restricted:!0})),renderFinalNewline:Oe(new D(83,"renderFinalNewline",!0,{description:s.localize(225,null)})),renderLineHighlight:Oe(new M(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(226,null)],description:s.localize(227,null)})),renderLineHighlightOnlyWhenFocus:Oe(new D(85,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(228,null)})),renderValidationDecorations:Oe(new M(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new M(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(229,null),s.localize(230,null),s.localize(231,null),""],description:s.localize(232,null)})),revealHorizontalRightPadding:Oe(new d(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new D(89,"roundedSelection",!0,{description:s.localize(233,null)})),rulers:Oe(new G),scrollbar:Oe(new se),scrollBeyondLastColumn:Oe(new d(92,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(234,null)})),scrollBeyondLastLine:Oe(new D(93,"scrollBeyondLastLine",!0,{description:s.localize(235,null)})),scrollPredominantAxis:Oe(new D(94,"scrollPredominantAxis",!0,{description:s.localize(236,null)})),selectionClipboard:Oe(new D(95,"selectionClipboard",!0,{description:s.localize(237,null),included:t.isLinux})),selectionHighlight:Oe(new D(96,"selectionHighlight",!0,{description:s.localize(238,null)})),selectOnLineNumbers:Oe(new D(97,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new M(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(239,null),s.localize(240,null)],description:s.localize(241,null)})),showUnused:Oe(new D(99,"showUnused",!0,{description:s.localize(242,null)})),showDeprecated:Oe(new D(125,"showDeprecated",!0,{description:s.localize(243,null)})),inlayHints:Oe(new pe),snippetSuggestions:Oe(new M(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(244,null),s.localize(245,null),s.localize(246,null),s.localize(247,null)],description:s.localize(248,null)})),smartSelect:Oe(new Xe),smoothScrolling:Oe(new D(102,"smoothScrolling",!1,{description:s.localize(249,null)})),stopRenderingLineAfter:Oe(new d(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new ze),inlineSuggest:Oe(new te),suggestFontSize:Oe(new d(106,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(250,null)})),suggestLineHeight:Oe(new d(107,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(251,null)})),suggestOnTriggerCharacters:Oe(new D(108,"suggestOnTriggerCharacters",!0,{description:s.localize(252,null)})),suggestSelection:Oe(new M(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(253,null),s.localize(254,null),s.localize(255,null)],description:s.localize(256,null)})),tabCompletion:Oe(new M(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),tabIndex:Oe(new d(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new q),unusualLineTerminators:Oe(new M(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(261,null),s.localize(262,null),s.localize(263,null)],description:s.localize(264,null)})),useShadowDOM:Oe(new D(114,"useShadowDOM",!0)),useTabStops:Oe(new D(115,"useTabStops",!0,{description:s.localize(265,null)})),wordSeparators:Oe(new I(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:s.localize(266,null)})),wordWrap:Oe(new M(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(267,null),s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),wordWrapBreakAfterCharacters:Oe(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new d(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(272,null)})),wordWrapOverride1:Oe(new M(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new M(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Je,{enumDescriptions:[s.localize(273,null),s.localize(274,null),s.localize(275,null),s.localize(276,null)],description:s.localize(277,null)})),wrappingStrategy:Oe(new M(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(278,null),s.localize(279,null)],description:s.localize(280,null)})),editorClassName:Oe(new P),pixelRatio:Oe(new Fe),tabFocusMode:Oe(new et),layoutInfo:Oe(new K),wrappingInfo:Oe(new nt)}}),define(ye[114],Ce([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[115],Ce([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[116],Ce([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ye[117],Ce([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ye[118],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[119],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[120],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[121],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[122],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[123],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[124],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[125],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(ye[126],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[127],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ye[128],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[129],Ce([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[130],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var s;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var E;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ye[131],Ce([0,1,115]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||t.test(n)}e.isValidVersionStr=A;function k(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(t);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=k;function T(n){if(!n)return null;let m=n.majorBase,r=n.majorMustEqual,g=n.minorBase,l=n.minorMustEqual,D=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(m===0||(l=!1),w=!1);let d=0;if(n.preRelease){const p=E.exec(n.preRelease);if(p){const[,I,c,M]=p;d=Date.UTC(Number(I),Number(c)-1,Number(M))}}return{majorBase:m,majorMustEqual:r,minorBase:g,minorMustEqual:l,patchBase:D,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:d}}e.normalizeVersion=T;function S(n,m,r){let g;typeof n=="string"?g=T(k(n)):g=n;let l;m instanceof Date?l=m.getTime():typeof m=="string"&&(l=new Date(m).getTime());let D;if(typeof r=="string"?D=T(k(r)):D=r,!g||!D)return!1;let w=g.majorBase,d=g.minorBase,p=g.patchBase,I=D.majorBase,c=D.minorBase,M=D.patchBase,o=D.notBefore,i=D.majorMustEqual,f=D.minorMustEqual,u=D.patchMustEqual;return D.isMinimum?w>I?!0:w<I?!1:d>c?!0:d<c||l&&l<o?!1:p>=M:(w===1&&I===0&&(!i||!f||!u)&&(I=1,c=0,M=0,i=!0,f=!1,u=!1),w<I?!1:w>I?!i:d<c?!1:d>c?!f:p<M?!1:p>M?!u:!(l&&l<o))}e.isValidVersion=S;function R(n,m,r,g){return r.isBuiltin||typeof r.main=="undefined"?!0:C(n,m,r.engines.vscode,g)}e.isValidExtensionVersion=R;function F(n,m,r){return n==="*"||C(m,r,n)}e.isEngineValid=F;function C(n,m,r,g=[]){let l=T(k(r));if(!l)return g.push(s.localize(0,null,r)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return g.push(s.localize(1,null,r)),!1}else if(!l.majorMustEqual)return g.push(s.localize(2,null,r)),!1;return S(n,m,l)?!0:(g.push(s.localize(3,null,n,r)),!1)}}),define(ye[80],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(E,A=[],k=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=s}),define(ye[56],Ce([0,1,80]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function E(k,T,S){T instanceof s.SyncDescriptor||(T=new s.SyncDescriptor(T,[],S)),t.push([k,T])}e.registerSingleton=E;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ye[132],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=s;class t{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let k of this._nodes.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(k);T.outgoing.set(this._hashFn(k),S),S.incoming.set(this._hashFn(A),T)}removeNode(A){const k=this._hashFn(A);this._nodes.delete(k);for(let T of this._nodes.values())T.outgoing.delete(k),T.incoming.delete(k)}lookupOrInsertNode(A){const k=this._hashFn(A);let T=this._nodes.get(k);return T||(T=new s(A),this._nodes.set(k,T)),T}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[k,T]of this._nodes)A.push(`${k}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,k]of this._nodes){const T=new Set([A]),S=this._findCycle(k,T);if(S)return S}}_findCycle(A,k){for(let[T,S]of A.outgoing){if(k.has(T))return[...k,T].join(" -> ");k.add(T);const R=this._findCycle(S,k);if(R)return R;k.delete(T)}}}e.Graph=t}),define(ye[3],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=T})(s=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function t(k,T,S,R){T[s.DI_TARGET]===T?T[s.DI_DEPENDENCIES].push({id:k,index:S,optional:R}):(T[s.DI_DEPENDENCIES]=[{id:k,index:S,optional:R}],T[s.DI_TARGET]=T)}function E(k){if(s.serviceIds.has(k))return s.serviceIds.get(k);const T=function(S,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,F,!1)};return T.toString=()=>k,s.serviceIds.set(k,T),T}e.createDecorator=E;function A(k){return k}e.refineServiceDecorator=A}),define(ye[133],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,s.createDecorator)("modelService");function t(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ye[134],Ce([0,1,4,57,6,21,75,55,133]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function R(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(R):!!g.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new s.Emitter}get onDidChange(){return this._onDidChange.event}register(l,D){let w={selector:l,provider:D,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(w){let d=this._entries.indexOf(w);d>=0&&(this._entries.splice(d,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(l){return this.all(l).length>0}all(l){if(!l)return[];this._updateScores(l);const D=[];for(let w of this._entries)w._score>0&&D.push(w.provider);return D}ordered(l){const D=[];return this._orderedForEach(l,w=>D.push(w.provider)),D}orderedGroups(l){const D=[];let w,d;return this._orderedForEach(l,p=>{w&&d===p._score?w.push(p.provider):(d=p._score,w=[p.provider],D.push(w))}),D}_orderedForEach(l,D){if(!!l){this._updateScores(l);for(const w of this._entries)w._score>0&&D(w)}}_updateScores(l){let D={uri:l.uri.toString(),language:l.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let w of this._entries)if(w._score=(0,T.score)(w.selector,l.uri,l.getLanguageId(),(0,S.shouldSynchronizeModel)(l)),R(w.selector)&&w._score>0){for(let d of this._entries)d._score=0;w._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(l,D){return l._score<D._score?1:l._score>D._score?-1:l._time<D._time?1:l._time>D._time?-1:0}}e.LanguageFeatureRegistry=F;const C=new WeakMap;let n=0;function m(g){let l=C.get(g);return l===void 0&&(l=++n,C.set(g,l)),l}class r{constructor(l,D,w=Number.MAX_SAFE_INTEGER){this._registry=l,this.min=D,this.max=w,this._cache=new A.LRUCache(50,.7)}_key(l){return l.id+this._registry.all(l).reduce((D,w)=>(0,t.doHash)(m(w),D),0)}_clamp(l){return l===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(l*1.3)))}get(l){const D=this._key(l),w=this._cache.get(D);return this._clamp(w?.value)}update(l,D){const w=this._key(l);let d=this._cache.get(w);return d||(d=new k.MovingAverage,this._cache.set(w,d)),d.update(D),this.get(l)}}e.LanguageFeatureRequestDelays=r}),define(ye[58],Ce([0,1,2,59,134,107,51]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var S;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(S=e.FontStyle||(e.FontStyle={}));var R;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var F;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var C;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=1024]="ITALIC_MASK",a[a.BOLD_MASK=2048]="BOLD_MASK",a[a.UNDERLINE_MASK=4096]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(C=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&768)>>>8}static getFontStyle(_){return(_&15360)>>>10}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let P=this.getForeground(_),N="mtk"+P,$=this.getFontStyle(_);return $&1&&(N+=" mtki"),$&2&&(N+=" mtkb"),$&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(_,P){const N=this.getForeground(_),$=this.getFontStyle(_);let y=`color: ${P[N]};`;return $&1&&(y+="font-style: italic;"),$&2&&(y+="font-weight: bold;"),$&4&&(y+="text-decoration: underline;"),y}}e.TokenMetadata=n;var m;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={}));var r;(function(a){const _=new Map;_.set(0,k.Codicon.symbolMethod),_.set(1,k.Codicon.symbolFunction),_.set(2,k.Codicon.symbolConstructor),_.set(3,k.Codicon.symbolField),_.set(4,k.Codicon.symbolVariable),_.set(5,k.Codicon.symbolClass),_.set(6,k.Codicon.symbolStruct),_.set(7,k.Codicon.symbolInterface),_.set(8,k.Codicon.symbolModule),_.set(9,k.Codicon.symbolProperty),_.set(10,k.Codicon.symbolEvent),_.set(11,k.Codicon.symbolOperator),_.set(12,k.Codicon.symbolUnit),_.set(13,k.Codicon.symbolValue),_.set(15,k.Codicon.symbolEnum),_.set(14,k.Codicon.symbolConstant),_.set(15,k.Codicon.symbolEnum),_.set(16,k.Codicon.symbolEnumMember),_.set(17,k.Codicon.symbolKeyword),_.set(27,k.Codicon.symbolSnippet),_.set(18,k.Codicon.symbolText),_.set(19,k.Codicon.symbolColor),_.set(20,k.Codicon.symbolFile),_.set(21,k.Codicon.symbolReference),_.set(22,k.Codicon.symbolCustomColor),_.set(23,k.Codicon.symbolFolder),_.set(24,k.Codicon.symbolTypeParameter),_.set(25,k.Codicon.account),_.set(26,k.Codicon.issues);function P(y){let L=_.get(y);return L||(console.info("No codicon found for CompletionItemKind "+y),L=k.Codicon.symbolProperty),L}a.toIcon=P;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function $(y,L){let z=N.get(y);return typeof z=="undefined"&&!L&&(z=9),z}a.fromString=$})(r=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(a){a[a.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var l;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(l=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var I;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(a){return a&&s.URI.isUri(a.uri)&&t.Range.isIRange(a.range)&&(t.Range.isIRange(a.originSelectionRange)||t.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=c;var M;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var o;(function(a){a[a.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var i;(function(a){const _=new Map;_.set(0,k.Codicon.symbolFile),_.set(1,k.Codicon.symbolModule),_.set(2,k.Codicon.symbolNamespace),_.set(3,k.Codicon.symbolPackage),_.set(4,k.Codicon.symbolClass),_.set(5,k.Codicon.symbolMethod),_.set(6,k.Codicon.symbolProperty),_.set(7,k.Codicon.symbolField),_.set(8,k.Codicon.symbolConstructor),_.set(9,k.Codicon.symbolEnum),_.set(10,k.Codicon.symbolInterface),_.set(11,k.Codicon.symbolFunction),_.set(12,k.Codicon.symbolVariable),_.set(13,k.Codicon.symbolConstant),_.set(14,k.Codicon.symbolString),_.set(15,k.Codicon.symbolNumber),_.set(16,k.Codicon.symbolBoolean),_.set(17,k.Codicon.symbolArray),_.set(18,k.Codicon.symbolObject),_.set(19,k.Codicon.symbolKey),_.set(20,k.Codicon.symbolNull),_.set(21,k.Codicon.symbolEnumMember),_.set(22,k.Codicon.symbolStruct),_.set(23,k.Codicon.symbolEvent),_.set(24,k.Codicon.symbolOperator),_.set(25,k.Codicon.symbolTypeParameter);function P(N){let $=_.get(N);return $||(console.info("No codicon found for SymbolKind "+N),$=k.Codicon.symbolProperty),$}a.toIcon=P})(i=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(_){this.value=_}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var u;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var b;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var v;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[81],Ce([0,1,11,2,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationOverrides=A;function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||s.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var T;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function R(l,D){const w=Object.create(null);for(let d in l)F(w,d,l[d],D);return w}e.toValuesTree=R;function F(l,D,w,d){const p=D.split("."),I=p.pop();let c=l;for(let M=0;M<p.length;M++){let o=p[M],i=c[o];switch(typeof i){case"undefined":i=c[o]=Object.create(null);break;case"object":break;default:d(`Ignoring ${D} as ${p.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}c=i}if(typeof c=="object"&&c!==null)try{c[I]=w}catch{d(`Ignoring ${D} as ${p.join(".")} is ${JSON.stringify(c)}`)}else d(`Ignoring ${D} as ${p.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=F;function C(l,D){const w=D.split(".");n(l,w)}e.removeFromValueTree=C;function n(l,D){const w=D.shift();if(D.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const d=l[w];typeof d=="object"&&!Array.isArray(d)&&(n(d,D),Object.keys(d).length===0&&delete l[w])}}function m(l,D,w){function d(c,M){let o=c;for(const i of M){if(typeof o!="object"||o===null)return;o=o[i]}return o}const p=D.split("."),I=d(l,p);return typeof I=="undefined"?w:I}e.getConfigurationValue=m;function r(l,D,w){Object.keys(D).forEach(d=>{d!=="__proto__"&&(d in l?s.isObject(l[d])&&s.isObject(D[d])?r(l[d],D[d],w):w&&(l[d]=D[d]):l[d]=D[d])})}e.merge=r;function g(l,D,w){const d=l.inspect(D),p=l.inspect(w);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:d.defaultValue}e.getMigratedSettingValue=g}),define(ye[44],Ce([0,1,23,9,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=s.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",s.isMacintosh),k.set("isLinux",s.isLinux),k.set("isWindows",s.isWindows),k.set("isWeb",s.isWeb),k.set("isMacNative",s.isMacintosh&&!s.isWeb),k.set("isEdge",A.indexOf("Edg/")>=0),k.set("isFirefox",A.indexOf("Firefox")>=0),k.set("isChrome",A.indexOf("Chrome")>=0),k.set("isSafari",A.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var S;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class R{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(y){return r.create(y)}static equals(y,L){return g.create(y,L)}static notEquals(y,L){return w.create(y,L)}static regex(y,L){return i.create(y,L)}static in(y,L){return l.create(y,L)}static not(y){return d.create(y)}static and(...y){return h.create(y,null)}static or(...y){return b.create(y,null,!0)}static greater(y,L){return I.create(y,L)}static greaterEquals(y,L){return c.create(y,L)}static smaller(y,L){return M.create(y,L)}static smallerEquals(y,L){return o.create(y,L)}static deserialize(y,L=!1){if(!!y)return this._deserializeOrExpression(y,L)}static _deserializeOrExpression(y,L){let z=y.split("||");return b.create(z.map(x=>this._deserializeAndExpression(x,L)),null,!0)}static _deserializeAndExpression(y,L){let z=y.split("&&");return h.create(z.map(x=>this._deserializeOne(x,L)),null)}static _deserializeOne(y,L){if(y=y.trim(),y.indexOf("!=")>=0){let z=y.split("!=");return w.create(z[0].trim(),this._deserializeValue(z[1],L))}if(y.indexOf("==")>=0){let z=y.split("==");return g.create(z[0].trim(),this._deserializeValue(z[1],L))}if(y.indexOf("=~")>=0){let z=y.split("=~");return i.create(z[0].trim(),this._deserializeRegexValue(z[1],L))}if(y.indexOf(" in ")>=0){let z=y.split(" in ");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const z=y.split(">=");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const z=y.split(">");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const z=y.split("<=");return o.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const z=y.split("<");return M.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(y)?d.create(y.substr(1).trim()):r.create(y)}static _deserializeValue(y,L){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let z=/^'([^']*)'$/.exec(y);return z?z[1].trim():y}static _deserializeRegexValue(y,L){if((0,t.isFalsyOrWhitespace)(y)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=y.indexOf("/"),x=y.lastIndexOf("/");if(z===x||z<0){if(L)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let B=y.slice(z+1,x),j=y[x+1]==="i"?"i":"";try{return new RegExp(B,j)}catch(ue){if(L)throw new Error(`bad regexp-value '${y}', parse error: ${ue}`);return console.warn(`bad regexp-value '${y}', parse error: ${ue}`),null}}}e.ContextKeyExpr=R;function F($,y){const L=$?$.substituteConstants():void 0,z=y?y.substituteConstants():void 0;return!L&&!z?!0:!L||!z?!1:L.equals(z)}e.expressionsAreEqualWithConstantSubstitution=F;function C($,y){return $.cmp(y)}class n{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class r{constructor(y,L){this.key=y,this.negated=L,this.type=2}static create(y,L=null){const z=k.get(y);return typeof z=="boolean"?z?m.INSTANCE:n.INSTANCE:new r(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:a(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=k.get(this.key);return typeof y=="boolean"?y?m.INSTANCE:n.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=r;class g{constructor(y,L,z){this.key=y,this.value=L,this.negated=z,this.type=4}static create(y,L,z=null){if(typeof L=="boolean")return L?r.create(y,z):d.create(y,z);const x=k.get(y);return typeof x=="boolean"?L===(x?"true":"false")?m.INSTANCE:n.INSTANCE:new g(y,L,z)}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=k.get(this.key);if(typeof y=="boolean"){const L=y?"true":"false";return this.value===L?m.INSTANCE:n.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class l{constructor(y,L){this.key=y,this.valueKey=L,this.type=10,this.negated=null}static create(y,L){return new l(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const L=y.getValue(this.valueKey),z=y.getValue(this.key);return Array.isArray(L)?L.indexOf(z)>=0:typeof z=="string"&&typeof L=="object"&&L!==null?T.call(L,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=l;class D{constructor(y){this._actual=y,this.type=11}static create(y){return new D(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new D(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class w{constructor(y,L,z){this.key=y,this.value=L,this.negated=z,this.type=5}static create(y,L,z=null){if(typeof L=="boolean")return L?d.create(y,z):r.create(y,z);const x=k.get(y);return typeof x=="boolean"?L===(x?"true":"false")?n.INSTANCE:m.INSTANCE:new w(y,L,z)}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=k.get(this.key);if(typeof y=="boolean"){const L=y?"true":"false";return this.value===L?n.INSTANCE:m.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class d{constructor(y,L){this.key=y,this.negated=L,this.type=3}static create(y,L=null){const z=k.get(y);return typeof z=="boolean"?z?n.INSTANCE:m.INSTANCE:new d(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:a(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=k.get(this.key);return typeof y=="boolean"?y?n.INSTANCE:m.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=r.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=d;function p($,y){if(typeof $=="string"){const L=parseFloat($);isNaN(L)||($=L)}return typeof $=="string"||typeof $=="number"?y($):n.INSTANCE}class I{constructor(y,L,z){this.key=y,this.value=L,this.negated=z,this.type=12}static create(y,L,z=null){return p(L,x=>new I(y,x,z))}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=I;class c{constructor(y,L,z){this.key=y,this.value=L,this.negated=z,this.type=13}static create(y,L,z=null){return p(L,x=>new c(y,x,z))}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class M{constructor(y,L,z){this.key=y,this.value=L,this.negated=z,this.type=14}static create(y,L,z=null){return p(L,x=>new M(y,x,z))}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class o{constructor(y,L,z){this.key=y,this.value=L,this.negated=z,this.type=15}static create(y,L,z=null){return p(L,x=>new o(y,x,z))}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class i{constructor(y,L){this.key=y,this.regexp=L,this.type=7,this.negated=null}static create(y,L){return new i(y,L)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const L=this.regexp?this.regexp.source:"",z=y.regexp?y.regexp.source:"";return L<z?-1:L>z?1:0}equals(y){if(y.type===this.type){const L=this.regexp?this.regexp.source:"",z=y.regexp?y.regexp.source:"";return this.key===y.key&&L===z}return!1}substituteConstants(){return this}evaluate(y){let L=y.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class f{constructor(y){this._actual=y,this.type=8}static create(y){return new f(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new f(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=f;function u($){let y=null;for(let L=0,z=$.length;L<z;L++){const x=$[L].substituteConstants();if($[L]!==x&&y===null){y=[];for(let B=0;B<L;B++)y[B]=$[B]}y!==null&&(y[L]=x)}return y===null?$:y}class h{constructor(y,L){this.expr=y,this.negated=L,this.type=6}static create(y,L){return h._normalizeArr(y,L)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let L=0,z=this.expr.length;L<z;L++){const x=C(this.expr[L],y.expr[L]);if(x!==0)return x}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].equals(y.expr[L]))return!1;return!0}return!1}substituteConstants(){const y=u(this.expr);return y===this.expr?this:h.create(y,this.negated)}evaluate(y){for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].evaluate(y))return!1;return!0}static _normalizeArr(y,L){const z=[];let x=!1;for(const B of y)if(!!B){if(B.type===1){x=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){z.push(...B.expr);continue}z.push(B)}if(z.length===0&&x)return m.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(C);for(let B=1;B<z.length;B++)z[B-1].equals(z[B])&&(z.splice(B,1),B--);if(z.length===1)return z[0];for(;z.length>1;){const B=z[z.length-1];if(B.type!==9)break;z.pop();const j=z.pop(),ue=z.length===0,K=b.create(B.expr.map(ne=>h.create([ne,j],null)),null,ue);K&&(z.push(K),z.sort(C))}return z.length===1?z[0]:new h(z,L)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let L of this.expr)y.push(...L.keys());return y}map(y){return new h(this.expr.map(L=>L.map(y)),null)}negate(){if(!this.negated){const y=[];for(let L of this.expr)y.push(L.negate());this.negated=b.create(y,this,!0)}return this.negated}}class b{constructor(y,L){this.expr=y,this.negated=L,this.type=9}static create(y,L,z){return b._normalizeArr(y,L,z)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let L=0,z=this.expr.length;L<z;L++){const x=C(this.expr[L],y.expr[L]);if(x!==0)return x}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].equals(y.expr[L]))return!1;return!0}return!1}substituteConstants(){const y=u(this.expr);return y===this.expr?this:b.create(y,this.negated,!1)}evaluate(y){for(let L=0,z=this.expr.length;L<z;L++)if(this.expr[L].evaluate(y))return!0;return!1}static _normalizeArr(y,L,z){let x=[],B=!1;if(y){for(let j=0,ue=y.length;j<ue;j++){const K=y[j];if(!!K){if(K.type===0){B=!0;continue}if(K.type===1)return m.INSTANCE;if(K.type===9){x=x.concat(K.expr);continue}x.push(K)}}if(x.length===0&&B)return n.INSTANCE;x.sort(C)}if(x.length!==0){if(x.length===1)return x[0];for(let j=1;j<x.length;j++)x[j-1].equals(x[j])&&(x.splice(j,1),j--);if(x.length===1)return x[0];if(z){for(let j=0;j<x.length;j++)for(let ue=j+1;ue<x.length;ue++)P(x[j],x[ue])&&(x.splice(ue,1),ue--);if(x.length===1)return x[0]}return new b(x,L)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let L of this.expr)y.push(...L.keys());return y}map(y){return new b(this.expr.map(L=>L.map(y)),null)}negate(){if(!this.negated){let y=[];for(let L of this.expr)y.push(L.negate());for(;y.length>1;){const L=y.shift(),z=y.shift(),x=[];for(const j of N(L))for(const ue of N(z))x.push(h.create([j,ue],null));const B=y.length===0;y.unshift(b.create(x,null,B))}this.negated=y[0]}return this.negated}}class v extends r{constructor(y,L,z){super(y,null);this._defaultValue=L,typeof z=="object"?v._info.push({...z,key:y}):z!==!0&&v._info.push({key:y,description:z,type:L!=null?typeof L:void 0})}static all(){return v._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return g.create(this.key,y)}notEqualsTo(y){return w.create(this.key,y)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function a($,y){return $<y?-1:$>y?1:0}function _($,y,L,z){return $<L?-1:$>L?1:y<z?-1:y>z?1:0}function P($,y){if(y.type===6&&$.type!==9&&$.type!==6){for(const x of y.expr)if($.equals(x))return!0}const L=$.negate(),z=N(L).concat(N(y));z.sort(C);for(let x=0;x<z.length;x++){const j=z[x].negate();for(let ue=x+1;ue<z.length;ue++){const K=z[ue];if(j.equals(K))return!0}}return!1}e.implies=P;function N($){return $.type===9?$.expr:[$]}}),define(ye[135],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[45],Ce([0,1,21,17,9,11,2,116,3]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function R(x){return x.create===!0}e.isFileOpenForWriteOptions=R;var F;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var C;(function(x){x[x.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var n;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=m;function r(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=r;function g(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function l(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=l;function D(x){return m(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var w;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(B,j){super(B);this.code=j}}e.FileSystemProviderError=d;function p(x,B){const j=new d(x.toString(),B);return c(j,B),j}e.createFileSystemProviderError=p;function I(x){return x||p((0,T.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=I;function c(x,B){return x.name=B?`${B} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=c;function M(x){if(!x)return w.Unknown;if(x instanceof d)return x.code;const B=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!B)return w.Unknown;switch(B[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=M;function o(x){if(x instanceof v)return x.fileOperationResult;switch(M(x)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var i;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class f{constructor(B,j,ue){this.resource=B,this.operation=j,this.target=ue}isOperation(B){return this.operation===B}}e.FileOperationEvent=f;var u;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor(B,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ue=new Map;for(const K of B){const ne=ue.get(K.type);ne?ne.push([K.resource,K]):ue.set(K.type,[[K.resource,K]])}for(const[K,ne]of ue)switch(K){case 1:this.added=s.TernarySearchTree.forUris(()=>j),this.added.fill(ne);break;case 0:this.updated=s.TernarySearchTree.forUris(()=>j),this.updated.fill(ne);break;case 2:this.deleted=s.TernarySearchTree.forUris(()=>j),this.deleted.fill(ne);break}}contains(B,...j){return this.doContains(B,{includeChildren:!1},...j)}affects(B,...j){return this.doContains(B,{includeChildren:!0},...j)}doContains(B,j,...ue){if(!B)return!1;const K=ue.length>0;return!!((!K||ue.includes(1))&&(this.added?.get(B)||j.includeChildren&&this.added?.findSuperstr(B))||(!K||ue.includes(0))&&(this.updated?.get(B)||j.includeChildren&&this.updated?.findSuperstr(B))||(!K||ue.includes(2))&&(this.deleted?.findSubstr(B)||j.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function b(x,B,j){return!x||!B||x===B||B.length>x.length?!1:(B.charAt(B.length-1)!==t.sep&&(B+=t.sep),j?(0,E.startsWithIgnoreCase)(x,B):x.indexOf(B)===0)}e.isParent=b;class v extends Error{constructor(B,j,ue){super(B);this.fileOperationResult=j,this.options=ue}}e.FileOperationError=v;class a extends v{constructor(B,j,ue){super(B,2,ue);this.stat=j}}e.NotModifiedSinceFileOperationError=a;var _;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=N;async function $(x,B){if(!B.hasProvider(k.URI.from({scheme:x.scheme})))return new Promise(j=>{const ue=B.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===x.scheme&&K.added&&(ue.dispose(),j())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class y{static formatSize(B){return(0,A.isNumber)(B)||(B=0),B<y.KB?(0,T.localize)(1,null,B.toFixed(0)):B<y.MB?(0,T.localize)(2,null,(B/y.KB).toFixed(2)):B<y.GB?(0,T.localize)(3,null,(B/y.MB).toFixed(2)):B<y.TB?(0,T.localize)(4,null,(B/y.GB).toFixed(2)):(0,T.localize)(5,null,(B/y.TB).toFixed(2))}}e.ByteSize=y,y.KB=1024,y.MB=y.KB*y.KB,y.GB=y.MB*y.KB,y.TB=y.GB*y.KB;var L;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function z(x){return{maxFileSize:x===0?300*y.MB:16*y.GB,maxHeapSize:x===0?700*y.MB:2*700*y.MB}}e.getPlatformLimits=z}),define(ye[60],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...E){this._entries=new Map;for(let[A,k]of E)this.set(A,k)}set(E,A){const k=this._entries.get(E);return this._entries.set(E,A),k}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=s}),define(ye[136],Ce([0,1,14,15,80,132,3,60]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class R extends Error{constructor(r){super("cyclic dependency between services");this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class F{constructor(r=new T.ServiceCollection,g=!1,l){this._activeInstantiations=new Set,this._services=r,this._strict=g,this._parent=l,this._services.set(k.IInstantiationService,this)}createChild(r){return new F(r,this._strict,this)}invokeFunction(r,...g){let l=n.traceInvocation(r),D=!1;try{return r({get:d=>{if(D)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(d,l);if(!p)throw new Error(`[invokeFunction] unknown service '${d}'`);return p}},...g)}finally{D=!0,l.stop()}}createInstance(r,...g){let l,D;return r instanceof E.SyncDescriptor?(l=n.traceCreation(r.ctor),D=this._createInstance(r.ctor,r.staticArguments.concat(g),l)):(l=n.traceCreation(r),D=this._createInstance(r,g,l)),l.stop(),D}_createInstance(r,g=[],l){let D=k._util.getServiceDependencies(r).sort((p,I)=>p.index-I.index),w=[];for(const p of D){let I=this._getOrCreateServiceInstance(p.id,l);if(!I&&this._strict&&!p.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${p.id}.`);w.push(I)}let d=D.length>0?D[0].index:g.length;if(g.length!==d){console.warn(`[createInstance] First service dependency of ${r.name} at position ${d+1} conflicts with ${g.length} static arguments`);let p=d-g.length;p>0?g=g.concat(new Array(p)):g=g.slice(0,d)}return new r(...[...g,...w])}_setServiceInstance(r,g){if(this._services.get(r)instanceof E.SyncDescriptor)this._services.set(r,g);else if(this._parent)this._parent._setServiceInstance(r,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let g=this._services.get(r);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):g}_getOrCreateServiceInstance(r,g){let l=this._getServiceInstanceOrDescriptor(r);return l instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,l,g.branch(r,!0)):(g.branch(r,!1),l)}_safeCreateAndCacheServiceInstance(r,g,l){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,g,l)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,g,l){const D=new A.Graph(p=>p.id.toString());let w=0;const d=[{id:r,desc:g,_trace:l}];for(;d.length;){const p=d.pop();if(D.lookupOrInsertNode(p),w++>1e3)throw new R(D);for(let I of k._util.getServiceDependencies(p.desc.ctor)){let c=this._getServiceInstanceOrDescriptor(I.id);if(!c&&!I.optional&&console.warn(`[createInstance] ${r} depends on ${I.id} which is NOT registered.`),c instanceof E.SyncDescriptor){const M={id:I.id,desc:c,_trace:p._trace.branch(I.id,!0)};D.insertEdge(p,M),d.push(M)}}}for(;;){const p=D.roots();if(p.length===0){if(!D.isEmpty())throw new R(D);break}for(const{data:I}of p){if(this._getServiceInstanceOrDescriptor(I.id)instanceof E.SyncDescriptor){const M=this._createServiceInstanceWithOwner(I.id,I.desc.ctor,I.desc.staticArguments,I.desc.supportsDelayedInstantiation,I._trace);this._setServiceInstance(I.id,M)}D.removeNode(I)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,g,l=[],D,w){if(this._services.get(r)instanceof E.SyncDescriptor)return this._createServiceInstance(g,l,D,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,g,l,D,w);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(r,g=[],l,D){if(l){const w=new s.IdleValue(()=>this._createInstance(r,g,D));return new Proxy(Object.create(null),{get(d,p){if(p in d)return d[p];let I=w.value,c=I[p];return typeof c!="function"||(c=c.bind(I),d[p]=c),c},set(d,p,I){return w.value[p]=I,!0}})}else return this._createInstance(r,g,D)}}e.InstantiationService=F;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class n{constructor(r,g){this.type=r,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new n(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(r){return S?new n(0,r.name):n._None}branch(r,g){let l=new n(2,r.toString());return this._dep.push([r,g,l]),l}stop(){let r=Date.now()-this._start;n._totals+=r;let g=!1;function l(w,d){let p=[],I=new Array(w+1).join("	");for(const[c,M,o]of d._dep)if(M&&o){g=!0,p.push(`${I}CREATES -> ${c}`);let i=l(w+1,o);i&&p.push(i)}else p.push(`${I}uses -> ${c}`);return p.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(r>2||g)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(ye[12],Ce([0,1,43,4,6,23,3]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function T(){return new Date().toISOString()}var S;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function R(M,o,i){switch(o){case S.Trace:M.trace(i);break;case S.Debug:M.debug(i);break;case S.Info:M.info(i);break;case S.Warning:M.warn(i);break;case S.Error:M.error(i);break;case S.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=R;function F(M){let o="";for(let i=0;i<M.length;i++){let f=M[i];if(typeof f=="object")try{f=JSON.stringify(f)}catch{}o+=(i>0?" ":"")+f}return o}e.format=F;class C extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,F([o,...i]))}debug(o,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,F([o,...i]))}info(o,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,F([o,...i]))}warn(o,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,F([o,...i]))}error(o,...i){if(this.checkLogLevel(S.Error))if(o instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=o.stack,this.log(S.Error,F(f))}else this.log(S.Error,F([o,...i]))}critical(o,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,F([o,...i]))}flush(){}}e.AbstractMessageLogger=n;class m extends C{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!A.isWindows}trace(o,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,o,...i):console.log(`[main ${T()}]`,o,...i))}debug(o,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,o,...i):console.log(`[main ${T()}]`,o,...i))}info(o,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,o,...i):console.log(`[main ${T()}]`,o,...i))}warn(o,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,o,...i):console.warn(`[main ${T()}]`,o,...i))}error(o,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,o,...i):console.error(`[main ${T()}]`,o,...i))}critical(o,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,o,...i):console.error(`[main ${T()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class r extends C{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=r;class g extends C{constructor(o,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,s.toErrorMessage)(o,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class l extends C{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const f of this.logServices)f.trace(o,...i)}debug(o,...i){for(const f of this.logServices)f.debug(o,...i)}info(o,...i){for(const f of this.logServices)f.info(o,...i)}warn(o,...i){for(const f of this.logServices)f.warn(o,...i)}error(o,...i){for(const f of this.logServices)f.error(o,...i)}critical(o,...i){for(const f of this.logServices)f.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=l;class D extends E.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=D;class w extends E.Disposable{constructor(o,i){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(f=>{this.logLevel=f,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(f))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let f=this.loggers.get(o.toString());return f||(f=this.doCreateLogger(o,i?.always?S.Trace:this.logLevel,i),this.loggers.set(o.toString(),f),i?.always||this.logLevelChangeableLoggers.push(f)),f}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return S.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=d;function p(M){if(M.verbose)return S.Trace;if(typeof M.logLevel=="string"){const o=I(M.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function I(M){switch(M){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=I;function c(M){switch(M){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(ye[82],Ce([0,1,34,117,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var k;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function R(r,g){return g-r}S.compare=R;const F=Object.create(null);F[S.Error]=(0,t.localize)(0,null),F[S.Warning]=(0,t.localize)(1,null),F[S.Info]=(0,t.localize)(2,null);function C(r){return F[r]||""}S.toString=C;function n(r){switch(r){case s.default.Error:return S.Error;case s.default.Warning:return S.Warning;case s.default.Info:return S.Info;case s.default.Ignore:return S.Hint}}S.fromSeverity=n;function m(r){switch(r){case S.Error:return s.default.Error;case S.Warning:return s.default.Warning;case S.Info:return s.default.Info;case S.Hint:return s.default.Ignore}}S.toSeverity=m}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const R="";function F(n){return C(n,!0)}S.makeKey=F;function C(n,m){let r=[R];return n.source?r.push(n.source.replace("\xA6","\\\xA6")):r.push(R),n.code?typeof n.code=="string"?r.push(n.code.replace("\xA6","\\\xA6")):r.push(n.code.value.replace("\xA6","\\\xA6")):r.push(R),n.severity!==void 0&&n.severity!==null?r.push(k.toString(n.severity)):r.push(R),n.message&&m?r.push(n.message.replace("\xA6","\\\xA6")):r.push(R),n.startLineNumber!==void 0&&n.startLineNumber!==null?r.push(n.startLineNumber.toString()):r.push(R),n.startColumn!==void 0&&n.startColumn!==null?r.push(n.startColumn.toString()):r.push(R),n.endLineNumber!==void 0&&n.endLineNumber!==null?r.push(n.endLineNumber.toString()):r.push(R),n.endColumn!==void 0&&n.endColumn!==null?r.push(n.endColumn.toString()):r.push(R),r.push(R),r.join("\xA6")}S.makeKeyOptionalMessage=C})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ye[137],Ce([0,1,4,34,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=S}),define(ye[138],Ce([0,1,6,9,2,3]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function k(S,R){return E.URI.isUri(S)?(0,t.equalsIgnoreCase)(S.scheme,R):(0,t.startsWithIgnoreCase)(S,R+":")}e.matchesScheme=k;function T(S,...R){return R.some(F=>k(S,F))}e.matchesSomeScheme=T});var Be=this&&this.__decorate||function(Z,e,s,t){var E=arguments.length,A=E<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,s):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Z,e,s,t);else for(var T=Z.length-1;T>=0;T--)(k=Z[T])&&(A=(E<3?k(A):E>3?k(e,s,A):k(e,s))||A);return E>3&&A&&Object.defineProperty(e,s,A),A},He=this&&this.__param||function(Z,e){return function(s,t){e(s,t,Z)}};define(ye[139],Ce([0,1,14,20,6,3]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var k;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends E.Disposable{constructor(C,n){super();this.deferred=new s.DeferredPromise,n.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};S=Be([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class R extends E.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(C){this.stop();const n=++this.currentOperationId,m=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ye[36],Ce([0,1,41,11]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(k,T){s.ok(t.isString(k)),s.ok(t.isObject(T)),s.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,T)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new E}),define(ye[140],Ce([0,1,4,36]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,R){this.schemasById[E(S)]=R,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new A;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ye[83],Ce([0,1,16,4,11,114,140,36]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=T.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(I,c=!0){this.registerConfigurations([I],c)}registerConfigurations(I,c=!0){const M=this.doRegisterConfigurations(I,c);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(I){const c=this.doDeregisterConfigurations(I);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:I,remove:c}){const M=[];M.push(...this.doDeregisterConfigurations(c)),M.push(...this.doRegisterConfigurations(I,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(M)})}registerDefaultConfigurations(I){const c=[],M=[];for(const{overrides:o,source:i}of I)for(const f in o)if(c.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const u={...this.configurationDefaultsOverrides.get(f)?.value||{},...o[f]};this.configurationDefaultsOverrides.set(f,{source:i,value:u});const h={type:"object",default:u,description:A.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:E.isString(i)?void 0:i};M.push(...r(f)),this.configurationProperties[f]=h,this.defaultLanguageConfigurationOverridesNode.properties[f]=h}else{this.configurationDefaultsOverrides.set(f,{value:o[f],source:i});const u=this.configurationProperties[f];u&&(this.updatePropertyDefaultValue(f,u),this.updateSchema(f,u))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(I){const c=[];for(const{overrides:M,source:o}of I)for(const i in M){const f=this.configurationDefaultsOverrides.get(i),u=E.isString(o)?o:o?.id,h=E.isString(f?.source)?f?.source:f?.source?.id;if(u===h)if(c.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const b=this.configurationProperties[i];b&&(this.updatePropertyDefaultValue(i,b),this.updateSchema(i,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const c of I)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(I,c){const M=[];return I.forEach(o=>{M.push(...this.validateAndRegisterProperties(o,c,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),M}doDeregisterConfigurations(I){const c=[],M=o=>{if(o.properties)for(const i in o.properties)c.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>M(i))};for(const o of I){M(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}return c}validateAndRegisterProperties(I,c=!0,M,o,i=3){i=E.isUndefinedOrNull(I.scope)?i:I.scope;let f=[],u=I.properties;if(u)for(let b in u){if(c&&w(b)){delete u[b];continue}const v=u[b];if(v.source=M,v.defaultDefaultValue=u[b].default,this.updatePropertyDefaultValue(b,v),e.OVERRIDE_PROPERTY_REGEX.test(b)?v.scope=void 0:(v.scope=E.isUndefinedOrNull(v.scope)?i:v.scope,v.restricted=E.isUndefinedOrNull(v.restricted)?!!o?.includes(b):v.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.excludedConfigurationProperties[b]=u[b],delete u[b];continue}else this.configurationProperties[b]=u[b];!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),f.push(b)}let h=I.allOf;if(h)for(let b of h)f.push(...this.validateAndRegisterProperties(b,c,M,o,i));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(I){const c=M=>{let o=M.properties;if(o)for(const f in o)this.updateSchema(f,o[f]);let i=M.allOf;i&&i.forEach(c)};c(I)}updateSchema(I,c){switch(e.allSettings.properties[I]=c,c.scope){case 1:e.applicationSettings.properties[I]=c;break;case 2:e.machineSettings.properties[I]=c;break;case 6:e.machineOverridableSettings.properties[I]=c;break;case 3:e.windowSettings.properties[I]=c;break;case 4:e.resourceSettings.properties[I]=c;break;case 5:e.resourceSettings.properties[I]=c,this.resourceLanguageSettingsSchema.properties[I]=c;break}}removeFromSchema(I,c){switch(delete e.allSettings.properties[I],c.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I],delete this.resourceLanguageSettingsSchema.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const c=`[${I}]`,M={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,M),e.allSettings.properties[c]=M,e.applicationSettings.properties[c]=M,e.machineSettings.properties[c]=M,e.machineOverridableSettings.properties[c]=M,e.windowSettings.properties[c]=M,e.resourceSettings.properties[c]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const I={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,c){const M=this.configurationDefaultsOverrides.get(I);let o=M?.value,i=M?.source;E.isUndefined(o)&&(o=c.defaultDefaultValue,i=void 0),E.isUndefined(o)&&(o=l(c.type)),c.default=o,c.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",m=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(p){const I=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let c=m.exec(p);for(;c?.length;){const M=c[1].trim();M&&I.push(M),c=m.exec(p)}}return(0,s.distinct)(I)}e.overrideIdentifiersFromKey=r;function g(p){return p.reduce((I,c)=>`${I}[${c}]`,"")}e.keyFromOverrideIdentifiers=g;function l(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const D=new C;T.Registry.add(e.Extensions.Configuration,D);function w(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):D.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):null:A.localize(6,null)}e.validateProperty=w;function d(){const p=[],I=D.getConfigurationProperties();for(const c of Object.keys(I))p.push([c,I[c].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=d}),define(ye[141],Ce([0,1,16,4,100,6,21,26,11,2,81,83,36]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(o={},i=[],f=[]){this._contents=o,this._keys=i,this._overrides=f,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,F.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,i){const f=this.getContentsForOverrideIdentifer(i);return f?o?(0,F.getConfigurationValue)(f,o):f:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const f of this.overrides)f.identifiers.includes(o)&&i.push(...f.keys);return s.distinct(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return s.distinct(o)}override(o){let i=this.overrideConfigurations.get(o);return i||(i=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,i)),i}merge(...o){const i=T.deepClone(this.contents),f=T.deepClone(this.overrides),u=[...this.keys];for(const h of o){this.mergeContents(i,h.contents);for(const b of h.overrides){const[v]=f.filter(a=>s.equals(a.identifiers,b.identifiers));v?(this.mergeContents(v.contents,b.contents),v.keys.push(...b.keys),v.keys=s.distinct(v.keys)):f.push(T.deepClone(b))}for(const b of h.keys)u.indexOf(b)===-1&&u.push(b)}return new m(i,u,f)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const i=this.getContentsForOverrideIdentifer(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let f={};for(const u of s.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[u],b=i[u];b&&(typeof h=="object"&&typeof b=="object"?(h=T.deepClone(h),this.mergeContents(h,b)):h=b),f[u]=h}return new m(f,this.keys,this.overrides)}mergeContents(o,i){for(const f of Object.keys(i)){if(f in o&&S.isObject(o[f])&&S.isObject(i[f])){this.mergeContents(o[f],i[f]);continue}o[f]=T.deepClone(i[f])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?T.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let i=null,f=null;const u=h=>{h&&(f?this.mergeContents(f,h):f=T.deepClone(h))};for(const h of this.overrides)s.equals(h.identifiers,[o])?i=h.contents:h.identifiers.includes(o)&&u(h.contents);return u(i),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,i){this.addKey(o),(0,F.addToValueTree)(this.contents,o,i,f=>{throw new Error(f)})}removeValue(o){this.removeKey(o)&&(0,F.removeFromValueTree)(this.contents,o)}addKey(o){let i=this.keys.length;for(let f=0;f<i;f++)o.indexOf(this.keys[f])===0&&(i=f);this.keys.splice(i,1,o)}removeKey(o){let i=this.keys.indexOf(o);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class r extends m{constructor(o={}){const i=n.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(i),u=Object.create(null),h=[];for(const b in i){const v=o[b],a=v!==void 0?v:i[b].default;(0,F.addToValueTree)(u,b,a,_=>console.error(`Conflict in default settings: ${_}`))}for(const b of Object.keys(u))C.OVERRIDE_PROPERTY_REGEX.test(b)&&h.push({identifiers:(0,C.overrideIdentifiersFromKey)(b),keys:Object.keys(u[b]),contents:(0,F.toValuesTree)(u[b],v=>console.error(`Conflict in default settings file: ${v}`))});super(u,f,h)}}e.DefaultConfigurationModel=r;class g{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,i){if(!S.isUndefinedOrNull(o)){const f=this.doParseContent(o);this.parseRaw(f,i)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,i){this._raw=o;const{contents:f,keys:u,overrides:h,restricted:b}=this.doParseRaw(o,i);this._configurationModel=new m(f,u,h),this._restrictedConfigurations=b||[]}doParseContent(o){let i={},f=null,u=[],h=[],b=[];function v(_){Array.isArray(u)?u.push(_):f!==null&&(u[f]=_)}let a={onObjectBegin:()=>{let _={};v(_),h.push(u),u=_,f=null},onObjectProperty:_=>{f=_},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{let _=[];v(_),h.push(u),u=_,f=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:v,onError:(_,P,N)=>{b.push({error:_,offset:P,length:N})}};if(o)try{E.visit(o,a),i=u[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return i}doParseRaw(o,i){const f=n.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),u=this.filter(o,f,!0,i);o=u.raw;const h=(0,F.toValuesTree)(o,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),b=Object.keys(o),v=this.toOverrides(o,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:h,keys:b,overrides:v,restricted:u.restricted}}filter(o,i,f,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:o,restricted:[]};const h={},b=[];for(let v in o)if(C.OVERRIDE_PROPERTY_REGEX.test(v)&&f){const a=this.filter(o[v],i,!1,u);h[v]=a.raw,b.push(...a.restricted)}else{const a=i[v],_=a?typeof a.scope!="undefined"?a.scope:3:void 0;a?.restricted&&b.push(v),(_===void 0||u.scopes===void 0||u.scopes.includes(_))&&(u.skipRestricted&&a?.restricted||(h[v]=o[v]))}return{raw:h,restricted:b}}toOverrides(o,i){const f=[];for(const u of Object.keys(o))if(C.OVERRIDE_PROPERTY_REGEX.test(u)){const h={};for(const b in o[u])h[b]=o[u][b];f.push({identifiers:(0,C.overrideIdentifiersFromKey)(u),keys:Object.keys(h),contents:(0,F.toValuesTree)(h,i)})}return f}}e.ConfigurationModelParser=g;class l extends A.Disposable{constructor(o,i,f,u){super();this.userSettingsResource=o,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=l;class D{constructor(o,i,f=new m,u=new m,h=new k.ResourceMap,b=new m,v=new k.ResourceMap,a=!0){this._defaultConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=f,this._workspaceConfiguration=u,this._folderConfigurations=h,this._memoryConfiguration=b,this._memoryConfigurationByResource=v,this._freeze=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(o,i,f){return this.getConsolidateConfigurationModel(i,f).getValue(o)}updateValue(o,i,f={}){let u;f.resource?(u=this._memoryConfigurationByResource.get(f.resource),u||(u=new m,this._memoryConfigurationByResource.set(f.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(o):u.setValue(o,i),f.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,i,f){const u=this.getConsolidateConfigurationModel(i,f),h=this.getFolderConfigurationModelForResource(i.resource,f),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),a=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),_=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),P=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),N=f?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,$=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(o):h.freeze().getValue(o):void 0,y=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(o):b.getValue(o),L=u.getValue(o),z=s.distinct(s.flatten(u.overrides.map(x=>x.identifiers))).filter(x=>u.getOverrideValue(o,x)!==void 0);return{defaultValue:v,userValue:a,userLocalValue:_,userRemoteValue:P,workspaceValue:N,workspaceFolderValue:$,memoryValue:y,value:L,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,user:a!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userRemote:P!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:h?.freeze().getValue(o),override:i.overrideIdentifier?h?.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:b.getValue(o),override:i.overrideIdentifier?b.getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(o){const i=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,i){this._folderConfigurations.set(o,i),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const f=[];if(!i){const{added:u,updated:h,removed:b}=I(this._defaultConfiguration,o);i=[...u,...h,...b]}for(const u of i)for(const h of(0,C.overrideIdentifiersFromKey)(u)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(h),v=o.getKeysForOverrideIdentifier(h),a=[...v.filter(_=>b.indexOf(_)===-1),...b.filter(_=>v.indexOf(_)===-1),...b.filter(_=>!T.equals(this._defaultConfiguration.override(h).getValue(_),o.override(h).getValue(_)))];f.push([h,a])}return this.updateDefaultConfiguration(o),{keys:i,overrides:f}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:f,removed:u,overrides:h}=I(this.localUserConfiguration,o),b=[...i,...f,...u];return b.length&&this.updateLocalUserConfiguration(o),{keys:b,overrides:h}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:f,removed:u,overrides:h}=I(this.remoteUserConfiguration,o);let b=[...i,...f,...u];return b.length&&this.updateRemoteUserConfiguration(o),{keys:b,overrides:h}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:f,removed:u,overrides:h}=I(this.workspaceConfiguration,o);let b=[...i,...f,...u];return b.length&&this.updateWorkspaceConfiguration(o),{keys:b,overrides:h}}compareAndUpdateFolderConfiguration(o,i){const f=this.folderConfigurations.get(o),{added:u,updated:h,removed:b,overrides:v}=I(f,i);let a=[...u,...h,...b];return(a.length||!f)&&this.updateFolderConfiguration(o,i),{keys:a,overrides:v}}compareAndDeleteFolderConfiguration(o){const i=this.folderConfigurations.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:f,updated:u,removed:h,overrides:b}=I(i,void 0);return{keys:[...f,...u,...h],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,i){let f=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier?f.override(o.overrideIdentifier):f}getConsolidatedConfigurationModelForResource({resource:o},i){let f=this.getWorkspaceConsolidatedConfiguration();if(i&&o){const u=i.getFolder(o);u&&(f=this.getFolderConsolidatedConfiguration(u.uri)||f);const h=this._memoryConfigurationByResource.get(o);h&&(f=f.merge(h))}return f}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let i=this._foldersConsolidatedConfigurations.get(o);if(!i){const f=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(o);u?(i=f.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(o,i)):i=f}return i}getFolderConfigurationModelForResource(o,i){if(i&&o){const f=i.getFolder(o);if(f)return this._folderConfigurations.get(f.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,i)=>{const{contents:f,overrides:u,keys:h}=this._folderConfigurations.get(i);return o.push([i,{contents:f,overrides:u,keys:h}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>o.add(i)),this.userConfiguration.freeze().keys.forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(f=>o.add(f))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(f=>o.add(f))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(f=>i.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(f=>i.add(f)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(f=>i.add(f)),this._folderConfigurations.forEach(f=>f.getKeysForOverrideIdentifier(o).forEach(u=>i.add(u))),[...i.values()]}static parse(o){const i=this.parseConfigurationModel(o.defaults),f=this.parseConfigurationModel(o.user),u=this.parseConfigurationModel(o.workspace),h=o.folders.reduce((b,v)=>(b.set(R.URI.revive(v[0]),this.parseConfigurationModel(v[1])),b),new k.ResourceMap);return new D(i,f,new m,u,h,new m,new k.ResourceMap,!1)}static parseConfigurationModel(o){return new m(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=D;function w(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const o=new Set,i=new Map;for(const u of M)u.keys.forEach(h=>o.add(h)),u.overrides.forEach(([h,b])=>{const v=(0,k.getOrSet)(i,h,new Set);b.forEach(a=>v.add(a))});const f=[];return i.forEach((u,h)=>f.push([h,[...u.values()]])),{keys:[...o.values()],overrides:f}}e.mergeChanges=w;class d{constructor(o,i,f,u){this.change=o,this.previous=i,this.currentConfiguraiton=f,this.currentWorkspace=u,this._previousConfiguration=void 0;const h=new Set;o.keys.forEach(v=>h.add(v)),o.overrides.forEach(([,v])=>v.forEach(a=>h.add(a))),this.affectedKeys=[...h.values()];const b=new m;this.affectedKeys.forEach(v=>b.setValue(v,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(i){const f=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(o,i,this.currentWorkspace);return!T.equals(f,u)}return!0}return!1}doesAffectedKeysTreeContains(o,i){let f=(0,F.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof f=="object"&&(u=Object.keys(f)[0]);){if(o=o[u],!o)return!1;f=f[u]}return!0}}e.ConfigurationChangeEvent=d;class p extends d{constructor(o,i,f,u){super({keys:o.allKeys(),overrides:[]},void 0,o,i);this.source=f,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=p;function I(M,o){const{added:i,removed:f,updated:u}=c(o,M),h=[],b=M?.getAllOverrideIdentifiers()||[],v=o?.getAllOverrideIdentifiers()||[];if(o){const a=v.filter(_=>!b.includes(_));for(const _ of a)h.push([_,o.getKeysForOverrideIdentifier(_)])}if(M){const a=b.filter(_=>!v.includes(_));for(const _ of a)h.push([_,M.getKeysForOverrideIdentifier(_)])}if(o&&M){for(const a of b)if(v.includes(a)){const _=c({contents:M.getOverrideValue(void 0,a)||{},keys:M.getKeysForOverrideIdentifier(a)},{contents:o.getOverrideValue(void 0,a)||{},keys:o.getKeysForOverrideIdentifier(a)});h.push([a,[..._.added,..._.removed,..._.updated]])}}return{added:i,removed:f,updated:u,overrides:h}}function c(M,o){const i=M?o?M.keys.filter(h=>o.keys.indexOf(h)===-1):[...M.keys]:[],f=o?M?o.keys.filter(h=>M.keys.indexOf(h)===-1):[...o.keys]:[],u=[];if(M&&o){for(const h of o.keys)if(M.keys.indexOf(h)!==-1){const b=(0,F.getConfigurationValue)(o.contents,h),v=(0,F.getConfigurationValue)(M.contents,h);T.equals(b,v)||u.push(h)}}return{added:i,removed:f,updated:u}}}),define(ye[84],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var t;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(k,T=t.Unknown,S){super(k);this._message=k,this._code=T,this._detail=S,this.isHandled=T===t.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(k){return k instanceof E&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof E&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof E&&k.isHandled}}e.RemoteAuthorityResolverError=E}),define(ye[61],Ce([0,1,10]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(R){return R.scheme===s.Schemas.vscodeRemote?R.authority:void 0}e.getRemoteAuthority=t;function E(R){if(!R)return;const F=R.indexOf("+");return F<0?R:R.substr(0,F)}e.getRemoteName=E;function A(R){return R.scheme!==s.Schemas.file&&R.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=A;function k(R){if(R.folders.length)return R.folders.every(F=>A(F.uri))?R.folders[0].uri:void 0;if(R.configuration&&A(R.configuration))return R.configuration}e.getVirtualWorkspaceLocation=k;function T(R){return k(R)?.scheme}e.getVirtualWorkspaceScheme=T;function S(R){return k(R)!==void 0}e.isVirtualWorkspace=S}),define(ye[25],Ce([0,1,9,3,61]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class S{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,r){if(typeof m=="undefined"||m===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof m=="string"||typeof r=="string"){let g=typeof m=="string"?m:m.value,l=typeof r=="string"?r:r.value;return s.equalsIgnoreCase(g,l)}return m._lower===r._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=S;function R(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function C(n,m){if(m){const r=`onResolveRemoteAuthority:${(0,E.getRemoteName)(m)}`;return n.activationEvents?.indexOf(r)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[142],Ce([0,1,9,25]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(r,g){return r.uuid&&g.uuid?r.uuid===g.uuid:r.id===g.id?!0:(0,s.compareIgnoreCase)(r.id,g.id)===0}e.areSameExtensions=E;class A{constructor(g,l){this.version=l,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof A?E(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=A;function k(r,g){return`${r}.${g}`}e.getExtensionId=k;function T(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function S(r,g){return T(k(r,g))}e.getGalleryExtensionId=S;function R(r,g){const l=[],D=w=>{for(const d of l)if(d.some(p=>E(g(p),g(w))))return d;return null};for(const w of r){const d=D(w);d?d.push(w):l.push([w])}return l}e.groupByExtension=R;function F(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function C(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function n(r){const g=new Set;if(r.malicious)for(const l of r.malicious)g.add(l.id);return g}e.getMaliciousExtensionsSet=n;function m(r,g){const l=[],D=g.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const w=D.shift();if(w&&l.every(d=>!E(d.identifier,{id:w}))){const d=r.filter(p=>E(p.identifier,{id:w}));d.length===1&&(l.push(d[0]),D.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=m}),define(ye[143],Ce([0,1,4,23,3,12]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var k;(function(r){r.Http="http",r.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(r){return e.LOCALHOST_ADDRESSES.indexOf(r)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(r){return e.ALL_INTERFACES_ADDRESSES.indexOf(r)>=0}e.isAllInterfaces=C;function n(r,g){return g?g!==1&&r<1024:!t.isWindows&&r<1024}e.isPortPrivileged=n;let m=class{constructor(g){this.logService=g,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,l){return this._tunnelProvider=g,g?(this._canElevate=l.elevation,this._privacyOptions=l.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],l=Array.from(this._tunnels.values());for(let D of l){const w=Array.from(D.values());for(let d of w){const p=await d.value;p&&g.push(p)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:l}of g.values())await l.then(D=>D?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,l,D,w,d=!1,p=T.Private,I){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${D} on local port ${w}.`),!g)return;l||(l="localhost");const c=this.retainOrCreateTunnel(g,l,D,w,d,p,I);return c?c.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(M);return(M.tunnelRemoteHost!==l||M.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const l=this._tunnels.get(g.tunnelRemoteHost);if(l){const D=l.get(g.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,D))}}}}async tryDisposeTunnel(g,l,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${l}.`);const w=D.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(l),w}}async closeTunnel(g,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${l} `);const D=this._tunnels.get(g);if(D&&D.has(l)){const w=D.get(l);w.refcount=0,await this.tryDisposeTunnel(g,l,w)}}addTunnelToMap(g,l,D){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(l,{refcount:1,value:D})}async removeEmptyTunnelFromMap(g,l){const D=this._tunnels.get(g);D&&(await D.get(l)||D.delete(l),D.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,l){let D=[g];F(g)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):C(g)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const w=D.map(d=>this._tunnels.get(d));for(const d of w){const p=d?.get(l);if(p)return p}}canTunnel(g){return!!R(g)}createWithProvider(g,l,D,w,d,p,I){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${D} on local port ${w}.`);const M={elevationRequired:d?n(w===void 0?D:w):!1},o={remoteAddress:{host:l,port:D},localAddressPort:w,privacy:p,public:p!==T.Private,protocol:I},i=g.forwardPort(o,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(l,D,i),i}};m=Be([He(0,A.ILogService)],m),e.AbstractTunnelService=m}),define(ye[144],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,k=5){let T;return T=A(S=>{const R=typeof S=="string"?S:S.data;let F=this._terminalBufferMap.get(E);if(F){F.data.push(R);return}const C=setTimeout(()=>this.flushBuffer(E),k);F={data:[R],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(E),T.dispose()}},this._terminalBufferMap.set(E,F)}),T}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=s}),define(ye[145],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var s;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(s=e.ColorScheme||(e.ColorScheme={}))}),define(ye[62],Ce([0,1,51,4,6,3,36,145]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(l){function D(w){return w&&typeof w=="object"&&typeof w.id=="string"}l.isThemeColor=D})(S=e.ThemeColor||(e.ThemeColor={}));function R(l){return{id:l}}e.themeColorFromId=R;var F;(function(l){function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||S.isThemeColor(i.color))}l.isThemeIcon=D;const w=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const f=w.exec(i);if(!f)return;let[,u]=f;return{id:u}}l.fromString=d;function p(i){return{id:i}}l.fromId=p;function I(i,f){let u=i.id;const h=u.lastIndexOf("~");return h!==-1&&(u=u.substring(0,h)),f&&(u=`${u}~${f}`),{id:u}}l.modify=I;function c(i){const f=i.id.lastIndexOf("~");if(f!==-1)return i.id.substring(f+1)}l.getModifier=c;function M(i,f){return i.id===f.id&&i.color?.id===f.color?.id}l.isEqual=M;function o(i,f){return{id:i.id,color:f?R(f):void 0}}l.asThemeIcon=o,l.asClassNameArray=s.CSSIcon.asClassNameArray,l.asClassName=s.CSSIcon.asClassName,l.asCSSSelector=s.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function C(l){switch(l){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,E.toDisposable)(()=>{const w=this.themingParticipants.indexOf(D);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;k.Registry.add(e.Extensions.ThemingContribution,m);function r(l){return m.onColorThemeChange(l)}e.registerThemingParticipant=r;class g extends E.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,w){let d=this.theme.getColor(D);return d&&w&&(d=w(d,this.theme)),d?d.toString():null}}e.Themable=g}),define(ye[46],Ce([0,1,21,24,2,3]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function T(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=T;function S(n){const m=n;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=S;class R{constructor(m,r,g,l,D){this._id=m,this._transient=g,this._configuration=l,this._ignorePathCasing=D,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=R;class F{constructor(m,r){this.raw=r,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,t.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function C(n){return new F({uri:n,index:0,name:(0,t.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=C}),define(ye[63],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(ye[30],Ce([0,1,10,24,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(T=>{const S=this._providerInfo.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,S)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(ye[146],Ce([0,1,14]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,T,S){this._deferredPromises=new Map,this._id=k,this._shared=T,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const C of R.values())C.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,T){let S=this._value[k];return typeof S=="undefined"&&(S=T),S}update(k,T){this._value[k]=T;let S=this._deferredPromises.get(k);if(S!==void 0)return S.p;const R=new s.DeferredPromise;return this._deferredPromises.set(k,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class E extends t{constructor(k,T){super(k.identifier.value,!0,T);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=E}),define(ye[147],Ce([0,1,4,2,12]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(T,S){this._logService=T,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new s.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,S,R){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(T)).acceptModelChanged(S.value,R)}$acceptDirtyStateChanged(T,S){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(T)).acceptDirty(S)}$acceptModelSaved(T){const S=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(T));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,S);const R=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(T));R.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};A=Be([He(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(ye[13],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[148],Ce([0,1,25,4]),function(Z,e,s,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){E.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(T.identifier),Ze(this,E,S,"f"),Ie(this,E,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(T){return Ie(this,E,"f").get(this._id,T)}store(T,S){return Ie(this,E,"f").store(this._id,T,S)}delete(T){return Ie(this,E,"f").delete(this._id,T)}}e.ExtensionSecrets=A,E=new WeakMap}),define(ye[85],Ce([0,1,3,4]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(ye[47],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var s;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(s=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,E=(w,d)=>{const p={controllerId:d};return t.set(w,p),p};e.createPrivateApiFor=E;const A=w=>t.get(w);e.getPrivateApiFor=A;const k=(w,d,p,I)=>{let c=p;return{enumerable:!0,configurable:!1,get(){return c},set(M){if(!I(c,M)){const o=c;c=M,w.listener?.({op:3,key:d,value:M,previous:o})}}}},T=(w,d)=>w===d,S={range:(w,d)=>w===d?!0:!w||!d?!1:w.isEqual(d),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(w,d)=>!(w.length!==d.length||w.some(p=>!d.find(I=>p.id===I.id)))},R=Object.keys(S),F=(w,d)=>({range:k(w,"range",void 0,S.range),label:k(w,"label",d,S.label),description:k(w,"description",void 0,S.description),canResolveChildren:k(w,"canResolveChildren",!1,S.canResolveChildren),busy:k(w,"busy",!1,S.busy),error:k(w,"error",void 0,S.error),tags:k(w,"tags",[],S.tags)}),C=(w,d)=>{const p=new Map;for(const I of R)S[I](w[I],d[I])||p.set(I,d[I]);return p};e.diffTestItems=C;class n extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class r extends Error{constructor(d,p,I){super(`TestItem with ID "${d}" is from controller "${p}" and cannot be added as a child of an item from controller "${I}".`)}}e.MixedTestItemController=r;const g=w=>{const d=(0,e.getPrivateApiFor)(w);let p=new Map;return{get size(){return p.size},forEach(I,c){for(const M of p.values())I.call(c,M,this)},replace(I){const c=new Map,M=new Set(p.keys()),o={op:4,ops:[]};for(const i of I){if(!(i instanceof l))throw new m(i.id);const f=(0,e.getPrivateApiFor)(i).controllerId;if(f!==d.controllerId)throw new r(i.id,f,d.controllerId);if(c.has(i.id))throw new n(i.id);c.set(i.id,i),M.delete(i.id),o.ops.push({op:0,item:i})}for(const i of M.keys())o.ops.push({op:1,id:i});d.listener?.(o),p=c},add(I){if(!(I instanceof l))throw new m(I.id);p.set(I.id,I),d.listener?.({op:0,item:I})},delete(I){p.delete(I)&&d.listener?.({op:1,id:I})},get(I){return p.get(I)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class l{constructor(d,p,I,c){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const M=(0,e.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof D?void 0:M.parent}},children:{value:g(this),enumerable:!0,writable:!1},...F(M,I)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=l;class D extends l{constructor(d,p){super(d,d,p,void 0)}}e.TestItemRootImpl=D}),define(ye[64],Ce([0,1,3,143,4,13]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(S){function R(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:C.protocol}}S.fromApiTunnel=R;function F(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==t.TunnelPrivacyId.ConstantPrivate&&C.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}S.fromServiceTunnel=F})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let T=class{constructor(R){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,C,n,m){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Be([He(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[7],Ce([0,1,16,15,76,21,78,9,11,2,35,45,84]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n){"use strict";var m,r,g,l,D,w,d,p,I,c,M,o,i,f,u,h,b,v,a,_;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let N=D=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let J=O;return new D(function(){if(J){for(const _e of J)_e&&typeof _e.dispose=="function"&&_e.dispose();J=void 0}})}dispose(){typeof Ie(this,m,"f")=="function"&&(Ie(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,N=D=Be([P],N),e.Disposable=N;let $=w=class{constructor(O,J){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(J<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=J}static Min(...O){if(O.length===0)throw new TypeError;let J=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(J)&&(J=Ge)}return J}static Max(...O){if(O.length===0)throw new TypeError;let J=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(J)&&(J=Ge)}return J}static isPosition(O){if(!O)return!1;if(O instanceof w)return!0;let{line:J,character:_e}=O;return typeof J=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,J=0){if(O===null||J===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,J=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&J===0?this:new w(this.line+_e,this.character+J)}with(O,J=this.character){if(O===null||J===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,J=typeof O.character=="number"?O.character:this.character),_e===this.line&&J===this.character?this:new w(_e,J)}toJSON(){return{line:this.line,character:this.character}}};$=w=Be([P],$),e.Position=$;let y=d=class{constructor(O,J,_e,Ge){let tt,at;if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new $(O,J),at=new $(_e,Ge)):O instanceof $&&J instanceof $&&(tt=O,at=J),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof d?!0:O?$.isPosition(O.start)&&$.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof d?this.contains(O._start)&&this.contains(O._end):O instanceof $?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const J=$.Max(O.start,this._start),_e=$.Min(O.end,this._end);if(!J.isAfter(_e))return new d(J,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const J=$.Min(O.start,this._start),_e=$.Max(O.end,this.end);return new d(J,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,J=this.end){if(O===null||J===null)throw(0,t.illegalArgument)();let _e;return O?$.isPosition(O)?_e=O:(_e=O.start||this.start,J=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&J.isEqual(this.end)?this:new d(_e,J)}toJSON(){return[this.start,this.end]}};y=d=Be([P],y),e.Range=y;let L=p=class extends y{constructor(O,J,_e,Ge){let tt,at;if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new $(O,J),at=new $(_e,Ge)):O instanceof $&&J instanceof $&&(tt=O,at=J),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof p?!0:O?y.isRange(O)&&$.isPosition(O.anchor)&&$.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=p=Be([P],L),e.Selection=L;class z{constructor(O,J,_e){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,t.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(J),this.connectionToken=_e}}e.ResolvedAuthority=z;class x extends Error{constructor(O,J=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=J,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(O,J){return new x(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(O){return new x(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var B;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var j;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=I=class{constructor(O,J){this._range=O,this._newText=J}static isTextEdit(O){return O instanceof I?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,J){return new I(O,J)}static insert(O,J){return I.replace(new y(O,O),J)}static delete(O){return I.replace(O,"")}static setEndOfLine(O){const J=new I(new y(new $(0,0),new $(0,0)),"");return J.newEol=O,J}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=I=Be([P],ue),e.TextEdit=ue;var K;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let ne=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,J,_e,Ge){this._edits.push({_type:1,from:O,to:J,options:_e,metadata:Ge})}createFile(O,J,_e){this._edits.push({_type:1,from:void 0,to:O,options:J,metadata:_e})}deleteFile(O,J,_e){this._edits.push({_type:1,from:O,to:void 0,options:J,metadata:_e})}replaceNotebookMetadata(O,J,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(O,J,_e,Ge,tt){let at,dt,kt=[],Rt;if(Me.isNotebookRange(J)&&Ut.isNotebookCellDataArray(_e)&&!Ut.isNotebookCellDataArray(Ge)?(at=J.start,dt=J.end,kt=_e,Rt=Ge):typeof J=="number"&&typeof _e=="number"&&Ut.isNotebookCellDataArray(Ge)&&(at=J,dt=_e,kt=Ge,Rt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:dt-at,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(O,J,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:J,metadata:_e}})}replace(O,J,_e,Ge){this._edits.push({_type:2,uri:O,edit:new ue(J,_e),metadata:Ge})}insert(O,J,_e,Ge){this.replace(O,new y(J,J),_e,Ge)}delete(O,J,_e){this.replace(O,J,"",_e)}has(O){return this._edits.some(J=>J._type===2&&J.uri.toString()===O.toString())}set(O,J){if(J)for(const _e of J)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(O){const J=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&J.push(_e.edit);return J}entries(){const O=new A.ResourceMap;for(let J of this._edits)if(J._type===2){let _e=O.get(J.uri);_e||(_e=[J.uri,[]],O.set(J.uri,_e)),_e[1].push(J.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ne=Be([P],ne),e.WorkspaceEdit=ne;let pe=c=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof c?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=c._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,J=this._tabstop++){if(typeof O=="function"){const _e=new c;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=c._escape(O);return this.value+="${",this.value+=J,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,J=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,J){if(typeof J=="function"){const _e=new c;_e._tabstop=this._tabstop,J(_e),this._tabstop=_e._tabstop,J=_e.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,J&&(this.value+=":",this.value+=J),this.value+="}",this}};pe=c=Be([P],pe),e.SnippetString=pe;var be;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(be=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let le=M=class{constructor(O,J){if(this.uri=O,J)if(J instanceof y)this.range=J;else if(J instanceof $)this.range=new y(J,J);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?y.isRange(O.range)&&R.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};le=M=Be([P],le),e.Location=le;let Se=class{constructor(O,J){this.location=O,this.message=J}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&R.URI.isUri(O.location.uri):!1}static isEqual(O,J){return O===J?!0:!O||!J?!1:O.message===J.message&&O.location.range.isEqual(J.location.range)&&O.location.uri.toString()===J.location.uri.toString()}};Se=Be([P],Se),e.DiagnosticRelatedInformation=Se;let Ee=class{constructor(O,J,_e=ae.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=O,this.message=J,this.severity=_e}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,J){return O===J?!0:!O||!J?!1:O.message===J.message&&O.severity===J.severity&&O.code===J.code&&O.severity===J.severity&&O.source===J.source&&O.range.isEqual(J.range)&&(0,s.equals)(O.tags,J.tags)&&(0,s.equals)(O.relatedInformation,J.relatedInformation,Se.isEqual)}};Ee=Be([P],Ee),e.Diagnostic=Ee;let Fe=class{constructor(O,J){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=J}};Fe=Be([P],Fe),e.Hover=Fe;var $e;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(O,J=$e.Text){this.range=O,this.kind=J}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Ve=Be([P],Ve),e.DocumentHighlight=Ve;var je;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var H;(function(U){U[U.Deprecated=1]="Deprecated"})(H=e.SymbolTag||(e.SymbolTag={}));let G=o=class{constructor(O,J,_e,Ge,tt){this.name=O,this.kind=J,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof le?this.location=Ge:_e instanceof y&&(this.location=new le(Ge,_e)),o.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};G=o=Be([P],G),e.SymbolInformation=G;let X=i=class{constructor(O,J,_e,Ge,tt){this.name=O,this.detail=J,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};X=i=Be([P],X),e.DocumentSymbol=X;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(O,J){this.title=O,this.kind=J}};q=Be([P],q),e.CodeAction=q;let te=f=class{constructor(O){this.value=O}append(O){return new f(this.value?this.value+f.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+f.sep)}};te.sep=".",te=f=Be([P],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let fe=class{constructor(O,J){if(this.range=O,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};fe=Be([P],fe),e.SelectionRange=fe;class Re{constructor(O,J,_e,Ge,tt,at){this.kind=O,this.name=J,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Re;class xe{constructor(O,J){this.fromRanges=J,this.from=O}}e.CallHierarchyIncomingCall=xe;class ze{constructor(O,J){this.fromRanges=J,this.to=O}}e.CallHierarchyOutgoingCall=ze;var Xe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,J){this.range=O,this.command=J}get isResolved(){return!!this.command}};et=Be([P],et),e.CodeLens=et;let st=u=class{constructor(O,J=!1){r.set(this,void 0),Ze(this,r,new E.MarkdownString(O,{supportThemeIcons:J}),"f")}static isMarkdownString(O){return O instanceof u?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ie(this,r,"f").value}set value(O){Ie(this,r,"f").value=O}get isTrusted(){return Ie(this,r,"f").isTrusted}set isTrusted(O){Ie(this,r,"f").isTrusted=O}get supportThemeIcons(){return Ie(this,r,"f").supportThemeIcons}set supportThemeIcons(O){Ie(this,r,"f").supportThemeIcons=O}get supportHtml(){return Ie(this,r,"f").supportHtml}set supportHtml(O){Ie(this,r,"f").supportHtml=O}appendText(O){return Ie(this,r,"f").appendText(O),this}appendMarkdown(O){return Ie(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,J){return Ie(this,r,"f").appendCodeblock(J??"",O),this}};r=new WeakMap,st=u=Be([P],st),e.MarkdownString=st;let Je=class{constructor(O,J){this.label=O,this.documentation=J}};Je=Be([P],Je),e.ParameterInformation=Je;let nt=class{constructor(O,J){this.label=O,this.documentation=J,this.parameters=[]}};nt=Be([P],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Be([P],lt),e.SignatureHelp=lt;var pt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ft;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ft=e.InlayHintKind||(e.InlayHintKind={}));let Oe=class{constructor(O,J,_e){this.text=O,this.position=J,this.kind=_e}};Oe=Be([P],Oe),e.InlayHint=Oe;var Mt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Mt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var V;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(V=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));let de=class{constructor(O,J){this.label=O,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&V[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};de=Be([P],de),e.CompletionItem=de;let Ne=class{constructor(O=[],J=!1){this.items=O,this.isIncomplete=J}};Ne=Be([P],Ne),e.CompletionList=Ne;let qe=class{constructor(O,J,_e){this.text=O,this.range=J,this.command=_e}};qe=Be([P],qe),e.InlineSuggestion=qe;let ot=class{constructor(O){this.items=O}};ot=Be([P],ot),e.InlineSuggestions=ot;var Ye;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var yt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(yt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var re;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var oe;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(oe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var he;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(J){switch(J){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(O,J){if(J&&!R.URI.isUri(J))throw(0,t.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=J}};me=Be([P],me),e.DocumentLink=me;let Te=class{constructor(O,J,_e,Ge){this.red=O,this.green=J,this.blue=_e,this.alpha=Ge}};Te=Be([P],Te),e.Color=Te;let We=class{constructor(O,J){if(J&&!(J instanceof Te))throw(0,t.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=J}};We=Be([P],We),e.ColorInformation=We;let Le=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};Le=Be([P],Le),e.ColorPresentation=Le;var Ke;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Ke=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(O,J,_e){if(this.startIndex=O,this.length=J,this.tooltip=_e,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,t.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ie;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ie=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=ge;var ee;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ee=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let we=h=class{constructor(O,J){if(this.label=J,typeof O!="string"||typeof J!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};we.Clean=new h("clean","Clean"),we.Build=new h("build","Build"),we.Rebuild=new h("rebuild","Rebuild"),we.Test=new h("test","Test"),we=h=Be([P],we),e.TaskGroup=we;function Pe(U){let O="";for(let J=0;J<U.length;J++)O+=U[J].replace(/,/g,",,")+",";return O}let Qe=class{constructor(O,J,_e){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=_e):this._options=J)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let J of this._args)O.push(J);return Pe(O)}};Qe=Be([P],Qe),e.ProcessExecution=Qe;let Ue=class{constructor(O,J,_e){if(this._args=[],Array.isArray(J)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=J,this._options=_e}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=J}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)O.push(typeof J=="string"?J:J.value);return Pe(O)}};Ue=Be([P],Ue),e.ShellExecution=Ue;var ut;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class St{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=St;let wt=b=class{constructor(O,J,_e,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof J=="string"?(this._name=this.name=J,this._source=this.source=_e,this.execution=Ge,dt=tt,this.__deprecated=!0):J===vt.Global||J===vt.Workspace?(this.target=J,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,dt=at):(this.target=J,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Qe?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ue?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const J=this._definition.type;(b.EmptyType===J||b.ProcessType===J||b.ShellType===J||b.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=b=Be([P],wt),e.Task=wt;var ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let gt=class{constructor(O,J=_t.None){this.collapsibleState=J,R.URI.isUri(O)?this.resourceUri=O:this.label=O}};gt=Be([P],gt),e.TreeItem=gt;var _t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Lt=Be([P],Lt),e.TreeDataTransferItem=Lt;let It=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,J){this._items.set(O,J)}forEach(O){this._items.forEach(O)}};It=Be([P],It),e.TreeDataTransfer=It;let Pt=class{constructor(O,J){this.id=O,this.color=J}};Pt=Be([P],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let At=class{constructor(O){this.id=O}};At=Be([P],At),e.ThemeColor=At;var Et;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ot=class{constructor(O,J){if(typeof O!="string"&&(!O||!R.URI.isUri(O)&&!R.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof J!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=R.URI.file(O),this.base=O):R.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=J}};Ot=Be([P],Ot),e.RelativePattern=Ot;let Nt=class{constructor(O,J,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof J=="string"&&(this.condition=J),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Nt=Be([P],Nt),e.Breakpoint=Nt;let bt=class extends Nt{constructor(O,J,_e,Ge,tt){super(J,_e,Ge,tt);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};bt=Be([P],bt),e.SourceBreakpoint=bt;let $t=class extends Nt{constructor(O,J,_e,Ge,tt){super(J,_e,Ge,tt);this.functionName=O}};$t=Be([P],$t),e.FunctionBreakpoint=$t;let jt=class extends Nt{constructor(O,J,_e,Ge,tt,at,dt){super(Ge,tt,at,dt);if(!J)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=J,this.canPersist=_e}};jt=Be([P],jt),e.DataBreakpoint=jt;let oi=class{constructor(O,J,_e){this.command=O,this.args=J||[],this.options=_e}};oi=Be([P],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,J){this.port=O,this.host=J}};si=Be([P],si),e.DebugAdapterServer=si;let Tt=class{constructor(O){this.path=O}};Tt=Be([P],Tt),e.DebugAdapterNamedPipeServer=Tt;let Yt=class{constructor(O){this.implementation=O}};Yt=Be([P],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,J){this.range=O,this.expression=J}};ai=Be([P],ai),e.EvaluatableExpression=ai;var Xt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(O,J){this.range=O,this.text=J}};Vt=Be([P],Vt),e.InlineValueText=Vt;let mt=class{constructor(O,J,_e=!0){this.range=O,this.variableName=J,this.caseSensitiveLookup=_e}};mt=Be([P],mt),e.InlineValueVariableLookup=mt;let li=class{constructor(O,J){this.range=O,this.expression=J}};li=Be([P],li),e.InlineValueEvaluatableExpression=li;let xt=class{constructor(O,J){this.frameId=O,this.stoppedLocation=J}};xt=Be([P],xt),e.InlineValueContext=xt;var qt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=v=class extends Error{constructor(O,J=C.FileSystemProviderErrorCode.Unknown,_e){super(R.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new v(O,C.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(O){return new v(O,C.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(O){return new v(O,C.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(O){return new v(O,C.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(O){return new v(O,C.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(O){return new v(O,C.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};Jt=v=Be([P],Jt),e.FileSystemError=Jt;let ci=class{constructor(O,J,_e){this.start=O,this.end=J,this.kind=_e}};ci=Be([P],ci),e.FoldingRange=ci;var fi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,J=[]){this.tokenTypes=O,this.tokenModifiers=J}}e.SemanticTokensLegend=Zt;function yi(U){return typeof U=="undefined"||(0,S.isStringArray)(U)}class Kt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let J=0,_e=O.tokenTypes.length;J<_e;J++)this._tokenTypeStrToInt.set(O.tokenTypes[J],J);for(let J=0,_e=O.tokenModifiers.length;J<_e;J++)this._tokenModifierStrToInt.set(O.tokenModifiers[J],J)}}push(O,J,_e,Ge,tt){if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,J,_e,Ge,tt);if(y.isRange(O)&&typeof J=="string"&&yi(_e))return this._push(O,J,_e);throw(0,t.illegalArgument)()}_push(O,J,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(J);let kt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Bt>>>0}this._pushEncoded(Ge,tt,at,dt,kt)}_pushEncoded(O,J,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Bt=0;for(let Ht=0;Ht<kt;Ht++){let zt=this._data[5*Ht],di=this._data[5*Ht+1];zt===0?(zt=Rt,di+=Bt):zt+=Rt,this._data[5*Ht]=zt,this._data[5*Ht+1]=di,Rt=zt,Bt=di}}let at=O,dt=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=J}static _sortAndDeltaEncode(O){let J=[];const _e=O.length/5|0;for(let dt=0;dt<_e;dt++)J[dt]=dt;J.sort((dt,kt)=>{const Rt=O[5*dt],Bt=O[5*kt];if(Rt===Bt){const Ht=O[5*dt+1],zt=O[5*kt+1];return Ht-zt}return Rt-Bt});const Ge=new Uint32Array(O.length);let tt=0,at=0;for(let dt=0;dt<_e;dt++){const kt=5*J[dt],Rt=O[kt+0],Bt=O[kt+1],Ht=O[kt+2],zt=O[kt+3],di=O[kt+4],Hi=Rt-tt,Yi=Hi===0?Bt-at:Bt,hi=5*dt;Ge[hi+0]=Hi,Ge[hi+1]=Yi,Ge[hi+2]=Ht,Ge[hi+3]=zt,Ge[hi+4]=di,tt=Rt,at=Bt}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(Kt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Kt;class Gt{constructor(O,J){this.resultId=J,this.data=O}}e.SemanticTokens=Gt;class _i{constructor(O,J,_e){this.start=O,this.deleteCount=J,this.data=_e}}e.SemanticTokensEdit=_i;class Ci{constructor(O,J){this.resultId=J,this.edits=O}}e.SemanticTokensEdits=Ci;var Qt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Si;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Si=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=Be([P],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.Separator=-1]="Separator",U[U.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,J,_e){this.badge=O,this.tooltip=J,this.color=_e}static validate(O){if(O.badge){let J=(0,T.nextCharLength)(O.badge,0);if(J<O.badge.length&&(J+=(0,T.nextCharLength)(O.badge,J)),O.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=Be([P],ti),e.ColorTheme=ti;var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Me{constructor(O,J){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(J<0)throw(0,t.illegalArgument)("end must be positive");O<=J?(this._start=O,this._end=J):(this._start=J,this._end=O)}static isNotebookRange(O){return O instanceof Me?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let J=this._start,_e=this._end;return O.start!==void 0&&(J=O.start),O.end!==void 0&&(_e=O.end),J===this._start&&_e===this._end?this:new Me(J,_e)}}e.NotebookRange=Me;class Ut{constructor(O,J,_e,Ge,tt,at,dt){this.kind=O,this.value=J,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,Ut.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(J=>Ut.isNotebookCellData(J))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ut;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,J){this.data=O,this.mime=J;const _e=(0,k.normalizeMimeType)(J,!0);if(!_e)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const J={name:O.name,message:O.message,stack:O.stack};return ft.json(J,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,J="application/octet-stream"){return new ft(O,J)}static text(O,J=k.Mimes.text){const _e=Ie(ft,g,"f",l).encode(String(O));return new ft(_e,J)}static json(O,J="application/json"){const _e=JSON.stringify(O,void 0,"	");return ft.text(_e,J)}}e.NotebookCellOutputItem=ft,g=ft,l={value:new TextEncoder};class ii{constructor(O,J,_e){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof J=="string"?(this.id=J,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=J??_e)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,S.isArray)(O.items)}static ensureUniqueMimeTypes(O,J=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}Ge.add(tt),J&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,J){this.text=O,this.alignment=J}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,J=[]){this.uri=O,this.provides=(0,s.asArray)(J)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,J){this.label=O,this.timestamp=J}};ni=Be([P],ni),e.TimelineItem=ni;var Fi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,J){this.ranges=O,this.wordPattern=J}}e.LinkedEditingRanges=Li;class Ni{constructor(O,J){this._port=O,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var ce;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(ce=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ke=class{constructor(O=void 0,J=void 0,_e=void 0){this.include=O,this.exclude=J,this.profile=_e}};ke=Be([P],ke),e.TestRunRequest=ke;let ct=a=class{constructor(O){this.message=O}static diff(O,J,_e){const Ge=new a(O);return Ge.expectedOutput=J,Ge.actualOutput=_e,Ge}};ct=a=Be([P],ct),e.TestMessage=ct;let Ct=class{constructor(O){this.id=O}};Ct=Be([P],Ct),e.TestTag=Ct;let Dt=class{constructor(O,J){this.covered=O,this.total=J}};Dt=Be([P],Dt),e.CoveredCount=Dt;let xi=_=class{constructor(O,J,_e,Ge){this.uri=O,this.statementCoverage=J,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,J){const _e=new Dt(0,0),Ge=new Dt(0,0),tt=new Dt(0,0);for(const dt of J)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const kt of dt.branches)Ge.total+=1,Ge.covered+=kt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new _(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=J,at}};xi=_=Be([P],xi),e.FileCoverage=xi;let Ui=class{constructor(O,J,_e=[]){this.executionCount=O,this.location=J,this.branches=_e}};Ui=Be([P],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,J){this.executionCount=O,this.location=J}};Bi=Be([P],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,J){this.executionCount=O,this.location=J}};$i=Be([P],$i),e.FunctionCoverage=$i;var qi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,J,_e,Ge,tt,at){this.kind=O,this.name=J,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(ye[86],Ce([0,1,41,10,9,222,113,7,16]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(r,g){g?R.set(r,g):R.delete(r)}e.setWordDefinitionFor=F;function C(r){return R.get(r)}e.getWordDefinitionFor=C;class n extends A.MirrorTextModel{constructor(g,l,D,w,d,p,I,c){super(l,D,w,d);this._proxy=g,this._languageId=p,this._isDirty=I,this._notebook=c,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,S.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(l){return l?g._getTextInRange(l):g.getText()},get eol(){return g._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(l){return g._lineAt(l)},offsetAt(l){return g._offsetAt(l)},positionAt(l){return g._positionAt(l)},validateRange(l){return g._validateRange(l)},validatePosition(l){return g._validatePosition(l)},getWordRangeAtPosition(l,D){return g._getWordRangeAtPosition(l,D)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,s.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,s.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const l=this._validateRange(g);if(l.isEmpty)return"";if(l.isSingleLine)return this._lines[l.start.line].substring(l.start.character,l.end.character);const D=this._eol,w=l.start.line,d=l.end.line,p=[];p.push(this._lines[w].substring(l.start.character));for(let I=w+1;I<d;I++)p.push(this._lines[I]);return p.push(this._lines[d].substring(0,l.end.character)),p.join(D)}_lineAt(g){let l;if(g instanceof T.Position?l=g.line:typeof g=="number"&&(l=g),typeof l!="number"||l<0||l>=this._lines.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new m(l,this._lines[l],l===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(g),D=this._lines[l.index].length;return new T.Position(l.index,Math.min(l.remainder,D))}_validateRange(g){if(!(g instanceof T.Range))throw new Error("Invalid argument");const l=this._validatePosition(g.start),D=this._validatePosition(g.end);return l===g.start&&D===g.end?g:new T.Range(l.line,l.character,D.line,D.character)}_validatePosition(g){if(!(g instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:l,character:D}=g,w=!1;if(l<0)l=0,D=0,w=!0;else if(l>=this._lines.length)l=this._lines.length-1,D=this._lines[l].length,w=!0;else{const d=this._lines[l].length;D<0?(D=0,w=!0):D>d&&(D=d,w=!0)}return w?new T.Position(l,D):g}_getWordRangeAtPosition(g,l){const D=this._validatePosition(g);if(!l)l=C(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const w=(0,k.getWordAtText)(D.character+1,(0,k.ensureValidWordDefinition)(l),this._lines[D.line],0);if(w)return new T.Range(D.line,w.startColumn-1,D.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(g,l,D){this._line=g,this._text=l,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(ye[149],Ce([0,1,7,4,223,6,55,21,2,35]),function(Z,e,s,t,E,A,k,T,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(n,m,r,g){this._notebook=r,this._selector=g,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(D=>{const w=this._cellUris.get(D.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const l=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>l(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const n=[],m=[];for(const r of this._notebook.getCells())r.kind===s.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),n.push(r.document.getText().length+1),m.push(r.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const d of this._cells)w+=d.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const m=this.locationAt(n.start),r=this.locationAt(n.end),g=this._cellUris.get(m.uri),l=this._cellUris.get(r.uri);if(g===void 0||l===void 0)return"";if(g===l)return this._cells[g].document.getText(new s.Range(m.range.start,r.range.end));const D=[this._cells[g].document.getText(new s.Range(m.range.start,new s.Position(this._cells[g].document.lineCount,0)))];for(let w=g+1;w<l;w++)D.push(this._cells[w].document.getText());return D.push(this._cells[l].document.getText(new s.Range(new s.Position(0,0),r.range.end))),D.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),r=this._cellLengths.getPrefixSum(m.index-1),g=this._cells[m.index].document.offsetAt(n.with(m.remainder));return r+g}positionAt(n){if(typeof n=="number"){const r=this._cellLengths.getIndexOf(n),g=this._cellLines.getPrefixSum(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(g)}const m=this._cellUris.get(n.uri);if(m!==void 0){const r=this._cellLines.getPrefixSum(m-1);return new s.Position(r+n.range.start.line,n.range.start.character)}return new s.Position(0,0)}locationAt(n){s.Range.isRange(n)||(n=new s.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let r=m;n.isEmpty||(r=this._cellLines.getIndexOf(n.end.line));const g=new s.Position(m.remainder,n.start.character),l=new s.Position(r.remainder,n.end.character),D=new s.Range(g,l),w=this._cells[m.index];return new s.Location(w.document.uri,w.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),r=this.validatePosition(n.end);return n.with(m,r)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),r=new s.Position(m.remainder,n.character),g=this._cells[m.index].document.validatePosition(r),l=this._cellLines.getPrefixSum(m.index-1);return new s.Position(l+g.line,g.character)}}e.ExtHostNotebookConcatDocument=F}),define(ye[150],Ce([0,1,7,13,4]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let S=T==="light"?s.ColorThemeKind.Light:T==="dark"?s.ColorThemeKind.Dark:s.ColorThemeKind.HighContrast;this._actual=new s.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([He(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ye[65],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(ye[151],Ce([0,1,22]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let R=this.buffers.indexOf(S);return R<0&&(R=this.buffers.length,this.buffers.push(S)),R}}function E(T,S){if(S.serializeBuffersForPostMessage){const R=new t,F=(m,r)=>{if(r instanceof ArrayBuffer){const g=R.add(r);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(r)){const g=A(r);if(g){const l=R.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:l,view:{type:g,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},C=JSON.stringify(T,F),n=R.buffers.map(m=>{const r=new Uint8Array(m);return s.VSBuffer.wrap(r)});return{message:C,buffers:n}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=E;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(T,S){const R=S.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),F=S.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const r=m,{index:g}=r,l=R[g];if(r.view)switch(r.view.type){case 1:return new Int8Array(l,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return m}:void 0;return{message:JSON.parse(T,F),arrayBuffers:R}}e.deserializeWebviewMessage=k}),define(ye[152],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var s;(function(t){function E(k){const T=new Map;return k.types.forEach((S,R)=>{T.set(S,{asString:async()=>k.items[R].asString})}),T}t.toITreeDataTransfer=E;async function A(k){const T={types:[],items:[]},S=Array.from(k.entries());for(const R of S)T.types.push(R[0]),T.items.push({asString:await R[1].asString()});return T}t.toTreeDataTransferDTO=A})(s=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ye[66],Ce([0,1,10,2]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(T,S){return T.scheme===s.Schemas.http||T.scheme===s.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===s.Schemas.file&&(T=t.URI.from({scheme:s.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:s.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=E;function A(T){return T.replace(/./g,S=>{const R=S.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?S:"-"+R.toString(16).padStart(4,"0")})}function k(T){return T.replace(/-([0-9a-f]{4})/g,(S,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=k}),define(ye[153],Ce([0,1,4,6,66]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,R){this._proxy=T,this._editors=S,this._initData=R,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const F=S.getVisibleTextEditors();for(const C of this._insets.values())F.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,S,R,F,C){let n;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===T){n=d;break}if(!n)throw new Error("not a visible editor");const m=this,r=this._handlePool++,g=new s.Emitter,l=new s.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,E.asWebviewUri)(d,m._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(d){this._options=d,m._proxy.$setOptions(r,d)}get options(){return this._options}set html(d){this._html=d,m._proxy.$setHtml(r,d)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(d){return m._proxy.$postMessage(r,d)}},w=new class{constructor(){this.editor=T,this.line=S,this.height=R,this.webview=D,this.onDidDispose=l.event}dispose(){m._insets.has(r)&&(m._insets.delete(r),m._proxy.$disposeEditorInset(r),l.fire(),l.dispose(),g.dispose())}};return this._proxy.$createEditorInset(r,n.id,n.value.document.uri,S+1,R,F||{},C.identifier,C.extensionLocation),this._insets.set(r,{editor:T,inset:w,onDidReceiveMessage:g}),w}$onDidDispose(T){const S=this._insets.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){const R=this._insets.get(T);R&&R.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(ye[154],Ce([0,1,125,11,2,6,3,44,36,45,16,10]),function(Z,e,s,t,E,A,k,T,S,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,s.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,s.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,s.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,s.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,s.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,s.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,s.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,s.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,s.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,s.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,s.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,s.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,s.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,s.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,s.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,s.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,s.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,s.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,s.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,s.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,s.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(y,L,z){for(const x of z.visibleEditorPanes)if(x.group.id===L&&y.matches(x.input))return x.getViewState()}e.findViewStateForEditor=n;function m(y){if(I(y))return!1;const L=y;return E.URI.isUri(L?.resource)}e.isResourceEditorInput=m;function r(y){if(I(y))return!1;const L=y;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=r;function g(y){if(I(y)||r(y))return!1;const L=y;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function l(y){if(I(y))return!1;const L=y;return L?L.resource===void 0||L.resource.scheme===C.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var D;(function(y){y[y.SHORT=0]="SHORT",y[y.MEDIUM=1]="MEDIUM",y[y.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var w;(function(y){y[y.EXPLICIT=1]="EXPLICIT",y[y.AUTO=2]="AUTO",y[y.FOCUS_CHANGE=3]="FOCUS_CHANGE",y[y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var d;(function(y){y[y.None=0]="None",y[y.Readonly=2]="Readonly",y[y.Untitled=4]="Untitled",y[y.Singleton=8]="Singleton",y[y.RequiresTrust=16]="RequiresTrust",y[y.CanSplitInGroup=32]="CanSplitInGroup",y[y.ForceDescription=64]="ForceDescription"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class p extends A.Disposable{}e.AbstractEditorInput=p;function I(y){return y instanceof p}e.isEditorInput=I;function c(y){const L=y;return E.URI.isUri(L?.preferredResource)}function M(y){const L=y;return I(L?.primary)&&I(L?.secondary)}e.isSideBySideEditorInput=M;function o(y){const L=y;return I(L?.modified)&&I(L?.original)}e.isDiffEditorInput=o;function i(y){return I(y?.editor)}e.isEditorInputWithOptions=i;function f(y){const L=y;return i(y)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=f;function u(y){const L=y;return typeof L?.groupId=="number"&&I(L.editor)}e.isEditorIdentifier=u;var h;(function(y){y[y.UNKNOWN=0]="UNKNOWN",y[y.REPLACE=1]="REPLACE",y[y.MOVE=2]="MOVE",y[y.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(y){y[y.GROUP_ACTIVE=0]="GROUP_ACTIVE",y[y.GROUP_INDEX=1]="GROUP_INDEX",y[y.GROUP_LOCKED=2]="GROUP_LOCKED",y[y.EDITOR_OPEN=3]="EDITOR_OPEN",y[y.EDITOR_CLOSE=4]="EDITOR_CLOSE",y[y.EDITOR_MOVE=5]="EDITOR_MOVE",y[y.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",y[y.EDITOR_LABEL=7]="EDITOR_LABEL",y[y.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",y[y.EDITOR_PIN=9]="EDITOR_PIN",y[y.EDITOR_STICKY=10]="EDITOR_STICKY",y[y.EDITOR_DIRTY=11]="EDITOR_DIRTY",y[y.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(b=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var v;(function(y){y[y.PRIMARY=1]="PRIMARY",y[y.SECONDARY=2]="SECONDARY",y[y.BOTH=3]="BOTH",y[y.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(L,z){if(!L)return;if(z?.supportSideBySide){const{primary:B,secondary:j}=this.getSideEditors(L);if(B&&j){if(z?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getOriginalUri(B,{filterByScheme:z.filterByScheme})??this.getOriginalUri(j,{filterByScheme:z.filterByScheme});L=z.supportSideBySide===v.PRIMARY?B:j}}if(r(L)||g(L))return;const x=c(L)?L.preferredResource:L.resource;return!x||!z||!z.filterByScheme?x:this.filterUri(x,z.filterByScheme)}getSideEditors(L){return M(L)||g(L)?{primary:L.primary,secondary:L.secondary}:o(L)||r(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,z){if(!L)return;if(z?.supportSideBySide){const{primary:B,secondary:j}=this.getSideEditors(L);if(B&&j){if(z?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getCanonicalUri(B,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:z.filterByScheme});L=z.supportSideBySide===v.PRIMARY?B:j}}if(r(L)||g(L))return;const x=L.resource;return!x||!z||!z.filterByScheme?x:this.filterUri(x,z.filterByScheme)}filterUri(L,z){if(Array.isArray(z)){if(z.some(x=>L.scheme===x))return L}else if(z===L.scheme)return L}}e.EditorResourceAccessor=new a;var _;(function(y){y[y.LEFT=0]="LEFT",y[y.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class P{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const z=this.instantiationService=L.get(k.IInstantiationService);for(const[x,B]of this.editorSerializerConstructors)this.createEditorSerializer(x,B,z);this.editorSerializerConstructors.clear()}createEditorSerializer(L,z,x){const B=x.createInstance(z);this.editorSerializerInstances.set(L,B)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,z){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,z,this.instantiationService):this.editorSerializerConstructors.set(L,z),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new P);async function N(y,L){if(!y||!y.length)return[];const z=await Promise.all(y.map(async x=>{const B=E.URI.revive(x.fileUri);if(!B||!await L.canHandleResource(B))return;let ue=x.exists,K=x.type;if(typeof ue!="boolean"||typeof K!="number")try{K=(await L.resolve(B)).isDirectory?R.FileType.Directory:R.FileType.Unknown,ue=!0}catch{ue=!1}if(!ue&&x.openOnlyIfExists||K===R.FileType.Directory)return;const ne={selection:ue?x.selection:void 0,pinned:!0,override:x.editorOverrideId};let pe;return ue?pe={resource:B,options:ne}:pe={resource:B,options:ne,forceUntitled:!0},pe}));return(0,F.coalesce)(z)}e.pathsToEditors=N;var $;(function(y){y[y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",y[y.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}))}),define(ye[155],Ce([0,1,4,14,126]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,S,R,F){const C={command:T};if(S&&Object.keys(S).length>0&&(C.arguments=S),this.internalSend("request",C),typeof F=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const r={type:"response",seq:0,request_seq:C.seq,success:!1,command:T,message:(0,E.localize)(0,null,F,T)};m(r)}},F)}return R&&this.pendingRequests.set(C.seq,R),C.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,S){return T.type!=="event"||S.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,t.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":{const S=T,R=this.pendingRequests.get(S.request_seq);R&&(this.pendingRequests.delete(S.request_seq),R(S));break}}}}internalSend(T,S){S.type=T,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((S,R)=>T.set(R,S)),await(0,t.timeout)(500),T.forEach((S,R)=>{S({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ye[156],Ce([0,1,9,2,17,26,10]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(o,i,f){return o.replace(T,function(u,h){return i&&h.length>0&&h[0]!=="_"?u:f&&f.hasOwnProperty(h)?f[h]:u})}e.formatPII=S;function R(o){const i={};for(const f of Object.keys(o))f.startsWith("!")||(i[f]=o[f]);return i}e.filterExceptionsFromTelemetry=R;function F(o){return o.configuration.request==="attach"&&!C(o)&&(!o.parentSession||F(o.parentSession))}e.isSessionAttach=F;function C(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(i,"extensionhost")||(0,s.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?C(o.parentSession):void 0}e.getExtensionHostDebugSession=C;function n(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=n;function m(o,i,f){let u,h=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,v=null;for(;v=b.exec(o);){let a=v.index+1,_=a+v[0].length;if(a<=i&&_>=f){u=v[0],h=a;break}}if(u){let a=/\w+/g,_=null;for(;(_=a.exec(u))&&!(_.index+1+h+_[0].length>=f););_&&(u=u.substring(0,a.lastIndex))}return u?{start:h,end:h+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(o){return!!(o&&o.match(r))}e.isUri=g;function l(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(g(o.path))return t.URI.parse(o.path);if((0,E.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function D(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return o.path}function w(o,i){const f=i?l:D,u=(0,A.deepClone)(o);return p(u,(h,b)=>{h&&b&&(b.path=f(b))}),u}e.convertToDAPaths=w;function d(o,i){const f=i?l:D,u=(0,A.deepClone)(o);return p(u,(h,b)=>{!h&&b&&(b.path=f(b))}),u}e.convertToVSCPaths=d;function p(o,i){switch(o.type){case"event":{const f=o;switch(f.event){case"output":i(!1,f.body.source);break;case"loadedSource":i(!1,f.body.source);break;case"breakpoint":i(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=o;switch(f.command){case"setBreakpoints":i(!0,f.arguments.source);break;case"breakpointLocations":i(!0,f.arguments.source);break;case"source":i(!0,f.arguments.source);break;case"gotoTargets":i(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(u=>i(!1,u));break;default:break}break}case"response":{const f=o;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(u=>i(!1,u.source));break;case"loadedSources":f.body.sources.forEach(u=>i(!1,u));break;case"scopes":f.body.scopes.forEach(u=>i(!1,u.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(u=>i(!1,u.source));break;case"setBreakpoints":f.body.breakpoints.forEach(u=>i(!1,u.source));break;default:break}break}}}function I(o){return o.filter(i=>!i.presentation?.hidden).sort((i,f)=>i.presentation?f.presentation?i.presentation.group?f.presentation.group?i.presentation.group!==f.presentation.group?i.presentation.group.localeCompare(f.presentation.group):c(i.presentation.order,f.presentation.order):-1:f.presentation.group?1:c(i.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=I;function c(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function M(o,i){const f=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(f!=="none"&&(await i.saveAll(),f==="allEditorsInActiveGroup")){const u=i.activeEditorPane;u&&await i.save({editor:u.input,groupId:u.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(ye[87],Ce([0,1,29,157,78,10,17,23,44]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var R;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var r;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(r=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var D;(function(a){a.scheme=A.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function P(x,B){return x.with({scheme:a.scheme,fragment:`ch${B.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}a.generate=P;function N(x){if(x.scheme!==a.scheme)return;const B=_.exec(x.fragment);return B?{handle:Number(B[1]),notebook:x.with({scheme:x.fragment.substr(B[0].length)||A.Schemas.file,fragment:null})}:void 0}a.parse=N;function $(x,B,j){return x.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${B.toString().padStart(7,"0")},${j??""},${x.scheme!==A.Schemas.file?x.scheme:""}`})}a.generateCellOutputUri=$;function y(x){if(x.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const B=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!B)return;const j=Number(B[1]),ue=B[2]&&B[2]!==""?B[2]:void 0,K=B[3];return{handle:j,outputId:ue,notebook:x.with({scheme:K||A.Schemas.file,fragment:null})}}a.parseCellOutputUri=y;function L(x,B,j){return x.with({scheme:j,fragment:`ch${B.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}a.generateCellUri=L;function z(x,B){if(x.scheme!==B)return;const j=_.exec(x.fragment);return j?{handle:Number(j[1]),notebook:x.with({scheme:x.fragment.substr(j[0].length)||A.Schemas.file,fragment:null})}:void 0}a.parseCellUri=z})(D=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function d(a){return w.get(a)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=d;function p(a){return w.get(a)?.supportedByCore??!1}e.mimeTypeSupportedByCore=p;function I(a){return w.get(a)?.mergeable??!1}e.mimeTypeIsMergeable=I;const c=a=>T.isWindows?a.replace(/\//g,"\\"):a;class M{constructor(_=[],P=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=P,this.order=[...new Set(_)].map(N=>({pattern:N,matches:s.parse(c(N))}))}sort(_){const P=new Map(t.Iterable.map(_,$=>[$,c($)]));let N=[];for(const{matches:$}of this.order)for(const[y,L]of P)if($(L)){N.push(y),P.delete(y);break}return P.size&&(N=N.concat([...P.keys()].sort(($,y)=>this.defaultOrder.indexOf($)-this.defaultOrder.indexOf(y)))),N}prioritize(_,P){const N=this.findIndex(_);if(N===-1){this.order.unshift({pattern:_,matches:s.parse(c(_))});return}const $=new Set(P.map(L=>this.findIndex(L,N)));$.delete(-1);const y=Array.from($).sort();this.order.splice(N+1,0,...y.map(L=>this.order[L]));for(let L=y.length-1;L>=0;L--)this.order.splice(y[L],1)}toArray(){return this.order.map(_=>_.pattern)}findIndex(_,P=this.order.length){const N=c(_);for(let $=0;$<P;$++)if(this.order[$].matches(N))return $;return-1}}e.MimeTypeDisplayOrder=M;function o(a,_,P,N=($,y)=>$===y){const $=[];function y(x,B,j){if(B===0&&j.length===0)return;const ue=$[$.length-1];ue&&ue.start+ue.deleteCount===x?(ue.deleteCount+=B,ue.toInsert.push(...j)):$.push({start:x,deleteCount:B,toInsert:j})}let L=0,z=0;for(;;){if(L===a.length){y(L,0,_.slice(z));break}if(z===_.length){y(L,a.length-L,[]);break}const x=a[L],B=_[z];if(N(x,B)){L+=1,z+=1;continue}P(B)?(y(L,1,[]),L+=1):(y(L,0,[B]),z+=1)}return $}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(a){a.default="default",a.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(a){const _=a;return!!((typeof _.include=="string"||s.isRelativePattern(_.include))&&(typeof _.exclude=="string"||s.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=f;function u(a,_,P){if(Array.isArray(a.viewType)&&a.viewType.indexOf(_)>=0||a.viewType===_)return!0;if(a.filenamePattern){let N=f(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,$=f(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(s.match(N,(0,k.basename)(P.fsPath).toLowerCase()))return!($&&s.match($,(0,k.basename)(P.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class h{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let P=0;P<this.textModel.cells.length;P++)_[P]=this.textModel.cells[P].getHashValue();return _}}e.CellSequence=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class v{static create(_){return`${v._prefix}${_}`}static parse(_){if(_.startsWith(v._prefix))return _.substr(v._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=v,v._prefix="notebook/"}),define(ye[158],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(ye[159],Ce([0,1,3,44]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,s.createDecorator)(e.OUTPUT_SERVICE_ID);var E;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ye[160],Ce([0,1,128,3,44]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,s.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,s.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,s.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[161],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=s;function t(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=t}),define(ye[88],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var s;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(s=e.TestResultState||(e.TestResultState={}));var t;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(C){C[C.Error=0]="Error",C[C.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(C,n)=>{n.expand!==void 0&&(C.expand=n.expand),n.item!==void 0&&(C.item=C.item?Object.assign(C.item,n.item):n.item)};e.applyTestItemUpdate=k;var T;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var S;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire",C[C.AddTag=5]="AddTag",C[C.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class R{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=R;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const r of n)switch(r[0]){case 0:{const g=r[1];if(g.parent){if(this.items.has(g.parent)){const l=this.items.get(g.parent);l.children.add(g.item.extId);const D=this.createItem(g,l);this.items.set(g.item.extId,D),m.add(D)}}else{const l=this.createItem(g);this.roots.add(l),this.items.set(g.item.extId,l),m.add(l)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=r[1],l=this.items.get(g.extId);if(!l)break;g.expand!==void 0&&(l.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(l,g),m.update(l);break}case 2:{const g=this.items.get(r[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const l=[[r[1]]];for(;l.length;)for(const D of l.pop()){const w=this.items.get(D);w&&(l.push(w.children),this.items.delete(D),m.remove(w,w!==g),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(r[1]);break;case 3:this.updatePendingRoots(r[1]);break;case 5:this._tags.set(r[1].id,r[1]);break;case 6:this._tags.delete(r[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=F}),define(ye[67],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(A){A.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class E{constructor(k,T=k.length){if(this.path=k,this.viewEnd=T,k.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,T,S=k.parent){if(k.id===T)return new E([T]);let R=[k.id];for(let F=S;F&&F.id!==T;F=F.parent)R.push(F.id);return R.push(T),new E(R.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new E(k.split("\0"))}static join(k,T){return new E([...k.path,T])}static joinToString(k,T){return k.toString()+"\0"+T}static compare(k,T){return k===T?0:T.startsWith(k+"\0")?2:k.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new E(this.path,k)}compare(k){if(typeof k=="string")return E.compare(this.toString(),k);for(let T=0;T<k.viewEnd&&T<this.viewEnd;T++)if(k.path[T]!==this.path[T])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=E}),define(ye[162],Ce([0,1,17,89,11,26,23,77,129]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(C,n,m){this._contributedVariables=new Map,this._context=C,this._labelService=n,m&&(this._envVariablesPromise=m.then(r=>this.prepareEnv(r)))}prepareEnv(C){if(k.isWindows){const n=Object.create(null);return Object.keys(C).forEach(m=>{n[m.toLowerCase()]=C[m]}),n}return C}resolveWithEnvironment(C,n,m){return this.recursiveResolve(this.prepareEnv(C),n?n.uri:void 0,m)}async resolveAsync(C,n){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,n)}async resolveAnyBase(C,n,m,r){const g=A.deepClone(n);return k.isWindows&&g.windows?Object.keys(g.windows).forEach(l=>g[l]=g.windows[l]):k.isMacintosh&&g.osx?Object.keys(g.osx).forEach(l=>g[l]=g.osx[l]):k.isLinux&&g.linux&&Object.keys(g.linux).forEach(l=>g[l]=g.linux[l]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g,m,r)}async resolveAnyAsync(C,n,m){return this.resolveAnyBase(C,n,m)}async resolveAnyMap(C,n,m){const r=new Map;return{newConfig:await this.resolveAnyBase(C,n,m,r),resolvedVariables:r}}resolveWithInteractionReplace(C,n,m,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,n,m,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,n){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,n)}recursiveResolve(C,n,m,r,g){if(E.isString(m))return this.resolveString(C,n,m,r,g);if(E.isArray(m))return m.map(l=>this.recursiveResolve(C,n,l,r,g));if(E.isObject(m)){let l=Object.create(null);return Object.keys(m).forEach(D=>{const w=this.resolveString(C,n,D,r,g);l[w]=this.recursiveResolve(C,n,m[D],r,g)}),l}return m}resolveString(C,n,m,r,g){return m.replace(R.VARIABLE_REGEXP,(D,w)=>{if(w.includes(R.VARIABLE_LHS))return D;let d=this.evaluateSingleVariable(C,D,w,n,r);return g&&g.set(w,d),d!==D&&E.isString(d)&&d.match(R.VARIABLE_REGEXP)&&(d=this.resolveString(C,n,d,r,g)),d})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,n,m,r,g){let l;const D=m.split(":");D.length>1&&(m=D[0],l=D[1]);const w=()=>{const I=this._context.getFilePath();if(I)return I;throw new Error((0,S.localize)(0,null,n))},d=()=>{const I=w();if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return c}throw new Error((0,S.localize)(1,null,n,s.basename(I)))},p=()=>{if(l){const I=this._context.getFolderUri(l);if(I)return I;throw new Error((0,S.localize)(2,null,n,l))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(m){case"env":if(l){if(C){const I=C[k.isWindows?l.toLowerCase():l];if(E.isString(I))return I}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(l){const I=this._context.getConfigurationValue(r,l);if(E.isUndefinedOrNull(I))throw new Error((0,S.localize)(6,null,n,l));if(E.isObject(I))throw new Error((0,S.localize)(7,null,n,l));return I}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,l,g,"command");case"input":return this.resolveFromMap(n,l,g,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return r||l?(0,T.normalizeDriveLetter)(this.fsPath(p())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(p()));case"lineNumber":{const I=this._context.getLineNumber();if(I)return I;throw new Error((0,S.localize)(9,null,n))}case"selectedText":{const I=this._context.getSelectedText();if(I)return I;throw new Error((0,S.localize)(10,null,n))}case"file":return w();case"fileWorkspaceFolder":return d();case"relativeFile":return r||l?s.relative(this.fsPath(p()),w()):w();case"relativeFileDirname":{const I=s.dirname(w());if(r||l){const c=s.relative(this.fsPath(p()),I);return c.length===0?".":c}return I}case"fileDirname":return s.dirname(w());case"fileExtname":return s.extname(w());case"fileBasename":return s.basename(w());case"fileBasenameNoExtension":{const I=s.basename(w());return I.slice(0,I.length-s.extname(I).length)}case"fileDirnameBasename":return s.basename(s.dirname(w()));case"execPath":{const I=this._context.getExecPath();return I||n}case"execInstallFolder":{const I=this._context.getAppRoot();return I||n}case"pathSeparator":return s.sep;default:try{const I=l?`${m}:${l}`:m;return this.resolveFromMap(n,I,g,void 0)}catch{return n}}}}resolveFromMap(C,n,m,r){if(n&&m){const g=r===void 0?m[n]:m[r+":"+n];if(typeof g=="string")return g;throw new Error((0,S.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[90],Ce([0,1,3,154]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var E;(function(r){r[r.UP=0]="UP",r[r.DOWN=1]="DOWN",r[r.LEFT=2]="LEFT",r[r.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(r){r[r.FIRST=0]="FIRST",r[r.LAST=1]="LAST",r[r.NEXT=2]="NEXT",r[r.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var T;(function(r){r[r.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",r[r.EVEN=1]="EVEN",r[r.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(r){r[r.COPY_EDITORS=0]="COPY_EDITORS",r[r.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function R(r){const g=r;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=R;var F;(function(r){r[r.CREATION_TIME=0]="CREATION_TIME",r[r.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",r[r.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(r){r[r.NEW_EDITOR=1]="NEW_EDITOR",r[r.MOVE_EDITOR=2]="MOVE_EDITOR",r[r.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function n(r){const g=r;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=n;function m(r){return r.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(ye[163],Ce([0,1,3,90]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const k=A;return typeof A=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=E}),define(ye[8],Ce([0,1,16,22,76,224,54,26,11,2,59,58,130,82,47,87,67,163,7]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(ie){function ge(W){const{selectionStartLineNumber:we,selectionStartColumn:Pe,positionLineNumber:Qe,positionColumn:Ue}=W,ut=new w.Position(we-1,Pe-1),vt=new w.Position(Qe-1,Ue-1);return new w.Selection(ut,vt)}ie.to=ge;function ee(W){const{anchor:we,active:Pe}=W;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ie.from=ee})(d=e.Selection||(e.Selection={}));var p;(function(ie){function ge(W){if(!W)return;const{start:we,end:Pe}=W;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ie.from=ge;function ee(W){if(!W)return;const{startLineNumber:we,startColumn:Pe,endLineNumber:Qe,endColumn:Ue}=W;return new w.Range(we-1,Pe-1,Qe-1,Ue-1)}ie.to=ee})(p=e.Range||(e.Range={}));var I;(function(ie){function ge(ee){switch(ee){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 3:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ie.to=ge})(I=e.TokenType||(e.TokenType={}));var c;(function(ie){function ge(W){return new w.Position(W.lineNumber-1,W.column-1)}ie.to=ge;function ee(W){return{lineNumber:W.line+1,column:W.character+1}}ie.from=ee})(c=e.Position||(e.Position={}));var M;(function(ie){function ge(we,Pe){return(0,s.coalesce)((0,s.asArray)(we).map(Qe=>ee(Qe,Pe)))}ie.from=ge;function ee(we,Pe){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:W(we.scheme,Pe),pattern:typeof we.pattern=="undefined"?void 0:V.from(we.pattern),exclusive:we.exclusive}}function W(we,Pe){return Pe&&typeof we=="string"?Pe.transformOutgoingScheme(we):we}})(M=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(ie){function ge(W){switch(W){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ie.from=ge;function ee(W){switch(W){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ie.to=ee})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ie){function ge(W){let we;return W.code&&((0,S.isString)(W.code)||(0,S.isNumber)(W.code)?we=String(W.code):we={value:String(W.code.value),target:W.code.target}),{...p.from(W.range),message:W.message,source:W.source,code:we,severity:u.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(f.from),tags:Array.isArray(W.tags)?(0,s.coalesce)(W.tags.map(o.from)):void 0}}ie.from=ge;function ee(W){const we=new w.Diagnostic(p.to(W),W.message,u.to(W.severity));return we.source=W.source,we.code=(0,S.isString)(W.code)?W.code:W.code?.value,we.relatedInformation=W.relatedInformation&&W.relatedInformation.map(f.to),we.tags=W.tags&&(0,s.coalesce)(W.tags.map(o.to)),we}ie.to=ee})(i=e.Diagnostic||(e.Diagnostic={}));var f;(function(ie){function ge(W){return{...p.from(W.location.range),message:W.message,resource:W.location.uri}}ie.from=ge;function ee(W){return new w.DiagnosticRelatedInformation(new w.Location(W.resource,p.to(W)),W.message)}ie.to=ee})(f=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(ie){function ge(W){switch(W){case w.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ie.from=ge;function ee(W){switch(W){case m.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ie.to=ee})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(ie){function ge(W){return typeof W=="number"&&W>=w.ViewColumn.One?W-1:W===w.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}ie.from=ge;function ee(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ie.to=ee})(h=e.ViewColumn||(e.ViewColumn={}));function b(ie){return typeof ie.range!="undefined"}function v(ie){return ie.length===0?!0:!!b(ie[0])}e.isDecorationOptionsArr=v;var a;(function(ie){function ge(Ue){return Ue.map(ie.from)}ie.fromMany=ge;function ee(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function W(Ue){let ut;if(ee(Ue)){const{language:ht,value:gt}=Ue;ut={value:"```"+ht+`
`+gt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ue)?ut={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?ut={value:Ue}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const St=ht=>{try{let gt=R.URI.parse(ht,!0);gt=gt.with({query:we(gt.query,vt)}),vt[ht]=gt}catch{}return""},wt=new A.Renderer;return wt.link=St,wt.image=ht=>St(E.parseHrefAndDimensions(ht).href),A(ut.value,{renderer:wt}),ut}ie.from=W;function we(Ue,ut){if(!Ue)return Ue;let vt;try{vt=(0,k.parse)(Ue)}catch{}if(!vt)return Ue;let St=!1;return vt=(0,T.cloneAndChange)(vt,wt=>{if(R.URI.isUri(wt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=wt,St=!0,ht}else return}),St?JSON.stringify(vt):Ue}function Pe(Ue){const ut=new w.MarkdownString(Ue.value,Ue.supportThemeIcons);return ut.isTrusted=Ue.isTrusted,ut.supportHtml=Ue.supportHtml,ut}ie.to=Pe;function Qe(Ue){if(!!Ue)return typeof Ue=="string"?Ue:ie.from(Ue)}ie.fromStrict=Qe})(a=e.MarkdownString||(e.MarkdownString={}));function _(ie){return v(ie)?ie.map(ge=>({range:p.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?a.fromMany(ge.hoverMessage):ge.hoverMessage?a.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):ie.map(ge=>({range:p.from(ge)}))}e.fromRangeOrRangeWithMessage=_;function P(ie){return typeof ie=="undefined"?ie:typeof ie=="string"?R.URI.file(ie):ie}e.pathOrURIToURI=P;var N;(function(ie){function ge(ee){return typeof ee=="undefined"?ee:{contentText:ee.contentText,contentIconPath:ee.contentIconPath?P(ee.contentIconPath):void 0,border:ee.border,borderColor:ee.borderColor,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,color:ee.color,backgroundColor:ee.backgroundColor,margin:ee.margin,width:ee.width,height:ee.height}}ie.from=ge})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(ie){function ge(ee){return typeof ee=="undefined"?ee:{backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?P(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?N.from(ee.before):void 0,after:ee.after?N.from(ee.after):void 0}}ie.from=ge})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ie){function ge(ee){if(typeof ee=="undefined")return ee;switch(ee){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ie.from=ge})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ie){function ge(ee){return{isWholeLine:ee.isWholeLine,rangeBehavior:ee.rangeBehavior?y.from(ee.rangeBehavior):void 0,overviewRulerLane:ee.overviewRulerLane,light:ee.light?$.from(ee.light):void 0,dark:ee.dark?$.from(ee.dark):void 0,backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?P(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?N.from(ee.before):void 0,after:ee.after?N.from(ee.after):void 0}}ie.from=ge})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ie){function ge(W){return{text:W.newText,eol:W.newEol&&lt.from(W.newEol),range:p.from(W.range)}}ie.from=ge;function ee(W){const we=new w.TextEdit(p.to(W.range),W.text);return we.newEol=typeof W.eol=="undefined"?void 0:lt.to(W.eol),we}ie.to=ee})(z=e.TextEdit||(e.TextEdit={}));var x;(function(ie){function ge(W,we,Pe){const Qe={edits:[]};if(W instanceof w.WorkspaceEdit)for(let Ue of W._allEntries())if(Ue._type===1)Qe.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const ut=we?.getDocument(Ue.uri);Qe.edits.push({_type:2,resource:Ue.uri,edit:z.from(Ue.edit),modelVersionId:ut?.version,metadata:Ue.metadata})}else Ue._type===3?Qe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Qe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Pe?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Ye.from)}});return Qe}ie.from=ge;function ee(W){const we=new w.WorkspaceEdit;for(const Pe of W.edits)Pe.edit?we.replace(R.URI.revive(Pe.resource),p.to(Pe.edit.range),Pe.edit.text):we.renameFile(R.URI.revive(Pe.oldUri),R.URI.revive(Pe.newUri),Pe.options);return we}ie.to=ee})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(ie){const ge=Object.create(null);ge[w.SymbolKind.File]=0,ge[w.SymbolKind.Module]=1,ge[w.SymbolKind.Namespace]=2,ge[w.SymbolKind.Package]=3,ge[w.SymbolKind.Class]=4,ge[w.SymbolKind.Method]=5,ge[w.SymbolKind.Property]=6,ge[w.SymbolKind.Field]=7,ge[w.SymbolKind.Constructor]=8,ge[w.SymbolKind.Enum]=9,ge[w.SymbolKind.Interface]=10,ge[w.SymbolKind.Function]=11,ge[w.SymbolKind.Variable]=12,ge[w.SymbolKind.Constant]=13,ge[w.SymbolKind.String]=14,ge[w.SymbolKind.Number]=15,ge[w.SymbolKind.Boolean]=16,ge[w.SymbolKind.Array]=17,ge[w.SymbolKind.Object]=18,ge[w.SymbolKind.Key]=19,ge[w.SymbolKind.Null]=20,ge[w.SymbolKind.EnumMember]=21,ge[w.SymbolKind.Struct]=22,ge[w.SymbolKind.Event]=23,ge[w.SymbolKind.Operator]=24,ge[w.SymbolKind.TypeParameter]=25;function ee(we){return typeof ge[we]=="number"?ge[we]:6}ie.from=ee;function W(we){for(const Pe in ge)if(ge[Pe]===we)return Number(Pe);return w.SymbolKind.Property}ie.to=W})(B=e.SymbolKind||(e.SymbolKind={}));var j;(function(ie){function ge(W){switch(W){case w.SymbolTag.Deprecated:return 1}}ie.from=ge;function ee(W){switch(W){case 1:return w.SymbolTag.Deprecated}}ie.to=ee})(j=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ie){function ge(W){return{name:W.name,kind:B.from(W.kind),tags:W.tags&&W.tags.map(j.from),containerName:W.containerName,location:ae.from(W.location)}}ie.from=ge;function ee(W){const we=new w.SymbolInformation(W.name,B.to(W.kind),W.containerName,ae.to(W.location));return we.tags=W.tags&&W.tags.map(j.to),we}ie.to=ee})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ie){function ge(W){const we={name:W.name||"!!MISSING: name!!",detail:W.detail,range:p.from(W.range),selectionRange:p.from(W.selectionRange),kind:B.from(W.kind),tags:W.tags?.map(j.from)??[]};return W.children&&(we.children=W.children.map(ge)),we}ie.from=ge;function ee(W){const we=new w.DocumentSymbol(W.name,W.detail,B.to(W.kind),p.to(W.range),p.to(W.selectionRange));return(0,s.isNonEmptyArray)(W.tags)&&(we.tags=W.tags.map(j.to)),W.children&&(we.children=W.children.map(ee)),we}ie.to=ee})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var ne;(function(ie){function ge(W){const we=new w.CallHierarchyItem(B.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}ie.to=ge;function ee(W,we,Pe){if(we=we??W._sessionId,Pe=Pe??W._itemId,we===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Pe,name:W.name,detail:W.detail,kind:B.from(W.kind),uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(j.from)}}ie.from=ee})(ne=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(ie){function ge(ee){return new w.CallHierarchyIncomingCall(ne.to(ee.from),ee.fromRanges.map(W=>p.to(W)))}ie.to=ge})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(ie){function ge(ee){return new w.CallHierarchyOutgoingCall(ne.to(ee.to),ee.fromRanges.map(W=>p.to(W)))}ie.to=ge})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ae;(function(ie){function ge(W){return{range:W.range&&p.from(W.range),uri:W.uri}}ie.from=ge;function ee(W){return new w.Location(R.URI.revive(W.uri),p.to(W.range))}ie.to=ee})(ae=e.location||(e.location={}));var le;(function(ie){function ge(W){const we=W,Pe=W;return{originSelectionRange:we.originSelectionRange?p.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Pe.uri,range:p.from(we.targetRange?we.targetRange:Pe.range),targetSelectionRange:we.targetSelectionRange?p.from(we.targetSelectionRange):void 0}}ie.from=ge;function ee(W){return{targetUri:R.URI.revive(W.uri),targetRange:p.to(W.range),targetSelectionRange:W.targetSelectionRange?p.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?p.to(W.originSelectionRange):void 0}}ie.to=ee})(le=e.DefinitionLink||(e.DefinitionLink={}));var Se;(function(ie){function ge(W){return{range:p.from(W.range),contents:a.fromMany(W.contents)}}ie.from=ge;function ee(W){return new w.Hover(W.contents.map(a.to),p.to(W.range))}ie.to=ee})(Se=e.Hover||(e.Hover={}));var Ee;(function(ie){function ge(W){return{range:p.from(W.range),expression:W.expression}}ie.from=ge;function ee(W){return new w.EvaluatableExpression(p.to(W.range),W.expression)}ie.to=ee})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(ie){function ge(W){if(W instanceof w.InlineValueText)return{type:"text",range:p.from(W.range),text:W.text};if(W instanceof w.InlineValueVariableLookup)return{type:"variable",range:p.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ie.from=ge;function ee(W){switch(W.type){case"text":return{range:p.to(W.range),text:W.text};case"variable":return{range:p.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:p.to(W.range),expression:W.expression}}}ie.to=ee})(Fe=e.InlineValue||(e.InlineValue={}));var $e;(function(ie){function ge(W){return{frameId:W.frameId,stoppedLocation:p.from(W.stoppedLocation)}}ie.from=ge;function ee(W){return new w.InlineValueContext(W.frameId,p.to(W.stoppedLocation))}ie.to=ee})($e=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(ie){function ge(W){return{range:p.from(W.range),kind:W.kind}}ie.from=ge;function ee(W){return new w.DocumentHighlight(p.to(W.range),W.kind)}ie.to=ee})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var je;(function(ie){function ge(ee){switch(ee){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ie.to=ge})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var H;(function(ie){function ge(ee){return{triggerKind:je.to(ee.triggerKind),triggerCharacter:ee.triggerCharacter}}ie.to=ge})(H=e.CompletionContext||(e.CompletionContext={}));var G;(function(ie){function ge(W){switch(W){case w.CompletionItemTag.Deprecated:return 1}}ie.from=ge;function ee(W){switch(W){case 1:return w.CompletionItemTag.Deprecated}}ie.to=ee})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ie){const ge=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ee(Pe){return ge.get(Pe)??9}ie.from=ee;const W=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function we(Pe){return W.get(Pe)??w.CompletionItemKind.Property}ie.to=we})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ie){function ge(ee,W){const we=new w.CompletionItem(ee.label);return we.insertText=ee.insertText,we.kind=X.to(ee.kind),we.tags=ee.tags?.map(G.to),we.detail=ee.detail,we.documentation=E.isMarkdownString(ee.documentation)?a.to(ee.documentation):ee.documentation,we.sortText=ee.sortText,we.filterText=ee.filterText,we.preselect=ee.preselect,we.commitCharacters=ee.commitCharacters,F.Range.isIRange(ee.range)?we.range=p.to(ee.range):typeof ee.range=="object"&&(we.range={inserting:p.to(ee.range.insert),replacing:p.to(ee.range.replace)}),we.keepWhitespace=typeof ee.insertTextRules=="undefined"?!1:Boolean(ee.insertTextRules&1),typeof ee.insertTextRules!="undefined"&&ee.insertTextRules&4?we.insertText=new w.SnippetString(ee.insertText):(we.insertText=ee.insertText,we.textEdit=we.range instanceof w.Range?new w.TextEdit(we.range,we.insertText):void 0),ee.additionalTextEdits&&ee.additionalTextEdits.length>0&&(we.additionalTextEdits=ee.additionalTextEdits.map(Pe=>z.to(Pe))),we.command=W&&ee.command?W.fromInternal(ee.command):void 0,we}ie.to=ge})(se=e.CompletionItem||(e.CompletionItem={}));var q;(function(ie){function ge(W){return{label:W.label,documentation:W.documentation?a.fromStrict(W.documentation):void 0}}ie.from=ge;function ee(W){return{label:W.label,documentation:E.isMarkdownString(W.documentation)?a.to(W.documentation):W.documentation}}ie.to=ee})(q=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(ie){function ge(W){return{label:W.label,documentation:W.documentation?a.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}ie.from=ge;function ee(W){return{label:W.label,documentation:E.isMarkdownString(W.documentation)?a.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}ie.to=ee})(te=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(ie){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.from):[]}}ie.from=ge;function ee(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.to):[]}}ie.to=ee})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(ie){function ge(W){return{text:W.text,position:c.from(W.position),kind:xe.from(W.kind??w.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ie.from=ge;function ee(W){const we=new w.InlayHint(W.text,c.to(W.position),xe.to(W.kind));return we.whitespaceAfter=W.whitespaceAfter,we.whitespaceBefore=W.whitespaceBefore,we}ie.to=ee})(Re=e.InlayHint||(e.InlayHint={}));var xe;(function(ie){function ge(W){return W}ie.from=ge;function ee(W){return W}ie.to=ee})(xe=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(ie){function ge(W){return{range:p.from(W.range),url:W.target,tooltip:W.tooltip}}ie.from=ge;function ee(W){let we;if(W.url)try{we=typeof W.url=="string"?R.URI.parse(W.url,!0):R.URI.revive(W.url)}catch{}return new w.DocumentLink(p.to(W.range),we)}ie.to=ee})(ze=e.DocumentLink||(e.DocumentLink={}));var Xe;(function(ie){function ge(W){const we=new w.ColorPresentation(W.label);return W.textEdit&&(we.textEdit=z.to(W.textEdit)),W.additionalTextEdits&&(we.additionalTextEdits=W.additionalTextEdits.map(Pe=>z.to(Pe))),we}ie.to=ge;function ee(W){return{label:W.label,textEdit:W.textEdit?z.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(we=>z.from(we)):void 0}}ie.from=ee})(Xe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ie){function ge(W){return new w.Color(W[0],W[1],W[2],W[3])}ie.to=ge;function ee(W){return[W.red,W.green,W.blue,W.alpha]}ie.from=ee})(et=e.Color||(e.Color={}));var st;(function(ie){function ge(W){return{range:p.from(W.range)}}ie.from=ge;function ee(W){return new w.SelectionRange(p.to(W.range))}ie.to=ee})(st=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ie){function ge(ee){switch(ee){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ie.to=ge})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ie){function ge(W){switch(W){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ie.from=ge;function ee(W){switch(W){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ie.to=ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(ie){function ge(W){if(W===w.EndOfLine.CRLF)return 1;if(W===w.EndOfLine.LF)return 0}ie.from=ge;function ee(W){if(W===1)return w.EndOfLine.CRLF;if(W===0)return w.EndOfLine.LF}ie.to=ee})(lt=e.EndOfLine||(e.EndOfLine={}));var pt;(function(ie){function ge(ee){if(typeof ee=="object")return ee.viewId;switch(ee){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ie.from=ge})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Ft;(function(ie){function ge(ee){const W={start:ee.start+1,end:ee.end+1};return ee.kind&&(W.kind=Oe.from(ee.kind)),W}ie.from=ge})(Ft=e.FoldingRange||(e.FoldingRange={}));var Oe;(function(ie){function ge(ee){if(ee)switch(ee){case w.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}ie.from=ge})(Oe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mt;(function(ie){function ge(ee){if(ee)return{pinned:typeof ee.preview=="boolean"?!ee.preview:void 0,inactive:ee.background,preserveFocus:ee.preserveFocus,selection:typeof ee.selection=="object"?p.from(ee.selection):void 0,override:typeof ee.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ie.from=ge})(Mt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var V;(function(ie){function ge(W){return W instanceof w.RelativePattern||typeof W=="string"?W:ee(W)?new w.RelativePattern(W.base,W.pattern):W}ie.from=ge;function ee(W){const we=W;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(V=e.GlobPattern||(e.GlobPattern={}));var Q;(function(ie){function ge(ee){if(ee){if(Array.isArray(ee))return ee.map(ge);if(typeof ee=="string")return ee;{const W=ee;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:V.from(W.pattern),exclusive:W.exclusive}}}else return}ie.from=ge})(Q=e.LanguageSelector||(e.LanguageSelector={}));var de;(function(ie){function ge(W){return{start:W.start,end:W.end}}ie.from=ge;function ee(W){return new w.NotebookRange(W.start,W.end)}ie.to=ee})(de=e.NotebookRange||(e.NotebookRange={}));var Ne;(function(ie){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ie.to=ge;function ee(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ie.from=ee})(Ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(ie){function ge(W){switch(W){case w.NotebookCellKind.Markup:return g.CellKind.Markup;case w.NotebookCellKind.Code:default:return g.CellKind.Code}}ie.from=ge;function ee(W){switch(W){case g.CellKind.Markup:return w.NotebookCellKind.Markup;case g.CellKind.Code:default:return w.NotebookCellKind.Code}}ie.to=ee})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var ot;(function(ie){function ge(W){const we={metadata:W.metadata??Object.create(null),cells:[]};for(let Pe of W.cells)w.NotebookCellData.validate(Pe),we.cells.push(Ye.from(Pe));return we}ie.from=ge;function ee(W){const we=new w.NotebookData(W.cells.map(Ye.to));return(0,S.isEmptyObject)(W.metadata)||(we.metadata=W.metadata),we}ie.to=ee})(ot=e.NotebookData||(e.NotebookData={}));var Ye;(function(ie){function ge(W){return{cellKind:qe.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Ne.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ae.from):[]}}ie.from=ge;function ee(W){return new w.NotebookCellData(qe.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ae.to):void 0,W.metadata,W.internalMetadata?Ne.to(W.internalMetadata):void 0)}ie.to=ee})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(ie){function ge(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ie.from=ge;function ee(W){return new w.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ie.to=ee})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(ie){function ge(W){return{outputId:W.id,items:W.items.map(yt.from),metadata:W.metadata}}ie.from=ge;function ee(W){const we=W.items.map(yt.to);return new w.NotebookCellOutput(we,W.outputId,W.metadata)}ie.to=ee})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ie){function ge(Pe){if(Pe!=null){if(Pe instanceof w.RelativePattern||typeof Pe=="string")return Pe;if(we(Pe))return new w.RelativePattern(Pe.base,Pe.pattern);if(W(Pe))return{include:V.from(Pe.include)||void 0,exclude:V.from(Pe.exclude)||void 0}}}ie.from=ge;function ee(Pe){return typeof Pe=="string"?Pe:we(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ie.to=ee;function W(Pe){const Qe=Pe,Ue=V.from(Qe.include);if(!(Ue&&Ue instanceof w.RelativePattern||typeof Ue=="string"))return!1;const ut=V.from(Qe.exclude);return!!(ut&&ut instanceof w.RelativePattern||typeof ut=="string")}function we(Pe){const Qe=Pe;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ie){function ge(ee){return{backgroundColor:ee.backgroundColor,borderColor:ee.borderColor,top:ee.top?N.from(ee.top):void 0}}ie.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var re;(function(ie){function ge(ee,W,we){const Pe=typeof ee.command=="string"?{title:"",command:ee.command}:ee.command;return{alignment:ee.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Pe,we),text:ee.text,tooltip:ee.tooltip,accessibilityInformation:ee.accessibilityInformation,priority:ee.priority}}ie.from=ge})(re=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var oe;(function(ie){function ge(ee){return{transientOutputs:ee?.transientOutputs??!1,transientCellMetadata:ee?.transientCellMetadata??{},transientDocumentMetadata:ee?.transientDocumentMetadata??{}}}ie.from=ge})(oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var he;(function(ie){function ge(W){return{uri:W.uri,provides:W.provides}}ie.from=ge;function ee(W){return new w.NotebookRendererScript(R.URI.revive(W.uri),W.provides)}ie.to=ee})(he=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(ie){function ge(W){return{message:a.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ae.from(W.location):void 0}}ie.from=ge;function ee(W){const we=new w.TestMessage(typeof W.message=="string"?W.message:a.to(W.message));return we.actualOutput=W.actual,we.expectedOutput=W.expected,we.location=W.location?ae.to(W.location):void 0,we}ie.to=ee})(me=e.TestMessage||(e.TestMessage={}));var Te;(function(ie){let ge;(function(ee){ee.Delimiter="\0"})(ge||(ge={})),ie.namespace=(ee,W)=>ee+"\0"+W,ie.denamespace=ee=>{const W=ee.indexOf("\0");return{ctrlId:ee.slice(0,W),tagId:ee.slice(W+1)}}})(Te=e.TestTag||(e.TestTag={}));var We;(function(ie){function ge(Pe){const Qe=(0,r.getPrivateApiFor)(Pe).controllerId;return{extId:l.TestId.fromExtHostTestItem(Pe,Qe).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Ue=>Te.namespace(Qe,Ue.id)),range:p.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&a.fromStrict(Pe.error)||null}}ie.from=ge;function ee(Pe){return{parent:void 0,error:void 0,id:l.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:R.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Qe=>{const{tagId:Ue}=Te.denamespace(Qe);return new w.TestTag(Ue)}),range:p.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ie.toPlain=ee;function W(Pe){const Qe=l.TestId.fromString(Pe.extId),Ue=new r.TestItemImpl(Qe.controllerId,Qe.localId,Pe.label,R.URI.revive(Pe.uri));return Ue.range=p.to(Pe.range||void 0),Ue.description=Pe.description||void 0,Ue}function we(Pe){let Qe;for(const Ue of Pe.tests){const ut=W(Ue.item);(0,r.getPrivateApiFor)(ut).parent=Qe,Qe=ut}return Qe}ie.toItemFromContext=we})(We=e.TestItem||(e.TestItem={})),function(ie){function ge(W){return{id:W.id}}ie.from=ge;function ee(W){return new w.TestTag(W.id)}ie.to=ee}(Te=e.TestTag||(e.TestTag={}));var Le;(function(ie){const ge=(W,we)=>{const Pe={...We.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(Ue=>Ue.type===0).map(me.to)})),children:W.children.map(Qe=>we.get(Qe)).filter(S.isDefined).map(Qe=>ge(Qe,we))};for(const Qe of Pe.children)Qe.parent=Pe;return Pe};function ee(W){const we=[],Pe=new Map;for(const Qe of W.items)Pe.set(Qe.item.extId,Qe),W.request.targets.some(Ue=>Ue.controllerId===Qe.controllerId&&Ue.testIds.includes(Qe.item.extId))&&we.push(Qe);return{completedAt:W.completedAt,results:we.map(Qe=>ge(Qe,Pe))}}ie.to=ee})(Le=e.TestResults||(e.TestResults={}));var Ke;(function(ie){function ge(Pe){return{covered:Pe.covered,total:Pe.covered}}function ee(Pe){return"line"in Pe?c.from(Pe):p.from(Pe)}function W(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ee(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ee(Qe.location)})):void 0}:{type:0,count:Pe.executionCount,location:ee(Pe.location)}}ie.fromDetailed=W;function we(Pe){return{uri:Pe.uri,statement:ge(Pe.statementCoverage),branch:Pe.branchCoverage&&ge(Pe.branchCoverage),function:Pe.functionCoverage&&ge(Pe.functionCoverage),details:Pe.detailedCoverage?.map(W)}}ie.fromFile=we})(Ke=e.TestCoverage||(e.TestCoverage={}));var it;(function(ie){function ge(ee){switch(ee){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ie.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ie){function ge(W){const we=new w.TypeHierarchyItem(B.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}ie.to=ge;function ee(W,we,Pe){if(we=we??W._sessionId,Pe=Pe??W._itemId,we===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Pe,kind:B.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(j.from)}}ie.from=ee})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ye[164],Ce([0,1,2,15,7,8,225]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(R,F,C,n={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=C,this._thresholds=n,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,C,n)=>{const r={dispose:this._callbacks.push([F,C,R])};return Array.isArray(n)&&n.push(r),r}}async $participateInSave(R,F){const C=s.URI.revive(R);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),r=[];try{for(let g of[...this._callbacks]){if(n)break;const l=this._documents.getDocument(C),D=await this._deliverEventAsyncAndBlameBadListeners(g,{document:l,reason:A.TextDocumentSaveReason.to(F)});r.push(D)}}finally{clearTimeout(m)}return r}_deliverEventAsyncAndBlameBadListeners([R,F,C],n){const m=this._badListeners.get(R);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,R,F,n).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const g=this._badListeners.get(R);this._badListeners.set(R,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,C,n){const m=[],r=Date.now(),{document:g,reason:l}=n,{version:D}=g,w=Object.freeze({document:g,reason:l,waitUntil(d){if(Object.isFrozen(m))throw(0,t.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(d))}});try{F.apply(C,[w])}catch(d){return Promise.reject(d)}return Object.freeze(m),new Promise((d,p)=>{const I=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(I),d(c)}).catch(c=>{clearTimeout(I),p(c)})}).then(d=>{const p={edits:[]};for(const I of d)if(Array.isArray(I)&&I.every(c=>c instanceof E.TextEdit))for(const{newText:c,newEol:M,range:o}of I)p.edits.push({_type:2,resource:g.uri,edit:{range:o&&A.Range.from(o),text:c,eol:M&&A.EndOfLine.from(M)}});if(p.edits.length!==0)return D===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(ye[165],Ce([0,1,4,29,2,8,7]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(F,C,n,m,r){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),r&&(this._config+=4);const g=(0,t.parse)(C),l=F(D=>{if(!n)for(let w of D.created){const d=E.URI.revive(w);g(d.fsPath)&&this._onDidCreate.fire(d)}if(!m)for(let w of D.changed){const d=E.URI.revive(w);g(d.fsPath)&&this._onDidChange.fire(d)}if(!r)for(let w of D.deleted){const d=E.URI.revive(w);g(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,l)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(F,C,n){this._logService=C,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,C,n,m){return new T(this._onFileSystemEvent.event,F,C,n,m)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,C){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:C.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,C){return(n,m,r)=>{const g=function(D){n.call(m,D)};return g.extension=F,C.event(g,void 0,r)}}async $onWillRunFileOperation(F,C,n,m){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(r=>({oldUri:E.URI.revive(r.source),newUri:E.URI.revive(r.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(r=>E.URI.revive(r.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(r=>E.URI.revive(r.target))},n,m)}}async _fireWillEvent(F,C,n,m){const r=new Set,g=[];if(await F.fireAsync(C,m,async(D,w)=>{const d=Date.now(),p=await Promise.resolve(D);p instanceof k.WorkspaceEdit&&(g.push(p),r.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-d>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||g.length===0)return;const l={edits:[]};for(let D of g){let{edits:w}=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);l.edits=l.edits.concat(w)}return{edit:l,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=S}),define(ye[166],Ce([0,1,10,26,2,8,7,87]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,m,r,g){this.start=n,this.deletedCount=m,this.deletedItems=r,this.items=g}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(r=>r.apiCell)}))}}class R{constructor(n,m,r){this.notebook=n,this._extHostDocument=m,this._cellData=r,this.handle=r.handle,this.uri=E.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=r.internalMetadata??{},this._metadata=Object.freeze(r.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(r.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(r){n._mime=r},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,m,r){const g=r.map(A.NotebookCellOutputItem.to),l=this._outputs.find(D=>D.id===n);l&&(m||(l.items.length=0),l.items.push(...g))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=R;class F{constructor(n,m,r,g,l,D){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=r,this._emitter=g,this.uri=l,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===s.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(g=>g.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const r of n.rawEvents)r.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===T.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(r.index,r.mime):r.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(r.index,r.metadata):r.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(r.index,r.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,r=n.end|0;return m<0&&(m=0),r>this._cells.length&&(r=this._cells.length),n.with({start:m,end:r})}_getCells(n){n=this._validateRange(n);const m=[];for(let r=n.start;r<n.end;r++)m.push(this._cells[r]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const r=[],g=[],l=[];n.reverse().forEach(D=>{const d=D[2].map(c=>{const M=new R(this,this._textDocumentsAndEditors,c);return m||g.push(R.asModelAddData(this.apiNotebook,c)),M}),p=new S(D[0],D[1],[],d),I=this._cells.splice(D[0],D[1],...d);for(const c of I)l.push(c.uri),p.deletedItems.push(c.apiCell);r.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:l}),m||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}_moveCell(n,m){const r=this._cells.splice(n,1);this._cells.splice(m,0,...r);const g=[new S(n,1,r.map(l=>l.apiCell),[]),new S(m,0,[],r)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(g)}))}_setCellOutputs(n,m){const r=this._cells[n];r.setOutputs(m),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(n,m,r,g){const l=this._cells[n];l.setOutputItems(m,r,g),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_changeCellLanguage(n,m){const r=this._cells[n];r.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(r.uri,m)}_changeCellMime(n,m){const r=this._cells[n];r.apiCell.mime=m}_changeCellMetadata(n,m){const r=this._cells[n],g=r.apiCell.metadata;r.setMetadata(m);const l=r.apiCell.metadata;(0,t.equals)(g,l)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:r.apiCell}))}_changeCellInternalMetadata(n,m){const r=this._cells[n],g=r.internalMetadata;if(r.setInternalMetadata(m),g.runState!==m.runState){const l=m.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,t.deepFreeze)({document:this.apiNotebook,cell:r.apiCell,state:l}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(ye[91],Ce([0,1,7,8,15]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:R})}replaceCells(S,R,F){this._throwIfFinalized(),!(S===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:S,count:R-S,cells:F.map(t.NotebookCellData.from)})}}class k{constructor(S,R,F,C,n,m){this.id=S,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=C,this._viewColumn=m}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(R){if(!Array.isArray(R)||!R.every(s.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");S._selections=R,S._trySetSelections(R)},get visibleRanges(){return S._visibleRanges},revealRange(R,F){S._proxy.$tryRevealRange(S.id,t.NotebookRange.from(R),F??s.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(R){const F=new A(this.document.version);return R(F),S._applyEdit(F.finalize())},setDecorations(R,F){return S.setDecorations(R,F)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(t.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let C=0;C<S.cellEdits.length;C++){if(F<0){R.push(S.cellEdits[C]),F++;continue}const m=R[F],r=S.cellEdits[C];if(m.editType===1&&r.editType===1&&m.index===r.index){m.cells.push(...S.cellEdits[C].cells),m.count+=S.cellEdits[C].count;continue}R.push(S.cellEdits[C]),F++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,R)}setDecorations(S,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return R.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(R),S.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(ye[167],Ce([0,1,8,139,120,20,52,15]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,r){const g=this._handles++,{title:l,location:D,cancellable:w}=m,d={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(g,{location:s.ProgressLocation.from(D),title:l,source:d,cancellable:w},n).catch(T.onUnexpectedExternalError),this._withProgress(g,r,!!w)}_withProgress(n,m,r){let g;r&&(g=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,g));const l=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),g&&g.dispose()};let D;try{D=m(new F(this._proxy,n),r&&g?g.token:A.CancellationToken.None)}catch(w){throw l(n),w}return D.then(w=>l(n),w=>l(n)),D}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=S;function R(C,n){return C.message=n.message,typeof n.increment=="number"&&(typeof C.increment=="number"?C.increment+=n.increment:C.increment=n.increment),C}class F extends t.Progress{constructor(n,m){super(r=>this.throttledReport(r));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Be([(0,k.throttle)(100,(C,n)=>R(C,n),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(ye[92],Ce([0,1,41,15,53,8,7]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(n,m,r){const g=T._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,g,A.DecorationRenderOptions.from(r)),this.value=Object.freeze({key:g,dispose(){n.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=T,T._Keys=new E.IdGenerator("TextEditorDecorationType");class S{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let r=null;if(n instanceof k.Position)r=new k.Range(n,n);else if(n instanceof k.Range)r=n;else throw new Error("Unrecognized location");this._pushEdit(r,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new k.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof k.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,r){const g=this._document.validateRange(n);this._collectedEdits.push({range:g,text:m,forceMoveMarkers:r})}setEndOfLine(n){if(this._throwIfFinalized(),n!==k.EndOfLine.LF&&n!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class R{constructor(n,m,r,g){this._proxy=n,this._id=m,this._accept(r),this._logService=g;const l=this;this.value={get tabSize(){return l._tabSize},set tabSize(D){l._setTabSize(D)},get insertSpaces(){return l._insertSpaces},set insertSpaces(D){l._setInsertSpaces(D)},get cursorStyle(){return l._cursorStyle},set cursorStyle(D){l._setCursorStyle(D)},get lineNumbers(){return l._lineNumbers},set lineNumbers(D){l._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let r=!1;if(typeof n.tabSize!="undefined"){const g=this._validateTabSize(n.tabSize);g==="auto"?(r=!0,m.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,r=!0,m.tabSize=g)}if(typeof n.insertSpaces!="undefined"){const g=this._validateInsertSpaces(n.insertSpaces);g==="auto"?(r=!0,m.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,r=!0,m.insertSpaces=g)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,r=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,r=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),r&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,m))}_warnOnError(n,m){m.catch(r=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(r)})}}e.ExtHostTextEditorOptions=R;class F{constructor(n,m,r,g,l,D,w,d){this.id=n,this._proxy=m,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._options=new R(this._proxy,this.id,D,r),this._visibleRanges=w,this._viewColumn=d;const p=this;this.value=Object.freeze({get document(){return g.getValue()},set document(I){throw(0,t.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(I){if(!(I instanceof k.Selection))throw(0,t.illegalArgument)("selection");p._selections=[I],p._trySetSelection()},get selections(){return p._selections},set selections(I){if(!Array.isArray(I)||I.some(c=>!(c instanceof k.Selection)))throw(0,t.illegalArgument)("selections");p._selections=I,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(I){throw(0,t.readonly)("visibleRanges")},get options(){return p._options.value},set options(I){p._disposed||p._options.assign(I)},get viewColumn(){return p._viewColumn},set viewColumn(I){throw(0,t.readonly)("viewColumn")},edit(I,c={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new S(g.getValue(),c);return I(M),p._applyEdit(M)},insertSnippet(I,c,M={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!c||Array.isArray(c)&&c.length===0)o=p._selections.map(i=>A.Range.from(i));else if(c instanceof k.Position){const{lineNumber:i,column:f}=A.Position.from(c);o=[{startLineNumber:i,startColumn:f,endLineNumber:i,endColumn:f}]}else if(c instanceof k.Range)o=[A.Range.from(c)];else{o=[];for(const i of c)if(i instanceof k.Range)o.push(A.Range.from(i));else{const{lineNumber:f,column:u}=A.Position.from(i);o.push({startLineNumber:f,startColumn:u,endLineNumber:f,endColumn:u})}}return m.$tryInsertSnippet(n,I.value,o,M)},setDecorations(I,c){const M=c.length===0;M&&!p._hasDecorationsForKey.has(I.key)||(M?p._hasDecorationsForKey.delete(I.key):p._hasDecorationsForKey.add(I.key),p._runOnProxy(()=>{if(A.isDecorationOptionsArr(c))return m.$trySetDecorations(n,I.key,A.fromRangeOrRangeWithMessage(c));{const o=new Array(4*c.length);for(let i=0,f=c.length;i<f;i++){const u=c[i];o[4*i]=u.start.line+1,o[4*i+1]=u.start.character+1,o[4*i+2]=u.end.line+1,o[4*i+3]=u.end.character+1}return m.$trySetDecorationsFast(n,I.key,o)}}))},revealRange(I,c){p._runOnProxy(()=>m.$tryRevealRange(n,A.Range.from(I),c||k.TextEditorRevealType.Default))},show(I){m.$tryShowEditor(n,A.ViewColumn.from(I))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,s.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,s.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,s.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,s.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const r=m.edits.map(l=>l.range);r.sort((l,D)=>l.end.line===D.end.line?l.end.character===D.end.character?l.start.line===D.start.line?l.start.character-D.start.character:l.start.line-D.start.line:l.end.character-D.end.character:l.end.line-D.end.line);for(let l=0,D=r.length-1;l<D;l++){const w=r[l].end;if(r[l+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=m.edits.map(l=>({range:A.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,g,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=F}),define(ye[168],Ce([0,1,123,24,2,4,6,14,7,11,16,8,20,152]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function r(D,w){if((0,R.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let d;return Array.isArray(D.highlights)&&(d=D.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),d=d.length?d:void 0),{label:D.label,highlights:d}}}class g{constructor(w,d,p){this._proxy=w,this.commands=d,this.logService=p,this.treeViews=new Map;function I(c){return c&&c.$treeViewId&&c.$treeItemHandle}d.registerArgumentProcessor({processArgument:c=>I(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(M=>I(M)?this.convertArgument(M):M):c})}registerTreeDataProvider(w,d,p){const I=this.createTreeView(w,{treeDataProvider:d},p);return{dispose:()=>I.dispose()}}createTreeView(w,d,p){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const I=d.dragAndDropController?.supportedMimeTypes,c=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,dragAndDropMimeTypes:I}),M=this.createExtHostTreeView(w,d,p);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(o){M.message=o},get title(){return M.title},set title(o){M.title=o},get description(){return M.description},set description(o){M.description=o},reveal:(o,i)=>M.reveal(o,i),dispose:async()=>{await c,this.treeViews.delete(w),M.dispose()}}}$getChildren(w,d){const p=this.treeViews.get(w);return p?p.getChildren(d):Promise.reject(new Error((0,s.localize)(0,null,w)))}async $onDrop(w,d,p,I,c){const M=this.treeViews.get(w);if(!M)return Promise.reject(new Error((0,s.localize)(1,null,w)));const o=m.TreeDataTransferConverter.toITreeDataTransfer(d);if(I===w&&c){const i=await M.onWillDrop(c);i&&i.forEach((f,u)=>{f&&o.set(u,f)})}return M.onDrop(o,p)}async $hasResolve(w){const d=this.treeViews.get(w);if(!d)throw new Error((0,s.localize)(2,null,w));return d.hasResolve}$resolve(w,d,p){const I=this.treeViews.get(w);if(!I)throw new Error((0,s.localize)(3,null,w));return I.resolveTreeItem(d,p)}$setExpanded(w,d,p){const I=this.treeViews.get(w);if(!I)throw new Error((0,s.localize)(4,null,w));I.setExpanded(d,p)}$setSelection(w,d){const p=this.treeViews.get(w);if(!p)throw new Error((0,s.localize)(5,null,w));p.setSelection(d)}$setVisible(w,d){const p=this.treeViews.get(w);if(!p)throw new Error((0,s.localize)(6,null,w));p.setVisible(d)}createExtHostTreeView(w,d,p){const I=new l(w,d,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(w,I),I}convertArgument(w){const d=this.treeViews.get(w.$treeViewId);return d?d.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=g;class l extends k.Disposable{constructor(w,d,p,I,c,M){super();if(this.viewId=w,this.proxy=p,this.commands=I,this.logService=c,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const f in M.contributes.views)for(const u of M.contributes.views[f])u.id===w&&(this._title=u.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let o,i;this._register(A.Event.debounce(this._onDidChangeData.event,(f,u)=>(f||(f={message:!1,elements:[]}),u.element!==!1&&(o||(o=new Promise(h=>i=h),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(u.element)?f.elements.push(...u.element):f.elements.push(u.element)),u.message&&(f.message=!0),f),200,!0)(({message:f,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=i;return o=null,this.refresh(u).then(()=>h())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,R.isUndefinedOrNull)(w))}async getChildren(w){const d=w?this.getExtensionElement(w):void 0;if(w&&!d)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(w);return p||(p=await this.fetchChildrenNodes(d)),p?p.map(I=>I.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,d){d=d||{select:!0,focus:!1};const p=(0,R.isUndefinedOrNull)(d.select)?!0:d.select,I=(0,R.isUndefinedOrNull)(d.focus)?!1:d.focus,c=(0,R.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(M=>this.resolveTreeNode(w,M[M.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:M.map(i=>i.item)},{select:p,focus:I,expand:c})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:I,expand:c})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,d){const p=this.getExtensionElement(w);p&&(d?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(w){(0,F.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(w){const d=[];for(const p of w){const I=this.getExtensionElement(p);I&&d.push(I)}if(!(!this.dndController?.onWillDrop||d.length===0))return this.dndController.onWillDrop(d)}async onDrop(w,d){const p=this.getExtensionElement(d);if(!!p)return(0,T.asPromise)(()=>this.dndController?.onDrop(w,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,d){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(w);if(p){const I=this.nodes.get(p);if(I){const c=await this.dataProvider.resolveTreeItem(I.extensionItem,p,d)??I.extensionItem;return I.item.tooltip=this.getTooltip(c.tooltip),I.item.command=this.getCommand(I.disposableStore,c.command),I.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(d=>d?this.resolveUnknownParentChain(d).then(p=>this.resolveTreeNode(d,p[p.length-1]).then(I=>(p.push(I),p))):Promise.resolve([]))}resolveParent(w){const d=this.nodes.get(w);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,T.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,d){const p=this.nodes.get(w);return p?Promise.resolve(p):(0,T.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(I=>this.createHandle(w,I,d,!0)).then(I=>this.getChildren(d?d.item.handle:void 0).then(()=>{const c=this.getExtensionElement(I);if(c){const M=this.nodes.get(c);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${I}`)}))}getChildrenNodes(w){if(w){let d;if(typeof w=="string"){const p=this.getExtensionElement(w);d=p?this.nodes.get(p):void 0}else d=w;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const d=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=w?this.nodes.get(w):void 0,I=await this.dataProvider.getChildren(w);if(d.token.isCancellationRequested)return;const c=await Promise.all((0,F.coalesce)(I||[]).map(async M=>{const o=await this.dataProvider.getTreeItem(M);return o&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(M,o,p):null}));return d.token.isCancellationRequested?void 0:(0,F.coalesce)(c)}finally{d.dispose()}}refresh(w){if(w.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(w);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const d=new Set,p=w.map(c=>this.nodes.get(c));for(const c of p)if(c&&!d.has(c.item.handle)){let M=c;for(;M&&M.parent&&p.findIndex(o=>M&&M.parent&&o&&o.item.handle===M.parent.item.handle)===-1;){const o=this.elements.get(M.parent.item.handle);M=o?this.nodes.get(o):void 0}M&&!M.parent&&d.add(c.item.handle)}const I=[];return d.forEach(c=>{const M=this.elements.get(c);if(M){const o=this.nodes.get(M);o&&(!o.parent||!d.has(o.parent.item.handle))&&I.push(c)}}),I}refreshHandles(w){const d={};return Promise.all(w.map(p=>this.refreshNode(p).then(I=>{I&&(d[p]=I.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(w){const d=this.getExtensionElement(w);if(d){const p=this.nodes.get(d);if(p)return this.clearChildren(d),(0,T.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(I=>{if(I){const c=this.createTreeNode(d,I,p.parent);return this.updateNodeCache(d,c,p,p.parent),p.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,d,p){const I=this.createTreeNode(w,d,p);if(d.id&&this.elements.has(I.item.handle))throw new Error((0,s.localize)(7,null,d.id));return this.addNodeToCache(w,I),this.addNodeToParentCache(I,p),I}getTooltip(w){return S.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,d){return d?this.commands.toInternal(d,w):void 0}createTreeNode(w,d,p){const I=new k.DisposableStore,c=this.createHandle(w,d,p),M=this.getLightIconPath(d);return{item:{handle:c,parentHandle:p?p.item.handle:void 0,label:r(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(I,d.command),contextValue:d.contextValue,icon:M,iconDark:this.getDarkIconPath(d)||M,themeIcon:this.getThemeIcon(d),collapsibleState:(0,R.isUndefinedOrNull)(d.collapsibleState)?S.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:p,children:void 0,disposableStore:I,dispose(){I.dispose()}}}getThemeIcon(w){return w.iconPath instanceof S.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:d,label:p,resourceUri:I},c,M){if(d)return`${l.ID_HANDLE_PREFIX}/${d}`;const o=r(p,this.extension),i=c?c.item.handle:l.LABEL_HANDLE_PREFIX;let f=o?o.label:I?(0,t.basename)(I):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const u=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,h=this.getChildrenNodes(c)||[];let b,v=0;do{if(b=`${i}/${v}:${f}`,M||!this.elements.has(b)||u===b)break;v++}while(v<=h.length);return b}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof S.ThemeIcon))return typeof w.iconPath=="string"||E.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof S.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return E.URI.isUri(w)?w:E.URI.file(w)}addNodeToCache(w,d){this.elements.set(d.item.handle,w),this.nodes.set(w,d)}updateNodeCache(w,d,p,I){this.elements.delete(d.item.handle),this.nodes.delete(w),d.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(w,d);const c=this.getChildrenNodes(I)||[],M=c.filter(o=>o.item.handle===p.item.handle)[0];M&&c.splice(c.indexOf(M),1,d)}addNodeToParentCache(w,d){d?(d.children||(d.children=[]),d.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const d=this.nodes.get(w);if(d){if(d.children)for(const p of d.children){const I=this.elements.get(p.item.handle);I&&this.clear(I)}d.children=void 0}}else this.clearAll()}clear(w){const d=this.nodes.get(w);if(d){if(d.children)for(const p of d.children){const I=this.elements.get(p.item.handle);I&&this.clear(I)}this.nodes.delete(w),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}l.LABEL_HANDLE_PREFIX="0",l.ID_HANDLE_PREFIX="1"}),define(ye[169],Ce([0,1,14,4,6,11,47,8,88,67]),function(Z,e,s,t,E,A,k,T,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const r=this.tree.get(n);if(!!r){if((r.expandLevels===void 0||m>r.expandLevels)&&(r.expandLevels=m),r.expand===1){const g=this.resolveChildren(r);return g.isOpen()?this.expandChildren(r,m-1):g.wait().then(()=>this.expandChildren(r,m-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,m-1)):this.expandChildren(r,m-1)}}dispose(){for(const n of this.tree.values())(0,k.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(R.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const r of m.ops)this.onTestItemEvent(n,r);break;case 3:{const{key:r,value:g,previous:l}=m,D=n.fullId.toString();switch(r){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(g,l,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:T.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:T.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[r]:g??null}}]);break}break}default:(0,A.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const r=R.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),g=(0,k.getPrivateApiFor)(n);g.parent&&g.parent!==m?.actual&&g.parent.children.delete(n.id);let l=this.tree.get(r.toString());if(!l){l={fullId:r,actual:n,parent:m?r.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(l.fullId.toString(),l),this.setItemParent(n,m),this.pushDiff([0,{parent:l.parent&&l.parent.toString(),controllerId:this.controllerId,expand:l.expand,item:T.TestItem.from(n)}]),this.connectItemAndChildren(n,l,m);return}if(l.actual===n){this.connectItem(n,l,m);return}const D=l.actual.children,w=l.actual,d=(0,k.diffTestItems)(w,n);(0,k.getPrivateApiFor)(w).listener=void 0,l.actual=n,l.expand=0;for(const[p,I]of d)this.onTestItemEvent(l,{op:3,key:p,value:I,previous:w[p]});this.connectItemAndChildren(n,l,m);for(const p of D)n.children.get(p.id)||this.removeItem(R.TestId.joinToString(r,p.id))}diffTagRefs(n,m,r){const g=new Set(m.map(l=>l.id));for(const l of n)g.delete(l.id)||this.incrementTagRefs(l);this.pushDiff([1,{extId:r,item:{tags:n.map(l=>T.TestTag.namespace(this.controllerId,l.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,T.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,k.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,r){this.setItemParent(n,r);const g=(0,k.getPrivateApiFor)(n);g.parent=r?.actual,g.listener=l=>this.onTestItemEvent(m,l),this.updateExpandability(m)}connectItemAndChildren(n,m,r){this.connectItem(n,m,r);for(const g of n.children)this.upsertItem(g,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const r=[];for(const g of n.actual.children){const l=this.expand(R.TestId.joinToString(n.fullId,g.id),m);(0,s.isThenable)(l)&&r.push(l)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const l=new s.Barrier;return l.open(),l}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new s.Barrier,r=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=l.stack||l.message||String(l))};let g;try{g=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(l){r(l)}return(0,s.isThenable)(g)?g.catch(r).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const r=[m];for(;r.length;){const g=r.pop();if(!!g){(0,k.getPrivateApiFor)(g.actual).listener=void 0;for(const l of g.actual.tags)this.decrementTagRefs(l.id);this.tree.delete(g.fullId.toString());for(const l of g.actual.children)r.push(this.tree.get(R.TestId.joinToString(g.fullId,l.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=F}),define(ye[170],Ce([0,1,3,135]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[171],Ce([0,1,25,4,17]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=A;class k{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let C of F.activationEvents)C==="onUri"&&(C=`onUri:${s.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(F)}}keepOnly(F){const C=new Set;F.forEach(n=>C.add(s.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>C.has(s.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,C){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const n=k._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(n.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(r=>m.add(s.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!m.has(s.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(F){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(l){this._nodesSet.has(l)||(this._nodesSet.add(l),this._nodesArr.push(l))}addArc(l,D){this.addNode(l),this.addNode(D),this._arcs.has(l)?this._arcs.get(l).push(D):this._arcs.set(l,[D])}getArcs(l){return this._arcs.has(l)?this._arcs.get(l):[]}hasOnlyGoodArcs(l,D){const w=C.getArcs(l);for(let d=0;d<w.length;d++)if(!D.has(w[d]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let l of F){const D=s.ExtensionIdentifier.toKey(l.identifier);if(n.set(D,l),l.extensionDependencies)for(let w of l.extensionDependencies){const d=s.ExtensionIdentifier.toKey(w);C.addArc(D,d)}}let m=new Set;C.getNodes().filter(l=>C.getArcs(l).length===0).forEach(l=>m.add(l));let r=C.getNodes().filter(l=>!m.has(l)),g;do{g=!1;for(let l=0;l<r.length;l++){const D=r[l];C.hasOnlyGoodArcs(D,m)&&(r.splice(l,1),l--,m.add(D),g=!0)}}while(g);return r.map(l=>n.get(l))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const C=this._activationMap.get(F);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const C=this._extensionsMap.get(s.ExtensionIdentifier.toKey(F));return C||void 0}}e.ExtensionDescriptionRegistry=k;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function S(R,F){const C=R.isBuiltin?0:R.isUnderDevelopment?2:1,n=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(C!==n)return C-n;const m=E.posix.basename(R.extensionLocation.path),r=E.posix.basename(F.extensionLocation.path);return m<r?-1:m>r?1:0}}),define(ye[172],Ce([0,1,22]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(T){const S=s.VSBuffer.alloc(1);switch(T){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function k(T,S){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=k}),define(ye[27],Ce([0,1,4,2,3,25,142]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var T;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class R{constructor(I){this.dependency=I}}e.MissingExtensionDependency=R;var F;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=C;function n(p,I){return p.enabledApiProposals?p.enabledApiProposals.includes(I):!1}e.isProposedApiEnabled=n;function m(p,I){if(!n(p,I))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${I}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${I}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=m;class r{constructor(I,c,M,o){this.codeLoadingTime=I,this.activateCallTime=c,this.activateResolvedTime=M,this.activationReason=o}}e.ActivationTimes=r;class g{constructor(I,c){this.description=I,this.value=c}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var l;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(l=e.ActivationKind||(e.ActivationKind={}));function D(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=D;function w(p,I){return{identifier:new A.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!I,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=w;class d{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(I){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(I){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(I){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(I){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(I,c){return Promise.resolve()}_onWillActivateExtension(I){}_onDidActivateExtension(I,c,M,o,i){}_onDidActivateExtensionError(I,c){}_onExtensionRuntimeError(I,c){}_onExtensionHostExit(I){}}e.NullExtensionService=d}),define(ye[173],Ce([0,1,15,25,27,12]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class T{constructor(g,l,D,w){this.startup=g,this.codeLoadingTime=l,this.activateCallTime=D,this.activateResolvedTime=w}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,l){return g===-1||l===-1?-1:l-g}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class R{constructor(g,l,D,w,d,p){this.activationFailed=g,this.activationFailedError=l,this.activationTimes=D,this.module=w,this.exports=d,this.subscriptions=p}}e.ActivatedExtension=R;class F extends R{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class C extends R{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class n extends R{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let m=class{constructor(g,l,D,w,d){this._logService=d,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,l.forEach(p=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(p))),this._hostExtensionsMap=new Map,D.forEach(p=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(p),p)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const l=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(l)}getActivatedExtension(g){const l=t.ExtensionIdentifier.toKey(g),D=this._activatedExtensions.get(l);if(!D)throw new Error("Extension `"+g.value+"` is not known or not activated");return D}activateByEvent(g,l){if(this._alreadyActivatedEvents[g])return k;const D=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(D.map(w=>({id:w.identifier,reason:{startup:l,extensionId:w.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,l){const D=this._registry.getExtensionDescription(g);if(!D)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:D.identifier,reason:l}])}_handleActivateRequest(g,l,D){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){l[t.ExtensionIdentifier.toKey(g.id)]=g;return}const w=this._registry.getExtensionDescription(g.id);if(!w){const I=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,I,new E.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new n(I));return}const d=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let p=!0;for(let I=0,c=d.length;I<c;I++){const M=d[I];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const h=w.displayName||w.identifier.value,b=this._registry.getExtensionDescription(M),v=b&&b.displayName||M,a=new Error(`Cannot activate the '${h}' extension because its dependency '${v}' failed to activate`);a.detail=o.activationFailedError,this._host.onExtensionActivationError(w.identifier,a,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(w.identifier),new n(a));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){p=!1,l[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;p=!1,l[t.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:g.reason};continue}const f=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(w.identifier,u,new E.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(w.identifier),new n(u));return}p?l[t.ExtensionIdentifier.toKey(w.identifier)]=g:D.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(d=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(d.id))),g.length===0))return Promise.resolve(void 0);const l=Object.create(null),D=[];for(let d=0,p=g.length;d<p;d++)this._handleActivateRequest(g[d],l,D);for(let d=0,p=D.length;d<p;d++){const I=t.ExtensionIdentifier.toKey(D[d].id);l[I]&&delete l[I]}const w=Object.keys(l).map(d=>l[d]);return D.length===0?Promise.all(w.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(w).then(d=>this._activateExtensions(D))}_activateExtension(g,l){const D=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const w=this._activatingExtensions.get(D);if(w)return w;const d=this._host.actualActivateExtension(g,l).then(void 0,p=>{const I=new Error;return p&&p.name&&(I.name=p.name),p&&p.message?I.message=`Activating extension '${g.value}' failed: ${p.message}.`:I.message=`Activating extension '${g.value}' failed: ${p}.`,p&&p.stack&&(I.stack=p.stack),this._isDisposed&&s.isPromiseCanceledError(p)?new n(p):(this._host.onExtensionActivationError(g,I,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(p),new n(p))}).then(p=>{this._activatedExtensions.set(D,p),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,d),d}};m=Be([He(4,A.ILogService)],m),e.ExtensionsActivator=m}),define(ye[174],Ce([0,1,12,28,27]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends s.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:E.ExtensionHostLogFileName}))}};A=Be([He(0,s.ILoggerService),He(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ye[175],Ce([0,1,15]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,k)=>{this._actualOk=A,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,s.onUnexpectedError)(A))}then(A,k){return this._ensureActual().then(A,k)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=t}),define(ye[37],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(R,F){this._proxyIdentifierBrand=void 0,this.isMain=R,this.sid=F,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const t=[];function E(S){const R=new s(!0,S);return t[R.nid]=R,R}e.createMainContextProxyIdentifier=E;function A(S){const R=new s(!1,S);return t[R.nid]=R,R}e.createExtHostContextProxyIdentifier=A;function k(S){return t[S].sid}e.getStringIdentifierForProxy=k;class T{constructor(R){this.value=R}}e.SerializableObjectWithBuffers=T}),define(ye[5],Ce([0,1,54,2,37]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var k;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(d){d.name="$ident";function p(c,M){return Object.defineProperty(c,d.name,{value:M,enumerable:!0}),c}d.mixin=p;function I(c){return c[d.name]}d.of=I})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(p){return p._id=m._n++,p}}e.IdObject=m,m._n=0;var r;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var l;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(l=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(d){if(d&&d.edits)for(const p of d.edits)typeof p.resource=="object"?p.resource=t.URI.revive(p.resource):(p.newUri=t.URI.revive(p.newUri),p.oldUri=t.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,s.revive)(p.metadata));return d}e.reviveWorkspaceEditDto=D;var w;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ye[68],Ce([0,1,5,4,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,S){return this._proxy.$getPassword(T,S)}store(T,S,R){return this._proxy.$setPassword(T,S,R)}delete(T,S){return this._proxy.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(ye[69],Ce([0,1,3,12,5,13]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(S,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(E.MainContext.MainThreadTelemetry)}report(S,R,F){const C=this.getUsageKey(S,R);this._reportedUsages.has(C)||(this._reportedUsages.add(C),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:S}))}getUsageKey(S,R){return`${S}-${R.identifier.value}`}};k=Be([He(0,A.IExtHostRpcService),He(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,R){}})}),define(ye[176],Ce([0,1,4,5,7,25]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,R,F,C={}){const n=A.ExtensionIdentifier.toKey(S.identifier),m=this._inFlightRequests.get(n)||[],r=[...F].sort().join(" ");let g=m.find(l=>l.scopes===r);if(g)return g.result;{const l=this._getSession(S,n,R,F,C);g={scopes:r,result:l},m.push(g),this._inFlightRequests.set(n,m);try{await l}finally{const D=m.findIndex(w=>w.scopes===r);D>-1&&(m.splice(D),this._inFlightRequests.set(n,m))}return l}}async _getSession(S,R,F,C,n={}){await this._proxy.$ensureProvider(F);const m=S.displayName||S.name;return this._proxy.$getSession(F,C,R,m,n)}async removeSession(S,R){const F=this._authenticationProviders.get(S);return F?F.provider.removeSession(R):this._proxy.$removeSession(S,R)}registerAuthenticationProvider(S,R,F,C){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:R,provider:F,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===S)||this._providers.push({id:S,label:R});const n=F.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(S,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,R,C?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const m=this._providers.findIndex(r=>r.id===S);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,R){return this._onDidChangeSessions.fire({provider:{id:S,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ye[177],Ce([0,1,5,13,8]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this._extHostDocumentsAndEditors=S,this._proxy=T.getProxy(s.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const S=E.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=Be([He(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ye[178],Ce([0,1,5]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const k=A.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(T){return k.$writeText(T)}})}}e.ExtHostClipboard=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[38],Ce([0,1,11,7,8,26,5,16,12,54,59,226,2,6,3,13,47,22,37,43]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let I=class{constructor(u,h){p.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ze(this,p,u.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=h,this.converter=new c(this,b=>{const v=this._apiCommands.get(b);return v?.result===o.Void?v:void 0},h),this._argumentProcessors=[{processArgument(b){return(0,R.revive)(b)}},{processArgument(b){return(0,A.cloneAndChange)(b,function(v){if(F.Range.isIRange(v))return E.Range.to(v);if(C.Position.isIPosition(v))return E.Position.to(v);if(F.Range.isIRange(v.range)&&n.URI.isUri(v.uri))return E.location.to(v);if(v instanceof D.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const h=this.registerCommand(!1,u.id,async(...b)=>{const v=u.args.map((_,P)=>{if(!_.validate(b[P]))throw new Error(`Invalid argument '${_.name}' when running '${u.id}', received: ${b[P]}`);return _.convert(b[P])}),a=await this.executeCommand(u.internalId,...v);return u.result.convert(a,b,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new t.Disposable(()=>{h.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,h,b,v,a,_){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:b,thisArg:v,description:a,extension:_}),u&&Ie(this,p,"f").$registerCommand(h),new t.Disposable(()=>{this._commands.delete(h)&&u&&Ie(this,p,"f").$unregisterCommand(h)})}executeCommand(u,...h){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,h,!0)}async _doExecuteCommand(u,h,b){if(this._commands.has(u))return this._executeContributedCommand(u,h,!1);{let v=!1;const a=(0,A.cloneAndChange)(h,function(_){if(_ instanceof t.Position)return E.Position.from(_);if(_ instanceof t.Range)return E.Range.from(_);if(_ instanceof t.Location)return E.location.from(_);if(t.NotebookRange.isNotebookRange(_))return E.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return v=!0,D.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return v=!0,D.VSBuffer.wrap(_);if(!Array.isArray(_))return _});try{const _=await Ie(this,p,"f").$executeCommand(u,v?new w.SerializableObjectWithBuffers(a):a,b);return(0,R.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(u,h,!1);throw _}}}async _executeContributedCommand(u,h,b){const v=this._commands.get(u);if(!v)throw new Error("Unknown command");let{callback:a,thisArg:_,description:P}=v;if(P)for(let N=0;N<P.args.length;N++)try{(0,s.validateConstraint)(h[N],P.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${P.args[N].name}' - ${P.args[N].description}`)}try{return await a.apply(_,h)}catch(N){if(u===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...h);$&&(u=$.command)}throw this._logService.error(N,u,v.extension?.identifier),b?new class extends Error{constructor(){super((0,d.toErrorMessage)(N));this.id=u,this.source=v.extension?.displayName??v.extension?.name}}:N}}$executeContributedCommand(u,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(h=h.map(b=>this._argumentProcessors.reduce((v,a)=>a.processArgument(v),b)),this._executeContributedCommand(u,h,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),Ie(this,p,"f").$getCommands().then(h=>(u&&(h=h.filter(b=>b[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[h,b]of this._commands){let{description:v}=b;v&&(u[h]=v)}return Promise.resolve(u)}};p=new WeakMap,I=Be([He(0,g.IExtHostRpcService),He(1,S.ILogService)],I),e.ExtHostCommands=I,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class c{constructor(u,h,b){this._commands=u,this._lookupApiCommand=h,this._logService=b,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,h){if(!u)return;const b={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return b;const v=this._lookupApiCommand(u.command);if(v)b.id=v.internalId,b.arguments=v.args.map((a,_)=>a.convert(u.arguments&&u.arguments[_]));else if((0,T.isNonEmptyArray)(u.arguments)){const a=++this._cachIdPool;this._cache.set(a,u),h.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),b.$ident=a,b.id=this.delegatingCommandId,b.arguments=[a],this._logService.trace("CommandsConverter#CREATE",u.command,a)}return b}fromInternal(u){const h=k.ObjectIdentifier.of(u);return typeof h=="number"?this._cache.get(h):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const h=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=c;class M{constructor(u,h,b,v){this.name=u,this.description=h,this.validate=b,this.convert=v}optional(){return new M(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,h){return new M(u??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=M,M.Uri=new M("uri","Uri of a text document",f=>n.URI.isUri(f),f=>f),M.Position=new M("position","A position in a text document",f=>t.Position.isPosition(f),E.Position.from),M.Range=new M("range","A range in a text document",f=>t.Range.isRange(f),E.Range.from),M.Selection=new M("selection","A selection in a text document",f=>t.Selection.isSelection(f),E.Selection.from),M.Number=new M("number","",f=>typeof f=="number",f=>f),M.String=new M("string","",f=>typeof f=="string",f=>f),M.CallHierarchyItem=new M("item","A call hierarchy item",f=>f instanceof t.CallHierarchyItem,E.CallHierarchyItem.from),M.TypeHierarchyItem=new M("item","A type hierarchy item",f=>f instanceof t.TypeHierarchyItem,E.TypeHierarchyItem.from),M.TestItem=new M("testItem","A VS Code TestItem",f=>f instanceof l.TestItemImpl,E.TestItem.from);class o{constructor(u,h){this.description=u,this.convert=h}}e.ApiCommandResult=o,o.Void=new o("no result",f=>f);class i{constructor(u,h,b,v,a){this.id=u,this.internalId=h,this.description=b,this.args=v,this.result=a}}e.ApiCommand=i}),define(ye[179],Ce([0,1,8,7,58,38,16,79]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(s.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,k.isFalsyOrEmpty)(n))return;class r extends t.SymbolInformation{static to(l){const D=new r(l.name,s.SymbolKind.to(l.kind),l.containerName||"",new t.Location(m[0],s.Range.to(l.range)));return D.detail=l.detail,D.range=D.location.range,D.selectionRange=s.Range.to(l.selectionRange),D.children=l.children?l.children.map(r.to):[],D}}return n.map(r.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(s.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(s.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(s.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(s.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(s.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>t.Position.isPosition(m)),n=>n.map(s.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let r;for(const g of m.reverse())r=new t.SelectionRange(s.Range.to(g),r);return r}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(s.WorkspaceSymbol.to))),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(s.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(s.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(s.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:s.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return s.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(s.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,T.decodeSemanticTokensDto)(n);if(m.type==="full")return new t.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,T.decodeSemanticTokensDto)(n);if(m.type==="full")return new t.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,r)=>{if(!n)return new t.CompletionList([]);const g=n.suggestions.map(l=>s.CompletionItem.to(l,r));return new t.CompletionList(g,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return s.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,r)=>F(g=>new t.CodeLens(s.Range.to(g.range),g.command&&r.fromInternal(g.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>t.Range.isRange(n),n=>t.Selection.isSelection(n)?s.Selection.from(n):s.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,r)=>F(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(g.command)}else{const l=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(l.edit=s.WorkspaceEdit.to(g.edit)),g.command&&(l.command=r.fromInternal(g.command)),l.isPreferred=g.isPreferred,l}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new t.ColorInformation(s.Range.to(m.range),s.Color.to(m.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof t.Color,s.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:s.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(s.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(s.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>s.NotebookExclusiveDocumentPattern.to(m))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(s.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(s.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(s.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(s.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class R{static register(m){S.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=R;function F(n){return m=>{if(Array.isArray(m))return m.map(n)}}function C(n){if(!Array.isArray(n))return;const m=[];for(const r of n)E.isLocationLink(r)?m.push(s.DefinitionLink.to(r)):m.push(s.location.to(r));return m}}),define(ye[180],Ce([0,1,14,52,4,6,2,58,25,8,7,5]),function(Z,e,s,t,E,A,k,T,S,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,r,g){const l=m.getProxy(C.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,r.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const f=this._commentControllers.get(i.handle);return f||i}else if(i&&i.$mid===7){const f=this._commentControllers.get(i.commentControlHandle);if(!f)return i;const u=f.getCommentThread(i.commentThreadHandle);return u||i}else if(i&&i.$mid===8){const f=this._commentControllers.get(i.thread.commentControlHandle);if(!f)return i;const u=f.getCommentThread(i.thread.commentThreadHandle);return u?{thread:u,text:i.text}:i}else if(i&&i.$mid===9){const f=this._commentControllers.get(i.thread.commentControlHandle);if(!f)return i;const u=f.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let h=i.commentUniqueId,b=u.getCommentByUniqueId(h);return b||i}else if(i&&i.$mid===10){const f=this._commentControllers.get(i.thread.commentControlHandle);if(!f)return i;const u=f.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let h=i.text,b=i.commentUniqueId,v=u.getCommentByUniqueId(b);return v?(v.body=h,v):i}return i}})}createCommentController(i,f,u){const h=D.handlePool++,b=new d(i,h,f,u);this._commentControllers.set(b.handle,b);const v=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return v.push(b),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),v),b.value}$createCommentThreadTemplate(i,f,u){const h=this._commentControllers.get(i);!h||h.$createCommentThreadTemplate(f,u)}async $updateCommentThreadTemplate(i,f,u){const h=this._commentControllers.get(i);!h||h.$updateCommentThreadTemplate(f,u)}$deleteCommentThread(i,f){const u=this._commentControllers.get(i);u&&u.$deleteCommentThread(f)}$provideCommentingRanges(i,f,u){const h=this._commentControllers.get(i);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const b=g.getDocument(k.URI.revive(f));return(0,s.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(b,u)).then(v=>v?v.map(a=>R.Range.from(a)):void 0)}$toggleReaction(i,f,u,h,b){const v=this._commentControllers.get(i);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const a=v.getCommentThread(f);if(a){const _=a.getCommentByUniqueId(h.uniqueIdInThread);if(v!==void 0&&_&&v.reactionHandler)return v.reactionHandler(_,c(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class w{constructor(i,f,u,h,b,v,a){this._commentControllerHandle=f,this._id=u,this._uri=h,this._range=b,this._comments=v,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),l.$createCommentThread(f,this.handle,this._id,this._uri,R.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{l.$deleteCommentThread(f,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(P){_.range=P},get comments(){return _.comments},set comments(P){_.comments=P},get collapsibleState(){return _.collapsibleState},set collapsibleState(P){_.collapsibleState=P},get canReply(){return _.canReply},set canReply(P){_.canReply=P},get contextValue(){return _.contextValue},set contextValue(P){_.contextValue=P},get label(){return _.label},set label(P){_.label=P},dispose:()=>{_.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const i=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),f={};i("range")&&(f.range=R.Range.from(this._range)),i("label")&&(f.label=this.label),i("contextValue")&&(f.contextValue=this.contextValue??null),i("comments")&&(f.comments=this._comments.map(u=>p(this,u,this._commentsMap))),i("collapsibleState")&&(f.collapseState=M(this._collapseState)),i("canReply")&&(f.canReply=this.canReply),this.modifications={},l.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(i){for(let f of this._commentsMap){let u=f[0],h=f[1];if(i===h)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}w._handlePool=0,Be([(0,t.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(i,f,u,h){this._extension=i,this._handle=f,this._id=u,this._label=h,this._threads=new Map,l.$registerCommentController(this.handle,u,h);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(v){b.options=v},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(v){b.commentingRangeProvider=v},get reactionHandler(){return b.reactionHandler},set reactionHandler(v){b.reactionHandler=v},createCommentThread(v,a,_){return b.createCommentThread(v,a,_).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,l.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,f,u,h){if(typeof i=="string"){const b=new w(this.id,this.handle,i,f,u,h,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new w(this.id,this.handle,void 0,i,f,u,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,f){const u=new w(this.id,this.handle,void 0,k.URI.revive(i),R.Range.to(f),[],this._extension.identifier);return u.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(i,f){let u=this._threads.get(i);u&&(u.range=R.Range.to(f))}$deleteCommentThread(i){let f=this._threads.get(i);f&&f.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(o,i,f){let u=f.get(i);u||(u=++o.commentHandle,f.set(i,u));const h=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:u,body:R.MarkdownString.from(i.body),userName:i.author.name,userIconPath:h,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>I(b)):void 0}}function I(o){return{label:o.label,iconPath:o.iconPath?R.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function c(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?k.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function M(o){if(o!==void 0)switch(o){case F.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(ye[93],Ce([0,1,2,5,7,3,13,12,16,9,17]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class bi{constructor(m,r){this._logService=r,this._provider=new Map,this._proxy=m.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,r){const g=bi._handlePool++;this._provider.set(g,{provider:m,extensionId:r}),this._proxy.$registerDecorationProvider(g,r.value);const l=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(g,null);return}let w=(0,S.asArray)(D);if(w.length<=bi._maxEventSize){this._proxy.$onDidChange(g,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,w.length);const d=w.map(c=>({uri:c,rank:(0,R.count)(c.path,"/")})),p=(0,S.groupBy)(d,(c,M)=>c.rank-M.rank||(0,R.compare)(c.uri.path,M.uri.path));let I=[];e:for(let c of p){let M;for(let o of c){let i=(0,F.dirname)(o.uri.path);if(M!==i&&(M=i,I.push(o.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(g,I)});return new E.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(m,r,g){if(!this._provider.has(m))return Object.create(null);const l=Object.create(null),{provider:D,extensionId:w}=this._provider.get(m);return await Promise.all(r.map(async d=>{try{const{uri:p,id:I}=d,c=await Promise.resolve(D.provideFileDecoration(s.URI.revive(p),g));if(!c)return;try{E.FileDecoration.validate(c),l[I]=[c.propagate,c.tooltip,c.badge,c.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${w.value}': ${M}`)}}catch(p){this._logService.error(p)}})),l}};C._handlePool=0,C._maxEventSize=250,C=Be([He(0,k.IExtHostRpcService),He(1,T.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[181],Ce([0,1,118,82,2,5,7,8,4,12,21,30]),function(Z,e,s,t,E,A,k,T,S,R,F,C){"use strict";var n,m,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(w,d,p,I,c,M){this._name=w,this._owner=d,this._maxDiagnosticsPerFile=p,n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),this._isDisposed=!1,Ze(this,r,new F.ResourceMap(o=>I.getComparisonKey(o)),"f"),Ze(this,n,c,"f"),Ze(this,m,M,"f")}dispose(){this._isDisposed||(Ie(this,m,"f").fire([...Ie(this,r,"f").keys()]),Ie(this,n,"f")&&Ie(this,n,"f").$clear(this._owner),Ie(this,r,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,d){if(!w){this.clear();return}this._checkDisposed();let p=[];if(E.URI.isUri(w)){if(!d){this.delete(w);return}Ie(this,r,"f").set(w,d.slice()),p=[w]}else if(Array.isArray(w)){p=[];let c;w=[...w].sort(g._compareIndexedTuplesByUri);for(const M of w){const[o,i]=M;if((!c||o.toString()!==c.toString())&&(c&&Ie(this,r,"f").get(c).length===0&&Ie(this,r,"f").delete(c),c=o,p.push(o),Ie(this,r,"f").set(o,[])),i){const f=Ie(this,r,"f").get(o);f&&f.push(...i)}else{const f=Ie(this,r,"f").get(o);f&&(f.length=0)}}}if(Ie(this,m,"f").fire(p),!Ie(this,n,"f"))return;const I=[];for(let c of p){let M=[];const o=Ie(this,r,"f").get(c);if(o)if(o.length>this._maxDiagnosticsPerFile){M=[];const i=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(let u of o)if(u.severity===i[f]&&M.push(T.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,s.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=o.map(i=>T.Diagnostic.from(i));I.push([c,M])}Ie(this,n,"f").$changeMany(this._owner,I)}delete(w){this._checkDisposed(),Ie(this,m,"f").fire([w]),Ie(this,r,"f").delete(w),Ie(this,n,"f")&&Ie(this,n,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Ie(this,m,"f").fire([...Ie(this,r,"f").keys()]),Ie(this,r,"f").clear(),Ie(this,n,"f")&&Ie(this,n,"f").$clear(this._owner)}forEach(w,d){this._checkDisposed();for(let p of Ie(this,r,"f").keys())w.apply(d,[p,this.get(p),this])}get(w){this._checkDisposed();const d=Ie(this,r,"f").get(w);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Ie(this,r,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,d){return w[0].toString()<d[0].toString()?-1:w[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=g,n=new WeakMap,m=new WeakMap,r=new WeakMap;let l=class ri{constructor(w,d,p){this._logService=d,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:I=>I.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=w.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(w){const d=new F.ResourceMap;for(const p of w)d.set(p,p);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(w,d){const{_collections:p,_proxy:I,_onDidChangeDiagnostics:c,_logService:M,_fileSystemInfoService:o}=this,i=new class{$changeMany(h,b){I.$changeMany(h,b),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,h,b.length===0?"CLEARING":b)}$clear(h){I.$clear(h),M.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,h)}dispose(){I.dispose()}};let f;if(!d)d="_generated_diagnostic_collection_name_#"+ri._idPool++,f=d;else if(!p.has(d))f=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do f=d+ri._idPool++;while(p.has(f))}return new class extends g{constructor(){super(d,f,ri._maxDiagnosticsPerFile,o.extUri,i,c);p.set(f,this)}dispose(){super.dispose(),p.delete(f)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const d=new Map,p=[];for(const I of this._collections.values())I.forEach((c,M)=>{let o=d.get(c.toString());typeof o=="undefined"&&(o=p.length,d.set(c.toString(),o),p.push([c,[]])),p[o][1]=p[o][1].concat(...M)});return p}}_getDiagnostics(w){let d=[];for(let p of this._collections.values())p.has(w)&&(d=d.concat(p.get(w)));return d}$acceptMarkersChange(w){if(!this._mirrorCollection){const d="_generated_mirror",p=new g(d,d,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,p),this._mirrorCollection=p}for(const[d,p]of w)this._mirrorCollection.set(E.URI.revive(d),p.map(T.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Be([He(1,R.ILogService),He(2,C.IExtHostFileSystemInfo)],l),e.ExtHostDiagnostics=l}),define(ye[182],Ce([0,1,2,5]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(T=>T?T.map(S=>s.URI.revive(S)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(T=>T?s.URI.revive(T):void 0)}}e.ExtHostDialogs=E}),define(ye[183],Ce([0,1,15,2,7,5,10,20,9]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(C,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,n){if(Object.keys(k.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=R._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,C);let r;return typeof n.onDidChange=="function"&&(r=n.onDidChange(g=>{if(g.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(m,g).then(l=>{if(!l&&typeof l!="string")return;const D=this._documentsAndEditors.getDocument(g);if(!D)return;const w=(0,S.splitLines)(l);if(!D.equalLines(w))return this._proxy.$onVirtualDocumentChange(g,l)},s.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(C,n){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(t.URI.revive(n),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(ye[184],Ce([0,1,4,6,2,5,86,8,11,26,7]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(m,r){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=r,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const l of g)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const l of g)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const r=this._documentsAndEditors.getDocument(m);if(r)return r}getDocument(m){const r=this.getDocumentData(m);if(!r?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return r.document}ensureDocumentData(m){const r=this._documentsAndEditors.getDocument(m);if(r)return Promise.resolve(r);let g=this._documentLoader.get(m.toString());return g||(g=this._proxy.$tryOpenDocument(m).then(l=>{this._documentLoader.delete(m.toString());const D=E.URI.revive(l);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(D))},l=>(this._documentLoader.delete(m.toString()),Promise.reject(l))),this._documentLoader.set(m.toString(),g)),g}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(r=>E.URI.revive(r))}$acceptModelModeChanged(m,r){const g=E.URI.revive(m),l=this._documentsAndEditors.getDocument(g);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(r),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(m){const r=E.URI.revive(m),g=this._documentsAndEditors.getDocument(r);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(m,r){const g=E.URI.revive(m),l=this._documentsAndEditors.getDocument(g);if(!l)throw new Error("unknown document");l._acceptIsDirty(r),this._onDidChangeDocument.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,r,g){const l=E.URI.revive(m),D=this._documentsAndEditors.getDocument(l);if(!D)throw new Error("unknown document");D._acceptIsDirty(g),D.onEvents(r);let w;r.isUndoing?w=F.TextDocumentChangeReason.Undo:r.isRedoing&&(w=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:D.document,contentChanges:r.changes.map(d=>({range:T.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:w}))}setWordDefinitionFor(m,r){(0,k.setWordDefinitionFor)(m,r)}}e.ExtHostDocuments=C}),define(ye[48],Ce([0,1,41,4,6,2,3,5,86,13,92,8,12,21,10,157,227]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(p,I){this._extHostRpc=p,this._logService=I,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const I=[],c=[],M=[];if(p.removedDocuments)for(const o of p.removedDocuments){const i=A.URI.revive(o),f=this._documents.get(i);f?.unref()&&(this._documents.delete(i),I.push(f.value))}if(p.addedDocuments)for(const o of p.addedDocuments){const i=A.URI.revive(o.uri);let f=this._documents.get(i);if(f&&i.scheme!==r.Schemas.vscodeNotebookCell&&i.scheme!==r.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);f||(f=new D(new S.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,f),c.push(f.value)),f.ref()}if(p.removedEditors)for(const o of p.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&M.push(i)}if(p.addedEditors)for(const o of p.addedEditors){const i=A.URI.revive(o.documentUri);s.ok(this._documents.has(i),`document '${i}' does not exist`),s.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const f=this._documents.get(i).value,u=new F.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new l.Lazy(()=>f.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(h=>C.Range.to(h)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,u)}p.newActiveEditor!==void 0&&(s.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,E.dispose)(I),(0,E.dispose)(M),p.removedDocuments&&this._onDidRemoveDocuments.fire(I),p.addedDocuments&&this._onDidAddDocuments.fire(c),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const I=this._editors.get(this._activeEditorId);return p?I:I?.value}allEditors(){return[...this._editors.values()]}};w=Be([He(0,R.IExtHostRpcService),He(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[70],Ce([0,1,8,5,2,4,3,13,14]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let R=class{constructor(C){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=C.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(C){let n=-1;this._tabs=C.map((r,g)=>(r.isActive&&(n=g),Object.freeze({label:r.label,viewColumn:s.ViewColumn.to(r.viewColumn),index:g,resource:E.URI.revive(r.resource),additionalResourcesAndViewIds:r.additionalResourcesAndViewIds.map(({resource:l,viewId:D})=>({resource:E.URI.revive(l),viewId:D})),viewId:r.editorId,isActive:r.isActive,move:async(l,D)=>{this._proxy.$moveTab(r,l,s.ViewColumn.from(D)),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(r),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((r,g)=>r.viewColumn===g.viewColumn?r.index-g.index:r.viewColumn-g.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Be([He(0,T.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(ye[185],Ce([0,1,2,5,6,7,8,228,9,22,27]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(r){this._stateMachine=void 0,this._schemes.push(r)}delete(r){const g=this._schemes.indexOf(r);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const r=this._schemes.sort(),g=[];let l,D,w=14,d=14;for(const p of r){let I=l?(0,S.commonPrefixLength)(l,p):0;for(I===0?D=1:D=d;I<p.length;I++)I+1===p.length?(w=d,d=9):d+=1,g.push([D,p.toUpperCase().charCodeAt(I),d]),g.push([D,p.toLowerCase().charCodeAt(I),d]),D=d;l=p,d=w}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new T.StateMachine(g)}}provideDocumentLinks(r){this._initStateMachine();const g=[],l=T.LinkComputer.computeLinks({getLineContent(D){return r.lineAt(D-1).text},getLineCount(){return r.lineCount}},this._stateMachine);for(const D of l){const w=k.DocumentLink.to(D);w.target&&g.push(w)}return g}}class n{constructor(r,g){this._extHostLanguageFeatures=g,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=r.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(r,g,l,D={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(w,l);let d=2;D.isCaseSensitive&&(d+=1024),D.isReadonly&&(d+=2048),typeof l.copy=="function"&&(d+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,F.checkProposedApiEnabled)(r,"fsChunks"),d+=4),this._proxy.$registerFileSystemProvider(w,g,d).catch(I=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${g}`),console.error(I)});const p=l.onDidChangeFile(I=>{const c=[];for(const M of I){let{uri:o,type:i}=M;if(o.scheme!==g)continue;let f;switch(i){case A.FileChangeType.Changed:f=0;break;case A.FileChangeType.Created:f=1;break;case A.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:o,type:f})}this._proxy.$onFileSystemChange(w,c)});return(0,E.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(r){const{type:g,ctime:l,mtime:D,size:w,permissions:d}=r;return{type:g,ctime:l,mtime:D,size:w,permissions:d}}$stat(r,g){return Promise.resolve(this._getFsProvider(r).stat(s.URI.revive(g))).then(l=>n._asIStat(l))}$readdir(r,g){return Promise.resolve(this._getFsProvider(r).readDirectory(s.URI.revive(g)))}$readFile(r,g){return Promise.resolve(this._getFsProvider(r).readFile(s.URI.revive(g))).then(l=>R.VSBuffer.wrap(l))}$writeFile(r,g,l,D){return Promise.resolve(this._getFsProvider(r).writeFile(s.URI.revive(g),l.buffer,D))}$delete(r,g,l){return Promise.resolve(this._getFsProvider(r).delete(s.URI.revive(g),l))}$rename(r,g,l,D){return Promise.resolve(this._getFsProvider(r).rename(s.URI.revive(g),s.URI.revive(l),D))}$copy(r,g,l,D){const w=this._getFsProvider(r);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(s.URI.revive(g),s.URI.revive(l),D))}$mkdir(r,g){return Promise.resolve(this._getFsProvider(r).createDirectory(s.URI.revive(g)))}$watch(r,g,l,D){const w=this._getFsProvider(r).watch(s.URI.revive(l),D);this._watches.set(g,w)}$unwatch(r,g){const l=this._watches.get(g);l&&(l.dispose(),this._watches.delete(g))}$open(r,g,l){const D=this._getFsProvider(r);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(s.URI.revive(g),l))}$close(r,g){const l=this._getFsProvider(r);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(g))}$read(r,g,l,D){const w=this._getFsProvider(r);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const d=R.VSBuffer.alloc(D);return Promise.resolve(w.read(g,l,d.buffer,0,D)).then(p=>d.slice(0,p))}$write(r,g,l,D){const w=this._getFsProvider(r);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(g,l,D.buffer,0,D.byteLength))}_getFsProvider(r){const g=this._fsProvider.get(r);if(!g){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return g}}e.ExtHostFileSystem=n}),define(ye[49],Ce([0,1,5,45,7,22,3,13,30,6]),function(Z,e,s,t,E,A,k,T,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Wt{constructor(n,m){this._fileSystemProvider=new Map,this._proxy=n.getProxy(s.MainContext.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(g){try{const l=r._fileSystemProvider.get(g.scheme);if(!l)return await r._proxy.$stat(g);await r._proxy.$ensureActivation(g.scheme);const D=await l.stat(g);return{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions}}catch(l){Wt._handleError(l)}},async readDirectory(g){try{const l=r._fileSystemProvider.get(g.scheme);return l?(await r._proxy.$ensureActivation(g.scheme),(await l.readDirectory(g)).slice()):await r._proxy.$readdir(g)}catch(l){return Wt._handleError(l)}},async createDirectory(g){try{return await r._proxy.$mkdir(g)}catch(l){return Wt._handleError(l)}},async readFile(g){try{const l=r._fileSystemProvider.get(g.scheme);return l?(await r._proxy.$ensureActivation(g.scheme),(await l.readFile(g)).slice()):(await r._proxy.$readFile(g)).buffer}catch(l){return Wt._handleError(l)}},async writeFile(g,l){try{return await r._proxy.$writeFile(g,A.VSBuffer.wrap(l))}catch(D){return Wt._handleError(D)}},async delete(g,l){try{const D=r._fileSystemProvider.get(g.scheme);return D?(await r._proxy.$ensureActivation(g.scheme),await D.delete(g,{recursive:!1,...l})):await r._proxy.$delete(g,{recursive:!1,useTrash:!1,...l})}catch(D){return Wt._handleError(D)}},async rename(g,l,D){try{return await r._proxy.$rename(g,l,{overwrite:!1,...D})}catch(w){return Wt._handleError(w)}},async copy(g,l,D){try{return await r._proxy.$copy(g,l,{overwrite:!1,...D})}catch(w){return Wt._handleError(w)}},isWritableFileSystem(g){const l=m.getCapabilities(g);if(typeof l=="number")return!(l&2048)}})}static _handleError(n){if(n instanceof E.FileSystemError)throw n;if(!(n instanceof Error))throw new E.FileSystemError(String(n));if(n.name==="ENOPRO")throw E.FileSystemError.Unavailable(n.message);switch(n.name){case t.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(n.message);case t.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(n.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(n.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(n.message);case t.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(n.message);case t.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(n.message);default:throw new E.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,m){return this._fileSystemProvider.set(n,m),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(n))}};F=Be([He(0,T.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[186],Ce([0,1,2,38]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(k,T,S,R){this._extHostNotebooks=T,this._textDocumentsAndEditors=S,this._commands=R;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new t.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new t.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new t.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new t.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:s.URI.revive(C.notebookUri),inputUri:s.URI.revive(C.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:s.URI.revive(C.notebookUri),inputUri:s.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(k,T,S,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=E}),define(ye[187],Ce([0,1,6,5]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,k),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=E}),define(ye[188],Ce([0,1,2,26,8,7,5,9,59,16,11,229,6,79,53,63,189,15,4]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentSymbols(H,G){const X=this._documents.getDocument(H),se=await this._provider.provideDocumentSymbols(X,G);if(!(0,R.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(E.DocumentSymbol.from):d._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((se,q)=>{let te=se.location.range.start.compareTo(q.location.range.start);return te===0&&(te=q.location.range.end.compareTo(se.location.range.end)),te});const G=[],X=[];for(const se of H){const q={name:se.name||"!!MISSING: name!!",kind:E.SymbolKind.from(se.kind),tags:se.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:E.Range.from(se.location.range),selectionRange:E.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(q),G.push(q);break}const te=X[X.length-1];if(S.Range.containsRange(te.range,q.range)&&!S.Range.equalsRange(te.range,q.range)){te.children&&te.children.push(q),X.push(q);break}X.pop()}}return G}}class p{constructor(H,G,X){this._documents=H,this._commands=G,this._provider=X,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,G){const X=this._documents.getDocument(H),se=await this._provider.provideCodeLenses(X,G);if(!se||G.isCancellationRequested)return;const q=this._cache.add(se),te=new n.DisposableStore;this._disposables.set(q,te);const fe={cacheId:q,lenses:[]};for(let Re=0;Re<se.length;Re++)fe.lenses.push({cacheId:[q,Re],range:E.Range.from(se[Re].range),command:this._commands.toInternal(se[Re].command,te)});return fe}async resolveCodeLens(H,G){const X=H.cacheId&&this._cache.get(...H.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,G),se||(se=X),G.isCancellationRequested)return;const q=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!q)return H.command=this._commands.toInternal(se.command??p._badCmd,q),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function I(je){return Array.isArray(je)?je.map(E.DefinitionLink.from):je?[E.DefinitionLink.from(je)]:[]}class c{constructor(H,G){this._documents=H,this._provider=G}async provideDefinition(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideDefinition(se,q,X);return I(te)}}class M{constructor(H,G){this._documents=H,this._provider=G}async provideDeclaration(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideDeclaration(se,q,X);return I(te)}}class o{constructor(H,G){this._documents=H,this._provider=G}async provideImplementation(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideImplementation(se,q,X);return I(te)}}class i{constructor(H,G){this._documents=H,this._provider=G}async provideTypeDefinition(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideTypeDefinition(se,q,X);return I(te)}}class f{constructor(H,G){this._documents=H,this._provider=G}async provideHover(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideHover(se,q,X);if(!(!te||(0,R.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=se.getWordRangeAtPosition(q)),te.range||(te.range=new A.Range(q,q)),E.Hover.from(te)}}class u{constructor(H,G){this._documents=H,this._provider=G}async provideEvaluatableExpression(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideEvaluatableExpression(se,q,X);if(te)return E.EvaluatableExpression.from(te)}}class h{constructor(H,G){this._documents=H,this._provider=G}async provideInlineValues(H,G,X,se){const q=this._documents.getDocument(H),te=await this._provider.provideInlineValues(q,E.Range.to(G),E.InlineValueContext.to(X),se);if(Array.isArray(te))return te.map(fe=>E.InlineValue.from(fe))}}class b{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentHighlights(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideDocumentHighlights(se,q,X);if(Array.isArray(te))return te.map(E.DocumentHighlight.from)}}class v{constructor(H,G){this._documents=H,this._provider=G}async provideLinkedEditingRanges(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.provideLinkedEditingRanges(se,q,X);if(te&&Array.isArray(te.ranges))return{ranges:(0,R.coalesce)(te.ranges.map(E.Range.from)),wordPattern:te.wordPattern}}}class a{constructor(H,G){this._documents=H,this._provider=G}async provideReferences(H,G,X,se){const q=this._documents.getDocument(H),te=E.Position.to(G),fe=await this._provider.provideReferences(q,te,X,se);if(Array.isArray(fe))return fe.map(E.location.from)}}class _{constructor(H,G,X,se,q,te,fe){this._documents=H,this._commands=G,this._diagnostics=X,this._provider=se,this._logService=q,this._extension=te,this._apiDeprecation=fe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,G,X,se){const q=this._documents.getDocument(H),te=C.Selection.isISelection(G)?E.Selection.to(G):E.Range.to(G),fe=[];for(const st of this._diagnostics.getDiagnostics(H))if(te.intersection(st.range)&&fe.push(st)>_._maxCodeActionsPerFile)break;const Re={diagnostics:fe,only:X.only?new A.CodeActionKind(X.only):void 0,triggerKind:E.CodeActionTriggerKind.to(X.trigger)},xe=await this._provider.provideCodeActions(q,te,Re,se);if(!(0,R.isNonEmptyArray)(xe)||se.isCancellationRequested)return;const ze=this._cache.add(xe),Xe=new n.DisposableStore;this._disposables.set(ze,Xe);const et=[];for(let st=0;st<xe.length;st++){const Je=xe[st];!Je||(_._isCommand(Je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this._commands.toInternal(Je,Xe)})):(Re.only&&(Je.kind?Re.only.contains(Je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,st],title:Je.title,command:Je.command&&this._commands.toInternal(Je.command,Xe),diagnostics:Je.diagnostics&&Je.diagnostics.map(E.Diagnostic.from),edit:Je.edit&&E.WorkspaceEdit.from(Je.edit),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(H,G){const[X,se]=H,q=this._cache.get(X,se);if(!q||_._isCommand(q)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(q,G)??q;return te?.edit?E.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}_._maxCodeActionsPerFile=1e3;class P{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentFormattingEdits(H,G,X){const se=this._documents.getDocument(H),q=await this._provider.provideDocumentFormattingEdits(se,G,X);if(Array.isArray(q))return q.map(E.TextEdit.from)}}class N{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentRangeFormattingEdits(H,G,X,se){const q=this._documents.getDocument(H),te=E.Range.to(G),fe=await this._provider.provideDocumentRangeFormattingEdits(q,te,X,se);if(Array.isArray(fe))return fe.map(E.TextEdit.from)}}class ${constructor(H,G){this._documents=H,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,G,X,se,q){const te=this._documents.getDocument(H),fe=E.Position.to(G),Re=await this._provider.provideOnTypeFormattingEdits(te,fe,X,se,q);if(Array.isArray(Re))return Re.map(E.TextEdit.from)}}class y{constructor(H,G){this._provider=H,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,G){const X=k.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(H,G);if((0,R.isNonEmptyArray)(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const te=k.IdObject.mixin(E.WorkspaceSymbol.from(q));this._symbolCache.set(te._id,q),X.symbols.push(te)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(H,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const X=this._symbolCache.get(H._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,G);return se&&(0,t.mixin)(H,E.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(H){const G=this._resultCache.get(H);if(G){for(let[X,se]=G;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete(H)}}}class L{constructor(H,G,X){this._documents=H,this._provider=G,this._logService=X}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,G,X,se){const q=this._documents.getDocument(H),te=E.Position.to(G);try{const fe=await this._provider.provideRenameEdits(q,te,X,se);return fe?E.WorkspaceEdit.from(fe):void 0}catch(fe){const Re=L._asMessage(fe);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(H,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(H),q=E.Position.to(G);try{const te=await this._provider.prepareRename(se,q,X);let fe,Re;if(A.Range.isRange(te)?(fe=te,Re=se.getText(te)):(0,F.isObject)(te)&&(fe=te.range,Re=te.placeholder),!fe||!Re)return;if(fe.start.line>q.line||fe.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(fe),text:Re}}catch(te){const fe=L._asMessage(te);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class z{constructor(H,G){this.resultId=H,this.tokens=G}}class x{constructor(H,G){this._documents=H,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,G,X){const se=this._documents.getDocument(H),q=G!==0?this._previousResults.get(G):null;let te=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return q&&this._previousResults.delete(G),te?(te=x._fixProvidedSemanticTokens(te),this._send(x._convertToEdits(q,te),te)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return x._isSemanticTokens(H)?x._isCorrectSemanticTokens(H)?H:new A.SemanticTokens(new Uint32Array(H.data),H.resultId):x._isSemanticTokensEdits(H)?x._isCorrectSemanticTokensEdits(H)?H:new A.SemanticTokensEdits(H.edits.map(G=>new A.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const G of H.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,G){if(!x._isSemanticTokens(G)||!H||!H.tokens)return G;const X=H.tokens,se=X.length,q=G.data,te=q.length;let fe=0;const Re=Math.min(se,te);for(;fe<Re&&X[fe]===q[fe];)fe++;if(fe===se&&fe===te)return new A.SemanticTokensEdits([],G.resultId);let xe=0;const ze=Re-fe;for(;xe<ze&&X[se-xe-1]===q[te-xe-1];)xe++;return new A.SemanticTokensEdits([{start:fe,deleteCount:se-fe-xe,data:q.subarray(fe,te-xe)}],G.resultId)}_send(H,G){if(x._isSemanticTokens(H)){const X=this._nextResultId++;return this._previousResults.set(X,new z(H.resultId,H.data)),(0,m.encodeSemanticTokensDto)({id:X,type:"full",data:H.data})}if(x._isSemanticTokensEdits(H)){const X=this._nextResultId++;return x._isSemanticTokens(G)?this._previousResults.set(X,new z(G.resultId,G.data)):this._previousResults.set(X,new z(H.resultId)),(0,m.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(H.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class B{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentRangeSemanticTokens(H,G,X){const se=this._documents.getDocument(H),q=await this._provider.provideDocumentRangeSemanticTokens(se,E.Range.to(G),X);return q?this._send(q):null}_send(H){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=B;class j{constructor(H,G,X,se,q){this._documents=H,this._commands=G,this._provider=X,this._apiDeprecation=se,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,G,X,se){const q=this._documents.getDocument(H),te=E.Position.to(G),fe=q.getWordRangeAtPosition(te)||new A.Range(te,te),Re=fe.with({end:te}),xe=new l.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,te,se,E.CompletionContext.to(X));if(!ze||se.isCancellationRequested)return;const Xe=Array.isArray(ze)?new A.CompletionList(ze):ze,et=j.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const Je=[],nt={x:et,b:Je,a:{replace:E.Range.from(fe),insert:E.Range.from(Re)},c:Xe.isIncomplete||void 0,d:xe.elapsed()};for(let lt=0;lt<Xe.items.length;lt++){const pt=Xe.items[lt],Ft=this._convertCompletionItem(pt,[et,lt],Re,fe);Je.push(Ft)}return nt}async resolveCompletionItem(H,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...H);if(!X)return;const se=await this._provider.resolveCompletionItem(X,G);if(!!se)return this._convertCompletionItem(se,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,G,X,se){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const te={x:G,a:H.label,b:H.kind!==void 0?E.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(E.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(H.command,q)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=H.textEdit.newText):typeof H.insertText=="string"?te.h=H.insertText:H.insertText instanceof A.SnippetString&&(te.h=H.insertText.value,te.i|=4);let fe;return H.textEdit?fe=H.textEdit.range:H.range&&(fe=H.range),A.Range.isRange(fe)?te.j=E.Range.from(fe):fe&&(!X?.isEqual(fe.inserting)||!se?.isEqual(fe.replacing))&&(te.j={insert:E.Range.from(fe.inserting),replace:E.Range.from(fe.replacing)}),te}}class ue{constructor(H,G,X){this._documents=H,this._provider=G,this._commands=X,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,G,X,se){const q=this._documents.getDocument(H),te=E.Position.to(G),fe=await this._provider.provideInlineCompletionItems(q,te,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:E.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:E.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},se);if(!fe||se.isCancellationRequested)return;const Re=(0,F.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Re.items);let ze;return{pid:xe,items:Re.items.map((Xe,et)=>{let st;return Xe.command&&(ze||(ze=new n.DisposableStore,this._disposables.set(xe,ze)),st=this._commands.toInternal(Xe.command,ze)),{text:Xe.text,range:Xe.range?E.Range.from(Xe.range):void 0,command:st,idx:et}})}}disposeCompletions(H){this._cache.delete(H);const G=this._disposables.get(H);G&&G.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,G){const X=this._cache.get(H,G);X&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let G=K.map.get(H);return G||(G=new K,K.map.set(H,G)),G}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=K,K.map=new WeakMap;class ne{constructor(H,G){this._documents=H,this._provider=G,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(H,G,X,se){const q=this._documents.getDocument(H),te=E.Position.to(G),fe=this.reviveContext(X),Re=await this._provider.provideSignatureHelp(q,te,se,fe);if(Re){const xe=this._cache.add([Re]);return{...E.SignatureHelp.from(Re),id:xe}}}reviveContext(H){let G;if(H.activeSignatureHelp){const X=E.SignatureHelp.to(H.activeSignatureHelp),se=this._cache.get(H.activeSignatureHelp.id,0);se?(G=se,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...H,activeSignatureHelp:G}}releaseSignatureHelp(H){this._cache.delete(H)}}class pe{constructor(H,G){this._documents=H,this._provider=G}async provideInlayHints(H,G,X){const se=this._documents.getDocument(H),q=await this._provider.provideInlayHints(se,E.Range.to(G),X);return q?{hints:q.map(E.InlayHint.from)}:void 0}}class be{constructor(H,G){this._documents=H,this._provider=G,this._cache=new g.Cache("DocumentLink")}async provideLinks(H,G){const X=this._documents.getDocument(H),se=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(se)||se.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(be._validateLink).map(E.DocumentLink.from)};{const q=this._cache.add(se),te={links:[],id:q};for(let fe=0;fe<se.length;fe++){if(!be._validateLink(se[fe]))continue;const Re=E.DocumentLink.from(se[fe]);Re.cacheId=[q,fe],te.links.push(Re)}return te}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...H);if(!X)return;const se=await this._provider.resolveDocumentLink(X,G);if(!(!se||!be._validateLink(se)))return E.DocumentLink.from(se)}releaseLinks(H){this._cache.delete(H)}}class ae{constructor(H,G){this._documents=H,this._provider=G}async provideColors(H,G){const X=this._documents.getDocument(H),se=await this._provider.provideDocumentColors(X,G);return Array.isArray(se)?se.map(te=>({color:E.Color.from(te.color),range:E.Range.from(te.range)})):[]}async provideColorPresentations(H,G,X){const se=this._documents.getDocument(H),q=E.Range.to(G.range),te=E.Color.to(G.color),fe=await this._provider.provideColorPresentations(te,{document:se,range:q},X);if(!!Array.isArray(fe))return fe.map(E.ColorPresentation.from)}}class le{constructor(H,G){this._documents=H,this._provider=G}async provideFoldingRanges(H,G,X){const se=this._documents.getDocument(H),q=await this._provider.provideFoldingRanges(se,G,X);if(!!Array.isArray(q))return q.map(E.FoldingRange.from)}}class Se{constructor(H,G,X){this._documents=H,this._provider=G,this._logService=X}async provideSelectionRanges(H,G,X){const se=this._documents.getDocument(H),q=G.map(E.Position.to),te=await this._provider.provideSelectionRanges(se,q,X);if(!(0,R.isNonEmptyArray)(te))return[];if(te.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Re=0;Re<q.length;Re++){const xe=[];fe.push(xe);let ze=q[Re],Xe=te[Re];for(;;){if(!Xe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(E.SelectionRange.from(Xe)),!Xe.parent)break;ze=Xe.range,Xe=Xe.parent}}return fe}}class Ee{constructor(H,G){this._documents=H,this._provider=G,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.prepareCallHierarchy(se,q,X);if(!te)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(te)?te.map(Re=>this._cacheAndConvertItem(fe,Re)):[this._cacheAndConvertItem(fe,te)]}async provideCallsTo(H,G,X){const se=this._itemFromCache(H,G);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!q)return q.map(te=>({from:this._cacheAndConvertItem(H,te.from),fromRanges:te.fromRanges.map(fe=>E.Range.from(fe))}))}async provideCallsFrom(H,G,X){const se=this._itemFromCache(H,G);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!q)return q.map(te=>({to:this._cacheAndConvertItem(H,te.to),fromRanges:te.fromRanges.map(fe=>E.Range.from(fe))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,G){const X=this._cache.get(H),se=E.CallHierarchyItem.from(G,H,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache(H,G){return this._cache.get(H)?.get(G)}}class Fe{constructor(H,G){this._documents=H,this._provider=G,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(H,G,X){const se=this._documents.getDocument(H),q=E.Position.to(G),te=await this._provider.prepareTypeHierarchy(se,q,X);if(!te)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(te)?te.map(Re=>this._cacheAndConvertItem(fe,Re)):[this._cacheAndConvertItem(fe,te)]}async provideSupertypes(H,G,X){const se=this._itemFromCache(H,G);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!q)return q.map(te=>this._cacheAndConvertItem(H,te))}async provideSubtypes(H,G,X){const se=this._itemFromCache(H,G);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!q)return q.map(te=>this._cacheAndConvertItem(H,te))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,G){const X=this._cache.get(H),se=E.TypeHierarchyItem.from(G,H,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache(H,G){return this._cache.get(H)?.get(G)}}class $e{constructor(H,G){this.adapter=H,this.extension=G}}class Ve{constructor(H,G,X,se,q,te,fe){this._adapter=new Map,this._uriTransformer=G,this._proxy=H.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=q,this._logService=te,this._apiDeprecation=fe}_transformDocumentSelector(H){return E.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new A.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ve._handlePool++}_withAdapter(H,G,X,se,q=!1){const te=this._adapter.get(H);if(!te)return Promise.resolve(se);if(te.adapter instanceof G){let fe;te.extension&&(fe=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${G.name}'`));const Re=X(te.adapter,te.extension),xe=te.extension;return xe&&Promise.resolve(Re).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),ze=>{q&&ze instanceof D.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error(ze))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,G){const X=this._nextHandle();return this._adapter.set(X,new $e(H,G)),X}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,G,X,se){const q=this._addNewAdapter(new d(this._documents,X),H),te=se&&se.label||Ve._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),te),this._createDisposable(q)}$provideDocumentSymbols(H,G,X){return this._withAdapter(H,d,se=>se.provideDocumentSymbols(s.URI.revive(G),X),void 0)}registerCodeLensProvider(H,G,X){const se=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new $e(new p(this._documents,this._commands.converter,X),H)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(G),q);let te=this._createDisposable(se);if(q!==void 0){const fe=X.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));te=A.Disposable.from(te,fe)}return te}$provideCodeLenses(H,G,X){return this._withAdapter(H,p,se=>se.provideCodeLenses(s.URI.revive(G),X),void 0)}$resolveCodeLens(H,G,X){return this._withAdapter(H,p,se=>se.resolveCodeLens(G,X),void 0)}$releaseCodeLenses(H,G){this._withAdapter(H,p,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(H,G,X){const se=this._addNewAdapter(new c(this._documents,X),H);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDefinition(H,G,X,se){return this._withAdapter(H,c,q=>q.provideDefinition(s.URI.revive(G),X,se),[])}registerDeclarationProvider(H,G,X){const se=this._addNewAdapter(new M(this._documents,X),H);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDeclaration(H,G,X,se){return this._withAdapter(H,M,q=>q.provideDeclaration(s.URI.revive(G),X,se),[])}registerImplementationProvider(H,G,X){const se=this._addNewAdapter(new o(this._documents,X),H);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideImplementation(H,G,X,se){return this._withAdapter(H,o,q=>q.provideImplementation(s.URI.revive(G),X,se),[])}registerTypeDefinitionProvider(H,G,X){const se=this._addNewAdapter(new i(this._documents,X),H);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideTypeDefinition(H,G,X,se){return this._withAdapter(H,i,q=>q.provideTypeDefinition(s.URI.revive(G),X,se),[])}registerHoverProvider(H,G,X,se){const q=this._addNewAdapter(new f(this._documents,X),H);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(H,G,X,se){return this._withAdapter(H,f,q=>q.provideHover(s.URI.revive(G),X,se),void 0)}registerEvaluatableExpressionProvider(H,G,X,se){const q=this._addNewAdapter(new u(this._documents,X),H);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(H,G,X,se){return this._withAdapter(H,u,q=>q.provideEvaluatableExpression(s.URI.revive(G),X,se),void 0)}registerInlineValuesProvider(H,G,X,se){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new h(this._documents,X),H);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(G),q);let fe=this._createDisposable(te);if(q!==void 0){const Re=X.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(q));fe=A.Disposable.from(fe,Re)}return fe}$provideInlineValues(H,G,X,se,q){return this._withAdapter(H,h,te=>te.provideInlineValues(s.URI.revive(G),X,se,q),void 0)}registerDocumentHighlightProvider(H,G,X){const se=this._addNewAdapter(new b(this._documents,X),H);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentHighlights(H,G,X,se){return this._withAdapter(H,b,q=>q.provideDocumentHighlights(s.URI.revive(G),X,se),void 0)}registerLinkedEditingRangeProvider(H,G,X){const se=this._addNewAdapter(new v(this._documents,X),H);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideLinkedEditingRanges(H,G,X,se){return this._withAdapter(H,v,async q=>{const te=await q.provideLinkedEditingRanges(s.URI.revive(G),X,se);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?Ve._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider(H,G,X){const se=this._addNewAdapter(new a(this._documents,X),H);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideReferences(H,G,X,se,q){return this._withAdapter(H,a,te=>te.provideReferences(s.URI.revive(G),X,se,q),void 0)}registerCodeActionProvider(H,G,X,se){const q=new n.DisposableStore,te=this._addNewAdapter(new _(this._documents,this._commands.converter,this._diagnostics,X,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(G),{providedKinds:se?.providedCodeActionKinds?.map(fe=>fe.value),documentation:se?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,q)}))},Ve._extLabel(H),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(te)),q}$provideCodeActions(H,G,X,se,q){return this._withAdapter(H,_,te=>te.provideCodeActions(s.URI.revive(G),X,se,q),void 0)}$resolveCodeAction(H,G,X){return this._withAdapter(H,_,se=>se.resolveCodeAction(G,X),void 0)}$releaseCodeActions(H,G){this._withAdapter(H,_,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(H,G,X){const se=this._addNewAdapter(new P(this._documents,X),H);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(G),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentFormattingEdits(H,G,X,se){return this._withAdapter(H,P,q=>q.provideDocumentFormattingEdits(s.URI.revive(G),X,se),void 0)}registerDocumentRangeFormattingEditProvider(H,G,X){const se=this._addNewAdapter(new N(this._documents,X),H);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(G),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(H,G,X,se,q){return this._withAdapter(H,N,te=>te.provideDocumentRangeFormattingEdits(s.URI.revive(G),X,se,q),void 0)}registerOnTypeFormattingEditProvider(H,G,X,se){const q=this._addNewAdapter(new $(this._documents,X),H);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),se,H.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(H,G,X,se,q,te){return this._withAdapter(H,$,fe=>fe.provideOnTypeFormattingEdits(s.URI.revive(G),X,se,q,te),void 0)}registerWorkspaceSymbolProvider(H,G){const X=this._addNewAdapter(new y(G,this._logService),H);return this._proxy.$registerNavigateTypeSupport(X,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(H,G,X){return this._withAdapter(H,y,se=>se.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol(H,G,X){return this._withAdapter(H,y,se=>se.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols(H,G){this._withAdapter(H,y,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(H,G,X){const se=this._addNewAdapter(new L(this._documents,X,this._logService),H);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(G),L.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits(H,G,X,se,q){return this._withAdapter(H,L,te=>te.provideRenameEdits(s.URI.revive(G),X,se,q),void 0)}$resolveRenameLocation(H,G,X,se){return this._withAdapter(H,L,q=>q.resolveRenameLocation(s.URI.revive(G),X,se),void 0)}registerDocumentSemanticTokensProvider(H,G,X,se){const q=this._nextHandle(),te=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new $e(new x(this._documents,X),H)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),se,te);let fe=this._createDisposable(q);if(te){const Re=X.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(te));fe=A.Disposable.from(fe,Re)}return fe}$provideDocumentSemanticTokens(H,G,X,se){return this._withAdapter(H,x,q=>q.provideDocumentSemanticTokens(s.URI.revive(G),X,se),null,!0)}$releaseDocumentSemanticTokens(H,G){this._withAdapter(H,x,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(H,G,X,se){const q=this._addNewAdapter(new B(this._documents,X),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(H,G,X,se){return this._withAdapter(H,B,q=>q.provideDocumentRangeSemanticTokens(s.URI.revive(G),X,se),null,!0)}registerCompletionItemProvider(H,G,X,se){const q=this._addNewAdapter(new j(this._documents,this._commands.converter,X,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),se,j.supportsResolving(X),`${H.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems(H,G,X,se,q){return this._withAdapter(H,j,te=>te.provideCompletionItems(s.URI.revive(G),X,se,q),void 0)}$resolveCompletionItem(H,G,X){return this._withAdapter(H,j,se=>se.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems(H,G){this._withAdapter(H,j,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(H,G,X){const se=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideInlineCompletions(H,G,X,se,q){return this._withAdapter(H,ue,te=>te.provideInlineCompletions(s.URI.revive(G),X,se,q),void 0)}$handleInlineCompletionDidShow(H,G,X){this._withAdapter(H,ue,async se=>{se.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList(H,G){this._withAdapter(H,ue,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(H,G,X,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,te=this._addNewAdapter(new ne(this._documents,X),H);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(G),q),this._createDisposable(te)}$provideSignatureHelp(H,G,X,se,q){return this._withAdapter(H,ne,te=>te.provideSignatureHelp(s.URI.revive(G),X,se,q),void 0)}$releaseSignatureHelp(H,G){this._withAdapter(H,ne,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(H,G,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new pe(this._documents,X),H);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),se);let te=this._createDisposable(q);if(se!==void 0){const fe=X.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(se));te=A.Disposable.from(te,fe)}return te}$provideInlayHints(H,G,X,se){return this._withAdapter(H,pe,q=>q.provideInlayHints(s.URI.revive(G),X,se),void 0)}registerDocumentLinkProvider(H,G,X){const se=this._addNewAdapter(new be(this._documents,X),H);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(H,G,X){return this._withAdapter(H,be,se=>se.provideLinks(s.URI.revive(G),X),void 0)}$resolveDocumentLink(H,G,X){return this._withAdapter(H,be,se=>se.resolveLink(G,X),void 0)}$releaseDocumentLinks(H,G){this._withAdapter(H,be,X=>X.releaseLinks(G),void 0)}registerColorProvider(H,G,X){const se=this._addNewAdapter(new ae(this._documents,X),H);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentColors(H,G,X){return this._withAdapter(H,ae,se=>se.provideColors(s.URI.revive(G),X),[])}$provideColorPresentations(H,G,X,se){return this._withAdapter(H,ae,q=>q.provideColorPresentations(s.URI.revive(G),X,se),void 0)}registerFoldingRangeProvider(H,G,X){const se=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new $e(new le(this._documents,X),H)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(G),q);let te=this._createDisposable(se);if(q!==void 0){const fe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));te=A.Disposable.from(te,fe)}return te}$provideFoldingRanges(H,G,X,se){return this._withAdapter(H,le,q=>q.provideFoldingRanges(s.URI.revive(G),X,se),void 0)}registerSelectionRangeProvider(H,G,X){const se=this._addNewAdapter(new Se(this._documents,X,this._logService),H);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideSelectionRanges(H,G,X,se){return this._withAdapter(H,Se,q=>q.provideSelectionRanges(s.URI.revive(G),X,se),[])}registerCallHierarchyProvider(H,G,X){const se=this._addNewAdapter(new Ee(this._documents,X),H);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareCallHierarchy(H,G,X,se){return this._withAdapter(H,Ee,q=>Promise.resolve(q.prepareSession(s.URI.revive(G),X,se)),void 0)}$provideCallHierarchyIncomingCalls(H,G,X,se){return this._withAdapter(H,Ee,q=>q.provideCallsTo(G,X,se),void 0)}$provideCallHierarchyOutgoingCalls(H,G,X,se){return this._withAdapter(H,Ee,q=>q.provideCallsFrom(G,X,se),void 0)}$releaseCallHierarchy(H,G){this._withAdapter(H,Ee,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider(H,G,X){const se=this._addNewAdapter(new Fe(this._documents,X),H);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareTypeHierarchy(H,G,X,se){return this._withAdapter(H,Fe,q=>Promise.resolve(q.prepareSession(s.URI.revive(G),X,se)),void 0)}$provideTypeHierarchySupertypes(H,G,X,se){return this._withAdapter(H,Fe,q=>q.provideSupertypes(G,X,se),void 0)}$provideTypeHierarchySubtypes(H,G,X,se){return this._withAdapter(H,Fe,q=>q.provideSubtypes(G,X,se),void 0)}$releaseTypeHierarchy(H,G){this._withAdapter(H,Fe,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,T.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ve._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ve._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ve._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ve._serializeRegExp(H.beforeText),afterText:H.afterText?Ve._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ve._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(H,G,X){let{wordPattern:se}=X;if(se&&(0,T.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(G,se):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const q=this._nextHandle(),te={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,te),this._createDisposable(q)}$setWordDefinitions(H){for(const G of H)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(ye[190],Ce([0,1,5,8,7,34,14,6]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(F,C,n,m){this._documents=C,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,C){await this._proxy.$changeLanguage(F,C);const n=this._documents.getDocumentData(F);if(!n)throw new Error(`document '${F.toString}' NOT found`);return n.document}async tokenAtPosition(F,C){const n=F.version,m=t.Position.from(C),r=await this._proxy.$tokensAtPosition(F.uri,m),g={type:E.StandardTokenType.Other,range:F.getWordRangeAtPosition(C)??new E.Range(C.line,C.character,C.line,C.character)};if(!r)return g;const l={range:t.Range.to(r.range),type:t.TokenType.to(r.type)};return!l.range.contains(C)||n!==F.version?g:l}createLanguageStatusItem(F,C,n){const m=this._handlePool++,r=this._proxy,g=this._ids,l=`${F.identifier.value}/${C}`;if(g.has(l))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);g.add(l);const D={selector:n,id:C,name:F.displayName??F.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w,d=new T.DisposableStore;const p=()=>{w?.dispose(),w=(0,k.disposableTimeout)(()=>{d.clear(),this._proxy.$setLanguageStatus(m,{id:l,name:D.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===E.LanguageStatusSeverity.Error?A.default.Error:D.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:D.command&&this._commands.toInternal(D.command,d),accessibilityInfo:D.accessibilityInformation,busy:D.busy})},0)},I={dispose(){d.dispose(),w?.dispose(),r.$removeLanguageStatus(m),g.delete(l)},get id(){return D.id},get name(){return D.name},set name(c){D.name=c,p()},get selector(){return D.selector},set selector(c){D.selector=c,p()},get text(){return D.text},set text(c){D.text=c,p()},get detail(){return D.detail},set detail(c){D.detail=c,p()},get severity(){return D.severity},set severity(c){D.severity=c,p()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(c){D.accessibilityInformation=c,p()},get command(){return D.command},set command(c){D.command=c,p()},get busy(){return D.busy},set busy(c){D.busy=c,p()}};return p(),I}}e.ExtHostLanguages=S}),define(ye[191],Ce([0,1,12,5,28,13,4]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends s.AbstractLoggerService{constructor(F,C){const n=new k.Emitter;super(C.logLevel,n.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,C,n){return new S(this._proxy,F,C,n)}};T=Be([He(0,A.IExtHostRpcService),He(1,E.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class S extends s.AbstractMessageLogger{constructor(F,C,n,m){super(m?.always);this.proxy=F,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(C,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,C){const n=[[F,C]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(F){this.proxy.$log(this.file,F)}}}),define(ye[192],Ce([0,1,5,12,27]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let k=class{constructor(S,R){this._logService=R,this._proxy=S.getProxy(s.MainContext.MainThreadMessageService)}showMessage(S,R,F,C,n){const m={extension:S};let r;typeof C=="string"||A(C)?r=[C,...n]:(m.modal=C?.modal,m.useCustom=C?.useCustom,m.detail=C?.detail,r=n),m.useCustom&&(0,E.checkProposedApiEnabled)(S,"resolvers");const g=[];for(let l=0;l<r.length;l++){const D=r[l];if(typeof D=="string")g.push({title:D,handle:l,isCloseAffordance:!1});else if(typeof D=="object"){let{title:w,isCloseAffordance:d}=D;g.push({title:w,isCloseAffordance:!!d,handle:l})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(R,F,m,g).then(l=>{if(typeof l=="number")return r[l]})}};k=Be([He(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(ye[193],Ce([0,1,22,4,57,6,21,9,11,2,63,5,8,7,37,166,91]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(d,p,I,c,M){this._textDocumentsAndEditors=I,this._textDocuments=c,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new t.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=d.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,f=o.cell.handle,h=this._documents.get(i)?.getCell(f);if(h)return h.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}getEditorById(d){const p=this._editors.get(d);if(!p)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(d){for(const[p,I]of this._editors)if(I.apiEditor===d)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,p){const I=this._documents.get(d);if(!I&&!p)throw new Error(`NO notebook document for '${d}'`);return I}_getProviderData(d){const p=this._notebookContentProviders.get(d);if(!p)throw new Error(`NO provider for '${d}'`);return p}registerNotebookContentProvider(d,p,I,c,M){if((0,T.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:d,provider:I});let o;return I.onDidChangeNotebookContentOptions&&(o=I.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(I.options);this._notebookProxy.$updateNotebookProviderOptions(p,i)})),this._notebookProxy.$registerNotebookProvider({id:d.identifier,location:d.extensionLocation},p,n.NotebookDocumentContentOptions.from(c),D._convertNotebookRegistrationData(d,M)),new m.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(d,p){if(!p)return;const I=p.filenamePattern.map(c=>n.NotebookExclusiveDocumentPattern.from(c)).filter(c=>c!==void 0);if(p.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:p.displayName,filenamePattern:I,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,p,I){const c=D._notebookStatusBarItemProviderHandlePool++,M=typeof I.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(c,I),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(c,M,p);let o;return M!==void 0&&(o=I.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(c),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(c,M),o&&o.dispose()})}async createNotebookDocument(d){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:d.viewType,content:d.content&&n.NotebookData.from(d.content)});return R.URI.revive(p)}async openNotebookDocument(d){const p=this._documents.get(d);if(p)return p.apiNotebook;const I=await this._notebookDocumentsProxy.$tryOpenNotebook(d),c=this._documents.get(R.URI.revive(I));return(0,S.assertIsDefined)(c?.apiNotebook)}async showNotebookDocument(d,p){R.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let I;typeof p=="object"?I={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:I={preserveFocus:!1};const c=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.notebookType,I),M=c&&this._editors.get(c)?.apiEditor;if(M)return M;throw c?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,p,I,c){const M=this._notebookStatusBarItemProviders.get(d),o=R.URI.revive(p),i=this._documents.get(o);if(!i||!M)return;const f=i.getCellFromIndex(I);if(!f)return;const u=await M.provideCellStatusBarItems(f.apiCell,c);if(!u)return;const h=new A.DisposableStore,b=this._statusBarCache.add([h]),a=(Array.isArray(u)?u:[u]).map(_=>n.NotebookStatusBarItem.from(_,this._commandsConverter,h));return{cacheId:b,items:a}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,p,I,c,M){if((0,T.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,I),this._notebookProxy.$registerNotebookSerializer(o,{id:d.identifier,location:d.extensionLocation},p,n.NotebookDocumentContentOptions.from(c),D._convertNotebookRegistrationData(d,M)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(d,p,I){const c=this._notebookSerializer.get(d);if(!c)throw new Error("NO serializer found");const M=await c.deserializeNotebook(p.buffer,I);return new r.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(d,p,I){const c=this._notebookSerializer.get(d);if(!c)throw new Error("NO serializer found");const M=await c.serializeNotebook(n.NotebookData.to(p.value),I);return s.VSBuffer.wrap(M)}async $openNotebook(d,p,I,c,M){const{provider:o}=this._getProviderData(d),i=await o.openNotebook(R.URI.revive(p),{backupId:I,untitledDocumentData:c?.buffer},M);return new r.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(d,p,I){const c=this.getNotebookDocument(R.URI.revive(p)),{provider:M}=this._getProviderData(d);return await M.saveNotebook(c.apiNotebook,I),!0}async $saveNotebookAs(d,p,I,c){const M=this.getNotebookDocument(R.URI.revive(p)),{provider:o}=this._getProviderData(d);return await o.saveNotebookAs(R.URI.revive(I),M.apiNotebook,c),!0}async $backupNotebook(d,p,I){const c=this.getNotebookDocument(R.URI.revive(p)),M=this._getProviderData(d),o=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,E.hash)([c.uri.toString(),this._backupIdPool++])),f=R.URI.joinPath(o,i),u=await M.provider.backupNotebook(c.apiNotebook,{destination:f},I);return c.updateBackup(u),u.id}_createExtHostEditor(d,p,I){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const c=new l.ExtHostNotebookEditor(p,this._notebookEditorsProxy,d,I.visibleRanges.map(n.NotebookRange.to),I.selections.map(n.NotebookRange.to),typeof I.viewColumn=="number"?n.ViewColumn.to(I.viewColumn):void 0);this._editors.set(p,c)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const I of d.value.removedDocuments){const c=R.URI.revive(I),M=this._documents.get(c);M&&(M.dispose(),this._documents.delete(c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===c.toString()&&this._editors.delete(o.id)}if(d.value.addedDocuments){const I=[];for(const c of d.value.addedDocuments){const M=R.URI.revive(c.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const o=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){o._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){o._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){o._onDidChangeCellMetadata.fire(f)},emitCellExecutionStateChange(f){o._onDidChangeCellExecutionState.fire(f)}},M,c);I.push(...c.cells.map(f=>g.ExtHostCell.asModelAddData(i.apiNotebook,f))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(d.value.addedEditors)for(const I of d.value.addedEditors){if(this._editors.has(I.id))return;const c=R.URI.revive(I.documentUri),M=this._documents.get(c);M&&this._createExtHostEditor(M,I.id,I)}const p=[];if(d.value.removedEditors)for(const I of d.value.removedEditors){const c=this._editors.get(I);c&&(this._editors.delete(I),this._activeNotebookEditor?.id===c.id&&(this._activeNotebookEditor=void 0),p.push(c))}if(d.value.visibleEditors){this._visibleNotebookEditors=d.value.visibleEditors.map(c=>this._editors.get(c)).filter(c=>!!c);const I=new Set;this._visibleNotebookEditors.forEach(c=>I.add(c.id));for(const c of this._editors.values()){const M=I.has(c.id);c._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(c=>c).filter(c=>c.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this._activeNotebookEditor=void 0:d.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(ye[194],Ce([0,1,4,53,12,5,13,8]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(C,n){const m=S._Keys.nextId();C.$registerNotebookEditorDecorationType(m,T.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){C.$removeNotebookEditorDecorationType(m)}}}}S._Keys=new t.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(C,n,m){this._logService=C,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,n);const m=this._notebooksAndEditors.getEditorById(C);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(T.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(T.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const n in C)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(T.ViewColumn.to(C[n]))}};R=Be([He(0,E.ILogService),He(1,k.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(ye[195],Ce([0,1,16,14,20,4,6,21,2,25,12,5,38,8,7,66,158,27,37]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let d=class{constructor(o,i,f,u,h){this._initData=i,this._extHostNotebook=f,this._commands=u,this._logService=h,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=o.getProxy(C.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:a}}else if(v&&"notebookEditor"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(a===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:a}}return v})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(o,i,f,u,h,b){for(let ne of this._kernelData.values())if(ne.controller.id===i&&R.ExtensionIdentifier.equals(o.identifier,ne.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const v=this._handlePool++,a=this;this._logService.trace(`NotebookController[${v}], CREATED by ${o.identifier.value}, ${i}`);const _=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${o.identifier}'`);let P=!1;const N=new k.DisposableStore,$=new A.Emitter,y=new A.Emitter,L={id:`${o.identifier.value}/${i}`,notebookType:f,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:u||o.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let z=h??_,x;this._proxy.$addKernel(v,L).catch(ne=>{console.log(ne),P=!0});let B=0;const j=()=>{if(P)return;const ne=++B;Promise.resolve().then(()=>{ne===B&&this._proxy.$updateKernel(v,L)})},ue=new T.ResourceMap,K={get id(){return i},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return L.label},set label(ne){L.label=ne??o.displayName??o.name,j()},get detail(){return L.detail??""},set detail(ne){L.detail=ne,j()},get description(){return L.description??""},set description(ne){L.description=ne,j()},get kind(){return(0,D.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind??""},set kind(ne){(0,D.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind=ne,j()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(ne){L.supportedLanguages=ne,j()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){L.supportsExecutionOrder=ne,j()},get rendererScripts(){return L.preloads?L.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ne){z=ne??_},get interruptHandler(){return x},set interruptHandler(ne){x=ne,L.supportsInterrupt=Boolean(ne),j()},createNotebookCellExecution(ne){if(P)throw new Error("notebook controller is DISPOSED");if(!ue.has(ne.notebook.uri))throw a._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return a._createNotebookCellExecution(ne)},dispose:()=>{P||(this._logService.trace(`NotebookController[${v}], DISPOSED`),P=!0,this._kernelData.delete(v),N.dispose(),$.dispose(),y.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(ne,pe){a._proxy.$updateNotebookPriority(v,ne.uri,pe)},onDidReceiveMessage:y.event,postMessage(ne,pe){return(0,D.checkProposedApiEnabled)(o,"notebookMessaging"),a._proxy.$postMessage(v,pe&&a._extHostNotebook.getIdByEditor(pe),ne)},asWebviewUri(ne){return(0,D.checkProposedApiEnabled)(o,"notebookMessaging"),(0,g.asWebviewUri)(ne,a._initData.remote)}};return this._kernelData.set(v,{extensionId:o.identifier,controller:K,onDidReceiveMessage:y,onDidChangeSelection:$,associatedNotebooks:ue}),K}$acceptNotebookAssociation(o,i,f){const u=this._kernelData.get(o);if(u){const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));f?u.associatedNotebooks.set(h.uri,!0):u.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,h.uri.toString(),f),u.onDidChangeSelection.fire({selected:f,notebook:h.apiNotebook})}}async $executeCells(o,i,f){const u=this._kernelData.get(o);if(!u)return;const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),b=[];for(let v of f){const a=h.getCell(v);a&&b.push(a.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,h.uri.toString(),b.length),await u.controller.executeHandler.call(u.controller,b,h.apiNotebook,u.controller)}catch(v){this._logService.error(`NotebookController[${o}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(o,i,f){const u=this._kernelData.get(o);if(!u)return;const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,h.apiNotebook);else for(let b of f){const v=h.getCell(b);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,i,f){const u=this._kernelData.get(o);if(!u)return;const h=this._extHostNotebook.getEditorById(i);u.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:f}))}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!f)throw new Error("invalid cell");if(this._activeExecutions.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const u=new I(f.notebook,f,this._proxy);this._activeExecutions.set(f.uri,u);const h=u.onDidChangeState(()=>{u.state===p.Resolved&&(u.dispose(),h.dispose(),this._activeExecutions.delete(f.uri))});return u.asApiObject()}};d=Be([He(4,F.ILogService)],d),e.ExtHostNotebookKernels=d;var p;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(p||(p={}));class I extends k.Disposable{constructor(o,i,f){super();this._document=o,this._cell=i,this._proxy=f,this._handle=I.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new c(10,u=>this.update(u)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const i=Array.isArray(o)?o:[o];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let i=this._cell;if(o&&(i=this._document.getCellFromApiCell(o)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(o){return o.map(i=>{const f=r.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return f===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:f,id:i.id,metadata:i.metadata})})}async updateOutputs(o,i,f){const u=this.cellIndexToHandle(i),h=this.validateAndConvertOutputs((0,s.asArray)(o));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:u,append:f,outputs:h})}async updateOutputItems(o,i,f){return o=r.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(o),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:o.map(m.NotebookCellOutputItem.from),outputId:i.id,append:f})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(f){o._executionOrder=f,o.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,executionOrder:o._executionOrder}])},start(f){if(o._state===p.Resolved||o._state===p.Started)throw new Error("Cannot call start again");o._state=p.Started,o._onDidChangeState.fire(),o.update({editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,runStartTime:f})},end(f,u){if(o._state===p.Resolved)throw new Error("Cannot call resolve twice");o._state=p.Resolved,o._onDidChangeState.fire(),o.updateSoon({editType:l.CellExecutionUpdateType.Complete,executionHandle:o._handle,runEndTime:u,lastRunSuccess:f}),o._collector.flush(),o._proxy.$removeExecution(o._handle)},clearOutput(f){return o.verifyStateForOutput(),o.updateOutputs([],f,!1)},appendOutput(f,u){return o.verifyStateForOutput(),o.updateOutputs(f,u,!0)},replaceOutput(f,u){return o.verifyStateForOutput(),o.updateOutputs(f,u,!1)},appendOutputItems(f,u){return o.verifyStateForOutput(),o.updateOutputItems(f,u,!0)},replaceOutputItems(f,u){return o.verifyStateForOutput(),o.updateOutputItems(f,u,!1)}})}}I.HANDLE=0;class c{constructor(o,i){this.delay=o,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>o.complete())}}}),define(ye[196],Ce([0,1,4,5,91,27]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(S,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,R,F){const C=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(R)?.fire({editor:C.apiEditor,message:F})}createRendererMessaging(S,R){if(!S.contributes?.notebookRenderer?.some(m=>m.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,A.isProposedApiEnabled)(S,"notebookEditor"),C=new WeakMap;return{onDidReceiveMessage:(m,r,g)=>{const l=F?m:D=>{const w={};C.set(w,D.editor),m({editor:w,message:D.message})};return this.getOrCreateEmitterFor(R).event(l,r,g)},postMessage:(m,r)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,r]=[r,m]);const g=F?r:C.get(r),l=g&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(l?.id,R,m)}}}getOrCreateEmitterFor(S){let R=this._rendererMessageEmitters.get(S);return R||(R=new s.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,R),R)}}e.ExtHostNotebookRenderers=k}),define(ye[94],Ce([0,1,5,6,3,13,12,159,49,28,30,109,22]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class m extends t.Disposable{constructor(l,D,w,d){super();this.id=l,this.name=D,this.logger=w,this.proxy=d,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(l){this.append(l+`
`)}append(l){this.write(l),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const l=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,l)}replace(l){const D=this.offset;this.write(l),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(l,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof l=="boolean"?l:D))}hide(){this.proxy.$close(this.id)}write(l){this.offset+=n.VSBuffer.fromString(l).byteLength,this.logger.info(l)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=m;let r=class{constructor(l,D,w,d,p){this.extHostFileSystem=w,this.extHostFileSystemInfo=d,this.loggerService=p,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=l.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.visibleChannelId=l;for(const[D,w]of this.channels)w.visible=D===this.visibleChannelId}createOutputChannel(l,D){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(l,D);return w.then(d=>{this.channels.set(d.id,d),d.visible=d.id===this.visibleChannelId}),this.createExtHostOutputChannel(l,w)}async doCreateOutputChannel(l,D){const w=await this.createOutputDirectory(),d=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),I=await this.proxy.$register(l,!1,d,D.identifier.value);return new m(I,l,p,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(l,D){let w=!1;const d=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return l},append(p){d(),D.then(I=>I.append(p))},appendLine(p){d(),D.then(I=>I.appendLine(p))},clear(){d(),D.then(p=>p.clear())},replace(p){d(),D.then(I=>I.replace(p))},show(p,I){d(),D.then(c=>c.show(p,I))},hide(){d(),D.then(p=>p.hide())},dispose(){w=!0,D.then(p=>p.dispose())}}}};r=Be([He(0,A.IExtHostRpcService),He(1,R.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,F.IExtHostFileSystemInfo),He(4,k.ILoggerService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(ye[197],Ce([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function r(g,l,D){const w=g.getProxy(k.MainContext.MainThreadQuickOpen);class d{constructor(h,b){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=b}showQuickPick(h,b,v=t.CancellationToken.None){this._onDidSelectItem=void 0;const a=Promise.resolve(h),_=++this._instances,P=w.$show(_,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},v),N={},$=P.then(()=>N);return Promise.race([$,a]).then(y=>{if(y!==N)return a.then(L=>{const z=[];for(let x=0;x<L.length;x++){const B=L[x];typeof B=="string"?z.push({label:B,handle:x}):B.kind===S.QuickPickItemKind.Separator?z.push({type:"separator",label:B.label}):z.push({label:B.label,description:B.description,detail:B.detail,picked:B.picked,alwaysShow:B.alwaysShow,handle:x})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{b.onDidSelectItem(L[x])}),w.$setItems(_,z),P.then(x=>{if(typeof x=="number")return L[x];if(Array.isArray(x))return x.map(B=>L[B])})})}).then(void 0,y=>{if(!(0,R.isPromiseCanceledError)(y))return w.$setError(_,y),Promise.reject(y)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,b=t.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,w.$input(h,typeof this._validateInput=="function",b).then(void 0,v=>{if(!(0,R.isPromiseCanceledError)(v))return Promise.reject(v)})}$validateInput(h){return this._validateInput?(0,s.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,b=t.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!v)return;const a=await this._workspace.getWorkspaceFolders2();if(!!a)return a.find(_=>_.uri.toString()===v.uri.toString())}createQuickPick(h){const b=new i(h,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(h){const b=new f(h,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(h,b){const v=this._sessions.get(h);v&&v._fireDidChangeValue(b)}$onDidAccept(h){const b=this._sessions.get(h);b&&b._fireDidAccept()}$onDidChangeActive(h,b){const v=this._sessions.get(h);v instanceof i&&v._fireDidChangeActive(b)}$onDidChangeSelection(h,b){const v=this._sessions.get(h);v instanceof i&&v._fireDidChangeSelection(b)}$onDidTriggerButton(h,b){const v=this._sessions.get(h);v&&v._fireDidTriggerButton(b)}$onDidTriggerItemButton(h,b,v){const a=this._sessions.get(h);a instanceof i&&a._fireDidTriggerItemButton(b,v)}$onDidHide(h){const b=this._sessions.get(h);b&&b._fireDidHide()}}class p{constructor(h,b){this._extensionId=h,this._onDidDispose=b,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((b,v)=>{const a=b===S.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(a,b)}),this.update({buttons:h.map((b,v)=>({...o(b),tooltip:b.tooltip,handle:b===S.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const b=this._handlesToButtons.get(h);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(h){if(!this._disposed){for(const b of Object.keys(h)){const v=h[b];this._pendingUpdate[b]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function I(u){if(u instanceof S.ThemeIcon)return{id:u.id};const h=M(u),b=c(u);return{dark:typeof h=="string"?T.URI.file(h):h,light:typeof b=="string"?T.URI.file(b):b}}function c(u){return typeof u=="object"&&"light"in u?u.light:u}function M(u){return typeof u=="object"&&"dark"in u?u.dark:u}function o(u){const h=I(u.iconPath);let b,v;return"id"in h?v=n.ThemeIcon.asClassName(h):b=h,{iconPath:b,iconClass:v}}class i extends p{constructor(h,b){super(h.identifier,b);this.extension=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){h.some(v=>v.kind!==void 0)&&(0,m.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((v,a)=>{this._handlesToItems.set(a,v),this._itemsToHandles.set(v,a)});const b=[];for(let v=0;v<h.length;v++){const a=h[v];a.kind===S.QuickPickItemKind.Separator?b.push({type:"separator",label:a.label}):b.push({handle:v,label:a.label,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,buttons:a.buttons?.map((_,P)=>({...o(_),tooltip:_.tooltip,handle:P}))})}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(h){const b=(0,F.coalesce)(h.map(v=>this._handlesToItems.get(v)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(h){const b=(0,F.coalesce)(h.map(v=>this._handlesToItems.get(v)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(h,b){const v=this._handlesToItems.get(h);if(!v||!v.buttons||!v.buttons.length)return;const a=v.buttons[b];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:v})}}class f extends p{constructor(h,b){super(h,b);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?C.default.Error:C.default.Ignore})}}return new d(l,D)}e.createExtHostQuickOpen=r});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[198],Ce([0,1,2,4,52,6,14,5,16,104,12,25,62,8,27]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r){"use strict";var g,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function D(b){if(b)return typeof b.iconPath=="string"?s.URI.file(b.iconPath):s.URI.isUri(b.iconPath)||n.ThemeIcon.isThemeIcon(b.iconPath)?b.iconPath:void 0}function w(b,v){if(!b.iconPath&&!v.iconPath)return 0;if(b.iconPath){if(!v.iconPath)return 1}else return-1;const a=typeof b.iconPath=="string"?b.iconPath:s.URI.isUri(b.iconPath)?b.iconPath.fsPath:b.iconPath.id,_=typeof v.iconPath=="string"?v.iconPath:s.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,R.comparePaths)(a,_)}function d(b,v){let a=0;if(b.strikeThrough!==v.strikeThrough)return b.strikeThrough?1:-1;if(b.faded!==v.faded)return b.faded?1:-1;if(b.tooltip!==v.tooltip)return(b.tooltip||"").localeCompare(v.tooltip||"");if(a=w(b,v),a!==0)return a;if(b.light&&v.light)a=w(b.light,v.light);else{if(b.light)return 1;if(v.light)return-1}if(a!==0)return a;if(b.dark&&v.dark)a=w(b.dark,v.dark);else{if(b.dark)return 1;if(v.dark)return-1}return a}function p(b,v){if(b.command!==v.command)return b.command<v.command?-1:1;if(b.title!==v.title)return b.title<v.title?-1:1;if(b.tooltip!==v.tooltip){if(b.tooltip!==void 0&&v.tooltip!==void 0)return b.tooltip<v.tooltip?-1:1;if(b.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(b.arguments===v.arguments)return 0;if(b.arguments)if(v.arguments){if(b.arguments.length!==v.arguments.length)return b.arguments.length-v.arguments.length}else return 1;else return-1;for(let a=0;a<b.arguments.length;a++){const _=b.arguments[a],P=v.arguments[a];if(_!==P)return _<P?-1:1}return 0}function I(b,v){let a=(0,R.comparePaths)(b.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(a!==0)return a;if(b.command&&v.command)a=p(b.command,v.command);else{if(b.command)return 1;if(v.command)return-1}if(a!==0)return a;if(b.decorations&&v.decorations)a=d(b.decorations,v.decorations);else{if(b.decorations)return 1;if(v.decorations)return-1}return a}function c(b,v){for(let a=0;a<b.length;a++)if(b[a]!==v[a])return!1;return!0}function M(b,v){return b.command===v.command&&b.title===v.title&&b.tooltip===v.tooltip&&(b.arguments&&v.arguments?c(b.arguments,v.arguments):b.arguments===v.arguments)}function o(b,v){return(0,S.equals)(b,v,M)}class i{constructor(v,a,_){this._extension=v,this._sourceControlHandle=_,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ze(this,g,a,"f")}get value(){return this._value}set value(v){v=v??"",Ie(this,g,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Ie(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Ie(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Ie(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}showValidationMessage(v,a){(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,g,"f").$showValidationMessage(this._sourceControlHandle,v,a)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=i,g=new WeakMap;class f{constructor(v,a,_,P,N){this._proxy=v,this._commands=a,this._sourceControlHandle=_,this._id=P,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,a){const _=this._resourceStatesCommandsMap.get(v);return _?(0,k.asPromise)(()=>this._commands.executeCommand(_.command,..._.arguments||[],a)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(I),_=(0,S.sortedDiff)(this._resourceSnapshot,v,I).map($=>{const y=$.toInsert.map(L=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,L);const x=L.resourceUri;let B;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Ee=new A.DisposableStore;B=this._commands.converter.toInternal(L.command,Ee),this._resourceStatesDisposablesMap.set(z,Ee)}else this._resourceStatesCommandsMap.set(z,L.command);const j=D(L.decorations),ue=L.decorations&&D(L.decorations.light)||j,K=L.decorations&&D(L.decorations.dark)||j,ne=[ue,K],pe=L.decorations&&L.decorations.tooltip||"",be=L.decorations&&!!L.decorations.strikeThrough,ae=L.decorations&&!!L.decorations.faded,le=L.contextValue||"";return{rawResource:[z,x,ne,pe,be,ae,le,B],handle:z}});return{start:$.start,deleteCount:$.deleteCount,toInsert:y}}),P=_.map(({start:$,deleteCount:y,toInsert:L})=>[$,y,L.map(z=>z.rawResource)]),N=_.reverse();for(const{start:$,deleteCount:y,toInsert:L}of N){const z=L.map(B=>B.handle),x=this._handlesSnapshot.splice($,y,...z);for(const B of x)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=v,P}dispose(){this._disposed=!0,this._onDidDispose.fire()}}f._handlePool=0;class u{constructor(v,a,_,P,N,$){this._extension=v,this._commands=_,this._id=P,this._label=N,this._rootUri=$,l.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ze(this,l,a,"f"),this._inputBox=new i(v,Ie(this,l,"f"),this.handle),Ie(this,l,"f").$registerSourceControl(this.handle,P,N,$)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Ie(this,l,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Ie(this,l,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Ie(this,l,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=v;const a=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Ie(this,l,"f").$updateSourceControl(this.handle,{acceptInputCommand:a})}get actionButton(){return(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=v;const a=v!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,l,"f").$updateSourceControl(this.handle,{actionButton:a??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&o(this._statusBarCommands,v))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=v;const a=(v||[]).map(_=>this._commands.converter.toInternal(_,this._statusBarDisposables.value));Ie(this,l,"f").$updateSourceControl(this.handle,{statusBarCommands:a})}get selected(){return this._selected}createResourceGroup(v,a){const _=new f(Ie(this,l,"f"),this._commands,this.handle,v,a),P=t.Event.once(_.onDidDispose)(()=>this.createdResourceGroups.delete(_));return this.createdResourceGroups.set(_,P),this.eventuallyAddResourceGroups(),_}eventuallyAddResourceGroups(){const v=[],a=[];for(const[_,P]of this.createdResourceGroups){P.dispose();const N=_.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(_),this.eventuallyUpdateResourceStates()});t.Event.once(_.onDidDispose)(()=>{this.updatedResourceGroups.delete(_),N.dispose(),this._groups.delete(_.handle),Ie(this,l,"f").$unregisterGroup(this.handle,_.handle)}),v.push([_.handle,_.id,_.label,_.features]);const $=_._takeResourceStateSnapshot();$.length>0&&a.push([_.handle,$]),this._groups.set(_.handle,_)}Ie(this,l,"f").$registerGroups(this.handle,v,a),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(a=>{const _=a._takeResourceStateSnapshot();_.length!==0&&v.push([a.handle,_])}),v.length>0&&Ie(this,l,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Ie(this,l,"f").$unregisterSourceControl(this.handle)}}l=new WeakMap,u._handlePool=0,Be([(0,E.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),Be([(0,E.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let h=class zi{constructor(v,a,_){this._commands=a,this.logService=_,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=v.getProxy(T.MainContext.MainThreadSCM),this._telemetry=v.getProxy(T.MainContext.MainThreadTelemetry),a.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const N=this._sourceControls.get(P.sourceControlHandle);if(!N)return P;const $=N.getResourceGroup(P.groupHandle);return $?$.getResourceState(P.handle):P}else if(P&&P.$mid===4){const N=this._sourceControls.get(P.sourceControlHandle);return N?N.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const N=this._sourceControls.get(P.handle);return N||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(v,a,_,P){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,a,_,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const N=zi._handlePool++,$=new u(v,this._proxy,this._commands,a,_,P);this._sourceControls.set(N,$);const y=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(v.identifier))||[];return y.push($),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(v.identifier),y),$}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const a=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(v.identifier)),_=a&&a[a.length-1];return _&&_.inputBox}$provideOriginalResource(v,a,_){const P=s.URI.revive(a);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,P.toString());const N=this._sourceControls.get(v);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(P,_)).then($=>$||null)}$onInputBoxValueChange(v,a){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const _=this._sourceControls.get(v);return _&&_.inputBox.$onInputBoxValueChange(a),Promise.resolve(void 0)}$executeResourceCommand(v,a,_,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,a,_);const N=this._sourceControls.get(v);if(!N)return Promise.resolve(void 0);const $=N.getResourceGroup(a);return $?$.$executeResourceCommand(_,P):Promise.resolve(void 0)}$validateInput(v,a,_){this.logService.trace("ExtHostSCM#$validateInput",v);const P=this._sourceControls.get(v);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>P.inputBox.validateInput(a,_)).then(N=>{if(!N)return Promise.resolve(void 0);const $=m.MarkdownString.fromStrict(N.message);return $?Promise.resolve([$,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};h._handlePool=0,h=Be([He(2,F.ILogService)],h),e.ExtHostSCM=h});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[199],Ce([0,1,7,5,121,6,8,11]),function(Z,e,s,t,E,A,k,T){"use strict";var S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(r,g,l,D,w=s.StatusBarAlignment.Left,d){S.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ze(this,S,r,"f"),Ze(this,R,g,"f"),this._entryId=F.ID_GEN++,this._extension=l,this._id=D,this._alignment=w,this._priority=this.validatePriority(d)}validatePriority(r){if(!!(0,T.isNumber)(r))return r===Number.POSITIVE_INFINITY?Number.MAX_VALUE:r===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:r}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(r){this._text=r,this.update()}set name(r){this._name=r,this.update()}set tooltip(r){this._tooltip=r,this.update()}set color(r){this._color=r,this.update()}set backgroundColor(r){r&&!F.ALLOWED_BACKGROUND_COLORS.has(r.id)&&(r=void 0),this._backgroundColor=r,this.update()}set command(r){this._command?.fromApi!==r&&(this._internalCommandRegistration.clear(),typeof r=="string"?this._command={fromApi:r,internal:Ie(this,R,"f").toInternal({title:"",command:r},this._internalCommandRegistration)}:r?this._command={fromApi:r,internal:Ie(this,R,"f").toInternal(r,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(r){this._accessibilityInformation=r,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let r;this._extension?this._id?r=`${this._extension.identifier.value}.${this._id}`:r=this._extension.identifier.value:r=this._id;let g;this._name?g=this._name:g=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,S,"f").$setEntry(this._entryId,r,g,this._text,D,this._command?.internal,l,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,S=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(r){this._messages=[],this._item=r.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(r){const g={message:r};return this._messages.unshift(g),this._update(),new s.Disposable(()=>{const l=this._messages.indexOf(g);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(r,g){this._proxy=r.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new C(this)}createStatusBarEntry(r,g,l,D){return new F(this._proxy,this._commands,r,g,l,D)}setStatusBarMessage(r,g){const l=this._statusMessage.setMessage(r);let D;return typeof g=="number"?D=setTimeout(()=>l.dispose(),g):typeof g!="undefined"&&g.then(()=>l.dispose(),()=>l.dispose()),new s.Disposable(()=>{l.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(ye[71],Ce([0,1,5,4,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this._proxy.$registerExtensionStorageKeysToSync(T,S)}getValue(T,S,R){return this._proxy.$getValue(T,S).then(F=>F||R)}setValue(T,S,R){return this._proxy.$setValue(T,S,R)}$acceptValue(T,S,R){this._onDidChangeStorage.fire({shared:T,key:S,value:R})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(ye[72],Ce([0,1,3,28,12,49,2]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let T=class{constructor(R,F,C){this._logService=F,this._extHostFileSystem=C,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(R){return k.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(R){if(this._value)return k.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return k.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Be([He(0,t.IExtHostInitDataService),He(1,E.ILogService),He(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(ye[39],Ce([0,1,4,5,3,2,13,6,7,122,15,161,20,35,144,62,11,14]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class w{constructor(u,h,b,v){this._proxy=u,this._id=h,this._creationOptions=b,this._name=v,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},get state(){return a._state},sendText(_,P=!0){a._checkDisposed(),a._proxy.$sendText(a._id,_,P)},show(_){a._checkDisposed(),a._proxy.$show(a._id,_)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(u,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,l.withNullAsUndefined)(u.shellPath),shellArgs:(0,l.withNullAsUndefined)(u.shellArgs),cwd:(0,l.withNullAsUndefined)(u.cwd),env:(0,l.withNullAsUndefined)(u.env),icon:(0,l.withNullAsUndefined)(o(u.iconPath)),color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,l.withNullAsUndefined)(u.message),strictEnv:(0,l.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,l.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,l.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,l.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(u.location,h?.resolvedExtHostIdentifier),disablePersistence:(0,l.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,h,b,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:g.ThemeColor.isThemeColor(v)?v.id:void 0,location:this._serializeParentTerminal(u,h),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,h){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,h){return u===this._cols&&h===this._rows||u===0||h===0?!1:(this._cols=u,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=w;class d{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,h){this._pty.setDimensions?.({columns:u,rows:h})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=d;let p=1,I=class extends T.Disposable{constructor(u,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[b,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,h){const b=new w(this._proxy,(0,m.generateUuid)(),u,u.name),v=new d(u.pty);return b.createExtensionTerminal(u.location,this._serializeParentTerminal(u,h).resolvedExtHostIdentifier,o(u.iconPath),i(u.color)).then(a=>{const _=this._setupExtHostProcessListeners(a,v);this._terminalProcessDisposables[a]=_}),this._terminals.push(b),b.value}_serializeParentTerminal(u,h){if(h=h||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const b=u.location.parentTerminal;if(b){const v=this._terminals.find(a=>a.value===b);v&&(h.resolvedExtHostIdentifier=v._id)}}else u.location&&typeof u.location!="object"?h.location=u.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(u,h){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const v=new d(h),a=this._setupExtHostProcessListeners(u,v);this._terminalProcessDisposables[u]=a}async $acceptActiveTerminalChanged(u){const h=this._activeTerminal;if(u===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(u);b&&(this._activeTerminal=b,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,h){const b=this._getTerminalById(u);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:h})}async $acceptTerminalDimensions(u,h,b){const v=this._getTerminalById(u);v&&v.setDimensions(h,b)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(u,h,b){this._terminalProcesses.get(u)?.resize(h,b)}async $acceptTerminalTitleChange(u,h){const b=this._getTerminalById(u);b&&(b.name=h)}async $acceptTerminalClosed(u,h){const b=this._getTerminalObjectIndexById(this._terminals,u);if(b!==null){const v=this._terminals.splice(b,1)[0];v.setExitCode(h),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(u,h,b,v){if(h){const P=this._getTerminalObjectIndexById(this._terminals,h);if(P!==null){this._terminals[P]._id=u,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const a={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:A.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},_=new w(this._proxy,u,a,b);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(u,h){const b=this._getTerminalById(u);b&&b._setProcessId(h)}async $startExtensionTerminal(u,h){const b=this._getTerminalById(u);if(!b)return{message:(0,R.localize)(0,null,u)};b.isOpen||await new Promise(a=>{const _=this.onDidOpenTerminal(async P=>{P===b.value&&(_.dispose(),a())})});const v=this._terminalProcesses.get(u);v?v.startSendingEvents(h):this._extensionTerminalAwaitingStart[u]={initialDimensions:h}}_setupExtHostProcessListeners(u,h){const b=new T.DisposableStore;b.add(h.onProcessReady(a=>this._proxy.$sendProcessReady(u,a.pid,a.cwd))),b.add(h.onDidChangeProperty(a=>this._proxy.$sendProcessProperty(u,a))),this._bufferer.startBuffering(u,h.onProcessData),b.add(h.onProcessExit(a=>this._onProcessExit(u,a))),this._terminalProcesses.set(u,h);const v=this._extensionTerminalAwaitingStart[u];return v&&h instanceof d&&(h.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),b}$acceptProcessAckDataEvent(u,h){this._terminalProcesses.get(u)?.acknowledgeDataEvent(h)}$acceptProcessInput(u,h){this._terminalProcesses.get(u)?.input(h)}$acceptTerminalInteraction(u){const h=this._getTerminalById(u);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(u,h,b){try{this._terminalProcesses.get(u)?.resize(h,b)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(u,h){this._terminalProcesses.get(u)?.shutdown(h)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(h=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:h}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,h,b){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,b),this._proxy.$registerProfileProvider(h,u.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(u,h){const b=new n.CancellationTokenSource().token;let v=await this._profileProviders.get(u)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(v&&!("options"in v)&&(v={options:v}),!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,h);return}this.createTerminalFromOptions(v.options,h)}}async $provideLinks(u,h){const b=this._getTerminalById(u);if(!b)return[];this._terminalLinkCache.delete(u);const v=this._terminalLinkCancellationSource.get(u);v&&v.dispose(!0);const a=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,a);const _=[],P={terminal:b.value,line:h},N=[];for(const L of this._linkProviders)N.push(D.Promises.withAsyncBody(async z=>{a.token.onCancellationRequested(()=>z({provider:L,links:[]}));const x=await L.provideTerminalLinks(P,a.token)||[];a.token.isCancellationRequested||z({provider:L,links:x})}));const $=await Promise.all(N);if(a.token.isCancellationRequested)return[];const y=new Map;for(const L of $)L&&L.links.length>0&&_.push(...L.links.map(z=>{const x={id:p++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return y.set(x.id,{provider:L.provider,link:z}),x}));return this._terminalLinkCache.set(u,y),_}$activateLink(u,h){const b=this._terminalLinkCache.get(u)?.get(h);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(u,h){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const b=this._terminalProcessDisposables[u];b&&(b.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,h)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,h){const b=this._getTerminalObjectIndexById(u,h);return b!==null?u[b]:null}_getTerminalObjectIndexById(u,h){let b=null;return u.some((v,a)=>v._id===h?(b=a,!0):!1),b}getEnvironmentVariableCollection(u){let h=this._environmentVariableCollections.get(u.identifier.value);return h||(h=new c,this._setEnvironmentVariableCollection(u.identifier.value,h)),h}_syncEnvironmentVariableCollection(u,h){const b=(0,C.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(u,h.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(u){u.forEach(h=>{const b=h[0],v=new c(h[1]);this._setEnvironmentVariableCollection(b,v)})}$acceptDefaultProfile(u,h){this._defaultProfile=u,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(u,h){this._environmentVariableCollections.set(u,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,h)})}};I=Be([He(1,k.IExtHostRpcService)],I),e.BaseExtHostTerminalService=I;class c{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,h){this._setIfDiffers(u,{value:h,type:S.EnvironmentVariableMutatorType.Replace})}append(u,h){this._setIfDiffers(u,{value:h,type:S.EnvironmentVariableMutatorType.Append})}prepend(u,h){this._setIfDiffers(u,{value:h,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,h){const b=this.map.get(u);(!b||b.value!==h.value||b.type!==h.type)&&(this.map.set(u,h),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,h){this.map.forEach((b,v)=>u.call(h,v,b,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let M=class extends I{constructor(u){super(!1,u)}createTerminal(u,h,b){throw new F.NotSupportedError}createTerminalFromOptions(u,h){throw new F.NotSupportedError}};M=Be([He(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function o(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function i(f){return g.ThemeColor.isThemeColor(f)?f:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[200],Ce([0,1,16,22,20,4,230,57,6,26,11,35,5,13,47,8,7,169,88,67]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let I=class{constructor(P,N){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new M(this.proxy),N.registerArgumentProcessor({processArgument:$=>$?.$mid===13?g.TestItem.toItemFromContext($):$})}createTestController(P,N){if(this.controllers.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const $=new S.DisposableStore,y=$.add(new D.SingleUseTestCollection(P));y.root.label=N;const L=new Map,z=this.proxy,x={items:y.root.children,get label(){return N},set label(j){N=j,y.root.label=j,z.$updateControllerLabel(P,N)},get id(){return P},createRunProfile:(j,ue,K,ne,pe)=>{let be=(0,T.hash)(j);for(;L.has(be);)be++;const ae=new v(this.proxy,P,be,j,ue,K,ne,pe);return L.set(be,ae),ae},createTestItem(j,ue,K){return new r.TestItemImpl(P,j,ue,K)},createTestRun:(j,ue,K=!0)=>this.runTracker.createTestRun(P,y,j,ue,K),set resolveHandler(j){y.resolveHandler=j},get resolveHandler(){return y.resolveHandler},dispose:()=>{$.dispose()}};x.createRunConfiguration=x.createRunProfile,z.$registerTestController(P,N),$.add((0,S.toDisposable)(()=>z.$unregisterTestController(P)));const B={controller:x,collection:y,profiles:L};return this.controllers.set(P,B),$.add((0,S.toDisposable)(()=>this.controllers.delete(P))),$.add(y.onDidGenerateDiff(j=>z.$publishDiff(P,j))),x}createTestObserver(){return this.observer.checkout()}async runTests(P,N=E.CancellationToken.None){const $=o(P);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get($.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:P.include?.map(L=>L.id)??[y.collection.root.id],profileGroup:a[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:P.exclude?.map(L=>L.id)},N)}$provideFileCoverage(P,N,$){return(0,s.mapFind)(this.runTracker.trackers,L=>L.id===P?L.getCoverage(N):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(P,N,$,y){return(0,s.mapFind)(this.runTracker.trackers,z=>z.id===P?z.getCoverage(N):void 0)?.resolveFileCoverage($,y)??Promise.resolve([])}$configureRunProfile(P,N){this.controllers.get(P)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(P){this.results=Object.freeze(P.map(N=>(0,R.deepFreeze)(g.TestResults.to(N))).concat(this.results).sort((N,$)=>$.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(P,N){const $=this.controllers.get(d.TestId.fromString(P).controllerId)?.collection;$&&(await $.expand(P,N<0?1/0:N),$.flushDiff())}$acceptDiff(P){this.observer.applyDiff(P)}async $runControllerTests(P,N){const $=this.controllers.get(P.controllerId);if(!$)return;const{collection:y,profiles:L}=$,z=L.get(P.profileId);if(!z)return;const x=P.testIds.map(K=>y.tree.get(K)).filter(F.isDefined),B=P.excludeExtIds.map(K=>$.collection.tree.get(K)).filter(F.isDefined).filter(K=>x.some(ne=>ne.fullId.compare(K.fullId)===2));if(!x.length)return;const j=new l.TestRunRequest(x.some(K=>K.actual instanceof r.TestItemRootImpl)?void 0:x.map(K=>K.actual),B.map(K=>K.actual),z),ue=this.runTracker.prepareForMainThreadTestRun(j,i.fromInternal(P,$.collection),N);try{await z.runHandler(j,N)}finally{ue.isRunning&&!N.isCancellationRequested&&await A.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(P){P===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(P)}};I=Be([He(0,m.IExtHostRpcService)],I),e.ExtHostTesting=I;class c extends S.Disposable{constructor(P,N,$){super();this.dto=P,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(P){return this.tasks.get(P)?.coverage}createRun(P){const N=this.dto.id,$=this.dto.controllerId,y=(0,C.generateUuid)(),L=new f(this.proxy,N,y),z=ue=>(K,...ne)=>{if(B){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...ne))},x=(ue,K)=>{const ne=K instanceof Array?K.map(g.TestMessage.from):[g.TestMessage.from(K)];if(ue.uri&&ue.range){const pe={range:g.Range.from(ue.range),uri:ue.uri};for(const be of ne)be.location=be.location||pe}this.proxy.$appendTestMessagesInRun(N,y,d.TestId.fromExtHostTestItem(ue,$).toString(),ne)};let B=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:P,get coverageProvider(){return L.coverageProvider},set coverageProvider(ue){L.coverageProvider=ue},enqueued:z(ue=>{this.proxy.$updateTestStateInRun(N,y,d.TestId.fromExtHostTestItem(ue,$).toString(),1)}),skipped:z(ue=>{this.proxy.$updateTestStateInRun(N,y,d.TestId.fromExtHostTestItem(ue,$).toString(),5)}),started:z(ue=>{this.proxy.$updateTestStateInRun(N,y,d.TestId.fromExtHostTestItem(ue,$).toString(),2)}),errored:z((ue,K,ne)=>{x(ue,K),this.proxy.$updateTestStateInRun(N,y,d.TestId.fromExtHostTestItem(ue,$).toString(),6,ne)}),failed:z((ue,K,ne)=>{x(ue,K),this.proxy.$updateTestStateInRun(N,y,d.TestId.fromExtHostTestItem(ue,$).toString(),4,ne)}),passed:z((ue,K)=>{this.proxy.$updateTestStateInRun(N,y,d.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,ne)=>{B||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(N,y,t.VSBuffer.fromString(ue),K&&g.location.from(K),ne&&d.TestId.fromExtHostTestItem(ne,$).toString()))},end:()=>{B||(B=!0,this.proxy.$finishedTestRunTask(N,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:j,coverage:L}),this.proxy.$startedTestRunTask(N,{id:y,name:P,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(P){if(!(P instanceof r.TestItemImpl))throw new r.InvalidTestItemError(P.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(P,this.dto.controllerId).toString()))return;const N=[],$=this.dto.colllection.root;for(;;){const y=g.TestItem.from(P);if(N.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),P===$))break;P=P.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class M{constructor(P){this.proxy=P,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(P,N,$){return this.getTracker(P,N,$)}cancelRunById(P){for(const N of this.tracked.values())if(N.id===P){N.dispose();return}}cancelAllRuns(){for(const P of this.tracked.values())P.dispose()}createTestRun(P,N,$,y,L){const z=this.tracked.get($);if(z)return z.createRun(y);const x=i.fromPublic(P,N,$,L),B=o($);this.proxy.$startedExtensionTestRun({controllerId:P,profile:B&&{group:a[B.kind],id:B.profileId},exclude:$.exclude?.map(ue=>ue.id)??[],id:x.id,include:$.include?.map(ue=>ue.id)??[N.root.id],persist:L});const j=this.getTracker($,x);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),j.createRun(y)}getTracker(P,N,$){const y=new c(N,this.proxy,$);return this.tracked.set(P,y),y.onEnd(()=>this.tracked.delete(P)),y}}e.TestRunCoordinator=M;const o=_=>{if(!!_.profile){if(!(_.profile instanceof v))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return _.profile}};class i{constructor(P,N,$,y,L,z){this.controllerId=P,this.id=N,this.isPersisted=L,this.colllection=z,this.includePrefix=$.map(x=>x+"\0"),this.excludePrefix=y.map(x=>x+"\0")}static fromPublic(P,N,$,y){return new i(P,(0,C.generateUuid)(),$.include?.map(L=>d.TestId.fromExtHostTestItem(L,P).toString())??[P],$.exclude?.map(L=>d.TestId.fromExtHostTestItem(L,P).toString())??[],y,N)}static fromInternal(P,N){return new i(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,N)}isIncluded(P){const N=d.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(N===$||N.startsWith($))return!1;for(const $ of this.includePrefix)if(N===$||N.startsWith($))return!0;return!1}}e.TestRunDto=i;class f{constructor(P,N,$){this.proxy=P,this.runId=N,this.taskId=$}set coverageProvider(P){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this._coverageProvider=P,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(P){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(P))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(P,N){const $=await this.fileCoverage;let y=$?.[P];return!this._coverageProvider||!$||!y?[]:(y.detailedCoverage||(y=$[P]=await this._coverageProvider.resolveFileCoverage?.(y,N)??y),y.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class u extends w.IncrementalChangeCollector{constructor(P){super();this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(P){this.added.add(P)}update(P){Object.assign(P.revived,g.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}if(this.updated.delete(P),P.parent&&this.alreadyRemoved.has(P.parent)){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:N,removed:$}=this;return{get added(){return[...P].map(y=>y.revived)},get updated(){return[...N].map(y=>y.revived)},get removed(){return[...$].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,N){return{...P,revived:g.TestItem.toPlain(P.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=h;class b{constructor(P){this.proxy=P}checkout(){this.current||(this.current=this.createObserverData());const P=this.current;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(N=>N.revived)},dispose:(0,k.once)(()=>{--P.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(P){return this.current?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.current?.tests.apply(P)}createObserverData(){const P=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:P}}}class v{constructor(P,N,$,y,L,z,x=!1,B=void 0){this.controllerId=N,this.profileId=$,this._label=y,this.kind=L,this.runHandler=z,this._isDefault=x,this._tag=B,p.set(this,void 0),Ze(this,p,P,"f");const j=a[L];if(typeof j!="number")throw new Error(`Unknown TestRunProfile.group ${L}`);Ie(this,p,"f").$publishTestRunProfile({profileId:$,controllerId:N,tag:B?g.TestTag.namespace(this.controllerId,B.id):null,label:y,group:j,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(P){P!==this._label&&(this._label=P,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get isDefault(){return this._isDefault}set isDefault(P){P!==this._isDefault&&(this._isDefault=P,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?g.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(P){P!==this._configureHandler&&(this._configureHandler=P,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}dispose(){Ie(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=v,p=new WeakMap;const a={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(ye[201],Ce([0,1,4,16,5,92,8,7]),function(Z,e,s,t,E,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(F,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new s.Emitter,this._onDidChangeTextEditorOptions=new s.Emitter,this._onDidChangeTextEditorVisibleRanges=new s.Emitter,this._onDidChangeTextEditorViewColumn=new s.Emitter,this._onDidChangeActiveTextEditor=new s.Emitter,this._onDidChangeVisibleTextEditors=new s.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const C=this._extHostDocumentsAndEditors.allEditors();return F?C:C.map(n=>n.value)}async showTextDocument(F,C,n){let m;typeof C=="number"?m={position:k.ViewColumn.from(C),preserveFocus:n}:typeof C=="object"?m={position:k.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?k.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(F.uri,m),g=r&&this._extHostDocumentsAndEditors.getEditor(r);if(g)return g.value;throw r?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,C){return new A.TextEditorDecorationType(this._proxy,F,C).value}$acceptEditorPropertiesChanged(F,C){const n=this._extHostDocumentsAndEditors.getEditor(F);if(!n)throw new Error("unknown text editor");if(C.options&&n._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(k.Selection.to);n._acceptSelections(m)}if(C.visibleRanges){const m=t.coalesce(C.visibleRanges.map(k.Range.to));n._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...C.options,lineNumbers:k.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const m=T.TextEditorSelectionChangeKind.fromValue(C.selections.source),r=C.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:r,kind:m})}if(C.visibleRanges){const m=t.coalesce(C.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(F){for(const C in F){const n=this._extHostDocumentsAndEditors.getEditor(C);if(!n)throw new Error("Unknown text editor");const m=k.ViewColumn.to(F[C]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=S}),define(ye[202],Ce([0,1,2,3,5,6,7]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class T{constructor(F,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(E.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:s.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(m))?.get(n.handle)}return n}})}async $getTimeline(F,C,n,m,r){return this._providers.get(F)?.provideTimeline(s.URI.revive(C),n,m,r)}registerTimelineProvider(F,C,n,m){const r=new A.DisposableStore,g=this.convertTimelineItem(C.id,m,r).bind(this);let l;C.onDidChange&&(l=C.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:C.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:F,onDidChange:void 0,async provideTimeline(w,d,p,I){I?.resetCache&&(r.clear(),D.get(C.id)?.clear());const c=await C.provideTimeline(w,d,p);if(c==null)return;const M=g(w,I);return{...c,source:C.id,items:c.items.map(M)}},dispose(){for(const w of D.values())w.get(C.id)?.clear();l?.dispose(),r.dispose()}})}convertTimelineItem(F,C,n){return(m,r)=>{let g;if(r?.cacheResults){let l=this._itemsBySourceAndUriMap.get(F);l===void 0&&(l=new Map,this._itemsBySourceAndUriMap.set(F,l));const D=S(m);g=l.get(D),g===void 0&&(g=new Map,l.set(D,g))}return l=>{const{iconPath:D,...w}=l,d=`${F}|${l.id??l.timestamp}`;g?.set(d,l);let p,I,c;return l.iconPath&&(D instanceof k.ThemeIcon?c={id:D.id,color:D.color}:s.URI.isUri(D)?(p=D,I=D):{light:p,dark:I}=D),{...w,id:w.id??void 0,handle:d,source:F,command:l.command?C.toInternal(l.command,n):void 0,icon:p,iconDark:I,themeIcon:c,accessibilityInformation:l.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=T;function S(R){return R?.toString()}}),define(ye[203],Ce([0,1,6,10,2,5]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,R,F,C){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const n=C.schemes.find(m=>!k.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,C.schemes,S,C.label),(0,s.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(S,R,F){const C=this._openers.get(S);if(!C)throw new Error(`Unknown opener with id: ${S}`);const n=E.URI.revive(R);return C.canOpenExternalUri(n,F)}async $openUri(S,R,F){const C=this._openers.get(S);if(!C)throw new Error(`Unknown opener id: '${S}'`);return C.openExternalUri(E.URI.revive(R.resolvedUri),{sourceUri:E.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[204],Ce([0,1,5,2,6,15,25]),function(Z,e,s,t,E,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(k.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const C=T.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(R)),this.handlers.set(C,F),this._proxy.$registerUriHandler(C,R),(0,E.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(R)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(R,F){const C=this.handlers.get(R);if(!C)return Promise.resolve(void 0);try{C.handleUri(t.URI.revive(F))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(R){return t.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=T,T.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[50],Ce([0,1,4,10,2,131,151,66,5]),function(Z,e,s,t,E,A,k,T,S){"use strict";var R,F,C,n,m,r,g,l,D,w,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class I{constructor(b,v,a,_,P,N,$){R.set(this,void 0),F.set(this,void 0),C.set(this,void 0),n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),g.set(this,""),l.set(this,void 0),D.set(this,!1),w.set(this,!1),d.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new s.Emitter),this._onDidDispose=Ie(this,p,"f").event,Ze(this,R,b,"f"),Ze(this,F,v,"f"),Ze(this,l,a,"f"),Ze(this,n,_,"f"),Ze(this,m,P,"f"),Ze(this,r,N,"f"),Ze(this,d,c(N),"f"),Ze(this,C,$,"f")}dispose(){Ze(this,D,!0,"f"),Ie(this,p,"f").fire(),Ie(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,w,!0,"f"),(0,T.asWebviewUri)(b,Ie(this,n,"f").remote)}get cspSource(){const b=Ie(this,r,"f").extensionLocation;if(b.scheme===t.Schemas.https||b.scheme===t.Schemas.http){let v=b.toString();return v.endsWith("/")||(v+="/"),v+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,g,"f")}set html(b){this.assertNotDisposed(),Ie(this,g,"f")!==b&&(Ze(this,g,b,"f"),!Ie(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,w,!0,"f"),Ie(this,C,"f").report("Webview vscode-resource: uris",Ie(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,F,"f").$setHtml(Ie(this,R,"f"),b))}get options(){return this.assertNotDisposed(),Ie(this,l,"f")}set options(b){this.assertNotDisposed(),Ie(this,F,"f").$setOptions(Ie(this,R,"f"),i(Ie(this,r,"f"),Ie(this,m,"f"),b)),Ze(this,l,b,"f")}async postMessage(b){if(Ie(this,D,"f"))return!1;const v=(0,k.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ie(this,d,"f")});return Ie(this,F,"f").$postMessage(Ie(this,R,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Ie(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=I,R=new WeakMap,F=new WeakMap,C=new WeakMap,n=new WeakMap,m=new WeakMap,r=new WeakMap,g=new WeakMap,l=new WeakMap,D=new WeakMap,w=new WeakMap,d=new WeakMap,p=new WeakMap;function c(h){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(h.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;class M{constructor(b,v,a,_,P){this.initData=v,this.workspace=a,this._logService=_,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=b.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(b,v,a){const _=this.getWebview(b);if(_){const{message:P}=(0,k.deserializeWebviewMessage)(v,a.value);_._onMessageEmitter.fire(P)}}$onMissingCsp(b,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,v,a){const _=new I(b,this._webviewProxy,f(v),this.initData,this.workspace,a,this._deprecationService);return this._webviews.set(b,_),_._onDidDispose(()=>{this._webviews.delete(b)}),_}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=M;function o(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=o;function i(h,b,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||u(h,b)}}e.serializeWebviewOptions=i;function f(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(b=>E.URI.from(b))}}e.reviveOptions=f;function u(h,b){return[...(b?.getWorkspaceFolders()||[]).map(v=>v.uri),h.extensionLocation]}}),define(ye[205],Ce([0,1,20,57,6,10,24,2,8,50,63,5,7]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(c,M){this.document=c,this._storagePath=M,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,M){await this.getEdit(c).undo(),M||this.disposeBackup()}async redo(c,M){await this.getEdit(c).redo(),M||this.disposeBackup()}disposeEdits(c){for(const M of c)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=p(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const M=this._edits.get(c,0);if(!M)throw new Error("No edit found");return M}}class r{constructor(){this._documents=new Map}get(c,M){return this._documents.get(this.key(c,M))}add(c,M,o){const i=this.key(c,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${c} resource:${M.uri}`);const f=new m(M,o);return this._documents.set(i,f),f}delete(c,M){const o=this.key(c,M.uri);this._documents.delete(o)}key(c,M){return`${c}@@@${M}`}}var g;(function(I){I[I.Text=0]="Text",I[I.Custom=1]="Custom"})(g||(g={}));class l{constructor(){this._providers=new Map}addTextProvider(c,M,o){return this.add(0,c,M,o)}addCustomProvider(c,M,o){return this.add(1,c,M,o)}get(c){return this._providers.get(c)}add(c,M,o,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:c,extension:o,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class D{constructor(c,M,o,i,f){this._extHostDocuments=M,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=f,this._editorProviders=new l,this._documents=new r,this._proxy=c.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,M,o,i){const f=new E.DisposableStore;return w(o)?(f.add(this._editorProviders.addTextProvider(M,c,o)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(c),M,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(c))):(f.add(this._editorProviders.addCustomProvider(M,c,o)),this.supportEditing(o)&&f.add(o.onDidChangeCustomDocument(u=>{const h=this.getCustomDocumentEntry(M,u.document.uri);if(d(u)){const b=h.addEdit(u);this._proxy.$onDidEdit(u.document.uri,M,b,u.label)}else this._proxy.$onContentChange(u.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(c),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(c))),n.Disposable.from(f,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(c,M,o,i,f){const u=this._editorProviders.get(M);if(!u)throw new Error(`No provider found for '${M}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${M}'`);const h=T.URI.revive(c),b=await u.provider.openCustomDocument(h,{backupId:o,untitledDocumentData:i?.buffer},f);let v;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(M,b,v),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(c,M){const o=this._editorProviders.get(M);if(!o)throw new Error(`No provider found for '${M}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=T.URI.revive(c),{document:f}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,f),f.dispose()}async $resolveWebviewEditor(c,M,o,i,f,u){const h=this._editorProviders.get(o);if(!h)throw new Error(`No provider found for '${o}'`);const b=S.ViewColumn.to(f),v=this._extHostWebview.createNewWebview(M,i.webviewOptions,h.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(M,o,i.title,b,i.panelOptions,v),_=T.URI.revive(c);switch(h.type){case 1:{const{document:P}=this.getCustomDocumentEntry(o,_);return h.provider.resolveCustomEditor(P,a,u)}case 0:{const P=this._extHostDocuments.getDocument(_);return h.provider.resolveCustomTextEditor(P,a,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,M,o){this.getCustomDocumentEntry(M,c).disposeEdits(o)}async $onMoveCustomEditor(c,M,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const f=this._extHostWebviewPanels.getWebviewPanel(c);if(!f)throw new Error("No webview found");const u=T.URI.revive(M),h=this._extHostDocuments.getDocument(u);await i.provider.moveCustomTextEditor(h,f,s.CancellationToken.None)}async $undo(c,M,o,i){return this.getCustomDocumentEntry(M,c).undo(o,i)}async $redo(c,M,o,i){return this.getCustomDocumentEntry(M,c).redo(o,i)}async $revert(c,M,o){const i=this.getCustomDocumentEntry(M,c);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(c,M,o){const i=this.getCustomDocumentEntry(M,c);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(c,M,o,i){const f=this.getCustomDocumentEntry(M,c);return this.getCustomEditorProvider(M).saveCustomDocumentAs(f.document,T.URI.revive(o),i)}async $backup(c,M,o){const i=this.getCustomDocumentEntry(M,c),u=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(u),u.id}getCustomDocumentEntry(c,M){const o=this._documents.get(c,T.URI.revive(M));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(c){const o=this._editorProviders.get(c)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(c){return!!c.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function w(I){return typeof I.resolveCustomTextEditor=="function"}function d(I){return typeof I.undo=="function"&&typeof I.redo=="function"}function p(I){const c=I.scheme===A.Schemas.file||I.scheme===A.Schemas.untitled?I.fsPath:I.toString();return(0,t.hash)(c)+""}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[206],Ce([0,1,4,6,2,35,8,50,5,7]),function(Z,e,s,t,E,A,k,T,S,R){"use strict";var F,C,n,m,r,g,l,D,w,d,p,I,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(u,h,b,v,a,_,P){super();F.set(this,void 0),C.set(this,void 0),n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),g.set(this,void 0),l.set(this,void 0),D.set(this,void 0),w.set(this,!0),d.set(this,!0),p.set(this,!1),I.set(this,this._register(new s.Emitter)),this.onDidDispose=Ie(this,I,"f").event,c.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=Ie(this,c,"f").event,Ze(this,F,u,"f"),Ze(this,C,h,"f"),Ze(this,n,b,"f"),Ze(this,r,_,"f"),Ze(this,D,a,"f"),Ze(this,g,v,"f"),Ze(this,m,P,"f")}dispose(){Ie(this,p,"f")||(Ze(this,p,!0,"f"),Ie(this,I,"f").fire(),Ie(this,C,"f").$disposeWebview(Ie(this,F,"f")),Ie(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,n,"f")}get title(){return this.assertNotDisposed(),Ie(this,g,"f")}set title(u){this.assertNotDisposed(),Ie(this,g,"f")!==u&&(Ze(this,g,u,"f"),Ie(this,C,"f").$setTitle(Ie(this,F,"f"),u))}get iconPath(){return this.assertNotDisposed(),Ie(this,l,"f")}set iconPath(u){this.assertNotDisposed(),Ie(this,l,"f")!==u&&(Ze(this,l,u,"f"),Ie(this,C,"f").$setIconPath(Ie(this,F,"f"),E.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Ie(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,D,"f")=="number"&&Ie(this,D,"f")<0))return Ie(this,D,"f")}get active(){return this.assertNotDisposed(),Ie(this,d,"f")}get visible(){return this.assertNotDisposed(),Ie(this,w,"f")}_updateViewState(u){Ie(this,p,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ze(this,d,u.active,"f"),Ze(this,w,u.visible,"f"),Ze(this,D,u.viewColumn,"f"),Ie(this,c,"f").fire({webviewPanel:this}))}reveal(u,h){this.assertNotDisposed(),Ie(this,C,"f").$reveal(Ie(this,F,"f"),{viewColumn:u?k.ViewColumn.from(u):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Ie(this,p,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,C=new WeakMap,n=new WeakMap,m=new WeakMap,r=new WeakMap,g=new WeakMap,l=new WeakMap,D=new WeakMap,w=new WeakMap,d=new WeakMap,p=new WeakMap,I=new WeakMap,c=new WeakMap;class o{constructor(u,h,b){this.webviews=h,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(u,h,b,v,a={}){const _=typeof v=="object"?v.viewColumn:v,P={viewColumn:k.ViewColumn.from(_),preserveFocus:typeof v=="object"&&!!v.preserveFocus},N=(0,T.shouldSerializeBuffersForPostMessage)(u),$=o.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(u),$,h,{title:b,panelOptions:i(a),webviewOptions:(0,T.serializeWebviewOptions)(u,this.workspace,a),serializeBuffersForPostMessage:N},P);const y=this.webviews.createNewWebview($,a,u);return this.createNewWebviewPanel($,h,b,_,a,y)}$onDidChangeWebviewPanelViewStates(u){const h=Object.keys(u);h.sort((b,v)=>{const a=u[b],_=u[v];return a.active?1:_.active?-1:+a.visible-+_.visible});for(const b of h){const v=this.getWebviewPanel(b);if(!v)continue;const a=u[b];v._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,h,b){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:b,extension:u}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(u)}),new R.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(u,h,b,v){const a=this._serializers.get(h);if(!a)throw new Error(`No serializer found for '${h}'`);const{serializer:_,extension:P}=a,N=this.webviews.createNewWebview(u,b.webviewOptions,P),$=this.createNewWebviewPanel(u,h,b.title,v,b.panelOptions,N);await _.deserializeWebviewPanel($,b.state)}createNewWebviewPanel(u,h,b,v,a,_){const P=new M(u,this._proxy,h,b,v,a,_);return this._webviewPanels.set(u,P),P}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=o;function i(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[207],Ce([0,1,4,6,50,5,7]),function(Z,e,s,t,E,A,k){"use strict";var T,S,R,F,C,n,m,r,g,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends t.Disposable{constructor(p,I,c,M,o,i){super();T.set(this,void 0),S.set(this,void 0),R.set(this,void 0),F.set(this,void 0),C.set(this,!1),n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),g.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=Ie(this,g,"f").event,l.set(this,this._register(new s.Emitter)),this.onDidDispose=Ie(this,l,"f").event,Ze(this,R,c,"f"),Ze(this,m,M,"f"),Ze(this,T,p,"f"),Ze(this,S,I,"f"),Ze(this,F,o,"f"),Ze(this,n,i,"f")}dispose(){Ie(this,C,"f")||(Ze(this,C,!0,"f"),Ie(this,l,"f").fire(),Ie(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,m,"f")}set title(p){this.assertNotDisposed(),Ie(this,m,"f")!==p&&(Ze(this,m,p,"f"),Ie(this,S,"f").$setWebviewViewTitle(Ie(this,T,"f"),p))}get description(){return this.assertNotDisposed(),Ie(this,r,"f")}set description(p){this.assertNotDisposed(),Ie(this,r,"f")!==p&&(Ze(this,r,p,"f"),Ie(this,S,"f").$setWebviewViewDescription(Ie(this,T,"f"),p))}get visible(){return Ie(this,n,"f")}get webview(){return Ie(this,F,"f")}get viewType(){return Ie(this,R,"f")}_setVisible(p){p===Ie(this,n,"f")||Ie(this,C,"f")||(Ze(this,n,p,"f"),Ie(this,g,"f").fire())}show(p){this.assertNotDisposed(),Ie(this,S,"f").$show(Ie(this,T,"f"),!!p)}assertNotDisposed(){if(Ie(this,C,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,S=new WeakMap,R=new WeakMap,F=new WeakMap,C=new WeakMap,n=new WeakMap,m=new WeakMap,r=new WeakMap,g=new WeakMap,l=new WeakMap;class w{constructor(p,I){this._extHostWebview=I,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,I,c,M){if(this._viewProviders.has(I))throw new Error(`View provider for '${I}' already registered`);return this._viewProviders.set(I,{provider:c,extension:p}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(p),I,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(I),this._proxy.$unregisterWebviewViewProvider(I)})}async $resolveWebviewView(p,I,c,M,o){const i=this._viewProviders.get(I);if(!i)throw new Error(`No view provider found for '${I}'`);const{provider:f,extension:u}=i,h=this._extHostWebview.createNewWebview(p,{},u),b=new D(p,this._proxy,I,c,h,!0);this._webviewViews.set(p,b),await f.resolveWebviewView(b,{state:M},o)}async $onDidChangeWebviewViewVisibility(p,I){this.getWebviewView(p)._setVisible(I)}async $disposeWebviewView(p){const I=this.getWebviewView(p);this._webviewViews.delete(p),I.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const I=this._webviewViews.get(p);if(!I)throw new Error("No webview found");return I}}e.ExtHostWebviewViews=w}),define(ye[95],Ce([0,1,4,5,2,10,9,3,13]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Wi{constructor(C){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=C.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,n){let m;if(typeof C=="string"){m=C;try{C=E.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,k.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,n)}async asExternalUri(C,n){if((0,k.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(C,n);return E.URI.from(m)}};R.InitialState={focused:!0},R=Be([He(0,S.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(ye[208],Ce([0,1,14,22,20,15,4,6,105,175,37]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(a,_){try{return JSON.stringify(a,_)}catch{return"null"}}const m="$$ref$$",r={[m]:-1};class g{constructor(_,P){this.jsonString=_,this.referencedBuffers=P}}function l(a,_=null,P=!1){const N=[];return{jsonString:(P?n:JSON.stringify)(a,(y,L)=>{if(typeof L=="undefined")return r;if(typeof L=="object"){if(L instanceof t.VSBuffer){const z=N.push(L)-1;return{[m]:z}}if(_)return _(y,L)}return L}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=l;function D(a,_,P){return JSON.parse(a,(N,$)=>{if($){const y=$[m];if(typeof y=="number")return _[y];if(P&&$.$mid===1)return P.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=D;function w(a,_){return JSON.stringify(a,_)}function d(a){return a?(_,P)=>P&&P.$mid===1?a.transformOutgoing(P):P:null}var p;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var I;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(I=e.ResponsiveState||(e.ResponsiveState={}));const c=()=>{},M=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(_,P=null,N=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=_,this._logger=P,this._uriTransformer=N,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,y=F.ProxyIdentifier.count;$<y;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(_=>{this._pendingRPCReplies[_].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(_){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(_){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(_){this._responsiveState!==_&&(this._responsiveState=_,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(_){return this._uriTransformer?(0,S.transformIncomingURIs)(_,this._uriTransformer):_}getProxy(_){const{nid:P,sid:N}=_;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,N)),this._proxies[P]}_createProxy(_,P){let N={get:($,y)=>(typeof y=="string"&&!$[y]&&y.charCodeAt(0)===36&&($[y]=(...L)=>this._remoteCall(_,y,L)),y===o?P:$[y])};return new Proxy(Object.create(null),N)}set(_,P){return this._locals[_.nid]=P,P}assertRegistered(_){for(let P=0,N=_.length;P<N;P++){const $=_[P];if(!this._locals[$.nid])throw new Error(`Missing actor ${$.sid} (isMain: ${$.isMain})`)}}_receiveOneMessage(_){if(this._isDisposed)return;const P=_.byteLength,N=f.read(_,0),$=N.readUInt8(),y=N.readUInt32();switch($){case 1:case 2:{let{rpcId:L,method:z,args:x}=h.deserializeRequestJSONArgs(N);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(P,y,L,z,x,$===2);break}case 3:case 4:{let{rpcId:L,method:z,args:x}=h.deserializeRequestMixedArgs(N);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(P,y,L,z,x,$===4);break}case 5:{this._logger&&this._logger.logIncoming(P,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(P,y);break}case 7:{this._receiveReply(P,y,void 0);break}case 9:{let L=h.deserializeReplyOKJSON(N);this._uriTransformer&&(L=(0,S.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(P,y,L);break}case 10:{const L=h.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(P,y,L);break}case 8:{let L=h.deserializeReplyOKVSBuffer(N);this._receiveReply(P,y,L);break}case 11:{let L=h.deserializeReplyErrError(N);this._uriTransformer&&(L=(0,S.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(P,y,L);break}case 12:{this._receiveReplyErr(P,y,void 0);break}default:console.error("received unexpected message"),console.error(_)}}_receiveRequest(_,P,N,$,y,L){this._logger&&this._logger.logIncoming(_,P,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(N)}.${$}(`,y);const z=String(P);let x,B;if(L){const ue=new E.CancellationTokenSource;y.push(ue.token),x=this._invokeHandler(N,$,y),B=()=>ue.cancel()}else x=this._invokeHandler(N,$,y),B=c;this._cancelInvokedHandlers[z]=B;const j=h.serializeAcknowledged(P);this._logger&&this._logger.logOutgoing(j.byteLength,P,1,"ack"),this._protocol.send(j),x.then(ue=>{delete this._cancelInvokedHandlers[z];const K=h.serializeReplyOK(P,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,P,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[z];const K=h.serializeReplyErr(P,ue);this._logger&&this._logger.logOutgoing(K.byteLength,P,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(_,P){this._logger&&this._logger.logIncoming(_,P,1,"receiveCancel");const N=String(P);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(_,P,N){this._logger&&this._logger.logIncoming(_,P,0,"receiveReply:",N);const $=String(P);if(!this._pendingRPCReplies.hasOwnProperty($))return;const y=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],y.resolveOk(N)}_receiveReplyErr(_,P,N){this._logger&&this._logger.logIncoming(_,P,0,"receiveReplyErr:",N);const $=String(P);if(!this._pendingRPCReplies.hasOwnProperty($))return;const y=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let L;N&&(N.$isError?(L=new Error,L.name=N.name,L.message=N.message,L.stack=N.stack):L=N),y.resolveErr(L)}_invokeHandler(_,P,N){try{return Promise.resolve(this._doInvokeHandler(_,P,N))}catch($){return Promise.reject($)}}_doInvokeHandler(_,P,N){const $=this._locals[_];if(!$)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(_));let y=$[P];if(typeof y!="function")throw new Error("Unknown method "+P+" on actor "+(0,F.getStringIdentifierForProxy)(_));return y.apply($,N)}_remoteCall(_,P,N){if(this._isDisposed)return Promise.reject(A.canceled());let $=null;if(N.length>0&&E.CancellationToken.isCancellationToken(N[N.length-1])&&($=N.pop()),$&&$.isCancellationRequested)return Promise.reject(A.canceled());const y=h.serializeRequestArguments(N,this._uriReplacer),L=++this._lastMessageId,z=String(L),x=new R.LazyPromise;$&&$.onCancellationRequested(()=>{const j=h.serializeCancel(L);this._logger&&this._logger.logOutgoing(j.byteLength,L,0,"cancel"),this._protocol.send(h.serializeCancel(L))}),this._pendingRPCReplies[z]=x,this._onWillSendRequest(L);const B=h.serializeRequest(L,_,P,y,!!$);return this._logger&&this._logger.logOutgoing(B.byteLength,L,0,`request: ${(0,F.getStringIdentifierForProxy)(_)}.${P}(`,N),this._protocol.send(B),x}}e.RPCProtocol=i,C=M,i.UNRESPONSIVE_TIME=3*1e3;class f{constructor(_,P){this._buff=_,this._offset=P}static alloc(_,P,N){let $=new f(t.VSBuffer.alloc(N+1+4),0);return $.writeUInt8(_),$.writeUInt32(P),$}static read(_,P){return new f(_,P)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(_){this._buff.writeUInt8(_,this._offset),this._offset+=1}readUInt8(){const _=this._buff.readUInt8(this._offset);return this._offset+=1,_}writeUInt32(_){this._buff.writeUInt32BE(_,this._offset),this._offset+=4}readUInt32(){const _=this._buff.readUInt32BE(this._offset);return this._offset+=4,_}static sizeShortString(_){return 1+_.byteLength}writeShortString(_){this._buff.writeUInt8(_.byteLength,this._offset),this._offset+=1,this._buff.set(_,this._offset),this._offset+=_.byteLength}readShortString(){const _=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,N}static sizeLongString(_){return 4+_.byteLength}writeLongString(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readLongString(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,N}writeBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}static sizeVSBuffer(_){return 4+_.byteLength}writeVSBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readVSBuffer(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+_);return this._offset+=_,P}static sizeMixedArray(_){let P=0;P+=1;for(let N=0,$=_.length;N<$;N++){const y=_[N];switch(P+=1,y.type){case 1:P+=this.sizeLongString(y.value);break;case 2:P+=this.sizeVSBuffer(y.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(y.value);for(let L=0;L<y.buffers.length;++L)P+=this.sizeVSBuffer(y.buffers[L]);break;case 4:break}}return P}writeMixedArray(_){this._buff.writeUInt8(_.length,this._offset),this._offset+=1;for(let P=0,N=_.length;P<N;P++){const $=_[P];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let y=0;y<$.buffers.length;++y)this.writeBuffer($.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const _=this._buff.readUInt8(this._offset);this._offset+=1;let P=new Array(_);for(let N=0;N<_;N++)switch(this.readUInt8()){case 1:P[N]=this.readLongString();break;case 2:P[N]=this.readVSBuffer();break;case 3:{const y=this.readUInt32(),L=this.readLongString(),z=[];for(let x=0;x<y;++x)z.push(this.readVSBuffer());P[N]=new F.SerializableObjectWithBuffers(D(L,z,null));break}case 4:P[N]=void 0;break}return P}}f.sizeUInt32=4;var u;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})(u||(u={}));class h{static _useMixedArgSerialization(_){for(let P=0,N=_.length;P<N;P++)if(_[P]instanceof t.VSBuffer||_[P]instanceof F.SerializableObjectWithBuffers||typeof _[P]=="undefined")return!0;return!1}static serializeRequestArguments(_,P){if(this._useMixedArgSerialization(_)){const N=[];for(let $=0,y=_.length;$<y;$++){const L=_[$];if(L instanceof t.VSBuffer)N[$]={type:2,value:L};else if(typeof L=="undefined")N[$]={type:4};else if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:x}=l(L.value,P);N[$]={type:3,value:t.VSBuffer.fromString(z),buffers:x}}else N[$]={type:1,value:t.VSBuffer.fromString(w(L,P))}}return{type:1,args:N}}return{type:0,args:w(_,P)}}static serializeRequest(_,P,N,$,y){switch($.type){case 0:return this._requestJSONArgs(_,P,N,$.args,y);case 1:return this._requestMixedArgs(_,P,N,$.args,y)}}static _requestJSONArgs(_,P,N,$,y){const L=t.VSBuffer.fromString(N),z=t.VSBuffer.fromString($);let x=0;x+=f.sizeUInt8(),x+=f.sizeShortString(L),x+=f.sizeLongString(z);let B=f.alloc(y?2:1,_,x);return B.writeUInt8(P),B.writeShortString(L),B.writeLongString(z),B.buffer}static deserializeRequestJSONArgs(_){const P=_.readUInt8(),N=_.readShortString(),$=_.readLongString();return{rpcId:P,method:N,args:JSON.parse($)}}static _requestMixedArgs(_,P,N,$,y){const L=t.VSBuffer.fromString(N);let z=0;z+=f.sizeUInt8(),z+=f.sizeShortString(L),z+=f.sizeMixedArray($);let x=f.alloc(y?4:3,_,z);return x.writeUInt8(P),x.writeShortString(L),x.writeMixedArray($),x.buffer}static deserializeRequestMixedArgs(_){const P=_.readUInt8(),N=_.readShortString(),$=_.readMixedArray(),y=new Array($.length);for(let L=0,z=$.length;L<z;L++){const x=$[L];typeof x=="string"?y[L]=JSON.parse(x):y[L]=x}return{rpcId:P,method:N,args:y}}static serializeAcknowledged(_){return f.alloc(5,_,0).buffer}static serializeCancel(_){return f.alloc(6,_,0).buffer}static serializeReplyOK(_,P,N){if(typeof P=="undefined")return this._serializeReplyOKEmpty(_);if(P instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(_,P);if(P instanceof F.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:y}=l(P.value,N,!0);return this._serializeReplyOKJSONWithBuffers(_,$,y)}else return this._serializeReplyOKJSON(_,n(P,N))}static _serializeReplyOKEmpty(_){return f.alloc(7,_,0).buffer}static _serializeReplyOKVSBuffer(_,P){let N=0;N+=f.sizeVSBuffer(P);let $=f.alloc(8,_,N);return $.writeVSBuffer(P),$.buffer}static deserializeReplyOKVSBuffer(_){return _.readVSBuffer()}static _serializeReplyOKJSON(_,P){const N=t.VSBuffer.fromString(P);let $=0;$+=f.sizeLongString(N);let y=f.alloc(9,_,$);return y.writeLongString(N),y.buffer}static _serializeReplyOKJSONWithBuffers(_,P,N){const $=t.VSBuffer.fromString(P);let y=0;y+=f.sizeUInt32,y+=f.sizeLongString($);for(const z of N)y+=f.sizeVSBuffer(z);let L=f.alloc(10,_,y);L.writeUInt32(N.length),L.writeLongString($);for(const z of N)L.writeBuffer(z);return L.buffer}static deserializeReplyOKJSON(_){const P=_.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(_,P){const N=_.readUInt32(),$=_.readLongString(),y=[];for(let L=0;L<N;++L)y.push(_.readVSBuffer());return new F.SerializableObjectWithBuffers(D($,y,P))}static serializeReplyErr(_,P){return P?this._serializeReplyErrEror(_,P):this._serializeReplyErrEmpty(_)}static _serializeReplyErrEror(_,P){const N=t.VSBuffer.fromString(n(A.transformErrorForSerialization(P),null));let $=0;$+=f.sizeLongString(N);let y=f.alloc(11,_,$);return y.writeLongString(N),y.buffer}static deserializeReplyErrError(_){const P=_.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(_){return f.alloc(12,_,0).buffer}}var b;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var v;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(v||(v={}))}),define(ye[209],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(A){const k=T=>{self.removeEventListener("message",k);const S=T.data;Object.defineProperties(self,{postMessage:{value(R,F){S.postMessage(R,F)}},onmessage:{get(){return S.onmessage},set(R){S.onmessage=R}}}),S.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(A,k,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${s})('${k}'))`,R=new Blob([S],{type:"application/javascript"}),F=URL.createObjectURL(R),C=new MessageChannel,n=F,m={type:"_newWorker",id:n,port:C.port2,url:F,options:T};A(m,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:n};C.port1.postMessage(r),URL.revokeObjectURL(F),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(r){C.port1.onmessage=r}},onmessageerror:{get(){return C.port1.onmessageerror},set(r){C.port1.onmessageerror=r}}}),C.port1.addEventListener("messageerror",r=>{const g=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(g)}),C.port1.addEventListener("message",r=>{const g=new MessageEvent("message",{data:r.data});this.dispatchEvent(g)}),C.port1.start()}}e.NestedWorker=t}),define(ye[210],Ce([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(ye[211],Ce([0,1,10,17,23,2,3,61,46,170,210]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let C=class Vi{constructor(m,r,g,l){this.localUserHome=m,this.remoteAgentService=r,this.environmentService=g,this.contextService=l,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||m})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,r){if(m.remoteAuthority)return s.Schemas.vscodeRemote;const g=(0,T.getVirtualWorkspaceScheme)(r.getWorkspace());if(g)return g;const l=r.getWorkspace().folders[0];if(l)return l.uri.scheme;const D=r.getWorkspace().configuration;return D?D.scheme:s.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?t.win32:t.posix)}async fileURI(m){let r="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const l=m.indexOf("/",2);l===-1?(r=m.substring(2),m="/"):(r=m.substring(2,l),m=m.substring(l)||"/")}return A.URI.from({scheme:s.Schemas.file,authority:r,path:m,query:"",fragment:""})}};C=Be([He(1,F.IRemoteAgentService),He(2,R.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(ye[96],Ce([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(k,T){this.line=k,this.character=T}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,T){return new s(0,0)}with(k){return new s(0,0)}}e.Position=s;class t{constructor(k,T,S,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(k,T),this.end=new s(S,R)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[40],Ce([0,1,16,29,26,42,9,3,17,15,96,11]),function(Z,e,s,t,E,A,k,T,S,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",r=(n.length+m.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var g;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function D(j){return!!j.preview}e.resultIsMatch=D;function w(j){return!!j.resource}e.isFileMatch=w;function d(j){return!!j.message}e.isProgressMessage=d;var p;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class I{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=I;class c{constructor(ue,K,ne){this.ranges=K;const pe=Array.isArray(K)?K:[K];if(ne&&ne.matchLines===1&&M(pe)){ue=(0,k.getNLines)(ue,ne.matchLines);let be="",ae=0,le=0;const Se=Math.floor(ne.charsPerLine/5),Ee=[];for(const Fe of pe){const $e=Math.max(Fe.startColumn-Se,0),Ve=Fe.startColumn+ne.charsPerLine;if($e>le+Se+r){const je=n+($e-le)+m;be+=je+ue.slice($e,Ve),ae+=$e-(le+je.length)}else be+=ue.slice(le,Ve);Ee.push(new i(0,Fe.startColumn-ae,Fe.endColumn-ae)),le=Ve}this.preview={text:be,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const be=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,s.mapArrayOrNot)(K,ae=>new o(ae.startLineNumber-be,ae.startColumn,ae.endLineNumber-be,ae.endColumn))}}}}e.TextSearchMatch=c;function M(j){const ue=j[0].startLineNumber;for(const K of j)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class o{constructor(ue,K,ne,pe){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=ne,this.endColumn=pe}}e.SearchRange=o;class i extends o{constructor(ue,K,ne){super(ue,K,ue,ne)}}e.OneLineRange=i;var f;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function u(j,ue=!0){const K=j&&j.files&&j.files.exclude,ne=ue&&j&&j.search&&j.search.exclude;if(!K&&!ne)return;if(!K||!ne)return K||ne;let pe=Object.create(null);return pe=E.mixin(pe,E.deepClone(K)),pe=E.mixin(pe,E.deepClone(ne),!0),pe}e.getExcludes=u;function h(j,ue){return j.excludePattern&&t.match(j.excludePattern,ue)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&t.match(j.includePattern,ue)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(K=>{const ne=K.folder.fsPath;if(A.isEqualOrParent(ue,ne)){const pe=S.relative(ne,ue);return!K.includePattern||!!t.match(K.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var b;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=v;function a(j){const ue=j.message;if((0,R.isPromiseCanceledError)(j))return new v(ue,b.canceled);try{const K=JSON.parse(ue);return new v(K.message,K.code)}catch{return new v(ue,b.other)}}e.deserializeSearchError=a;function _(j){const ue={message:j.message,code:j.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=_;function P(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=P;function N(j){return j.type==="success"}e.isSerializedSearchSuccess=N;function $(j){return!!j.path}e.isSerializedFileMatch=$;function y(j,ue){const K=j.searchPath?j.searchPath:j.relativePath;return(0,k.fuzzyContains)(K,ue)}e.isFilePatternMatch=y;class L{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function z(j,ue){const K={...j||{},...ue||{}};return Object.keys(K).filter(ne=>{const pe=K[ne];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=z;class x{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let ne=ue.includePattern;K.includePattern&&(ne?ne={...ne,...K.includePattern}:ne=K.includePattern),ne&&(this._parsedIncludeExpression=t.parse(ne))}matchesExcludesSync(ue,K,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ne))}includedInQuerySync(ue,K,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,ne))}includedInQuery(ue,K,ne){const pe=this._parsedExcludeExpression(ue,K,ne),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,ne):!0;return(0,C.isPromise)(pe)?pe.then(ae=>ae?!1:be()):be()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=x;function B(j){for(const ue in j)if(typeof j[ue]!="boolean")return!0;return!1}}),define(ye[31],Ce([0,1,16,14,20,4,21,10,75,24,9,11,2,124,3,12,137,46,30,28,13,7,40,5]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d,p,I,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(_,P,N){return new R.ExtUri($=>h($,N)).isEqual(_,P)}function i(_,P,N){return o(_.uri,P.uri,N)?0:(0,F.compare)(_.uri.toString(),P.uri.toString())}function f(_,P,N){return _.index!==P.index?_.index<P.index?-1:1:o(_.uri,P.uri,N)?(0,F.compare)(_.name,P.name):(0,F.compare)(_.uri.toString(),P.uri.toString())}function u(_,P,N,$){const y=_.slice(0).sort((z,x)=>N(z,x,$)),L=P.slice(0).sort((z,x)=>N(z,x,$));return(0,s.delta)(y,L,(z,x)=>N(z,x,$))}function h(_,P){const N=P.getCapabilities(_.scheme);return!(N&&N&1024)}class b extends D.Workspace{constructor(P,N,$,y,L,z,x){super(P,$.map(B=>new D.WorkspaceFolder(B)),y,L,x);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(x),$.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(P,N,$,y){if(!P)return{workspace:null,added:[],removed:[]};const{id:L,name:z,folders:x,configuration:B,transient:j,isUntitled:ue}=P,K=[],ne=N;N?x.forEach((le,Se)=>{const Ee=n.URI.revive(le.uri),Fe=b._findFolder($||N,Ee,y);Fe?(Fe.name=le.name,Fe.index=le.index,K.push(Fe)):K.push({uri:Ee,name:le.name,index:Se})}):K.push(...x.map(({uri:le,name:Se,index:Ee})=>({uri:n.URI.revive(le),name:Se,index:Ee}))),K.sort((le,Se)=>le.index<Se.index?-1:1);const pe=new b(L,z,K,!!j,B?n.URI.revive(B):null,!!ue,le=>h(le,y)),{added:be,removed:ae}=u(ne?ne.workspaceFolders:[],pe.workspaceFolders,i,y);return{workspace:pe,added:be,removed:ae}}static _findFolder(P,N,$){for(let y=0;y<P.folders.length;y++){const L=P.workspaceFolders[y];if(o(L.uri,N,$))return L}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,N){return N&&this._structure.get(P)&&(P=(0,R.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let v=class{constructor(P,N,$,y){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=y,this._extHostFileSystemInfo=$,this._requestIdProvider=new S.Counter,this._barrier=new t.Barrier,this._proxy=P.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(M.MainContext.MainThreadMessageService);const L=N.workspace;this._confirmedWorkspace=L?new b(L.id,L.name,[],!!L.transient,L.configuration?n.URI.revive(L.configuration):null,!!L.isUntitled,z=>h(z,$)):void 0}$initializeWorkspace(P,N){this._trusted=N,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:T.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,N,$,...y){const L=[];if(Array.isArray(y)&&y.forEach(ue=>{n.URI.isUri(ue.uri)&&!L.some(K=>o(K.uri,ue.uri,this._extHostFileSystemInfo))&&L.push({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[N,$].some(ue=>typeof ue!="number"||ue<0)||$===0&&L.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+$>z.length)return!1;const x=z.slice(0);x.splice(N,$,...L.map(ue=>({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<x.length;ue++){const K=x[ue];if(x.some((ne,pe)=>pe!==ue&&o(K.uri,ne.uri,this._extHostFileSystemInfo)))return!1}x.forEach((ue,K)=>ue.index=K);const{added:B,removed:j}=u(z,x,f,this._extHostFileSystemInfo);if(B.length===0&&j.length===0)return!1;if(this._proxy){const ue=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(ue,N,$,L).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(l.Severity.Error,(0,m.localize)(0,null,ue,K.toString()),{extension:P},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(P,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,N)}async getWorkspaceFolder2(P,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,N)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,N){let $,y="";if(typeof P=="string"?($=n.URI.file(P),y=P):typeof P!="undefined"&&($=P,y=P.fsPath),!$)return y;const L=this.getWorkspaceFolder($,!0);if(!L)return y;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)(L.uri,$);return N&&L.name&&(z=`${L.name}/${z}`),z}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:N,added:$,removed:y}=b.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:y}))}findFiles(P,N,$,y,L=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${y.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),L&&L.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:B}=a(P);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(x),(0,C.withUndefinedAsNull)(B),(0,C.withUndefinedAsNull)(z),(0,C.withUndefinedAsNull)($),L).then(j=>Array.isArray(j)?j.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(P,N,$,y,L=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${y.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),x=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:B,folder:j}=a(N.include),ue=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,K={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:x,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:B,excludePattern:ue},ne=!1;if(this._activeSearchCallbacks[z]=pe=>{if(ne)return;const be=n.URI.revive(pe.resource);pe.results.forEach(ae=>{(0,c.resultIsMatch)(ae)?$({uri:be,preview:{text:ae.preview.text,matches:(0,s.mapArrayOrNot)(ae.preview.matches,le=>new I.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))},ranges:(0,s.mapArrayOrNot)(ae.ranges,le=>new I.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))}):$({uri:be,text:ae.text,lineNumber:ae.lineNumber})})},L.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(P,(0,C.withUndefinedAsNull)(j),K,z,L);return delete this._activeSearchCallbacks[z],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[z],pe}}$handleTextSearchResult(P,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](P)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Be([He(0,p.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,w.IExtHostFileSystemInfo),He(3,g.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function a(_){let P,N;return _&&(typeof _=="string"?P=_:(P=_.pattern,N=_.baseFolder||n.URI.file(_.base))),{includePattern:P,folder:N}}}),define(ye[32],Ce([0,1,26,4,31,5,7,141,83,11,14,3,13,12,2]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(M,o){if(o){const i=o.split(".");let f=M;for(let u=0;f&&u<i.length;u++)f=f[i[u]];return f}}function l(M){return M instanceof r.URI}function D(M){return M&&M.uri instanceof r.URI&&M.languageId&&typeof M.languageId=="string"}function w(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function d(M){return M&&M.uri instanceof r.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function p(M){if(l(M))return{resource:M};if(D(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(w(M))return{overrideIdentifier:M.languageId};if(d(M))return{resource:M.uri};if(M===null)return{resource:null}}let I=class{constructor(o,i,f){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=f,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new c(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(o,i))}};I=Be([He(0,n.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,m.ILogService)],I),e.ExtHostConfiguration=I;class c{constructor(o,i,f,u){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=u,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,f))}getConfiguration(o,i,f){const u=p(i)||{},h=this._toReadonlyValue(o?g(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,u,f?.identifier);function b(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(a){return typeof g(h,a)!="undefined"},get:(a,_)=>{this._validateConfigurationAccess(o?`${o}.${a}`:a,u,f?.identifier);let P=g(h,a);if(typeof P=="undefined")P=_;else{let N;const $=(y,L)=>{let z;const x=()=>{N=N||(0,s.deepClone)(h),z=z||g(N,L)};return(0,R.isObject)(y)?new Proxy(y,{get:(B,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return x(),()=>z;if(N)return z=z||g(N,L),z[j];const ue=B[j];return typeof j=="string"?$(ue,`${L}.${j}`):ue},set:(B,j,ue)=>(x(),z&&(z[j]=ue),!0),deleteProperty:(B,j)=>(x(),z&&delete z[j],!0),defineProperty:(B,j,ue)=>(x(),z&&Object.defineProperty(z,j,ue),!0)}):y};P=$(P,a)}return P},update:(a,_,P,N)=>{a=o?`${o}.${a}`:a;const $=b(P);return _!==void 0?this._proxy.$updateConfigurationOption($,a,_,u,N):this._proxy.$removeConfigurationOption($,a,u,N)},inspect:a=>{a=o?`${o}.${a}`:a;const _=(0,s.deepClone)(this._configuration.inspect(a,u,this._extHostWorkspace.workspace));if(_)return{key:a,defaultValue:_.default?.value,globalValue:_.user?.value,workspaceValue:_.workspace?.value,workspaceFolderValue:_.workspaceFolder?.value,defaultLanguageValue:_.default?.override,globalLanguageValue:_.user?.override,workspaceLanguageValue:_.workspace?.override,workspaceFolderLanguageValue:_.workspaceFolder?.override,languageIds:_.overrideIdentifiers}}};return typeof h=="object"&&(0,s.mixin)(v,h,!1),Object.freeze(v)}_toReadonlyValue(o){const i=f=>(0,R.isObject)(f)?new Proxy(f,{get:(u,h)=>i(u[h]),set:(u,h,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(u,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(u,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return i(o)}_validateConfigurationAccess(o,i,f){const u=S.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),h=f?`[${f.value}] `:"";if(u===4){typeof i?.resource=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const f=new T.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,h)=>f.affectsConfiguration(u,p(h))})}_toMap(o){return o.reduce((i,f)=>(i.set(f[0],f[1]),i),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[97],Ce([0,1,2,14,4,5,7,31,48,32,20,39,13,28,3,10,23,12,69,160,15]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d,p){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(L){function z(B){if(B!=null)return B}L.from=z;function x(B){if(B!=null)return B}L.to=x})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(L){function z(B){if(B!=null)return B}L.from=z;function x(B){if(B!=null)return B}L.to=x})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(L){function z(B){if(B!=null)return B}L.from=z;function x(B){if(B!=null)return B}L.to=x})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(L){function z(j){if(j){const ue=j;return ue&&!!ue.process}else return!1}L.is=z;function x(j){if(j==null)return;const ue={process:j.process,args:j.args};return j.options&&(ue.options=o.from(j.options)),ue}L.from=x;function B(j){if(j!=null)return new k.ProcessExecution(j.process,j.args,j.options)}L.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(L){function z(B){if(B!=null)return B}L.from=z;function x(B){if(B!=null)return B}L.to=x})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(L){function z(j){if(j){const ue=j;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}L.is=z;function x(j){if(j==null)return;const ue={};return j.commandLine!==void 0?ue.commandLine=j.commandLine:(ue.command=j.command,ue.args=j.args),j.options&&(ue.options=f.from(j.options)),ue}L.from=x;function B(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new k.ShellExecution(j.commandLine,j.options):new k.ShellExecution(j.command,j.args?j.args:[],j.options)}L.to=B})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(L){function z(j){if(j){let ue=j;return ue&&ue.customExecution==="customExecution"}else return!1}L.is=z;function x(j){return{customExecution:"customExecution"}}L.from=x;function B(j,ue){return ue.get(j)}L.to=B})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(L){function z(x,B){let j;return x.scope!==void 0&&typeof x.scope!="number"?j=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===k.TaskScope.Workspace&&B&&B.workspaceFile?j=B.workspaceFile:j=d.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:j}}L.from=z})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(L){function z(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}L.from=z})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var a;(function(L){function z(j,ue){if(j==null)return[];const K=[];for(let ne of j){const pe=x(ne,ue);pe&&K.push(pe)}return K}L.fromMany=z;function x(j,ue){if(j==null)return;let K;j.execution instanceof k.ProcessExecution?K=i.from(j.execution):j.execution instanceof k.ShellExecution?K=u.from(j.execution):j.execution&&j.execution instanceof k.CustomExecution&&(K=h.from(j.execution));const ne=c.from(j.definition);let pe;return j.scope?typeof j.scope=="number"?pe=j.scope:pe=j.scope.uri:pe=k.TaskScope.Workspace,!ne||!pe?void 0:{_id:j._id,definition:ne,name:j.name,source:{extensionId:ue.identifier.value,label:j.source,scope:pe},execution:K,isBackground:j.isBackground,group:v.from(j.group),presentationOptions:M.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}L.from=x;async function B(j,ue,K){if(j==null)return;let ne;i.is(j.execution)?ne=i.to(j.execution):u.is(j.execution)?ne=u.to(j.execution):h.is(j.execution)&&(ne=h.to(j._id,K));const pe=c.to(j.definition);let be;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?be=j.source.scope:be=await ue.resolveWorkspaceFolder(s.URI.revive(j.source.scope)):be=k.TaskScope.Workspace),!pe||!be)return;const ae=new k.Task(pe,be,j.name,j.source.label,ne,j.problemMatchers);return j.isBackground!==void 0&&(ae.isBackground=j.isBackground),j.group!==void 0&&(ae.group=k.TaskGroup.from(j.group._id),ae.group&&j.group.isDefault&&(ae.group=new k.TaskGroup(ae.group.id,ae.group.label),j.group.isDefault&&(ae.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ae.presentationOptions=M.to(j.presentationOptions)),j._id&&(ae._id=j._id),j.detail&&(ae.detail=j.detail),ae}L.to=B})(a=e.TaskDTO||(e.TaskDTO={}));var _;(function(L){function z(B){return B}L.from=z;function x(B){if(!!B)return Object.assign(Object.create(null),B)}L.to=x})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(z,x,B){this._id=x,this._task=B,I.set(this,void 0),Ze(this,I,z,"f")}get task(){return this._task}terminate(){Ie(this,I,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}I=new WeakMap;var N;(function(L){function z(x){return{id:x._id,task:void 0}}L.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(z,x,B,j,ue,K,ne,pe){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=z.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=j,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ne,this._deprecationService=pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,x,B){if(!B)return new k.Disposable(()=>{});const j=this.nextHandle();return this._handlers.set(j,{type:x,provider:B,extension:z}),this._proxy.$registerTaskProvider(j,x),new k.Disposable(()=>{this._handlers.delete(j),this._proxy.$unregisterTaskProvider(j)})}registerTaskSystem(z,x){this._proxy.$registerTaskSystem(z,x)}fetchTasks(z){return this._proxy.$fetchTasks(_.from(z)).then(async x=>{const B=[];for(let j of x){const ue=await a.to(j,this._workspaceProvider,this._providedCustomExecutions2);ue&&B.push(ue)}return B})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(x=>z.push(x)),z}terminateTask(z){if(!(z instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,x,B){const j=this._providedCustomExecutions2.get(z.id);j&&(this._activeCustomExecutions2.set(z.id,j),this._terminalService.attachPtyToTerminal(x,await j.callback(B))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const x=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const x=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:x,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const x=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:z.exitCode})}$provideTasks(z,x){const B=this._handlers.get(z);if(!B)return Promise.reject(new Error("no handler found"));const j=[],ue=(0,t.asPromise)(()=>B.provider.provideTasks(F.CancellationToken.None)).then(K=>this.provideTasksInternal(x,j,B,K));return new Promise(K=>{ue.then(ne=>{Promise.all(j).then(()=>{K(ne)})})})}async $resolveTask(z,x){const B=this._handlers.get(z);if(!B)return Promise.reject(new Error("no handler found"));if(x.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${B.type}].`);const j=await a.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const ue=await B.provider.resolveTask(j,F.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,B);const K=a.from(ue,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,x,B){const j=await this._proxy.$createTaskId(z);!B&&!this._providedCustomExecutions2.has(j)&&(this._notProvidedCustomExecutions.add(j),this._activeCustomExecutions2.set(j,x.execution)),this._providedCustomExecutions2.set(j,x.execution)}async getTaskExecution(z,x){if(typeof z=="string"){const ue=this._taskExecutionPromises.get(z);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let B=this._taskExecutionPromises.get(z.id);if(B)return B;const j=new Promise((ue,K)=>{function ne(pe,be,ae){ae?ue(new P(pe,be.id,ae)):K("Unexpected: Task does not exist.")}x?ne(this,z,x):a.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(pe=>ne(this,z,pe))});return this._taskExecutionPromises.set(z.id,j),j.then(ue=>(this._taskExecutions.set(z.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(z,x){z._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let B=this._notProvidedCustomExecutions.values(),j=B.next();for(;!j.done;)!this._activeCustomExecutions2.has(j.value)&&this._lastStartedTask!==j.value&&(this._providedCustomExecutions2.delete(j.value),this._notProvidedCustomExecutions.delete(j.value)),j=B.next()}};$=Be([He(0,n.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,R.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,D.ILogService),He(7,w.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let y=class extends ${constructor(z,x,B,j,ue,K,ne,pe){super(z,x,B,j,ue,K,ne,pe);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:l.PlatformToString(0)})}async executeTask(z,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const B=a.from(x,z);if(B===void 0)throw new Error("Task is not valid");if(h.is(B.execution))await this.addCustomExecution(B,x,!1);else throw new p.NotSupportedError;const j=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),x);return this._proxy.$executeTask(B).catch(ue=>{throw new Error(ue)}),j}provideTasksInternal(z,x,B,j){const ue=[];if(j)for(let K of j){this.checkDeprecation(K,B),(!K.definition||!z[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ne=a.from(K,B.extension);ne&&h.is(ne.execution)?(ue.push(ne),x.push(this.addCustomExecution(ne,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:B.extension}}async resolveTaskInternal(z){if(h.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,x,B){}};y=Be([He(0,n.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,R.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,D.ILogService),He(7,w.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")}),define(ye[212],Ce([0,1,16,74,29,77,21,10,17,24,9,11,2,231,127,81,46,90,211,40]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(b,v,a,_){this.configurationService=b,this.workspaceContextService=v,this.editorGroupsService=a,this.pathService=_}text(b,v,a={}){b=this.getContentPattern(b,a);const _=this.configurationService.getValue(),P=v&&v.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(v?.map(l.toWorkspaceFolder),a),type:2,contentPattern:b,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:_.search.usePCRE2||P||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles}}getContentPattern(b,v){const a=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const _={...b,wordSeparators:a.editor.wordSeparators};return this.isCaseSensitive(b,v)&&(_.isCaseSensitive=!0),this.isMultiline(b)&&(_.isMultiline=!0),_}file(b,v={}){return{...this.commonQuery(b,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}handleIncludeExclude(b,v){return b?(b=Array.isArray(b)?b.map(i):i(b),v?this.parseSearchPaths(b):{pattern:c(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],v={}){const a=this.handleIncludeExclude(v.includePattern,v.expandPatterns),_=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),P=b.length>1,N=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,v,_)):b.map(L=>this.getFolderQueryForRoot(L,v,_,P))).filter(L=>!!L),$={_reason:v._reason,folderQueries:N,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:_.pattern,includePattern:a.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const z=s.coalesce(s.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(j=>j.resource)))).filter(B=>(0,d.pathIncludedInQuery)($,B.fsPath)),x=this.commonQueryFromFileList(z);return{...$,...x}}const y=v.extraFileResources&&v.extraFileResources.filter(L=>(0,d.pathIncludedInQuery)($,L.fsPath));return $.extraFileResources=y&&y.length?y:void 0,$}commonQueryFromFileList(b){const v=[],a=new k.ResourceMap,_={};let P=!1;return b.forEach(N=>{if(N.scheme===T.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(N)){const y=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:S.dirname(N.fsPath)});let L=a.get(y);L||(P=!0,L={folder:y,includePattern:{}},v.push(L),a.set(y,L));const z=S.relative(y.fsPath,N.fsPath);(0,C.assertIsDefined)(L.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(P=!0,_[N.fsPath]=!0)}),{folderQueries:v,includePattern:_,usingSearchPaths:!0,excludePattern:P?void 0:{"**/*":!0}}}isCaseSensitive(b,v){if(v.isSmartCase){if(b.isRegExp){if(F.containsUppercaseCharacter(b.pattern,!0))return!0}else if(F.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const v=x=>S.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),_=(Array.isArray(b)?b:M(b)).map(x=>{const B=this.pathService.resolvedUserHome;return B?(0,A.untildify)(x,B.scheme===T.Schemas.file?B.fsPath:B.path):x}),P=t.groupBy(_,x=>v(x)?"searchPaths":"exprSegments"),N=(P.exprSegments||[]).map(x=>F.rtrim(x,"/")).map(x=>F.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),$={},y=this.expandSearchPathPatterns(P.searchPaths||[]);y&&y.length&&($.searchPaths=y);const L=s.flatten(N),z=c(...L);return z&&($.pattern=z),$}getExcludesForFolder(b,v){return v.disregardExcludeSettings?void 0:(0,d.getExcludes)(b,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const v=s.flatten(b.map(_=>{let{pathPortion:P,globPortion:N}=I(_);N&&(N=f(N));const $=this.expandOneSearchPath(P);return s.flatten($.map(y=>this.resolveOneSearchPathPattern(y,N)))})),a=new Map;return v.forEach(_=>{const P=_.searchPath.toString(),N=a.get(P);N?_.pattern&&(N.pattern=N.pattern||{},N.pattern[_.pattern]=!0):a.set(P,{searchPath:_.searchPath,pattern:_.pattern?c(_.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(b){if(S.isAbsolute(b)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==T.Schemas.file?[{searchPath:v[0].uri.with({path:b})}]:[{searchPath:n.URI.file(S.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const _=S.posix.resolve(v.path,b);return[{searchPath:v.with({path:_})}]}const a=f(b);return[{searchPath:v,pattern:a}]}else{if(b==="./"||b===".\\")return[];{const v=b.replace(/^\.[\/\\]/,""),_=this.workspaceContextService.getWorkspace().folders.map(P=>{const N=v.match(new RegExp(`^${F.escapeRegExpCharacters(P.name)}(?:/(.*)|$)`));return N?{match:N,folder:P}:null}).filter(C.isDefined);if(_.length)return _.map(P=>{const N=P.match[1];return{searchPath:P.folder.uri,pattern:N&&f(N)}});{const P=b.match(/\.[\/\\](.+)[\/\\]?/),N=P?P[1]:b,$=r.localize(0,null,N);throw new Error($)}}}}resolveOneSearchPathPattern(b,v){const a=b.pattern&&v?`${b.pattern}/${v}`:b.pattern||v,_=[{searchPath:b.searchPath,pattern:a}];return a&&!a.endsWith("**")&&_.push({searchPath:b.searchPath,pattern:a+"/**"}),_}getFolderQueryForSearchPath(b,v,a){const _=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(b.searchPath),v,a,!1);return _?{..._,includePattern:b.pattern}:null}getFolderQueryForRoot(b,v,a,_){let P;const N=n.URI.isUri(b)?b:b.uri;if(a.searchPaths){const x=a.searchPaths.filter(B=>(0,R.isEqual)(B.searchPath,N))[0];if(x&&!x.pattern)return null;x&&(P=x.pattern)}const $=this.configurationService.getValue({resource:N}),L={...this.getExcludesForFolder($,v)||{},...P||{}},z=n.URI.isUri(b)?(0,R.basename)(b):b.name;return{folder:N,folderName:_?z:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!$.search.followSymlinks}}};p=Be([He(0,g.IConfigurationService),He(1,l.IWorkspaceContextService),He(2,D.IEditorGroupsService),He(3,w.IPathService)],p),e.QueryBuilder=p;function I(h){const b=h.match(/[\*\{\}\(\)\[\]\?]/);if(b){const v=b.index,a=h.substr(0,v).match(/[/|\\][^/\\]*$/);if(a){let _=h.substr(0,a.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:h.substr((a.index||0)+1)}}}return{pathPortion:h}}function c(...h){return h.length?h.reduce((b,v)=>(b[v]=!0,b),Object.create(null)):void 0}function M(h){return E.splitGlobAware(h,",").map(b=>b.trim()).filter(b=>!!b.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function f(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(h,b){h=s.distinct(h,_=>_.toString());const v=[],a=b.getWorkspace();return h&&h.forEach(_=>{let P;if(b.getWorkbenchState()===2)P=(0,R.relativePath)(a.folders[0].uri,_),P&&P!=="."&&(P="./"+P);else{const N=b.getWorkspaceFolder(_);if(N){const $=N.name;if(a.folders.filter(L=>L.name===$).length===1){const L=(0,R.relativePath)(N.uri,_);L===""?P=`./${N.name}`:P=`./${N.name}/${L}`}else P=_.fsPath}}P&&v.push(P)}),v}e.resolveResourcesForSearchIncludes=u}),define(ye[213],Ce([0,1,24,2,20,15,3,212,40,46]),function(Z,e,s,t,E,A,k,T,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function C(g,l){const D=l.activationEvents;if(!D)return Promise.resolve(void 0);const w=[],d=[];for(const i of D)if(/^workspaceContains:/.test(i)){const f=i.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||g.forceUsingSearch?d.push(f):w.push(f)}if(w.length===0&&d.length===0)return Promise.resolve(void 0);let p;const I=new Promise((i,f)=>{p=i}),c=i=>p({activationEvent:i}),M=Promise.all(w.map(i=>n(g,i,c))).then(()=>{}),o=m(g,l.identifier,d,c);return Promise.all([M,o]).then(()=>{p(void 0)}),I}e.checkActivateWorkspaceContainsExtension=C;async function n(g,l,D){for(const w of g.folders)if(await g.exists(s.joinPath(t.URI.revive(w),l))){D(`workspaceContains:${l}`);return}}async function m(g,l,D,w){if(D.length===0)return Promise.resolve(void 0);const d=new E.CancellationTokenSource,p=g.checkExists(g.folders,D,d.token),I=setTimeout(async()=>{d.cancel(),g.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${D.join(",")}`)},F);let c=!1;try{c=await p}catch(M){A.isPromiseCanceledError(M)||A.onUnexpectedError(M)}d.dispose(),clearTimeout(I),c&&w(`workspaceContains:${D.join(",")}`)}function r(g,l,D,w){const d=g.get(k.IInstantiationService),p=g.get(S.ISearchService),c=d.createInstance(T.QueryBuilder).file(l.map(M=>(0,R.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:D,exists:!0});return p.fileSearch(c,w).then(M=>!!M.limitHit,M=>A.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=r});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[33],Ce([0,1,119,17,73,24,14,6,21,2,12,5,32,173,71,31,27,171,15,25,22,146,7,84,3,28,72,13,60,64,39,4,213,68,148,10]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d,p,I,c,M,o,i,f,u,h,b,v,a,_,P,N,$){"use strict";var y,L,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let x=class ji extends T.Disposable{constructor(K,ne,pe,be,ae,le,Se,Ee,Fe,$e){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ne,this._extHostContext=pe,this._initData=Se,this._extHostWorkspace=be,this._extHostConfiguration=ae,this._logService=le,this._extHostTunnelService=Fe,this._extHostTerminalService=$e,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=Ee,this._instaService=K.createChild(new h.ServiceCollection([r.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(je=>Ve.add(d.ExtensionIdentifier.toKey(je))),this._activator=this._register(new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,H,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,w.transformErrorForSerialization(H),G)},actualActivateExtension:async(je,H)=>{if(Ve.has(d.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,H),new m.HostExtension;const G=this._registry.getExtensionDescription(je);return this._activateExtension(G,H)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){w.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch{}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,ne){return this._activator.activateByEvent(K,ne)}_activateById(K,ne){return this._activator.activateById(K,ne)}activateByIdWithErrors(K,ne){return this._activateById(K,ne).then(()=>{const pe=this._activator.getActivatedExtension(K);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==$.Schemas.file)return K;const ne=await this._hostUtils.realpath(K.fsPath);return R.URI.file(ne)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=S.TernarySearchTree.forUris(ne=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ne));for(const ne of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ne)){const pe=await this._realPathExtensionUri(ne.extensionLocation);K.set(pe,ne)}return K})()),this._extensionPathIndex}_deactivate(K){let ne=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return ne;const pe=this._activator.getActivatedExtension(K);if(!pe)return ne;try{typeof pe.module.deactivate=="function"&&(ne=Promise.resolve(pe.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(`An error occurred when deactivating the extension '${K.value}':`),this._logService.error(be)}try{(0,T.dispose)(pe.subscriptions)}catch(be){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this._logService.error(be)}return ne}async _activateExtension(K,ne){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,ne).then(pe=>{const be=pe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,ne),this._logExtensionActivationTimes(K,ne,"success",be),pe},pe=>{throw this._logExtensionActivationTimes(K,ne,"failure"),pe})}_logExtensionActivationTimes(K,ne,pe,be){const ae=B(K,ne);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ae,...be||{},outcome:pe})}_doActivateExtension(K,ne){const pe=B(K,ne);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",pe);const be=this._getEntryPoint(K);if(!be)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${K.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this._logService.flush();const ae=new m.ExtensionActivationTimesBuilder(ne.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,A.joinPath)(K.extensionLocation,be),ae),this._loadExtensionContext(K)]).then(le=>(E.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,le[0],le[1],ae))).then(le=>(E.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}_loadExtensionContext(K){const ne=new I.ExtensionGlobalMemento(K,this._storage),pe=new I.ExtensionMemento(K.identifier.value,!1,this._storage),be=new N.ExtensionSecrets(K,this._secretState),ae=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,le=this._initData.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([ne.whenReady,pe.whenReady,this._storagePath.whenReady]).then(()=>{const Se=this;let Ee;return Object.freeze({globalState:ne,workspaceState:pe,secrets:be,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return t.join(K.extensionLocation.fsPath,Fe)},get storagePath(){return Se._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Se._storagePath.globalValue(K).fsPath},get logPath(){return t.join(Se._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return R.URI.joinPath(Se._initData.logsLocation,K.identifier.value)},get storageUri(){return Se._storagePath.workspaceValue(K)},get globalStorageUri(){return Se._storagePath.globalValue(K)},get extensionMode(){return ae},get extension(){return Ee===void 0&&(Ee=new j(Se,K.identifier,K,le)),Ee},get extensionRuntime(){return(0,l.checkProposedApiEnabled)(K,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,ne,pe,be,ae){return pe=pe||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,ne,pe,be,ae).then(le=>new m.ActivatedExtension(!1,null,ae.build(),pe,le,be.subscriptions))}static _callActivateOptional(K,ne,pe,be,ae){if(typeof pe.activate=="function")try{ae.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const le=typeof global=="object"?global:self,Se=pe.activate.apply(le,[be]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(Se).then(Ee=>(ae.activateResolveStop(),Ee))}catch(le){return Promise.reject(le)}else return Promise.resolve(pe)}_activateOneStartupFinished(K,ne){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:ne}).then(void 0,pe=>{this._logService.error(pe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const ne of K.activationEvents)ne==="onStartupFinished"&&this._activateOneStartupFinished(K,ne)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const ne=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],pe=this._handleWorkspaceContainsEagerExtensions(ne),be=Promise.all([K,pe]).then(()=>{});return Promise.race([be,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ne=>this._handleWorkspaceContainsEagerExtension(K,ne))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,ne){if(this.isActivated(ne.identifier))return;const pe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:K.map(le=>le.uri),forceUsingSearch:pe,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,Se,Ee)=>this._mainThreadWorkspaceProxy.$checkExists(le,Se,Ee)},ae=await(0,_.checkActivateWorkspaceContainsExtension)(be,ne);if(!!ae)return this._activateById(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:ae.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:ne}=this._initData.environment;if(!K||!ne)throw new Error(s.localize(0,null));const pe=await this._loadCommonJSModule(null,ne,new m.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(s.localize(1,null,ne.toString()));return new Promise((be,ae)=>{const le=(Fe,$e)=>{Fe?ae(Fe):be(typeof $e=="number"&&$e>0?1:0)},Se=(0,A.originalFSPath)(ne),Ee=pe.run(Se,le);Ee&&Ee.then&&Ee.then(()=>{be(0)}).catch(Fe=>{ae(Fe.toString())})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,ne){return this._resolvers[K]=ne,(0,T.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const ne=K.indexOf("+");if(ne===-1)throw new Error("Not an authority that can be resolved!");const pe=K.substr(0,ne);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this._resolvers[pe]}}async $resolveAuthority(K,ne){const{authorityPrefix:pe,resolver:be}=await this._activateAndGetResolver(K);if(!be)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${pe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(be)),E.mark(`code/extHost/willResolveAuthority/${pe}`);const ae=await be.resolve(K,{resolveAttempt:ne});E.mark(`code/extHost/didResolveAuthorityOK/${pe}`);const le={authority:K,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},Se={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:le,options:Se,tunnelInformation:{environmentTunnels:ae.environmentTunnels}}}}catch(ae){if(E.mark(`code/extHost/didResolveAuthorityError/${pe}`),ae instanceof c.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(K,ne){const{authorityPrefix:pe,resolver:be}=await this._activateAndGetResolver(K);if(!be)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${pe}`);const ae=R.URI.revive(ne);if(typeof be.getCanonicalURI=="undefined")return ae;const le=await(0,k.asPromise)(()=>be.getCanonicalURI(ae));return le||ae}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,ne){return ne===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(pe=>this._activateByEvent(K,!1))}async $activate(K,ne){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,ne),!0):!1}async $deltaExtensions(K,ne){K.forEach(be=>be.extensionLocation=R.URI.revive(be.extensionLocation));const pe=await this.getExtensionPathIndex();return await Promise.all(ne.map(async be=>{const ae=this._registry.getExtensionDescription(be);ae&&pe.delete(await this._realPathExtensionUri(ae.extensionLocation))})),await Promise.all(K.map(async be=>{const ae=await this._realPathExtensionUri(be.extensionLocation);pe.set(ae,be)})),this._registry.deltaExtensions(K,ne),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let ne=p.VSBuffer.alloc(K),pe=Math.random()%256;for(let be=0;be<K;be++)ne.writeUInt8(pe,be);return ne}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};x=Be([He(0,o.IInstantiationService),He(1,e.IHostUtils),He(2,u.IExtHostRpcService),He(3,g.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,F.ILogService),He(6,i.IExtHostInitDataService),He(7,f.IExtensionStoragePaths),He(8,b.IExtHostTunnelService),He(9,v.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function B(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class j{constructor(K,ne,pe,be){y.set(this,void 0),L.set(this,void 0),z.set(this,void 0),Ze(this,y,K,"f"),Ze(this,L,ne,"f"),Ze(this,z,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=be}get isActive(){return Ie(this,y,"f").isActivated(Ie(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,y,"f").getExtensionExports(Ie(this,z,"f"))}activate(){return Ie(this,y,"f").activateByIdWithErrors(Ie(this,z,"f"),{startup:!1,extensionId:Ie(this,L,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=j,y=new WeakMap,L=new WeakMap,z=new WeakMap}),define(ye[98],Ce([0,1,17,2,4,14,5,7,155,31,33,48,162,32,156,13,3,11,89,70]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,l.createDecorator)("IExtHostDebugService");let p=class{constructor(h,b,v,a,_,P){this._workspaceService=b,this._extensionService=v,this._editorsService=a,this._configurationService=_,this._editorTabs=P,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=h.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange($=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,b){const v=h;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let a=`debug:${encodeURIComponent(v.path||"")}`,_="?";return b&&(a+=`${_}session=${encodeURIComponent(b.id)}`,_="&"),a+=`${_}ref=${v.sourceReference}`,t.URI.parse(a)}else{if(v.path)return t.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const b=[];for(const v of h.getAllExtensionDescriptions())if(v.contributes){const a=v.contributes.debuggers;if(a&&a.length>0)for(const _ of a)(0,r.isDebuggerMainContribution)(_)&&b.push(_.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(b=>h.push(b)),h}addBreakpoints(h){this.startBreakpoints();const b=h.filter(_=>{const P=_.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,_),!0)});this.fireBreakpointChanges(b,[],[]);const v=[],a=new Map;for(const _ of b)if(_ instanceof T.SourceBreakpoint){let P=a.get(_.location.uri.toString());P||(P={type:"sourceMulti",uri:_.location.uri,lines:[]},a.set(_.location.uri.toString(),P),v.push(P)),P.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof T.FunctionBreakpoint&&v.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(h){this.startBreakpoints();const b=h.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],b,[]);const v=b.filter(P=>P instanceof T.SourceBreakpoint).map(P=>P.id),a=b.filter(P=>P instanceof T.FunctionBreakpoint).map(P=>P.id),_=b.filter(P=>P instanceof T.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(v,a,_)}startDebugging(h,b,v){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,b,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,debugUI:v.debugUI,suppressSaveBeforeStart:v.suppressSaveBeforeStart})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,b,v){if(!b)return new T.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:a,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,v,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,a),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(h,b,v){if(!v)return new T.Disposable(()=>{});if(!this.definesDebugType(h,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:a,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,a),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(h,b){if(!b)return new T.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:v,factory:b}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==b)})}async $runInTerminal(h,b){return Promise.resolve(void 0)}async $substituteVariables(h,b){if(!this._variableResolver){const[_,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,P)}let v;const a=await this.getFolder(h);return a&&(v={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(v,b)}createDebugAdapter(h,b){if(h.type==="implementation")return new i(h.implementation)}createSignService(){}async $startDASession(h,b){const v=this,a=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const P=this.convertToDto(_),N=this.createDebugAdapter(P,a);if(!N)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const $=N;return this._debugAdapters.set(h,$),this.getDebugAdapterTrackers(a).then(y=>(y&&this._debugAdaptersTrackers.set(h,y),$.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const z=L,x={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(z.arguments.value);x.body={signature:B},$.sendResponse(x)}else throw new Error("no signer")}catch(B){x.success=!1,x.message=B.message,$.sendResponse(x)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(L),L=(0,r.convertToVSCPaths)(L,!0),v._debugServiceProxy.$acceptDAMessage(h,L)}),$.onError(L=>{y&&y.onError&&y.onError(L),this._debugServiceProxy.$acceptDAError(h,L.name,L.message,L.stack)}),$.onExit(L=>{y&&y.onExit&&y.onExit((0,D.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,D.withNullAsUndefined)(L),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),$.startSession()))})}$sendDAMessage(h,b){b=(0,r.convertToDAPaths)(b,!1);const v=this._debugAdaptersTrackers.get(h);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(b);const a=this._debugAdapters.get(h);a&&a.sendMessage(b)}$stopDASession(h){const b=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),b&&b.onWillStopSession&&b.onWillStopSession();const v=this._debugAdapters.get(h);return this._debugAdapters.delete(h),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const b=[],v=[],a=[];if(h.added)for(const _ of h.added){const P=_.id;if(P&&!this._breakpoints.has(P)){let N;if(_.type==="function")N=new T.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")N=new T.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const $=t.URI.revive(_.uri);N=new T.SourceBreakpoint(new T.Location($,new T.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}N._id=P,this._breakpoints.set(P,N),b.push(N)}}if(h.removed)for(const _ of h.removed){const P=this._breakpoints.get(_);P&&(this._breakpoints.delete(_),v.push(P))}if(h.changed){for(const _ of h.changed)if(_.id){const P=this._breakpoints.get(_.id);if(P){if(P instanceof T.FunctionBreakpoint&&_.type==="function"){const N=P;N.enabled=_.enabled,N.condition=_.condition,N.hitCondition=_.hitCondition,N.logMessage=_.logMessage,N.functionName=_.functionName}else if(P instanceof T.SourceBreakpoint&&_.type==="source"){const N=P;N.enabled=_.enabled,N.condition=_.condition,N.hitCondition=_.hitCondition,N.logMessage=_.logMessage,N.location=new T.Location(t.URI.revive(_.uri),new T.Position(_.line,_.character))}a.push(P)}}}this.fireBreakpointChanges(b,v,a)}$provideDebugConfigurations(h,b,v){return(0,A.asPromise)(async()=>{const a=this.getConfigProviderByHandle(h);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(b);return a.provideDebugConfigurations(_,v)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(h,b,v,a){return(0,A.asPromise)(async()=>{const _=this.getConfigProviderByHandle(h);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(b);return _.resolveDebugConfiguration(P,v,a)})}$resolveDebugConfigurationWithSubstitutedVariables(h,b,v,a){return(0,A.asPromise)(async()=>{const _=this.getConfigProviderByHandle(h);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(b);return _.resolveDebugConfigurationWithSubstitutedVariables(P,v,a)})}async $provideDebugAdapter(h,b){const v=this.getAdapterDescriptorFactoryByHandle(h);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(b);return this.getAdapterDescriptor(v,a).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(h){const b=await this.getSession(h);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(h){const b=await this.getSession(h);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,b){const v=await this.getSession(h);v&&v._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(h,b){const a={session:await this.getSession(h),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(h){if(h instanceof T.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof T.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const b=this._adapterFactories.filter(v=>v.type===h);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(h){const b=this._adapterFactories.filter(v=>v.handle===h);if(b.length>0)return b[0].factory}getConfigProviderByHandle(h){const b=this._configProviders.filter(v=>v.handle===h);if(b.length>0)return b[0].provider}definesDebugType(h,b){if(h.contributes){const v=h.contributes.debuggers;if(v&&v.length>0){for(const a of v)if(a.label&&a.type&&a.type===b)return!0}}return!1}getDebugAdapterTrackers(h){const v=h.configuration.type,a=this._trackerFactories.filter(_=>_.type===v||_.type==="*").map(_=>(0,A.asPromise)(()=>_.factory.createDebugAdapterTracker(h)).then(P=>P,P=>null));return Promise.race([Promise.all(a).then(_=>{const P=_.filter(N=>!!N);if(P.length>0)return new o(P)}),new Promise((_,P)=>{const N=setTimeout(()=>{clearTimeout(N),P(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(h,b){const v=b.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new T.DebugAdapterServer(v));if(h){const _=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>h.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,_))).then(P=>{if(P)return P})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,a))}daExecutableFromPackage(h,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,b,v){(h.length>0||b.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:b,changed:v}))}async getSession(h){if(h)if(typeof h=="string"){const b=this._debugSessions.get(h);if(b)return b}else{let b=this._debugSessions.get(h.id);if(!b){const v=await this.getFolder(h.folderUri),a=h.parent?this._debugSessions.get(h.parent):void 0;b=new I(this._debugServiceProxy,h.id,h.type,h.name,v,h.configuration,a),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(h){if(h){const b=t.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};p=Be([He(0,g.IExtHostRpcService),He(1,R.IExtHostWorkspace),He(2,F.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class I{constructor(h,b,v,a,_,P,N){this._debugServiceProxy=h,this._id=b,this._type=v,this._name=a,this._workspaceFolder=_,this._configuration=P,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,b)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=I;class c{constructor(h){this.value=Object.freeze({append(b){h.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=c;class M extends n.AbstractVariableResolverService{constructor(h,b,v,a,_){function P(){if(b){const N=b.activeEditor();if(N)return N.document.uri;const $=a.tabs.filter(y=>y.isActive);if($.length>0){const y=$[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:$[0].resource}}}super({getFolderUri:N=>{const $=h.filter(y=>y.name===N);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(N,$)=>v.getConfiguration(void 0,N).get($),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=P();if(N)return s.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(_){const N=P();if(N){const $=_.getWorkspaceFolder(N);if($)return s.normalize($.uri.fsPath)}}},getSelectedText:()=>{if(b){const N=b.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(b){const N=b.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=M;class o{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(b=>b.onError?b.onError(h):void 0)}onExit(h,b){this.trackers.forEach(v=>v.onExit?v.onExit(h,b):void 0)}}class i extends S.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends p{constructor(h,b,v,a,_,P){super(h,b,v,a,_,P)}createVariableResolver(h,b,v){return new M(h,b,v,this._editorTabs)}};f=Be([He(0,g.IExtHostRpcService),He(1,R.IExtHostWorkspace),He(2,F.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(ye[214],Ce([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(d,p,I,c,M,o,i){this._apiFactory=d,this._extensionRegistry=p,this._instaService=I,this._extHostConfiguration=c,this._extHostExtensionService=M,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,p,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(l,p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,p,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let p of d.nodeModuleName)this._factories.set(p,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(p=>d.alternativeModuleName(p))}};r=Be([He(2,F.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,C.IExtHostExtensionService),He(5,R.IExtHostInitDataService),He(6,m.ILogService)],r),e.RequireInterceptor=r;class g{constructor(d,p,I,c,M){this._apiFactory=d,this._extensionPaths=p,this._extensionRegistry=I,this._configProvider=c,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,p){const I=this._extensionPaths.findSubstr(p);if(I){let c=this._extApiImpl.get(T.ExtensionIdentifier.toKey(I.identifier));return c||(c=this._apiFactory(I,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(I.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((M,o)=>c+=`	${o} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let l=class{constructor(d,p,I){this._extensionPaths=d,this.nodeModuleName="keytar",this._mainThreadTelemetry=p.getProxy(E.MainContext.MainThreadTelemetry);const{environment:c}=I,M=p.getProxy(E.MainContext.MainThreadKeytar);if(c.appRoot){let o=c.appRoot.fsPath;n.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,i)=>M.$getPassword(o,i),setPassword:(o,i,f)=>M.$setPassword(o,i,f),deletePassword:(o,i)=>M.$deletePassword(o,i),findPassword:o=>M.$findPassword(o),findCredentials(o){return M.$findCredentials(o)}}}load(d,p){const I=this._extensionPaths.findSubstr(p);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:I?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(d){const p=d.length;if(p<=7||!this.alternativeNames)return;const I=p-7;if((d.charAt(I)==="/"||d.charAt(I)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};l=Be([He(1,S.IExtHostRpcService),He(2,R.IExtHostInitDataService)],l);let D=class{constructor(d,p,I){this._extensionPaths=d,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=I.getProxy(E.MainContext.MainThreadTelemetry);const c=I.getProxy(E.MainContext.MainThreadWindow);this._impl=(M,o)=>{const i=t.URI.parse(M);return o?this.callOriginal(M,o):i.scheme==="http"||i.scheme==="https"?c.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?c.$openUri(i,M,{}):this.callOriginal(M,o)}}load(d,p,I){const c=this._extensionPaths.findSubstr(p);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=I(d),this._impl}callOriginal(d,p){return this.sendNoForwardTelemetry(),this._original(d,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=Be([He(2,S.IExtHostRpcService)],D)}),define(ye[215],Ce([0,1,14,15,73,6,2,5,208,12,56,60,28,136,13,65,33,39]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(p,I,c,M){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=c,this._rpcProtocol=new S.RPCProtocol(p,null,M),I=w._transform(I,this._rpcProtocol);const o=new C.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());o.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...I}),o.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),o.set(g.IURITransformerService,new g.URITransformerService(M)),o.set(l.IHostUtils,c);const i=new m.InstantiationService(o,!0);this._disposables.add(i.invokeFunction(b=>b.get(D.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(b=>b.get(l.IExtHostExtensionService))),this._logService=i.invokeFunction(b=>b.get(R.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",I),this._extensionService=i.invokeFunction(b=>b.get(l.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(v,a)=>{let _="",P,N;for(const $ of a)_+=`
	at ${$.toString()}`,N=$.getFileName(),!P&&N&&(P=b.findSubstr(k.URI.file(N)));return f.set(v,P),`${v.name||"Error"}: ${v.message||""}${_}`}});const u=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(b=>{const v=t.transformErrorForSerialization(b),a=f.get(b);a?u.$onExtensionRuntimeError(a.identifier,v):h.$onUnexpectedError(v)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(c=>{this._logService.error(c)}),this._rpcProtocol.dispose();const I=this._extensionService.deactivateAll();Promise.race([(0,s.timeout)(5e3),I]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,I){p.extensions.forEach(M=>M.extensionLocation=k.URI.revive(I.transformIncomingURIs(M.extensionLocation))),p.environment.appRoot=k.URI.revive(I.transformIncomingURIs(p.environment.appRoot));const c=p.environment.extensionDevelopmentLocationURI;return c&&(p.environment.extensionDevelopmentLocationURI=c.map(M=>k.URI.revive(I.transformIncomingURIs(M)))),p.environment.extensionTestsLocationURI=k.URI.revive(I.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=k.URI.revive(I.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=k.URI.revive(I.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=k.URI.revive(I.transformIncomingURIs(p.logsLocation)),p.logFile=k.URI.revive(I.transformIncomingURIs(p.logFile)),p.workspace=I.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=w}),define(ye[216],Ce([0,1,17,20,43,29,24,189,40]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(n,m,r){this.config=n,this.provider=m,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((r,g)=>{const l=D=>{this.resultCount++,n(D)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const w=D.toString(),d=s.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,d)||this.matchFile(l,{base:D,basename:d})}),Promise.all(m.map(D=>this.searchInFolder(D,l))).then(D=>{r({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{g(new Error((0,E.toErrorMessage)(D)))})})}async searchInFolder(n,m){const r=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(n),l=this.initDirectoryTree(),D=new S.QueryGlobTester(this.config,n),w=!D.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(r),d=T.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,r.token),I=d.elapsed(),c=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(M=>{const o=s.posix.relative(n.folder.path,M.path);if(w){const i=s.basename(M.path);this.matchFile(m,{base:n.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(l,n.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(l,D,m),{providerTime:I,postProcessTime:c.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(n){const m=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:r,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,r,g){if(r===this.filePattern){const D=s.basename(this.filePattern);this.matchFile(g,{base:m,relativePath:this.filePattern,basename:D})}function l(D){const w=s.basename(D),d=s.dirname(D);let p=n[d];p||(p=n[d]=[],l(d)),p.push({base:m,relativePath:D,basename:w})}l(r)}matchDirectoryTree({rootEntries:n,pathToEntries:m},r,g){const l=this,D=this.filePattern;function w(d){const p=A.hasSiblingFn(()=>d.map(I=>I.basename));for(let I=0,c=d.length;I<c;I++){const M=d[I],{relativePath:o,basename:i}=M;if(r.matchesExcludesSync(o,i,D!==i?p:void 0))continue;const f=m[o];if(f)w(f);else{if(o===D)continue;l.matchFile(g,M)}if(l.isLimitHit)break}}w(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class F{constructor(){this.sessions=new Map}fileSearch(n,m,r,g){const l=this.getSessionTokenSource(n.cacheKey),D=new R(n,m,l&&l.token);let w=0;const d=p=>{w+=p.length,r(p.map(I=>this.rawMatchToSearchItem(I)))};return this.doSearch(D,F.BATCH_SIZE,d,g).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:p.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new t.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:k.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,r,g){g.onCancellationRequested(()=>{n.cancel()});const l=w=>{w&&(D.push(w),m>0&&D.length>=m&&(r(D),D=[]))};let D=[];return n.search(l).then(w=>(D.length&&r(D),w),w=>(D.length&&r(D),Promise.reject(w)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(ye[217],Ce([0,1,16,20,43,29,10,17,24,11,2,40]),function(Z,e,s,t,E,A,k,T,S,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(d,p,I,c){this.query=d,this.provider=p,this.fileUtils=I,this.processType=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,p){const I=this.query.folderQueries||[],c=new t.CancellationTokenSource;return p.onCancellationRequested(()=>c.cancel()),new Promise((M,o)=>{this.collector=new r(d);let i=!1;const f=(u,h)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(u);l(u)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,c.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const v=this.resultSize(u);this.resultCount+=v,(v>0||!l(u))&&this.collector.add(u,h)}};Promise.all(I.map((u,h)=>this.searchInFolder(u,b=>f(b,h),c.token))).then(u=>{c.dispose(),this.collector.flush();const h=u.some(b=>!!b&&!!b.limitHit);M({limitHit:this.isLimitHit||h,messages:(0,s.flatten)(u.map(b=>b?.message?(0,R.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},u=>{c.dispose();const h=(0,E.toErrorMessage)(u);o(new Error(h))})})}resultSize(d){return l(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,p){const I=Array.isArray(d.ranges)?d.ranges:[d.ranges],c=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:I.slice(0,p),preview:{matches:c.slice(0,p),text:d.preview.text},uri:d.uri}}async searchInFolder(d,p,I){const c=new C.QueryGlobTester(this.query,d),M=[],o={report:u=>{if(!this.validateProviderResult(u))return;const h=d.folder.scheme===k.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(u.uri))):void 0,b=S.relativePath(d.folder,u.uri);if(b){const v=c.includedInQuery(b,T.basename(b),h);(0,R.isPromise)(v)?M.push(v.then(a=>{a&&p(u)})):v&&p(u)}}},i=this.getSearchOptionsForFolder(d),f=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,o,I);return M.length&&await Promise.all(M),f}validateProviderResult(d){if(l(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const p=(0,C.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),I=(0,C.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),c={folder:F.URI.from(d.folder),excludes:I,includes:p,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return c.usePCRE2=this.query.usePCRE2,c}}e.TextSearchManager=n;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class r{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,p=>this.sendItems(p))}add(d,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!S.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(g(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=r;function g(w){return l(w)?{preview:{matches:(0,s.mapArrayOrNot)(w.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:w.preview.text},ranges:(0,s.mapArrayOrNot)(w.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function l(w){return!!w.preview}e.extensionResultIsMatch=l;class D{constructor(d,p){this.maxBatchSize=d,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,p){!d||this.addItemToBatch(d,p)}addItems(d,p){!d||this.addItemsToBatch(d,p)}addItemToBatch(d,p){this.batch.push(d),this.batchSize+=p,this.onUpdate()}addItemsToBatch(d,p){this.batch=this.batch.concat(d),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(ye[99],Ce([0,1,6,5,3,216,13,65,12,2,217]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let C=class{constructor(g,l,D){this.extHostRpc=g,this._uriTransformer=l,this._logService=D,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,l){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const D=this._handlePool++;return this._textSearchProvider.set(D,l),this._proxy.$registerTextSearchProvider(D,this._transformScheme(g)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(g,l){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const D=this._handlePool++;return this._fileSearchProvider.set(D,l),this._proxy.$registerFileSearchProvider(D,this._transformScheme(g)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(g,l,D,w){const d=n(D),p=this._fileSearchProvider.get(g);if(p)return this._fileSearchManager.fileSearch(d,p,I=>{this._proxy.$handleFileMatch(g,l,I.map(c=>c.resource))},w);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,l,D,w){const d=this._textSearchProvider.get(g);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const p=n(D);return this.createTextSearchManager(p,d).search(c=>this._proxy.$handleTextMatch(g,l,c),w)}$enableExtensionHostSearch(){}createTextSearchManager(g,l){return new F.TextSearchManager(g,l,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};C=Be([He(0,k.IExtHostRpcService),He(1,T.IURITransformerService),He(2,S.ILogService)],C),e.ExtHostSearch=C;function n(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(m),extraFileResources:r.extraFileResources&&r.extraFileResources.map(g=>R.URI.revive(g))}}e.reviveQuery=n;function m(r){return{...r,folder:R.URI.revive(r.folder)}}}),define(ye[218],Ce([0,1,20,15,4,34,2,112,232,106,55,45,5,179,178,38,180,32,181,182,183,164,184,48,33,185,165,188,190,192,94,167,197,198,199,71,39,201,168,8,7,204,50,95,31,74,153,187,61,93,97,98,99,12,65,13,28,193,150,64,69,176,202,149,72,49,207,205,206,177,30,200,203,68,70,85,195,96,196,10,138,194,147,186,6,27]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d,p,I,c,M,o,i,f,u,h,b,v,a,_,P,N,$,y,L,z,x,B,j,ue,K,ne,pe,be,ae,le,Se,Ee,Fe,$e,Ve,je,H,G,X,se,q,te,fe,Re,xe,ze,Xe,et,st,Je,nt,lt,pt,Ft,Oe,Mt,V,Q,de,Ne,qe,ot,Ye,yt,Ae,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function re(oe){const he=oe.get(G.IExtHostInitDataService),me=oe.get(lt.IExtHostFileSystemInfo),Te=oe.get(Xe.IExtHostConsumerFileSystem),We=oe.get(o.IExtHostExtensionService),Le=oe.get(ne.IExtHostWorkspace),Ke=oe.get(V.IExtHostTelemetry),it=oe.get(D.IExtHostConfiguration),rt=oe.get(je.IURITransformerService),ie=oe.get(H.IExtHostRpcService),ge=oe.get($.IExtHostStorage),ee=oe.get(ze.IExtensionStoragePaths),W=oe.get(Ve.ILoggerService),we=oe.get(Ve.ILogService),Pe=oe.get(q.IExtHostTunnelService),Qe=oe.get(te.IExtHostApiDeprecationService),Ue=oe.get(K.IExtHostWindow),ut=oe.get(Oe.IExtHostSecretState),vt=oe.get(Mt.IExtHostEditorTabs);ie.set(n.ExtHostContext.ExtHostFileSystemInfo,me),ie.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ie.set(n.ExtHostContext.ExtHostWorkspace,Le),ie.set(n.ExtHostContext.ExtHostConfiguration,it),ie.set(n.ExtHostContext.ExtHostExtensionService,We),ie.set(n.ExtHostContext.ExtHostStorage,ge),ie.set(n.ExtHostContext.ExtHostTunnelService,Pe),ie.set(n.ExtHostContext.ExtHostWindow,Ue),ie.set(n.ExtHostContext.ExtHostSecretState,ut),ie.set(n.ExtHostContext.ExtHostTelemetry,Ke),ie.set(n.ExtHostContext.ExtHostEditorTabs,vt);const St=ie.set(n.ExtHostContext.ExtHostDecorations,oe.get(Se.IExtHostDecorations)),wt=ie.set(n.ExtHostContext.ExtHostDocumentsAndEditors,oe.get(M.IExtHostDocumentsAndEditors)),ht=ie.set(n.ExtHostContext.ExtHostCommands,oe.get(g.IExtHostCommands)),gt=ie.set(n.ExtHostContext.ExtHostTerminalService,oe.get(y.IExtHostTerminalService)),_t=ie.set(n.ExtHostContext.ExtHostDebugService,oe.get(Fe.IExtHostDebugService)),Lt=ie.set(n.ExtHostContext.ExtHostSearch,oe.get($e.IExtHostSearch)),It=ie.set(n.ExtHostContext.ExtHostTask,oe.get(Ee.IExtHostTask)),Pt=ie.set(n.ExtHostContext.ExtHostOutputService,oe.get(v.IExtHostOutputService)),At=ie.set(n.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(ie)),Et=ie.set(n.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(ie,wt)),Ot=ie.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ie,wt,we)),Nt=ie.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new I.ExtHostDocumentSaveParticipant(we,Et,ie.getProxy(n.MainContext.MainThreadBulkEdits))),bt=ie.set(n.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(ie,ht,wt,Et,ee)),$t=ie.set(n.ExtHostContext.ExtHostNotebookDocuments,new yt.ExtHostNotebookDocuments(we,bt)),jt=ie.set(n.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(we,ie,bt)),oi=ie.set(n.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ie,he,bt,ht,we)),si=ie.set(n.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(ie,bt)),Tt=ie.set(n.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(ie,wt)),Yt=ie.set(n.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(ie.getProxy(n.MainContext.MainThreadTreeViews),ht,we)),ai=ie.set(n.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(ie.getProxy(n.MainContext.MainThreadEditorInsets),Tt,he)),Xt=ie.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(ie,we,me)),Vt=ie.set(n.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(ie,Et,ht.converter,rt)),mt=ie.set(n.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(ie,rt,Et,ht,Xt,we,Qe)),li=ie.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ie,mt)),xt=ie.set(n.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(ie,we,wt)),qt=ie.set(n.ExtHostContext.ExtHostQuickOpen,(0,_.createExtHostQuickOpen)(ie,Le,ht)),Jt=ie.set(n.ExtHostContext.ExtHostSCM,new P.ExtHostSCM(ie,ht,we)),ci=ie.set(n.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(ie,ht,Et)),fi=ie.set(n.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(ie.getProxy(n.MainContext.MainThreadProgress))),Ei=ie.set(n.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(ie)),mi=ie.set(n.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(ie)),Zt=ie.set(n.ExtHostContext.ExtHostAuthentication,new fe.ExtHostAuthentication(ie)),yi=ie.set(n.ExtHostContext.ExtHostTimeline,new Re.ExtHostTimeline(ie,ht)),Kt=ie.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ie,{remote:he.remote},Le,we,Qe)),Gt=ie.set(n.ExtHostContext.ExtHostWebviewPanels,new Je.ExtHostWebviewPanels(ie,Kt,Le)),_i=ie.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ie,Et,ee,Kt,Gt)),Ci=ie.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(ie,Kt)),Qt=ie.set(n.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(ie,ht)),Si=ie.set(n.ExtHostContext.ExtHostUriOpeners,new Ft.ExtHostUriOpeners(ie));ie.set(n.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(ie,bt,wt,ht));const ei=(0,pe.values)(n.ExtHostContext);ie.assertRegistered(ei);const Di=new nt.ExtHostBulkEdits(ie,wt),ki=new r.ExtHostClipboard(ie),ui=new b.ExtHostMessageService(ie,we),ti=new d.ExtHostDialogs(ie),gi=new N.ExtHostStatusBar(ie,ht.converter);return m.ExtHostApiCommands.register(ht),function(Me,Ut,pi){const ft=function(){let Y=!Me.isUnderDevelopment;function ce(){Y||(we.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ke(ct){if(Array.isArray(ct))ct.forEach(ke);else if(typeof ct=="string")ce();else{const Ct=ct;typeof Ct.scheme=="undefined"&&ce(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ct}}(),ii={getSession(Y,ce,ke){return Zt.getSession(Me,Y,ce,ke)},async hasSession(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,Y,ce,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,ce,ke,ct){return Zt.registerAuthenticationProvider(Y,ce,ke,ct)}},Ii={registerCommand(Y,ce,ke){return ht.registerCommand(!0,Y,ce,ke,void 0,Me)},registerTextEditorCommand(Y,ce,ke){return ht.registerCommand(!0,Y,(...ct)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){we.warn("Cannot execute "+Y+" because there is no active text editor.");return}return Ct.edit(Dt=>{ce.apply(ke,[Ct,Dt,...ct])}).then(Dt=>{Dt||we.warn("Edits from command "+Y+" were not applied.")},Dt=>{we.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Me)},registerDiffInformationCommand:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),ht.registerCommand(!0,Y,async(...ct)=>{const Ct=wt.activeEditor(!0);if(!Ct){we.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(Ct.id);ce.apply(ke,[Dt,...ct])},void 0,void 0,Me)),executeCommand(Y,...ce){return ht.executeCommand(Y,...ce)},getCommands(Y=!1){return ht.getCommands(Y)}},vi={get machineId(){return he.telemetryInfo.machineId},get sessionId(){return he.telemetryInfo.sessionId},get language(){return he.environment.appLanguage},get appName(){return he.environment.appName},get appRoot(){return he.environment.appRoot?.fsPath??""},get appHost(){return he.environment.appHost},get uriScheme(){return he.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ke.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ke.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(he.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return Ue.openUri(Y,{allowTunneling:!!he.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===he.environment.appUriScheme)return At.createAppUri(Y);try{return await Ue.asExternalUri(Y,{allowTunneling:!!he.remote.authority})}catch(ce){if((0,ot.matchesScheme)(Y,qe.Schemas.http)||(0,ot.matchesScheme)(Y,qe.Schemas.https))return Y;throw ce}},get remoteName(){return(0,le.getRemoteName)(he.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),he.remote.authority},get uiKind(){return he.uiKind}};he.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=he.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Pi={createTestController(Y,ce){return Qt.createTestController(Y,ce)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.results}},Ti={getExtension(Y){const ce=Ut.getExtensionDescription(Y);if(ce)return new o.Extension(We,Me.identifier,ce,wi)},get all(){return Ut.getAllExtensionDescriptions().map(Y=>new o.Extension(We,Me.identifier,Y,wi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(Y){return Xt.createDiagnosticCollection(Me.identifier,Y)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:Y=>Xt.getDiagnostics(Y),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(Y,ce){return Vt.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,F.score)(x.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,ke){return mt.registerCodeActionProvider(Me,ft(Y),ce,ke)},registerCodeLensProvider(Y,ce){return mt.registerCodeLensProvider(Me,ft(Y),ce)},registerDefinitionProvider(Y,ce){return mt.registerDefinitionProvider(Me,ft(Y),ce)},registerDeclarationProvider(Y,ce){return mt.registerDeclarationProvider(Me,ft(Y),ce)},registerImplementationProvider(Y,ce){return mt.registerImplementationProvider(Me,ft(Y),ce)},registerTypeDefinitionProvider(Y,ce){return mt.registerTypeDefinitionProvider(Me,ft(Y),ce)},registerHoverProvider(Y,ce){return mt.registerHoverProvider(Me,ft(Y),ce,Me.identifier)},registerEvaluatableExpressionProvider(Y,ce){return mt.registerEvaluatableExpressionProvider(Me,ft(Y),ce,Me.identifier)},registerInlineValuesProvider(Y,ce){return mt.registerInlineValuesProvider(Me,ft(Y),ce,Me.identifier)},registerDocumentHighlightProvider(Y,ce){return mt.registerDocumentHighlightProvider(Me,ft(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return mt.registerLinkedEditingRangeProvider(Me,ft(Y),ce)},registerReferenceProvider(Y,ce){return mt.registerReferenceProvider(Me,ft(Y),ce)},registerRenameProvider(Y,ce){return mt.registerRenameProvider(Me,ft(Y),ce)},registerDocumentSymbolProvider(Y,ce,ke){return mt.registerDocumentSymbolProvider(Me,ft(Y),ce,ke)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Me,Y)},registerDocumentFormattingEditProvider(Y,ce){return mt.registerDocumentFormattingEditProvider(Me,ft(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return mt.registerDocumentRangeFormattingEditProvider(Me,ft(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,ke,...ct){return mt.registerOnTypeFormattingEditProvider(Me,ft(Y),ce,[ke].concat(ct))},registerDocumentSemanticTokensProvider(Y,ce,ke){return mt.registerDocumentSemanticTokensProvider(Me,ft(Y),ce,ke)},registerDocumentRangeSemanticTokensProvider(Y,ce,ke){return mt.registerDocumentRangeSemanticTokensProvider(Me,ft(Y),ce,ke)},registerSignatureHelpProvider(Y,ce,ke,...ct){return typeof ke=="object"?mt.registerSignatureHelpProvider(Me,ft(Y),ce,ke):mt.registerSignatureHelpProvider(Me,ft(Y),ce,typeof ke=="undefined"?[]:[ke,...ct])},registerCompletionItemProvider(Y,ce,...ke){return mt.registerCompletionItemProvider(Me,ft(Y),ce,ke)},registerInlineCompletionItemProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),mt.registerInlineCompletionsProvider(Me,ft(Y),ce)},registerDocumentLinkProvider(Y,ce){return mt.registerDocumentLinkProvider(Me,ft(Y),ce)},registerColorProvider(Y,ce){return mt.registerColorProvider(Me,ft(Y),ce)},registerFoldingRangeProvider(Y,ce){return mt.registerFoldingRangeProvider(Me,ft(Y),ce)},registerSelectionRangeProvider(Y,ce){return mt.registerSelectionRangeProvider(Me,Y,ce)},registerCallHierarchyProvider(Y,ce){return mt.registerCallHierarchyProvider(Me,Y,ce)},registerTypeHierarchyProvider(Y,ce){return mt.registerTypeHierarchyProvider(Me,Y,ce)},setLanguageConfiguration:(Y,ce)=>mt.setLanguageConfiguration(Me,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Vt.tokenAtPosition(Y,ce)},registerInlayHintsProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),mt.registerInlayHintsProvider(Me,Y,ce)},createLanguageStatusItem(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Vt.createLanguageStatusItem(Me,Y,ce)}},Ri={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,ce,ke){const ct=await(k.URI.isUri(Y)?Promise.resolve(ni.openTextDocument(Y)):Promise.resolve(Y));return Tt.showTextDocument(ct,ce,ke)},createTextEditorDecorationType(Y){return Tt.createTextEditorDecorationType(Me,Y)},onDidChangeActiveTextEditor(Y,ce,ke){return Tt.onDidChangeActiveTextEditor(Y,ce,ke)},onDidChangeVisibleTextEditors(Y,ce,ke){return Tt.onDidChangeVisibleTextEditors(Y,ce,ke)},onDidChangeTextEditorSelection(Y,ce,ke){return Tt.onDidChangeTextEditorSelection(Y,ce,ke)},onDidChangeTextEditorOptions(Y,ce,ke){return Tt.onDidChangeTextEditorOptions(Y,ce,ke)},onDidChangeTextEditorVisibleRanges(Y,ce,ke){return Tt.onDidChangeTextEditorVisibleRanges(Y,ce,ke)},onDidChangeTextEditorViewColumn(Y,ce,ke){return Tt.onDidChangeTextEditorViewColumn(Y,ce,ke)},onDidCloseTerminal(Y,ce,ke){return gt.onDidCloseTerminal(Y,ce,ke)},onDidOpenTerminal(Y,ce,ke){return gt.onDidOpenTerminal(Y,ce,ke)},onDidChangeActiveTerminal(Y,ce,ke){return gt.onDidChangeActiveTerminal(Y,ce,ke)},onDidChangeTerminalDimensions(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),gt.onDidChangeTerminalDimensions(Y,ce,ke)},onDidChangeTerminalState(Y,ce,ke){return gt.onDidChangeTerminalState(Y,ce,ke)},onDidWriteTerminalData(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(Y,ce,ke)},get state(){return Ue.state},onDidChangeWindowState(Y,ce,ke){return Ue.onDidChangeWindowState(Y,ce,ke)},showInformationMessage(Y,...ce){return ui.showMessage(Me,A.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return ui.showMessage(Me,A.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return ui.showMessage(Me,A.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,ke){return Array.isArray(Y)&&Y.some(ct=>ct.kind===B.QuickPickItemKind.Separator)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),qt.showQuickPick(Y,ce,ke)},showWorkspaceFolderPick(Y){return qt.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return qt.showInput(Y,ce)},showOpenDialog(Y){return ti.showOpenDialog(Y)},showSaveDialog(Y){return ti.showSaveDialog(Y)},createStatusBarItem(Y,ce,ke){let ct,Ct,Dt;return typeof Y=="string"?(ct=Y,Ct=ce,Dt=ke):(Ct=Y,Dt=ce),gi.createStatusBarEntry(Me,ct,Ct,Dt)},setStatusBarMessage(Y,ce){return gi.setStatusBarMessage(Y,ce)},withScmProgress(Y){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fi.withProgress(Me,{location:B.ProgressLocation.SourceControl},(ce,ke)=>Y({report(ct){}}))},withProgress(Y,ce){return fi.withProgress(Me,Y,ce)},createOutputChannel(Y){return Pt.createOutputChannel(Y,Me)},createWebviewPanel(Y,ce,ke,ct){return Gt.createWebviewPanel(Me,Y,ce,ke,ct)},createWebviewTextEditorInset(Y,ce,ke,ct){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),ai.createWebviewEditorInset(Y,ce,ke,ct,Me)},createTerminal(Y,ce,ke){return typeof Y=="object"?"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y):gt.createTerminal(Y,ce,ke)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ce){return gt.registerProfileProvider(Me,Y,ce)},registerTreeDataProvider(Y,ce){return Yt.registerTreeDataProvider(Y,ce,Me)},createTreeView(Y,ce){return Yt.createTreeView(Y,ce,Me)},registerWebviewPanelSerializer:(Y,ce)=>Gt.registerWebviewPanelSerializer(Me,Y,ce),registerCustomEditorProvider:(Y,ce,ke={})=>_i.registerCustomEditorProvider(Me,Y,ce,ke),registerFileDecorationProvider(Y){return St.registerFileDecorationProvider(Y,Me.identifier)},registerUriHandler(Y){return At.registerUriHandler(Me.identifier,Y)},createQuickPick(){return qt.createQuickPick(Me)},createInputBox(){return qt.createInputBox(Me.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,ke){return mi.onDidChangeActiveColorTheme(Y,ce,ke)},registerWebviewViewProvider(Y,ce,ke){return Ci.registerWebviewViewProvider(Me,Y,ce,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(Y,ce,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(Y,ce,ke)},onDidChangeNotebookEditorVisibleRanges(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(Y,ce,ke)},showNotebookDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Si.registerExternalUriOpener(Me.identifier,Y,ce,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),u.InlineCompletionController.get(Y)}},ni={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw t.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw t.readonly()},updateWorkspaceFolders:(Y,ce,...ke)=>Le.updateWorkspaceFolders(Me,Y,ce||0,...ke),onDidChangeWorkspaceFolders:function(Y,ce,ke){return Le.onDidChangeWorkspace(Y,ce,ke)},asRelativePath:(Y,ce)=>Le.getRelativePath(Y,ce),findFiles:(Y,ce,ke,ct)=>Le.findFiles(x.GlobPattern.from(Y),x.GlobPattern.from(ce),ke,Me.identifier,ct),findTextInFiles:(Y,ce,ke,ct)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let Ct,Dt;return typeof ce=="object"?(Ct=ce,Dt=ke):(Ct={},Dt=ce,ct=ke),Le.findTextInFiles(Y,Ct||{},Dt,Me.identifier,ct)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,ke,ct)=>xt.createFileSystemWatcher(x.GlobPattern.from(Y),ce,ke,ct),get textDocuments(){return Et.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw t.readonly()},openTextDocument(Y){let ce;const ke=Y;if(typeof Y=="string")ce=Promise.resolve(k.URI.file(Y));else if(k.URI.isUri(Y))ce=Promise.resolve(Y);else if(!ke||typeof ke=="object")ce=Et.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ct=>Et.ensureDocumentData(ct).then(Ct=>Ct.document))},onDidOpenTextDocument:(Y,ce,ke)=>Et.onDidAddDocument(Y,ce,ke),onDidCloseTextDocument:(Y,ce,ke)=>Et.onDidRemoveDocument(Y,ce,ke),onDidChangeTextDocument:(Y,ce,ke)=>Et.onDidChangeDocument(Y,ce,ke),onDidSaveTextDocument:(Y,ce,ke)=>Et.onDidSaveDocument(Y,ce,ke),onWillSaveTextDocument:(Y,ce,ke)=>Nt.getOnWillSaveTextDocumentEvent(Me)(Y,ce,ke),get notebookDocuments(){return bt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ce){let ke;if(k.URI.isUri(Y))ke=Y,await bt.openNotebookDocument(Y);else if(typeof Y=="string")ke=k.URI.revive(await bt.createNotebookDocument({viewType:Y,content:ce}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ce,ke,ct){return bt.registerNotebookSerializer(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,ce,ke,ct)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),bt.registerNotebookContentProvider(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,ce,ke)=>pi.onDidChangeConfiguration(Y,ce,ke),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,pi.getConfiguration(Y,ce,Me)},registerTextDocumentContentProvider(Y,ce){return Ot.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Me,Y,ce)),registerFileSystemProvider(Y,ce,ke){return(0,De.combinedDisposable)(li.registerFileSystemProvider(Me,Y,ce,ke),Te.addFileSystemProvider(Y,ce))},get fs(){return Te.value},registerFileSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Lt.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Lt.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),We.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,ke)=>xt.onDidCreateFile(Y,ce,ke),onDidDeleteFiles:(Y,ce,ke)=>xt.onDidDeleteFile(Y,ce,ke),onDidRenameFiles:(Y,ce,ke)=>xt.onDidRenameFile(Y,ce,ke),onWillCreateFiles:(Y,ce,ke)=>xt.getOnWillCreateFileEvent(Me)(Y,ce,ke),onWillDeleteFiles:(Y,ce,ke)=>xt.getOnWillDeleteFileEvent(Me)(Y,ce,ke),onWillRenameFiles:(Y,ce,ke)=>xt.getOnWillRenameFileEvent(Me)(Y,ce,ke),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.openTunnel(Me,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.getTunnels()},onDidChangeTunnels:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.onDidChangeTunnels(Y,ce,ke)),registerPortAttributesProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),Pe.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),yi.registerTimelineProvider(Y,ce,Me.identifier,ht.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ce,ke)=>Le.onDidGrantWorkspaceTrust(Y,ce,ke)},Fi={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(Y,ce,ke){return Jt.createSourceControl(Me,Y,ce,ke)}},Mi={createCommentController(Y,ce){return ci.createCommentController(Me,Y,ce)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(Y,ce,ke){return _t.onDidStartDebugSession(Y,ce,ke)},onDidTerminateDebugSession(Y,ce,ke){return _t.onDidTerminateDebugSession(Y,ce,ke)},onDidChangeActiveDebugSession(Y,ce,ke){return _t.onDidChangeActiveDebugSession(Y,ce,ke)},onDidReceiveDebugSessionCustomEvent(Y,ce,ke){return _t.onDidReceiveDebugSessionCustomEvent(Y,ce,ke)},onDidChangeBreakpoints(Y,ce,ke){return _t.onDidChangeBreakpoints(Y,ce,ke)},registerDebugConfigurationProvider(Y,ce,ke){return _t.registerDebugConfigurationProvider(Y,ce,ke||B.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return _t.registerDebugAdapterDescriptorFactory(Me,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return _t.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?_t.startDebugging(Y,ce,{parentSession:ke}):_t.startDebugging(Y,ce,ke||{})},stopDebugging(Y){return _t.stopDebugging(Y)},addBreakpoints(Y){return _t.addBreakpoints(Y)},removeBreakpoints(Y){return _t.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return _t.asDebugSourceUri(Y,ce)}},Li={registerTaskProvider:(Y,ce)=>It.registerTaskProvider(Me,Y,ce),fetchTasks:Y=>It.fetchTasks(Y),executeTask:Y=>It.executeTask(Me,Y),get taskExecutions(){return It.taskExecutions},onDidStartTask:(Y,ce,ke)=>It.onDidStartTask(Y,ce,ke),onDidEndTask:(Y,ce,ke)=>It.onDidEndTask(Y,ce,ke),onDidStartTaskProcess:(Y,ce,ke)=>It.onDidStartTaskProcess(Y,ce,ke),onDidEndTaskProcess:(Y,ce,ke)=>It.onDidEndTaskProcess(Y,ce,ke)},Ni={createNotebookController(Y,ce,ke,ct,Ct){return oi.createNotebookController(Me,Y,ce,ke,ct,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ce)=>bt.registerNotebookCellStatusBarItemProvider(Me,Y,ce),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),$t.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Me,Y)},onDidChangeNotebookDocumentMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),$t.onDidChangeNotebookDocumentMetadata(Y,ce,ke)},onDidChangeNotebookCells(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeNotebookCells(Y,ce,ke)},onDidChangeNotebookCellExecutionState(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),bt.onDidChangeNotebookCellExecutionState(Y,ce,ke)},onDidChangeCellOutputs(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeCellOutputs(Y,ce,ke)},onDidChangeCellMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeCellMetadata(Y,ce,ke)},createConcatTextDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new xe.ExtHostNotebookConcatDocument(bt,Et,Y,ce)}};return{version:he.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:B.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:R.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:n.UIKind,Uri:k.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:de.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=re}),define(ye[219],Ce([0,1,56,94,31,93,32,38,48,39,97,98,99,71,64,69,95,49,30,68,85,70,191,12,174]),function(Z,e,s,t,E,A,k,T,S,R,F,C,n,m,r,g,l,D,w,d,p,I,c,M,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(M.ILoggerService,c.ExtHostLoggerService),(0,s.registerSingleton)(M.ILogService,o.ExtHostLogService),(0,s.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,s.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,s.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,s.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,s.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,s.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,s.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,s.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,s.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,s.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,s.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,s.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,s.registerSingleton)(r.IExtHostTunnelService,r.ExtHostTunnelService),(0,s.registerSingleton)(l.IExtHostWindow,l.ExtHostWindow),(0,s.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,s.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,s.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,s.registerSingleton)(I.IExtHostEditorTabs,I.ExtHostEditorTabs)}),define(ye[220],Ce([0,1,218,33,214,7,14,5,10]),function(Z,e,s,t,E,A,k,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends E.RequireInterceptor{_installInterceptor(){}getModule(r,g){for(let l of this._alternatives){let D=l(r);if(D){r=D;break}}if(this._factories.has(r))return this._factories.get(r).load(r,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const r=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);n(r,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(r){return r.browser}async _loadCommonJSModule(r,g,l){g=g.with({path:C(g.path,".js")}),r&&performance.mark(`code/extHost/willFetchExtensionCode/${r.value}`);const D=await fetch(S.FileAccess.asBrowserUri(g).toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r.value}`),D.status!==200)throw new Error(D.statusText);const w=await D.text(),d=`${g.toString(!0)}#vscode-extension`,p=`${w}
//# sourceURL=${d}`;let I;try{I=new Function("module","exports","require",p)}catch(i){throw console.error(r?`Loading code for extension ${r.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${g.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const c={},M={exports:c},o=i=>{const f=this._fakeModules.getModule(i,g);if(f===void 0)throw new Error(`Cannot load module '${i}'`);return f};try{return l.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r.value}`),I(M,c,o),M.exports!==c?M.exports:c}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r.value}`),l.codeLoadingStop()}}async $setRemoteEnvironment(r){}async _waitForDebuggerAttachment(r=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+r;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=F;function C(m,r){return m.endsWith(r)?m:m+r}function n(m,r){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(w,d){const p=console[w];console[w]=function(){m.$logExtensionHostMessage({type:"__$console",severity:d,arguments:D(arguments)}),r&&p.apply(console,arguments)}}const l=1e5;function D(w){const d=[],p=[];if(w.length)for(let I=0;I<w.length;I++){if(typeof w[I]=="undefined")w[I]="undefined";else if(w[I]instanceof Error){const c=w[I];c.stack?w[I]=c.stack:w[I]=c.toString()}p.push(w[I])}try{const I=JSON.stringify(p,function(c,M){if(M&&typeof M=="object"){if(d.indexOf(M)!==-1)return"[Circular]";d.push(M)}return M});return I.length>l?"Output omitted for a large object that exceeds the limits":I}catch(I){return`Output omitted for an object that cannot be inspected ('${I.toString()}')`}}}}),define(ye[221],Ce([0,1,56,33,72,220]),function(Z,e,s,t,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(t.IExtHostExtensionService,A.ExtHostExtensionService),(0,s.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(ye[233],Ce([0,1,22,4,172,215,209,17,73,10,2,219,221]),function(Z,e,s,t,E,A,k,T,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(d,p){return d instanceof Request||/^file:/i.test(String(d))&&(d=R.FileAccess.asBrowserUri(F.URI.parse(String(d))).toString(!0)),m(d,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,p,I,c,M){return/^file:/i.test(p.toString())&&(p=R.FileAccess.asBrowserUri(F.URI.parse(p.toString())).toString(!0)),super.open(d,p,I??!0,c,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const d=self.Worker;Worker=function(p,I){/^file:/i.test(p.toString())&&(p=R.FileAccess.asBrowserUri(F.URI.parse(p.toString())).toString(!0));const M=`(${function(u){function h(a){return typeof a=="string"||a instanceof URL?String(a).replace(/^file:\/\//i,"vscode-file://vscode-app"):a}const b=fetch.bind(self);self.fetch=function(a,_){return a instanceof Request?b(a,_):b(h(a),_)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,_,P,N,$){return super.open(a,h(_),P??!0,N,$)}};const v=importScripts.bind(self);self.importScripts=(...a)=>{v(...a.map(h))},v(u)}.toString()}('${p}'))`;I=I||{},I.name=I.name||T.basename(p.toString());const o=new Blob([M],{type:"application/javascript"}),i=URL.createObjectURL(o);return new d(i,I)}}else self.Worker=class extends k.NestedWorker{constructor(d,p){super(n,d,{name:T.basename(d.toString()),...p})}};const r=new class{constructor(){this.pid=void 0}exit(d){C()}async exists(d){return!0}async realpath(d){return d}};class g{constructor(){const p=new MessageChannel,I=new t.Emitter;let c=!1;n(p.port2,[p.port2]),p.port1.onmessage=M=>{const{data:o}=M;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const i=s.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,E.isMessageOfType)(i,2)){c=!0,D("received terminate message from renderer");return}I.fire(i)},this.protocol={onMessage:I.event,send:M=>{if(!c){const o=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);p.port1.postMessage(o,[o])}}}}}function l(d){return new Promise(p=>{const I=d.onMessage(c=>{I.dispose();const M=JSON.parse(c.toString());d.send((0,E.createMessageOfType)(0)),p({protocol:d,initData:M})});d.send((0,E.createMessageOfType)(1))})}let D=d=>C();function w(){const d=new g;S.mark("code/extHost/willConnectToRenderer"),l(d.protocol).then(p=>{S.mark("code/extHost/didWaitForInitData");const I=new A.ExtensionHostMain(p.protocol,p.initData,r,null);D=c=>I.terminate(c)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e8a26d3ebf5095d4324ad4bf794787540ed3b33e/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
